
(* This generated code requires the following version of MenhirLib: *)

let () =
  MenhirLib.StaticVersion.require_20231231

module MenhirBasics = struct
  
  exception Error
  
  let _eRR =
    fun _s ->
      raise Error
  
  type token = 
    | WHILE
    | WHEN
    | UU_WRITE
    | UU_UNPREDICTABLE_UNLESS
    | UU_UNPREDICTABLE
    | UU_UNALLOCATED
    | UU_REGISTER
    | UU_READWRITE
    | UU_POSTDECODE
    | UU_OPERATOR_TWO
    | UU_OPERATOR_ONE
    | UU_OPCODE
    | UU_NOP
    | UU_NEWMAP
    | UU_NEWEVENT
    | UU_MAP
    | UU_INSTRUCTION_SET
    | UU_INSTRUCTION
    | UU_GUARD
    | UU_FUNCTION
    | UU_FIELD
    | UU_EXECUTE
    | UU_EXCEPTIONTAKEN
    | UU_EVENT
    | UU_ENCODING
    | UU_DECODE
    | UU_CONFIG
    | UU_CONDITIONAL
    | UU_BUILTIN
    | UU_ARRAY
    | UNTIL
    | UNPREDICTABLE
    | UNKNOWN
    | UNDEFINED
    | TYPEOF
    | TYPE
    | TRY
    | TO
    | THROW
    | THEN
    | STRING_LIT of (
# 82 "asllib/Parser0.mly"
       (string)
# 60 "asllib/Parser0.ml"
  )
    | STAR
    | SLASH
    | SEMICOLON
    | SEE
    | RPAREN
    | RETURN
    | REPEAT
    | REM
    | RECORD
    | REAL_LIT of (
# 86 "asllib/Parser0.mly"
       (Q.t)
# 74 "asllib/Parser0.ml"
  )
    | REAL
    | RBRACK
    | RBRACE_RBRACE
    | RBRACE
    | QUOT
    | QUALIFIER of (
# 88 "asllib/Parser0.mly"
       (string)
# 84 "asllib/Parser0.ml"
  )
    | PLUS_PLUS
    | PLUS_COLON
    | PLUS
    | OTHERWISE
    | OR
    | OF
    | NOT
    | MOD
    | MINUS
    | MASK_LIT of (
# 83 "asllib/Parser0.mly"
       (Bitvector.mask)
# 98 "asllib/Parser0.ml"
  )
    | LT_LT
    | LT_EQ
    | LT
    | LPAREN
    | LIMIT
    | LET
    | LBRACK
    | LBRACE_LBRACE
    | LBRACE
    | IS
    | INT_LIT of (
# 85 "asllib/Parser0.mly"
       (Z.t)
# 113 "asllib/Parser0.ml"
  )
    | INTEGER
    | INDENT
    | IN
    | IMPLIES
    | IMPLEM_DEFINED
    | IFF
    | IF
    | IDENTIFIER of (
# 82 "asllib/Parser0.mly"
       (string)
# 125 "asllib/Parser0.ml"
  )
    | GT_GT
    | GT_EQ
    | GT
    | FOR
    | EQ_GT
    | EQ_EQ
    | EQ
    | EOR
    | EOL
    | EOF
    | ENUMERATION
    | ELSIF
    | ELSE
    | DOWNTO
    | DOT_DOT
    | DOT
    | DO
    | DIV
    | DEDENT
    | DEBUG
    | CONSTRAINED_UNPRED
    | CONSTANT
    | CONFIG
    | COMMA
    | COLON
    | CATCH
    | CASE
    | CARET
    | BOOL_LIT of (
# 87 "asllib/Parser0.mly"
       (bool)
# 158 "asllib/Parser0.ml"
  )
    | BOOLEAN
    | BITS_LIT of (
# 84 "asllib/Parser0.mly"
       (Bitvector.t)
# 164 "asllib/Parser0.ml"
  )
    | BITS
    | BIT
    | BAR_BAR
    | BANG_EQ
    | BANG
    | ASSERT
    | ARRAY
    | AND
    | AMP_AMP
    | AMP
  
end

include MenhirBasics

# 23 "asllib/Parser0.mly"
  

  module Prelude = struct
    open AST
    open ASTUtils

    let version = V0

    let build_expr_conds =
      let make_cond { desc = c, e_then; _ } e_else =
        E_Cond (c, e_then, e_else)
      in
      fun (elseifs, e) -> List.fold_right (map2_desc make_cond) elseifs e

    let build_stmt_conds (s_elsifs, s_else) =
      let s_else = match s_else with Some s -> s | None -> s_pass in
      let folder { desc = c, s_then; _ } s_else = S_Cond (c, s_then, s_else) in
      List.fold_right (map2_desc folder) s_elsifs s_else

    let t_bit =
      T_Bits (E_Literal (L_Int Z.one) |> add_dummy_annotation ~version, [])


    let make_ldi_vars (ty, xs) =
      let make_one x =
        S_Decl (LDK_Var, LDI_Typed (LDI_Var x, ty), None)
        |> add_dummy_annotation ~version
      in
      List.map make_one xs |> stmt_from_list |> desc

    let make_func name args return_type body =
      let subprogram_type =
        match return_type with | Some _ -> ST_Function | None -> ST_Procedure
      and parameters = []
      and recurse_limit = None
      in
      D_Func {
        name;
        args;
        return_type;
        body;
        parameters;
        subprogram_type;
        recurse_limit;
        builtin = false;
      }

    let make_concat es =
      match es with
      | [] -> E_Literal (L_BitVector Bitvector.empty)
      | [ bv ] -> bv |> desc
      | bv :: bvs -> List.fold_left (binop BV_CONCAT) bv bvs |> desc

  end

  open Prelude


# 240 "asllib/Parser0.ml"

module Tables = struct
  
  include MenhirBasics
  
  let token2terminal : token -> int =
    fun _tok ->
      match _tok with
      | AMP ->
          127
      | AMP_AMP ->
          126
      | AND ->
          125
      | ARRAY ->
          124
      | ASSERT ->
          123
      | BANG ->
          122
      | BANG_EQ ->
          121
      | BAR_BAR ->
          120
      | BIT ->
          119
      | BITS ->
          118
      | BITS_LIT _ ->
          117
      | BOOLEAN ->
          116
      | BOOL_LIT _ ->
          115
      | CARET ->
          114
      | CASE ->
          113
      | CATCH ->
          112
      | COLON ->
          111
      | COMMA ->
          110
      | CONFIG ->
          109
      | CONSTANT ->
          108
      | CONSTRAINED_UNPRED ->
          107
      | DEBUG ->
          106
      | DEDENT ->
          105
      | DIV ->
          104
      | DO ->
          103
      | DOT ->
          102
      | DOT_DOT ->
          101
      | DOWNTO ->
          100
      | ELSE ->
          99
      | ELSIF ->
          98
      | ENUMERATION ->
          97
      | EOF ->
          96
      | EOL ->
          95
      | EOR ->
          94
      | EQ ->
          93
      | EQ_EQ ->
          92
      | EQ_GT ->
          91
      | FOR ->
          90
      | GT ->
          89
      | GT_EQ ->
          88
      | GT_GT ->
          87
      | IDENTIFIER _ ->
          86
      | IF ->
          85
      | IFF ->
          84
      | IMPLEM_DEFINED ->
          83
      | IMPLIES ->
          82
      | IN ->
          81
      | INDENT ->
          80
      | INTEGER ->
          79
      | INT_LIT _ ->
          78
      | IS ->
          77
      | LBRACE ->
          76
      | LBRACE_LBRACE ->
          75
      | LBRACK ->
          74
      | LET ->
          73
      | LIMIT ->
          72
      | LPAREN ->
          71
      | LT ->
          70
      | LT_EQ ->
          69
      | LT_LT ->
          68
      | MASK_LIT _ ->
          67
      | MINUS ->
          66
      | MOD ->
          65
      | NOT ->
          64
      | OF ->
          63
      | OR ->
          62
      | OTHERWISE ->
          61
      | PLUS ->
          60
      | PLUS_COLON ->
          59
      | PLUS_PLUS ->
          58
      | QUALIFIER _ ->
          57
      | QUOT ->
          56
      | RBRACE ->
          55
      | RBRACE_RBRACE ->
          54
      | RBRACK ->
          53
      | REAL ->
          52
      | REAL_LIT _ ->
          51
      | RECORD ->
          50
      | REM ->
          49
      | REPEAT ->
          48
      | RETURN ->
          47
      | RPAREN ->
          46
      | SEE ->
          45
      | SEMICOLON ->
          44
      | SLASH ->
          43
      | STAR ->
          42
      | STRING_LIT _ ->
          41
      | THEN ->
          40
      | THROW ->
          39
      | TO ->
          38
      | TRY ->
          37
      | TYPE ->
          36
      | TYPEOF ->
          35
      | UNDEFINED ->
          34
      | UNKNOWN ->
          33
      | UNPREDICTABLE ->
          32
      | UNTIL ->
          31
      | UU_ARRAY ->
          30
      | UU_BUILTIN ->
          29
      | UU_CONDITIONAL ->
          28
      | UU_CONFIG ->
          27
      | UU_DECODE ->
          26
      | UU_ENCODING ->
          25
      | UU_EVENT ->
          24
      | UU_EXCEPTIONTAKEN ->
          23
      | UU_EXECUTE ->
          22
      | UU_FIELD ->
          21
      | UU_FUNCTION ->
          20
      | UU_GUARD ->
          19
      | UU_INSTRUCTION ->
          18
      | UU_INSTRUCTION_SET ->
          17
      | UU_MAP ->
          16
      | UU_NEWEVENT ->
          15
      | UU_NEWMAP ->
          14
      | UU_NOP ->
          13
      | UU_OPCODE ->
          12
      | UU_OPERATOR_ONE ->
          11
      | UU_OPERATOR_TWO ->
          10
      | UU_POSTDECODE ->
          9
      | UU_READWRITE ->
          8
      | UU_REGISTER ->
          7
      | UU_UNALLOCATED ->
          6
      | UU_UNPREDICTABLE ->
          5
      | UU_UNPREDICTABLE_UNLESS ->
          4
      | UU_WRITE ->
          3
      | WHEN ->
          2
      | WHILE ->
          1
  
  and error_terminal =
    0
  
  and token2value : token -> Obj.t =
    fun _tok ->
      match _tok with
      | AMP ->
          Obj.repr ()
      | AMP_AMP ->
          Obj.repr ()
      | AND ->
          Obj.repr ()
      | ARRAY ->
          Obj.repr ()
      | ASSERT ->
          Obj.repr ()
      | BANG ->
          Obj.repr ()
      | BANG_EQ ->
          Obj.repr ()
      | BAR_BAR ->
          Obj.repr ()
      | BIT ->
          Obj.repr ()
      | BITS ->
          Obj.repr ()
      | BITS_LIT _v ->
          Obj.repr _v
      | BOOLEAN ->
          Obj.repr ()
      | BOOL_LIT _v ->
          Obj.repr _v
      | CARET ->
          Obj.repr ()
      | CASE ->
          Obj.repr ()
      | CATCH ->
          Obj.repr ()
      | COLON ->
          Obj.repr ()
      | COMMA ->
          Obj.repr ()
      | CONFIG ->
          Obj.repr ()
      | CONSTANT ->
          Obj.repr ()
      | CONSTRAINED_UNPRED ->
          Obj.repr ()
      | DEBUG ->
          Obj.repr ()
      | DEDENT ->
          Obj.repr ()
      | DIV ->
          Obj.repr ()
      | DO ->
          Obj.repr ()
      | DOT ->
          Obj.repr ()
      | DOT_DOT ->
          Obj.repr ()
      | DOWNTO ->
          Obj.repr ()
      | ELSE ->
          Obj.repr ()
      | ELSIF ->
          Obj.repr ()
      | ENUMERATION ->
          Obj.repr ()
      | EOF ->
          Obj.repr ()
      | EOL ->
          Obj.repr ()
      | EOR ->
          Obj.repr ()
      | EQ ->
          Obj.repr ()
      | EQ_EQ ->
          Obj.repr ()
      | EQ_GT ->
          Obj.repr ()
      | FOR ->
          Obj.repr ()
      | GT ->
          Obj.repr ()
      | GT_EQ ->
          Obj.repr ()
      | GT_GT ->
          Obj.repr ()
      | IDENTIFIER _v ->
          Obj.repr _v
      | IF ->
          Obj.repr ()
      | IFF ->
          Obj.repr ()
      | IMPLEM_DEFINED ->
          Obj.repr ()
      | IMPLIES ->
          Obj.repr ()
      | IN ->
          Obj.repr ()
      | INDENT ->
          Obj.repr ()
      | INTEGER ->
          Obj.repr ()
      | INT_LIT _v ->
          Obj.repr _v
      | IS ->
          Obj.repr ()
      | LBRACE ->
          Obj.repr ()
      | LBRACE_LBRACE ->
          Obj.repr ()
      | LBRACK ->
          Obj.repr ()
      | LET ->
          Obj.repr ()
      | LIMIT ->
          Obj.repr ()
      | LPAREN ->
          Obj.repr ()
      | LT ->
          Obj.repr ()
      | LT_EQ ->
          Obj.repr ()
      | LT_LT ->
          Obj.repr ()
      | MASK_LIT _v ->
          Obj.repr _v
      | MINUS ->
          Obj.repr ()
      | MOD ->
          Obj.repr ()
      | NOT ->
          Obj.repr ()
      | OF ->
          Obj.repr ()
      | OR ->
          Obj.repr ()
      | OTHERWISE ->
          Obj.repr ()
      | PLUS ->
          Obj.repr ()
      | PLUS_COLON ->
          Obj.repr ()
      | PLUS_PLUS ->
          Obj.repr ()
      | QUALIFIER _v ->
          Obj.repr _v
      | QUOT ->
          Obj.repr ()
      | RBRACE ->
          Obj.repr ()
      | RBRACE_RBRACE ->
          Obj.repr ()
      | RBRACK ->
          Obj.repr ()
      | REAL ->
          Obj.repr ()
      | REAL_LIT _v ->
          Obj.repr _v
      | RECORD ->
          Obj.repr ()
      | REM ->
          Obj.repr ()
      | REPEAT ->
          Obj.repr ()
      | RETURN ->
          Obj.repr ()
      | RPAREN ->
          Obj.repr ()
      | SEE ->
          Obj.repr ()
      | SEMICOLON ->
          Obj.repr ()
      | SLASH ->
          Obj.repr ()
      | STAR ->
          Obj.repr ()
      | STRING_LIT _v ->
          Obj.repr _v
      | THEN ->
          Obj.repr ()
      | THROW ->
          Obj.repr ()
      | TO ->
          Obj.repr ()
      | TRY ->
          Obj.repr ()
      | TYPE ->
          Obj.repr ()
      | TYPEOF ->
          Obj.repr ()
      | UNDEFINED ->
          Obj.repr ()
      | UNKNOWN ->
          Obj.repr ()
      | UNPREDICTABLE ->
          Obj.repr ()
      | UNTIL ->
          Obj.repr ()
      | UU_ARRAY ->
          Obj.repr ()
      | UU_BUILTIN ->
          Obj.repr ()
      | UU_CONDITIONAL ->
          Obj.repr ()
      | UU_CONFIG ->
          Obj.repr ()
      | UU_DECODE ->
          Obj.repr ()
      | UU_ENCODING ->
          Obj.repr ()
      | UU_EVENT ->
          Obj.repr ()
      | UU_EXCEPTIONTAKEN ->
          Obj.repr ()
      | UU_EXECUTE ->
          Obj.repr ()
      | UU_FIELD ->
          Obj.repr ()
      | UU_FUNCTION ->
          Obj.repr ()
      | UU_GUARD ->
          Obj.repr ()
      | UU_INSTRUCTION ->
          Obj.repr ()
      | UU_INSTRUCTION_SET ->
          Obj.repr ()
      | UU_MAP ->
          Obj.repr ()
      | UU_NEWEVENT ->
          Obj.repr ()
      | UU_NEWMAP ->
          Obj.repr ()
      | UU_NOP ->
          Obj.repr ()
      | UU_OPCODE ->
          Obj.repr ()
      | UU_OPERATOR_ONE ->
          Obj.repr ()
      | UU_OPERATOR_TWO ->
          Obj.repr ()
      | UU_POSTDECODE ->
          Obj.repr ()
      | UU_READWRITE ->
          Obj.repr ()
      | UU_REGISTER ->
          Obj.repr ()
      | UU_UNALLOCATED ->
          Obj.repr ()
      | UU_UNPREDICTABLE ->
          Obj.repr ()
      | UU_UNPREDICTABLE_UNLESS ->
          Obj.repr ()
      | UU_WRITE ->
          Obj.repr ()
      | WHEN ->
          Obj.repr ()
      | WHILE ->
          Obj.repr ()
  
  and default_reduction =
    (16, "\000\000\000\000\000n\000\000\000\000\000\000\000\000\000\000\000\t\000\000\000\000\000\017\000\007\000\000\0008\000\000\000F\000\000\000\000\000\000\000;\000\000\000\r\000\000\000\000\000\000\000\000\0002\000\006\000\000\0007\000\000\000D\000\000\000\000\000:\000\000\000\015\000\005\000\000\0009\000\000\000H\000\b\000\000\000\000\000\000\000<\000\000\000N\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\235\000\000\000\000\002\238\000\000\002\234\002\237\002\236\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000.\000\000\000\000\002n\000\000\000/\000-\000\000\000\000\000\000\002\206\000\000\002\227\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002h\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0005\000\000\000\000\0006\000\000\000\000\000\000\000\000\002f\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002e\002g\000\000\000\000\0004\002\154\000\000\000\000\002\162\000\000\002\163\000\000\000\000\002j\002\152\000\000\002\199\000\000\002\213\0000\000\000\000\000\000\000\002\202\000\000\002\158\000\000\002\159\000\000\002\219\000\000\000\000\000\000\000\000\002\149\000\000\000\000\002\186\000\000\002\193\000\000\002\194\002\151\000\000\002\198\000\000\002\211\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\b\000\000\000\000\000\000\000\000\002\201\000\000\002\160\000\000\002\161\000\000\002\217\002\150\000\000\002\200\000\000\002\215\002\153\000\000\000\000\000\000\000\000\002\204\000\000\000\000\002\203\000\000\002\221\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\239\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\244\000\000\000L\000\000\000\000\000\000\002\243\000\000\000J\000\000\000\000\000\000\000\000\000\000\002\245\000\000\002\208\000\000\002\231\000\000\000\000\000\000\000\000\002\207\000\000\002\229\000\000\000\000\000\000\000\000\000\000\000\000\002\209\000\000\002\233\000\000\000\000\002\191\000\000\000\000\000\000\000\000\000\000\002\189\000\000\002\190\002\188\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\195\000\000\000\000\000\000\000\000\000\000\002\196\000\000\000\000\002\197\000\000\000\000\002\146\000\000\000\000\000\000\000\000\000\000\002\144\000\000\000\000\000\000\002\145\000\000\002\192\000\000\000\000\000\000\002Y\001D\000\000\000\000\002\205\000\000\002\225\000\000\002\223\000\000\000\000\000\000\0001\000\000\000\000\000\000\002\241\000\000\000\000\000\000\000\000\002\148\000\000\002\246\000\000\000A\000\000\000X\000\000\000\000\000\000\000\000\000@\000\000\000V\000\000\000\000\000\000\000\000\000\000\000\000\000B\000\000\000Z\000\000\000\000\000\000\000=\000\000\000\000\000\000\000>\000\000\000R\000\000\000P\000\000\000\016\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0003\000\000\000\004\000\000\000\000\000+\000\000\000\000\000\014\000\000\000\018\000\000\000\000\000?\000\000\000T\000\000\002\242\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001J\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000`\000\000\000c\000\000\000\000\000a\000\000\000b\000\000\000l\000\000\000\000\000f\000\000\000g\000\000\000d\000\000\000e\000\000\000\000\000j\000\000\000k\000i\000\000\002r\000\000\000h\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\182\000\000\000\000\000\000\000\000\001\160\000\000\000\000\000\000\000\000\001\181\000\000\000\000\001\221\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\180\000\000\000\000\000\000\000\000\001\179\000\000\000\000\001\220\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\184\000\000\000\000\000\000\000\000\001\183\000\000\000\000\001\222\001\231\001\172\000\000\000\000\000\000\000\000\001\171\000\000\000\000\001\216\001\174\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\176\000\000\000\000\000\000\000\000\001\175\000\000\000\000\001\218\000\000\000\000\000\000\000\000\001\173\000\000\000\000\001\217\001\166\000\000\000\000\000\000\000\000\001\165\000\000\000\000\001\213\001\202\000\000\000\000\000\000\000\000\001\201\000\000\000\000\000\000\000\000\000\000\001\188\000\000\000\000\000\000\000\000\001\187\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\194\000\000\000\000\000\000\000\000\001\193\000\000\000^\000\\\000\000\000]\000\000\000\000\000\000\000_\000\000\000\000\002p\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\210\000\000\000\000\000\000\000\000\000\000\001\186\000\000\000\000\000\000\000\000\001\185\000\000\000\000\000\000\000\000\000\000\001\192\000\000\000\000\000\000\000\000\001\191\000\000\000\000\000\000\001\209\000\000\000\000\000\000\000\000\000\000\001\190\000\000\000\000\000\000\000\000\001\189\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\198\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\200\000\000\000\000\000\000\000\000\001\199\000\000\000\000\000\000\000\000\001\197\000\000\000\000\000\000\000\000\000\000\001\196\000\000\000\000\000\000\000\000\001\195\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\206\000\000\000\000\000\000\000\000\001\205\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\204\000\000\000\000\000\000\000\000\001\203\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\208\000\000\000\000\000\000\000\000\001\207\001\235\001\232\001\168\000\000\000\000\000\000\001\225\000\000\000\000\000\000\001\226\000\000\000\000\000\000\000\000\001\167\000\000\000\000\001\214\001\240\000\000\001\239\000\000\000\000\000\000\000\000\001\236\001\162\000\000\000\000\000\000\000\000\001\161\000\000\000\000\001\211\001\170\000\000\000\000\000\000\001\223\000\000\000\000\000\000\001\224\000\000\000\000\000\000\000\000\001\169\000\000\000\000\001\215\001\164\000\000\000\000\000\000\000\000\001\163\000\000\000\000\001\212\001\227\000\000\000\000\000\000\001\228\001\229\000\000\000\000\001\230\001\242\000\000\000\000\000\000\000\000\001\241\000\000\000\000\001\243\001\244\001\178\000\000\000\000\000\000\000\000\001\177\000\000\000\000\001\219\001\237\000\000\000\000\000\000\001\238\001\233\000\000\000\000\000\000\001\234\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\132\002\129\002\135\002\130\002~\002\127\002\128\002\134\002\131\002\136\002\133\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\016\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\133\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002&\000\000\000\000\000\000\002'\000\000\002(\000\137\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\134\000\000\000\000\000\000\000\135\000\000\000\136\000\127\000\000\000\000\000\000\000\128\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\129\000\000\000\000\000\000\000\130\000\000\000\000\000\000\000\000\000u\000y\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000v\000\000\000\000\000\000\000w\000\000\000x\000\000\000\000\000\000\000\000\000p\000t\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\131\000\000\000\000\000\000\000\132\000\000\000\000\000\000\000\000\000z\000~\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000{\000\000\000\000\000\000\000|\000\000\000}\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000q\000\000\000\000\000\000\000r\000\000\000s\000\000\000\000\002H\000\000\000\000\002J\000\000\000\000\000\000\000\000\002I\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002L\000\000\000\000\000\000\000\000\002K\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\n\001\014\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\011\000\000\000\000\000\000\001\012\000\000\001\r\000\000\000\000\000\000\000\000\000\000\000\000\002*\002.\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002+\000\000\000\000\000\000\002,\000\000\002-\002)\000\000\000\000\000\000\000\000\000\000\000\000\002B\002F\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002C\000\000\000\000\000\000\002D\000\000\002E\002A\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0020\0024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0021\000\000\000\000\000\000\0022\000\000\0023\002/\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0026\002:\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0027\000\000\000\000\000\000\0028\000\000\0029\0025\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002<\002@\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002=\000\000\000\000\000\000\002>\000\000\002?\002;\000\000\000\000\000\000\000\000\002G\000\000\000\000\000\000\000\000\000\000\000\000\002O\000\000\000\000\000\000\000\000\002P\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001G\001H\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002R\000\000\002V\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002S\000\000\000\000\000\000\000\000\002T\000\000\000\000\002U\000\000\002Q\000\000\000\000\002N\000\000\000\000\000\000\000\000\000\000\002M\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002_\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\150\000\000\000\000\000\000\000\000\000\178\000\000\000\000\000\000\000\000\000\161\000\177\000\000\000\000\000\000\002l\000\000\000\000\000\000\000\000\000\180\000\000\000\000\000\000\000\000\000\162\000\179\000\000\000\000\000\000\000\000\000\223\000\000\000\000\000\000\000\000\000\212\000\222\000\000\000\000\000\000\000\000\000\225\000\000\000\000\000\000\000\000\000\213\000\224\000\000\000\000\000\000\000\000\000\147\000\000\000\000\000\000\000\207\000\000\000\000\000\000\000\000\000\000\000\206\000\201\000\000\000\000\000\000\000\000\000\000\000\148\000\000\000\000\000\000\000\000\000\170\000\000\000\000\000\000\000\000\000\157\000\169\000\000\000\000\000\000\000\000\000\172\000\000\000\000\000\000\000\000\000\158\000\171\000\000\000\000\000\000\000\000\000\215\000\000\000\000\000\000\000\000\000\208\000\214\000\000\000\000\000\000\000\000\000\217\000\000\000\000\000\000\000\000\000\209\000\216\000\000\000\000\000\000\000\000\000\145\000\000\000\000\000\000\000\203\000\000\000\000\000\000\000\000\000\000\000\202\000\199\000\000\000\000\000\000\000\149\000\000\000\000\000\000\000\000\000\174\000\000\000\000\000\000\000\000\000\159\000\173\000\000\000\000\000\000\000\000\000\176\000\000\000\000\000\000\000\000\000\160\000\175\000\000\000\000\000\000\000\000\000\219\000\000\000\000\000\000\000\000\000\210\000\218\000\000\000\000\000\000\000\000\000\221\000\000\000\000\000\000\000\000\000\211\000\220\000\000\000\000\000\000\000\000\000\146\000\000\000\000\000\000\000\205\000\000\000\000\000\000\000\000\000\000\000\204\000\200\000\155\000\000\000\000\000\000\000\000\000\000\000\156\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\151\000\000\000\000\000\000\000\000\000\000\000\152\000\000\000\000\000\000\000\000\000\000\000\000\000\153\000\000\000\000\000\000\000\000\000\000\000\154\000\144\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\142\000\000\000\000\000\000\000\000\000\000\000\143\000\141\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\139\000\000\000\000\000\000\000\000\000\000\000\140\001\002\000\000\000\000\000\000\000\000\000\000\000\000\001\001\000\192\000\000\000\000\000\000\000\000\000\183\000\191\000\000\000\000\000\000\000\000\000\194\000\000\000\000\000\000\000\000\000\184\000\193\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\244\000\000\000\000\000\000\000\000\000\231\000\243\000\000\000\000\000\000\002\139\000\000\000\000\000\000\002\140\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\246\000\000\000\000\000\000\000\000\000\232\000\245\000\000\000\000\000\000\000\000\000\000\000\242\000\000\000\000\000\000\000\000\000\227\000\241\000\167\000\000\000\000\000\000\000\000\000\000\000\000\000\168\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\163\000\000\000\000\000\000\000\000\000\000\000\000\000\164\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\165\000\000\000\000\000\000\000\000\000\000\000\000\000\166\000\188\000\000\000\000\000\000\000\000\000\181\000\187\000\000\000\000\000\000\000\000\000\190\000\000\000\000\000\000\000\000\000\182\000\189\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\238\000\000\000\000\000\000\000\000\000\229\000\237\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\240\000\000\000\000\000\000\000\000\000\230\000\239\000\000\000\000\000\000\000\000\000\000\000\236\000\000\000\000\000\000\000\000\000\226\000\235\001\000\000\000\000\000\000\000\000\000\000\196\000\000\000\000\000\000\000\000\000\185\000\195\000\000\000\000\000\000\000\000\000\198\000\000\000\000\000\000\000\000\000\186\000\197\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\250\000\000\000\000\000\000\000\000\000\233\000\249\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\252\000\000\000\000\000\000\000\000\000\234\000\251\000\000\000\000\000\000\000\000\000\000\000\000\000\255\000\000\000\000\000\000\000\000\000\000\000\248\000\000\000\000\000\000\000\000\000\228\000\247\001\004\000\000\000\000\000\000\000\000\000\000\002\\\000\000\000\000\000\000\001\006\000\000\000\000\000\000\000\000\000\254\000\000\000\000\000\000\001\003\000\000\000\000\000\000\000\000\000\000\001\005\000\000\000\000\000\000\000\000\000\253\000\000\000\003\000\001\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\018\000\000\000\000\000\000\001\019\000\000\001\020\0014\0016\000\000\000\000\000\000\000\000\0015\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0018\000\000\000\000\000\000\000\000\0017\000\000\000\000\000\000\000\000\000\000\001\022\001\026\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\023\000\000\000\000\000\000\001\024\000\000\001\025\001\021\000\000\000\000\000\000\000\000\000\000\000\000\001.\0012\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001/\000\000\000\000\000\000\0010\000\000\0011\001-\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\028\001 \000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\029\000\000\000\000\000\000\001\030\000\000\001\031\001\027\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\"\001&\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001#\000\000\000\000\000\000\001$\000\000\001%\001!\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001(\001,\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001)\000\000\000\000\000\000\001*\000\000\001+\001'\000\000\000\000\000\000\000\000\0013\001;\000\000\000\000\000\000\000\000\001<\001>\000\000\001B\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001?\000\000\000\000\000\000\000\000\001@\000\000\000\000\001A\000\000\001=\001:\000\000\000\000\000\000\000\000\000\000\0019\000\000\002`")
  
  and error =
    (128, "\000\000\000\000\024\000(@\001\001\002\001\192\012\011\b@\000\000\000\189\005\168@!!\022!\192<K\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\186\005\027o\160c\219?\131 \198\000\000\000\000\016B8@\161#\006\000\000\000\031(\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\016\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\250\005\027n\160c\219?\131 \198\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000B\186\005\027o\160s\219?\131 \198\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016B8@\161#\006\000\000\000\031(\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\016@<@\161#\006\000\000\000\031(\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\016\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\250\005\027n\160c\219?\131 \198\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000B\186\005\027o\160s\219?\131 \198\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016B8@\161#\006\000\000\000\031(\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\016\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\250\005\027n\160c\219?\131 \198\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000@\000\000\000\000\000\016\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\250\005\027n\160c\219?\131 \198\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\000\000\000\000\000 \000\000\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000@0\004\no q\202\006\129 \198\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\016\000\b@\001\001\002\000\000\000\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016\000\b@\001\001\002\000\000\000\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0002\000\nn a\202\002\129 \198\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\002\186\005\027n\160c\219?\131 \198\000\000\000\000\016@<@\161#\006\000\000\000\031(\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0002\000\nn a\202\002\129 \198\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\002\186\005\027n\160c\219?\131 \198\000\000\000\000\000\000\000\000\000 \002\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\004\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\002\186\005\027n\160c\219?\131 \198\000\000\000\000@\000\000\000\000\000\016\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000p\004\026l c\202\002\131 \198\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\002\186\005\027n\160c\219?\131 \198\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\002\186\005\027n\160c\219?\131 \198\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\002\186\005\027n\160c\219?\131 \198\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\002\186\005\027n\160c\219?\131 \198\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\002\186\005\027n\160c\219?\131 \198\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\002\186\005\027n\160c\219?\131 \198\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\002\186\005\027n\160c\219?\131 \198\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\002\186\005\027h\160#\027?\131 \198\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\002\186\005\027n\160c\219?\131 \198\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\002\186\005\027n\160c\219?\131 \198\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\002\186\005\027h\160#\027?\131 \198\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\016@8@\177#\006\000\000\000\031(\000\000\000\000\016@9@\161#\006\000\000\002\031(\000\000\000\000\016@8@\177#\006\000\000\000\031(\000\000\000\000\000\000\001\000\000\000\000\000\000\002\000\000\000\000\000\000\016@8@\177#\006\000\000\000\031(\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0000\001\nn a\202\006\131 \198\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\002\186\005\027n\160c\219?\131 \198\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\002\186\005\027h\160#\027?\131 \198\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\002\186\005\027h\160#\027?\131 \198\000\000\000\000\016@8@\177#\006\000\000\000\031(\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\186\005\027n\160c\219?\131 \198\000\000\000\000\016@8@\177#\006\000\000\000\031(\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\186\005\027n\160c\219?\131 \198\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0000\001\nn a\202\002\131 \198\000\000\000\000\016@8@\177#\006\000\000\000\031(\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\002\186\005\027n\160c\219?\131 \198\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\002\186\005\027n\160c\219?\131 \198\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\002\186\005\027n\160c\219?\131 \198\000\000\000\000\016@8@\177#\006\000\000\000\031(\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\186\005\027n\160c\219?\131 \198\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0000\004\026m c\202\002\131 \198\000\000\000\000\016B8@\161#\006\000\000\000\031(\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0002\004\nn a\202\002\131 \198\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\016\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000p\004\026l c\202\002\131 \198\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000@0\004\026m s\202\002\131 \198\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016B8@\161#\006\000\000\000\031(\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000p\004\026l c\202\002\131 \198\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0002\000\nn a\202\002\131 \198\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016@<@\161#\006\000\000\000\031(\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\016\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000p\004\026l c\202\002\131 \198\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\000\176\000\nn a\202\002\129 \198\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0000\000\nn a\2022\129 \198\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\000\176\000\nn a\202\002\129 \198\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0000\000\nn a\2022\129 \198\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0000\004\026n c\202\002\131 \198\000\000\000\000@0\004\026m s\202\002\131 \198\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016B8@\161#\006\000\000\000\031(\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000p\004\026l c\202\002\131 \198\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\016\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000p\004\026l c\202\002\131 \198\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0002\000\nn a\202\002\129 \198\000\000\000\000@\000\000\000\000\b\016\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016@9@\161#\006\000\000\000\031(\000\000\000\000@\000\000\000\000\000\016\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000p\004\026l c\202\002\131 \198\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\000\000\000\000\000 \000\000\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000@0\004\no q\202\006\129 \198\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\016\000\b@\001\001\002\000\000\000\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000@0\004\no q\202\006\129 \198\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\016\000\b@\001\001\002\000\000\000\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\250\005\027n\160c\219?\131 \198\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@0\004\no q\202\006\129 \198\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\016\000\b@\001\001\002\000\000\000\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\250\005\027n\160c\219?\131 \198\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0000\000\nn a\202\006\129 \198\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0000\004\nn a\202\002\129 \198\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\016\000\b@\001\001\002\000\000\000\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\016\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000p\004\026l c\202\002\131 \198\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@0\004\no q\202\006\129 \198\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\016\000\b@\001\001\002\000\000\000\011\b\000\000\000\000@\000\000\000\000\000\016\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000p\004\026l c\202\002\131 \198\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0000\000\nn a\202\006\129 \198\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0000\004\nn a\202\002\129 \198\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\016\000\b@\001\001\002\000\000\000\011\b\000\000\000\000@\000\000\000\000\000\016\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000p\004\026l c\202\002\131 \198\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0000\004\026l c\202\002\131 \198\000\000\000\000\016@<@\161#\006\000\000\000\031(\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0000\004\026l c\202\002\131 \198\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0000\004\026l c\202\002\131 \198\000\000\000\000\000\000\000\000\000 \002\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0000\004\026l c\202\002\131 \198\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0000\004\026l c\202\002\131 \198\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0000\004\nl c\202\002\130 \198\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0000\004\026l c\202\002\131 \198\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0000\004\026l c\202\002\131 \198\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0000\004\026l c\202\002\131 \198\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0000\004\026l c\202\002\131 \198\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0000\004\026l c\202\002\131 \198\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0000\004\026l c\202\002\131 \198\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0000\004\026l c\202\002\131 \198\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0000\004\026h #J\002\131 \198\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0000\004\026l c\202\002\131 \198\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0000\004\026l c\202\002\131 \198\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\016@8@\177#\006\000\000\000\031(\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0000\004\026l c\202\002\131 \198\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0000\004\026h #J\002\131 \198\000\000\000\000\016@8@\177#\006\000\000\000\031(\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0000\004\026l c\202\002\131 \198\000\000\000\000\016@8@\177#\006\000\000\000\031(\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0000\004\026l c\202\002\131 \198\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0000\004\026l c\202\002\131 \198\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0000\004\026l c\202\002\131 \198\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0000\004\nl c\202\002\130 \198\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\002\000\000\000\000\000\000\016@9@\161#\006\000\000\000\031(\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\016\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000p\004\026l c\202\002\131 \198\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000p\004\026l c\202\002\131 \198\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0000\004\026l c\202\002\131 \198\000\000\000\000\0000\004\026l c\202\002\131 \198\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\n @\000\b\018\000\000\002\000\001\000\000\000\000\016@9@\161#\006\000\000\000\031(\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\016\000\b@\001\001\002\000\000\000\011\b\000\000\000\000\000\002\000\000\000\000\000\000\000\002\000\000\000\000\000\000\016\000\b@\001\001\002\000\000\000\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\016\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\250\005\027n\160c\219?\131 \198\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@0\004\no q\202\006\129 \198\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\016\000\b@\001\001\002\000\000\000\011\b\000\000\000\000@\000\000\000\000\000\016\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\250\005\027n\160c\219?\131 \198\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0000\000\nn a\202\006\129 \198\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0000\004\nn a\202\002\129 \198\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\016\000\b@\001\001\002\000\000\000\011\b\000\000\000\000@\000\000\000\000\000\016\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\250\005\027n\160c\219?\131 \198\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\186\005\027n\160c\219?\131 \198\000\000\000\000\0002\000\nn a\202\002\129 \198\000\000\000\000@\000\000\000\000\b\016\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016@9@\161#\006\000\000\000\031(\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\016\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\250\005\027n\160c\219?\131 \198\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\250\005\027n\160c\219?\131 \198\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\176\000\nn a\202\002\129 \198\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0000\000\nn a\2022\129 \198\000\000\000\000\000\000\000\000\000\000\000\000\016\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\002\186\005\027n\160c\219?\131 \198\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0002\000\nn a\202\002\131 \198\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\186\005\027n\160c\219?\131 \198\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0002\000\nn a\202\002\129 \198\000\000\000\000@\000\000\000\000\000\016\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\250\005\027n\160c\219?\131 \198\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0002\000\nn a\202\002\129 \198\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\b\000\000\000\004\000\004\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000@\001 \002\004\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\016\000\b@\001\001\002\000\000\000\011\b\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016\000\t@\001\001\002\000\000\000\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000 @\001 \002\004\000\000\000\000\000\000\000\000\016\002\b@\001\001\002\000\000\000\011\b\000\000\000\000\000\b\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\016\002\b@\001\001\002\000\000\000\011\b\000\000\000\000\000\000 @\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\016\002\b@\001\001\002\000\000\000\011\b\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0000\000\nn\160a\202\003\129 \198\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0000\000\nn a\202\003\129 \198\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\b\000\000\001\000\000\000\000\000\000\000\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\b\000\000\001\000\000\000\000\000\000\000\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0002\000\nn a\202\002\129 \198\000\000\000\000\000\000 \000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000@\000\000\001\000\002\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\016H8@\161#\006\000\000\000\031(\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\003 \000\004\002\000\000\000\000\000\000\000\016B8@\161#\006\000\000\000\031(\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000 \000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000 \000\003 \002\004\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000 @! \002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000 @! \002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\004\000\002 \000\000\002\002\000\000\000\000\000\000\016@8@\161#\006@\000\000\031(\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016@<@\161#\006\000\000\000\031(\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000 \002\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000 @! \002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000H\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000 \000\003 \002\004\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\016\000\b@\001\001\002\000\000\000\011\b\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0002\000\nn a\202\002\129 \198\000\000\000\000\000\000 \000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000 \000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0002\000\nn a\202\002\129 \198\000\000\000\000\000\000 \000\000\b\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000 \000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000 \000\000\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000@0\004\no q\202\006\129 \198\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\016\000\b@\001\001\002\000\000\000\011\b\000\000\000\000\000\000 \000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002 \000\004\002\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\004\000\002\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@0\004\no q\202\006\129 \198\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\016\000\b@\001\001\002\000\000\000\011\b\000\000\000\000\000\000 \000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\004\000\002\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0000\000\nn a\202\006\129 \198\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0000\004\nn a\202\002\129 \198\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\016\000\b@\001\001\002\000\000\000\011\b\000\000\000\000\000\000 \000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\004\000\002\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\004\000\002\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016@9@\161#\006\000\000\000\031(\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\004\000\002\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\004\000\002\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\004\000\002\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000 \000!\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000 \000!\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000 \000!\000\002\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000 \000!\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000 \000!\000\002\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\002\004\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0002\000\nn a\202\002\129 \198\000\000\000\000\000\000 \000\000\b\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016@9@\161#\006\000\000\000\031(\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000@0\004\no q\202\006\129 \198\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\016\000\b@\001\001\002\000\000\000\011\b\000\000\000\000\000\000 \000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@0\004\no q\202\006\129 \198\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\016\000\b@\001\001\002\000\000\000\011\b\000\000\000\000\000\000 \000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0000\000\nn a\202\006\129 \198\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0000\004\nn a\202\002\129 \198\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\016\000\b@\001\001\002\000\000\000\011\b\000\000\000\000\000\000 \000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016B8@\161#\006\000\000\000\031(\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\004\000\002\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\004\000\002\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016B8@\161#\006\000\000\000\031(\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\004\000\002\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\004\000\002\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0002\000\nn a\202\002\129 \198\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\004\000\002\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\000\176\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\018\001\0008\011\024@\000\000\000\181\005\168@!!\150 0xK\024@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0020\000\nn a\202\n\129 \198\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0000\000\nn\160a\203\002\129 \198\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0000\000\nn a\203\002\129 \198\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0000\000\011n a\202\002\129 \198\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000 \000\000\000\000\000\000\004\000\000\000\000\000@\000\000\000\000\000\000\000@0@0\n\002\000\000\000\020\000\000\000\000\000\177\005(@!!\022\017\000:\011\028\000\000\000\000\000@0@0\n\002\000\000\000\020\000\000\000\000\000\177\005(@!!\022\017\000:\011\028\000\000\000\000\000@0@0\n\002\000\000\000\020\000\000\000\000\000\177\005(@!!\022\017\000:\011\028\000\000\000\000\000@0@0\n\002\000\000\000\020\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\177\005(@!!\022\017\000:\011\028\000\000\000\000\000@0@0\n\002\000\000\000\020\000\000\000\000\000\177\005(@!!\022\017\000:\011\028\000\000\000\000\000@0@0\n\002\000\000\000\020\000\000\000\000\000\177\005(@!!\022\017\000:\011\028\000\000\000\000\000@0@0\n\002\000\000\000\020\000\000\000\000\000\016@8@\177#\006\000\000\000\031(\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\177\005(@!!\022\017\000:\011\028\000\000\000\000\000@0@0\n\002\000\000\000\020\000\000\000\000\000\177\005(@!!\022\017\000:\011\028\000\000\000\000\000@0@0\n\002\000\000\000\020\000\000\000\000\000\177\005(@!!\022\017\000:\011\028\000\000\000\000\000@0@0\n\002\000\000\000\020\000\000\000\000\000\177\005(@!!\022\017\000:\011\028\000\000\000\000\000@0@0\n\002\000\000\000\020\000\000\000\000\000\177\005(@!!\022\017\000:\011\028\000\000\000\000\000@0@0\n\002\000\000\000\020\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\177\005(@!!\022\017\0008\011\028\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\000\176\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\018\000\0008\011\024\000\000\000\000\000\000\000\000\000\000\000\0010\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\000\176\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\018\000\0008\011\024\000\000\000\000\000\000\000\000\000\000\000\0010\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\016\000\000\000 \000\000\000\000\000\000\004\000\000\000\000\000@\000\000\000\000\000\000\177\005(@!!\018\001\0008\011\024 \000\000\000\000\000\000\004\000\000\128\000\000@\000\000@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000 \000\000\000\000\000\000\004\000\000\000\000\000@\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\001\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\000\176\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\018\000\0008\011\024\000\000\000\000\000\000\000\000\000\000\000\0010\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\016\000\000\000@\000\000\000\181\005\168@!!\022 \000xK\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\177\005(@!!\018\000\0008\011\024\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000@\000\000\000\181\005\168@!!\022 \000xK\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\181\005\168@!!\022 \000xK\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\001\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\000\176\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\018\000\0008\011\024\000\000\000\000\000\000\000\000\000\000\000\0010\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\016\000\000\000 \000\000\000\000\000\000\004\000\000\000\000\000@\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\177\005(@!!\018\000\0008\011\024\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000 \000\000\000\000\000\000\004\000\000\000\000\000@\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\000\000\000\004\000\000\000\000\000@\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\177\005(@!!\018\000\0008\011\024\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000 \000\000\000\000\000\000\004\000\000\000\000\000@\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\177\005(@!!\022\001\0008\011\024\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\000\176\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\018\000\0008\011\024\000\000\000\000\000\000\000\000\000\000\000\0010\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\016\000\000\000 \000\000\000\000\000\000\004\000\000\000\000\000@\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\177\005(@!!\018\000\0008\011\024\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000 \000\000\000\000\000\000\004\000\000\000\000\000@\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\000\000\000\004\000\000\128\000\000@\000\000@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000 \000\000\000\000\000\000\004\000\000\000\000\000@\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\001\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\000\176\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\018\000\0008\011\024\000\000\000\000\000\000\000\000\000\000\000\0010\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\016\000\000\000 \000\000\000\000\000\000\004\000\000\000\000\000@\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\177\005(@!!\018\000\0008\011\024\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000 \000\000\000\000\000\000\004\000\000\000\000\000@\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\000\000\000\004\000\000\000\000\000@\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\000\000\000\004\000\000\128\000\000@\000\000@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000 \000\000\000\000\000\000\004\000\000\000\000\000@\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0000\000\nn a\218\002\129 \198\000\000\000\000\177\005(@!!\022\001\0008\011\024\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\000\176\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\018\000\0008\011\024\000\000\000\000\000\000\000\000\000\000\000\0010\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\016\000\000\000 \000\000\000\000\000\000\004\000\000\000\000\000@\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\177\005(@!!\018\000\0008\011\024\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000 \000\000\000\000\000\000\004\000\000\000\000\000@\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\000\000\000\004\000\000\128\000\000@\000\000@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000 \000\000\000\000\000\000\004\000\000\000\000\000@\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\001\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\000\176\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\018\000\0008\011\024\000\000\000\000\000\000\000\000\000\000\000\0010\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\016\000\000\000 \000\000\000\000\000\000\004\000\000\000\000\000@\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\177\005(@!!\018\000\0008\011\024\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000 \000\000\000\000\000\000\004\000\000\000\000\000@\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\000\000\000\004\000\000\000\000\000@\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\001\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\000\176\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\018\000\0008\011\024\000\000\000\000\000\000\000\000\000\000\000\0010\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\016\000\000\000 \000\000\000\000\000\000\004\000\000\000\000\000@\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\177\005(@!!\018\000\0008\011\024\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000 \000\000\000\000\000\000\004\000\000\000\000\000@\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\000\000\000\004\000\000\000\000\000@\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000@\000\000\000\181\005\168@!!\022 \000xK\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000@\000\000\000\181\005\168@!!\022 \000xK\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000@\000\000\000\181\005\168@!!\022 \000xK\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0000\000\nn\160a\203\002\129 \198\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0000\000\nn a\203\002\129 \198\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000@\000\000\000\181\005\168@!!\022 \000xK\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000@\000\000\000\181\005\168@!!\022 \000xK\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000@\000\000\000\181\005\168@!!\022 0xK\024\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\000\176\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\018\001\0008\011\024@\000\000\000\181\005\168@!!\150 \176xK\024@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000@\000\000\000\181\005\168@!!\022 \176xK\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\001\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\000\176\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\018\000\0008\011\024\000\000\000\000\000\000\000\000\000\000\000\0010\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\016\000\000\000@\000\000\000\181\005\168@!!\022 \176xK\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\177\005(@!!\018\000\0008\011\024\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000@\000\000\000\181\005\168@!!\022 \176xK\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\181\005\168@!!\022 \176xK\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\181\005\168@!!\022 \016xK\024\000\000\000\000\177\005(@!!\018\001\0008\011\024@\000\000\000\181\005\168@!!\150 \000xK\024@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000@\000\000\000\181\005\168@!!\022 \000xK\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\001\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\000\176\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\018\000\0008\011\024\000\000\000\000\000\000\000\000\000\000\000\0010\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\016\000\000\000@\000\000\000\181\005\168@!!\022 \000xK\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\177\005(@!!\018\000\0008\011\024\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000@\000\000\000\181\005\168@!!\022 \000xK\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\181\005\168@!!\022 \000xK\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\181\005\168@!!\022 \016xK\024\000\000\000\000\177\005(@!!\018\001\0008\011\024@\000\000\000\181\005\168@!!\150 \000xK\024@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000@\000\000\000\181\005\168@!!\022 \000xK\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\001\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\000\176\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\018\000\0008\011\024\000\000\000\000\000\000\000\000\000\000\000\0010\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\016\000\000\000@\000\000\000\181\005\168@!!\022 \000xK\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\177\005(@!!\018\000\0008\011\024\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000@\000\000\000\181\005\168@!!\022 \000xK\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\181\005\168@!!\022 \000xK\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\0010\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\000\176\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\018\000\0008\011\024\000\000\000\000\000\000\000\000\000\000\000\0010\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\016\000\000\000@\000\000\000\181\005\168@!!\022 0xK\024@\000\000\000\181\005\168@!!\022 \016xK\024\000\000\000\000\177\005(@!!\018\001\0008\011\024@\000\000\000\181\005\168@!!\150 \000xK\024@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000@\000\000\000\181\005\168@!!\022 \000xK\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\001\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\000\176\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\018\000\0008\011\024\000\000\000\000\000\000\000\000\000\000\000\0010\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\016\000\000\000@\000\000\000\181\005\168@!!\022 \000xK\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\177\005(@!!\018\000\0008\011\024\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000@\000\000\000\181\005\168@!!\022 \000xK\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\181\005\168@!!\022 \000xK\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\177\005(@!!\018\000\0008\011\024\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000@\000\000\000\181\005\168@!!\022 0xK\024@\000\000\000\181\005\168@!!\022 \016xK\024\000\000\000\000\177\005(@!!\018\001\0008\011\024@\000\000\000\181\005\168@!!\150 \000xK\024@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000@\000\000\000\181\005\168@!!\022 \000xK\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\001\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\000\176\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\018\000\0008\011\024\000\000\000\000\000\000\000\000\000\000\000\0010\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\016\000\000\000@\000\000\000\181\005\168@!!\022 \000xK\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\177\005(@!!\018\000\0008\011\024\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000@\000\000\000\181\005\168@!!\022 \000xK\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\181\005\168@!!\022 \000xK\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\181\005\168@!!\022 0xK\024@\000\000\000\181\005\168@!!\022 \016xK\024\000\000\000\000\177\005(@!!\018\001\0008\011\024@\000\000\000\181\005\168@!!\150 \000xK\024@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000@\000\000\000\181\005\168@!!\022 \000xK\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\001\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\000\176\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\018\000\0008\011\024\000\000\000\000\000\000\000\000\000\000\000\0010\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\016\000\000\000@\000\000\000\181\005\168@!!\022 \000xK\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\177\005(@!!\018\000\0008\011\024\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000@\000\000\000\181\005\168@!!\022 \000xK\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\181\005\168@!!\022 \000xK\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016\000\000\000\000\000\000\000\177\005(@!!\018\000\0008\011\024\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000@\000\000\000\181\005\168@!!\022 \000xK\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn\160a\202\002\129 \198\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000@\000\000\000\181\005\168@!!\022 \000xK\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000@\000\000\000\181\005\168@!!\022 \000xK\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000 \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0000\000\nn a\203\002\129 \198 \000\000\000\000\000\000\004\000\000\128\000\000@\000\000@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000 \000\000\000\000\000\000\004\000\000\000\000\000@\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000@\000\000\000\000\000\000\177\005(@!!\018\001\0008\011\024\000\000\000\000\000\000\000\000\000\000\128\000\000@\000\000@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000@\000\000\000\181\005\168@!!\022 \000xK\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\181\005\168@!!\022 \000xK\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\001\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\000\176\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\018\000\0008\011\024\000\000\000\000\000\000\000\000\000\000\000\0010\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\016\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000@\000\000\000\181\005\168@!!\022 \000xK\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\177\005(@!!\018\000\0008\011\024\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000@\000\000\000\181\005\168@!!\022 \000xK\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000@\000\000\000\181\005\168@!!\022 \000xK\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\181\005\168@!!\022 \000xK\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000@\000\000\000\181\005\168@!!\022 \000xK\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000@\000\000\000\181\005\168@!!\022 \000xK\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000 @\001 \002\004\000\000\000\000\000\000\000\000\016\002\b@\001\001\002\000\000\000\011\b\000\000\000\000\000\b\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000@\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\001\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\016\000\b@\001\001\002\000\000\000\011\b\000\000\000\000\000\000 @\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\016\000\b@\001\001\002\000\000\000\011\b\000\000\000\000\000\000 @\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\016\000\b@\001!\002\000\000\000\011\b\000\000\000\000\000\000 @\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0000\004\nn a\202\006\129 \198\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000 @\000\000\002\000\000\000\000\000\000\000\000\000\000\b\000\000\001 \000\005\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016\002\b@\001\001\002\000\000\000\011\b\000\000\000\000\000\b\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\024\000(@\001\001\130\000\192\012\011\b@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\002\004\000\000\000\000\000\000\002\000\000\000\000\000\000\016\000\b@\001\001\002\000\000\000\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\024\000(@\001\001\130\000\192\012\011\b@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016\000\012@\001\001\002\000\000\000\011\b\000\000\000\000\000\b\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\024\000(@\001\001\130\000\192\012\011\b@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\024\000(@\001\001\130\000\192\012\011\b@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\128\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\024\b(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\b\000\000\001 \000\005\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016\002\b@\001\001\002\000\000\000\011\b\000\000\000\000\000\b\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\024\000(@\001\001\130\000\192\012\011\b@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\024\000(@\001\001\130\000\192\012\011\b@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016\000\012@\001\001\002\000\000\000\011\b\000\000\000\000\000\b\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\024\000(@\001\001\130\000\192\012\011\b@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\024\000(@\001\001\130\000\192\012\011\b@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\128\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\024\b(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\001 \000\005\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016\002\b@\001\001\002\000\000\000\011\b\000\000\000\000\000\b\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\024\000(@\001\001\130\000\192\012\011\b@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\024\000(@\001\001\130\000\192\012\011\b@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016\000\012@\001\001\002\000\000\000\011\b\000\000\000\000\000\b\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\024\000(@\001\001\130\000\192\012\011\b@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\024\000(@\001\001\130\000\192\012\011\b@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\128\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\024\b(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0000\004\nn a\202\002\129 \198\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0000\004\nn a\202\006\129 \198\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0000\004\nn a\202\002\129 \198\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0000\004\nn a\202\006\129 \198\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0000\004\nn a\202\002\129 \198\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\024\000(@\001\001\130\000\192\012\011\b@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\024\000(@\001\001\130\000\192\012\011\b@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016\000\012@\001\001\002\000\000\000\011\b\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\016\000\b@\001\001\002\000\000\000\011\b\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\024\000(@\001\001\130\000\192\012\011\b@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\001\000\000\000\000\000\000\004\000\000\000\000\000\000\002\000\000\000\000\000\000\016\000\b@\001\001\002\000\000\000\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\002\000\000\000\000\000\000\016\000\b@\001\001\002\000\000\000\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\016\000\b@\001\001\002\000\000\000\011\b\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\024\000(@\001\001\130\000\192\012\011\b@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016\000\b@\001\001\002\000\000\000\011\b\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\024\000(@\001\001\130\000\192\012\011\b@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\016\002\b@\001\001\002\000\000\000\011\b\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\016\002\b@\001\001\002\000\000\000\011\b\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\024\000(@\001\001\130\000\192\012\011\b@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\024\000(@\001\001\130\000\192\012\011\b@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016\000\012@\001\001\002\000\000\000\011\b\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\016\000\b@\001\001\002\000\000\000\011\b\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\024\000(@\001\001\130\000\192\012\011\b@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\016\000\b@\001\001\002\000\000\000\011\b\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\024\000(@\001\001\130\000\192\012\011\b@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016\000\b@\001\001\002\000\000\000\011\b\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\024\000(@\001\001\130\000\192\012\011\b@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016\002\b@\001\001\002\000\000\000\011\b\000\000\000\000\000\b\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\024\000(@\001\001\130\000\192\012\011\b@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\024\000(@\001\001\130\000\192\012\011\b@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016\000\012@\001\001\002\000\000\000\011\b\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\016\000\b@\001\001\002\000\000\000\011\b\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\024\000(@\001\001\130\000\192\012\011\b@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\016\000\b@\001\001\002\000\000\000\011\b\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\024\000(@\001\001\130\000\192\012\011\b@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\016\000\b@\001\001\002\000\000\000\011\b\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016\000\b@\001\001\002\000\000\000\011\b\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\024\000(@\001\001\130\000\192\012\011\b@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\016\000\b@\001\001\002\000\000\000\011\b\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\002\000\000\000\000\000\000\016\002\b@\001\001\002\000\000\000\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016\000\b@\001\001\002\000\000\000\011\b\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\004\000\004\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\016\000\b@\001\001\002\000\000\000\011\b\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016\000\b@\001\001\002\000\000\000\011\b\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\181\005\168@!!\022!\1288K\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\181\005\168@!!\022 \1288K\024\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0000\000\nn\160a\202\003\129 \198\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0000\000\nn a\202\003\129 \198\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000@\000\000\000\181\005\168@!!\022 \1288K\024\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000 \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000@\000\000\000\000\000\000\177\005(@!!\018\001\0008\011\024\000\000\000\000\000\000\000\000\000\000\128\000\000@\000\000@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000@\000\000\000\181\005\168@!!\022 \1288K\024\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn\160a\202\002\129 \198\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000@\000\000\000\181\005\168@!!\022 \1288K\024\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\000\176\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\018\001\0008\011\024@\000\000\000\181\005\168@!!\150 \1768K\024@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000@\000\000\000\181\005\168@!!\022 \1768K\024@\000\000\000\181\005\168@!!\022 \1448K\024\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0020\000\nn a\202\n\129 \198\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0000\000\nn\160a\203\002\129 \198\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0000\000\nn a\203\002\129 \198\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000@\000\000\000\181\005\168@!!\022 \1288K\024\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0000\000\011n a\202\002\129 \198\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000 \000\000\000\000\000\000\004\000\000\000\000\000@\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000@\000\000\000\181\005\168@!!\022 \1288K\024\000\000\000\000\000\000\000\000\000\000\004\001\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\000\176\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\018\000\0008\011\024\000\000\000\000\000\000\000\000\000\000\000\0010\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\016\000\000\000@\000\000\000\181\005\168@!!\022 \1288K\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\177\005(@!!\018\000\0008\011\024\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000@\000\000\000\181\005\168@!!\022 \1288K\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\181\005\168@!!\022 \1288K\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000@\000\000\000\181\005\168@!!\022 \1288K\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0000\000\nn\160a\203\002\129 \198\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0000\000\nn a\203\002\129 \198\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000@\000\000\000\181\005\168@!!\022 \1288K\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000@\000\000\000\181\005\168@!!\022 \1288K\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\177\005(@!!\018\001\0008\011\024@\000\000\000\181\005\168@!!\150 \1288K\024@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000@\000\000\000\181\005\168@!!\022 \1288K\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\001\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\000\176\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\018\000\0008\011\024\000\000\000\000\000\000\000\000\000\000\000\0010\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\016\000\000\000@\000\000\000\181\005\168@!!\022 \1288K\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\177\005(@!!\018\000\0008\011\024\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000@\000\000\000\181\005\168@!!\022 \1288K\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\181\005\168@!!\022 \1288K\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\181\005\168@!!\022 \1448K\024\000\000\000\000\177\005(@!!\018\001\0008\011\024@\000\000\000\181\005\168@!!\150 \1288K\024@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000@\000\000\000\181\005\168@!!\022 \1288K\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\001\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\000\176\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\018\000\0008\011\024\000\000\000\000\000\000\000\000\000\000\000\0010\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\016\000\000\000@\000\000\000\181\005\168@!!\022 \1288K\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\177\005(@!!\018\000\0008\011\024\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000@\000\000\000\181\005\168@!!\022 \1288K\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\181\005\168@!!\022 \1288K\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\0010\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\000\176\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\018\000\0008\011\024\000\000\000\000\000\000\000\000\000\000\000\0010\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\016\000\000\000@\000\000\000\181\005\168@!!\022 \1768K\024@\000\000\000\181\005\168@!!\022 \1448K\024\000\000\000\000\177\005(@!!\018\001\0008\011\024@\000\000\000\181\005\168@!!\150 \1288K\024@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000@\000\000\000\181\005\168@!!\022 \1288K\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\001\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\000\176\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\018\000\0008\011\024\000\000\000\000\000\000\000\000\000\000\000\0010\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\016\000\000\000@\000\000\000\181\005\168@!!\022 \1288K\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\177\005(@!!\018\000\0008\011\024\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000@\000\000\000\181\005\168@!!\022 \1288K\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\181\005\168@!!\022 \1288K\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\177\005(@!!\018\000\0008\011\024\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000@\000\000\000\181\005\168@!!\022 \1768K\024@\000\000\000\181\005\168@!!\022 \1448K\024\000\000\000\000\177\005(@!!\018\001\0008\011\024@\000\000\000\181\005\168@!!\150 \1288K\024@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000@\000\000\000\181\005\168@!!\022 \1288K\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\001\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\000\176\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\018\000\0008\011\024\000\000\000\000\000\000\000\000\000\000\000\0010\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\016\000\000\000@\000\000\000\181\005\168@!!\022 \1288K\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\177\005(@!!\018\000\0008\011\024\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000@\000\000\000\181\005\168@!!\022 \1288K\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\181\005\168@!!\022 \1288K\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\181\005\168@!!\022 \1768K\024@\000\000\000\181\005\168@!!\022 \1448K\024\000\000\000\000\177\005(@!!\018\001\0008\011\024@\000\000\000\181\005\168@!!\150 \1288K\024@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000@\000\000\000\181\005\168@!!\022 \1288K\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\001\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\000\176\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\018\000\0008\011\024\000\000\000\000\000\000\000\000\000\000\000\0010\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\016\000\000\000@\000\000\000\181\005\168@!!\022 \1288K\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\177\005(@!!\018\000\0008\011\024\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000@\000\000\000\181\005\168@!!\022 \1288K\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\181\005\168@!!\022 \1288K\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016\000\000\000\000\000\000\000\177\005(@!!\018\000\0008\011\024\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000@\000\000\000\181\005\168@!!\022 \1288K\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000@\000\000\000\181\005\168@!!\022 \1288K\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\181\005\168@!!\022 \1288K\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\001\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\000\176\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\018\000\0008\011\024\000\000\000\000\000\000\000\000\000\000\000\0010\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\016\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000@\000\000\000\181\005\168@!!\022 \1288K\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\177\005(@!!\018\000\0008\011\024\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000@\000\000\000\181\005\168@!!\022 \1288K\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000@\000\000\000\181\005\168@!!\022 \1288K\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\181\005\168@!!\022 \1288K\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000@\000\000\000\181\005\168@!!\022 \1288K\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000")
  
  and start =
    2
  
  and action =
    ((16, "\028<\028L\000\000\203\198\000\127\194N\000q\194N\000\000\001\"\194\192\000\000\000\000\000A\000\000\001\212\000\000\000d\000\218\000C\000\000\1952\000\000\194N\194N\194N\1952\000\000\000\000\001\022\000\000\002\134\000\000\194N\000p\000\000\195\164\000\000\000\000\001$\000\000\0038\000\000\000\000\000\252\194N\002\002\000\000\003\234\000\000\194N\001\b\201\172\000\220\001\022)\248\001x\025v\000\000\001n\001\190\000\000\025v\000\000\000\000\000\000\001\224\194NM*\194N\n,\196\022\002\024\194NR\\\194N\n\222\000}\0004\000\000\000<\0004\000\000\002\130\000\000\000\000\194N\011\144\002r\000\000JV\000\000\194N\012B\194N\012\244\194N\r\166\194N\014X\194N\015\n\194N\015\188\194N\016n\194N\025x\194N\017 \194N\017\210\194N\026*\002\152\196\180\194N\196\180\000f\196\180\000\000R\\\194N\018\132\194N\026\220\194N\027\142\194N\000\000\0196\197R\000\000\019\232\194Ne\016\196\180\000\000\194N\020\154\194N\021L\194N\021\254\196\180\000\000\000\000\022\176\003.\000\000\000\000J\226\197R\000\000\003D\000\000R\232\194N\000\000\000\000\002x\000\000Kv\000\000\000\000\002\250\003,\029\252\000\000\197\196\000\000\004*\000\000L\n\000\000\196\022\196\022\194Ne\156\000\000\194N\004\154\000\000\195\164\000\000\004\152\000\000\000\000\002\202\000\000L\158\000\000\194NR\\\194NM*\194Ne\016\194NM*\000\000\004J\194NM*\030\136\000\000\1986\000\000\004\198\000\000M\190\000\000\000\000\003h\000\000NR\000\000\000\000\004\170\194Ne\016\000\028\000\000\196\022\003j\000\000N\230\000\000\196\022\004\188\202\030\005\030\005J*$\005\146\025v\000\000\005\168\202\144\005\152\005\240*P\006V\025v\000\000\004\156\000\000*\228\006l\025v\000\000\005N\000\000M*\194N\150\226\006n\025v\000\000\003|\000\000Oz\000\000+\016\006\148\025v\003\146\000\000P\014\000\000R\232\194N\151n\006\150\025v\003\158\000\000P\162\000\000St\198\168\000\000T\000\196\022T\140\000o\001P\000\000\006\184\000\000\000\000\196\022U\024\196\022U\164\196\022\151\250\196\022V0\196\022V\188\196\022WH\196\022W\212\196\022X`\196\022X\236\196\022Yx\196\022\192D\196\022Z\004\196\022Z\144\006\154\196\180\006\214\000\000\196\022[\028\196\022\192\208\199F\000\000[\168\199\228\000\000\\4\196\022\000\000\196\022\\\192\196\022]L\196\022\000\000\196\022\152\132\196\022\000\000\006\240\000\000\006\176\001\224\198\168\000\000\000\000\006\248\003\170\000\000Q6\000\000Q\202\000\000]\216^d\0070\000\000 \254\196\022\0078\000\000\006\206\025v\001&\025v\000\000\007b\000\000\003\184\000\000\006\000\000\000+<\007D\025v\003\202\000\000\006\178\000\000e\016\194N\153\014\007F\025v\003\214\000\000\007d\000\000\023b\149\208\000j\000\000\196\022\007X\003\220\000\000\b\022\000\000\b\200\000\000\007l\000\000\150V\194NM*\007\004\194N\024\020\007b\000\000f(\000\000\194N\007t\000\000\024\198\007x\000\000\007z\000\000\150V\003\222\000\000\tz\000\000\150\226\000\000\000\234\007\012\0072\000\016\007&\203\198\000\023\007\030\007F\007^\025v\007N\007\164\025v\000\000\007\144\007\168\007D\203\198\0078\007^\000;\025v\003\020\007N\203\198\026\218\000~\007\128\030\212\007Z\007~\031F\194NM*\194NR\\\007f\007\134\031F\000zf\206\001\238gZ\007\168\194N\151n\0036\007~\194NR\\g\230\007\142\007\228hr\000\184\007\230h\254\194Ni\138\000\137\200V\007\236j\022\003\166\007\140\194N\153\014j\162\007~\007\160\001\168\007\148\194N\153\160k.\000\000\0262\000\000\007\132\007\166\000\000\0262\000\000\007\238\000\000\000=\196\022\000\000\007\168\000\000\199F\000\000\007\242\000\000\003\156\002\178\000\000\007\250\000\000\000\000\0262\000\000\b\020\000\000\003\174\007\186\194N\1542k\186\000@\b\030lF\002Z\007\190\194N\154\196l\210\194N\155Vm^\b\"m\234%:\007\238\194N\153\014\003\230\007\196\194N\155\232nv\003\232\007\200\194N\156zo\002\007\248\194N\153\160\0010\007\206\194N\157\012o\142\003\242\007\208\194N\157\158p\026\194N\1580p\166\007\252\203\002\007\202\007\240+\208\b&\025v\003\248\007\238\194N\158\194q2\000\000\000*\194N\159Tq\190\000\000\001\006\194N\159\230rJ\000\000\bTr\214\000\000,\\\b0\025v\004\000\007\246\194N\160xsb\000\000\001~\194N\161\ns\238\000\000\bZtz\000\000\150V\194N\161\150\b6\025v\004\020\007\252\194N\162(u\006\000\000\001\172\194N\162\186u\146\000\000\bdv\030\000\000\000\000\000\000\001\178\194N\163Lv\170\000\000\bfw6\000\000\000\000\196\022\bR\004$\b\016\194N\163\222w\194\000\000\001\218\194N\164pxN\000\000\bxx\218\000\000\001\240\194N\165\002yf\000\000\b~y\242\000\000\000\000\002\026\194N\165\148z~\000\000\b\128{\n\000\000\000\000\b.\194N\166&{\150\000\000\004&\b0\194N\166\184|\"\000\000\b2\194N\167J|\174\000\000\b\"\bD\004,\b<\194N\167\220}:\000\000\b>\194N\168n}\198\000\000\001\148\000\000\000\000\001\148\000\000\b \001\148\b\162\000\000\004\014\001\148\000\000\b$\001\148\b\166\bJ\194N\169\000~R\000\000\004X\bP\194N\169\146~\222\000\000\bR\194N\170$\127j\000\000\002\128\bT\194N\170\182\127\246\000\000\b\\\194N\171H\128\130\000\000\194N\171\218\129\014\000\000\004`\bh\194N\172l\129\154\000\000\bl\194N\172\254\130&\000\000\b\154\194N\1542\002\022\bp\194N\173\144\130\178\000\000\196\022\b\190\004p\bt\194N\174\"\131>\000\000\bv\194N\174\180\131\202\000\000\bz\194N\175F\132V\000\000\004~\b~\194N\175\216\132\226\000\000\b\128\194N\176j\133n\000\000\b\168\203t\bv\b\156,\232\b\208\025v\004\150\b\156\194N\176\252\133\250\000\000\b\160\194N\177\142\134\134\000\000-t\b\224\025v\004\152\b\166\194N\178 \135\018\000\000\b\168\194N\178\178\135\158\000\000\150\226\194N\179>\b\230\025v\004\154\b\172\194N\179\208\136*\000\000\b\174\194N\180b\136\182\000\000\000\000\000\000\000\000\200\200\t\022\137B\000\000\t\020\t\026\137\206\000\000\002\160\194N\180\244\138Z\000\000\t$\138\230\000\000\000\000\139r\000\000\b\214\t,\t2\139\254\000\000\000\000\002\162\194N\181\134\140\138\000\000\tB\141\022\000\000\000\000\201:\tD\141\162\000\000\tB\tH\142.\000\000\002\238\194N\182\024\142\186\000\000\tJ\143F\000\000\000\000\003\022\194N\182\170\143\210\000\000\tP\144^\000\000\000\000\tN\tV\144\234\000\000\000\000\183<\145v\000\000\000\000\194N\154\196\tX\146\002\000\000\tZ\146\142\000\000\000\000\000\000\003\028\194N\183\206\147\026\000\000\t\\\147\166\000\000\000\000\tZ\td\1482\000\000\000\000\tb\th\148\190\000\000\t\n\t4\031F\t\026\t:\031F\194N\150\226\031F\029\014\031F\t0\t$\194NM*\194NR\\\194NM*\t@\031F\194NM*\t$\tF\001D\210\014_\n\210\014_\150\210\014`\"\210\014\t\030\t@`\174\210\014a:\210\014a\198\210\014\196\180\t\128bR\210\014b\222\210\014cj\210\014c\246\210\014d\130\210\014\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\149J\194N\151n\031F\000\018\194N\153\014\031F\000\018\000\000\003f\001D \000\001D\031F\t\"\001D\000\000\001p\194N\153\160\031F\000\018\004\004.2\000\000\031F\t<.\236\000\000/\166\000\000\000\000\002\244\194N\1542\031F\000\018\004\024\001D\000\000\031F\tB\001D\000\000\001D\000\000\000\000\031F\tJ\001D\000\000\193@\194N\154\196\031F\000\018\004B\001D\000\000\031F\tN\001D\000\000\001\246\031F\t>\001D\000\000\000\000\003p\194N\155V\031F\000\018\004P\001D\000\000\031F\tT\001D\000\000\001D\000\000\002\168\031F\tB\001D\000\000\000\000\194NM*\193\194\194N\155\232\031F\000\018\004p\001D\000\000\031F\tX\001D\000\000\002\198\031F\tF\001D\000\000\000\000\004\000\194N\156z\031F\000\018\004t\001D\000\000\031F\t\\\001D\000\000\001D\000\000\004\"\194N\157\012\031F\000\018\004v\001D\000\000\031F\tb\001D\000\000\001D\000\000\tP0`\000\000\tR1\026\000\000\t\142\031F\tb1\212\000\000\194NR\232\194Ne\016\t\154\031F\tj2\142\000\000\t\172\031F\t|3H\000\000\t~\029\006\194N\157\158 \186\029\006\031F\t\128\029\006\000\000\000\000\004\178\194N\1580\031F\000\018\004\152\029\006\000\000\031F\t\150\029\006\000\000\029\006\000\000\031F!t \000\031F\t\1364\002\000\000\000\000\004\196\194N\158\194\031F\000\018\004\1824\188\000\000\031F\t\1585v\000\00060\000\000\000\000 \186\".!t\031F\t\1426\234\000\000\000\000\004\200\194N\159T\031F\000\018\004\1847\164\000\000\031F\t\1648^\000\0009\024\000\000\000\000\000\163\194N\159\230\031F\000\018\004\202\029\006\".\"\232\"\232\031F\t\1469\210\000\000\000\000\004\234\194N\160x\031F\000\018\004\204:\140\000\000\031F\t\168;F\000\000<\000\000\000\000\000\031F\t\170\029\006#\162#\162$\\\031F\t\156<\186\000\000\000\000\004\242\194N\161\n\031F\000\018\004\238=t\000\000\031F\t\178>.\000\000>\232\000\000\000\000\029\006%\022$\\%\208\031F\t\160?\162\000\000\000\000\005\004\194N\161\150\031F\000\018\004\244@\\\000\000\031F\t\188A\022\000\000A\208\000\000\000\000\t\184\031F\t\200B\138\000\000\t\184\nN\194Ne\016\t\208CD\000\000\194N\184`\t\210C\254\000\000\t\192\t\180\t\236\t\222\t\254\002\230\194Ne\156\002\230\031F\t\206\003T\000\000\000\000\005\n%\022\003\174\031F\t\212\t\218D\184\000\000Er\000\000\005\022\194N\162(\031F\000\018\004\248\t\224F,\000\000\031F\t\252\t\236F\230\000\000\t\240G\160\000\000HZ\000\000\t\242I\020\000\000\n\b\n(\031F\t\248I\206\000\000\t\250\203\198\000x\031j\005p\n\020\203\198\005\\\n\b\n*\nH\005v\002\182\005v\000\000\nx\n\148\n0\203\198\025v\000\246\nD\194N\184\242\nB\203\198\025v\001 \nH\194N\185\132\nF\203\198\025v\002\188\nr\194Ne\156\n\180\nP\203\198\0032\000\182\nT\203\198\000\000 $\005\136\nV\203\198\000\000\203\198\031F\nD\203\198\000\000\000\000\nl\002\150\025v\000\000\n\190\005\144\nb\203\198\000\000\204(\031F\nP\203\198\000\000\000\000\025v\005\156\nf\203\198\000\000\204z\031F\nZ\203\198\000\000\000\000\n\198\005\160\nz\203\198\000\000\204\170\031F\nj\203\198\000\000\000\000\194N\186\022\n\128\203\198\000\000\005\148\n\130\203\198\000\000\031F\np\204(\n\134\203\198\000\000\000\000\nz\n\158\000\194\n\144\203\198\000\000 \222\005\170\n\146\203\198\000\000\204\232\031F\n\128\203\198\000\000\000\000\n\252\005\182\n\160\203\198\000\000\205\024\031F\n\146\203\198\000\000\000\000\026\218\005\200\n\174\203\198\000\000\205V\031F\n\158\203\198\000\000\000\000\011\n\005\208\n\184\203\198\000\000\205\134\031F\n\166\203\198\000\000\000\000\194N\186\168\n\188\203\198\000\000\005\150\n\190\203\198\000\000\031F\n\172\204z\n\198\203\198\000\000\000\000\000\250\n\200\203\198\000\000!\152\005\216\n\202\203\198\000\000\205\196\031F\n\192\203\198\000\000\000\000\011<\005\224\n\224\203\198\000\000\205\244\031F\n\206\203\198\000\000\000\000\030\212\005\226\n\242\203\198\000\000\2062\031F\n\224\203\198\000\000\000\000\011J\005\234\n\248\203\198\000\000\206b\031F\n\230\203\198\000\000\000\000\194N\187:\011\000\203\198\000\000\005\204\011\002\203\198\000\000\031F\n\242\204\232\011\b\203\198\000\000\000\000\000\000\194N\187\198\011p\011\012\203\198\000\000\011\000\011&\011@\194Nf(\011~\011 \203\198\000\000\194N\188R\011\138\011,\203\198\000\000\011Z\194N\149\208\011\152\0114\203\198\000\000\194N\188\222\011\156\0118\203\198\000\000\000\000\011,\011P\011F\194N\189p\011D\203\198\000\000\011J\194N\190\002\011L\203\198\000\000\000\000\011D\011j\011d\194N\190\148\011d\203\198\000\000\011l\194N\191&\011j\203\198\000\000\000\000\011\146\005v\011\190\011\214\011r\203\198\000\000\000\000\206\160\031F\011d\203\198\000\000\000\000\011\220\005\236\011|\203\198\000\000\206\208\031F\011r\203\198\000\000\000\000-\192\011\144\025v\011\164\006\024\011\148\203\198\000\000\207\014\031F\011\144\203\198\000\000\000\000\000W\005\188\025v\000\000\011\184\005\246\025v\000\000\011\252\011\174\025v\011\190\006\026\011\178\203\198\000\000\207>\031F\011\160\203\198\000\000\000\000\025v\011\202\006\"\011\186\203\198\000\000\207|\031F\011\168\203\198\000\000\000\000\000\000\012 \011\192\011\228\031F\011\180\203\198\000\000\011\188\011\228\012\006\"R\011\222\012\000\031F\011\208\203\198\000\000\012H\011\232\012\b\031F\011\216\203\198\000\000\012 #\012\011\244\012\020\031F\011\228\203\198\000\000\012`\012\004\012(\031F\011\254\203\198\000\000\000\000\207\172\031F\012\002\203\198\000\000\000\000\012|\006(\012\028\203\198\000\000\207\234\031F\012\n\203\198\000\000\000\000^\152\012$\025v\0124\006:\012$\203\198\000\000\208\026\031F\012\022\203\198\000\000\000\000\012\128\0122\025v\012J\006B\012>\203\198\000\000\208X\031F\0120\203\198\000\000\000\000\025v\012X\006N\012V\203\198\000\000\208\136\031F\012D\203\198\000\000\000\000\000\000#\198\006\\\012Z\203\198\000\000\208\198\031F\012H\203\198\000\000\000\000\012\192\006h\012d\203\198\000\000\208\246\031F\012R\203\198\000\000\000\000f\\\012n\025v\012~\006\130\012n\203\198\000\000\2094\031F\012\\\203\198\000\000\000\000\012\198\012|\025v\012\140\006\138\012|\203\198\000\000\209d\031F\012p\203\198\000\000\000\000\012\174\025v\012\224\012\250\012\150\203\198\000\000\025v\012\170\006\144\012\154\203\198\000\000\209\162\031F\012\136\203\198\000\000\000\000\000\000\012\206\025v\012\180\005\138$\128\000\000\r\b\012\168\203\198\000\000\025v\r\016\012\176\203\198\000\000\002&\012\182\203\198\000\000\012\236\025v\r&\012\200\203\198\000\000\025v\r2\012\206\203\198\000\000\012\206\000\000\000\000\028L\000\000&\138\194Ne\156\194NR\232\012\210\012\242\031F\012\194&\138\012\220\012\252\031F\012\204\012\200\r\002\012\246\r\022\002\230\005\232%\208\006\"\031F\012\244\012\246&\138\r\012\r,\031F\012\252\r\150\194N\149\208\r\024&\138\194N\162\186&\138\029v\031F\r\b\029\006&\138\r0\r$\194NR\232\194Nf(\194N\149\208\r@\031F\r\016&\138\194NR\\\r*\rJ\001D\r\026&\138\006f\194N\163L\031F\000\018\0060&\138\000\000\031F\r6&\138\000\000&\138\000\000\000\000\000\000\rX\031F\r.&\138\000\000\194N\150V\194N\150\226\rd\031F\r4&\138\000\000\rh\031F\r8&\138\000\000'D&\138\031F\r:&\138\000\000\000\000\006n\194N\163\222\031F\000\018\006X&\138\000\000\031F\rP&\138\000\000&\138\000\000\000\000'D'\254'D\031F\r@&\138\000\000\000\000\006\142\194N\164p\031F\000\018\006\140&\138\000\000\031F\rX&\138\000\000&\138\000\000\000\000\001J\194N\165\002\031F\000\018\006\146\029\006'\254(\184'\254\031F\rF&\138\000\000\000\000\006\200\194N\165\148\031F\000\018\006\174&\138\000\000\031F\r\\&\138\000\000&\138\000\000\000\000\031F\rb\029\006(\184)r(\184\031F\rT&\138\000\000\000\000\006\218\194N\166&\031F\000\018\006\204&\138\000\000\031F\rn&\138\000\000&\138\000\000\000\000\029\006)r.2)r\031F\rb&\138\000\000\000\000\006\222\194N\166\184\031F\000\018\006\206&\138\000\000\031F\rz&\138\000\000&\138\000\000\000\000\rv\031F\r\128&\138\000\000\000\000\194N\191\184\r\130&\138\000\000\000\000&\138\000\000\006\244\194N\167J\031F\000\018\006\226\rp&\138\000\000\031F\r\134\rt&\138\000\000\rz&\138\000\000&\138\000\000\000\000\r\144\r\176\031F\r\136&\138\000\000\r\160\000\000"), (16, "\000R\000:\001\137\007\178\019\186\000%\001\137\000%\000\022\000%\000%\000%\001:\000%\020\150\000\030\t\193\016\"\0049\004z\000%\011\181\000%\t\193\001V\001\137\000%\000%\011\181\000%\000%\004\138\000%\000%\001\137\000%\000%\000%\000V\000%\b\026\000%\007\022\027r\b*\028\222\006\218\003z\000%\000%\003\214\000>\006\206\000%\000%\000%\000%\011\181\000%\000%\029\130\000%\000%\029\218\029N\000%\000%\000%\000%\000%\000%\000%\b:\bz\t\177\030J\r\206\000%\000%\001>\bR\000%\030f\t\177\027~\030\154\006.\000%\000%\000\142\003~\b\026\000%\000%\000)\b*\000)\005\142\000)\000)\000)\030\194\000)\r\214\0049\007b\t\141\016\"\0049\000)\011\177\000)\001B\007.\tZ\000)\000)\011\177\000)\000)\028\022\000)\000)\b:\000)\000)\000)\000\146\000)\0062\000)\022\022\014\254\007\158\0276\022\182\006J\000)\000)\003\238\001F\023\206\000)\000)\000)\000)\011\177\000)\000)\028Z\000)\000)\000J\027\198\000)\000)\000)\000)\000)\000)\000)\001\222\022\194\014\158\015v\023*\000)\000)\023\218\024\206\000)\0242\000z\022^\006\194\t\177\000)\000)\014\178\000\162\026\150\000)\000)\000-\023\130\000-\023\150\000-\000-\000-\024\138\000-\024\158\nI\022z\000N\024\218\000\182\000-\0252\000-\026Z\b\242\030\214\000-\000-\000\210\000-\000-\026\182\000-\000-\000\218\000-\000-\000-\000*\000-\025\138\000-\025\158\004~\000~\016>\tn\000\222\000-\000-\nF\000\166\026z\000-\000-\000-\000-\t\177\000-\000-\n\134\000-\000-\001F\016F\000-\000-\000-\000-\000-\000-\000-!b\000\230\011F\015v\001B\000-\000-\005\194\t\177\000-\">\t\177\007\222\016\"\0049\000-\000-\001\185\011J\016Z\000-\000-\001\017\011N\001\017\000B\001\017\001\017\001\017\016\134\001\017\t\177\001\129\014\018\t\178\000\242\001\129\001\017\011R\001\017\000\190\007j\t\177\001\017\001\017\tY\001\017\001\017\0142\001\017\001\017\001F\001\017\001\017\001\017\001\129\001\017\t\254\001\017\000\246\n&\001\014\016>\t\177\001\129\001\017\001\017\0126\014\234\030\218\001\017\001\017\001\017\001\017\001F\001\017\001\017\001F\001\017\001\017\nj\017\018\001\017\001\017\001\017\001\017\001\017\001\017\001\017\001&\000\194\n\138\015v\012J\001\017\001\017\001f\001F\001\017\002\134\005n\b\134\030\230\012~\001\017\001\017\001\185\015v\001F\001\017\001\017\001\t\n\174\001\t\000\130\001\t\001\t\001\t\030\254\001\t\011\194\001\133\r\138\021R\001R\001\133\001\t\t\169\001\t\001F\t\177\t\177\001\t\001\t\t\169\001\t\001\t\r\170\001\t\001\t\002\246\001\t\001\t\001\t\001\133\001\t\001j\001\t\bB\002\138\022\150\016>\tq\001\133\001\t\001\t\011\214\025\230\001\206\001\t\001\t\001\t\001\t\011\234\001\t\001\t\016>\001\t\001\t\t\177\017b\001\t\001\t\001\t\001\t\001\t\001\t\001\t\021R\r\174\r\242\001B\005\021\001\t\001\t\017\178\026\"\001\t\007\030\t\177\002\250\022\246\t\177\001\t\001\t\001\185\001F\001F\001\t\001\t\001\025\021^\001\025\000\170\001\025\001\025\001\025\022>\001\025\022\178\001\185\007~\002V\016\150\002n\001\025\023\194\001\025\0146\003Z\003\134\001\025\001\025\016\194\001\025\001\025\005\021\001\025\001\025\004\018\001\025\001\025\001\025\002\154\001\025\001F\001\025\005\017\014Z\028\154\004.\014\202\002\158\001\025\001\025\024\202\004R\014\198\001\025\001\025\001\025\001\025\005\130\001\025\001\025\001F\001\025\001\025\001F\005\214\001\025\001\025\001\025\001\025\001\025\001\025\001\025\007\194\005\242\003^\003\138\bf\001\025\001\025\006\022\017*\001\025\006>\006\170\004\022\016:\005\017\001\025\001\025\016\206\017V\b>\001\025\001\025\0011\0042\0011\000\198\0011\0011\0011\004V\0011\bN\b\190\b\210\021~\005\134\014V\0011\t\006\0011\r\238\tB\005\218\0011\0011\t\154\0011\0011\t\185\0011\0011\005\246\0011\0011\0011\t\230\0011\006\026\0011\021\146\006B\006\174\002\178\nR\n\230\0011\0011\011\026\n\206\n\170\0011\0011\0011\0011\n\"\0011\0011\tj\0011\0011\017\202\t\174\0011\0011\0011\0011\0011\0011\0011\011\150\017\246\t\250\016n\011\254\0011\0011\016v\018\002\0011\nf\n\250\012V\016\170\011.\0011\0011\016\178\018.\012\150\0011\0011\001)\011j\001)\003\218\001)\001)\001)\002\218\001)\012\222\r\022\rV\016\246\002\234\011\170\001)\016\254\001)\012\018\017>\003*\001)\001)\017F\001)\001)\012j\001)\001)\003F\001)\001)\001)\012\170\001)\017\150\001)\017\222\018\022\017\158\003n\017\230\018\030\001)\001)\012\242\r*\rj\001)\001)\001)\001)\003\154\001)\001)\018\222\001)\001)\018\202\018\230\001)\001)\001)\001)\001)\001)\001)\019\"\018\246\019~\0196\019\146\001)\001)\019>\019\154\001)\019N\021v\019\170\019\206\020\n\001)\001)\020.\020\018\019\246\001)\001)\001!\020^\001!\003\242\001!\001!\001!\020\"\001!\020r\020\190\020\138\020\210\020z\021\178\001!\020\218\001!\021\190\021\158\020\234\001!\001!\022\030\001!\001!\022*\001!\001!\021\210\001!\001!\001!\021\222\001!\022\202\001!\tu\te\023\006\003\162\023\154\024\162\001!\001!\0232\003\166\023^\001!\001!\001!\001!\023\226\001!\001!\026\210\001!\001!\024\014\003\174\001!\001!\001!\001!\001!\001!\001!\024:\022:\025\162\n!\024f\001!\001!\026\242\024\226\001!\023\166\024\174\025\014\025:\003\186\001!\001!\025f\027\018\022\214\001!\001!\001Y\023\018\001Y\005\222\001Y\001Y\001Y\023>\001Y\023j\n%\031v\003\194\030\170\023\238\001Y\025\174\001Y\027J\027\162\024\026\001Y\001Y\027\210\001Y\001Y\028\186\001Y\001Y\024F\001Y\001Y\001Y\024r\001Y\028\242\001Y\024\238\027v\029*\003\198\025\026\025F\001Y\001Y\029Z\025r\027\030\001Y\001Y\001Y\001Y\029\138\001Y\001Y#\026\001Y\001Y\029\182\031~\001Y\001Y\001Y\001Y\001Y\001Y\001Y\027\134\003\206\027V\027\174\029\238\001Y\001Y\027\222\030&\001Y\028\198\030r\003\230\004\006 6\001Y\001Y\"\206 >\028\254\001Y\001Y\001Q\0296\001Q\005\250\001Q\001Q\001Q\029f\001Q \"\004&\004J \222 \202\029\150\001Q \230\001Q\004\134 N\029\194\001Q\001Q \246\001Q\001Q\004\250\001Q\001Q!&\001Q\001Q\001Q\029\250\001Q\005\002\001Q\0302!:!R\030~!v!B\001Q\001Q!\214\005b\005j\001Q\001Q\001Q\001Q\005~\001Q\001Q!\178\001Q\001Q!\158!\186\001Q\001Q\001Q\001Q\001Q\001Q\001Q\"\006!\202\"f\"\026\"z\001Q\001Q\"\"\"\130\001Q\"2\005\162\"\146\"\218\"\238\001Q\001Q\005\178\"\250\005\186\001Q\001Q\001a#\014\001a\006\030\001a\001a\001a\005\206\001a\005\234\006\014\006:\006V\006j\006v\001a\006\138\001a\006\150\006\158\006\198\001a\001a\006\202\001a\001a\006\210\001a\001a\006\222\001a\001a\001a\006\226\001a\006\230\001a\006\238\006\242\006\254\007\002\007\006\007\014\001a\001a\007\018\007\"\0072\001a\001a\001a\001a\007:\001a\001a\007>\001a\001a\007V\007Z\001a\001a\001a\001a\001a\001a\001a\007r\007\130\007\146\007\150\007\162\001a\001a\007\186\007\198\001a\007\214\007\218\007\226\007\254\b\002\001a\001a\b\018\b&\b6\001a\001a\001A\bJ\001A\006F\001A\001A\001A\b^\001A\bj\b~\b\138\b\166\b\178\b\194\001A\b\214\001A\b\230\b\246\t\n\001A\001A\t&\001A\001A\t.\001A\001A\t2\001A\001A\001A\t:\001A\tF\001A\t\130\t\146\t\158\t\198\t\222\t\234\001A\001A\n\018\n:\nN\001A\001A\001A\001A\nV\001A\001A\n~\001A\001A\n\158\n\194\001A\001A\001A\001A\001A\001A\001A\n\210\n\234\n\254\011\018\011\022\001A\001A\011\030\0112\001A\011Z\011b\011v\011~\011\130\001A\001A\011\154\011\174\011\198\001A\001A\0019\011\218\0019\006N\0019\0019\0019\012\002\0019\012\022\012*\012:\012R\012Z\012n\0019\012\130\0019\012\154\012\174\012\194\0019\0019\012\202\0019\0019\012\206\0019\0019\012\214\0019\0019\0019\012\226\0019\012\246\0019\r\014\r\026\r.\rN\rZ\rn\0019\0019\r\146\r\158\r\162\0019\0019\0019\0019\r\194\0019\0019\r\218\0019\0019\r\222\r\226\0019\0019\0019\0019\0019\0019\0019\014\006\014\026\014&\014*\014J\0019\0019\014n\014~\0019\014\130\014\170\014\182\014\222\014\238\0019\0019\014\242\015\002\015\006\0019\0019\001I\015\018\001I\006\178\001I\001I\001I\015\022\001I\015\030\015\"\015>\015B\015^\015n\001I\015r\001I\015\150\015\154\015\186\001I\001I\016N\001I\001I\016~\001I\001I\016\186\001I\001I\001I\016\214\001I\017\006\001I\017\026\017N\017j\017\166\017\186\017\238\001I\001I\018&\018:\018F\001I\001I\001I\001I\018R\001I\001I\018Z\001I\001I\018v\018~\001I\001I\001I\001I\001I\001I\001I\018\138\018\146\018\158\018\186\018\238\001I\001I\019\018\019F\001I\019n\019\162\019\230\020\026\0206\001I\001I\020N\020\130\020\174\001I\001I\000\137\020\226\000\137\020\250\000\137\000\137\000\137\021\002\000\137\021\014\021\018\021\030\0212\021>\021B\000\137\021F\000\137\021J\021N\021f\000\137\000\137\021\134\000\137\000\137\021\138\000\137\000\137\021\182\000\137\000\137\000\137\021\198\000\137\021\202\001\030\021\214\021\234\021\246\021\250\022\002\022\014\000\137\000\137\022\"\022.\0222\000\137\000\137\000\137\000\137\0226\000\137\000\137\022J\000\137\000\137\022N\022R\000\137\000\137\000\137\000\137\0016\000\137\000\137\022b\022n\022~\022\138\022\154\000\137\000\137\022\166\022\170\001Z\022\186\022\206\022\226\022\242\023\002\000\137\000\137\023\n\023\030\0236\000\137\000\137\000\145\023J\000\145\023Z\000\145\000\145\000\145\023b\000\145\023v\023\142\023\158\023\174\023\182\023\198\000\145\023\202\000\145\023\210\023\230\023\250\000\145\000\145\024\n\000\145\000\145\024\018\000\145\000\145\024&\000\145\000\145\000\145\024>\000\145\024R\001\030\024b\024j\024~\024\150\024\166\024\182\000\145\000\145\024\190\024\210\024\230\000\145\000\145\000\145\000\145\024\250\000\145\000\145\025\n\000\145\000\145\025\018\025&\000\145\000\145\000\145\000\145\0016\000\145\000\145\025>\025R\025b\025j\025~\000\145\000\145\025\150\025\166\001Z\025\182\025\190\025\218\025\222\025\234\000\145\000\145\025\238\025\242\025\254\000\145\000\145\000\157\026\002\000\157\026\022\000\157\000\157\000\157\026\026\000\157\026&\0262\0266\026J\026N\026^\000\157\026b\000\157\026f\026r\026~\000\157\000\157\026\138\000\157\000\157\026\154\000\157\000\157\026\158\000\157\000\157\000\157\026\162\000\157\026\174\001\030\026\186\026\198\026\214\026\222\026\226\026\230\000\157\000\157\026\254\027\014\027\022\000\157\000\157\000\157\000\157\027*\000\157\000\157\027>\000\157\000\157\027F\027N\000\157\000\157\000\157\000\157\0016\000\157\000\157\027b\027\130\027\146\027\150\027\158\000\157\000\157\027\166\027\186\000\157\027\206\027\214\027\234\027\254\028\002\000\157\000\157\028\006\028\014\028\026\000\157\000\157\000}\028\030\000}\028\"\001\022\001.\000}\028*\000}\028.\0286\028B\028F\028J\028R\000}\028^\000}\028f\028j\028r\000}\000}\028~\000}\000}\028\130\001z\000}\028\134\001\130\000}\000}\028\142\000}\028\166\001\030\028\182\028\190\028\210\028\230\028\238\028\246\000}\000}\029\n\029\026\029\030\000}\001\138\000}\000}\029&\000}\000}\029.\000}\000}\029B\029V\000}\000}\000}\000}\0016\000}\001\146\029^\029r\029\142\029\162\029\178\000}\000}\029\186\029\206\001Z\029\226\029\234\029\242\030\006\030\022\000}\000}\030\026\030\"\030*\000}\000}\000\133\030>\000\133\030N\000\133\000\133\000\133\030V\000\133\030Z\030^\030n\030v\030\138\030\158\000\133\030\166\000\133\030\182\030\186\030\202\000\133\000\133\030\206\000\133\000\133\030\222\000\133\000\133\030\234\000\133\000\133\000\133\030\242\000\133\030\246\001\030\031\006\031\n\031\023\031>\031B\031J\000\133\000\133\031R\031V\031^\000\133\000\133\000\133\000\133\031b\000\133\000\133\031f\000\133\000\133\031j\031n\000\133\000\133\000\133\000\133\0016\000\133\000\133\031\134\031\138\031\146\031\150\031\158\000\133\000\133\031\162\031\174\001Z\031\202\031\214\031\218\031\246\031\254\000\133\000\133 \014 \018 \026\000\133\000\133\000\149 F\000\149 b\000\149\000\149\000\149 j\000\149 \134 \142 \154 \162 \186 \238\000\149!\022\000\149!J!\142!\194\000\149\000\149!\222\000\149\000\149!\246\000\149\000\149\"*\000\149\000\149\000\149\"V\000\149\"\138\001\030\"\162\"\170\"\194\"\242#\002#\006\000\149\000\149#\018#*#.\000\149\000\149\000\149\000\149#6\000\149\000\149#C\000\149\000\149\000\000\000\000\000\149\000\149\000\149\000\149\0016\000\149\000\149\000\000\000\000\000\000\000\000\000\000\000\149\000\149\000\000\000\000\001Z\000\000\000\000\000\000\000\000\000\000\000\149\000\149\000\000\000\000\000\000\000\149\000\149\000\153\000\000\000\153\000\000\000\153\000\153\000\153\000\000\000\153\000\000\000\000\000\000\000\000\000\000\000\000\000\153\000\000\000\153\000\000\000\000\000\000\000\153\000\153\000\000\000\153\000\153\000\000\000\153\000\153\000\000\000\153\000\153\000\153\000\000\000\153\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\000\153\000\153\000\000\000\000\000\000\000\153\000\153\000\153\000\153\000\000\000\153\000\153\000\000\000\153\000\153\000\000\000\000\000\153\000\153\000\153\000\153\0016\000\153\000\153\000\000\000\000\000\000\000\000\000\000\000\153\000\153\000\000\000\000\001Z\000\000\000\000\000\000\000\000\000\000\000\153\000\153\000\000\000\000\000\000\000\153\000\153\000a\000\000\000a\000\000\000a\000a\000a\000\000\000a\000\000\000\000\000\000\000\000\000\000\000\000\000a\000\000\000a\000\000\000\000\000\000\000a\000a\000\000\000a\000a\000\000\000a\000a\000\000\000a\000a\000a\000\000\000a\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\000a\000a\000\000\000\000\000\000\000a\000a\000a\000a\000\000\000a\000a\000\000\000a\000a\000\000\000\000\000a\000a\000a\000a\0016\000a\000a\000\000\000\000\000\000\000\000\000\000\000a\000a\000\000\000\000\001Z\000\000\000\000\000\000\000\000\000\000\000a\000a\000\000\000\000\000\000\000a\000a\000\141\000\000\000\141\000\000\001\022\001.\000\141\000\000\000\141\000\000\000\000\000\000\000\000\000\000\000\000\000\141\000\000\000\141\000\000\000\000\000\000\000\141\000\141\000\000\000\141\000\141\000\000\001z\000\141\000\000\001\130\000\141\000\141\000\000\000\141\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\000\141\000\141\000\000\000\000\000\000\000\141\001\138\000\141\000\141\000\000\000\141\000\141\000\000\000\141\000\141\000\000\000\000\000\141\000\141\000\141\000\141\0016\000\141\001\146\000\000\000\000\000\000\000\000\000\000\000\141\000\141\000\000\000\000\001Z\000\000\000\000\000\000\000\000\000\000\000\141\000\141\000\000\000\000\000\000\000\141\000\141\000\129\000\000\000\129\000\000\001\022\001.\000\129\000\000\000\129\000\000\000\000\000\000\000\000\000\000\000\000\000\129\000\000\000\129\000\000\000\000\000\000\000\129\000\129\000\000\000\129\000\129\000\000\001z\000\129\000\000\001\130\000\129\000\129\000\000\000\129\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\000\129\000\129\000\000\000\000\000\000\000\129\001\138\000\129\000\129\000\000\000\129\000\129\000\000\000\129\000\129\000\000\000\000\000\129\000\129\000\129\000\129\0016\000\129\001\146\000\000\000\000\000\000\000\000\000\000\000\129\000\129\000\000\000\000\001Z\000\000\000\000\000\000\000\000\000\000\000\129\000\129\000\000\000\000\000\000\000\129\000\129\000e\000\000\000e\000\000\001\022\001.\000e\000\000\000e\000\000\000\000\000\000\000\000\000\000\000\000\000e\000\000\000e\000\000\000\000\000\000\000e\000e\000\000\000e\000e\000\000\001z\000e\000\000\001\130\000e\000e\000\000\000e\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\000e\000e\000\000\000\000\000\000\000e\001\138\000e\000e\000\000\000e\000e\000\000\000e\000e\000\000\000\000\000e\000e\000e\000e\0016\000e\001\146\000\000\000\000\000\000\000\000\000\000\000e\000e\000\000\000\000\001Z\000\000\000\000\000\000\000\000\000\000\000e\000e\000\000\000\000\000\000\000e\000e\000U\000\000\000U\000\000\001\022\001.\000U\000\000\000U\000\000\000\000\000\000\000\000\000\000\000\000\000U\000\000\000U\000\000\000\000\000\000\000U\000U\000\000\000U\000U\000\000\001z\000U\000\000\001\130\000U\000U\000\000\000U\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\000U\000U\000\000\000\000\000\000\000U\001\138\000U\000U\000\000\000U\000U\000\000\000U\000U\000\000\000\000\000U\000U\000U\000U\0016\000U\001\146\000\000\000\000\000\000\000\000\000\000\000U\000U\000\000\000\000\001Z\000\000\000\000\000\000\000\000\000\000\000U\000U\000\000\000\000\000\000\000U\000U\000u\000\000\000u\000\000\001\022\001.\000u\000\000\000u\000\000\000\000\000\000\000\000\000\000\000\000\000u\000\000\000u\000\000\000\000\000\000\000u\001r\000\000\001\154\000u\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000u\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\000u\000\000\000\000\000\000\000u\001\138\001\242\001\250\000\000\000u\002\002\000\000\001\178\000u\000\000\000\000\000u\000u\000u\000u\0016\000u\001\146\000\000\000\000\000\000\000\000\000\000\000u\000u\000\000\000\000\001Z\000\000\000\000\000\000\000\000\000\000\000u\002\014\000\000\000\000\000\000\001\186\000u\000i\000\000\000i\000\000\001\022\001.\000i\000\000\000i\000\000\000\000\000\000\000\000\000\000\000\000\000i\000\000\000i\000\000\000\000\000\000\000i\001r\000\000\001\154\000i\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000i\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\000i\000\000\000\000\000\000\000i\001\138\001\242\001\250\000\000\000i\000i\000\000\001\178\000i\000\000\000\000\000i\000i\000i\000i\0016\000i\001\146\000\000\000\000\000\000\000\000\000\000\000i\000i\000\000\000\000\001Z\000\000\000\000\000\000\000\000\000\000\000i\000i\000\000\000\000\000\000\001\186\000i\000m\000\000\000m\000\000\001\022\001.\000m\000\000\000m\000\000\000\000\000\000\000\000\000\000\000\000\000m\000\000\000m\000\000\000\000\000\000\000m\001r\000\000\001\154\000m\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000m\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\000m\000\000\000\000\000\000\000m\001\138\001\242\001\250\000\000\000m\000m\000\000\001\178\000m\000\000\000\000\000m\000m\000m\000m\0016\000m\001\146\000\000\000\000\000\000\000\000\000\000\000m\000m\000\000\000\000\001Z\000\000\000\000\000\000\000\000\000\000\000m\000m\000\000\000\000\000\000\001\186\000m\001i\000\000\001i\000\000\001\022\001.\001i\000\000\001i\000\000\000\000\000\000\000\000\000\000\000\000\001i\000\000\001i\000\000\000\000\000\000\001i\001r\000\000\001\154\001i\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\001i\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\001\234\000\000\000\000\000\000\001i\001\138\001\242\001\250\000\000\001i\002\002\000\000\001\178\001i\000\000\000\000\001i\001i\001i\001i\0016\001i\001\146\000\000\000\000\000\000\000\000\000\000\001i\001i\000\000\000\000\001Z\000\000\000\000\000\000\000\000\000\000\0022\002\014\000\000\000\000\000\000\001\186\002:\000]\000\000\000]\000\000\001\022\001.\000]\000\000\000]\000\000\000\000\000\000\000\000\000\000\000\000\000]\000\000\000]\000\000\000\000\000\000\000]\001r\000\000\001\154\000]\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000]\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\000]\000\000\000\000\000\000\000]\001\138\001\242\001\250\000\000\000]\002\002\000\000\001\178\000]\000\000\000\000\000]\000]\000]\000]\0016\000]\001\146\000\000\000\000\000\000\000\000\000\000\000]\000]\000\000\000\000\001Z\000\000\000\000\000\000\000\000\000\000\000]\002\014\000\000\000\000\000\000\001\186\000]\000Y\000\000\000Y\000\000\001\022\001.\000Y\000\000\000Y\000\000\000\000\000\000\000\000\000\000\000\000\000Y\000\000\000Y\000\000\000\000\000\000\000Y\001r\000\000\001\154\000Y\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000Y\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\000Y\000\000\000\000\000\000\000Y\001\138\001\242\001\250\000\000\000Y\002\002\000\000\001\178\000Y\000\000\000\000\000Y\000Y\000Y\000Y\0016\000Y\001\146\000\000\000\000\000\000\000\000\000\000\000Y\000Y\000\000\000\000\001Z\000\000\000\000\000\000\000\000\000\000\000Y\002\014\000\000\000\000\000\000\001\186\000Y\000M\000\000\000M\000\000\001\022\001.\000M\000\000\000M\000\000\000\000\000\000\000\000\000\000\000\000\000M\000\000\000M\000\000\000\000\000\000\000M\000M\000\000\000M\000M\000\000\001z\000M\000\000\001\130\000M\000M\000\000\000M\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\000M\000M\000\000\000\000\000\000\000M\001\138\000M\000M\000\000\000M\000M\000\000\000M\000M\000\000\000\000\000M\000M\000M\000M\0016\000M\001\146\000\000\000\000\000\000\000\000\000\000\000M\000M\000\000\000\000\001Z\000\000\000\000\000\000\000\000\000\000\000M\000M\000\000\000\000\000\000\000M\000M\000I\000\000\000I\000\000\000I\000I\000I\000\000\000I\000\000\000\000\000\000\000\000\000\000\000\000\000I\000\000\000I\000\000\000\000\000\000\000I\000I\000\000\000I\000I\000\000\000I\000I\000\000\000I\000I\000I\000\000\000I\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\000I\000I\000\000\000\000\000\000\000I\000I\000I\000I\000\000\000I\000I\000\000\000I\000I\000\000\000\000\000I\000I\000I\000I\0016\000I\000I\000\000\000\000\000\000\000\000\000\000\000I\000I\000\000\000\000\000I\000\000\000\000\000\000\000\000\000\000\000I\000I\000\000\000\000\000\000\000I\000I\000\173\000\000\000\173\000\000\001\022\001.\000\173\000\000\000\173\000\000\000\000\000\000\000\000\000\000\000\000\000\173\000\000\000\173\000\000\000\000\000\000\000\173\001r\000\000\001\154\000\173\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\173\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\001\234\000\000\000\000\000\000\000\173\001\138\001\242\001\250\000\000\000\173\002\002\000\000\001\178\000\173\000\000\000\000\000\173\000\173\000\173\000\173\0016\000\173\001\146\000\000\000\000\000\000\000\000\000\000\000\173\002*\000\000\000\000\001Z\000\000\000\000\000\000\000\000\000\000\0022\002\014\000\000\000\000\000\000\001\186\002:\000Q\000\000\000Q\000\000\000Q\000Q\000Q\000\000\000Q\000\000\000\000\000\000\000\000\000\000\000\000\000Q\000\000\000Q\000\000\000\000\000\000\000Q\000Q\000\000\000Q\000Q\000\000\000Q\000Q\000\000\000Q\000Q\000Q\000\000\000Q\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\000Q\000Q\000\000\000\000\000\000\000Q\000Q\000Q\000Q\000\000\000Q\000Q\000\000\000Q\000Q\000\000\000\000\000Q\000Q\000Q\000Q\0016\000Q\000Q\000\000\000\000\000\000\000\000\000\000\000Q\000Q\000\000\000\000\000Q\000\000\000\000\000\000\000\000\000\000\000Q\000Q\000\000\000\018\000\000\000Q\000Q\000y\000\000\000y\000\000\001\022\001.\000y\007\026\000y\000\000\000\000\000\000\000\000\000\234\023.\000y\005!\000y\000\238\000\000\000\000\000y\001r\000\000\001\154\000y\000\000\001z\001\162\000\000\001\130\000\000\000\250\000\000\000y\003\186\001\030\000\000\000\000\000\000\000\254\000\000\000\000\000\000\000y\000\000\000\000\001\002\000y\001\138\000\000\000\000\000\000\000y\000y\000\000\001\178\000y\000\000\000\000\000y\000y\000y\000y\0016\000y\001\146\000\000\000\000\000\000\000\000\000\000\000y\000y\000\000\000\000\001Z\001\006\000\000\001\n\003\178\000\000\000y\000y\000\000\003\182\000\000\001\186\000y\000\161\000\000\000\161\000\000\001\022\001.\000\161\000\000\000\161\000\000\000\000\000\000\000\000\000\000\000\000\000\161\007\246\000\161\000\000\000\000\000\000\000\161\001r\007\250\001\154\000\161\000\000\001z\001\162\000\000\001\130\000\000\007\238\000\000\000\161\000\000\001\030\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\161\000\000\000\000\000\000\000\161\001\138\000\000\000\000\b\n\000\161\000\161\000\000\001\178\000\161\000\000\000\000\000\161\000\161\000\161\000\161\0016\000\161\001\146\000\000\000\000\000\000\000\000\000\000\000\161\000\161\000\000\000\000\001Z\000\000\000\000\000\000\000\000\000\000\000\161\000\161\000\000\000\018\000\000\001\186\000\161\000q\000\000\000q\000\000\001\022\001.\000q\007*\000q\000\000\000\000\000\000\000\000\000\234\0246\000q\000\000\000q\000\238\000\000\000\000\000q\001r\000\000\001\154\000q\000\000\001z\001\162\000\000\001\130\000\000\000\250\000\000\000q\000\000\001\030\000\000\000\000\000\000\000\254\000\000\000\000\000\000\000q\000\000\000\000\001\002\000q\001\138\000\000\000\000\000\000\000q\000q\000\000\001\178\000q\000\000\000\000\000q\000q\000q\000q\0016\000q\001\146\000\000\000\000\000\000\000\000\000\000\000q\000q\000\000\000\000\001Z\001\006\000\000\001\n\003\178\000\000\000q\000q\000\000\003\182\000\000\001\186\000q\000\165\000\000\000\165\000\000\001\022\001.\000\165\000\000\000\165\000\000\000\000\000\000\000\000\000\000\000\000\000\165\000\000\000\165\000\000\000\000\000\000\000\165\001r\000\000\001\154\000\165\000\000\001z\001\162\000\000\001\130\000\000\000\000\000\000\000\165\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\165\000\000\000\000\000\000\000\165\001\138\000\000\000\000\000\000\000\165\000\165\000\000\001\178\000\165\001\177\000\000\000\165\000\165\000\165\000\165\0016\000\165\001\146\000\000\000\000\000\000\000\000\000\000\000\165\000\165\000\000\000\000\001Z\000\000\000\000\000\000\000\000\000\000\000\165\000\165\001\177\001\177\000\000\001\186\000\165\001\177\000\000\001\177\001\177\001\177\001\177\000\000\001\177\000\000\000\000\001\177\000\000\001\177\001\177\000\000\001\177\001\177\001\177\001\177\000\000\001\177\000\000\000\000\000\000\000\000\001\177\000\000\000\000\000\000\000\000\000\000\001\177\000\000\000\000\001\177\000\000\000\000\000\000\000\000\001\177\000\000\000\000\001\177\000\000\000\000\000\000\001\177\001\177\000\000\000\000\000\000\001\177\000\000\001\177\001\177\000\006\001\177\001\177\001\177\000\000\000\000\000\000\004!\000\006\001\177\001\177\004!\000\000\001\177\001\177\000\000\000\000\000\000\000\000\001\177\001\177\001\177\001\177\001\177\001\177\000\000\001\177\000\000\000\000\001\177\000\000\001\177\001\177\000\000\000\000\000\000\001\177\001\177\004!\000\000\004!\004!\004!\004!\004!\004!\000\000\004!\000\000\004!\000\000\004!\000\000\004!\004!\004!\004!\004!\004!\000\000\004!\000\000\004!\004!\000\000\000\000\000\000\004!\000\000\000\000\000\000\000\000\004!\000\000\000\000\000\000\004!\004!\000\000\000\000\004!\004!\000\000\000\000\004!\004!\018\178\000\000\000\000\004!\0156\004!\004!\004!\004!\004!\004!\004!\000\000\004!\004!\004!\004!\000\000\018\162\004!\000\000\004!\018\162\004!\004!\004!\004!\004!\004!\004!\004!\004!\004!\004!\000\000\000\000\004!\004!\004!\004!\004!\000\000\004!\004!\004!\000\000\000\000\004!\004!\000\000\004!\000\000\000\000\000\000\000\000\004!\031\194\000\000\000\000\004!\000\000\004!\004!\000\000\000\000\000\000\004!\000\000\000\000\000\000\000\000\000\000\004!\000\000\018\162\004!\002\162\000\000\000\000\000\000\000\000\000\000\004!\004!\004!\ni\ni\000\000\000\000\004!\000\000\000\000\004!\000\000\004!\004!\ni\000\000\000\000\004!\004!\000\000\ni\ni\000\000\ni\000\000\000\000\ni\ni\000\000\ni\ni\000\000\002\166\000\000\000\000\ni\000\000\000\000\000\000\000\000\000\000\000\000\ni\ni\002\182\000\000\000\000\ni\ni\ni\ni\000\000\000\000\ni\000\000\ni\000\000\000\000\000\000\000\000\000\000\000\000\000\000\ni\0036\ni\000\000\000\000\000\000\000\000\000\000\ni\ni\nm\nm\ni\000\000\000\000\000\000\000\000\000\000\ni\ni\000\000\nm\000\000\ni\ni\000\000\000\000\nm\nm\000\000\nm\000\000\000\000\nm\nm\000\000\nm\nm\000\000\003:\000\000\000\018\nm\000\000\000\000\000\000\000\000\000\000\000\000\nm\nm\003J\0076\000\000\nm\nm\nm\nm\000\234\0256\nm\000\000\nm\000\238\007B\000\000\000\000\000\000\000\000\000\000\nm\000\000\nm\000\000\000\000\000\000\000\000\000\250\nm\nm\000\000\000\000\nm\000\000\000\000\000\254\000\000\000\000\nm\nm\000\000\000\000\001\002\nm\nm\007^\000\000\007f\007n\000\000\015\014\000\000\007\142\000\000\000\000\000\000\000\000\000\000\007\154\000\000\007\166\015\026\000\000\007\174\000\000\007\190\000\018\000\000\000\000\000\000\007\210\000\000\001\006\000\000\001\n\003\178\000\000\022\026\000\000\007\238\003\182\000\000\000\000\000\234\007\242\000\000\000\000\b\006\000\238\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\015&\b\130\000\000\000\000\000\250\015:\000\000\000\000\000\000\007B\0152\000\000\000\254\000\000\019\002\000\000\000\000\000\000\000\000\001\002\007\221\b\150\b\162\b\170\000\000\000\000\000\000\000\000\015b\000\000\000\000\b\206\000\000\b\226\t\002\000\000\000\000\000\000\t\022\t\"\007^\000\000\007f\007n\000\000\015\014\000\000\007\142\000\000\001\006\000\000\001\n\003\178\007\154\000\000\007\166\015\026\003\182\007\174\000\000\007\190\000\018\000\000\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\022\198\000\000\007\238\000\000\000\000\000\000\000\234\007\242\000\000\000\000\b\006\000\238\000\000\000\000\000\000\bb\019\n\000\000\000\000\bv\000\000\015&\b\130\000\000\000\000\000\250\015:\000\000\000\000\000\000\007B\016B\000\000\000\254\000\000\000\000\000\000\000\000\000\000\000\000\001\002\007\241\b\150\b\162\b\170\000\000\000\000\000\000\000\000\015b\000\000\000\000\b\206\000\000\b\226\t\002\000\000\000\000\000\000\t\022\t\"\007^\000\000\007f\007n\000\000\015\014\000\000\007\142\000\000\001\006\000\000\001\n\003\178\007\154\000\000\007\166\015\026\003\182\007\174\000\000\007\190\000\018\000\000\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\023\222\000\000\007\238\011\189\000\000\000\000\000\234\007\242\000\000\000\000\b\006\000\238\000\000\000\000\011\189\bb\011\189\000\000\000\000\bv\011\189\015&\b\130\000\000\000\000\000\250\015:\011\189\000\000\000\000\007B\018\174\000\000\000\254\000\000\019^\000\000\000\000\000\000\000\000\001\002\b=\b\150\b\162\b\170\000\000\005\170\000\000\000\000\015b\000\000\000\000\b\206\011\189\b\226\t\002\011\189\000\000\000\000\t\022\t\"\007^\000\000\007f\007n\000\000\015\014\000\000\007\142\000\000\001\006\000\000\001\n\003\178\007\154\000\000\007\166\015\026\003\182\007\174\011\189\007\190\000\018\000\000\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\024\222\000\000\007\238\000\000\011\189\000\000\000\234\007\242\000\000\000\000\b\006\000\238\000\000\000\000\000\000\bb\019f\000\000\000\000\bv\000\000\015&\b\130\000\000\000\000\000\250\015:\000\000\000\000\000\000\007B\019\006\000\000\000\254\000\000\000\000\000\000\000\000\000\000\000\000\001\002\bQ\b\150\b\162\b\170\000\000\000\000\000\000\000\000\015b\000\000\000\000\b\206\000\000\b\226\t\002\000\000\000\000\000\000\t\022\t\"\007^\000\000\007f\007n\000\000\015\014\000\000\007\142\000\000\001\006\000\000\001\n\003\178\007\154\000\000\007\166\015\026\003\182\007\174\000\000\007\190\000\018\000\000\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\028&\000\000\007\238\000\000\000\000\000\000\000\234\007\242\000\000\000\000\b\006\000\238\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\015&\b\130\000\000\000\000\000\250\015:\000\000\000\000\000\000\007B\019b\000\000\000\254\000\000\019\214\000\000\000\000\000\000\000\000\001\002\007\245\b\150\b\162\b\170\000\000\000\000\000\000\000\000\015b\000\000\000\000\b\206\000\000\b\226\t\002\000\000\000\000\000\000\t\022\t\"\007^\000\000\007f\007n\000\000\015\014\000\000\007\142\000\000\001\006\000\000\001\n\003\178\007\154\000\000\007\166\015\026\003\182\007\174\000\000\007\190\000\018\000\000\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\028b\000\000\007\238\000\000\000\000\000\000\000\234\007\242\000\000\000\000\b\006\000\238\000\000\000\000\000\000\bb\019\222\000\000\000\000\bv\000\000\015&\b\130\000\000\000\000\000\250\015:\000\000\000\000\000\000\007B\019\218\000\000\000\254\000\000\000\000\000\000\000\000\000\000\000\000\001\002\b\t\b\150\b\162\b\170\000\000\000\000\000\000\000\000\015b\000\000\000\000\b\206\000\000\b\226\t\002\000\000\000\000\000\000\t\022\t\"\007^\000\000\007f\007n\000\000\015\014\000\000\007\142\000\000\001\006\000\000\001\n\003\178\007\154\000\000\007\166\015\026\003\182\007\174\000\000\007\190\000\018\000\000\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\029\134\000\000\007\238\000\000\000\000\000\000\000\234\007\242\000\000\000\000\b\006\000\238\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\015&\b\130\000\000\000\000\000\250\015:\000\000\000\000\000\000\007B\020B\000\000\000\254\000\000\020>\000\000\000\000\000\000\000\000\001\002\b\r\b\150\b\162\b\170\000\000\000\000\000\000\000\000\015b\000\000\000\000\b\206\000\000\b\226\t\002\000\000\000\000\000\000\t\022\t\"\007^\000\000\007f\007n\000\000\015\014\000\000\007\142\000\000\001\006\000\000\001\n\003\178\007\154\000\000\007\166\015\026\003\182\007\174\000\000\007\190\000\018\000\000\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\ti\000\000\007\238\000\000\000\000\000\000\000\234\007\242\000\000\000\000\b\006\000\238\000\000\000\000\000\000\bb\020F\000\000\000\000\bv\000\000\015&\b\130\000\000\000\000\000\250\015:\000\000\000\000\000\000\007B\020\162\000\000\000\254\000\000\000\000\000\000\000\000\000\000\000\000\001\002\b!\b\150\b\162\b\170\000\000\000\000\000\000\000\000\015b\000\000\000\000\b\206\000\000\b\226\t\002\000\000\000\000\000\000\t\022\t\"\007^\000\000\007f\007n\000\000\015\014\000\000\007\142\000\000\001\006\000\000\001\n\003\178\007\154\000\000\007\166\015\026\003\182\007\174\000\000\007\190\b\174\000\000\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\n\226\007\242\000\000\000\000\b\006\011\014\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\015&\b\130\000\000\000\000\011B\015:\000\000\000\000\000\000\007B\021z\000\000\011\146\000\000\020\158\000\000\000\000\000\000\000\000\011\190\b%\b\150\b\162\b\170\000\000\000\000\000\000\000\000\015b\000\000\000\000\b\206\000\000\b\226\t\002\000\000\000\000\000\000\t\022\t\"\007^\000\000\007f\007n\000\000\015\014\000\000\007\142\000\000\011\250\000\000\012&\012\146\007\154\000\000\007\166\015\026\012\190\007\174\000\000\007\190\000\000\000\000\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\020\166\000\000\000\000\bv\000\000\015&\b\130\000\000\000\000\000\000\015:\000\000\000\000\000\000\031*\031z\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b9\b\150\b\162\b\170\000\000\000\000\000\000\000\000\015b\000\000\000\000\b\206\000\000\b\226\t\002\000\000\000\000\000\000\t\022\t\"\007^\000\000\007f\007n\000\000\031N\000\000\007\142\000\000\000\000\000\000\000\000\000\000\007\154\000\000\007\166\031\142\000\000\007\174\000\000\007\190\000\000\000\000\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb \178\000\000\000\000\bv\000\000\031\178\b\130\000\000\000\000\000\000\031\210\000\000\000\000\000\000\031*\031\190\004A\000\000\000\000 \170\000\000\000\000\000\000\000\000\000\000\000\000\b\150\b\162\b\170\000\000\000\000\000\000\000\000 \002\000\000\000\000\b\206\000\000\b\226\t\002\000\000\000\000\000\000\t\022\t\"\007^\000\000\007f\007n\000\000\031N\000\000\007\142\000\000\000\000\000\000\000\000\000\000\007\154\000\000\007\166\031\142\000\000\007\174\000\000\007\190\000\000\000\000\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb!\014\000\000\000\000\bv\000\000\031\178\b\130\000\000\000\000\000\000\031\210\000\000\000\000\000\000\031* \174\004A\000\000\000\000!\006\000\000\000\000\000\000\000\000\000\000\000\000\b\150\b\162\b\170\000\000\000\000\000\000\000\000 \002\000\000\000\000\b\206\000\000\b\226\t\002\000\000\000\000\000\000\t\022\t\"\007^\000\000\007f\007n\000\000\031N\000\000\007\142\000\000\000\000\000\000\000\000\000\000\007\154\000\000\007\166\031\142\000\000\007\174\000\000\007\190\000\000\000\000\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb!\134\000\000\000\000\bv\000\000\031\178\b\130\000\000\000\000\000\000\031\210\000\000\000\000\000\000\031*!\n\004A\000\000\000\000!~\000\000\000\000\000\000\000\000\000\000\000\000\b\150\b\162\b\170\000\000\000\000\000\000\000\000 \002\000\000\000\000\b\206\000\000\b\226\t\002\000\000\000\000\000\000\t\022\t\"\007^\000\000\007f\007n\000\000\031N\000\000\007\142\000\000\000\000\000\000\000\000\000\000\007\154\000\000\007\166\031\142\000\000\007\174\000\000\007\190\000\000\000\000\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb!\238\000\000\000\000\bv\000\000\031\178\b\130\000\000\000\000\000\000\031\210\000\000\000\000\000\000\031*!\130\004A\000\000\000\000!\230\000\000\000\000\000\000\000\000\000\000\000\000\b\150\b\162\b\170\000\000\000\000\000\000\000\000 \002\000\000\000\000\b\206\000\000\b\226\t\002\000\000\000\000\000\000\t\022\t\"\007^\000\000\007f\007n\000\000\031N\000\000\007\142\000\000\000\000\000\000\000\000\000\000\007\154\000\000\007\166\031\142\000\000\007\174\000\000\007\190\000\000\000\000\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\"N\000\000\000\000\bv\000\000\031\178\b\130\000\000\000\000\000\000\031\210\000\000\000\000\000\000\000\000!\234\004A\000\000\000\000\"F\000R\000\000\000\000\000\000\000\000\000\000\b\150\b\162\b\170\000%\000%\000\000\000\000 \002\000\000\000\000\b\206\000\000\b\226\t\002\000\226\000\000\000R\t\022\t\"\000\000\000\000\000%\000\000\000%\000\000\000%\000%\000%\000\000\000%\000%\000%\000V\000\000\000\000\000%\003\170\000\000\000R\000\000\000\000\000\000\000%\000%\003\214\000%\000\000\000%\000%\000%\000%\000%\000%\000%\000V\000%\000\000\000%\003\202\000\000\000\000\000\000\000%\000%\000%\000%\003\214\000%\000\000\000\000\000%\000%\000%\000%\000%\000%\000V\000%\000\000\000%\000\000\000%\000%\000\000\000%\000%\000%\000%\003\214\000\000\000\000\000\000\000%\000%\000%\000\000\000\000\000%\000\000\000%\000\000\000\000\000\000\000%\000%\000\000\000%\000%\000%\000%\000\000\000\000\000\142\000\000\000\000\000\000\000%\000\000\000\000\000%\000\000\000)\000)\000\000\000\000\000%\000%\000\000\000\000\000\000\000%\000%\003\226\000\000\000\142\000\000\000\000\000\000\000\000\000)\000\000\000)\000\000\000)\000)\000)\000\000\000)\000)\000)\000\146\000\000\000\000\000)\004\"\000\000\000\142\000\000\000\000\000\000\000)\000)\003\238\000)\000\000\000)\000)\000)\000)\000)\000)\000)\000\146\000)\000\000\000)\005\230\000\000\000\000\000\000\000)\000)\000)\000)\003\238\000)\000\000\000\000\000)\000)\000)\000)\000)\000)\000\146\000)\000\000\000)\000\000\000)\000)\000\000\000)\000)\000)\000)\003\238\000\000\000\000\000\000\000)\000)\000)\000\000\000\000\000)\000\000\000)\000\000\000\000\000\000\000)\000)\000\000\000)\000)\000)\000)\000\000\000\000\000R\000\000\000\000\000\000\000)\000\000\000\000\000)\000\000\000%\000%\000\000\000\000\000)\000)\000\000\000\000\000\000\000)\000)\t6\000\000\000\000\000\000\000\000\000\000\000\000\000%\000\000\000%\000\000\000\000\000%\000%\000\000\000%\000%\000%\000V\000\000\000\000\000%\000\000\000\000\000\000\000\000\000\000\000\000\000%\000%\003\214\000\000\000\000\000\000\000%\000%\000%\000\000\000\000\000%\000\000\000%\000\000\000\000\000\000\000\000\000\000\000\000\000%\000%\000\142\000%\000\000\000\000\000\000\000\000\000\000\000\000\000%\000)\000)\000%\000\000\000\000\000\000\000\000\000\000\000%\000%\000\000\t\142\000\000\000%\000%\000\000\000\000\000\000\000)\000\000\000)\000\000\000\000\000)\000)\000\000\000)\000)\000)\000\146\000\000\000\000\000)\000\000\000\000\000\000\000\000\000\000\000\000\000)\000)\003\238\000\000\000\000\000\000\000)\000)\000)\000\000\000\000\000)\000\000\000)\000\000\000\000\000\000\000\000\000\000\000\000\000)\000)\000R\000)\000\000\000\000\000\000\000\000\000\000\000\000\000)\000%\000%\000)\000\000\000\000\000\000\000\000\000\000\000)\000)\000\000\012\210\000\000\000)\000)\000\000\000\000\000\000\000%\000\000\000%\000\000\000\000\000%\000%\000\000\000%\000%\000%\000V\000\000\000\000\000%\000\000\000\000\000\000\000\000\000\000\000\000\000%\000%\003\214\000\000\000\000\000\000\000%\000%\000%\000\000\000\000\000%\000\000\000%\000\000\000\000\000\000\000\000\000\000\000\000\000%\000%\000\142\000%\000\000\000\000\000\000\000\000\000\000\000\000\000%\000)\000)\000%\000\000\000\000\000\000\000\000\000\000\000%\000%\000\000\r\n\000\000\000%\000%\000\000\000\000\000\000\000)\000\000\000)\000\000\000\000\000)\000)\000\000\000)\000)\000)\000\146\000\000\000\018\000)\000\000\000\000\000\000\000\000\000\000\000\000\000)\000)\003\238\000\000\000\000\000\000\000)\000)\000)\000\234\027:\000)\000\000\000)\000\238\007B\000\000\000\000\000\000\000\000\000)\000)\000\000\000)\000\000\000\000\000\000\000\000\000\250\000\000\000)\000\000\000\000\000)\000\000\000\000\000\254\000\000\000\000\000)\000)\000\000\000\000\001\002\000)\000)\007^\000\000\007f\007n\000\000\015\014\000\000\007\142\000\000\000\000\000\000\000\000\000\000\007\154\000\000\007\166\015\026\000\000\007\174\000\000\007\190\000\000\000\000\000\000\000\000\007\210\000\000\001\006\000\000\001\n\003\178\000\000\000\000\000\000\007\238\003\182\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\015&\b\130\000\000\000\000\000\000\015:\000\000\000\000\000\000\007B\"J\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\209\b\150\b\162\b\170\000\000\000\000\000\000\000\000\015b\000\000\000\000\b\206\000\000\b\226\t\002\000\000\000\000\000\000\t\022\t\"\007^\000\000\007f\007n\000\000\015\014\000\000\007\142\000\000\000\000\000\000\000\000\000\000\007\154\000\000\007\166\015\026\000\000\007\174\000\000\007\190\000\000\000\000\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\015&\b\130\000\000\000\000\000\000\015:\000\000\000\000\000\000\007B\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\213\b\150\b\162\b\170\000\000\000\000\000\000\000\000\015b\000\000\000\000\b\206\000\000\b\226\t\002\000\000\000\000\000\000\t\022\t\"\007^\000\000\007f\007n\000\000\015\014\000\000\007\142\000\000\000\000\000\000\000\000\000\000\007\154\000\000\007\166\015\026\000\000\007\174\000\000\007\190\000\000\000\000\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\015&\b\130\000\000\000\000\000\000\015:\000\000\000\000\000\000\007B\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\217\b\150\b\162\b\170\000\000\000\000\000\000\000\000\015b\000\000\000\000\b\206\000\000\b\226\t\002\000\000\000\000\000\000\t\022\t\"\007^\000\000\007f\007n\000\000\015\014\000\000\007\142\000\000\000\000\000\000\000\000\000\000\007\154\000\000\007\166\015\026\000\000\007\174\000\000\007\190\000\000\000\000\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\015&\b\130\000\000\000\000\000\000\015:\000\000\000\000\000\000\007B\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\bY\b\150\b\162\b\170\000\000\000\000\000\000\000\000\015b\000\000\000\000\b\206\000\000\b\226\t\002\000\000\000\000\000\000\t\022\t\"\007^\000\000\007f\007n\000\000\015\014\000\000\007\142\000\000\000\000\000\000\000\000\000\000\007\154\000\000\007\166\015\026\000\000\007\174\000\000\007\190\000\000\000\000\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\015&\b\130\000\000\000\000\000\000\015:\000\000\000\000\000\000\007B\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\ba\b\150\b\162\b\170\000\000\000\000\000\000\000\000\015b\000\000\000\000\b\206\000\000\b\226\t\002\000\000\000\000\000\000\t\022\t\"\007^\000\000\007f\007n\000\000\015\014\000\000\007\142\000\000\000\000\000\000\000\000\000\000\007\154\000\000\007\166\015\026\000\000\007\174\000\000\007\190\000\000\000\000\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\015&\b\130\000\000\000\000\000\000\015:\000\000\000\000\000\000\007B\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b]\b\150\b\162\b\170\000\000\000\000\000\000\000\000\015b\000\000\000\000\b\206\000\000\b\226\t\002\000\000\000\000\000\000\t\022\t\"\007^\000\000\007f\007n\000\000\015\014\000\000\007\142\000\000\000\000\000\000\000\000\000\000\007\154\000\000\007\166\015\026\000\000\007\174\000\000\007\190\000\000\000\000\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\015&\b\130\000\000\000\000\000\000\015:\000\000\000\000\000\000\007B\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\bi\b\150\b\162\b\170\000\000\000\000\000\000\000\000\015b\000\000\000\000\b\206\000\000\b\226\t\002\000\000\000\000\000\000\t\022\t\"\007^\000\000\007f\007n\000\000\015\014\000\000\007\142\000\000\000\000\000\000\000\000\000\000\007\154\000\000\007\166\015\026\000\000\007\174\000\000\007\190\000\000\000\000\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\015&\b\130\000\000\000\000\000\000\015:\000\000\000\000\000\000\007B\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\be\b\150\b\162\b\170\000\000\000\000\000\000\000\000\015b\000\000\000\000\b\206\000\000\b\226\t\002\000\000\000\000\000\000\t\022\t\"\007^\000\000\007f\007n\000\000\015\014\000\000\007\142\000\000\000\000\000\000\000\000\000\000\007\154\000\000\007\166\015\026\000\000\007\174\000\000\007\190\000\000\000\000\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\015&\b\130\000\000\000\000\000\000\015:\000\000\000\000\000\000\007B\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\225\b\150\b\162\b\170\000\000\000\000\000\000\000\000\015b\000\000\000\000\b\206\000\000\b\226\t\002\000\000\000\000\000\000\t\022\t\"\007^\000\000\007f\007n\000\000\015\014\000\000\007\142\000\000\000\000\000\000\000\000\000\000\007\154\000\000\007\166\015\026\000\000\007\174\000\000\007\190\000\000\000\000\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\015&\b\130\000\000\000\000\000\000\015:\000\000\000\000\000\000\007B\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\229\b\150\b\162\b\170\000\000\000\000\000\000\000\000\015b\000\000\000\000\b\206\000\000\b\226\t\002\000\000\000\000\000\000\t\022\t\"\007^\000\000\007f\007n\000\000\015\014\000\000\007\142\000\000\000\000\000\000\000\000\000\000\007\154\000\000\007\166\015\026\000\000\007\174\000\000\007\190\000\000\000\000\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\015&\b\130\000\000\000\000\000\000\015:\000\000\000\000\000\000\007B\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\233\b\150\b\162\b\170\000\000\000\000\000\000\000\000\015b\000\000\000\000\b\206\000\000\b\226\t\002\000\000\000\000\000\000\t\022\t\"\007^\000\000\007f\007n\000\000\015\014\000\000\007\142\000\000\000\000\000\000\000\000\000\000\007\154\000\000\007\166\015\026\000\000\007\174\000\000\007\190\000\000\000\000\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\015&\b\130\000\000\000\000\000\000\015:\000\000\000\000\000\000\007B\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\237\b\150\b\162\b\170\000\000\000\000\000\000\000\000\015b\000\000\000\000\b\206\000\000\b\226\t\002\000\000\000\000\000\000\t\022\t\"\007^\000\000\007f\007n\000\000\015\014\000\000\007\142\000\000\000\000\000\000\000\000\000\000\007\154\000\000\007\166\015\026\000\000\007\174\000\000\007\190\000\000\000\000\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\015&\b\130\000\000\000\000\000\000\015:\000\000\000\000\000\000\007B\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\bA\b\150\b\162\b\170\000\000\000\000\000\000\000\000\015b\000\000\000\000\b\206\000\000\b\226\t\002\000\000\000\000\000\000\t\022\t\"\007^\000\000\007f\007n\000\000\015\014\000\000\007\142\000\000\000\000\000\000\000\000\000\000\007\154\000\000\007\166\015\026\000\000\007\174\000\000\007\190\000\000\000\000\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\015&\b\130\000\000\000\000\000\000\015:\000\000\000\000\000\000\007B\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\bE\b\150\b\162\b\170\000\000\000\000\000\000\000\000\015b\000\000\000\000\b\206\000\000\b\226\t\002\000\000\000\000\000\000\t\022\t\"\007^\000\000\007f\007n\000\000\015\014\000\000\007\142\000\000\000\000\000\000\000\000\000\000\007\154\000\000\007\166\015\026\000\000\007\174\000\000\007\190\000\000\000\000\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\015&\b\130\000\000\000\000\000\000\015:\000\000\000\000\000\000\007B\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\bI\b\150\b\162\b\170\000\000\000\000\000\000\000\000\015b\000\000\000\000\b\206\000\000\b\226\t\002\000\000\000\000\000\000\t\022\t\"\007^\000\000\007f\007n\000\000\015\014\000\000\007\142\000\000\000\000\000\000\000\000\000\000\007\154\000\000\007\166\015\026\000\000\007\174\000\000\007\190\000\000\000\000\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\015&\b\130\000\000\000\000\000\000\015:\000\000\000\000\000\000\007B\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\bM\b\150\b\162\b\170\000\000\000\000\000\000\000\000\015b\000\000\000\000\b\206\000\000\b\226\t\002\000\000\000\000\000\000\t\022\t\"\007^\000\000\007f\007n\000\000\015\014\000\000\007\142\000\000\000\000\000\000\000\000\000\000\007\154\000\000\007\166\015\026\000\000\007\174\000\000\007\190\000\000\000\000\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\015&\b\130\000\000\000\000\000\000\015:\000\000\000\000\000\000\007B\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\249\b\150\b\162\b\170\000\000\000\000\000\000\000\000\015b\000\000\000\000\b\206\000\000\b\226\t\002\000\000\000\000\000\000\t\022\t\"\007^\000\000\007f\007n\000\000\015\014\000\000\007\142\000\000\000\000\000\000\000\000\000\000\007\154\000\000\007\166\015\026\000\000\007\174\000\000\007\190\000\000\000\000\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\015&\b\130\000\000\000\000\000\000\015:\000\000\000\000\000\000\007B\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\253\b\150\b\162\b\170\000\000\000\000\000\000\000\000\015b\000\000\000\000\b\206\000\000\b\226\t\002\000\000\000\000\000\000\t\022\t\"\007^\000\000\007f\007n\000\000\015\014\000\000\007\142\000\000\000\000\000\000\000\000\000\000\007\154\000\000\007\166\015\026\000\000\007\174\000\000\007\190\000\000\000\000\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\015&\b\130\000\000\000\000\000\000\015:\000\000\000\000\000\000\007B\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\001\b\150\b\162\b\170\000\000\000\000\000\000\000\000\015b\000\000\000\000\b\206\000\000\b\226\t\002\000\000\000\000\000\000\t\022\t\"\007^\000\000\007f\007n\000\000\015\014\000\000\007\142\000\000\000\000\000\000\000\000\000\000\007\154\000\000\007\166\015\026\000\000\007\174\000\000\007\190\000\000\000\000\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\015&\b\130\000\000\000\000\000\000\015:\000\000\000\000\000\000\007B\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\005\b\150\b\162\b\170\000\000\000\000\000\000\000\000\015b\000\000\000\000\b\206\000\000\b\226\t\002\000\000\000\000\000\000\t\022\t\"\007^\000\000\007f\007n\000\000\015\014\000\000\007\142\000\000\000\000\000\000\000\000\000\000\007\154\000\000\007\166\015\026\000\000\007\174\000\000\007\190\000\000\000\000\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\015&\b\130\000\000\000\000\000\000\015:\000\000\000\000\000\000\007B\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\017\b\150\b\162\b\170\000\000\000\000\000\000\000\000\015b\000\000\000\000\b\206\000\000\b\226\t\002\000\000\000\000\000\000\t\022\t\"\007^\000\000\007f\007n\000\000\015\014\000\000\007\142\000\000\000\000\000\000\000\000\000\000\007\154\000\000\007\166\015\026\000\000\007\174\000\000\007\190\000\000\000\000\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\015&\b\130\000\000\000\000\000\000\015:\000\000\000\000\000\000\007B\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\021\b\150\b\162\b\170\000\000\000\000\000\000\000\000\015b\000\000\000\000\b\206\000\000\b\226\t\002\000\000\000\000\000\000\t\022\t\"\007^\000\000\007f\007n\000\000\015\014\000\000\007\142\000\000\000\000\000\000\000\000\000\000\007\154\000\000\007\166\015\026\000\000\007\174\000\000\007\190\000\000\000\000\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\015&\b\130\000\000\000\000\000\000\015:\000\000\000\000\000\000\007B\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\025\b\150\b\162\b\170\000\000\000\000\000\000\000\000\015b\000\000\000\000\b\206\000\000\b\226\t\002\000\000\000\000\000\000\t\022\t\"\007^\000\000\007f\007n\000\000\015\014\000\000\007\142\000\000\000\000\000\000\000\000\000\000\007\154\000\000\007\166\015\026\000\000\007\174\000\000\007\190\000\000\000\000\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\015&\b\130\000\000\000\000\000\000\015:\000\000\000\000\000\000\007B\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\029\b\150\b\162\b\170\000\000\000\000\000\000\000\000\015b\000\000\000\000\b\206\000\000\b\226\t\002\000\000\000\000\000\000\t\022\t\"\007^\000\000\007f\007n\000\000\015\014\000\000\007\142\000\000\000\000\000\000\000\000\000\000\007\154\000\000\007\166\015\026\000\000\007\174\000\000\007\190\000\000\000\000\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\015&\b\130\000\000\000\000\000\000\015:\000\000\000\000\000\000\007B\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b)\b\150\b\162\b\170\000\000\000\000\000\000\000\000\015b\000\000\000\000\b\206\000\000\b\226\t\002\000\000\000\000\000\000\t\022\t\"\007^\000\000\007f\007n\000\000\015\014\000\000\007\142\000\000\000\000\000\000\000\000\000\000\007\154\000\000\007\166\015\026\000\000\007\174\000\000\007\190\000\000\000\000\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\015&\b\130\000\000\000\000\000\000\015:\000\000\000\000\000\000\007B\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b-\b\150\b\162\b\170\000\000\000\000\000\000\000\000\015b\000\000\000\000\b\206\000\000\b\226\t\002\000\000\000\000\000\000\t\022\t\"\007^\000\000\007f\007n\000\000\015\014\000\000\007\142\000\000\000\000\000\000\000\000\000\000\007\154\000\000\007\166\015\026\000\000\007\174\000\000\007\190\000\000\000\000\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\015&\b\130\000\000\000\000\000\000\015:\000\000\000\000\000\000\007B\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b1\b\150\b\162\b\170\000\000\000\000\000\000\000\000\015b\000\000\000\000\b\206\000\000\b\226\t\002\000\000\000\000\000\000\t\022\t\"\007^\000\000\007f\007n\000\000\015\014\000\000\007\142\000\000\000\000\000\000\000\000\000\000\007\154\000\000\007\166\015\026\000\000\007\174\000\000\007\190\000\000\000\000\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\015&\b\130\000\000\000\000\000\000\015:\000\000\000\000\000\000\007B\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b5\b\150\b\162\b\170\000\000\000\000\000\000\000\000\015b\000\000\000\000\b\206\000\000\b\226\t\002\000\000\000\000\000\000\t\022\t\"\007^\000\000\007f\007n\000\000\015\014\000\000\007\142\000\000\000\000\000\000\000\000\000\000\007\154\000\000\007\166\015\026\000\000\007\174\000\000\007\190\000\000\000\000\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\015&\b\130\000\000\000\000\000\000\015:\000\000\000\000\000\000\007B\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\bU\b\150\b\162\b\170\000\000\000\000\000\000\000\000\015b\000\000\000\000\b\206\000\000\b\226\t\002\000\000\000\000\000\000\t\022\t\"\007^\000\000\007f\007n\000\000\015\014\000\000\007\142\000\000\000\000\000\000\000\000\000\000\007\154\000\000\007\166\015\026\000\000\007\174\000\000\007\190\000\000\000\000\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\015&\b\130\000\000\000\000\000\000\015:\000\000\000\000\000\000\007B\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\bu\b\150\b\162\b\170\000\000\000\000\000\000\000\000\015b\000\000\000\000\b\206\000\000\b\226\t\002\000\000\000\000\000\000\t\022\t\"\007^\000\000\007f\007n\000\000\015\014\000\000\007\142\000\000\000\000\000\000\000\000\000\000\007\154\000\000\007\166\015\026\000\000\007\174\000\000\007\190\000\000\000\000\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\015&\b\130\000\000\000\000\000\000\015:\000\000\000\000\000\000\007B\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\by\b\150\b\162\b\170\000\000\000\000\000\000\000\000\015b\000\000\000\000\b\206\000\000\b\226\t\002\000\000\000\000\000\000\t\022\t\"\007^\000\000\007f\007n\000\000\015\014\000\000\007\142\000\000\000\000\000\000\000\000\000\000\007\154\000\000\007\166\015\026\000\000\007\174\000\000\007\190\000\000\000\000\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\015&\b\130\000\000\000\000\000\000\015:\000\000\000\000\000\000\007B\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\129\b\150\b\162\b\170\000\000\000\000\000\000\000\000\015b\000\000\000\000\b\206\000\000\b\226\t\002\000\000\000\000\000\000\t\022\t\"\007^\000\000\007f\007n\000\000\015\014\000\000\007\142\000\000\000\000\000\000\000\000\000\000\007\154\000\000\007\166\015\026\000\000\007\174\000\000\007\190\000\000\000\000\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\015&\b\130\000\000\000\000\000\000\015:\000\000\000\000\000\000\007B\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\145\b\150\b\162\b\170\000\000\000\000\000\000\000\000\015b\000\000\000\000\b\206\000\000\b\226\t\002\000\000\000\000\000\000\t\022\t\"\007^\000\000\007f\007n\000\000\015\014\000\000\007\142\000\000\000\000\000\000\000\000\000\000\007\154\000\000\007\166\015\026\000\000\007\174\000\000\007\190\000\000\000\000\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\015&\b\130\000\000\000\000\000\000\015:\000\000\000\000\000\000\007B\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\133\b\150\b\162\b\170\000\000\000\000\000\000\000\000\015b\000\000\000\000\b\206\000\000\b\226\t\002\000\000\000\000\000\000\t\022\t\"\007^\000\000\007f\007n\000\000\015\014\000\000\007\142\000\000\000\000\000\000\000\000\000\000\007\154\000\000\007\166\015\026\000\000\007\174\000\000\007\190\000\000\000\000\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\015&\b\130\000\000\000\000\000\000\015:\000\000\000\000\000\000\007B\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\137\b\150\b\162\b\170\000\000\000\000\000\000\000\000\015b\000\000\000\000\b\206\000\000\b\226\t\002\000\000\000\000\000\000\t\022\t\"\007^\000\000\007f\007n\000\000\015\014\000\000\007\142\000\000\000\000\000\000\000\000\000\000\007\154\000\000\007\166\015\026\000\000\007\174\000\000\007\190\000\000\000\000\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\015&\b\130\000\000\000\000\000\000\015:\000\000\000\000\000\000\007B\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\141\b\150\b\162\b\170\000\000\000\000\000\000\000\000\015b\000\000\000\000\b\206\000\000\b\226\t\002\000\000\000\000\000\000\t\022\t\"\007^\000\000\007f\007n\000\000\015\014\000\000\007\142\000\000\000\000\000\000\000\000\000\000\007\154\000\000\007\166\015\026\000\000\007\174\000\000\007\190\000\000\000\000\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\015&\b\130\000\000\000\000\000\000\015:\000\000\000\000\000\000\007B\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b}\b\150\b\162\b\170\000\000\000\000\000\000\000\000\015b\000\000\000\000\b\206\000\000\b\226\t\002\000\000\000\000\000\000\t\022\t\"\007^\000\000\007f\007n\000\000\015\014\000\000\007\142\000\000\000\000\000\000\000\000\000\000\007\154\000\000\007\166\015\026\000\000\007\174\000\000\007\190\000\000\000\000\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\015&\b\130\000\000\000\000\000\000\015:\000\000\000\000\000\000\007B\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\bq\b\150\b\162\b\170\000\000\000\000\000\000\000\000\015b\000\000\000\000\b\206\000\000\b\226\t\002\000\000\000\000\000\000\t\022\t\"\007^\000\000\007f\007n\000\000\015\014\000\000\007\142\000\000\000\000\000\000\000\000\000\000\007\154\000\000\007\166\015\026\000\000\007\174\000\000\007\190\000\000\000\000\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\015&\b\130\000\000\000\000\000\000\015:\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\bm\b\150\b\162\b\170\001n\011\133\011\133\000\000\015b\000\000\000\000\b\206\000\000\b\226\t\002\000\000\011\133\000\000\t\022\t\"\000\000\000\000\011\133\011\133\000\000\011\133\000\000\000\000\011\133\011\133\000\000\011\133\011\133\000\000\000\000\000\000\000\000\011\133\000\000\000\000\000\000\000\000\000\000\000\000\011\133\011\133\000\000\000\000\000\000\011\133\011\133\011\133\011\133\000\000\000\000\011\133\000\000\011\133\000\000\000\000\000\000\000\000\000\000\000\000\000\000\011\133\000\000\011\133\000\000\000\000\000\000\000\000\000\000\011\133\011\133\nq\nq\011\133\000\000\000\000\000\000\000\000\000\000\011\133\011\133\000\000\nq\000\000\011\133\011\133\000\000\000\000\nq\nq\000\000\nq\000\000\000\000\nq\nq\000\000\nq\nq\000\000\002b\000\000\000\000\nq\000\000\000\000\000\000\000\000\000\000\000\000\nq\nq\000\000\000\000\000\000\nq\nq\nq\nq\000\000\000\000\nq\000\000\nq\000\000\000\000\000\000\000\000\000\000\000\000\000\000\nq\000\000\nq\000\000\000\000\000\000\000\000\000\000\nq\nq\000\000\000\000\nq\002\142\011M\011M\000\000\000\000\nq\nq\000\000\000\000\000\000\nq\nq\011M\000\000\000\000\000\000\000\000\000\000\011M\011M\000\000\011M\000\000\000\000\011M\011M\000\000\011M\011M\000\000\000\000\000\000\000\000\011M\000\000\000\000\000\000\000\000\000\000\000\000\011M\011M\000\000\000\000\000\000\011M\011M\011M\011M\000\000\000\000\011M\000\000\011M\000\000\000\000\000\000\000\000\000\000\000\000\000\000\011M\000\000\011M\000\000\000\000\000\000\000\000\000\000\011M\011M\000\000\000\000\011M\002\186\011e\011e\000\000\000\000\011M\011M\000\000\000\000\000\000\011M\011M\011e\000\000\000\000\000\000\000\000\000\000\011e\011e\000\000\011e\000\000\000\000\011e\011e\000\000\011e\011e\000\000\000\000\000\000\000\000\011e\000\000\000\000\000\000\000\000\000\000\000\000\011e\011e\000\000\000\000\000\000\011e\011e\011e\011e\000\000\000\000\011e\000\000\011e\000\000\000\000\000\000\000\000\000\000\000\000\000\000\011e\000\000\011e\000\000\000\000\000\000\000\000\000\000\011e\011e\000\000\000\000\011e\002\254\011E\011E\000\000\000\000\011e\011e\000\000\000\000\000\000\011e\011e\011E\000\000\000\000\000\000\000\000\000\000\011E\011E\000\000\011E\000\000\000\000\011E\011E\000\000\011E\011E\000\000\000\000\000\000\000\000\011E\000\000\000\000\000\000\000\000\000\000\000\000\011E\011E\000\000\000\000\000\000\011E\011E\011E\011E\000\000\000\000\011E\000\000\011E\000\000\000\000\000\000\000\000\000\000\000\000\000\000\011E\000\000\011E\000\000\000\000\000\000\015J\000\000\011E\011E\001\022\001.\011E\000\000\005\166\000\000\000\000\000\000\011E\011E\000\000\n\233\000\000\011E\011E\000\000\000\000\n\233\001r\000\000\001\154\015j\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\007J\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\001\234\000\000\000\000\000\000\n\233\001\138\001\242\001\250\000\000\017~\002\002\000\000\001\178\015Z\000\000\000\000\003\018\004\025\018b\003\250\0016\021\242\001\146\000\000\000\000\000\000\000\000\000\000\n\233\002*\000\000\000\000\001Z\003N\011]\011]\000\000\000\000\0022\002\014\000\000\000\000\000\000\001\186\002:\011]\000\000\000\000\000\000\000\000\000\000\011]\011]\000\000\011]\000\000\000\000\011]\011]\000\000\011]\011]\000\000\000\000\000\000\000\000\011]\000\000\000\000\000\000\000\000\000\000\000\000\011]\011]\000\000\000\000\000\000\011]\011]\011]\011]\000\000\000\000\011]\000\000\011]\000\000\000\000\000\000\000\000\000\000\000\000\000\000\011]\000\000\011]\000\000\000\000\000\000\000\000\000\000\011]\011]\000\000\000\000\011]\003b\011U\011U\000\000\000\000\011]\011]\000\000\000\000\000\000\011]\011]\011U\000\000\000\000\000\000\000\000\000\000\011U\011U\000\000\011U\000\000\000\000\011U\011U\000\000\011U\011U\000\000\000\000\000\000\000\000\011U\000\000\000\000\000\000\000\000\000\000\000\000\011U\011U\000\000\000\000\000\000\011U\011U\011U\011U\000\000\000\000\011U\000\000\011U\000\000\000\000\000\000\000\000\000\000\000\000\000\000\011U\000\000\011U\000\000\000\000\000\000\000\000\000\000\011U\011U\000\000\000\000\011U\003\142\011m\011m\000\000\000\000\011U\011U\000\000\000\000\000\000\011U\011U\011m\000\000\000\000\000\000\000\000\000\000\011m\011m\000\000\011m\000\000\000\000\011m\011m\000\000\011m\011m\000\000\000\000\000\000\000\000\011m\000\000\000\000\000\000\000\000\000\000\000\000\011m\011m\000\000\000\000\000\000\011m\011m\011m\011m\000\000\000\000\011m\000\000\011m\000\000\000\000\000\000\000\000\000\000\000\000\000\000\011m\000\000\011m\000\000\000\000\000\000\000\000\000\000\011m\011m\000\000\000\000\011m\004\026\011\149\011\149\000\000\000\000\011m\011m\000\000\000\000\000\000\011m\011m\011\149\000\000\000\000\000\000\000\000\000\000\011\149\011\149\000\000\011\149\000\000\000\000\011\149\011\149\000\000\011\149\011\149\000\000\000\000\000\000\000\000\011\149\000\000\000\000\000\000\000\000\000\000\000\000\011\149\011\149\000\000\000\000\000\000\011\149\011\149\011\149\011\149\000\000\000\000\011\149\000\000\011\149\000\000\000\000\000\000\000\000\000\000\000\000\000\000\011\149\000\000\011\149\000\000\000\000\000\000\000\000\000\000\011\149\011\149\000\000\000\000\011\149\0046\011\141\011\141\000\000\000\000\011\149\011\149\000\000\000\000\000\000\011\149\011\149\011\141\000\000\000\000\000\000\000\000\000\000\011\141\011\141\000\000\011\141\000\000\000\000\011\141\011\141\000\000\011\141\011\141\000\000\000\000\000\000\000\000\011\141\000\000\000\000\000\000\000\000\000\000\000\000\011\141\011\141\000\000\000\000\000\000\011\141\011\141\011\141\011\141\000\000\000\000\011\141\000\000\011\141\000\000\000\000\000\000\000\000\000\000\000\000\000\000\011\141\000\000\011\141\000\000\000\000\000\000\000\000\000\000\011\141\011\141\000\000\000\000\011\141\004Z\011\157\011\157\000\000\000\000\011\141\011\141\000\000\000\000\000\000\011\141\011\141\011\157\000\000\000\000\000\000\000\000\000\000\011\157\011\157\000\000\011\157\000\000\000\000\011\157\011\157\000\000\011\157\011\157\000\000\000\000\000\000\000\000\011\157\000\000\000\000\000\000\000\000\000\000\000\000\011\157\011\157\000\000\000\000\000\000\011\157\011\157\011\157\011\157\000\000\000\000\011\157\000\000\011\157\000\000\000\000\000\000\000\000\000\000\000\000\000\000\011\157\000\000\011\157\000\000\000\000\000\000\000\000\000\000\011\157\011\157\000\000\000\000\011\157\005\138\011}\011}\000\000\000\000\011\157\011\157\000\000\000\000\000\000\011\157\011\157\011}\000\000\000\000\000\000\000\000\000\000\011}\011}\000\000\011}\000\000\000\000\011}\011}\000\000\011}\011}\000\000\000\000\000\000\000\000\011}\000\000\000\000\000\000\000\000\000\000\000\000\011}\011}\000\000\000\000\000\000\011}\011}\011}\011}\000\000\000\000\011}\000\000\011}\000\000\000\000\000\000\000\000\000\000\000\000\000\000\011}\000\000\011}\000\000\000\000\000\000\000\000\000\000\011}\011}\000\000\000\000\011}\005\146\011u\011u\000\000\000\000\011}\011}\000\000\000\000\000\000\011}\011}\011u\000\000\000\000\000\000\000\000\000\000\011u\011u\000\000\011u\000\000\000\000\011u\011u\000\000\011u\011u\000\000\000\000\000\000\000\000\011u\000\000\000\000\000\000\000\000\000\000\000\000\011u\011u\000\000\000\000\000\000\011u\011u\011u\011u\000\000\000\000\011u\000\000\011u\000\000\000\000\000\000\000\000\000\000\000\000\000\000\011u\000\000\011u\000\000\000\000\000\000\000\000\000\000\011u\011u\000\000\003\n\011u\001\022\001.\007\138\000\000\001b\011u\011u\000\000\000\000\000\000\011u\011u\000\000\t\129\000\000\000\000\000\000\000\000\001r\000\000\001\154 \n\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\015R\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\001\234\000\000\000\000\000\000\000\000\001\138\001\242\001\250\000\000\000\000\002\002\000\000\001\178\018N\000\000\000\000\000\000\000\000\000\000\002\026\0016\007R\001\146\000\000\000\000\000\000\031\226\000\000\002B\002*\001\022\001.\001Z\000\000\t\161\000\000\000\000\000\000\0022\002\014\000\000\t\161\000\000\001\186\002:\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\018j\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\001\234\000\000\000\000\000\000\000\000\001\138\001\242\001\250\000\000\000\000\002\002\000\000\001\178\018\134\000\000\000\000\000\000\000\000 r\004>\0016\031:\001\146\000\000\000\000\000\000\000\000\000\000\002v\002*\n\141\n\141\001Z\000\000\000\000\000\000\000\000\000\000\0022\002\014\000\000\n\141\000\000\001\186\002:\000\000\000\000\n\141\n\141\000\000\n\141\000\000\000\000\n\141\n\141\000\000\n\141\n\141\000\000\000\000\000\000\000\000\004b\000\000\000\000\000\000\000\000\000\000\000\000\n\141\n\141\000\000\000\000\000\000\n\141\n\141\n\141\n\141\000\000\000\000\n\141\000\000\n\141\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004v\000\000\n\141\000\000\000\000\000\000\000\000\000\000\n\141\n\141\004n\004\150\n\141\000\000\000\000\000\000\000\000\000\000\n\141\n\141\000\000\n1\000\000\n\141\n\141\000\000\000\000\004\158\004\166\000\000\004\206\000\000\000\000\004\174\004\214\000\000\004\182\004\222\000\000\000\000\000\000\000\000\004b\000\000\000\000\000\000\000\000\000\000\000\000\004\246\005\006\000\000\000\000\000\000\n1\004\190\005\014\n1\000\000\000\000\005\022\000\000\004\230\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004v\000\000\004\198\000\000\000\000\000\000\000\000\000\000\005F\005N\n\205\n\205\004\142\000\000\000\000\000\000\000\000\000\000\0056\005\"\000\000\n\205\000\000\004\238\005>\000\000\000\000\n\205\n\205\000\000\n\205\000\000\000\000\n\205\n\205\000\000\n\205\n\205\000\000\000\000\000\000\000\000\004b\000\000\000\000\000\000\000\000\000\000\000\000\n\205\n\205\000\000\000\000\000\000\n\205\n\205\n\205\n\205\000\000\000\000\n\205\000\000\n\205\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004v\000\000\n\205\000\000\000\000\000\000\000\000\000\000\n\205\n\205\n\225\n\225\004\142\000\000\000\000\000\000\000\000\000\000\n\205\n\205\000\000\n\225\000\000\n\205\n\205\000\000\000\000\n\225\n\225\000\000\n\225\000\000\000\000\n\225\n\225\000\000\n\225\n\225\000\000\000\000\000\000\000\000\004b\000\000\000\000\000\000\000\000\000\000\000\000\n\225\n\225\000\000\000\000\000\000\n\225\n\225\n\225\n\225\000\000\000\000\n\225\000\000\n\225\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004v\000\000\n\225\000\000\000\000\000\000\000\000\000\000\n\225\n\225\n\213\n\213\n\225\000\000\000\000\000\000\000\000\000\000\n\225\n\225\000\000\n\213\000\000\n\225\n\225\000\000\000\000\n\213\n\213\000\000\n\213\000\000\000\000\n\213\n\213\000\000\n\213\n\213\000\000\000\000\000\000\000\000\004b\000\000\000\000\000\000\000\000\000\000\000\000\n\213\n\213\000\000\000\000\000\000\n\213\n\213\n\213\n\213\000\000\000\000\n\213\000\000\n\213\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004v\000\000\n\213\000\000\000\000\000\000\000\000\000\000\n\213\n\213\004n\004\150\004\142\000\000\000\000\000\000\000\000\000\000\n\213\n\213\000\000\n\193\000\000\n\213\n\213\000\000\000\000\n\193\n\193\000\000\n\193\000\000\000\000\004\174\n\193\000\000\004\182\n\193\000\000\000\000\000\000\000\000\004b\000\000\000\000\000\000\000\000\000\000\000\000\n\193\n\193\000\000\000\000\000\000\n\193\004\190\n\193\n\193\000\000\000\000\n\193\000\000\n\193\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004v\000\000\004\198\000\000\000\000\000\000\000\000\000\000\n\193\n\193\n\201\n\201\004\142\000\000\000\000\000\000\000\000\000\000\n\193\n\193\000\000\n\201\000\000\n\193\n\193\000\000\000\000\n\201\n\201\000\000\n\201\000\000\000\000\n\201\n\201\000\000\n\201\n\201\000\000\000\000\000\000\000\000\004b\000\000\000\000\000\000\000\000\000\000\000\000\n\201\n\201\000\000\000\000\000\000\n\201\n\201\n\201\n\201\000\000\000\000\n\201\000\000\n\201\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004v\000\000\n\201\000\000\000\000\000\000\000\000\000\000\n\201\n\201\n\217\n\217\004\142\000\000\000\000\000\000\000\000\000\000\n\201\n\201\000\000\n\217\000\000\n\201\n\201\000\000\000\000\n\217\n\217\000\000\n\217\000\000\000\000\n\217\n\217\000\000\n\217\n\217\000\000\000\000\000\000\000\000\004b\000\000\000\000\000\000\000\000\000\000\000\000\n\217\n\217\000\000\000\000\000\000\n\217\n\217\n\217\n\217\000\000\000\000\n\217\000\000\n\217\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004v\000\000\n\217\000\000\000\000\000\000\000\000\000\000\n\217\n\217\n\221\n\221\004\142\000\000\000\000\000\000\000\000\000\000\n\217\n\217\000\000\n\221\000\000\n\217\n\217\000\000\000\000\n\221\n\221\000\000\n\221\000\000\000\000\n\221\n\221\000\000\n\221\n\221\000\000\000\000\000\000\000\000\004b\000\000\000\000\000\000\000\000\000\000\000\000\n\221\n\221\000\000\000\000\000\000\n\221\n\221\n\221\n\221\000\000\000\000\n\221\000\000\n\221\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004v\000\000\n\221\000\000\000\000\000\000\000\000\000\000\n\221\n\221\n\165\n\165\004\142\000\000\000\000\000\000\000\000\000\000\n\221\n\221\000\000\n\165\000\000\n\221\n\221\000\000\000\000\n\165\n\165\000\000\n\165\000\000\000\000\n\165\n\165\000\000\n\165\n\165\000\000\000\000\000\000\000\000\004b\000\000\000\000\000\000\000\000\000\000\000\000\n\165\n\165\000\000\000\000\000\000\n\165\n\165\n\165\n\165\000\000\000\000\n\165\000\000\n\165\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004v\000\000\n\165\000\000\000\000\000\000\000\000\000\000\n\165\n\165\004n\004\150\004\142\000\000\000\000\000\000\000\000\000\000\n\165\n\165\000\000\n\209\000\000\n\165\n\165\000\000\000\000\n\209\n\209\000\000\n\209\000\000\000\000\004\174\n\209\000\000\004\182\n\209\000\000\000\000\000\000\000\000\004b\000\000\000\000\000\000\000\000\000\000\000\000\n\209\n\209\000\000\000\000\000\000\n\209\004\190\n\209\n\209\000\000\000\000\n\209\000\000\n\209\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004v\000\000\004\198\000\000\000\000\000\000\000\000\000\000\n\209\n\209\004n\004\150\004\142\000\000\000\000\000\000\000\000\000\000\n\209\n\209\000\000\n\197\000\000\n\209\n\209\000\000\000\000\n\197\n\197\000\000\n\197\000\000\000\000\004\174\n\197\000\000\004\182\n\197\000\000\000\000\000\000\000\000\004b\000\000\000\000\000\000\000\000\000\000\000\000\n\197\n\197\000\000\000\000\000\000\n\197\004\190\n\197\n\197\000\000\000\000\n\197\000\000\n\197\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004v\000\000\004\198\000\000\000\000\000\000\000\000\000\000\n\197\n\197\004n\004\150\004\142\000\000\000\000\000\000\000\000\000\000\n\197\n\197\000\000\n\169\000\000\n\197\n\197\000\000\000\000\n\169\n\169\000\000\n\169\000\000\000\000\004\174\n\169\000\000\004\182\n\169\000\000\000\000\000\000\000\000\004b\000\000\000\000\000\000\000\000\000\000\000\000\n\169\n\169\000\000\000\000\000\000\n\169\004\190\n\169\n\169\000\000\000\000\n\169\000\000\n\169\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004v\000\000\004\198\000\000\000\000\000\000\000\000\000\000\n\169\n\169\004n\004\150\004\142\000\000\000\000\000\000\000\000\000\000\n\169\n\169\000\000\n\153\000\000\n\169\n\169\000\000\000\000\n\153\n\153\000\000\n\153\000\000\000\000\004\174\n\153\000\000\004\182\n\153\000\000\000\000\000\000\000\000\004b\000\000\000\000\000\000\000\000\000\000\000\000\n\153\n\153\000\000\000\000\000\000\n\153\004\190\n\153\n\153\000\000\000\000\n\153\000\000\n\153\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004v\000\000\004\198\000\000\000\000\000\000\000\000\000\000\n\153\n\153\004n\004\150\004\142\000\000\000\000\000\000\000\000\000\000\n\153\n\153\000\000\n\185\000\000\n\153\n\153\000\000\000\000\n\185\004\166\000\000\004\206\000\000\000\000\004\174\004\214\000\000\004\182\004\222\000\000\000\000\000\000\000\000\004b\000\000\000\000\000\000\000\000\000\000\000\000\004\246\n\185\000\000\000\000\000\000\n\185\004\190\005\014\n\185\000\000\000\000\005\022\000\000\004\230\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004v\000\000\004\198\000\000\000\000\000\000\000\000\000\000\n\185\n\185\004n\004\150\004\142\000\000\000\000\000\000\000\000\000\000\n\185\005\"\000\000\n\173\000\000\004\238\n\185\000\000\000\000\n\173\004\166\000\000\004\206\000\000\000\000\004\174\004\214\000\000\004\182\004\222\000\000\000\000\000\000\000\000\004b\000\000\000\000\000\000\000\000\000\000\000\000\004\246\n\173\000\000\000\000\000\000\n\173\004\190\005\014\n\173\000\000\000\000\n\173\000\000\004\230\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004v\000\000\004\198\000\000\000\000\000\000\000\000\000\000\n\173\n\173\004n\004\150\004\142\000\000\000\000\000\000\000\000\000\000\n\173\n\173\000\000\n\177\000\000\004\238\n\173\000\000\000\000\n\177\004\166\000\000\004\206\000\000\000\000\004\174\004\214\000\000\004\182\004\222\000\000\000\000\000\000\000\000\004b\000\000\000\000\000\000\000\000\000\000\000\000\004\246\n\177\000\000\000\000\000\000\n\177\004\190\005\014\n\177\000\000\000\000\n\177\000\000\004\230\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004v\000\000\004\198\000\000\000\000\000\000\000\000\000\000\n\177\n\177\004n\004\150\004\142\000\000\000\000\000\000\000\000\000\000\n\177\n\177\000\000\n\161\000\000\004\238\n\177\000\000\000\000\n\161\004\166\000\000\004\206\000\000\000\000\004\174\004\214\000\000\004\182\004\222\000\000\000\000\000\000\000\000\004b\000\000\000\000\000\000\000\000\000\000\000\000\004\246\n\161\000\000\000\000\000\000\n\161\004\190\005\014\n\161\000\000\000\000\005\022\000\000\004\230\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004v\000\000\004\198\000\000\000\000\000\000\000\000\000\000\n\161\n\161\004n\004\150\004\142\000\000\000\000\000\000\000\000\000\000\n\161\005\"\000\000\n\157\000\000\004\238\n\161\000\000\000\000\n\157\004\166\000\000\004\206\000\000\000\000\004\174\004\214\000\000\004\182\004\222\000\000\000\000\000\000\000\000\004b\000\000\000\000\000\000\000\000\000\000\000\000\004\246\n\157\000\000\000\000\000\000\n\157\004\190\005\014\n\157\000\000\000\000\005\022\000\000\004\230\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004v\000\000\004\198\000\000\000\000\000\000\000\000\000\000\n\157\n\157\004n\004\150\004\142\000\000\000\000\000\000\000\000\000\000\n\157\005\"\000\000\n\145\000\000\004\238\n\157\000\000\000\000\n\145\n\145\000\000\n\145\000\000\000\000\004\174\n\145\000\000\004\182\n\145\000\000\000\000\000\000\000\000\004b\000\000\000\000\000\000\000\000\000\000\000\000\n\145\n\145\000\000\000\000\000\000\n\145\004\190\n\145\n\145\000\000\000\000\n\145\000\000\n\145\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004v\000\000\004\198\000\000\000\000\000\000\000\000\000\000\n\145\n\145\n\149\n\149\004\142\000\000\000\000\000\000\000\000\000\000\n\145\n\145\000\000\n\149\000\000\n\145\n\145\000\000\000\000\n\149\n\149\000\018\n\149\000\000\000\000\n\149\n\149\000\000\n\149\n\149\000\000\000\000\000\000\000\000\004b\000\000\000\000\000\000\000\234\028\226\000\000\n\149\n\149\000\238\000\000\000\000\n\149\n\149\n\149\n\149\000\000\000\000\n\149\000\000\n\149\000\000\000\000\000\250\000\000\000\000\000\000\000\000\004v\000\000\n\149\000\254\000\000\000\000\000\000\000\000\n\149\n\149\001\002\000\000\n\149\t\229\000\000\t\229\t\229\000\000\n\149\n\149\t\229\000\000\000\000\n\149\n\149\000\000\t\229\000\000\t\229\000\000\000\000\t\229\000\000\t\229\000\000\000\000\000\000\000\000\t\229\000\000\001\006\000\000\001\n\003\178\000\000\000\000\000\000\t\229\003\182\000\000\000\000\000\000\t\229\000\000\000\000\t\229\000\000\000\000\000\000\000\000\t\229\000\000\000\000\000\000\t\229\000\000\t\229\t\229\000\000\000\000\000\000\000\000\t\229\000\000\000\000\000\000\t\229\000\000\000\000\000\000\000\000\000\000\000\000\t\241\000\000\t\241\t\241\t\229\t\229\t\229\t\241\015~\000\000\000\000\000\000\000\000\t\241\t\229\t\241\t\229\t\229\t\241\000\000\t\241\t\229\t\229\t\229\000\000\t\241\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\t\241\000\000\000\000\000\000\000\000\t\241\000\000\000\000\t\241\000\000\000\000\000\000\000\000\t\241\000\000\000\000\000\000\t\241\000\000\t\241\t\241\000\000\000\000\000\000\000\000\t\241\000\000\000\000\000\000\t\241\000\000\000\000\000\000\000\000\000\000\000\000\t\221\000\000\t\221\t\221\t\241\t\241\t\241\t\221\015\134\000\000\000\000\000\000\000\000\t\221\t\241\t\221\t\241\t\241\t\221\000\000\t\221\t\241\t\241\t\241\000\000\t\221\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\t\221\000\000\000\000\000\000\000\000\t\221\000\000\000\000\t\221\000\000\000\000\000\000\000\000\t\221\000\000\000\000\000\000\t\221\000\000\t\221\t\221\000\000\000\000\000\000\000\000\t\221\000\000\000\000\000\000\t\221\000\000\000\000\000\000\000\000\000\000\000\000\t\233\000\000\t\233\t\233\t\221\t\221\t\221\t\233\015\142\000\000\000\000\000\000\000\000\t\233\t\221\t\233\t\221\t\221\t\233\000\000\t\233\t\221\t\221\t\221\000\000\t\233\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\t\233\000\000\000\000\000\000\000\000\t\233\000\000\000\000\t\233\000\000\000\000\000\000\000\000\t\233\000\000\000\000\000\000\t\233\000\000\t\233\t\233\000\000\000\000\000\000\000\000\t\233\000\000\000\000\000\000\t\233\000\000\000\000\000\000\000\000\000\000\000\000\t\209\000\000\t\209\t\209\t\233\t\233\t\233\t\209\015\158\000\000\000\000\000\000\000\000\t\209\t\233\t\209\t\233\t\233\t\209\000\000\t\209\t\233\t\233\t\233\000\000\t\209\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\t\209\000\000\000\000\000\000\000\000\t\209\000\000\000\000\t\209\000\000\000\000\000\000\000\000\t\209\000\000\000\000\000\000\t\209\000\000\t\209\t\209\000\000\000\000\000\000\000\000\t\209\000\000\000\000\000\000\t\209\000\000\000\000\000\000\000\000\000\000\000\000\t\205\000\000\t\205\t\205\t\209\t\209\t\209\t\205\015\166\000\000\000\000\000\000\000\000\t\205\t\209\t\205\t\209\t\209\t\205\000\000\t\205\t\209\t\209\t\209\000\000\t\205\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\t\205\000\000\000\000\000\000\000\000\t\205\000\000\000\000\t\205\000\000\000\000\000\000\000\000\t\205\000\000\000\000\000\000\t\205\000\000\t\205\t\205\000\000\000\000\000\000\000\000\t\205\000\000\000\000\000\000\t\205\000\000\000\000\000\000\000\000\000\000\000\000\t\201\000\000\t\201\t\201\t\205\t\205\t\205\t\201\015\174\000\000\000\000\000\000\000\000\t\201\t\205\t\201\t\205\t\205\t\201\000\000\t\201\t\205\t\205\t\205\000\000\t\201\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\t\201\000\000\000\000\000\000\000\000\t\201\000\000\000\000\t\201\000\000\000\000\000\000\000\000\t\201\000\000\000\000\000\000\t\201\000\000\t\201\t\201\000\000\000\000\000\000\000\000\t\201\000\000\000\000\000\000\t\201\000\000\000\000\000\000\000\000\000\000\000\000\t\217\000\000\t\217\t\217\t\201\t\201\t\201\t\217\015\190\000\000\000\000\000\000\000\000\t\217\t\201\t\217\t\201\t\201\t\217\000\000\t\217\t\201\t\201\t\201\000\000\t\217\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\t\217\000\000\000\000\000\000\000\000\t\217\000\000\000\000\t\217\000\000\000\000\000\000\000\000\t\217\000\000\000\000\000\000\t\217\000\000\t\217\t\217\000\000\000\000\000\000\000\000\t\217\000\000\000\000\000\000\t\217\000\000\000\000\000\000\000\000\000\000\000\000\t\237\000\000\t\237\t\237\t\217\t\217\t\217\t\237\015\198\000\000\000\000\000\000\000\000\t\237\t\217\t\237\t\217\t\217\t\237\000\000\t\237\t\217\t\217\t\217\000\000\t\237\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\t\237\000\000\000\000\000\000\000\000\t\237\000\000\000\000\t\237\000\000\000\000\000\000\000\000\t\237\000\000\000\000\000\000\t\237\000\000\t\237\t\237\000\000\000\000\000\000\000\000\t\237\000\000\000\000\000\000\t\237\000\000\000\000\000\000\000\000\000\000\000\000\t\213\000\000\t\213\t\213\t\237\t\237\t\237\t\213\015\206\000\000\000\000\000\000\000\000\t\213\t\237\t\213\t\237\t\237\t\213\000\000\t\213\t\237\t\237\t\237\000\000\t\213\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\t\213\000\000\000\000\000\000\000\000\t\213\000\000\000\000\t\213\000\000\000\000\000\000\000\000\t\213\000\000\000\000\000\000\t\213\000\000\t\213\t\213\000\000\000\000\000\000\000\000\t\213\000\000\000\000\000\000\t\213\000\000\000\000\000\000\000\000\000\000\000\000\t\225\000\000\t\225\t\225\t\213\t\213\t\213\t\225\015\214\000\000\000\000\000\000\000\000\t\225\t\213\t\225\t\213\t\213\t\225\000\000\t\225\t\213\t\213\t\213\000\000\t\225\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\t\225\000\000\000\000\000\000\000\000\t\225\000\000\000\000\t\225\000\000\000\000\000\000\000\000\t\225\000\000\000\000\000\000\t\225\000\000\t\225\t\225\000\000\000\000\000\000\000\000\t\225\000\000\000\000\000\000\t\225\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\t\225\t\225\t\225\000\000\015\222\003\026\000\000\001\022\001.\021\026\t\225\003v\t\225\t\225\000\000\000\000\000\000\t\225\t\225\t\225\t\133\000\000\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\021&\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\001\234\000\000\000\000\000\000\000\000\001\138\001\242\001\250\000\000\000\000\002\002\000\000\001\178\018r\000\000\000\000\000\000\000\000\000\000\006\002\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\002\"\002*\001\022\001.\001Z\000\000\002\206\000\000\000\000\000\000\0022\002\014\000\000\022\162\000\000\001\186\002:\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\0312\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\001\234\000\000\000\000\000\000\000\000\001\138\001\242\001\250\000\000\000\000\002\002\000\000\001\178\021Z\000\000\000\000\000\000\000\000\000\000\025\206\0016#&\001\146\000\000\000\000\000\000\000\000\000\000\002\210\002*\001\022\001.\001Z\000\000\006~\000\000\000\000\000\000\0022\002\014\000\000\025\250\000\000\001\186\002:\000\000\000\000\000\000\001r\000\018\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\031\234\000\000\001\030\000\000\000\000\000\000\000\234\029\222\000\000\001\202\001\234\000\238\000\000\000\000\000\000\001\138\001\242\001\250\000\000\000\000\002\002\000\000\001\178 ^\000\000\000\250\000\000\000\000\000\000\026\n\0016\000\000\001\146\000\254\000\000\000\000\000\000\000\000\006\130\002*\001\002\000\000\001Z\007^\000\000\007f\007n\000\000\0022\002\014\007\142\000\000\000\000\001\186\002:\000\000\007\154\000\000\007\166\000\000\000\000\007\174\000\000\007\190\000\000\000\000\000\000\000\000\007\210\000\000\001\006\000\000\001\n\003\178\000\000\000\000\000\000\007\238\003\182\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\006M\b\130\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\006M\000\000\000\000\006M\006M\000\000\000\000\007^\000\000\007f\007n\b\150\b\162\b\170\007\142\000\000\000\000\000\000\000\000\000\000\007\154\b\206\007\166\b\226\t\002\007\174\000\000\007\190\t\022\t\"\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\006]\b\130\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\006]\000\000\000\000\006]\006]\000\000\000\000\007^\000\000\007f\007n\b\150\b\162\b\170\007\142\000\000\000\000\000\000\000\000\000\000\007\154\b\206\007\166\b\226\t\002\007\174\000\000\007\190\t\022\t\"\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\005q\b\130\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005q\000\000\000\000\005q\005q\000\000\000\000\007^\000\000\007f\007n\b\150\b\162\b\170\007\142\000\000\000\000\000\000\000\000\000\000\007\154\b\206\007\166\b\226\t\002\007\174\000\000\007\190\t\022\t\"\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\006y\b\130\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\006y\000\000\000\000\006y\006y\000\000\000\000\007^\000\000\007f\007n\b\150\b\162\b\170\007\142\000\000\000\000\000\000\000\000\000\000\007\154\b\206\007\166\b\226\t\002\007\174\000\000\007\190\t\022\t\"\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\006q\b\130\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\006q\000\000\000\000\006q\006q\000\000\000\000\007^\000\000\007f\007n\b\150\b\162\b\170\007\142\000\000\000\000\000\000\000\000\000\000\007\154\b\206\007\166\b\226\t\002\007\174\000\000\007\190\t\022\t\"\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\006=\b\130\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\006=\000\000\000\000\006=\006=\000\000\000\000\007^\000\000\007f\007n\b\150\b\162\b\170\007\142\000\000\000\000\000\000\000\000\000\000\007\154\b\206\007\166\b\226\t\002\007\174\000\000\007\190\t\022\t\"\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\0065\b\130\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0065\000\000\000\000\0065\0065\000\000\000\000\007^\000\000\007f\007n\b\150\b\162\b\170\007\142\000\000\000\000\000\000\000\000\000\000\007\154\b\206\007\166\b\226\t\002\007\174\000\000\007\190\t\022\t\"\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\0059\b\130\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0059\000\000\000\000\0059\0059\000\000\000\000\007^\000\000\007f\007n\b\150\b\162\b\170\007\142\000\000\000\000\000\000\000\000\000\000\007\154\b\206\007\166\b\226\t\002\007\174\000\000\007\190\t\022\t\"\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\005Q\b\130\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005Q\000\000\000\000\005Q\005Q\000\000\000\000\007^\000\000\007f\007n\b\150\b\162\b\170\007\142\000\000\000\000\000\000\000\000\000\000\007\154\b\206\007\166\b\226\t\002\007\174\000\000\007\190\t\022\t\"\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\0051\b\130\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0051\000\000\000\000\0051\0051\000\000\000\000\007^\000\000\007f\007n\b\150\b\162\b\170\007\142\000\000\000\000\000\000\000\000\000\000\007\154\b\206\007\166\b\226\t\002\007\174\000\000\007\190\t\022\t\"\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\006i\b\130\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\006i\000\000\000\000\006i\006i\000\000\000\000\007^\000\000\007f\007n\b\150\b\162\b\170\007\142\000\000\000\000\000\000\000\000\000\000\007\154\b\206\007\166\b\226\t\002\007\174\000\000\007\190\t\022\t\"\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\005I\b\130\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005I\000\000\000\000\005I\005I\000\000\000\000\007^\000\000\007f\007n\b\150\b\162\b\170\007\142\000\000\000\000\000\000\000\000\000\000\007\154\b\206\007\166\b\226\t\002\007\174\000\000\007\190\t\022\t\"\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\006I\b\130\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\006I\000\000\000\000\006I\006I\000\000\000\000\007^\000\000\007f\007n\b\150\b\162\b\170\007\142\000\000\000\000\000\000\000\000\000\000\007\154\b\206\007\166\b\226\t\002\007\174\000\000\007\190\t\022\t\"\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\006U\b\130\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\006U\000\000\000\000\006U\006U\000\000\000\000\007^\000\000\007f\007n\b\150\b\162\b\170\007\142\000\000\000\000\000\000\000\000\000\000\007\154\b\206\007\166\b\226\t\002\007\174\000\000\007\190\t\022\t\"\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\005\209\b\130\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005\209\000\000\000\000\005\209\005\209\000\000\000\000\007^\000\000\007f\007n\b\150\b\162\b\170\007\142\000\000\000\000\000\000\000\000\000\000\007\154\b\206\007\166\b\226\t\002\007\174\000\000\007\190\t\022\t\"\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\005A\b\130\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005A\000\000\000\000\005A\005A\000\000\000\000\007^\000\000\007f\007n\b\150\b\162\b\170\007\142\000\000\000\000\000\000\000\000\000\000\007\154\b\206\007\166\b\226\t\002\007\174\000\000\007\190\t\022\t\"\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\005a\b\130\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005a\000\000\000\000\005a\005a\000\000\000\000\007^\000\000\007f\007n\b\150\b\162\b\170\007\142\000\000\000\000\000\000\000\000\000\000\007\154\b\206\007\166\b\226\t\002\007\174\000\000\007\190\t\022\t\"\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\005Y\b\130\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005Y\000\000\000\000\005Y\005Y\000\000\000\000\007^\000\000\007f\007n\b\150\b\162\b\170\007\142\000\000\000\000\000\000\000\000\000\000\007\154\b\206\007\166\b\226\t\002\007\174\000\000\007\190\t\022\t\"\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\006E\b\130\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\006E\000\000\000\000\006E\006E\000\000\000\000\007^\000\000\007f\007n\b\150\b\162\b\170\007\142\000\000\000\000\000\000\000\000\000\000\007\154\b\206\007\166\b\226\t\002\007\174\000\000\007\190\t\022\t\"\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\005\129\b\130\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005\129\000\000\000\000\005\129\005\129\000\000\000\000\007^\000\000\007f\007n\b\150\b\162\b\170\007\142\000\000\000\000\000\000\000\000\000\000\007\154\b\206\007\166\b\226\t\002\007\174\000\000\007\190\t\022\t\"\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\005)\b\130\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005)\000\000\000\000\005)\005)\000\000\000\000\007^\000\000\007f\007n\b\150\b\162\b\170\007\142\000\000\000\000\000\000\000\000\000\000\007\154\b\206\007\166\b\226\t\002\007\174\000\000\007\190\t\022\t\"\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\005}\b\130\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005}\000\000\000\000\005}\005}\000\000\000\000\007^\000\000\007f\007n\b\150\b\162\b\170\007\142\000\000\000\000\000\000\000\000\000\000\007\154\b\206\007\166\b\226\t\002\007\174\000\000\007\190\t\022\t\"\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\006\029\b\130\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\006\029\000\000\000\000\006\029\006\029\000\000\000\000\007^\000\000\007f\007n\b\150\b\162\b\170\007\142\000\000\000\000\000\000\000\000\000\000\007\154\b\206\007\166\b\226\t\002\007\174\000\000\007\190\t\022\t\"\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\005y\b\130\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005y\000\000\000\000\005y\005y\000\000\000\000\007^\000\000\007f\007n\b\150\b\162\b\170\007\142\000\000\000\000\000\000\000\000\000\000\007\154\b\206\007\166\b\226\t\002\007\174\000\000\007\190\t\022\t\"\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\005u\b\130\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005u\000\000\000\000\005u\005u\000\000\000\000\007^\000\000\007f\007n\b\150\b\162\b\170\007\142\000\000\000\000\000\000\000\000\000\000\007\154\b\206\007\166\b\226\t\002\007\174\000\000\007\190\t\022\t\"\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\006\025\b\130\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\006\025\000\000\000\000\006\025\006\025\000\000\000\000\007^\000\000\007f\007n\b\150\b\162\b\170\007\142\000\000\000\000\000\000\000\000\000\000\007\154\b\206\007\166\b\226\t\002\007\174\000\000\007\190\t\022\t\"\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\005\137\b\130\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005\137\000\000\000\000\005\137\005\137\000\000\000\000\007^\000\000\007f\007n\b\150\b\162\b\170\007\142\000\000\000\000\000\000\000\000\000\000\007\154\b\206\007\166\b\226\t\002\007\174\000\000\007\190\t\022\t\"\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\005\133\b\130\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005\133\000\000\000\000\005\133\005\133\000\000\000\000\007^\000\000\007f\007n\b\150\b\162\b\170\007\142\000\000\000\000\000\000\000\000\000\000\007\154\b\206\007\166\b\226\t\002\007\174\000\000\007\190\t\022\t\"\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\006!\b\130\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\006!\000\000\000\000\006!\006!\000\000\000\000\007^\000\000\007f\007n\b\150\b\162\b\170\007\142\000\000\000\000\000\000\000\000\000\000\007\154\b\206\007\166\b\226\t\002\007\174\000\000\007\190\t\022\t\"\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\005U\b\130\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005U\000\000\000\000\005U\005U\000\000\000\000\007^\000\000\007f\007n\b\150\b\162\b\170\007\142\000\000\000\000\000\000\000\000\000\000\007\154\b\206\007\166\b\226\t\002\007\174\000\000\007\190\t\022\t\"\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\006\t\b\130\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\006\t\000\000\000\000\006\t\006\t\000\000\000\000\007^\000\000\007f\007n\b\150\b\162\b\170\007\142\000\000\000\000\000\000\000\000\000\000\007\154\b\206\007\166\b\226\t\002\007\174\000\000\007\190\t\022\t\"\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\005i\b\130\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005i\000\000\000\000\005i\005i\000\000\000\000\007^\000\000\007f\007n\b\150\b\162\b\170\007\142\000\000\000\000\000\000\000\000\000\000\007\154\b\206\007\166\b\226\t\002\007\174\000\000\007\190\t\022\t\"\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\005e\b\130\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005e\000\000\000\000\005e\005e\000\000\000\000\007^\000\000\007f\007n\b\150\b\162\b\170\007\142\000\000\000\000\000\000\000\000\000\000\007\154\b\206\007\166\b\226\t\002\007\174\000\000\007\190\t\022\t\"\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\006\017\b\130\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\006\017\000\000\000\000\006\017\006\017\000\000\000\000\007^\000\000\007f\007n\b\150\b\162\b\170\007\142\000\000\000\000\000\000\000\000\000\000\007\154\b\206\007\166\b\226\t\002\007\174\000\000\007\190\t\022\t\"\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\005]\b\130\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005]\000\000\000\000\005]\005]\000\000\000\000\007^\000\000\007f\007n\b\150\b\162\b\170\007\142\000\000\000\000\000\000\000\000\000\000\007\154\b\206\007\166\b\226\t\002\007\174\000\000\007\190\t\022\t\"\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\006\r\b\130\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\006\r\000\000\000\000\006\r\006\r\000\000\000\000\007^\000\000\007f\007n\b\150\b\162\b\170\007\142\000\000\000\000\000\000\000\000\000\000\007\154\b\206\007\166\b\226\t\002\007\174\000\000\007\190\t\022\t\"\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\005=\b\130\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005=\000\000\000\000\005=\005=\000\000\000\000\007^\000\000\007f\007n\b\150\b\162\b\170\007\142\000\000\000\000\000\000\000\000\000\000\007\154\b\206\007\166\b\226\t\002\007\174\000\000\007\190\t\022\t\"\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\005\253\b\130\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005\253\000\000\000\000\005\253\005\253\000\000\000\000\007^\000\000\007f\007n\b\150\b\162\b\170\007\142\000\000\000\000\000\000\000\000\000\000\007\154\b\206\007\166\b\226\t\002\007\174\000\000\007\190\t\022\t\"\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\005\205\b\130\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005\205\000\000\000\000\005\205\005\205\000\000\000\000\007^\000\000\007f\007n\b\150\b\162\b\170\007\142\000\000\000\000\000\000\000\000\000\000\007\154\b\206\007\166\b\226\t\002\007\174\000\000\007\190\t\022\t\"\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\005\153\b\130\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005\153\000\000\000\000\005\153\005\153\000\000\000\000\007^\000\000\007f\007n\b\150\b\162\b\170\007\142\000\000\000\000\000\000\000\000\000\000\007\154\b\206\007\166\b\226\t\002\007\174\000\000\007\190\t\022\t\"\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\005\149\b\130\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005\149\000\000\000\000\005\149\005\149\000\000\000\000\007^\000\000\007f\007n\b\150\b\162\b\170\007\142\000\000\000\000\000\000\000\000\000\000\007\154\b\206\007\166\b\226\t\002\007\174\000\000\007\190\t\022\t\"\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\005\177\b\130\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005\177\000\000\000\000\005\177\005\177\000\000\000\000\007^\000\000\007f\007n\b\150\b\162\b\170\007\142\000\000\000\000\000\000\000\000\000\000\007\154\b\206\007\166\b\226\t\002\007\174\000\000\007\190\t\022\t\"\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\005\173\b\130\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005\173\000\000\000\000\005\173\005\173\000\000\000\000\007^\000\000\007f\007n\b\150\b\162\b\170\007\142\000\000\000\000\000\000\000\000\000\000\007\154\b\206\007\166\b\226\t\002\007\174\000\000\007\190\t\022\t\"\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\005\241\b\130\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005\241\000\000\000\000\005\241\005\241\000\000\000\000\007^\000\000\007f\007n\b\150\b\162\b\170\007\142\000\000\000\000\000\000\000\000\000\000\007\154\b\206\007\166\b\226\t\002\007\174\000\000\007\190\t\022\t\"\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\005\145\b\130\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005\145\000\000\000\000\005\145\005\145\000\000\000\000\007^\000\000\007f\007n\b\150\b\162\b\170\007\142\000\000\000\000\000\000\000\000\000\000\007\154\b\206\007\166\b\226\t\002\007\174\000\000\007\190\t\022\t\"\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\005\141\b\130\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005\141\000\000\000\000\005\141\005\141\000\000\000\000\007^\000\000\007f\007n\b\150\b\162\b\170\007\142\000\000\000\000\000\000\000\000\000\000\007\154\b\206\007\166\b\226\t\002\007\174\000\000\007\190\t\022\t\"\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\005\169\b\130\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005\169\000\000\000\000\005\169\005\169\000\000\000\000\007^\000\000\007f\007n\b\150\b\162\b\170\007\142\000\000\000\000\000\000\000\000\000\000\007\154\b\206\007\166\b\226\t\002\007\174\000\000\007\190\t\022\t\"\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\005\165\b\130\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005\165\000\000\000\000\005\165\005\165\000\000\000\000\007^\000\000\007f\007n\b\150\b\162\b\170\007\142\000\000\000\000\000\000\000\000\000\000\007\154\b\206\007\166\b\226\t\002\007\174\000\000\007\190\t\022\t\"\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\005\237\b\130\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005\237\000\000\000\000\005\237\005\237\000\000\000\000\007^\000\000\007f\007n\b\150\b\162\b\170\007\142\000\000\000\000\000\000\000\000\000\000\007\154\b\206\007\166\b\226\t\002\007\174\000\000\007\190\t\022\t\"\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\005\161\b\130\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005\161\000\000\000\000\005\161\005\161\000\000\000\000\007^\000\000\007f\007n\b\150\b\162\b\170\007\142\000\000\000\000\000\000\000\000\000\000\007\154\b\206\007\166\b\226\t\002\007\174\000\000\007\190\t\022\t\"\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\005\157\b\130\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005\157\000\000\000\000\005\157\005\157\000\000\000\000\007^\000\000\007f\007n\b\150\b\162\b\170\007\142\000\000\000\000\000\000\000\000\000\000\007\154\b\206\007\166\b\226\t\002\007\174\000\000\007\190\t\022\t\"\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\005\193\b\130\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005\193\000\000\000\000\005\193\005\193\000\000\000\000\007^\000\000\007f\007n\b\150\b\162\b\170\007\142\000\000\000\000\000\000\000\000\000\000\007\154\b\206\007\166\b\226\t\002\007\174\000\000\007\190\t\022\t\"\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\005\201\b\130\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005\201\000\000\000\000\005\201\005\201\000\000\000\000\007^\000\000\007f\007n\b\150\b\162\b\170\007\142\000\000\000\000\000\000\000\000\000\000\007\154\b\206\007\166\b\226\t\002\007\174\000\000\007\190\t\022\t\"\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\005\197\b\130\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005\197\000\000\000\000\005\197\005\197\000\000\000\000\007^\000\000\007f\007n\b\150\b\162\b\170\007\142\000\000\000\000\000\000\000\000\000\000\007\154\b\206\007\166\b\226\t\002\007\174\000\000\007\190\t\022\t\"\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\005\189\b\130\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005\189\000\000\000\000\005\189\005\189\000\000\000\000\007^\000\000\007f\007n\b\150\b\162\b\170\007\142\000\000\000\000\000\000\000\000\000\000\007\154\b\206\007\166\b\226\t\002\007\174\000\000\007\190\t\022\t\"\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\005\185\b\130\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005\185\000\000\000\000\005\185\005\185\000\000\000\000\007^\000\000\007f\007n\b\150\b\162\b\170\007\142\000\000\000\000\000\000\000\000\000\000\007\154\b\206\007\166\b\226\t\002\007\174\000\000\007\190\t\022\t\"\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\005\181\b\130\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005\181\000\000\000\000\005\181\005\181\000\000\000\000\007^\000\000\007f\007n\b\150\b\162\b\170\007\142\000\000\000\000\000\000\000\000\000\000\007\154\b\206\007\166\b\226\t\002\007\174\000\000\007\190\t\022\t\"\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\005\225\b\130\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005\225\000\000\000\000\005\225\005\225\000\000\000\000\007^\000\000\007f\007n\b\150\b\162\b\170\007\142\000\000\000\000\000\000\000\000\000\000\007\154\b\206\007\166\b\226\t\002\007\174\000\000\007\190\t\022\t\"\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\005\221\b\130\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005\221\000\000\000\000\005\221\005\221\000\000\000\000\007^\000\000\007f\007n\b\150\b\162\b\170\007\142\000\000\000\000\000\000\000\000\000\000\007\154\b\206\007\166\b\226\t\002\007\174\000\000\007\190\t\022\t\"\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\005\217\b\130\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005\217\000\000\000\000\005\217\005\217\000\000\000\000\007^\000\000\007f\007n\b\150\b\162\b\170\007\142\000\000\000\000\000\000\000\000\000\000\007\154\b\206\007\166\b\226\t\002\007\174\000\000\007\190\t\022\t\"\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\005\213\b\130\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005\213\000\000\000\000\005\213\005\213\000\000\000\000\007^\000\000\007f\007n\b\150\b\162\b\170\007\142\000\000\000\000\000\000\000\000\000\000\007\154\b\206\007\166\b\226\t\002\007\174\000\000\007\190\t\022\t\"\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\005\233\b\130\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005\233\000\000\000\000\005\233\005\233\000\000\000\000\007^\000\000\007f\007n\b\150\b\162\b\170\007\142\000\000\000\000\000\000\000\000\000\000\007\154\b\206\007\166\b\226\t\002\007\174\000\000\007\190\t\022\t\"\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\005\229\b\130\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005\229\000\000\000\000\005\229\005\229\000\000\000\000\007^\000\000\007f\007n\b\150\b\162\b\170\007\142\000\000\000\000\000\000\000\000\000\000\007\154\b\206\007\166\b\226\t\002\007\174\000\000\007\190\t\022\t\"\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\006-\b\130\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\006-\000\000\000\000\006-\006-\000\000\000\000\007^\000\000\007f\007n\b\150\b\162\b\170\007\142\000\000\000\000\000\000\000\000\000\000\007\154\b\206\007\166\b\226\t\002\007\174\000\000\007\190\t\022\t\"\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\0061\b\130\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0061\000\000\000\000\0061\0061\000\000\000\000\007^\000\000\007f\007n\b\150\b\162\b\170\007\142\000\000\000\000\000\000\000\000\000\000\007\154\b\206\007\166\b\226\t\002\007\174\000\000\007\190\t\022\t\"\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\005E\b\130\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005E\000\000\000\000\005E\005E\000\000\000\000\007^\000\000\007f\007n\b\150\b\162\b\170\007\142\000\000\000\000\000\000\000\000\000\000\007\154\b\206\007\166\b\226\t\002\007\174\000\000\007\190\t\022\t\"\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\006\001\b\130\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\006\001\000\000\000\000\006\001\006\001\000\000\000\000\007^\000\000\007f\007n\b\150\b\162\b\170\007\142\000\000\000\000\000\000\000\000\000\000\007\154\b\206\007\166\b\226\t\002\007\174\000\000\007\190\t\022\t\"\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\006e\b\130\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\006e\000\000\000\000\006e\006e\000\000\000\000\007^\000\000\007f\007n\b\150\b\162\b\170\007\142\000\000\000\000\000\000\000\000\000\000\007\154\b\206\007\166\b\226\t\002\007\174\000\000\007\190\t\022\t\"\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\006Y\b\130\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\006Y\000\000\000\000\006Y\006Y\000\000\000\000\007^\000\000\007f\007n\b\150\b\162\b\170\007\142\000\000\000\000\000\000\000\000\000\000\007\154\b\206\007\166\b\226\t\002\007\174\000\000\007\190\t\022\t\"\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\005-\b\130\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005-\000\000\000\000\005-\005-\000\000\000\000\007^\000\000\007f\007n\b\150\b\162\b\170\007\142\000\000\000\000\000\000\000\000\000\000\007\154\b\206\007\166\b\226\t\002\007\174\000\000\007\190\t\022\t\"\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\005\245\b\130\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005\245\000\000\000\000\005\245\005\245\000\000\000\000\007^\000\000\007f\007n\b\150\b\162\b\170\007\142\000\000\000\000\000\000\000\000\000\000\007\154\b\206\007\166\b\226\t\002\007\174\000\000\007\190\t\022\t\"\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\006%\b\130\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\006%\000\000\000\000\006%\006%\000\000\000\000\007^\000\000\007f\007n\b\150\b\162\b\170\007\142\000\000\000\000\000\000\000\000\000\000\007\154\b\206\007\166\b\226\t\002\007\174\000\000\007\190\t\022\t\"\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\006)\b\130\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\006)\000\000\000\000\006)\006)\000\000\000\000\007^\000\000\007f\007n\b\150\b\162\b\170\007\142\000\000\000\000\000\000\000\000\000\000\007\154\b\206\007\166\b\226\t\002\007\174\000\000\007\190\t\022\t\"\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\005M\b\130\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005M\000\000\000\000\005M\005M\000\000\000\000\007^\000\000\007f\007n\b\150\b\162\b\170\007\142\000\000\000\000\000\000\000\000\000\000\007\154\b\206\007\166\b\226\t\002\007\174\000\000\007\190\t\022\t\"\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\006\005\b\130\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\006\005\000\000\000\000\006\005\006\005\000\000\000\000\007^\000\000\007f\007n\b\150\b\162\b\170\007\142\000\000\000\000\000\000\000\000\000\000\007\154\b\206\007\166\b\226\t\002\007\174\000\000\007\190\t\022\t\"\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\0055\b\130\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0055\000\000\000\000\0055\0055\000\000\000\000\007^\000\000\007f\007n\b\150\b\162\b\170\007\142\000\000\000\000\000\000\000\000\000\000\007\154\b\206\007\166\b\226\t\002\007\174\000\000\007\190\t\022\t\"\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\005\249\b\130\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005\249\000\000\000\000\005\249\005\249\000\000\000\000\007^\000\000\007f\007n\b\150\b\162\b\170\007\142\000\000\000\000\000\000\000\000\000\000\007\154\b\206\007\166\b\226\t\002\007\174\000\000\007\190\t\022\t\"\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\0069\b\130\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0069\000\000\000\000\0069\0069\000\000\000\000\007^\000\000\007f\007n\b\150\b\162\b\170\007\142\000\000\000\000\000\000\000\000\000\000\007\154\b\206\007\166\b\226\t\002\007\174\000\000\007\190\t\022\t\"\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\006A\b\130\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\006A\000\000\000\000\006A\006A\000\000\000\000\007^\000\000\007f\007n\b\150\b\162\b\170\007\142\000\000\000\000\000\000\000\000\000\000\007\154\b\206\007\166\b\226\t\002\007\174\000\000\007\190\t\022\t\"\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\006m\b\130\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\006m\000\000\000\000\006m\006m\000\000\000\000\007^\000\000\007f\007n\b\150\b\162\b\170\007\142\000\000\000\000\000\000\000\000\000\000\007\154\b\206\007\166\b\226\t\002\007\174\000\000\007\190\t\022\t\"\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\006u\b\130\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\006u\000\000\000\000\006u\006u\000\000\000\000\007^\000\000\007f\007n\b\150\b\162\b\170\007\142\000\000\000\000\000\000\000\000\000\000\007\154\b\206\007\166\b\226\t\002\007\174\000\000\007\190\t\022\t\"\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\005m\b\130\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005m\000\000\000\000\005m\005m\000\000\000\000\007^\000\000\007f\007n\b\150\b\162\b\170\007\142\000\000\000\000\000\000\000\000\000\000\007\154\b\206\007\166\b\226\t\002\007\174\000\000\007\190\t\022\t\"\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\006\021\b\130\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\006\021\000\000\000\000\006\021\006\021\000\000\000\000\007^\000\000\007f\007n\b\150\b\162\b\170\007\142\000\000\000\000\000\000\000\000\000\000\007\154\b\206\007\166\b\226\t\002\007\174\000\000\007\190\t\022\t\"\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\006a\b\130\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\006a\000\000\000\000\006a\006a\000\000\000\000\007^\000\000\007f\007n\b\150\b\162\b\170\007\142\000\000\000\000\000\000\000\000\000\000\007\154\b\206\007\166\b\226\t\002\007\174\000\000\007\190\t\022\t\"\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\006Q\b\130\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\006Q\000\000\000\000\006Q\006Q\000\000\000\000\007^\000\000\007f\007n\b\150\b\162\b\170\007\142\000\000\000\000\000\000\000\000\000\000\007\154\b\206\007\166\b\226\t\002\007\174\000\000\007\190\t\022\t\"\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\016\018\b\130\000\000\000\000\000\000\000\000\016\222\000\000\000\000\000\000\017^\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\150\b\162\b\170\001\022\001.\031\170\000\000\006*\000\000\000\000\b\206\000\000\b\226\t\002\026.\000\000\000\000\t\022\t\"\017v\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\"\182\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\001\234\000\000\000\000\000\000\000\000\001\138\001\242\001\250\000\000\000\000\002\002\000\000\001\178\031\242\000\000\000\000\000\000\000\000\000\000\026>\0016\000\000\001\146\000\000\000\000\006^\000\000\001\022\001.\002*\000\000\006\166\001Z\000\000\000\000\000\000\000\000\000\000\0022\002\014\000\000\000\000\000\000\001\186\002:\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000 z\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\001\234\000\000\000\000\000\000\000\000\001\138\001\242\001\250\000\000\000\000\002\002\000\000\001\178 \150\000\000\000\000\000\000\000\000\000\000\t\210\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\015.\002*\001\022\001.\001Z\000\000\006\186\000\000\000\000\000\000\0022\002\014\000\000\004\002\000\000\001\186\002:\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\001\234\000\000\000\000\000\000\000\000\001\138\001\242\001\250\000\000\000\000\002\002\000\000\001\178 \130\000\000\000\000\000\000\000\000\000\000\rB\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\016\026\002*\001\022\001.\001Z\000\000\007z\000\000\000\000\000\000\0022\002\014\000\000\004F\000\000\001\186\002:\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\001\234\000\000\000\000\000\000\000\000\001\138\001\242\001\250\000\000\000\000\002\002\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\002*\004n\004\150\001Z\000\000\000\000\000\000\000\000\000\000\0022\002\014\000\000\n9\000\000\001\186\002:\000\000\000\000\000\000\004\166\000\000\004\206\000\000\000\000\004\174\004\214\000\000\004\182\004\222\000\000\000\000\000\000\000\000\004b\000\000\000\000\000\000\000\000\000\000\000\000\004\246\005\006\000\000\000\000\000\000\n9\004\190\005\014\n9\000\000\000\000\005\022\000\000\004\230\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004v\000\000\004\198\000\000\000\000\000\000\000\000\000\000\005.\004n\004\150\000\000\004\142\000\000\000\000\000\000\000\000\000\000\0056\005\"\n5\000\000\000\000\004\238\005>\000\000\000\000\004\166\000\000\004\206\000\000\000\000\004\174\004\214\000\000\004\182\004\222\000\000\000\000\000\000\000\000\004b\000\000\000\000\000\000\000\000\000\000\000\000\004\246\005\006\000\000\000\000\000\000\n5\004\190\005\014\n5\000\000\000\000\005\022\000\000\004\230\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004v\000\000\004\198\000\000\000\000\000\000\000\000\016*\005V\001\022\001.\007\206\004\142\b\186\000\000\000\000\000\000\000\000\0056\005\"\006\n\000\000\000\000\004\238\005>\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\001\234\000\000\000\000\000\000\000\000\001\138\001\242\001\250\000\000\000\000\002\002\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\002*\000\000\016b\001Z\001\022\001.\007\234\000\000\b\238\0022\002\014\000\000\000\000\000\000\001\186\002:\000\000\000\000\000\000\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\001\234\000\000\000\000\000\000\000\000\001\138\001\242\001\250\000\000\000\000\002\002\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\002*\000\000\016\158\001Z\001\022\001.\br\000\000\0122\0022\002\014\000\000\000\000\000\000\001\186\002:\000\000\000\000\000\000\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\001\234\000\000\000\000\000\000\000\000\001\138\001\242\001\250\000\000\000\000\002\002\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\002*\000\000\016\234\001Z\001\022\001.\b\146\000\000\014\166\0022\002\014\000\000\000\000\000\000\001\186\002:\000\000\000\000\000\000\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\001\234\000\000\000\000\000\000\000\000\001\138\001\242\001\250\000\000\000\000\002\002\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\002*\000\000\0172\001Z\001\022\001.\b\158\000\000\000\000\0022\002\014\000\000\000\000\000\000\001\186\002:\000\000\000\000\000\000\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\001\234\000\000\000\000\000\000\000\000\001\138\001\242\001\250\000\000\000\000\002\002\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\002*\000\000\017\138\001Z\001\022\001.\b\202\000\000\000\000\0022\002\014\000\000\000\000\000\000\001\186\002:\000\000\000\000\000\000\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\001\234\000\000\000\000\000\000\000\000\001\138\001\242\001\250\000\000\000\000\002\002\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\002*\000\000\017\210\001Z\001\022\001.\b\222\000\000\000\000\0022\002\014\000\000\000\000\000\000\001\186\002:\000\000\000\000\000\000\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\001\234\000\000\000\000\000\000\000\000\001\138\001\242\001\250\000\000\000\000\002\002\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\002*\000\000\018\n\001Z\001\022\001.\b\254\000\000\000\000\0022\002\014\000\000\000\000\000\000\001\186\002:\000\000\000\000\000\000\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\001\234\000\000\000\000\000\000\000\000\001\138\001\242\001\250\000\000\000\000\002\002\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\002*\000\000\018\170\001Z\001\022\001.\t\018\000\000\000\000\0022\002\014\000\000\000\000\000\000\001\186\002:\000\000\000\000\000\000\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\001\234\000\000\000\000\000\000\000\000\001\138\001\242\001\250\000\000\000\000\002\002\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\002*\000\000\018\210\001Z\001\022\001.\t\030\000\000\000\000\0022\002\014\000\000\000\000\000\000\001\186\002:\000\000\000\000\000\000\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\001\234\000\000\000\000\000\000\000\000\001\138\001\242\001\250\000\000\000\000\002\002\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\002*\000\000\019*\001Z\001\022\001.\tN\000\000\000\000\0022\002\014\000\000\000\000\000\000\001\186\002:\000\000\000\000\000\000\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\001\234\000\000\000\000\000\000\000\000\001\138\001\242\001\250\000\000\000\000\002\002\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\002*\000\000\019\134\001Z\001\022\001.\tb\000\000\000\000\0022\002\014\000\000\000\000\000\000\001\186\002:\000\000\000\000\000\000\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\001\234\000\000\000\000\000\000\000\000\001\138\001\242\001\250\000\000\000\000\002\002\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\002*\000\000\019\194\001Z\001\022\001.\tv\000\000\000\000\0022\002\014\000\000\000\000\000\000\001\186\002:\000\000\000\000\000\000\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\001\234\000\000\000\000\000\000\000\000\001\138\001\242\001\250\000\000\000\000\002\002\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\002*\000\000\019\254\001Z\001\022\001.\t\166\000\000\000\000\0022\002\014\000\000\000\000\000\000\001\186\002:\000\000\000\000\000\000\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\001\234\000\000\000\000\000\000\000\000\001\138\001\242\001\250\000\000\000\000\002\002\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\002*\000\000\020f\001Z\001\022\001.\t\186\000\000\000\000\0022\002\014\000\000\000\000\000\000\001\186\002:\000\000\000\000\000\000\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\001\234\000\000\000\000\000\000\000\000\001\138\001\242\001\250\000\000\000\000\002\002\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\020\198\002*\001\022\001.\001Z\000\000\000\000\000\000\000\000\000\000\0022\002\014\000\000\t\218\000\000\001\186\002:\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\001\234\000\000\000\000\000\000\000\000\001\138\001\242\001\250\000\000\000\000\002\002\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\002*\000\000\021\166\001Z\001\022\001.\t\242\000\000\000\000\0022\002\014\000\000\000\000\000\000\001\186\002:\000\000\000\000\000\000\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\001\234\000\000\000\000\000\000\000\000\001\138\001\242\001\250\000\000\000\000\002\002\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\002*\000\000\031\186\001Z\001\022\001.\n\006\000\000\000\000\0022\002\014\000\000\000\000\000\000\001\186\002:\000\000\000\000\000\000\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\001\234\000\000\000\000\000\000\000\000\001\138\001\242\001\250\000\000\000\000\002\002\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\002*\000\000 *\001Z\001\022\001.\n.\000\000\000\000\0022\002\014\000\000\000\000\000\000\001\186\002:\000\000\000\000\000\000\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\001\234\000\000\000\000\000\000\000\000\001\138\001\242\001\250\000\000\000\000\002\002\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\002*\000\000 \210\001Z\001\022\001.\n^\000\000\000\000\0022\002\014\000\000\000\000\000\000\001\186\002:\000\000\000\000\000\000\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\001\234\000\000\000\000\000\000\000\000\001\138\001\242\001\250\000\000\000\000\002\002\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\002*\000\000!.\001Z\001\022\001.\nr\000\000\000\000\0022\002\014\000\000\000\000\000\000\001\186\002:\000\000\000\000\000\000\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\001\234\000\000\000\000\000\000\000\000\001\138\001\242\001\250\000\000\000\000\002\002\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\002*\000\000!j\001Z\001\022\001.\n\146\000\000\000\000\0022\002\014\000\000\000\000\000\000\001\186\002:\000\000\000\000\000\000\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\001\234\000\000\000\000\000\000\000\000\001\138\001\242\001\250\000\000\000\000\002\002\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\002*\000\000!\166\001Z\001\022\001.\n\182\000\000\000\000\0022\002\014\000\000\000\000\000\000\001\186\002:\000\000\000\000\000\000\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\001\234\000\000\000\000\000\000\000\000\001\138\001\242\001\250\000\000\000\000\002\002\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\002*\000\000\"\014\001Z\001\022\001.\n\218\000\000\000\000\0022\002\014\000\000\000\000\000\000\001\186\002:\000\000\000\000\000\000\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\001\234\000\000\000\000\000\000\000\000\001\138\001\242\001\250\000\000\000\000\002\002\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\002*\000\000\"n\001Z\001\022\001.\n\242\000\000\000\000\0022\002\014\000\000\000\000\000\000\001\186\002:\000\000\000\000\000\000\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\001\234\000\000\000\000\000\000\000\000\001\138\001\242\001\250\000\000\000\000\002\002\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\002*\000\000\"\226\001Z\001\022\001.\011\006\000\000\000\000\0022\002\014\000\000\000\000\000\000\001\186\002:\000\000\000\000\000\000\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\001\234\000\000\000\000\000\000\000\000\001\138\001\242\001\250\000\000\000\000\002\002\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\002*\000\000\000\000\001Z\001\022\001.\011&\000\000\000\000\0022\002\014\000\000\000\000\000\000\001\186\002:\000\000\000\000\000\000\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\001\234\000\000\000\000\000\000\000\000\001\138\001\242\001\250\000\000\000\000\002\002\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\002*\000\000\000\000\001Z\001\022\001.\011:\000\000\000\000\0022\002\014\000\000\000\000\000\000\001\186\002:\000\000\000\000\000\000\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\001\234\000\000\000\000\000\000\000\000\001\138\001\242\001\250\000\000\000\000\002\002\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\002*\000\000\000\000\001Z\001\022\001.\011\138\000\000\000\000\0022\002\014\000\000\000\000\000\000\001\186\002:\000\000\000\000\000\000\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\001\234\000\000\000\000\000\000\000\000\001\138\001\242\001\250\000\000\000\000\002\002\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\002*\000\000\000\000\001Z\001\022\001.\011\162\000\000\000\000\0022\002\014\000\000\000\000\000\000\001\186\002:\000\000\000\000\000\000\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\001\234\000\000\000\000\000\000\000\000\001\138\001\242\001\250\000\000\000\000\002\002\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\002*\000\000\000\000\001Z\001\022\001.\011\182\000\000\000\000\0022\002\014\000\000\000\000\000\000\001\186\002:\000\000\000\000\000\000\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\001\234\000\000\000\000\000\000\000\000\001\138\001\242\001\250\000\000\000\000\002\002\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\002*\000\000\000\000\001Z\001\022\001.\011\206\000\000\000\000\0022\002\014\000\000\000\000\000\000\001\186\002:\000\000\000\000\000\000\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\001\234\000\000\000\000\000\000\000\000\001\138\001\242\001\250\000\000\000\000\002\002\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\002*\000\000\000\000\001Z\001\022\001.\011\226\000\000\000\000\0022\002\014\000\000\000\000\000\000\001\186\002:\000\000\000\000\000\000\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\001\234\000\000\000\000\000\000\000\000\001\138\001\242\001\250\000\000\000\000\002\002\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\002*\000\000\000\000\001Z\001\022\001.\011\242\000\000\000\000\0022\002\014\000\000\000\000\000\000\001\186\002:\000\000\000\000\000\000\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\001\234\000\000\000\000\000\000\000\000\001\138\001\242\001\250\000\000\000\000\002\002\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\002*\000\000\000\000\001Z\001\022\001.\012\n\000\000\000\000\0022\002\014\000\000\000\000\000\000\001\186\002:\000\000\000\000\000\000\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\001\234\000\000\000\000\000\000\000\000\001\138\001\242\001\250\000\000\000\000\002\002\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\002*\000\000\000\000\001Z\001\022\001.\012\030\000\000\000\000\0022\002\014\000\000\000\000\000\000\001\186\002:\000\000\000\000\000\000\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\001\234\000\000\000\000\000\000\000\000\001\138\001\242\001\250\000\000\000\000\002\002\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\002*\000\000\000\000\001Z\001\022\001.\012B\000\000\000\000\0022\002\014\000\000\000\000\000\000\001\186\002:\000\000\000\000\000\000\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\001\234\000\000\000\000\000\000\000\000\001\138\001\242\001\250\000\000\000\000\002\002\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\002*\000\000\000\000\001Z\001\022\001.\012b\000\000\000\000\0022\002\014\000\000\000\000\000\000\001\186\002:\000\000\000\000\000\000\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\001\234\000\000\000\000\000\000\000\000\001\138\001\242\001\250\000\000\000\000\002\002\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\002*\000\000\000\000\001Z\001\022\001.\012v\000\000\000\000\0022\002\014\000\000\000\000\000\000\001\186\002:\000\000\000\000\000\000\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\001\234\000\000\000\000\000\000\000\000\001\138\001\242\001\250\000\000\000\000\002\002\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\002*\000\000\000\000\001Z\001\022\001.\012\138\000\000\000\000\0022\002\014\000\000\000\000\000\000\001\186\002:\000\000\000\000\000\000\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\001\234\000\000\000\000\000\000\000\000\001\138\001\242\001\250\000\000\000\000\002\002\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\002*\000\000\000\000\001Z\001\022\001.\012\162\000\000\000\000\0022\002\014\000\000\000\000\000\000\001\186\002:\000\000\000\000\000\000\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\001\234\000\000\000\000\000\000\000\000\001\138\001\242\001\250\000\000\000\000\002\002\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\002*\000\000\000\000\001Z\001\022\001.\012\182\000\000\000\000\0022\002\014\000\000\000\000\000\000\001\186\002:\000\000\000\000\000\000\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\001\234\000\000\000\000\000\000\000\000\001\138\001\242\001\250\000\000\000\000\002\002\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\002*\000\000\000\000\001Z\001\022\001.\012\234\000\000\000\000\0022\002\014\000\000\000\000\000\000\001\186\002:\000\000\000\000\000\000\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\001\234\000\000\000\000\000\000\000\000\001\138\001\242\001\250\000\000\000\000\002\002\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\002*\000\000\000\000\001Z\001\022\001.\012\254\000\000\000\000\0022\002\014\000\000\000\000\000\000\001\186\002:\000\000\000\000\000\000\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\001\234\000\000\000\000\000\000\000\000\001\138\001\242\001\250\000\000\000\000\002\002\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\002*\000\000\000\000\001Z\001\022\001.\r\"\000\000\000\000\0022\002\014\000\000\000\000\000\000\001\186\002:\000\000\000\000\000\000\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\001\234\000\000\000\000\000\000\000\000\001\138\001\242\001\250\000\000\000\000\002\002\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\002*\000\000\000\000\001Z\001\022\001.\r6\000\000\000\000\0022\002\014\000\000\000\000\000\000\001\186\002:\000\000\000\000\000\000\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\001\234\000\000\000\000\000\000\000\000\001\138\001\242\001\250\000\000\000\000\002\002\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\002*\001\022\001.\001Z\000\000\000\000\000\000\000\000\000\000\0022\002\014\000\000\rJ\000\000\001\186\002:\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\001\234\000\000\000\000\000\000\000\000\001\138\001\242\001\250\000\000\000\000\002\002\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\002*\000\000\000\000\001Z\001\022\001.\rb\000\000\000\000\0022\002\014\000\000\000\000\000\000\001\186\002:\000\000\000\000\000\000\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\001\234\000\000\000\000\000\000\000\000\001\138\001\242\001\250\000\000\000\000\002\002\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\002*\000\000\000\000\001Z\001\022\001.\rv\000\000\000\000\0022\002\014\000\000\000\000\000\000\001\186\002:\000\000\000\000\000\000\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\001\234\000\000\000\000\000\000\000\000\001\138\001\242\001\250\000\000\000\000\002\002\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\002*\000\000\000\000\001Z\001\022\001.\r\182\000\000\000\000\0022\002\014\000\000\000\000\000\000\001\186\002:\000\000\000\000\000\000\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\001\234\000\000\000\000\000\000\000\000\001\138\001\242\001\250\000\000\000\000\002\002\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\002*\000\000\000\000\001Z\001\022\001.\r\250\000\000\000\000\0022\002\014\000\000\000\000\000\000\001\186\002:\000\000\000\000\000\000\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\001\234\000\000\000\000\000\000\000\000\001\138\001\242\001\250\000\000\000\000\002\002\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\002*\000\000\000\000\001Z\001\022\001.\014>\000\000\000\000\0022\002\014\000\000\000\000\000\000\001\186\002:\000\000\000\000\000\000\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\001\234\000\000\000\000\000\000\000\000\001\138\001\242\001\250\000\000\000\000\002\002\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\002*\000\000\000\000\001Z\001\022\001.\014b\000\000\000\000\0022\002\014\000\000\000\000\000\000\001\186\002:\000\000\000\000\000\000\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\001\234\000\000\000\000\000\000\000\000\001\138\001\242\001\250\000\000\000\000\002\002\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\002*\000\000\000\000\001Z\001\022\001.\014\146\000\000\000\000\0022\002\014\000\000\000\000\000\000\001\186\002:\000\000\000\000\000\000\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\001\234\000\000\000\000\000\000\000\000\001\138\001\242\001\250\000\000\000\000\002\002\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\002*\000\000\000\000\001Z\001\022\001.\014\210\000\000\000\000\0022\002\014\000\000\000\000\000\000\001\186\002:\000\000\000\000\000\000\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\001\234\000\000\000\000\000\000\000\000\001\138\001\242\001\250\000\000\000\000\002\002\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\002*\000\000\000\000\001Z\001\022\001.\021.\000\000\000\000\0022\002\014\000\000\000\000\000\000\001\186\002:\000\000\000\000\000\000\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\001\234\000\000\000\000\000\000\000\000\001\138\001\242\001\250\000\000\000\000\002\002\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\002*\000\000\000\000\001Z\001\022\001.\022j\000\000\000\000\0022\002\014\000\000\000\000\000\000\001\186\002:\000\000\000\000\000\000\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\001\234\000\000\000\000\000\000\000\000\001\138\001\242\001\250\000\000\000\000\002\002\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\002*\000\000\000\000\001Z\001\022\001.\022\134\000\000\000\000\0022\002\014\000\000\000\000\000\000\001\186\002:\000\000\000\000\000\000\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\001\234\000\000\000\000\000\000\000\000\001\138\001\242\001\250\000\000\000\000\002\002\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\002*\000\000\000\000\001Z\001\022\001.\023\138\000\000\000\000\0022\002\014\000\000\000\000\000\000\001\186\002:\000\000\000\000\000\000\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\001\234\000\000\000\000\000\000\000\000\001\138\001\242\001\250\000\000\000\000\002\002\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\002*\000\000\000\000\001Z\001\022\001.\024\146\000\000\000\000\0022\002\014\000\000\000\000\000\000\001\186\002:\000\000\000\000\000\000\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\001\234\000\000\000\000\000\000\000\000\001\138\001\242\001\250\000\000\000\000\002\002\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\002*\000\000\000\000\001Z\001\022\001.\025\146\000\000\000\000\0022\002\014\000\000\000\000\000\000\001\186\002:\000\000\000\000\000\000\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\001\234\000\000\000\000\000\000\000\000\001\138\001\242\001\250\000\000\000\000\002\002\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\002*\001\022\001.\001Z\000\000\000\000\000\000\000\000\000\000\0022\002\014\000\000\025\214\000\000\001\186\002:\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\001\234\000\000\000\000\000\000\000\000\001\138\001\242\001\250\000\000\000\000\002\002\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\002*\001\022\001.\001Z\000\000\000\000\000\000\000\000\000\000\0022\002\014\000\000\026\018\000\000\001\186\002:\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\001\234\000\000\000\000\000\000\000\000\001\138\001\242\001\250\000\000\000\000\002\002\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\002*\001\022\001.\001Z\000\000\000\000\000\000\000\000\000\000\0022\002\014\000\000\026F\000\000\001\186\002:\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\001\234\000\000\000\000\000\000\000\000\001\138\001\242\001\250\000\000\000\000\002\002\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\002*\000\000\000\000\001Z\001\022\001.\026n\000\000\000\000\0022\002\014\000\000\000\000\000\000\001\186\002:\000\000\000\000\000\000\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\001\234\000\000\000\000\000\000\000\000\001\138\001\242\001\250\000\000\000\000\002\002\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\002*\000\000\000\000\001Z\001\022\001.\026\134\000\000\000\000\0022\002\014\000\000\000\000\000\000\001\186\002:\000\000\000\000\000\000\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\001\234\000\000\000\000\000\000\000\000\001\138\001\242\001\250\000\000\000\000\002\002\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\002*\000\000\000\000\001Z\001\022\001.\026\170\000\000\000\000\0022\002\014\000\000\000\000\000\000\001\186\002:\000\000\000\000\000\000\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\001\234\000\000\000\000\000\000\000\000\001\138\001\242\001\250\000\000\000\000\002\002\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\002*\000\000\000\000\001Z\001\022\001.\026\194\000\000\000\000\0022\002\014\000\000\000\000\000\000\001\186\002:\000\000\000\000\000\000\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\001\234\000\000\000\000\000\000\000\000\001\138\001\242\001\250\000\000\000\000\002\002\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\002*\000\000\000\000\001Z\001\022\001.\"\190\000\000\000\000\0022\002\014\000\000\000\000\000\000\001\186\002:\000\000\000\000\000\000\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\001\234\000\000\000\000\000\000\000\000\001\138\001\242\001\250\000\000\000\000\002\002\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\002*\004n\004\150\001Z\000\000\000\000\000\000\000\000\000\000\0022\002\014\000\000\n\189\000\000\001\186\002:\000\000\000\000\n\189\004\166\000\000\004\206\000\000\000\000\004\174\004\214\000\000\004\182\000\000\000\000\000\000\000\000\000\000\004b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\n\189\000\000\000\000\000\000\n\189\004\190\000\000\n\189\000\000\000\000\n\189\000\000\004\230\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004v\000\000\004\198\000\000\000\000\000\000\000\000\000\000\n\189\n\189\004n\004\150\004\142\000\000\000\000\000\000\000\000\000\000\n\189\n\189\000\000\n\181\000\000\004\238\n\189\000\000\000\000\n\181\004\166\000\000\004\206\000\000\000\000\004\174\004\214\000\000\004\182\000\000\000\000\000\000\000\000\000\000\004b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\n\181\000\000\000\000\000\000\n\181\004\190\007^\n\181\007f\007n\n\181\000\000\004\230\007\142\000\000\000\000\000\000\000\000\000\000\007\154\004v\007\166\004\198\000\000\007\174\000\000\007\190\000\000\n\181\n\181\000\000\007\210\004\142\000\000\000\000\000\000\000\000\000\000\n\181\n\181\007\238\000\000\000\000\004\238\n\181\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\016\226\b\130\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\017\014\000\000\007^\000\000\007f\007n\000\000\000\000\000\000\007\142\000\000\b\150\b\162\b\170\000\000\007\154\000\000\007\166\000\000\000\000\007\174\b\206\007\190\b\226\t\002\000\000\000\000\007\210\t\022\t\"\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\017\130\b\130\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\017\174\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\026\b\150\b\162\b\170\000\000\000\000\000\"\000\000\000\000\007\170\000\000\b\206\000\000\b\226\t\002\000&\0002\0006\t\022\t\"\t\137\000\000\000F\000\000\000\000\000\000\000\000\000\000\000\000\000^\000\000\000b\002\006\000\000\000\000\000\000\000f\000\000\000\000\000j\000\000\000\000\000\000\000r\000v\000\000\000\000\000\000\000\000\000\000\000\134\000\138\000\000\000\000\000\000\000\000\000\000\000\026\000\000\000\000\000\000\000\000\000\000\000\"\000\000\000\000\000\000\000\000\000.\000\000\000\000\000\000\000&\0002\0006\001\214\000\000\000\000\000\000\000F\000\154\000\158\000\174\000\178\000\186\000\000\000^\000\202\000b\000\206\000\000\000\000\000\000\000f\000\000\000\000\000j\000\000\000\000\000\000\000r\000v\000\000\000\000\000\000\000\000\000\000\000\134\000\138\000\000\000\000\000\000\000\000\000\000\000\026\000\000\000\000\000\000\000\000\000\000\000\"\000\000\000\000\000\000\000\000\000Z\000\000\000\000\000\000\000&\0002\0006\000n\000\000\000\000\000\000\000F\000\154\000\158\000\174\000\178\000\186\000\000\000^\000\202\000b\000\206\000\000\000\000\000\000\000f\000\000\000\000\000j\000\000\000\000\000\000\000r\000v\000\000\000\000\000\000\000\000\000\000\000\134\000\138\000\000\000\000\000\000\000\000\000\000\000\026\000\000\000\000\000\000\000\000\000\000\000\"\000\000\000\000\000\000\000\000\000\150\000\000\000\000\000\000\000&\0002\0006\002\226\000\000\000\000\000\000\000F\000\154\000\158\000\174\000\178\000\186\000\000\000^\000\202\000b\000\206\000\000\000\000\000\000\000f\000\000\000\000\000j\000\000\000\000\000\000\000r\000v\000\000\000\000\000\000\000\000\000\000\000\134\000\138\000\000\000\000\000\000\000\000\000\000\001\"\000\000\000\000\000\000\000\000\000\000\002Z\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002^\002~\002\130\002\146\000\000\005\t\000\000\002\150\000\154\000\158\000\174\000\178\000\186\000\000\002\190\000\202\002\194\000\206\000\000\000\000\000\000\002\198\000\000\000\000\002\222\000\000\000\000\000\000\002\238\002\242\000\000\000\000\000\000\000\000\000\000\003\002\0032\000\000\000\000\b\030\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\026\003R\003V\003f\003j\003\130\000\"\000\000\003\146\000\000\003\150\000\000\000\000\000\000\000\000\000&\0002\0006\000\000\000\000\000\000\000\000\000F\000\000\000\000\000\000\000\000\000\000\000\000\000^\000\000\001\210\001\218\000\000\000\000\000\000\000f\000\000\000\000\000j\000\000\000\000\000\000\000r\000v\000\000\000\000\000\000\000\000\000\000\000\134\000\138\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\026\000\154\000\158\000\174\000\178\000\186\000\"\000\000\000\202\000\000\000\206\002f\000\000\000\000\000\000\000&\0002\0006\000\000\000\000\000\000\000\000\000F\000\000\000\000\000\000\000\000\000\000\000\000\000^\000\000\000b\002\018\000\000\000\000\000\000\000f\000\000\000\000\000j\000\000\000\000\000\000\000r\000v\000\000\000\000\000\000\000\000\000\000\000\134\000\138\000\000\000\000\000\000\000\000\000\000\000\026\000\000\000\000\000\000\000\000\000\000\000\"\000\000\000\000\000\000\000\000\002\170\000\000\000\000\000\000\000&\0002\0006\000\000\000\000\000\000\000\000\000F\000\154\000\158\000\174\000\178\000\186\000\000\000^\000\202\000b\000\206\000\000\000\000\000\000\000f\000\000\000\000\000j\000\000\000\000\000\000\000r\000v\000\000\000\000\000\000\000\000\000\000\000\134\000\138\000\000\000\000\000\000\000\000\000\000\000\026\000\000\000\000\000\000\000\000\000\000\000\"\000\000\000\000\000\000\000\000\003>\000\000\000\000\000\000\000&\0002\0006\000\000\000\000\000\000\000\000\000F\000\154\000\158\000\174\000\178\000\186\000\000\000^\000\202\000b\000\206\000\000\000\000\000\000\000f\000\000\000\000\000j\000\000\000\000\000\000\000r\000v\000\000\000\000\000\000\000\000\000\000\000\134\000\138\000\000\000\000\000\000\000\000\000\000\001\"\000\000\000\000\000\000\000\000\000\000\002Z\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002^\002~\002\130\004f\000\000\t]\000\000\002\150\000\154\000\158\000\174\000\178\000\186\000\000\002\190\000\202\002\194\000\206\000\000\000\000\000\000\002\198\000\000\000\000\002\222\000\000\000\000\000\000\002\238\002\242\000\000\000\000\000\000\000\000\000\000\003\002\0032\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\"\003R\003V\003f\003j\003\130\002Z\000\000\003\146\000\000\003\150\000\000\000\000\000\000\000\000\002^\002~\002\130\b.\000\000\000\000\000\000\002\150\000\000\000\000\000\000\000\000\000\000\000\000\002\190\000\000\002\194\005\026\000\000\000\000\000\000\002\198\000\000\000\000\002\222\000\000\000\000\000\000\002\238\002\242\000\000\000\000\000\000\000\000\000\000\003\002\0032\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\"\003R\003V\003f\003j\003\130\002Z\000\000\003\146\000\000\003\150\000\000\000\000\000\000\000\000\002^\002~\002\130\000\000\000\000\000\000\000\000\002\150\000\000\000\000\000\000\000\000\000\000\000\000\002\190\000\000\002\194\005&\000\000\000\000\000\000\002\198\000\000\000\000\002\222\000\000\000\000\000\000\002\238\002\242\000\000\000\000\000\000\000\000\000\000\003\002\0032\000\000\000\000\000\000\000\000\000\000\000\026\000\000\000\000\000\000\000\000\000\000\000\"\000\000\000\000\000\000\000\000\007\182\000\000\000\000\000\000\000&\0002\0006\000\000\000\000\000\000\000\000\000F\003R\003V\003f\003j\003\130\000\000\000^\003\146\000b\003\150\000\000\000\000\000\000\000f\000\000\000\000\000j\000\000\000\000\000\000\000r\000v\000\000\000\000\000\000\000\000\000\000\000\134\000\138\000\000\000\000\000\000\000\000\000\000\000\026\000\000\000\000\000\000\000\000\000\000\000\"\000\000\000\000\000\000\000\000\r\142\000\000\000\000\000\000\000&\0002\0006\000\000\000\000\000\000\000\000\000F\000\154\000\158\000\174\000\178\000\186\000\000\000^\000\202\000b\000\206\000\000\000\000\000\000\000f\000\000\000\000\000j\000\000\000\000\000\000\000r\000v\000\000\000\000\000\000\000\000\000\000\000\134\000\138\000\000\000\000\000\000\000\000\000\000\000\026\000\000\000\000\000\000\000\000\000\000\000\"\000\000\000\000\000\000\000\000\014\022\000\000\000\000\000\000\000&\0002\0006\000\000\000\000\000\000\000\000\000F\000\154\000\158\000\174\000\178\000\186\000\000\000^\000\202\000b\000\206\000\000\000\000\000\000\000f\000\000\000\000\000j\000\000\000\000\000\000\000r\000v\000\000\000\000\000\000\000\000\000\000\000\134\000\138\000\000\000\000\000\000\000\000\000\000\000\026\000\000\000\000\000\000\000\000\000\000\000\"\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000&\0002\0006\000\000\000\000\000\000\000\000\000\214\000\154\000\158\000\174\000\178\000\186\000\000\000^\000\202\000b\000\206\000\000\000\000\000\000\000f\000\000\000\000\000j\000\000\000\000\000\000\000r\000v\000\000\000\000\000\000\000\000\000\000\000\134\005\226\000\000\000\000\000\000\000\000\000\000\000\026\000\000\000\000\000\000\000\000\000\000\000\"\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000&\0002\0006\000\000\000\000\000\000\000\000\003\158\000\154\000\158\000\174\000\178\000\186\000\000\000^\000\202\000b\000\206\000\000\000\000\000\000\000f\000\000\000\000\000j\000\000\000\000\000\000\000r\000v\000\000\000\000\000\000\000\000\000\000\000\134\004\030\000\000\000\000\000\000\000\000\000\000\000\026\000\000\000\000\000\000\000\000\000\000\000\"\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000&\0002\0006\000\000\000\000\000\000\000\000\003\190\000\154\000\158\000\174\000\178\000\186\000\000\000^\000\202\000b\000\206\000\000\000\000\000\000\000f\000\000\000\000\000j\000\000\000\000\000\000\000r\000v\000\000\000\000\000\000\000\000\000\000\000\134\003\222\000\000\000\000\000\000\000\000\000\000\000\026\000\000\000\000\000\000\000\000\000\000\000\"\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000&\0002\0006\000\000\000\000\000\000\000\000\t*\000\154\000\158\000\174\000\178\000\186\000\000\000^\000\202\000b\000\206\000\000\000\000\000\000\000f\000\000\000\000\000j\000\000\000\000\000\000\000r\000v\000\000\000\000\000\000\000\000\000\000\000\134\t\138\000\000\000\000\000\000\000\000\000\000\000\026\000\000\000\000\000\000\000\000\000\000\000\"\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000&\0002\0006\000\000\000\000\000\000\000\000\012\198\000\154\000\158\000\174\000\178\000\186\000\000\000^\000\202\000b\000\206\000\000\000\000\000\000\000f\000\000\000\000\000j\000\000\000\018\006\190\000r\000v\000\000\000\000\000\000\000\000\000\000\000\134\r\006\000\000\000\000\000\000\000\000\006\214\000\000\000\234\000\000\000\000\000\000\000\000\007\n\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007&\000\000\000\000\000\154\000\158\000\174\000\178\000\186\000\254\022\218\000\202\000\000\000\206\000\018\006\190\022\018\000\000\000\000\000\000\000\000\000\000\000\000\023\178\000\000\000\000\002%\022&\000\000\006\214\000\000\000\234\000\000\000\000\000\000\000\000\007\n\000\000\022V\022r\000\000\000\000\000\000\000\000\000\000\000\000\001\006\000\000\001\n\003\178\007&\000\000\000\000\000\000\022\142\000\018\006\190\000\000\000\254\023\022\000\000\000\000\000\000\000\000\024\186\022\018\000\000\000\000\000\000\000\000\006\214\000\000\000\234\000\000\000\000\002%\022&\007\n\000\000\000\018\006\190\000\000\000\000\000\000\000\000\000\000\000\000\022V\022r\000\000\000\000\007&\000\000\000\000\006\214\001\006\000\234\001\n\003\178\000\254\023B\007\n\000\000\022\142\000\000\000\000\022\018\000\000\000\000\000\000\000\018\006\190\000\000\000\000\000\000\007&\002%\022&\000\000\025\186\000\000\000\000\000\000\000\254\023n\006\214\000\000\000\234\022V\022r\022\018\000\000\007\n\000\000\000\018\006\190\001\006\000\000\001\n\003\178\002%\022&\000\000\000\000\022\142\000\000\007&\000\000\000\000\006\214\000\000\000\234\022V\022r\000\254\023\242\007\n\000\000\000\000\000\000\001\006\022\018\001\n\003\178\000\000\000\018\006\190\000\000\022\142\000\000\007&\002%\022&\000\000\000\000\000\000\000\000\000\000\000\254\024\030\006\214\000\000\000\234\022V\022r\022\018\000\000\007\n\000\000\000\018\006\190\001\006\000\000\001\n\003\178\002%\022&\000\000\000\000\022\142\000\000\007&\000\000\000\000\006\214\000\000\000\234\022V\022r\000\254\024J\007\n\000\000\000\000\000\000\001\006\022\018\001\n\003\178\000\000\000\018\006\190\000\000\022\142\000\000\007&\002%\022&\000\000\000\000\000\000\000\000\000\000\000\254\024v\006\214\000\000\000\234\022V\022r\022\018\000\000\007\n\000\000\000\018\006\190\001\006\000\000\001\n\003\178\002%\022&\000\000\000\000\022\142\000\000\007&\000\000\000\000\006\214\000\000\000\234\022V\022r\000\254\024\242\007\n\000\000\000\000\000\000\001\006\022\018\001\n\003\178\000\000\000\018\006\190\000\000\022\142\000\000\007&\002%\022&\000\000\000\000\000\000\000\000\000\000\000\254\025\030\006\214\000\000\000\234\022V\022r\022\018\000\000\007\n\000\000\000\018\006\190\001\006\000\000\001\n\003\178\002%\022&\000\000\000\000\022\142\000\000\007&\000\000\000\000\006\214\000\000\000\234\022V\022r\000\254\025J\007\n\000\000\000\000\000\000\001\006\022\018\001\n\003\178\000\000\000\018\006\190\000\000\022\142\000\000\007&\002%\022&\000\000\000\000\000\000\000\000\000\000\000\254\025v\006\214\000\000\000\234\022V\022r\022\018\000\000\007\n\000\000\000\018\006\190\001\006\000\000\001\n\003\178\002%\022&\000\000\000\000\022\142\000\000\007&\000\000\000\000\006\214\000\000\000\234\022V\022r\000\254\026\246\007\n\000\000\000\000\000\000\001\006\022\018\001\n\003\178\000\000\000\018\006\190\000\000\022\142\000\000\007&\002%\022&\000\000\000\000\000\000\000\000\000\000\000\254\027\"\006\214\000\000\000\234\022V\022r\022\018\000\000\007\n\000\000\000\018\006\190\001\006\000\000\001\n\003\178\002%\022&\000\000\000\000\022\142\000\000\007&\000\000\000\000\006\214\000\000\000\234\022V\022r\000\254\027Z\007\n\000\000\000\000\000\000\001\006\022\018\001\n\003\178\000\000\000\018\006\190\000\000\022\142\000\000\007&\002%\022&\000\000\000\000\000\000\000\000\000\000\000\254\027\178\006\214\000\000\000\234\022V\022r\022\018\000\000\007\n\000\000\000\018\006\190\001\006\000\000\001\n\003\178\002%\022&\000\000\000\000\022\142\000\000\007&\000\000\000\000\006\214\000\000\000\234\022V\022r\000\254\027\226\007\n\000\000\000\000\000\000\001\006\022\018\001\n\003\178\000\000\000\018\006\190\000\000\022\142\000\000\007&\002%\022&\000\000\000\000\000\000\000\000\000\000\000\254\028\158\006\214\000\000\000\234\022V\022r\022\018\000\000\007\n\000\000\000\018\006\190\001\006\000\000\001\n\003\178\002%\022&\000\000\000\000\022\142\000\000\007&\000\000\000\000\006\214\000\000\000\234\022V\022r\000\254\028\202\007\n\000\000\000\000\000\000\001\006\022\018\001\n\003\178\000\000\000\018\006\190\000\000\022\142\000\000\007&\002%\022&\000\000\000\000\000\000\000\000\000\000\000\254\029\002\006\214\000\000\000\234\022V\022r\022\018\000\000\007\n\000\000\000\018\006\190\001\006\000\000\001\n\003\178\002%\022&\000\000\000\000\022\142\000\000\007&\000\000\000\000\006\214\000\000\000\234\022V\022r\000\254\029:\007\n\000\000\000\000\000\000\001\006\022\018\001\n\003\178\000\000\000\018\006\190\000\000\022\142\000\000\007&\002%\022&\000\000\000\000\000\000\000\000\000\000\000\254\029j\006\214\000\000\000\234\022V\022r\022\018\000\000\007\n\000\000\000\018\006\190\001\006\000\000\001\n\003\178\002%\022&\000\000\000\000\022\142\000\000\007&\000\000\000\000\006\214\000\000\000\234\022V\022r\000\254\029\154\007\n\000\000\000\000\000\000\001\006\022\018\001\n\003\178\000\000\000\018\006\190\000\000\022\142\000\000\007&\002%\022&\000\000\000\000\000\000\000\000\000\000\000\254\029\198\006\214\000\000\000\234\022V\022r\022\018\000\000\007\n\000\000\000\018\006\190\001\006\000\000\001\n\003\178\002%\022&\000\000\000\000\022\142\000\000\007&\000\000\000\000\006\214\000\000\000\234\022V\022r\000\254\029\254\007\n\000\000\000\000\000\000\001\006\022\018\001\n\003\178\000\000\000\018\006\190\000\000\022\142\000\000\007&\002%\022&\000\000\000\000\000\000\000\000\000\000\000\254\0306\006\214\000\000\000\234\022V\022r\022\018\000\000\007\n\000\000\000\000\000\000\001\006\000\000\001\n\003\178\002%\022&\000\000\000\000\022\142\000\000\007&\000\000\000\000\000\000\000\000\000\000\022V\022r\000\254\030\130\000\000\000\000\000\000\000\000\001\006\022\018\001\n\003\178\000\000\000\000\000\000\000\000\022\142\000\000\015z\002%\022&\000\000\000\000\000\000\000\000\000\000\000\000\015\130\015\138\000\000\000\000\022V\022r\000\000\015\146\000\000\000\000\000\000\000\000\001\006\000\000\001\n\003\178\015\162\015\170\000\000\000\000\022\142\000\000\000\000\000\000\000\000\000\000\015\178\000\000\015\194\000\000\000\000\000\000\000\000\000\000\000\000\000\000\015\202\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\015\210\000\000\015\218"))
  
  and lhs =
    (8, "\001\000!                                                                                        \031\031\031\031\030\030\030\030\030\030\030\030\030\030\030\030\030\029\029\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\026\026\025\025\025\025\025\025\024\024\023\023\023\023\023\023\023\023\023\023\023\023\023\023\023\023\023\023\023\023\023\023\023\023\023\023\023\023\023\023\023\023\023\023\023\023\023\023\023\023\023\023\023\023\023\023\023\023\023\023\022\022\021\021\021\021\020\020\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\017\017\017\016\016\016\015\015\015\014\r\r\r\r\r\r\r\r\012\012\011\011\n\n\t\t\b\b\007\007\007\007\007\007\007\007\007\007\007\007\007\007\007\007\007\007\007\007\007\007\006\006\006\006\005\005\005\005\005\005\004\004\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\002\002\002\002\002\002\002\002\002\002\002\002\002")
  
  and goto =
    ((16, "\000\026\000#\000\000\000T\000\000\000p\000\000\000\158\000\000\000\000\003,\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\003\208\000\000\000\220\001\n\0018\0046\000\000\000\000\000\000\000\000\000\000\000\000\001\132\000\000\000\000\005\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\194\000\000\000\000\000\000\000\000\002L\000\000\002\168\000\000\000\000\000\000\000\000\003\018\000\000\000\000\000\000\000\000\0038\000\000\000\000\000\000\000\000\003\030\000\000\003X\000\000\000Z\000\000\003\130\000\000\003\146\000\000\000\000\003\236\000\000\000\000\004\026\000\000\000\000\000\000\000\000\003\244\000\000\000\000\000\000\000\000\000\000\004@\000\000\004f\000\000\004\150\000\000\004\170\000\000\004\186\000\000\004\202\000\000\004\250\000\000\005\200\000\000\005\202\000\000\0062\000\000\t\004\000\000\000\000\000\017\001\n\000t\000\000\000x\000\000\000\000\tx\000\000\t\130\000\000\t\136\000\000\t\138\000\000\000\000\t\140\000\000\000\000\t\142\000\000\000\162\000\000\t\144\000\000\t\146\000\000\t\148\000\000\000\166\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005\b\000\000\000\000\000\000\000\000\005\014\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005\016\000\000\000\000\000\000\000\000\000\000\t\208\t\210\t\154\000\000\000\000\005\018\000\000\000\000\005\020\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\t\156\000\000\t\158\t\172\t\162\000\000\t\164\t\178\000\000\000\000\t\168\000\000\000\000\000\000\005\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\t\170\000\000\000\000\000\000\000\007\000\000\000\000\000\000\000\000\t\230\000\000\t\174\000\000\000\000\000\000\000\000\t\236\000\000\000\000\t\178\000\000\000\000\000\000\000\000\t\240\000\000\000\000\000\000\000\000\000\000\t\242\000\000\000\000\000\000\000\000\t\184\000\000\000\000\t\246\000\000\000\000\000\000\000\000\000\000\000\000\000\000\t\248\000\000\000\000\000\000\000\000\000\000\t\190\000\000\000\000\t\252\000\000\000\000\000\000\000\000\000\000\000|\000\000\000\000\t\252\000\000\000\000\t\240\000\000\000\000\000\000\000\000\n\000\000\000\n\002\000\000\n\004\000\000\n\006\000\000\n\b\000\000\n\n\000\000\n\012\000\000\n\014\000\000\n\016\000\000\n\018\000\000\n\020\000\000\n\022\000\000\n\024\000\000\000\000\000\208\000\000\000\000\n\026\000\000\n\028\000\000\n\030\000\000\000\000\n \000\000\000\000\001\014\000\000\n\"\000\000\n$\000\000\0014\000\000\n&\000\000\001<\000\000\000\000\000\000\000\000\000\000\000\016\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005\000\000\000\000\000\000\001d\000\000\001l\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\n*\000\000\000\000\000\000\000\000\000\000\t\240\000\000\000\000\n.\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\t\244\n\002\000\000\t\248\000\000\000\000\000\000\000\000\000\000\005\028\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\146\000\000\000\000\000\000\000\000\003\136\000\000\000\000\004\016\000\000\000\000\000\000\000\000\001\150\000\000\000\000\000\000\004\134\000\000\000\000\001\154\0038\000\000\000\000\0054\000\000\000\000\000\005\t\250\000\000\t\252\000\000\000\000\000\000\000\022\000\000\005\016\000\000\005\026\000\000\t\254\000\000\n,\000\000\n\002\000\000\005\030\000\000\000\000\0058\000\000\000\000\005:\n\004\005<\000\000\005$\000\000\005@\n2\000\000\n\b\000\000\005B\000\000\000\000\n6\000\000\n\012\000\000\005D\000\000\004\138\000\000\000\000\000\000\000\000\004\170\000\000\000\000\000\000\000\000\001\156\000\000\000\000\000\000\001\236\000\000\000\000\000\000\000\000\n:\000\000\000\000\000\000\000\000\004\186\000\000\000\000\000\000\n<\000\000\n\018\000\000\005F\000\000\000\000\005H\n@\000\000\n\022\000\000\005J\n\024\000\000\005L\000\000\005T\000\000\000\000\n\026\000\000\000\000\000\000\n\028\000\000\005d\nJ\000\000\n \000\000\005f\000\000\n\"\000\000\nP\000\000\n&\000\000\005h\nT\000\000\n*\000\000\005l\n,\000\000\005n\000\000\n.\000\000\000\000\000\000\000\000\nl\n^\000\000\n4\000\000\005p\000\000\000\000\n6\000\000\005r\000\000\000\000\n8\000\000\005t\000\000\000\000\005v\000\000\000\000\000\000\nv\nh\000\000\n>\000\000\005x\000\000\000\000\n@\000\000\005\128\000\000\000\000\005\144\000\000\000\000\nB\000\000\000\000\n\128\nr\000\000\nH\000\000\005\146\000\000\000\000\nJ\000\000\005\148\000\000\000\000\005\152\000\000\000\000\000\000\000\000\nL\000\000\005\154\000\000\000\000\005\156\000\000\000\000\000\b\000\000\nz\000\000\nP\000\000\005\158\000\000\000\000\nR\000\000\005\160\000\000\000\000\005\162\000\000\000\000\nT\000\000\005\164\000\000\000\000\005\172\000\000\000\000\000\000\nV\000\000\005\188\000\000\000\000\005\190\000\000\000\000\000\000\nX\000\000\005\192\000\000\000\000\000\000\nZ\000\000\005\196\000\000\000\000\n\\\000\000\005\198\000\000\000\000\000\000\000\000\000\000\n^\000\000\005\200\000\000\000\000\n`\000\000\005\202\000\000\nd\000\000\000\000\nf\000\000\000\000\004\200\000\000\000\000\000\000\005\224\000\000\000\000\005\226\000\000\000\000\nf\000\000\005\208\000\000\000\000\000\000\nh\000\000\005\216\000\000\000\000\nj\000\000\005\232\000\000\000\000\000\000\nl\000\000\005\234\000\000\000\000\nn\000\000\005\236\000\000\np\000\000\005\240\000\000\000\000\000\000\nr\000\000\005\242\000\000\000\000\nt\000\000\005\244\000\000\000\000\nv\000\000\000\000\000\000\nx\000\000\005\246\000\000\000\n\000\000\000\000\000\000\nz\000\000\005\252\000\000\000\000\n|\000\000\006\004\000\000\000\000\n~\000\000\006\014\000\000\000\000\000\000\n\128\000\000\006\016\000\000\000\000\n\130\000\000\006\020\000\000\000\000\n\132\000\000\000\000\000\000\000\000\n\194\000\000\000\000\n\136\000\000\006\022\000\000\000\000\n\138\000\000\006\024\000\000\000\000\000\000\n\200\000\000\000\000\n\142\000\000\006\028\000\000\000\000\n\144\000\000\006\030\000\000\000\000\n\146\000\000\000\000\n\208\000\000\000\000\n\150\000\000\006 \000\000\000\000\n\152\000\000\006\"\000\000\000\000\000\000\000\000\0066\000\000\0060\000\000\000\000\000\000\006<\000\000\000\000\n\154\000\000\006>\000\000\000\000\006@\000\000\000\000\006B\000\000\000\000\000\000\000\000\006D\000\000\000\000\000\000\n\156\000\000\006H\000\000\000\000\006J\000\000\000\000\006H\000\000\006N\000\000\000\000\000\000\006\\\000\000\000\000\n\158\000\000\006f\000\000\000\000\006h\000\000\000\000\000\000\n\160\000\000\006j\000\000\000\000\006l\000\000\000\000\000\000\000\000\006n\000\000\000\000\000\000\006p\000\000\000\000\n\162\000\000\000\000\006t\000\000\000\000\006v\000\000\000\000\000\000\000\000\n\164\000\000\006x\000\000\000\000\006z\000\000\000\000\000\000\000\000\006\136\000\000\000\000\000\000\000\000\006\146\000\000\000\000\000\000\000\026\000\000\000\000\000\030\n\166\000\000\006\148\n\182\000\"\000\000\000\000\n\170\000\000\n\172\000\000\n\174\000\000\000\000\000&\n\176\000\000\000\000\000\000\n\186\n\230\000\000\n\232\000\000\n\234\000\000\n\236\000\000\000\000\000\000\n\238\000\000\n\240\000\000\n\242\001\186\000\000\000\000\n\244\000\000\n\246\000\000\n\248\000\000\n\250\000\000\n\252\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\006\150\n\204\000\000\006\152\n\222\n\208\000\000\006\154\n\226\000\000\000\000\n\220\006\156\n\222\000*\000\000\n\224\000\000\000\000\n\218\000\000\006\160\n\236\000\000\000D\000\000\006\162\000\000\000H\000\000\000L\000\000\000\000\000\000\n\222\000\000\006\164\n\240\000\000\n\234\000\000\006\166\000\000\n\236\000\000\n\238\000\000\000\000\006\180\000\000\n\240\000\000\006\190\n\234\000\000\006\192\n\252\000\000\n\246\000\000\006\194\000\000\n\248\000\000\n\250\000P\000\000\n\252\000\000\000\000\000\000\n\246\000\000\006\196\011\b\000\000\011\002\000\000\006\198\000\000\011\004\000\000\011\006\000\000\011\b\000T\000\000\011\n\000\000\000\000\011\004\000\000\006\200\011\006\000\000\006\204\011\024\000\000\011\018\000\000\006\206\000\000\011\020\000\000\011\022\000X\000\000\011\024\000\000\000\000\000\000\011\018\000\000\006\208\011$\000\000\011\030\000\000\006\210\000\000\011 \000\000\011\"\000\000\000\000\011\028\000\000\006\224\011.\000\000\011(\000\000\006\234\000\000\011*\000\000\011,\000\000\000\000\000r\000\000\000\000\000v\000\000\000\000\000z\000\000\000~\000\000\011&\000\000\011(\000\000\000\000\000\130\000\000\000\134\000\000\000\000\000\160\000\000\000\164\000\000\000\000\0118\011,\000\000\006\236\011<\000\168\000\000\011>\000\000\000\000\000\000\0112\000\000\006\238\011D\000\000\011D\000\000\006\240\000\000\011F\000\000\011H\000\000\000\172\006\242\000\176\000\180\000\000\000\206\000\000\000\000\000\000\011<\000\000\006\244\011N\000\000\000\210\000\000\006\248\000\000\000\214\000\000\000\218\000\000\000\000\000\222\006\250\000\226\000\252\000\000\001\000\000\000\000\000\000\000\011@\000\000\006\252\011R\000\000\001\004\000\000\006\254\000\000\001\b\000\000\001\012\000\000\000\000\011T\011F\000\000\007\012\011X\000\000\011X\001\016\007\022\001*\001.\000\000\0012\000\000\000\000\000\000\011L\000\000\007\024\011^\000\000\0016\000\000\007\026\000\000\001:\000\000\001>\000\000\000\000\007\028\000\000\011^\001X\007\030\001\\\001`\000\000\001d\000\000\000\000\000\000\011R\000\000\007 \011d\000\000\001h\000\000\007$\000\000\001l\000\000\001\134\000\000\000\000\011d\001\138\007&\001\142\001\146\000\000\001\150\000\000\000\000\000\000\011X\000\000\007(\011j\000\000\001\154\000\000\007*\000\000\001\180\000\000\001\184\000\000\000\000\000\000\0078\000\000\001\188\000\000\000\000\000\000\011\\\000\000\000\000\001\192\000\000\011^\000\000\000\000\001\196\000\000\000\000\000\000\000\000\000\000\000\000\011v\011b\000\000\011z\001\200\000\000\011|\000\000\000\000\000\000\007B\000\000\001\226\000\000\000\000\001\230\000\000\001\234\000\000\000\000\011h\000\000\007D\011z\000\000\000\000\001\238\000\000\007F\000\000\000\000\001\242\000\000\000\000\001\246\000\000\002\016\000\000\000\000\002\020\000\000\000\000\000\000\002\024\000\000\002\028\000\000\000\000\001\250\000\000\007n\000\000\000\000\002\028\000\000\000\000\000\000\000\000\011\142\000\000\011\144\000\000\000\000\000\000\000\000\002 \011\172\000\000\000\000\011r\000\000\000\000\002$\011\176\000\000\000\000\011v\000\000\000\000\002(\011\180\000\000\000\000\011z\000\000\000\000\000\000\002J\000\000\000\000\000\000\002x\000\000\007r\000\000\000\000\002\128\000\000\002\132\002 \000\000\002\166\000\000\000\000\000\000\000\000\007t\000\000\000\000\000\000\000\000\002\174\000\000\002\212\002$\000\000\002\220\000\000\000\000\007v\000\000\000\000\003\002\000\000\003\n\002>\000\000\0030\000\000\000\000\000\000\000\000\000\000\007j\000\000\007l\002B\000\000\007x\000\000\000\000\011|\000\000\000\000\007\130\000\000\000\000\000\000\007\138\000\000\002F\000\000\007\140\000\000\007\142\000\000\000\000\000\000\000\000\000\000\000\000\007\144\000\000\007\146\000\000\000\000\007\148\000\000\007\150\002J\000\000\007\152\000\000\000\000\000\000\000\000\000\000\007\154\000\000\007\160\002N\000\000\007\162\000\000\000\000\007\166\000\000\000\000\007\168\000\000\007\172\002R\000\000\007\174\000\000\000\000\000\000\000\000\000\000\007\176\000\000\007\178\002l\000\000\007\182\000\000\000\000\011~\000\000\000\000\007\186\000\000\000\000\000\000\007\196\000\000\002p\000\000\007\206\000\000\007\208\000\000\000\000\000\000\000\000\007\214\000\000\007\216\000\000\000\000\007\220\000\000\007\230\002t\000\000\007\238\000\000\000\000\000\000\000\000\000\000\007\240\000\000\007\242\002x\000\000\007\244\000\000\000\000\007\248\000\000\000\000\007\250\000\000\007\252\002|\000\000\007\254\000\000\000\000\000\000\000\000\000\000\b\004\000\000\b\006\002\128\000\000\b\012\000\000\000\000\011\128\000\000\000\000\b\016\000\000\000\000\000\000\b\018\000\000\002\154\000\000\b\020\000\000\b\022\000\000\000\000\000\000\011\130\000\000\000\000\000\000\b\026\000\000\000\000\000\000\000\000\011\132\000\000\000\000\000\000\b\028\000\000\011\134\000\000\000\000\000\000\b\030\000\000\000\000\011\136\000\000\000\000\000\000\b(\000\000\011\138\000\000\000\000\000\000\b*\000\000\000\000\000\000\000\000\000\000\011\140\000\000\000\000\b2\000\000\000\000\011\142\000\000\000\000\b4\000\000\000\000\000\000\000\000\000\000\011\144\000\000\000\000\b:\000\000\000\000\011\146\000\000\000\000\b<\000\000\000\000\000\000\011\182\000\000\000\000\000\000\b@\000\000\000\000\bJ\002\158\000\000\bR\000\000\000\000\000\000\000\000\000\000\bT\000\000\bV\002\162\000\000\bX\000\000\000\000\005:\000\000\011\210\000\000\000\000\000\000\b^\000\000\b`\002\166\000\000\bb\000\000\000\000\000\000\000\000\bh\000\000\000\000\000\000\bv\000\000\000\000\000\000\011\212\000\000\000\000\000\000\bj\000\000\bt\002\170\000\000\bx\000\000\000\000\011\214\000\000\000\000\000\000\bz\000\000\b\128\002\174\000\000\b\130\000\000\000\000\000\000\000\000\000\000\000\000\002\200\000\000\b\140\000\000\000\000\000\000\000\000\b\142\000\000\000\000\002\204\000\000\b\150\000\000\000\000\000\000\000\000\002\208\000\000\b\152\000\000\000\000\b\158\000\000\000\000\002\212\000\000\b\154\000\000\000\000\000\000\000\000\002\216\000\000\b\162\000\000\000\000\b\164\002\220\000\000\b\168\000\000\000\000\000\000\000\000\000\000\b\174\000\000\b\182\002\246\000\000\b\184\000\000\000\000\b\186\000\000\011\216\000\000\000\000\000\000\b\188\000\000\b\192\002\250\000\000\b\196\000\000\000\000\000\000\000\000\011\218\000\000\000\000\000\000\b\198\000\000\b\206\002\254\000\000\b\208\000\000\000\000\011\220\000\000\000\000\000\000\b\210\000\000\b\216\003\002\000\000\b\220\000\000\000\000\000\000\b\222\000\000\000\000\b\226\000\000\b\228\003\006\000\000\b\230\000\000\000\000\000\000\000\000\000\000\b\236\000\000\b\244\003\n\000\000\b\250\000\000\000\000\b\254\000\000\011\222\000\000\000\000\000\000\b\252\000\000\t\b\003$\000\000\t\012\000\000\000\000\000\000\000\000\011\224\000\000\000\000\000\000\t\016\000\000\t\018\003(\000\000\t\026\000\000\000\000\000\000\004D\000\000\000\000\000\000\t\028\000\000\011\226\000\000\000\000\000\000\t \000\000\t\"\003,\000\000\t$\000\000\000\000\000\000\000\000\t*\000\000\000\000\t4\000\000\000\000\000\000\t(\000\000\011\228\000\000\000\000\t0\000\000\000\000\000\000\t2\000\000\000\000\t<\000\000\000\000\t6\000\000\011\230\000\000\000\000\t8\000\000\000\000\000\000\000\000\000\210\000\000\003.\011\172\000\000\011\174\000\000\000\000\000\000\0032\000\000\0034\000\000\000\000\003N\000\000\000\000\000\000\000\000\000\000\011\198\000\000\t&\000\000\003R\000\000\000\000\003T\000\000\000\000\003X\000\000\000\000\011\178\000\000\000\000\003Z\011\180\000\000\t(\011\196\003`\000\000\011\198\003l\000\000\000\000\011\186\000\000\011\188\000\000\011\190\000\000\000\000\003z\000\000\003|\011\192\000\000\000\000\000\000\011\202\000\000\003~\000\000\011\196\000\000\t:\011\214\000\000\003\128\000\000\tD\000\000\003\152\000\000\003\154\000\000\000\000\000\000\000\000\003\142\000\000\003\158\000\000\011\200\000\000\011\202\000\000\000\000\003\170\000\000\003\178\000\000\000\000\003\184\000\000\003\188\000\000\tJ\003\190\003\204\000\000\003\208\000\000\000\000\000\000\011\204\000\000\tL\011\222\000\000\003\214\000\000\tN\000\000\003\220\000\000\003\224\000\000\000\000\003\240\tR\003\244\004\000\000\000\003\250\000\000\000\000\000\000\011\208\000\000\tT\011\226\000\000\004\004\000\000\tV\000\000\004\020\000\000\004\024\000\000\000\000\011\228\011\214\000\000\tX\011\232\000\000\011\232\004\030\t\\\004$\0042\000\000\0046\000\000\000\000\000\000\011\220\000\000\t^\011\238\000\000\0048\000\000\tf\000\000\004<\000\000\004B\000\000\000\000\tp\000\000\011\238\004T\tv\004V\004b\000\000\004f\000\000\000\000\000\000\011\226\000\000\tx\011\244\000\000\004h\000\000\tz\000\000\004r\000\000\004\130\000\000\000\000\011\244\004\132\t~\004\134\004\146\000\000\004\150\000\000\000\000\000\000\011\232\000\000\t\128\011\250\000\000\004\162\000\000\t\130\000\000\004\166\000\000\004\178\000\000\000\000\000\000\t\132\000\000\004\182\000\000\000\000\011\236\000\000\000\000\004\194\000\000\000\000\004\198\000\000\000\000\011\238\000\000\t\136\012\000\000\000\000\000\004\210\000\000\t\138\000\000\000\000\004\214\000\000\000\000\004\226\000\000\004\230\000\000\000\000\000\000\000\000\004\242\000\000\004\246\000\000\000\000\000\000"), (16, "\001\027\001\027\001Z\001Z\001\027\000\149\001Z\001\027\001\027\001Z\001Z\001\027\000\003\001Z\001^\001^\005\131\004\022\001^\001_\001l\001^\001^\001\142\000z\001]\002\147\003\020\002V\005z\004\022\005O\004\022\005C\004\022\004\167\004\022\004\145\004\022\004\019\004\022\002V\000\004\002V\005\172\002V\007\199\002V\001\027\002V\001h\002V\004\029\004\022\004!\004\022\004#\004\022\004F\004\022\004Z\004\022\004n\004\022\002V\001\027\002V\001X\002V\007\197\002V\000\147\002V\000y\002V\004\144\004\022\004\147\004\022\004\150\004\022\004\152\004\022\004\159\004\022\004\161\004\022\002V\001\174\002V\000z\002V\000z\002V\000\138\002V\000\146\002V\004\164\004\022\004\166\004\022\004\174\004\022\004\214\004\022\004\199\004\022\004\196\004\022\002V\001\169\002V\000z\002V\000z\002V\001@\002V\007\201\002V\004\198\004\022\004\207\004\022\004\211\004\022\004\213\004\022\004\237\004\022\004\222\004\022\002V\007\202\002V\000z\002V\001\027\002V\001M\002V\001\164\002V\004\219\004\022\004\221\004\022\004\230\004\022\004\234\004\022\004\236\004\022\005\011\004\022\002V\001\027\002V\001S\002V\001\027\002V\001W\002V\000\148\002V\004\252\004\022\004\249\004\022\004\251\004\022\005\004\004\022\005\b\004\022\005\n\004\022\002V\001p\002V\001s\002V\001p\002V\001r\002V\001\159\002V\005%\004\022\005\022\004\022\005\019\004\022\005\021\004\022\005\030\004\022\005\"\004\022\002V\005\172\002V\005\172\002V\005\172\002V\001\027\002V\002\t\002V\005$\004\022\005=\004\022\005.\004\022\005+\004\022\005-\004\022\0056\004\022\002V\001\151\002V\007\166\002V\007`\002V\007&\002V\003\238\002V\005:\004\022\005<\004\022\005B\004\022\005I\004\022\005N\004\022\005Y\004\022\002V\001\027\002V\002\r\002V\000z\002V\005\172\002V\001\138\002V\005a\004\022\005d\004\022\005f\004\022\005o\004\022\005t\004\022\005w\004\022\002V\005\172\002V\005\172\002V\005\172\002V\005\172\002V\006\254\002V\005y\004\022\005|\004\022\005\128\004\022\005\130\004\022\005\184\004\022\005\199\004\022\002V\005\172\002V\006\188\002V\006\180\002V\006\165\002V\006\150\002V\005\210\004\022\005\221\004\022\005\235\004\022\005\254\004\022\006\t\004\022\006\020\004\022\002V\005\172\002V\006s\002V\005\172\002V\005\172\002V\001\137\002V\006\031\004\022\006-\004\022\006>\004\022\006I\004\022\006T\004\022\006_\004\022\002V\005\172\002V\005\176\002V\005\172\002V\005\181\002V\005\187\002V\006m\004\022\006\191\004\022\006\202\004\022\006\216\004\022\006\238\004\022\006\250\004\022\002V\005\172\002V\005\186\002V\005\172\002V\005\196\002V\001\128\002V\007\003\004\022\007\r\004\022\007\020\004\022\007\028\004\022\007#\004\022\007)\004\022\002V\005\172\002V\005\202\002V\005\172\002V\005\201\002V\001u\002V\0074\004\022\007B\004\022\007P\004\022\007\\\004\022\007h\004\022\007s\004\022\002V\005\172\002V\005\207\002V\001n\002V\005\213\002V\001\167\002V\007\129\004\022\007\143\004\022\007\162\004\022\b\b\007\210\004\022\b\b\b\208\000E\002V\b\201\002V\005\212\002V\002V\000\157\002V\002V\007\215\004\022\007\225\004\022\b\b\007\231\004\022\b\b\b\179\007\242\004\022\b\173\002V\001\187\002V\002V\b\b\002V\002V\000G\b@\002V\007\255\004\022\b\b\b\b\b\b\002V\b\023\b\022\b\015\001\191\b\026\004\022\002V\002V\002V\002V\b\b\b\b\000K\b\b\b\019\b\021\002V\b\028\b#\004\022\000M\002V\002V\b\b\002V\b(\004\022\b%\b\b\b\b\002V\001\165\b*\b1\002V\b.\004\022\002V\b\b\002V\002V\b\b\b0\000T\b\b\b9\b\b\002V\b=\002V\b?\000\157\002V\001\187\b\b\002V\b\b\002V\bW\b\b\bH\bE\004\022\bG\b\b\002V\000S\002V\bP\000X\002V\001\190\b\b\002V\b\b\002V\bT\b\b\bV\001\187\b\b\bu\001\157\002V\bf\002V\bc\004\022\002V\b\b\b\b\002V\b\b\be\bn\b\b\br\007\149\002V\bt\002V\002V\000\157\002V\b\b\b\b\002V\000^\b\143\b\128\b}\004\022\005\188\b\b\b\b\002V\002V\b\127\b\136\b\b\002\023\007-\002V\b\140\002V\002V\000`\b\b\b\b\b\b\002V\b\142\b\167\b\152\b\149\004\022\002\004\b\b\002V\002V\002V\b\151\002\006\b\b\002\022\b\b\002V\b\160\002V\b\164\000b\b\b\002\216\b\b\002V\b\166\002V\b\172\002\006\b\b\000d\b\b\002V\b\178\002V\b\181\002\006\b\b\000f\b\b\002V\b\190\002V\b\195\002\218\b\b\000h\b\b\002V\b\198\002V\b\200\b\205\004\022\001\149\b\b\002V\000\155\002V\b\207\000\159\000\172\000\182\000\186\002V\000\209\002V\001\162\003\191\005\188\000j\003\159\006\220\003\186\000\157\003\177\006\228\000\157\006\255\002V\000\157\000\157\000\157\000\157\002V\000\157\002V\000\157\003\176\003\167\003\163\000\157\003\158\003\149\003\132\003{\003s\003b\003a\002V\002V\002V\003`\002V\002V\002V\002V\002V\002V\002V\002\179\002\170\002\145\002V\002\136\002\135\002U\002Z\002_\002b\002k\002V\002V\002V\002p\002V\002V\002V\002V\002V\002V\002V\002s\002~\002\131\002V\002\134\002\141\002\144\002\153\002\158\002\161\002\166\002V\002V\002V\002\169\002V\002V\002V\002V\002V\002V\002V\002\175\002\178\002\184\002V\002\190\002\195\002\203\002\208\002\220\002\223\002\228\002V\002V\002V\002\234\002V\002V\002V\002V\000l\000n\002V\002\239\002\245\002\250\002V\002\254\003\004\003\t\003\018\002\218\002\218\003\026\002V\002V\002V\003\031\002V\002V\002V\002V\003$\003*\002V\003/\003<\003A\002V\003J\003O\003Z\003_\002V\002V\003g\002V\002V\002V\003f\002V\002V\002V\002V\003\137\003j\003o\003r\003u\003z\002V\003\128\003\131\000p\003\136\000\157\002V\002V\002V\002V\002V\003\140\002V\002V\000\157\002V\003\145\003\148\003\154\003\157\003\162\003\166\002V\003\172\003\175\003\182\003\185\002V\002V\002V\002V\002V\002V\003\190\002V\002V\002V\002V\003\195\004\238\004\128\004\b\004\012\004%\002V\004\026\004\031\004)\004.\002V\002V\002V\002V\002V\002V\0045\002V\002V\002V\002V\004J\004<\004A\004N\004S\004r\002V\004d\004i\004v\004{\002V\002V\002V\002V\002V\002V\004\132\002V\002V\002V\002V\004\137\004\178\004\182\004\187\004\200\004\204\002V\004\209\004\223\004\227\004\232\002V\002V\002V\002V\002V\002V\004\242\002V\002V\002V\002V\004\253\005\001\005\006\005\r\005\023\005\027\002V\005 \005/\0053\0058\002V\002V\002V\002V\002V\002V\005@\002V\002V\002V\002V\005g\005k\005q\005\172\005\172\005\188\002V\005\188\005\188\005\188\005\172\002V\002V\002V\006\195\005\172\005\192\005\191\005\214\005\172\005\172\005\172\005\172\005\188\005\172\005\172\005\172\005\172\005\218\005\224\005\172\005\172\006\002\005\188\005\172\005\223\005\172\005\172\005\172\005\172\005\229\005\172\006\024\005\172\005\233\005\240\005\239\005\246\005\172\005\251\006\001\006\000\006\006\005\172\005\172\006\012\006\011\005\172\005\188\006\017\005\172\006\023\006\022\006\028\006\"\005\172\006!\006B\006'\005\172\005\172\005\172\005\172\006+\005\188\005\172\005\172\005\172\0062\0061\005\172\005\172\0066\006X\005\172\006;\005\172\005\172\005\172\005\172\006A\005\172\005\172\005\172\006@\006F\006L\006K\005\172\005\172\006Q\006W\006V\005\172\005\172\006\\\006b\005\172\005\172\006a\005\172\006g\006k\006r\006q\005\172\006y\006\130\006\136\005\172\005\172\005\172\005\172\006\143\006\149\005\172\005\172\005\172\006\158\006\164\006\220\005\172\006\173\006\179\006\223\006\187\005\172\006\220\005\172\005\172\006\194\006\227\005\172\005\172\006\193\006\199\006\205\006\204\005\172\005\188\006\213\006\219\006\218\005\172\005\172\005\172\006\235\005\188\007\016\005\172\005\172\006\241\005\172\006\240\006\247\005\172\007\031\006\253\006\252\005\172\005\172\006\220\005\172\007\005\005\172\007F\005\172\005\172\007\015\007\022\007\030\005\172\005\172\005\172\007%\007,\005\172\007+\005\172\005\188\0071\005\172\005\172\005\172\0077\0076\005\172\007?\007l\007E\005\172\007D\007M\005\172\005\172\006\220\007S\007R\007Y\007\133\005\172\007_\005\172\007^\005\172\005\172\007e\007k\007j\005\172\005\172\007p\005\172\005\172\005\172\007v\005\172\007\169\007u\007~\005\172\005\172\007\169\005\172\005\172\007\132\007\169\007\131\000r\007\140\007\146\007\173\b\182\bX\007\145\007\153\007\172\007\159\007\165\007\164\007\188\007\176\b\012\002V\002V\007\181\007\185\b\017\007\191\007\196\b2\b6\b;\002V\bI\bM\bR\b\\\002V\bg\bk\002V\002V\002V\bp\002V\002V\002V\002V\bw\002V\002V\b\129\b\133\b\138\002V\b\153\b\157\b\162\b\170\002V\b\186\b\192\002V\002V\002V\000|\002V\002V\002V\002V\000~\002V\002V\000\128\000\131\000\134\000\136\000\140\000\142\000\144\001g\001f\000\179\000\194\000\196\000\202\000\198\000\200\000\201\000\204\000\221\001\024\001\015\001\004\000\254\000\245\000\251\001\000\001\003\001\011\001\017\001\020\001\029\001!\001%\001'\001)\001+\001-\001/\0011\0013\0015\0017\0019\001;\001=\001C\001E\001H\001K\001O\001Q\001U\001|\001\130\001\133\001\153\001\154\001\156\001\210\001\212\001\222\003\183\001\226\003\164\003\155\001\243\003\146\001\250\002\018\003\129\002\028\003p\002$\002'\002.\0022\002\176\0027\002;\002\167\002?\002\142\002D\002G\002t\002P\002`\002S\002X\002]\002f\002q\002i\002n\002v\002y\002\132\002|\002\129\002\139\002\159\002\151\002\156\002\164\002\173\002\182\002\188\002\193\002\201\002\206\002\221\002\214\002\226\002\232\002\237\002\243\002\248\002\252\003\002\003\007\003\012\003\016\003\024\003\029\003\"\003(\003-\003P\0037\003:\003?\003E\003H\003M\003R\003U\003X\003]\003m\003~\003\143\003\152\003\169\003\180\003\203\004\215\003\210\003\212\003\214\003\218\004\142\004\004\004\003\004\002\004\001\004\000\003\255\003\254\003\253\003\252\003\251\003\250\003\249\004\006\004\014\004\n\004\r\0043\004$\004\021\004\024\004\027\004'\004*\004,\0040\0042\0047\004:\004=\004?\004C\004I\004H\004L\004O\004Q\004U\004W\004]\004\\\004_\004b\004e\004g\004k\004q\004p\004t\004w\004y\004}\004\127\004\130\004\133\004\135\004\139\004\141\004\154\004\156\004\192\004\170\004\177\004\176\004\180\004\183\004\185\004\189\004\191\004\202\004\205\004\225\004\228\005>\004\240\004\243\004\245\004\255\005\002\005\015\005\025\005\028\005'\0051\0054\005F\005K\005]\005V\005\\\005[\005i\005l\005\146\005\145\005\151\005\154\005\158\005\161\005\165\005\168\005\226\006$\006d\006u\006~\006\132\006\139\006\145\006\155\006\161\006\170\006\176\006\183\006\209\006\231\006\243\007;\007I\007U\007z\007\136\007\155\007\178\007\193\007\204\007\206\007\221\007\234\007\238\bA\007\244\007\248\007\250\007\252\b\002\b\006\b\n\b\r\b\030\b \b4\b7\bK\bN\b\168\bZ\b]\b_\bi\bl\by\b\131\b\134\b\145\b\155\b\158\b\175\b\184\b\187"))
  
  and semantic_action =
    [|
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = x;
            MenhirLib.EngineTypes.startp = _startpos_x_;
            MenhirLib.EngineTypes.endp = _endpos_x_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let x : (AST.decl option list) = Obj.magic x in
        let _1 : (unit list) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x = 
# 232 "asllib/Parser0.mly"
                      ( List.filter_map Fun.id x )
# 816 "asllib/Parser0.ml"
           in
          (
# 196 "<standard.mly>"
    ( x )
# 821 "asllib/Parser0.ml"
           : (AST.t))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = x;
            MenhirLib.EngineTypes.startp = _startpos_x_;
            MenhirLib.EngineTypes.endp = _endpos_x_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let x : (AST.expr) = Obj.magic x in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__3_ in
        let _v : (AST.expr) = 
# 205 "<standard.mly>"
    ( x )
# 861 "asllib/Parser0.ml"
         in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : (
# 87 "asllib/Parser0.mly"
       (bool)
# 882 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v =
          let desc =
            let literal_expression =
              let _1_1 = _1 in
              
# 399 "asllib/Parser0.mly"
                       AST.L_Bool        
# 894 "asllib/Parser0.ml"
               _1_1
            in
            
# 365 "asllib/Parser0.mly"
                                                        AST.E_Literal    
# 900 "asllib/Parser0.ml"
             literal_expression
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 909 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : (
# 85 "asllib/Parser0.mly"
       (Z.t)
# 931 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v =
          let desc =
            let literal_expression =
              let _1_1 = _1 in
              
# 400 "asllib/Parser0.mly"
                       AST.L_Int         
# 943 "asllib/Parser0.ml"
               _1_1
            in
            
# 365 "asllib/Parser0.mly"
                                                        AST.E_Literal    
# 949 "asllib/Parser0.ml"
             literal_expression
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 958 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : (
# 86 "asllib/Parser0.mly"
       (Q.t)
# 980 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v =
          let desc =
            let literal_expression =
              let _1_1 = _1 in
              
# 401 "asllib/Parser0.mly"
                       AST.L_Real        
# 992 "asllib/Parser0.ml"
               _1_1
            in
            
# 365 "asllib/Parser0.mly"
                                                        AST.E_Literal    
# 998 "asllib/Parser0.ml"
             literal_expression
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 1007 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : (
# 84 "asllib/Parser0.mly"
       (Bitvector.t)
# 1029 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v =
          let desc =
            let literal_expression =
              let _1_1 = _1 in
              
# 402 "asllib/Parser0.mly"
                       AST.L_BitVector   
# 1041 "asllib/Parser0.ml"
               _1_1
            in
            
# 365 "asllib/Parser0.mly"
                                                        AST.E_Literal    
# 1047 "asllib/Parser0.ml"
             literal_expression
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 1056 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 1078 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v =
          let desc =
            let literal_expression =
              let _1_1 = _1 in
              
# 403 "asllib/Parser0.mly"
                       AST.L_String      
# 1090 "asllib/Parser0.ml"
               _1_1
            in
            
# 365 "asllib/Parser0.mly"
                                                        AST.E_Literal    
# 1096 "asllib/Parser0.ml"
             literal_expression
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 1105 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = q;
              MenhirLib.EngineTypes.startp = _startpos_q_;
              MenhirLib.EngineTypes.endp = _endpos_q_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 1139 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 1145 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos__1_ in
        let _v =
          let desc =
            let qualident =
              let i = _1 in
              
# 347 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 1157 "asllib/Parser0.ml"
              
            in
            
# 366 "asllib/Parser0.mly"
                                                        AST.E_Var        
# 1163 "asllib/Parser0.ml"
             qualident
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos_q_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 1172 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 1194 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v =
          let desc =
            let qualident = _1 in
            
# 366 "asllib/Parser0.mly"
                                                        AST.E_Var        
# 1205 "asllib/Parser0.ml"
             qualident
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 1214 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v =
          let desc =
            let qualident = 
# 349 "asllib/Parser0.mly"
              ( "record" )
# 1242 "asllib/Parser0.ml"
             in
            
# 366 "asllib/Parser0.mly"
                                                        AST.E_Var        
# 1247 "asllib/Parser0.ml"
             qualident
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 1256 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = q;
                  MenhirLib.EngineTypes.startp = _startpos_q_;
                  MenhirLib.EngineTypes.endp = _endpos_q_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 1304 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 1310 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos__3_ in
        let _v =
          let desc =
            let params = 
# 352 "asllib/Parser0.mly"
             ( [] )
# 1320 "asllib/Parser0.ml"
             in
            let args =
              let x = 
# 298 "asllib/Parser0.mly"
                ( [] )
# 1326 "asllib/Parser0.ml"
               in
              
# 205 "<standard.mly>"
    ( x )
# 1331 "asllib/Parser0.ml"
              
            in
            let name =
              let i = _1 in
              
# 347 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 1339 "asllib/Parser0.ml"
              
            in
            
# 368 "asllib/Parser0.mly"
        ( AST.E_Call { name; args; params; call_type = ST_Function } )
# 1345 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos_q_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 1354 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined2;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1;
                MenhirLib.EngineTypes.startp = _startpos__1_;
                MenhirLib.EngineTypes.endp = _endpos__1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _2;
                  MenhirLib.EngineTypes.startp = _startpos__2_;
                  MenhirLib.EngineTypes.endp = _endpos__2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = q;
                    MenhirLib.EngineTypes.startp = _startpos_q_;
                    MenhirLib.EngineTypes.endp = _endpos_q_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (AST.expr list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 1409 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 1415 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos__3_ in
        let _v =
          let desc =
            let params = 
# 352 "asllib/Parser0.mly"
             ( [] )
# 1425 "asllib/Parser0.ml"
             in
            let args =
              let _1_inlined1 = _1_inlined2 in
              let x = _1_inlined1 in
              
# 205 "<standard.mly>"
    ( x )
# 1433 "asllib/Parser0.ml"
              
            in
            let name =
              let i = _1 in
              
# 347 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 1441 "asllib/Parser0.ml"
              
            in
            
# 368 "asllib/Parser0.mly"
        ( AST.E_Call { name; args; params; call_type = ST_Function } )
# 1447 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos_q_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 1456 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 1492 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__3_ in
        let _v =
          let desc =
            let params = 
# 352 "asllib/Parser0.mly"
             ( [] )
# 1502 "asllib/Parser0.ml"
             in
            let args =
              let x = 
# 298 "asllib/Parser0.mly"
                ( [] )
# 1508 "asllib/Parser0.ml"
               in
              
# 205 "<standard.mly>"
    ( x )
# 1513 "asllib/Parser0.ml"
              
            in
            let name = _1 in
            
# 368 "asllib/Parser0.mly"
        ( AST.E_Call { name; args; params; call_type = ST_Function } )
# 1520 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 1529 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined2;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = _1;
                MenhirLib.EngineTypes.startp = _startpos__1_;
                MenhirLib.EngineTypes.endp = _endpos__1_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (AST.expr list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 1572 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__3_ in
        let _v =
          let desc =
            let params = 
# 352 "asllib/Parser0.mly"
             ( [] )
# 1582 "asllib/Parser0.ml"
             in
            let args =
              let _1_inlined1 = _1_inlined2 in
              let x = _1_inlined1 in
              
# 205 "<standard.mly>"
    ( x )
# 1590 "asllib/Parser0.ml"
              
            in
            let name = _1 in
            
# 368 "asllib/Parser0.mly"
        ( AST.E_Call { name; args; params; call_type = ST_Function } )
# 1597 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 1606 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__3_ in
        let _v =
          let desc =
            let params = 
# 352 "asllib/Parser0.mly"
             ( [] )
# 1648 "asllib/Parser0.ml"
             in
            let args =
              let x = 
# 298 "asllib/Parser0.mly"
                ( [] )
# 1654 "asllib/Parser0.ml"
               in
              
# 205 "<standard.mly>"
    ( x )
# 1659 "asllib/Parser0.ml"
              
            in
            let name = 
# 349 "asllib/Parser0.mly"
              ( "record" )
# 1665 "asllib/Parser0.ml"
             in
            
# 368 "asllib/Parser0.mly"
        ( AST.E_Call { name; args; params; call_type = ST_Function } )
# 1670 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 1679 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined2;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = _1;
                MenhirLib.EngineTypes.startp = _startpos__1_;
                MenhirLib.EngineTypes.endp = _endpos__1_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (AST.expr list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__3_ in
        let _v =
          let desc =
            let params = 
# 352 "asllib/Parser0.mly"
             ( [] )
# 1728 "asllib/Parser0.ml"
             in
            let args =
              let _1_inlined1 = _1_inlined2 in
              let x = _1_inlined1 in
              
# 205 "<standard.mly>"
    ( x )
# 1736 "asllib/Parser0.ml"
              
            in
            let name = 
# 349 "asllib/Parser0.mly"
              ( "record" )
# 1742 "asllib/Parser0.ml"
             in
            
# 368 "asllib/Parser0.mly"
        ( AST.E_Call { name; args; params; call_type = ST_Function } )
# 1747 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 1756 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e;
          MenhirLib.EngineTypes.startp = _startpos_e_;
          MenhirLib.EngineTypes.endp = _endpos_e_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let e : (AST.expr) = Obj.magic e in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_e_ in
        let _v =
          let desc =
            let unop = 
# 774 "asllib/Parser0.mly"
            ( AST.BNOT )
# 1791 "asllib/Parser0.ml"
             in
            
# 369 "asllib/Parser0.mly"
                                                        AST.E_Unop       
# 1796 "asllib/Parser0.ml"
             (unop, e)
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 1805 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e;
          MenhirLib.EngineTypes.startp = _startpos_e_;
          MenhirLib.EngineTypes.endp = _endpos_e_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let e : (AST.expr) = Obj.magic e in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_e_ in
        let _v =
          let desc =
            let unop = 
# 775 "asllib/Parser0.mly"
            ( AST.NEG )
# 1840 "asllib/Parser0.ml"
             in
            
# 369 "asllib/Parser0.mly"
                                                        AST.E_Unop       
# 1845 "asllib/Parser0.ml"
             (unop, e)
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 1854 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e;
          MenhirLib.EngineTypes.startp = _startpos_e_;
          MenhirLib.EngineTypes.endp = _endpos_e_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let e : (AST.expr) = Obj.magic e in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_e_ in
        let _v =
          let desc =
            let unop = 
# 776 "asllib/Parser0.mly"
            ( AST.NOT )
# 1889 "asllib/Parser0.ml"
             in
            
# 369 "asllib/Parser0.mly"
                                                        AST.E_Unop       
# 1894 "asllib/Parser0.ml"
             (unop, e)
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 1903 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 781 "asllib/Parser0.mly"
                 ( AST.AND    )
# 1945 "asllib/Parser0.ml"
             in
            
# 370 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 1950 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 1959 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 782 "asllib/Parser0.mly"
                 ( AST.BAND   )
# 2001 "asllib/Parser0.ml"
             in
            
# 370 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 2006 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 2015 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 783 "asllib/Parser0.mly"
                 ( AST.BOR    )
# 2057 "asllib/Parser0.ml"
             in
            
# 370 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 2062 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 2071 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 784 "asllib/Parser0.mly"
                 ( AST.DIV    )
# 2113 "asllib/Parser0.ml"
             in
            
# 370 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 2118 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 2127 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 785 "asllib/Parser0.mly"
                 ( AST.EOR    )
# 2169 "asllib/Parser0.ml"
             in
            
# 370 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 2174 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 2183 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 786 "asllib/Parser0.mly"
                 ( AST.EQ_OP  )
# 2225 "asllib/Parser0.ml"
             in
            
# 370 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 2230 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 2239 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 787 "asllib/Parser0.mly"
                 ( AST.NEQ    )
# 2281 "asllib/Parser0.ml"
             in
            
# 370 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 2286 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 2295 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 788 "asllib/Parser0.mly"
                 ( AST.GEQ    )
# 2337 "asllib/Parser0.ml"
             in
            
# 370 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 2342 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 2351 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 789 "asllib/Parser0.mly"
                 ( AST.IMPL   )
# 2393 "asllib/Parser0.ml"
             in
            
# 370 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 2398 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 2407 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 790 "asllib/Parser0.mly"
                 ( AST.LEQ    )
# 2449 "asllib/Parser0.ml"
             in
            
# 370 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 2454 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 2463 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 791 "asllib/Parser0.mly"
                 ( AST.PLUS   )
# 2505 "asllib/Parser0.ml"
             in
            
# 370 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 2510 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 2519 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 792 "asllib/Parser0.mly"
                 ( AST.MINUS  )
# 2561 "asllib/Parser0.ml"
             in
            
# 370 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 2566 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 2575 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 793 "asllib/Parser0.mly"
                 ( AST.MOD    )
# 2617 "asllib/Parser0.ml"
             in
            
# 370 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 2622 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 2631 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 794 "asllib/Parser0.mly"
                 ( AST.MUL    )
# 2673 "asllib/Parser0.ml"
             in
            
# 370 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 2678 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 2687 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 795 "asllib/Parser0.mly"
                 ( AST.OR     )
# 2729 "asllib/Parser0.ml"
             in
            
# 370 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 2734 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 2743 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 796 "asllib/Parser0.mly"
                 ( AST.RDIV   )
# 2785 "asllib/Parser0.ml"
             in
            
# 370 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 2790 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 2799 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 797 "asllib/Parser0.mly"
                 ( AST.SHL    )
# 2841 "asllib/Parser0.ml"
             in
            
# 370 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 2846 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 2855 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 798 "asllib/Parser0.mly"
                 ( AST.SHR    )
# 2897 "asllib/Parser0.ml"
             in
            
# 370 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 2902 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 2911 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 778 "asllib/Parser0.mly"
                                  ( AST.PLUS )
# 2953 "asllib/Parser0.ml"
             in
            
# 370 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 2958 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 2967 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 806 "asllib/Parser0.mly"
                 ( AST.LT     )
# 3009 "asllib/Parser0.ml"
             in
            
# 370 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 3014 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 3023 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 807 "asllib/Parser0.mly"
                 ( AST.GT     )
# 3065 "asllib/Parser0.ml"
             in
            
# 370 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 3070 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 3079 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2;
              MenhirLib.EngineTypes.startp = _startpos__2_;
              MenhirLib.EngineTypes.endp = _endpos__2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = h;
                MenhirLib.EngineTypes.startp = _startpos_h_;
                MenhirLib.EngineTypes.endp = _endpos_h_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (AST.expr list) = Obj.magic _1_inlined1 in
        let _2 : unit = Obj.magic _2 in
        let h : (AST.expr) = Obj.magic h in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__3_ in
        let _v =
          let desc =
            let _1 =
              let x =
                let _1 = _1_inlined1 in
                let t = _1 in
                
# 301 "asllib/Parser0.mly"
                                           ( h::t )
# 3139 "asllib/Parser0.ml"
                
              in
              
# 205 "<standard.mly>"
    ( x )
# 3145 "asllib/Parser0.ml"
              
            in
            let _1_1 = _1 in
            
# 371 "asllib/Parser0.mly"
                                                        AST.E_Tuple      
# 3152 "asllib/Parser0.ml"
             _1_1
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 3161 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = expr;
          MenhirLib.EngineTypes.startp = _startpos_expr_;
          MenhirLib.EngineTypes.endp = _endpos_expr_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = e;
                MenhirLib.EngineTypes.startp = _startpos_e_;
                MenhirLib.EngineTypes.endp = _endpos_e_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = c;
                    MenhirLib.EngineTypes.startp = _startpos_c_;
                    MenhirLib.EngineTypes.endp = _endpos_c_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let expr : (AST.expr) = Obj.magic expr in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : ((AST.expr * AST.expr) AST.annotated list) = Obj.magic _1_inlined1 in
        let e : (AST.expr) = Obj.magic e in
        let _3 : unit = Obj.magic _3 in
        let c : (AST.expr) = Obj.magic c in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_expr_ in
        let _v =
          let desc =
            let e_else =
              let _1 = _1_inlined1 in
              let _1_1 = _1 in
              
# 391 "asllib/Parser0.mly"
                                                build_expr_conds  
# 3234 "asllib/Parser0.ml"
               (_1_1, expr)
            in
            
# 372 "asllib/Parser0.mly"
                                                        AST.E_Cond       
# 3240 "asllib/Parser0.ml"
             (c, e, e_else)
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_expr_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 3249 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e;
              MenhirLib.EngineTypes.startp = _startpos_e_;
              MenhirLib.EngineTypes.endp = _endpos_e_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 3283 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let e : (AST.expr) = Obj.magic e in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e_ in
        let _endpos = _endpos__1_ in
        let _v =
          let desc =
            let ident = _1 in
            
# 373 "asllib/Parser0.mly"
                                                        AST.E_GetField   
# 3296 "asllib/Parser0.ml"
             (e, ident)
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos_e_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 3305 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2;
              MenhirLib.EngineTypes.startp = _startpos__2_;
              MenhirLib.EngineTypes.endp = _endpos__2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = e;
                MenhirLib.EngineTypes.startp = _startpos_e_;
                MenhirLib.EngineTypes.endp = _endpos_e_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let _1 : unit = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let e : (AST.expr) = Obj.magic e in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e_ in
        let _endpos = _endpos__3_ in
        let _v =
          let desc =
            let _3 =
              let x = 
# 298 "asllib/Parser0.mly"
                ( [] )
# 3355 "asllib/Parser0.ml"
               in
              
# 205 "<standard.mly>"
    ( x )
# 3360 "asllib/Parser0.ml"
              
            in
            let _3_1 = _3 in
            
# 374 "asllib/Parser0.mly"
                                                        AST.E_GetFields  
# 3367 "asllib/Parser0.ml"
             (e, _3_1)
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos_e_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 3376 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = e;
                  MenhirLib.EngineTypes.startp = _startpos_e_;
                  MenhirLib.EngineTypes.endp = _endpos_e_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (string list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let e : (AST.expr) = Obj.magic e in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e_ in
        let _endpos = _endpos__3_ in
        let _v =
          let desc =
            let _3 =
              let x = _1_inlined1 in
              
# 205 "<standard.mly>"
    ( x )
# 3434 "asllib/Parser0.ml"
              
            in
            let _3_1 = _3 in
            
# 374 "asllib/Parser0.mly"
                                                        AST.E_GetFields  
# 3441 "asllib/Parser0.ml"
             (e, _3_1)
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos_e_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 3450 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e;
              MenhirLib.EngineTypes.startp = _startpos_e_;
              MenhirLib.EngineTypes.endp = _endpos_e_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let _1 : unit = Obj.magic _1 in
        let e : (AST.expr) = Obj.magic e in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e_ in
        let _endpos = _endpos__3_ in
        let _v =
          let desc =
            let _2 =
              let x = 
# 298 "asllib/Parser0.mly"
                ( [] )
# 3493 "asllib/Parser0.ml"
               in
              
# 205 "<standard.mly>"
    ( x )
# 3498 "asllib/Parser0.ml"
              
            in
            let _2_1 = _2 in
            
# 375 "asllib/Parser0.mly"
                                                        AST.E_Slice      
# 3505 "asllib/Parser0.ml"
             (e, _2_1)
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos_e_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 3514 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = e;
                MenhirLib.EngineTypes.startp = _startpos_e_;
                MenhirLib.EngineTypes.endp = _endpos_e_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (AST.slice list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let e : (AST.expr) = Obj.magic e in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e_ in
        let _endpos = _endpos__3_ in
        let _v =
          let desc =
            let _2 =
              let x = _1_inlined1 in
              
# 205 "<standard.mly>"
    ( x )
# 3565 "asllib/Parser0.ml"
              
            in
            let _2_1 = _2 in
            
# 375 "asllib/Parser0.mly"
                                                        AST.E_Slice      
# 3572 "asllib/Parser0.ml"
             (e, _2_1)
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos_e_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 3581 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__3_ in
        let _v =
          let desc =
            let _1 =
              let x = 
# 298 "asllib/Parser0.mly"
                ( [] )
# 3617 "asllib/Parser0.ml"
               in
              
# 205 "<standard.mly>"
    ( x )
# 3622 "asllib/Parser0.ml"
              
            in
            let _1_1 = _1 in
            
# 376 "asllib/Parser0.mly"
                                                        make_concat      
# 3629 "asllib/Parser0.ml"
             _1_1
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 3638 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (AST.expr list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__3_ in
        let _v =
          let desc =
            let _1 =
              let x = _1_inlined1 in
              
# 205 "<standard.mly>"
    ( x )
# 3682 "asllib/Parser0.ml"
              
            in
            let _1_1 = _1 in
            
# 376 "asllib/Parser0.mly"
                                                        make_concat      
# 3689 "asllib/Parser0.ml"
             _1_1
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 3698 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = e;
                  MenhirLib.EngineTypes.startp = _startpos_e_;
                  MenhirLib.EngineTypes.endp = _endpos_e_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (AST.pattern list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let e : (AST.expr) = Obj.magic e in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e_ in
        let _endpos = _endpos__3_ in
        let _v =
          let desc =
            let bpattern =
              let desc =
                let x =
                  let _1 = _1_inlined1 in
                  let _1_1 = _1 in
                  
# 749 "asllib/Parser0.mly"
                                                       AST.Pattern_Any  
# 3759 "asllib/Parser0.ml"
                   _1_1
                in
                
# 205 "<standard.mly>"
    ( x )
# 3765 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 3774 "asllib/Parser0.ml"
              
            in
            
# 377 "asllib/Parser0.mly"
                                                        AST.E_Pattern    
# 3780 "asllib/Parser0.ml"
             (e, bpattern)
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos_e_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 3789 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e;
              MenhirLib.EngineTypes.startp = _startpos_e_;
              MenhirLib.EngineTypes.endp = _endpos_e_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _1 : (
# 83 "asllib/Parser0.mly"
       (Bitvector.mask)
# 3823 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let e : (AST.expr) = Obj.magic e in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e_ in
        let _endpos = _endpos__1_ in
        let _v =
          let desc =
            let pattern_mask =
              let desc =
                let _1_1 = _1 in
                
# 736 "asllib/Parser0.mly"
                                           AST.Pattern_Mask 
# 3838 "asllib/Parser0.ml"
                 _1_1
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 3847 "asllib/Parser0.ml"
              
            in
            
# 378 "asllib/Parser0.mly"
                                                        AST.E_Pattern    
# 3853 "asllib/Parser0.ml"
             (e, pattern_mask)
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos_e_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 3862 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _1_inlined1;
          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e;
              MenhirLib.EngineTypes.startp = _startpos_e_;
              MenhirLib.EngineTypes.endp = _endpos_e_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _1_inlined1 : (
# 83 "asllib/Parser0.mly"
       (Bitvector.mask)
# 3896 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let e : (AST.expr) = Obj.magic e in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e_ in
        let _endpos = _endpos__1_inlined1_ in
        let _v =
          let desc =
            let _2 =
              let desc =
                let pm =
                  let (_endpos__1_, _startpos__1_, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined1) in
                  let desc =
                    let _1_1 = _1 in
                    
# 736 "asllib/Parser0.mly"
                                           AST.Pattern_Mask 
# 3914 "asllib/Parser0.ml"
                     _1_1
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 3923 "asllib/Parser0.ml"
                  
                in
                
# 379 "asllib/Parser0.mly"
                                                     AST.Pattern_Not  
# 3929 "asllib/Parser0.ml"
                 pm
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined1_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 3938 "asllib/Parser0.ml"
              
            in
            let _2_1 = _2 in
            
# 379 "asllib/Parser0.mly"
                                                                           AST.E_Pattern  
# 3945 "asllib/Parser0.ml"
             (e, _2_1)
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined1_, _startpos_e_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 3954 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let desc = 
# 319 "asllib/Parser0.mly"
                          ( AST.(T_Int UnConstrained) )
# 3990 "asllib/Parser0.ml"
               in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 3998 "asllib/Parser0.ml"
              
            in
            let _1_1 = _1 in
            
# 380 "asllib/Parser0.mly"
                                                        AST.E_Unknown    
# 4005 "asllib/Parser0.ml"
             _1_1
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 4014 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let desc = 
# 320 "asllib/Parser0.mly"
                          ( AST.T_Real                )
# 4050 "asllib/Parser0.ml"
               in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 4058 "asllib/Parser0.ml"
              
            in
            let _1_1 = _1 in
            
# 380 "asllib/Parser0.mly"
                                                        AST.E_Unknown    
# 4065 "asllib/Parser0.ml"
             _1_1
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 4074 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let desc = 
# 321 "asllib/Parser0.mly"
                          ( AST.T_Bool                )
# 4110 "asllib/Parser0.ml"
               in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 4118 "asllib/Parser0.ml"
              
            in
            let _1_1 = _1 in
            
# 380 "asllib/Parser0.mly"
                                                        AST.E_Unknown    
# 4125 "asllib/Parser0.ml"
             _1_1
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 4134 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 4163 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let desc =
                let tident = _1 in
                
# 322 "asllib/Parser0.mly"
                            AST.T_Named                
# 4176 "asllib/Parser0.ml"
                 tident
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 4185 "asllib/Parser0.ml"
              
            in
            let _1_1 = _1 in
            
# 380 "asllib/Parser0.mly"
                                                        AST.E_Unknown    
# 4192 "asllib/Parser0.ml"
             _1_1
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 4201 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = q;
                MenhirLib.EngineTypes.startp = _startpos_q_;
                MenhirLib.EngineTypes.endp = _endpos_q_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 4242 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 4248 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let _2 = _2_inlined1 in
              let desc =
                let tident =
                  let i = _1 in
                  
# 339 "asllib/Parser0.mly"
                                   ( q ^ "_" ^ i )
# 4263 "asllib/Parser0.ml"
                  
                in
                
# 322 "asllib/Parser0.mly"
                            AST.T_Named                
# 4269 "asllib/Parser0.ml"
                 tident
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos_q_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 4278 "asllib/Parser0.ml"
              
            in
            let _1_1 = _1 in
            
# 380 "asllib/Parser0.mly"
                                                        AST.E_Unknown    
# 4285 "asllib/Parser0.ml"
             _1_1
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos_q_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 4294 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let desc = 
# 323 "asllib/Parser0.mly"
                          ( t_bit                     )
# 4330 "asllib/Parser0.ml"
               in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 4338 "asllib/Parser0.ml"
              
            in
            let _1_1 = _1 in
            
# 380 "asllib/Parser0.mly"
                                                        AST.E_Unknown    
# 4345 "asllib/Parser0.ml"
             _1_1
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 4354 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _3;
            MenhirLib.EngineTypes.startp = _startpos__3_;
            MenhirLib.EngineTypes.endp = _endpos__3_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = x;
              MenhirLib.EngineTypes.startp = _startpos_x_;
              MenhirLib.EngineTypes.endp = _endpos_x_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _3 : unit = Obj.magic _3 in
        let x : (AST.expr) = Obj.magic x in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let desc =
                let e = 
# 205 "<standard.mly>"
    ( x )
# 4412 "asllib/Parser0.ml"
                 in
                
# 324 "asllib/Parser0.mly"
                          ( AST.(T_Bits (e, []))      )
# 4417 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 4426 "asllib/Parser0.ml"
              
            in
            let _1_1 = _1 in
            
# 380 "asllib/Parser0.mly"
                                                        AST.E_Unknown    
# 4433 "asllib/Parser0.ml"
             _1_1
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 4442 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _3_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = x;
                    MenhirLib.EngineTypes.startp = _startpos_x_;
                    MenhirLib.EngineTypes.endp = _endpos_x_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined3 : (AST.bitfield list) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let x : (AST.expr) = Obj.magic x in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let desc =
                let b =
                  let _1_inlined1 = _1_inlined3 in
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 4524 "asllib/Parser0.ml"
                  
                in
                let e = 
# 205 "<standard.mly>"
    ( x )
# 4530 "asllib/Parser0.ml"
                 in
                
# 325 "asllib/Parser0.mly"
                                      ( AST.(T_Bits (e, b)) )
# 4535 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__3_inlined1_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 4544 "asllib/Parser0.ml"
              
            in
            let _1_1 = _1 in
            
# 380 "asllib/Parser0.mly"
                                                        AST.E_Unknown    
# 4551 "asllib/Parser0.ml"
             _1_1
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 4560 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _3;
            MenhirLib.EngineTypes.startp = _startpos__3_;
            MenhirLib.EngineTypes.endp = _endpos__3_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = x;
              MenhirLib.EngineTypes.startp = _startpos_x_;
              MenhirLib.EngineTypes.endp = _endpos_x_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _3 : unit = Obj.magic _3 in
        let x : (AST.expr) = Obj.magic x in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let desc =
                let _1 =
                  let _2 = 
# 205 "<standard.mly>"
    ( x )
# 4619 "asllib/Parser0.ml"
                   in
                  ()
                in
                
# 265 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 4626 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 4635 "asllib/Parser0.ml"
              
            in
            let _1_1 = _1 in
            
# 380 "asllib/Parser0.mly"
                                                        AST.E_Unknown    
# 4642 "asllib/Parser0.ml"
             _1_1
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 4651 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (
# 82 "asllib/Parser0.mly"
       (string)
# 4713 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let desc =
                let _1 =
                  let _2 =
                    let _1_inlined1 = _1_inlined2 in
                    let x =
                      let _1 = _1_inlined1 in
                      ()
                    in
                    
# 205 "<standard.mly>"
    ( x )
# 4734 "asllib/Parser0.ml"
                    
                  in
                  ()
                in
                
# 265 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 4742 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 4751 "asllib/Parser0.ml"
              
            in
            let _1_1 = _1 in
            
# 380 "asllib/Parser0.mly"
                                                        AST.E_Unknown    
# 4758 "asllib/Parser0.ml"
             _1_1
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 4767 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _2_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = q;
                      MenhirLib.EngineTypes.startp = _startpos_q_;
                      MenhirLib.EngineTypes.endp = _endpos_q_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (
# 82 "asllib/Parser0.mly"
       (string)
# 4841 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 4847 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let _2 = _2_inlined1 in
              let desc =
                let _1 =
                  let _2 =
                    let _1_inlined1 = _1_inlined2 in
                    let x =
                      let _1 = _1_inlined1 in
                      let _1 =
                        let i = _1 in
                        
# 339 "asllib/Parser0.mly"
                                   ( q ^ "_" ^ i )
# 4869 "asllib/Parser0.ml"
                        
                      in
                      ()
                    in
                    
# 205 "<standard.mly>"
    ( x )
# 4877 "asllib/Parser0.ml"
                    
                  in
                  ()
                in
                
# 265 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 4885 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 4894 "asllib/Parser0.ml"
              
            in
            let _1_1 = _1 in
            
# 380 "asllib/Parser0.mly"
                                                        AST.E_Unknown    
# 4901 "asllib/Parser0.ml"
             _1_1
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 4910 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _2_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _3_inlined1 : (AST.expr) = Obj.magic _3_inlined1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined2 : (AST.expr) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let _2 = _2_inlined1 in
              let desc =
                let _1 =
                  let _2 =
                    let _1_inlined1 = _1_inlined2 in
                    let x =
                      let (_3, _1) = (_3_inlined1, _1_inlined1) in
                      ()
                    in
                    
# 205 "<standard.mly>"
    ( x )
# 5004 "asllib/Parser0.ml"
                    
                  in
                  ()
                in
                
# 265 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 5012 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 5021 "asllib/Parser0.ml"
              
            in
            let _1_1 = _1 in
            
# 380 "asllib/Parser0.mly"
                                                        AST.E_Unknown    
# 5028 "asllib/Parser0.ml"
             _1_1
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 5037 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 123 "<standard.mly>"
    ( None )
# 5073 "asllib/Parser0.ml"
               in
              let _1 = 
# 319 "asllib/Parser0.mly"
                          ( AST.(T_Int UnConstrained) )
# 5078 "asllib/Parser0.ml"
               in
              ()
            in
            
# 351 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 5085 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 5094 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = x;
          MenhirLib.EngineTypes.startp = _startpos_x_;
          MenhirLib.EngineTypes.endp = _endpos_x_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let x : (
# 82 "asllib/Parser0.mly"
       (string)
# 5128 "asllib/Parser0.ml"
        ) = Obj.magic x in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_x_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 126 "<standard.mly>"
    ( Some x )
# 5141 "asllib/Parser0.ml"
               in
              let _1 = 
# 319 "asllib/Parser0.mly"
                          ( AST.(T_Int UnConstrained) )
# 5146 "asllib/Parser0.ml"
               in
              ()
            in
            
# 351 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 5153 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_x_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 5162 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 123 "<standard.mly>"
    ( None )
# 5198 "asllib/Parser0.ml"
               in
              let _1 = 
# 320 "asllib/Parser0.mly"
                          ( AST.T_Real                )
# 5203 "asllib/Parser0.ml"
               in
              ()
            in
            
# 351 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 5210 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 5219 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = x;
          MenhirLib.EngineTypes.startp = _startpos_x_;
          MenhirLib.EngineTypes.endp = _endpos_x_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let x : (
# 82 "asllib/Parser0.mly"
       (string)
# 5253 "asllib/Parser0.ml"
        ) = Obj.magic x in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_x_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 126 "<standard.mly>"
    ( Some x )
# 5266 "asllib/Parser0.ml"
               in
              let _1 = 
# 320 "asllib/Parser0.mly"
                          ( AST.T_Real                )
# 5271 "asllib/Parser0.ml"
               in
              ()
            in
            
# 351 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 5278 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_x_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 5287 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 123 "<standard.mly>"
    ( None )
# 5323 "asllib/Parser0.ml"
               in
              let _1 = 
# 321 "asllib/Parser0.mly"
                          ( AST.T_Bool                )
# 5328 "asllib/Parser0.ml"
               in
              ()
            in
            
# 351 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 5335 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 5344 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = x;
          MenhirLib.EngineTypes.startp = _startpos_x_;
          MenhirLib.EngineTypes.endp = _endpos_x_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let x : (
# 82 "asllib/Parser0.mly"
       (string)
# 5378 "asllib/Parser0.ml"
        ) = Obj.magic x in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_x_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 126 "<standard.mly>"
    ( Some x )
# 5391 "asllib/Parser0.ml"
               in
              let _1 = 
# 321 "asllib/Parser0.mly"
                          ( AST.T_Bool                )
# 5396 "asllib/Parser0.ml"
               in
              ()
            in
            
# 351 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 5403 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_x_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 5412 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 5441 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 123 "<standard.mly>"
    ( None )
# 5452 "asllib/Parser0.ml"
               in
              let _1 =
                let tident = _1 in
                
# 322 "asllib/Parser0.mly"
                            AST.T_Named                
# 5459 "asllib/Parser0.ml"
                 tident
              in
              ()
            in
            
# 351 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 5467 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 5476 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = x;
          MenhirLib.EngineTypes.startp = _startpos_x_;
          MenhirLib.EngineTypes.endp = _endpos_x_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let x : (
# 82 "asllib/Parser0.mly"
       (string)
# 5510 "asllib/Parser0.ml"
        ) = Obj.magic x in
        let _2 : unit = Obj.magic _2 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 5516 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_x_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 126 "<standard.mly>"
    ( Some x )
# 5527 "asllib/Parser0.ml"
               in
              let _1 =
                let tident = _1 in
                
# 322 "asllib/Parser0.mly"
                            AST.T_Named                
# 5534 "asllib/Parser0.ml"
                 tident
              in
              ()
            in
            
# 351 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 5542 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_x_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 5551 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = q;
                MenhirLib.EngineTypes.startp = _startpos_q_;
                MenhirLib.EngineTypes.endp = _endpos_q_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 5592 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 5598 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 123 "<standard.mly>"
    ( None )
# 5609 "asllib/Parser0.ml"
               in
              let _1 =
                let _2 = _2_inlined1 in
                let tident =
                  let i = _1 in
                  
# 339 "asllib/Parser0.mly"
                                   ( q ^ "_" ^ i )
# 5618 "asllib/Parser0.ml"
                  
                in
                
# 322 "asllib/Parser0.mly"
                            AST.T_Named                
# 5624 "asllib/Parser0.ml"
                 tident
              in
              ()
            in
            
# 351 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 5632 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos_q_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 5641 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = x;
          MenhirLib.EngineTypes.startp = _startpos_x_;
          MenhirLib.EngineTypes.endp = _endpos_x_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = q;
                  MenhirLib.EngineTypes.startp = _startpos_q_;
                  MenhirLib.EngineTypes.endp = _endpos_q_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let x : (
# 82 "asllib/Parser0.mly"
       (string)
# 5687 "asllib/Parser0.ml"
        ) = Obj.magic x in
        let _2 : unit = Obj.magic _2 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 5693 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 5699 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos_x_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 126 "<standard.mly>"
    ( Some x )
# 5710 "asllib/Parser0.ml"
               in
              let _1 =
                let _2 = _2_inlined1 in
                let tident =
                  let i = _1 in
                  
# 339 "asllib/Parser0.mly"
                                   ( q ^ "_" ^ i )
# 5719 "asllib/Parser0.ml"
                  
                in
                
# 322 "asllib/Parser0.mly"
                            AST.T_Named                
# 5725 "asllib/Parser0.ml"
                 tident
              in
              ()
            in
            
# 351 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 5733 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_x_, _startpos_q_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 5742 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 123 "<standard.mly>"
    ( None )
# 5778 "asllib/Parser0.ml"
               in
              let _1 = 
# 323 "asllib/Parser0.mly"
                          ( t_bit                     )
# 5783 "asllib/Parser0.ml"
               in
              ()
            in
            
# 351 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 5790 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 5799 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = x;
          MenhirLib.EngineTypes.startp = _startpos_x_;
          MenhirLib.EngineTypes.endp = _endpos_x_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let x : (
# 82 "asllib/Parser0.mly"
       (string)
# 5833 "asllib/Parser0.ml"
        ) = Obj.magic x in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_x_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 126 "<standard.mly>"
    ( Some x )
# 5846 "asllib/Parser0.ml"
               in
              let _1 = 
# 323 "asllib/Parser0.mly"
                          ( t_bit                     )
# 5851 "asllib/Parser0.ml"
               in
              ()
            in
            
# 351 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 5858 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_x_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 5867 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _3_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = x;
              MenhirLib.EngineTypes.startp = _startpos_x_;
              MenhirLib.EngineTypes.endp = _endpos_x_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let x : (AST.expr) = Obj.magic x in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 123 "<standard.mly>"
    ( None )
# 5924 "asllib/Parser0.ml"
               in
              let _1 =
                let e = 
# 205 "<standard.mly>"
    ( x )
# 5930 "asllib/Parser0.ml"
                 in
                
# 324 "asllib/Parser0.mly"
                          ( AST.(T_Bits (e, []))      )
# 5935 "asllib/Parser0.ml"
                
              in
              ()
            in
            
# 351 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 5943 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 5952 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = x_inlined1;
          MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
          MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = x;
                MenhirLib.EngineTypes.startp = _startpos_x_;
                MenhirLib.EngineTypes.endp = _endpos_x_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let x_inlined1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 6004 "asllib/Parser0.ml"
        ) = Obj.magic x_inlined1 in
        let _2 : unit = Obj.magic _2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let x : (AST.expr) = Obj.magic x in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_x_inlined1_ in
        let _v =
          let desc =
            let _1 =
              let _3 =
                let x = x_inlined1 in
                
# 126 "<standard.mly>"
    ( Some x )
# 6022 "asllib/Parser0.ml"
                
              in
              let _1 =
                let e = 
# 205 "<standard.mly>"
    ( x )
# 6029 "asllib/Parser0.ml"
                 in
                
# 324 "asllib/Parser0.mly"
                          ( AST.(T_Bits (e, []))      )
# 6034 "asllib/Parser0.ml"
                
              in
              ()
            in
            
# 351 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 6042 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_x_inlined1_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 6051 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _3_inlined2;
            MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
            MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = x;
                    MenhirLib.EngineTypes.startp = _startpos_x_;
                    MenhirLib.EngineTypes.endp = _endpos_x_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _1_inlined3 : (AST.bitfield list) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let x : (AST.expr) = Obj.magic x in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 123 "<standard.mly>"
    ( None )
# 6129 "asllib/Parser0.ml"
               in
              let _1 =
                let b =
                  let _1_inlined1 = _1_inlined3 in
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 6138 "asllib/Parser0.ml"
                  
                in
                let e = 
# 205 "<standard.mly>"
    ( x )
# 6144 "asllib/Parser0.ml"
                 in
                
# 325 "asllib/Parser0.mly"
                                      ( AST.(T_Bits (e, b)) )
# 6149 "asllib/Parser0.ml"
                
              in
              ()
            in
            
# 351 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 6157 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 6166 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = x_inlined1;
          MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
          MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = x;
                      MenhirLib.EngineTypes.startp = _startpos_x_;
                      MenhirLib.EngineTypes.endp = _endpos_x_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let x_inlined1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 6236 "asllib/Parser0.ml"
        ) = Obj.magic x_inlined1 in
        let _2 : unit = Obj.magic _2 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _1_inlined3 : (AST.bitfield list) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let x : (AST.expr) = Obj.magic x in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_x_inlined1_ in
        let _v =
          let desc =
            let _1 =
              let _3 =
                let x = x_inlined1 in
                
# 126 "<standard.mly>"
    ( Some x )
# 6257 "asllib/Parser0.ml"
                
              in
              let _1 =
                let b =
                  let _1_inlined1 = _1_inlined3 in
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 6267 "asllib/Parser0.ml"
                  
                in
                let e = 
# 205 "<standard.mly>"
    ( x )
# 6273 "asllib/Parser0.ml"
                 in
                
# 325 "asllib/Parser0.mly"
                                      ( AST.(T_Bits (e, b)) )
# 6278 "asllib/Parser0.ml"
                
              in
              ()
            in
            
# 351 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 6286 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_x_inlined1_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 6295 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _3_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = x;
              MenhirLib.EngineTypes.startp = _startpos_x_;
              MenhirLib.EngineTypes.endp = _endpos_x_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let x : (AST.expr) = Obj.magic x in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 123 "<standard.mly>"
    ( None )
# 6352 "asllib/Parser0.ml"
               in
              let _1 =
                let _1 =
                  let _2 = 
# 205 "<standard.mly>"
    ( x )
# 6359 "asllib/Parser0.ml"
                   in
                  ()
                in
                
# 265 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 6366 "asllib/Parser0.ml"
                
              in
              ()
            in
            
# 351 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 6374 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 6383 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = x_inlined1;
          MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
          MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = x;
                MenhirLib.EngineTypes.startp = _startpos_x_;
                MenhirLib.EngineTypes.endp = _endpos_x_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let x_inlined1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 6435 "asllib/Parser0.ml"
        ) = Obj.magic x_inlined1 in
        let _2 : unit = Obj.magic _2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let x : (AST.expr) = Obj.magic x in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_x_inlined1_ in
        let _v =
          let desc =
            let _1 =
              let _3 =
                let x = x_inlined1 in
                
# 126 "<standard.mly>"
    ( Some x )
# 6453 "asllib/Parser0.ml"
                
              in
              let _1 =
                let _1 =
                  let _2 = 
# 205 "<standard.mly>"
    ( x )
# 6461 "asllib/Parser0.ml"
                   in
                  ()
                in
                
# 265 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 6468 "asllib/Parser0.ml"
                
              in
              ()
            in
            
# 351 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 6476 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_x_inlined1_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 6485 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (
# 82 "asllib/Parser0.mly"
       (string)
# 6547 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 123 "<standard.mly>"
    ( None )
# 6560 "asllib/Parser0.ml"
               in
              let _1 =
                let _3 = _3_inlined2 in
                let _1 =
                  let _2 =
                    let _1_inlined1 = _1_inlined2 in
                    let x =
                      let _1 = _1_inlined1 in
                      ()
                    in
                    
# 205 "<standard.mly>"
    ( x )
# 6574 "asllib/Parser0.ml"
                    
                  in
                  ()
                in
                
# 265 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 6582 "asllib/Parser0.ml"
                
              in
              ()
            in
            
# 351 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 6590 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 6599 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = x;
          MenhirLib.EngineTypes.startp = _startpos_x_;
          MenhirLib.EngineTypes.endp = _endpos_x_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _4;
              MenhirLib.EngineTypes.startp = _startpos__4_;
              MenhirLib.EngineTypes.endp = _endpos__4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let x : (
# 82 "asllib/Parser0.mly"
       (string)
# 6663 "asllib/Parser0.ml"
        ) = Obj.magic x in
        let _2 : unit = Obj.magic _2 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (
# 82 "asllib/Parser0.mly"
       (string)
# 6672 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_x_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 126 "<standard.mly>"
    ( Some x )
# 6685 "asllib/Parser0.ml"
               in
              let _1 =
                let _3 = _3_inlined2 in
                let _1 =
                  let _2 =
                    let _1_inlined1 = _1_inlined2 in
                    let x =
                      let _1 = _1_inlined1 in
                      ()
                    in
                    
# 205 "<standard.mly>"
    ( x )
# 6699 "asllib/Parser0.ml"
                    
                  in
                  ()
                in
                
# 265 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 6707 "asllib/Parser0.ml"
                
              in
              ()
            in
            
# 351 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 6715 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_x_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 6724 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _2_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = q;
                      MenhirLib.EngineTypes.startp = _startpos_q_;
                      MenhirLib.EngineTypes.endp = _endpos_q_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (
# 82 "asllib/Parser0.mly"
       (string)
# 6798 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 6804 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 123 "<standard.mly>"
    ( None )
# 6817 "asllib/Parser0.ml"
               in
              let _1 =
                let (_3, _2) = (_3_inlined2, _2_inlined1) in
                let _1 =
                  let _2 =
                    let _1_inlined1 = _1_inlined2 in
                    let x =
                      let _1 = _1_inlined1 in
                      let _1 =
                        let i = _1 in
                        
# 339 "asllib/Parser0.mly"
                                   ( q ^ "_" ^ i )
# 6831 "asllib/Parser0.ml"
                        
                      in
                      ()
                    in
                    
# 205 "<standard.mly>"
    ( x )
# 6839 "asllib/Parser0.ml"
                    
                  in
                  ()
                in
                
# 265 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 6847 "asllib/Parser0.ml"
                
              in
              ()
            in
            
# 351 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 6855 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 6864 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = x;
          MenhirLib.EngineTypes.startp = _startpos_x_;
          MenhirLib.EngineTypes.endp = _endpos_x_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _4;
              MenhirLib.EngineTypes.startp = _startpos__4_;
              MenhirLib.EngineTypes.endp = _endpos__4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _2_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = q;
                        MenhirLib.EngineTypes.startp = _startpos_q_;
                        MenhirLib.EngineTypes.endp = _endpos_q_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let x : (
# 82 "asllib/Parser0.mly"
       (string)
# 6940 "asllib/Parser0.ml"
        ) = Obj.magic x in
        let _2 : unit = Obj.magic _2 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (
# 82 "asllib/Parser0.mly"
       (string)
# 6949 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 6955 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_x_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 126 "<standard.mly>"
    ( Some x )
# 6968 "asllib/Parser0.ml"
               in
              let _1 =
                let (_3, _2) = (_3_inlined2, _2_inlined1) in
                let _1 =
                  let _2 =
                    let _1_inlined1 = _1_inlined2 in
                    let x =
                      let _1 = _1_inlined1 in
                      let _1 =
                        let i = _1 in
                        
# 339 "asllib/Parser0.mly"
                                   ( q ^ "_" ^ i )
# 6982 "asllib/Parser0.ml"
                        
                      in
                      ()
                    in
                    
# 205 "<standard.mly>"
    ( x )
# 6990 "asllib/Parser0.ml"
                    
                  in
                  ()
                in
                
# 265 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 6998 "asllib/Parser0.ml"
                
              in
              ()
            in
            
# 351 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 7006 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_x_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 7015 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__3_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__3_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _2_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3_inlined3 : unit = Obj.magic _3_inlined3 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _3_inlined1 : (AST.expr) = Obj.magic _3_inlined1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined2 : (AST.expr) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 123 "<standard.mly>"
    ( None )
# 7100 "asllib/Parser0.ml"
               in
              let _1 =
                let (_3, _2) = (_3_inlined3, _2_inlined1) in
                let _1 =
                  let _2 =
                    let _1_inlined1 = _1_inlined2 in
                    let x =
                      let (_3, _1) = (_3_inlined1, _1_inlined1) in
                      ()
                    in
                    
# 205 "<standard.mly>"
    ( x )
# 7114 "asllib/Parser0.ml"
                    
                  in
                  ()
                in
                
# 265 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 7122 "asllib/Parser0.ml"
                
              in
              ()
            in
            
# 351 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 7130 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 7139 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = x;
          MenhirLib.EngineTypes.startp = _startpos_x_;
          MenhirLib.EngineTypes.endp = _endpos_x_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _4;
              MenhirLib.EngineTypes.startp = _startpos__4_;
              MenhirLib.EngineTypes.endp = _endpos__4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__3_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__3_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _2_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let x : (
# 82 "asllib/Parser0.mly"
       (string)
# 7215 "asllib/Parser0.ml"
        ) = Obj.magic x in
        let _2 : unit = Obj.magic _2 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3_inlined3 : unit = Obj.magic _3_inlined3 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _3_inlined1 : (AST.expr) = Obj.magic _3_inlined1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined2 : (AST.expr) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_x_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 126 "<standard.mly>"
    ( Some x )
# 7235 "asllib/Parser0.ml"
               in
              let _1 =
                let (_3, _2) = (_3_inlined3, _2_inlined1) in
                let _1 =
                  let _2 =
                    let _1_inlined1 = _1_inlined2 in
                    let x =
                      let (_3, _1) = (_3_inlined1, _1_inlined1) in
                      ()
                    in
                    
# 205 "<standard.mly>"
    ( x )
# 7249 "asllib/Parser0.ml"
                    
                  in
                  ()
                in
                
# 265 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 7257 "asllib/Parser0.ml"
                
              in
              ()
            in
            
# 351 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 7265 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_x_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 7274 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _2 : unit = Obj.magic _2 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc = 
# 359 "asllib/Parser0.mly"
          ( AST.E_Binop (BV_CONCAT, e1, e2) )
# 7315 "asllib/Parser0.ml"
           in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 7323 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v : (AST.local_decl_item) = 
# 687 "asllib/Parser0.mly"
            ( AST.LDI_Discard )
# 7349 "asllib/Parser0.ml"
         in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 7370 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v =
          let x = _1 in
          (
# 688 "asllib/Parser0.mly"
                          ( AST.LDI_Var x )
# 7380 "asllib/Parser0.ml"
           : (AST.local_decl_item))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v =
          let x = 
# 344 "asllib/Parser0.mly"
                                         ( "record" )
# 7407 "asllib/Parser0.ml"
           in
          (
# 688 "asllib/Parser0.mly"
                          ( AST.LDI_Var x )
# 7412 "asllib/Parser0.ml"
           : (AST.local_decl_item))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2;
              MenhirLib.EngineTypes.startp = _startpos__2_;
              MenhirLib.EngineTypes.endp = _endpos__2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = h;
                MenhirLib.EngineTypes.startp = _startpos_h_;
                MenhirLib.EngineTypes.endp = _endpos_h_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (AST.local_decl_item list) = Obj.magic _1_inlined1 in
        let _2 : unit = Obj.magic _2 in
        let h : (AST.local_decl_item) = Obj.magic h in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__3_ in
        let _v =
          let ldis =
            let x =
              let _1 = _1_inlined1 in
              let t = _1 in
              
# 301 "asllib/Parser0.mly"
                                           ( h::t )
# 7471 "asllib/Parser0.ml"
              
            in
            
# 205 "<standard.mly>"
    ( x )
# 7477 "asllib/Parser0.ml"
            
          in
          (
# 691 "asllib/Parser0.mly"
                                           ( AST.LDI_Tuple ldis )
# 7483 "asllib/Parser0.ml"
           : (AST.local_decl_item))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v =
          let desc = 
# 665 "asllib/Parser0.mly"
                    ( AST.LE_Discard )
# 7510 "asllib/Parser0.ml"
           in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 7518 "asllib/Parser0.ml"
           : (AST.lexpr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = q;
              MenhirLib.EngineTypes.startp = _startpos_q_;
              MenhirLib.EngineTypes.endp = _endpos_q_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 7552 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 7558 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos__1_ in
        let _v =
          let desc =
            let qualident =
              let i = _1 in
              
# 347 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 7570 "asllib/Parser0.ml"
              
            in
            
# 664 "asllib/Parser0.mly"
                             AST.LE_Var  
# 7576 "asllib/Parser0.ml"
             qualident
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos_q_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 7585 "asllib/Parser0.ml"
           : (AST.lexpr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 7607 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v =
          let desc =
            let qualident = _1 in
            
# 664 "asllib/Parser0.mly"
                             AST.LE_Var  
# 7618 "asllib/Parser0.ml"
             qualident
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 7627 "asllib/Parser0.ml"
           : (AST.lexpr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v =
          let desc =
            let qualident = 
# 349 "asllib/Parser0.mly"
              ( "record" )
# 7655 "asllib/Parser0.ml"
             in
            
# 664 "asllib/Parser0.mly"
                             AST.LE_Var  
# 7660 "asllib/Parser0.ml"
             qualident
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 7669 "asllib/Parser0.ml"
           : (AST.lexpr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = lexpr;
              MenhirLib.EngineTypes.startp = _startpos_lexpr_;
              MenhirLib.EngineTypes.endp = _endpos_lexpr_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let _1 : unit = Obj.magic _1 in
        let lexpr : (AST.lexpr) = Obj.magic lexpr in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_lexpr_ in
        let _endpos = _endpos__3_ in
        let _v =
          let desc =
            let _2 =
              let x = 
# 298 "asllib/Parser0.mly"
                ( [] )
# 7712 "asllib/Parser0.ml"
               in
              
# 205 "<standard.mly>"
    ( x )
# 7717 "asllib/Parser0.ml"
              
            in
            let _2_1 = _2 in
            
# 675 "asllib/Parser0.mly"
                                                 AST.LE_Slice        
# 7724 "asllib/Parser0.ml"
             (lexpr, _2_1)
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos_lexpr_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 7733 "asllib/Parser0.ml"
           : (AST.lexpr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = lexpr;
                MenhirLib.EngineTypes.startp = _startpos_lexpr_;
                MenhirLib.EngineTypes.endp = _endpos_lexpr_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (AST.slice list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let lexpr : (AST.lexpr) = Obj.magic lexpr in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_lexpr_ in
        let _endpos = _endpos__3_ in
        let _v =
          let desc =
            let _2 =
              let x = _1_inlined1 in
              
# 205 "<standard.mly>"
    ( x )
# 7784 "asllib/Parser0.ml"
              
            in
            let _2_1 = _2 in
            
# 675 "asllib/Parser0.mly"
                                                 AST.LE_Slice        
# 7791 "asllib/Parser0.ml"
             (lexpr, _2_1)
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos_lexpr_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 7800 "asllib/Parser0.ml"
           : (AST.lexpr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _4;
          MenhirLib.EngineTypes.startp = _startpos__4_;
          MenhirLib.EngineTypes.endp = _endpos__4_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = lexpr;
              MenhirLib.EngineTypes.startp = _startpos_lexpr_;
              MenhirLib.EngineTypes.endp = _endpos_lexpr_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _4 : unit = Obj.magic _4 in
        let _2 : unit = Obj.magic _2 in
        let lexpr : (AST.lexpr) = Obj.magic lexpr in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_lexpr_ in
        let _endpos = _endpos__4_ in
        let _v =
          let desc =
            let _3 = 
# 298 "asllib/Parser0.mly"
                ( [] )
# 7842 "asllib/Parser0.ml"
             in
            let _3_1 = _3 in
            
# 676 "asllib/Parser0.mly"
                                                 AST.LE_Slice        
# 7848 "asllib/Parser0.ml"
             (lexpr, _3_1)
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos_lexpr_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 7857 "asllib/Parser0.ml"
           : (AST.lexpr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _4;
          MenhirLib.EngineTypes.startp = _startpos__4_;
          MenhirLib.EngineTypes.endp = _endpos__4_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2;
              MenhirLib.EngineTypes.startp = _startpos__2_;
              MenhirLib.EngineTypes.endp = _endpos__2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = lexpr;
                MenhirLib.EngineTypes.startp = _startpos_lexpr_;
                MenhirLib.EngineTypes.endp = _endpos_lexpr_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let _4 : unit = Obj.magic _4 in
        let _1 : (AST.slice list) = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let lexpr : (AST.lexpr) = Obj.magic lexpr in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_lexpr_ in
        let _endpos = _endpos__4_ in
        let _v =
          let desc =
            let _3 = _1 in
            let _3_1 = _3 in
            
# 676 "asllib/Parser0.mly"
                                                 AST.LE_Slice        
# 7908 "asllib/Parser0.ml"
             (lexpr, _3_1)
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos_lexpr_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 7917 "asllib/Parser0.ml"
           : (AST.lexpr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (AST.lexpr list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__3_ in
        let _v =
          let desc =
            let _1 =
              let x = _1_inlined1 in
              
# 205 "<standard.mly>"
    ( x )
# 7961 "asllib/Parser0.ml"
              
            in
            let _1_1 = _1 in
            
# 677 "asllib/Parser0.mly"
                                                 AST.LE_Destructuring  
# 7968 "asllib/Parser0.ml"
             _1_1
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 7977 "asllib/Parser0.ml"
           : (AST.lexpr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = lexpr;
              MenhirLib.EngineTypes.startp = _startpos_lexpr_;
              MenhirLib.EngineTypes.endp = _endpos_lexpr_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 8011 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let lexpr : (AST.lexpr) = Obj.magic lexpr in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_lexpr_ in
        let _endpos = _endpos__1_ in
        let _v =
          let desc =
            let ident = _1 in
            
# 678 "asllib/Parser0.mly"
                                                 AST.LE_SetField     
# 8024 "asllib/Parser0.ml"
             (lexpr, ident)
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos_lexpr_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 8033 "asllib/Parser0.ml"
           : (AST.lexpr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2;
              MenhirLib.EngineTypes.startp = _startpos__2_;
              MenhirLib.EngineTypes.endp = _endpos__2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = l;
                MenhirLib.EngineTypes.startp = _startpos_l_;
                MenhirLib.EngineTypes.endp = _endpos_l_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let _1 : unit = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let l : (AST.lexpr) = Obj.magic l in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_l_ in
        let _endpos = _endpos__3_ in
        let _v =
          let desc =
            let f =
              let x = 
# 298 "asllib/Parser0.mly"
                ( [] )
# 8083 "asllib/Parser0.ml"
               in
              
# 205 "<standard.mly>"
    ( x )
# 8088 "asllib/Parser0.ml"
              
            in
            
# 679 "asllib/Parser0.mly"
                                               ( AST.LE_SetFields (l, f, []) )
# 8094 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos_l_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 8103 "asllib/Parser0.ml"
           : (AST.lexpr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = l;
                  MenhirLib.EngineTypes.startp = _startpos_l_;
                  MenhirLib.EngineTypes.endp = _endpos_l_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (string list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let l : (AST.lexpr) = Obj.magic l in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_l_ in
        let _endpos = _endpos__3_ in
        let _v =
          let desc =
            let f =
              let x = _1_inlined1 in
              
# 205 "<standard.mly>"
    ( x )
# 8161 "asllib/Parser0.ml"
              
            in
            
# 679 "asllib/Parser0.mly"
                                               ( AST.LE_SetFields (l, f, []) )
# 8167 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos_l_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 8176 "asllib/Parser0.ml"
           : (AST.lexpr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (AST.lexpr list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__3_ in
        let _v =
          let desc =
            let _2 = 
# 665 "asllib/Parser0.mly"
                    ( AST.LE_Discard )
# 8218 "asllib/Parser0.ml"
             in
            let _1 =
              let _1 =
                let x = _1_inlined1 in
                
# 205 "<standard.mly>"
    ( x )
# 8226 "asllib/Parser0.ml"
                
              in
              ()
            in
            _2
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 8239 "asllib/Parser0.ml"
           : (AST.lexpr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let _menhir_s = _menhir_env.MenhirLib.EngineTypes.current in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _endpos = _startpos in
        let _v : (unit list) = 
# 216 "<standard.mly>"
    ( [] )
# 8258 "asllib/Parser0.ml"
         in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = x;
            MenhirLib.EngineTypes.startp = _startpos_x_;
            MenhirLib.EngineTypes.endp = _endpos_x_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let xs : (unit list) = Obj.magic xs in
        let x : unit = Obj.magic x in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_x_ in
        let _endpos = _endpos_xs_ in
        let _v : (unit list) = 
# 219 "<standard.mly>"
    ( x :: xs )
# 8290 "asllib/Parser0.ml"
         in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let _menhir_s = _menhir_env.MenhirLib.EngineTypes.current in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _endpos = _startpos in
        let _v : (AST.case_alt list) = 
# 216 "<standard.mly>"
    ( [] )
# 8308 "asllib/Parser0.ml"
         in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.case_alt list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.pattern list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let stmt =
                let (_1_inlined1, _1) = (_1_inlined3, _1_inlined2) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 604 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 8382 "asllib/Parser0.ml"
                 _3_1
              in
              let where = 
# 731 "asllib/Parser0.mly"
    ( None )
# 8388 "asllib/Parser0.ml"
               in
              let pattern =
                let (_endpos__1_, _startpos__1_, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined1) in
                let desc =
                  let _1_1 = _1 in
                  
# 738 "asllib/Parser0.mly"
                                                   AST.Pattern_Any  
# 8397 "asllib/Parser0.ml"
                   _1_1
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 8406 "asllib/Parser0.ml"
                
              in
              
# 723 "asllib/Parser0.mly"
        ( AST.{ pattern; where; stmt } )
# 8412 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 8421 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 8427 "asllib/Parser0.ml"
           : (AST.case_alt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined5;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined4;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = expr;
                    MenhirLib.EngineTypes.startp = _startpos_expr_;
                    MenhirLib.EngineTypes.endp = _endpos_expr_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined3;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.case_alt list) = Obj.magic xs in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined5 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined5 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.pattern list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let stmt =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let _1 = _1_inlined2 in
                        let _2 = 
# 123 "<standard.mly>"
    ( None )
# 8527 "asllib/Parser0.ml"
                         in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 698 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 8534 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 8543 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 695 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 8549 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 8558 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 8566 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 621 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 8572 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 8581 "asllib/Parser0.ml"
                
              in
              let where = 
# 731 "asllib/Parser0.mly"
    ( None )
# 8587 "asllib/Parser0.ml"
               in
              let pattern =
                let (_endpos__1_, _startpos__1_, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined1) in
                let desc =
                  let _1_1 = _1 in
                  
# 738 "asllib/Parser0.mly"
                                                   AST.Pattern_Any  
# 8596 "asllib/Parser0.ml"
                   _1_1
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 8605 "asllib/Parser0.ml"
                
              in
              
# 723 "asllib/Parser0.mly"
        ( AST.{ pattern; where; stmt } )
# 8611 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 8620 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 8626 "asllib/Parser0.ml"
           : (AST.case_alt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined7;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined6;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined5;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined4;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3;
                      MenhirLib.EngineTypes.startp = _startpos__3_;
                      MenhirLib.EngineTypes.endp = _endpos__3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = expr;
                        MenhirLib.EngineTypes.startp = _startpos_expr_;
                        MenhirLib.EngineTypes.endp = _endpos_expr_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined3;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined2;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _menhir_s;
                                MenhirLib.EngineTypes.semv = _1;
                                MenhirLib.EngineTypes.startp = _startpos__1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_;
                                MenhirLib.EngineTypes.next = _menhir_stack;
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.case_alt list) = Obj.magic xs in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined7 : (AST.stmt list) = Obj.magic _1_inlined7 in
        let _1_inlined6 : unit = Obj.magic _1_inlined6 in
        let _1_inlined5 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined5 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.pattern list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let stmt =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined7, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                        let _2 =
                          let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                          let x =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 8745 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 126 "<standard.mly>"
    ( Some x )
# 8751 "asllib/Parser0.ml"
                          
                        in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 698 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 8759 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 8768 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 695 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 8774 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 8783 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 8791 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 621 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 8797 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 8806 "asllib/Parser0.ml"
                
              in
              let where = 
# 731 "asllib/Parser0.mly"
    ( None )
# 8812 "asllib/Parser0.ml"
               in
              let pattern =
                let (_endpos__1_, _startpos__1_, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined1) in
                let desc =
                  let _1_1 = _1 in
                  
# 738 "asllib/Parser0.mly"
                                                   AST.Pattern_Any  
# 8821 "asllib/Parser0.ml"
                   _1_1
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 8830 "asllib/Parser0.ml"
                
              in
              
# 723 "asllib/Parser0.mly"
        ( AST.{ pattern; where; stmt } )
# 8836 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 8845 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 8851 "asllib/Parser0.ml"
           : (AST.case_alt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.case_alt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.pattern list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let stmt =
                let _1 = _1_inlined2 in
                let x =
                  let _1_1 = _1 in
                  
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 8912 "asllib/Parser0.ml"
                   _1_1
                in
                
# 196 "<standard.mly>"
    ( x )
# 8918 "asllib/Parser0.ml"
                
              in
              let where = 
# 731 "asllib/Parser0.mly"
    ( None )
# 8924 "asllib/Parser0.ml"
               in
              let pattern =
                let (_endpos__1_, _startpos__1_, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined1) in
                let desc =
                  let _1_1 = _1 in
                  
# 738 "asllib/Parser0.mly"
                                                   AST.Pattern_Any  
# 8933 "asllib/Parser0.ml"
                   _1_1
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 8942 "asllib/Parser0.ml"
                
              in
              
# 723 "asllib/Parser0.mly"
        ( AST.{ pattern; where; stmt } )
# 8948 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 8957 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 8963 "asllib/Parser0.ml"
           : (AST.case_alt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined2;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = _1;
                MenhirLib.EngineTypes.startp = _startpos__1_;
                MenhirLib.EngineTypes.endp = _endpos__1_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.case_alt list) = Obj.magic xs in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.pattern list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let stmt =
                let _1 = _1_inlined2 in
                
# 597 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 9015 "asllib/Parser0.ml"
                
              in
              let where = 
# 731 "asllib/Parser0.mly"
    ( None )
# 9021 "asllib/Parser0.ml"
               in
              let pattern =
                let (_endpos__1_, _startpos__1_, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined1) in
                let desc =
                  let _1_1 = _1 in
                  
# 738 "asllib/Parser0.mly"
                                                   AST.Pattern_Any  
# 9030 "asllib/Parser0.ml"
                   _1_1
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 9039 "asllib/Parser0.ml"
                
              in
              
# 723 "asllib/Parser0.mly"
        ( AST.{ pattern; where; stmt } )
# 9045 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 9054 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 9060 "asllib/Parser0.ml"
           : (AST.case_alt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _2;
                    MenhirLib.EngineTypes.startp = _startpos__2_;
                    MenhirLib.EngineTypes.endp = _endpos__2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.case_alt list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (AST.pattern list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let stmt =
                let (_1_inlined1, _2, _1) = (_1_inlined3, _2_inlined1, _1_inlined2) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 604 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 9142 "asllib/Parser0.ml"
                 _3_1
              in
              let where = 
# 123 "<standard.mly>"
    ( None )
# 9148 "asllib/Parser0.ml"
               in
              let pattern =
                let (_endpos__1_, _startpos__1_, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined1) in
                let desc =
                  let _1_1 = _1 in
                  
# 738 "asllib/Parser0.mly"
                                                   AST.Pattern_Any  
# 9157 "asllib/Parser0.ml"
                   _1_1
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 9166 "asllib/Parser0.ml"
                
              in
              
# 723 "asllib/Parser0.mly"
        ( AST.{ pattern; where; stmt } )
# 9172 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 9181 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 9187 "asllib/Parser0.ml"
           : (AST.case_alt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined5;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined4;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = expr;
                    MenhirLib.EngineTypes.startp = _startpos_expr_;
                    MenhirLib.EngineTypes.endp = _endpos_expr_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined3;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _2;
                          MenhirLib.EngineTypes.startp = _startpos__2_;
                          MenhirLib.EngineTypes.endp = _endpos__2_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = _1;
                              MenhirLib.EngineTypes.startp = _startpos__1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.case_alt list) = Obj.magic xs in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined5 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined5 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (AST.pattern list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let stmt =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let _1 = _1_inlined2 in
                        let _2 = 
# 123 "<standard.mly>"
    ( None )
# 9294 "asllib/Parser0.ml"
                         in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 698 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 9301 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 9310 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 695 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 9316 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 9325 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 9333 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 621 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 9339 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 9348 "asllib/Parser0.ml"
                
              in
              let where = 
# 123 "<standard.mly>"
    ( None )
# 9354 "asllib/Parser0.ml"
               in
              let pattern =
                let (_endpos__1_, _startpos__1_, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined1) in
                let desc =
                  let _1_1 = _1 in
                  
# 738 "asllib/Parser0.mly"
                                                   AST.Pattern_Any  
# 9363 "asllib/Parser0.ml"
                   _1_1
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 9372 "asllib/Parser0.ml"
                
              in
              
# 723 "asllib/Parser0.mly"
        ( AST.{ pattern; where; stmt } )
# 9378 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 9387 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 9393 "asllib/Parser0.ml"
           : (AST.case_alt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined7;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined6;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined5;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined4;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3;
                      MenhirLib.EngineTypes.startp = _startpos__3_;
                      MenhirLib.EngineTypes.endp = _endpos__3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = expr;
                        MenhirLib.EngineTypes.startp = _startpos_expr_;
                        MenhirLib.EngineTypes.endp = _endpos_expr_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined3;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined2;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _2;
                              MenhirLib.EngineTypes.startp = _startpos__2_;
                              MenhirLib.EngineTypes.endp = _endpos__2_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined1;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _menhir_s;
                                  MenhirLib.EngineTypes.semv = _1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_;
                                  MenhirLib.EngineTypes.next = _menhir_stack;
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.case_alt list) = Obj.magic xs in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined7 : (AST.stmt list) = Obj.magic _1_inlined7 in
        let _1_inlined6 : unit = Obj.magic _1_inlined6 in
        let _1_inlined5 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined5 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (AST.pattern list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let stmt =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined7, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                        let _2 =
                          let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                          let x =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 9519 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 126 "<standard.mly>"
    ( Some x )
# 9525 "asllib/Parser0.ml"
                          
                        in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 698 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 9533 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 9542 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 695 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 9548 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 9557 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 9565 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 621 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 9571 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 9580 "asllib/Parser0.ml"
                
              in
              let where = 
# 123 "<standard.mly>"
    ( None )
# 9586 "asllib/Parser0.ml"
               in
              let pattern =
                let (_endpos__1_, _startpos__1_, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined1) in
                let desc =
                  let _1_1 = _1 in
                  
# 738 "asllib/Parser0.mly"
                                                   AST.Pattern_Any  
# 9595 "asllib/Parser0.ml"
                   _1_1
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 9604 "asllib/Parser0.ml"
                
              in
              
# 723 "asllib/Parser0.mly"
        ( AST.{ pattern; where; stmt } )
# 9610 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 9619 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 9625 "asllib/Parser0.ml"
           : (AST.case_alt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.case_alt list) = Obj.magic xs in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (AST.pattern list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let stmt =
                let _1 = _1_inlined2 in
                let x =
                  let _1_1 = _1 in
                  
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 9693 "asllib/Parser0.ml"
                   _1_1
                in
                
# 196 "<standard.mly>"
    ( x )
# 9699 "asllib/Parser0.ml"
                
              in
              let where = 
# 123 "<standard.mly>"
    ( None )
# 9705 "asllib/Parser0.ml"
               in
              let pattern =
                let (_endpos__1_, _startpos__1_, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined1) in
                let desc =
                  let _1_1 = _1 in
                  
# 738 "asllib/Parser0.mly"
                                                   AST.Pattern_Any  
# 9714 "asllib/Parser0.ml"
                   _1_1
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 9723 "asllib/Parser0.ml"
                
              in
              
# 723 "asllib/Parser0.mly"
        ( AST.{ pattern; where; stmt } )
# 9729 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_inlined1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 9738 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 9744 "asllib/Parser0.ml"
           : (AST.case_alt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined2;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2;
              MenhirLib.EngineTypes.startp = _startpos__2_;
              MenhirLib.EngineTypes.endp = _endpos__2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.case_alt list) = Obj.magic xs in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (AST.pattern list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let stmt =
                let _1 = _1_inlined2 in
                
# 597 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 9803 "asllib/Parser0.ml"
                
              in
              let where = 
# 123 "<standard.mly>"
    ( None )
# 9809 "asllib/Parser0.ml"
               in
              let pattern =
                let (_endpos__1_, _startpos__1_, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined1) in
                let desc =
                  let _1_1 = _1 in
                  
# 738 "asllib/Parser0.mly"
                                                   AST.Pattern_Any  
# 9818 "asllib/Parser0.ml"
                   _1_1
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 9827 "asllib/Parser0.ml"
                
              in
              
# 723 "asllib/Parser0.mly"
        ( AST.{ pattern; where; stmt } )
# 9833 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 9842 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 9848 "asllib/Parser0.ml"
           : (AST.case_alt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _2;
                    MenhirLib.EngineTypes.startp = _startpos__2_;
                    MenhirLib.EngineTypes.endp = _endpos__2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _2_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.case_alt list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _2_inlined2 : unit = Obj.magic _2_inlined2 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _2 : unit = Obj.magic _2 in
        let _2_inlined1 : (AST.expr) = Obj.magic _2_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.pattern list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let stmt =
                let (_1_inlined1, _2, _1) = (_1_inlined4, _2_inlined2, _1_inlined3) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 604 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 9944 "asllib/Parser0.ml"
                 _3_1
              in
              let where =
                let _1 = _1_inlined2 in
                let _2 = _2_inlined1 in
                let x = _2 in
                
# 126 "<standard.mly>"
    ( Some x )
# 9954 "asllib/Parser0.ml"
                
              in
              let pattern =
                let (_endpos__1_, _startpos__1_, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined1) in
                let desc =
                  let _1_1 = _1 in
                  
# 738 "asllib/Parser0.mly"
                                                   AST.Pattern_Any  
# 9964 "asllib/Parser0.ml"
                   _1_1
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 9973 "asllib/Parser0.ml"
                
              in
              
# 723 "asllib/Parser0.mly"
        ( AST.{ pattern; where; stmt } )
# 9979 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 9988 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 9994 "asllib/Parser0.ml"
           : (AST.case_alt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined6;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined5;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = expr;
                    MenhirLib.EngineTypes.startp = _startpos_expr_;
                    MenhirLib.EngineTypes.endp = _endpos_expr_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined4;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined3;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _2;
                          MenhirLib.EngineTypes.startp = _startpos__2_;
                          MenhirLib.EngineTypes.endp = _endpos__2_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _2_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined2;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined1;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _menhir_s;
                                  MenhirLib.EngineTypes.semv = _1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_;
                                  MenhirLib.EngineTypes.next = _menhir_stack;
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.case_alt list) = Obj.magic xs in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined6 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined6 in
        let _1_inlined5 : (AST.stmt list) = Obj.magic _1_inlined5 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _2 : unit = Obj.magic _2 in
        let _2_inlined1 : (AST.expr) = Obj.magic _2_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.pattern list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let stmt =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined4_, _startpos__1_inlined3_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let _1 = _1_inlined2 in
                        let _2 = 
# 123 "<standard.mly>"
    ( None )
# 10115 "asllib/Parser0.ml"
                         in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 698 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 10122 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 10131 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 695 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 10137 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 10146 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 10154 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 621 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 10160 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 10169 "asllib/Parser0.ml"
                
              in
              let where =
                let _1 = _1_inlined2 in
                let _2 = _2_inlined1 in
                let x = _2 in
                
# 126 "<standard.mly>"
    ( Some x )
# 10179 "asllib/Parser0.ml"
                
              in
              let pattern =
                let (_endpos__1_, _startpos__1_, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined1) in
                let desc =
                  let _1_1 = _1 in
                  
# 738 "asllib/Parser0.mly"
                                                   AST.Pattern_Any  
# 10189 "asllib/Parser0.ml"
                   _1_1
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 10198 "asllib/Parser0.ml"
                
              in
              
# 723 "asllib/Parser0.mly"
        ( AST.{ pattern; where; stmt } )
# 10204 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 10213 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 10219 "asllib/Parser0.ml"
           : (AST.case_alt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined8;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined7;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined6;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined5;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3;
                      MenhirLib.EngineTypes.startp = _startpos__3_;
                      MenhirLib.EngineTypes.endp = _endpos__3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = expr;
                        MenhirLib.EngineTypes.startp = _startpos_expr_;
                        MenhirLib.EngineTypes.endp = _endpos_expr_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined4;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined3;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _2;
                              MenhirLib.EngineTypes.startp = _startpos__2_;
                              MenhirLib.EngineTypes.endp = _endpos__2_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _2_inlined1;
                                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _1_inlined2;
                                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _1_inlined1;
                                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _menhir_s;
                                      MenhirLib.EngineTypes.semv = _1;
                                      MenhirLib.EngineTypes.startp = _startpos__1_;
                                      MenhirLib.EngineTypes.endp = _endpos__1_;
                                      MenhirLib.EngineTypes.next = _menhir_stack;
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.case_alt list) = Obj.magic xs in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined8 : (AST.stmt list) = Obj.magic _1_inlined8 in
        let _1_inlined7 : unit = Obj.magic _1_inlined7 in
        let _1_inlined6 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined6 in
        let _1_inlined5 : (AST.stmt list) = Obj.magic _1_inlined5 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _2 : unit = Obj.magic _2 in
        let _2_inlined1 : (AST.expr) = Obj.magic _2_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.pattern list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let stmt =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined4_, _startpos__1_inlined3_, _1_inlined8, _1_inlined7, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                        let _2 =
                          let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                          let x =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 10359 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 126 "<standard.mly>"
    ( Some x )
# 10365 "asllib/Parser0.ml"
                          
                        in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 698 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 10373 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 10382 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 695 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 10388 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 10397 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 10405 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 621 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 10411 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 10420 "asllib/Parser0.ml"
                
              in
              let where =
                let _1 = _1_inlined2 in
                let _2 = _2_inlined1 in
                let x = _2 in
                
# 126 "<standard.mly>"
    ( Some x )
# 10430 "asllib/Parser0.ml"
                
              in
              let pattern =
                let (_endpos__1_, _startpos__1_, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined1) in
                let desc =
                  let _1_1 = _1 in
                  
# 738 "asllib/Parser0.mly"
                                                   AST.Pattern_Any  
# 10440 "asllib/Parser0.ml"
                   _1_1
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 10449 "asllib/Parser0.ml"
                
              in
              
# 723 "asllib/Parser0.mly"
        ( AST.{ pattern; where; stmt } )
# 10455 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 10464 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 10470 "asllib/Parser0.ml"
           : (AST.case_alt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2_inlined2;
            MenhirLib.EngineTypes.startp = _startpos__2_inlined2_;
            MenhirLib.EngineTypes.endp = _endpos__2_inlined2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _2_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.case_alt list) = Obj.magic xs in
        let _2_inlined2 : unit = Obj.magic _2_inlined2 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _2 : unit = Obj.magic _2 in
        let _2_inlined1 : (AST.expr) = Obj.magic _2_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.pattern list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let stmt =
                let _1 = _1_inlined3 in
                let x =
                  let _1_1 = _1 in
                  
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 10552 "asllib/Parser0.ml"
                   _1_1
                in
                
# 196 "<standard.mly>"
    ( x )
# 10558 "asllib/Parser0.ml"
                
              in
              let where =
                let _1 = _1_inlined2 in
                let _2 = _2_inlined1 in
                let x = _2 in
                
# 126 "<standard.mly>"
    ( Some x )
# 10568 "asllib/Parser0.ml"
                
              in
              let pattern =
                let (_endpos__1_, _startpos__1_, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined1) in
                let desc =
                  let _1_1 = _1 in
                  
# 738 "asllib/Parser0.mly"
                                                   AST.Pattern_Any  
# 10578 "asllib/Parser0.ml"
                   _1_1
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 10587 "asllib/Parser0.ml"
                
              in
              
# 723 "asllib/Parser0.mly"
        ( AST.{ pattern; where; stmt } )
# 10593 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_inlined2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 10602 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 10608 "asllib/Parser0.ml"
           : (AST.case_alt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined3;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2;
              MenhirLib.EngineTypes.startp = _startpos__2_;
              MenhirLib.EngineTypes.endp = _endpos__2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.case_alt list) = Obj.magic xs in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _2 : unit = Obj.magic _2 in
        let _2_inlined1 : (AST.expr) = Obj.magic _2_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.pattern list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let stmt =
                let _1 = _1_inlined3 in
                
# 597 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 10681 "asllib/Parser0.ml"
                
              in
              let where =
                let _1 = _1_inlined2 in
                let _2 = _2_inlined1 in
                let x = _2 in
                
# 126 "<standard.mly>"
    ( Some x )
# 10691 "asllib/Parser0.ml"
                
              in
              let pattern =
                let (_endpos__1_, _startpos__1_, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined1) in
                let desc =
                  let _1_1 = _1 in
                  
# 738 "asllib/Parser0.mly"
                                                   AST.Pattern_Any  
# 10701 "asllib/Parser0.ml"
                   _1_1
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 10710 "asllib/Parser0.ml"
                
              in
              
# 723 "asllib/Parser0.mly"
        ( AST.{ pattern; where; stmt } )
# 10716 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined3_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 10725 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 10731 "asllib/Parser0.ml"
           : (AST.case_alt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = expr;
                    MenhirLib.EngineTypes.startp = _startpos_expr_;
                    MenhirLib.EngineTypes.endp = _endpos_expr_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.case_alt list) = Obj.magic xs in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.pattern list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let stmt =
                let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _1_inlined4, _1_inlined3, _1_inlined2) in
                let desc =
                  let simple_else_opt =
                    let _1 = _1_inlined2 in
                    let _2 = 
# 123 "<standard.mly>"
    ( None )
# 10821 "asllib/Parser0.ml"
                     in
                    let _1_1 = _1 in
                    let _2_1 = _2 in
                    
# 698 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 10828 "asllib/Parser0.ml"
                     (_1_1, _2_1)
                  in
                  let simple_stmt_list =
                    let _1 = _1_inlined1 in
                    let _1_1 = _1 in
                    
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 10837 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 695 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 10843 "asllib/Parser0.ml"
                   (expr, simple_stmt_list, simple_else_opt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 10852 "asllib/Parser0.ml"
                
              in
              let where = 
# 731 "asllib/Parser0.mly"
    ( None )
# 10858 "asllib/Parser0.ml"
               in
              let pattern =
                let (_endpos__1_, _startpos__1_, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined1) in
                let desc =
                  let _1_1 = _1 in
                  
# 738 "asllib/Parser0.mly"
                                                   AST.Pattern_Any  
# 10867 "asllib/Parser0.ml"
                   _1_1
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 10876 "asllib/Parser0.ml"
                
              in
              
# 725 "asllib/Parser0.mly"
        ( AST.{ pattern; where; stmt } )
# 10882 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 10891 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 10897 "asllib/Parser0.ml"
           : (AST.case_alt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined6;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined5;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined4;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined3;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3;
                      MenhirLib.EngineTypes.startp = _startpos__3_;
                      MenhirLib.EngineTypes.endp = _endpos__3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = expr;
                        MenhirLib.EngineTypes.startp = _startpos_expr_;
                        MenhirLib.EngineTypes.endp = _endpos_expr_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined2;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = _1;
                              MenhirLib.EngineTypes.startp = _startpos__1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.case_alt list) = Obj.magic xs in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.pattern list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let stmt =
                let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2) in
                let desc =
                  let simple_else_opt =
                    let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                    let _2 =
                      let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                      let x =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 11006 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 126 "<standard.mly>"
    ( Some x )
# 11012 "asllib/Parser0.ml"
                      
                    in
                    let _1_1 = _1 in
                    let _2_1 = _2 in
                    
# 698 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 11020 "asllib/Parser0.ml"
                     (_1_1, _2_1)
                  in
                  let simple_stmt_list =
                    let _1 = _1_inlined1 in
                    let _1_1 = _1 in
                    
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 11029 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 695 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 11035 "asllib/Parser0.ml"
                   (expr, simple_stmt_list, simple_else_opt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 11044 "asllib/Parser0.ml"
                
              in
              let where = 
# 731 "asllib/Parser0.mly"
    ( None )
# 11050 "asllib/Parser0.ml"
               in
              let pattern =
                let (_endpos__1_, _startpos__1_, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined1) in
                let desc =
                  let _1_1 = _1 in
                  
# 738 "asllib/Parser0.mly"
                                                   AST.Pattern_Any  
# 11059 "asllib/Parser0.ml"
                   _1_1
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 11068 "asllib/Parser0.ml"
                
              in
              
# 725 "asllib/Parser0.mly"
        ( AST.{ pattern; where; stmt } )
# 11074 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 11083 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 11089 "asllib/Parser0.ml"
           : (AST.case_alt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = expr;
                    MenhirLib.EngineTypes.startp = _startpos_expr_;
                    MenhirLib.EngineTypes.endp = _endpos_expr_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _2;
                        MenhirLib.EngineTypes.startp = _startpos__2_;
                        MenhirLib.EngineTypes.endp = _endpos__2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.case_alt list) = Obj.magic xs in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (AST.pattern list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let stmt =
                let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _1_inlined4, _1_inlined3, _1_inlined2) in
                let desc =
                  let simple_else_opt =
                    let _1 = _1_inlined2 in
                    let _2 = 
# 123 "<standard.mly>"
    ( None )
# 11186 "asllib/Parser0.ml"
                     in
                    let _1_1 = _1 in
                    let _2_1 = _2 in
                    
# 698 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 11193 "asllib/Parser0.ml"
                     (_1_1, _2_1)
                  in
                  let simple_stmt_list =
                    let _1 = _1_inlined1 in
                    let _1_1 = _1 in
                    
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 11202 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 695 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 11208 "asllib/Parser0.ml"
                   (expr, simple_stmt_list, simple_else_opt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 11217 "asllib/Parser0.ml"
                
              in
              let where = 
# 123 "<standard.mly>"
    ( None )
# 11223 "asllib/Parser0.ml"
               in
              let pattern =
                let (_endpos__1_, _startpos__1_, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined1) in
                let desc =
                  let _1_1 = _1 in
                  
# 738 "asllib/Parser0.mly"
                                                   AST.Pattern_Any  
# 11232 "asllib/Parser0.ml"
                   _1_1
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 11241 "asllib/Parser0.ml"
                
              in
              
# 725 "asllib/Parser0.mly"
        ( AST.{ pattern; where; stmt } )
# 11247 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 11256 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 11262 "asllib/Parser0.ml"
           : (AST.case_alt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined6;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined5;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined4;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined3;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3;
                      MenhirLib.EngineTypes.startp = _startpos__3_;
                      MenhirLib.EngineTypes.endp = _endpos__3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = expr;
                        MenhirLib.EngineTypes.startp = _startpos_expr_;
                        MenhirLib.EngineTypes.endp = _endpos_expr_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined2;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _2;
                            MenhirLib.EngineTypes.startp = _startpos__2_;
                            MenhirLib.EngineTypes.endp = _endpos__2_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _menhir_s;
                                MenhirLib.EngineTypes.semv = _1;
                                MenhirLib.EngineTypes.startp = _startpos__1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_;
                                MenhirLib.EngineTypes.next = _menhir_stack;
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.case_alt list) = Obj.magic xs in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (AST.pattern list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let stmt =
                let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2) in
                let desc =
                  let simple_else_opt =
                    let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                    let _2 =
                      let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                      let x =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 11378 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 126 "<standard.mly>"
    ( Some x )
# 11384 "asllib/Parser0.ml"
                      
                    in
                    let _1_1 = _1 in
                    let _2_1 = _2 in
                    
# 698 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 11392 "asllib/Parser0.ml"
                     (_1_1, _2_1)
                  in
                  let simple_stmt_list =
                    let _1 = _1_inlined1 in
                    let _1_1 = _1 in
                    
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 11401 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 695 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 11407 "asllib/Parser0.ml"
                   (expr, simple_stmt_list, simple_else_opt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 11416 "asllib/Parser0.ml"
                
              in
              let where = 
# 123 "<standard.mly>"
    ( None )
# 11422 "asllib/Parser0.ml"
               in
              let pattern =
                let (_endpos__1_, _startpos__1_, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined1) in
                let desc =
                  let _1_1 = _1 in
                  
# 738 "asllib/Parser0.mly"
                                                   AST.Pattern_Any  
# 11431 "asllib/Parser0.ml"
                   _1_1
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 11440 "asllib/Parser0.ml"
                
              in
              
# 725 "asllib/Parser0.mly"
        ( AST.{ pattern; where; stmt } )
# 11446 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 11455 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 11461 "asllib/Parser0.ml"
           : (AST.case_alt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined5;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined4;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = expr;
                    MenhirLib.EngineTypes.startp = _startpos_expr_;
                    MenhirLib.EngineTypes.endp = _endpos_expr_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined3;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _2;
                        MenhirLib.EngineTypes.startp = _startpos__2_;
                        MenhirLib.EngineTypes.endp = _endpos__2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _2_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined2;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _menhir_s;
                                MenhirLib.EngineTypes.semv = _1;
                                MenhirLib.EngineTypes.startp = _startpos__1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_;
                                MenhirLib.EngineTypes.next = _menhir_stack;
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.case_alt list) = Obj.magic xs in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined5 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined5 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _2 : unit = Obj.magic _2 in
        let _2_inlined1 : (AST.expr) = Obj.magic _2_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.pattern list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let stmt =
                let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined3_, _1_inlined5, _1_inlined4, _1_inlined3) in
                let desc =
                  let simple_else_opt =
                    let _1 = _1_inlined2 in
                    let _2 = 
# 123 "<standard.mly>"
    ( None )
# 11572 "asllib/Parser0.ml"
                     in
                    let _1_1 = _1 in
                    let _2_1 = _2 in
                    
# 698 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 11579 "asllib/Parser0.ml"
                     (_1_1, _2_1)
                  in
                  let simple_stmt_list =
                    let _1 = _1_inlined1 in
                    let _1_1 = _1 in
                    
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 11588 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 695 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 11594 "asllib/Parser0.ml"
                   (expr, simple_stmt_list, simple_else_opt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 11603 "asllib/Parser0.ml"
                
              in
              let where =
                let _1 = _1_inlined2 in
                let _2 = _2_inlined1 in
                let x = _2 in
                
# 126 "<standard.mly>"
    ( Some x )
# 11613 "asllib/Parser0.ml"
                
              in
              let pattern =
                let (_endpos__1_, _startpos__1_, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined1) in
                let desc =
                  let _1_1 = _1 in
                  
# 738 "asllib/Parser0.mly"
                                                   AST.Pattern_Any  
# 11623 "asllib/Parser0.ml"
                   _1_1
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 11632 "asllib/Parser0.ml"
                
              in
              
# 725 "asllib/Parser0.mly"
        ( AST.{ pattern; where; stmt } )
# 11638 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 11647 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 11653 "asllib/Parser0.ml"
           : (AST.case_alt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined7;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined6;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined5;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined4;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3;
                      MenhirLib.EngineTypes.startp = _startpos__3_;
                      MenhirLib.EngineTypes.endp = _endpos__3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = expr;
                        MenhirLib.EngineTypes.startp = _startpos_expr_;
                        MenhirLib.EngineTypes.endp = _endpos_expr_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined3;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _2;
                            MenhirLib.EngineTypes.startp = _startpos__2_;
                            MenhirLib.EngineTypes.endp = _endpos__2_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _2_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined2;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _1_inlined1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _menhir_s;
                                    MenhirLib.EngineTypes.semv = _1;
                                    MenhirLib.EngineTypes.startp = _startpos__1_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_;
                                    MenhirLib.EngineTypes.next = _menhir_stack;
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.case_alt list) = Obj.magic xs in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined7 : (AST.stmt list) = Obj.magic _1_inlined7 in
        let _1_inlined6 : unit = Obj.magic _1_inlined6 in
        let _1_inlined5 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined5 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _2 : unit = Obj.magic _2 in
        let _2_inlined1 : (AST.expr) = Obj.magic _2_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.pattern list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let stmt =
                let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined3_, _1_inlined7, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3) in
                let desc =
                  let simple_else_opt =
                    let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                    let _2 =
                      let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                      let x =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 11783 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 126 "<standard.mly>"
    ( Some x )
# 11789 "asllib/Parser0.ml"
                      
                    in
                    let _1_1 = _1 in
                    let _2_1 = _2 in
                    
# 698 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 11797 "asllib/Parser0.ml"
                     (_1_1, _2_1)
                  in
                  let simple_stmt_list =
                    let _1 = _1_inlined1 in
                    let _1_1 = _1 in
                    
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 11806 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 695 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 11812 "asllib/Parser0.ml"
                   (expr, simple_stmt_list, simple_else_opt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 11821 "asllib/Parser0.ml"
                
              in
              let where =
                let _1 = _1_inlined2 in
                let _2 = _2_inlined1 in
                let x = _2 in
                
# 126 "<standard.mly>"
    ( Some x )
# 11831 "asllib/Parser0.ml"
                
              in
              let pattern =
                let (_endpos__1_, _startpos__1_, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined1) in
                let desc =
                  let _1_1 = _1 in
                  
# 738 "asllib/Parser0.mly"
                                                   AST.Pattern_Any  
# 11841 "asllib/Parser0.ml"
                   _1_1
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 11850 "asllib/Parser0.ml"
                
              in
              
# 725 "asllib/Parser0.mly"
        ( AST.{ pattern; where; stmt } )
# 11856 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 11865 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 11871 "asllib/Parser0.ml"
           : (AST.case_alt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = desc;
                    MenhirLib.EngineTypes.startp = _startpos_desc_;
                    MenhirLib.EngineTypes.endp = _endpos_desc_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.case_alt list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let desc : unit = Obj.magic desc in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_desc_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let stmt =
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 604 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 11938 "asllib/Parser0.ml"
                 _3_1
              in
              let loc =
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 11947 "asllib/Parser0.ml"
                
              in
              
# 727 "asllib/Parser0.mly"
        ( AST.{ pattern = ASTUtils.add_pos_from loc Pattern_All; where = None; stmt } )
# 11953 "asllib/Parser0.ml"
              
            in
            let _endpos_desc_ = _endpos__4_ in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 11962 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 11968 "asllib/Parser0.ml"
           : (AST.case_alt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = expr;
                    MenhirLib.EngineTypes.startp = _startpos_expr_;
                    MenhirLib.EngineTypes.endp = _endpos_expr_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = desc;
                          MenhirLib.EngineTypes.startp = _startpos_desc_;
                          MenhirLib.EngineTypes.endp = _endpos_desc_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.case_alt list) = Obj.magic xs in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined3 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined3 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (AST.stmt list) = Obj.magic _1 in
        let desc : unit = Obj.magic desc in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_desc_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let stmt =
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let _1 = _1_inlined2 in
                        let _2 = 
# 123 "<standard.mly>"
    ( None )
# 12060 "asllib/Parser0.ml"
                         in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 698 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 12067 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 12076 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 695 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 12082 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 12091 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 12099 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 621 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 12105 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 12114 "asllib/Parser0.ml"
                
              in
              let loc =
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 12123 "asllib/Parser0.ml"
                
              in
              
# 727 "asllib/Parser0.mly"
        ( AST.{ pattern = ASTUtils.add_pos_from loc Pattern_All; where = None; stmt } )
# 12129 "asllib/Parser0.ml"
              
            in
            let _endpos_desc_ = _endpos__6_ in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 12138 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 12144 "asllib/Parser0.ml"
           : (AST.case_alt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined5;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined4;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3;
                      MenhirLib.EngineTypes.startp = _startpos__3_;
                      MenhirLib.EngineTypes.endp = _endpos__3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = expr;
                        MenhirLib.EngineTypes.startp = _startpos_expr_;
                        MenhirLib.EngineTypes.endp = _endpos_expr_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = desc;
                              MenhirLib.EngineTypes.startp = _startpos_desc_;
                              MenhirLib.EngineTypes.endp = _endpos_desc_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.case_alt list) = Obj.magic xs in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined5 : (AST.stmt list) = Obj.magic _1_inlined5 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _1_inlined3 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined3 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (AST.stmt list) = Obj.magic _1 in
        let desc : unit = Obj.magic desc in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_desc_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let stmt =
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                        let _2 =
                          let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                          let x =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 12255 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 126 "<standard.mly>"
    ( Some x )
# 12261 "asllib/Parser0.ml"
                          
                        in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 698 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 12269 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 12278 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 695 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 12284 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 12293 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 12301 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 621 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 12307 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 12316 "asllib/Parser0.ml"
                
              in
              let loc =
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 12325 "asllib/Parser0.ml"
                
              in
              
# 727 "asllib/Parser0.mly"
        ( AST.{ pattern = ASTUtils.add_pos_from loc Pattern_All; where = None; stmt } )
# 12331 "asllib/Parser0.ml"
              
            in
            let _endpos_desc_ = _endpos__6_ in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 12340 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 12346 "asllib/Parser0.ml"
           : (AST.case_alt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = desc;
                MenhirLib.EngineTypes.startp = _startpos_desc_;
                MenhirLib.EngineTypes.endp = _endpos_desc_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.case_alt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1 : (AST.stmt list) = Obj.magic _1 in
        let desc : unit = Obj.magic desc in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_desc_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let stmt =
                let x =
                  let _1_1 = _1 in
                  
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 12399 "asllib/Parser0.ml"
                   _1_1
                in
                
# 196 "<standard.mly>"
    ( x )
# 12405 "asllib/Parser0.ml"
                
              in
              let loc =
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 12414 "asllib/Parser0.ml"
                
              in
              
# 727 "asllib/Parser0.mly"
        ( AST.{ pattern = ASTUtils.add_pos_from loc Pattern_All; where = None; stmt } )
# 12420 "asllib/Parser0.ml"
              
            in
            let _endpos_desc_ = _endpos__2_ in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 12429 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 12435 "asllib/Parser0.ml"
           : (AST.case_alt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = desc;
              MenhirLib.EngineTypes.startp = _startpos_desc_;
              MenhirLib.EngineTypes.endp = _endpos_desc_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let xs : (AST.case_alt list) = Obj.magic xs in
        let _1 : unit = Obj.magic _1 in
        let desc : unit = Obj.magic desc in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_desc_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let stmt = 
# 597 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 12478 "asllib/Parser0.ml"
               in
              let loc =
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 12486 "asllib/Parser0.ml"
                
              in
              
# 727 "asllib/Parser0.mly"
        ( AST.{ pattern = ASTUtils.add_pos_from loc Pattern_All; where = None; stmt } )
# 12492 "asllib/Parser0.ml"
              
            in
            let _endpos_desc_ = _endpos__1_ in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 12501 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 12507 "asllib/Parser0.ml"
           : (AST.case_alt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let _menhir_s = _menhir_env.MenhirLib.EngineTypes.current in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _endpos = _startpos in
        let _v : (AST.decl option list) = 
# 216 "<standard.mly>"
    ( [] )
# 12526 "asllib/Parser0.ml"
         in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = e;
                MenhirLib.EngineTypes.startp = _startpos_e_;
                MenhirLib.EngineTypes.endp = _endpos_e_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _4;
                  MenhirLib.EngineTypes.startp = _startpos__4_;
                  MenhirLib.EngineTypes.endp = _endpos__4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _2_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = q;
                        MenhirLib.EngineTypes.startp = _startpos_q_;
                        MenhirLib.EngineTypes.endp = _endpos_q_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = t;
                          MenhirLib.EngineTypes.startp = _startpos_t_;
                          MenhirLib.EngineTypes.endp = _endpos_t_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let e : (AST.expr) = Obj.magic e in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 12606 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 12612 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let t : (AST.ty) = Obj.magic t in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _2 =
              let _1 = _1_inlined2 in
              _2
            in
            let x =
              let _2 = _2_inlined1 in
              let x =
                let desc =
                  let x =
                    let _1 = _1_inlined1 in
                    let i = _1 in
                    
# 347 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 12635 "asllib/Parser0.ml"
                    
                  in
                  let gdk = 
# 410 "asllib/Parser0.mly"
                ( AST.GDK_Constant  )
# 12641 "asllib/Parser0.ml"
                   in
                  
# 418 "asllib/Parser0.mly"
          ( AST.D_GlobalStorage {
            keyword = gdk;
            name = x;
            initial_value = Some e;
            ty = Some t;
          } )
# 12651 "asllib/Parser0.ml"
                  
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos_e_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 12660 "asllib/Parser0.ml"
                
              in
              
# 233 "asllib/Parser0.mly"
                      Some  
# 12666 "asllib/Parser0.ml"
               x
            in
            
# 196 "<standard.mly>"
    ( x )
# 12672 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 12678 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = e;
                MenhirLib.EngineTypes.startp = _startpos_e_;
                MenhirLib.EngineTypes.endp = _endpos_e_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _4;
                  MenhirLib.EngineTypes.startp = _startpos__4_;
                  MenhirLib.EngineTypes.endp = _endpos__4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = t;
                      MenhirLib.EngineTypes.startp = _startpos_t_;
                      MenhirLib.EngineTypes.endp = _endpos_t_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let e : (AST.expr) = Obj.magic e in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 12747 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let t : (AST.ty) = Obj.magic t in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _2 =
              let _1 = _1_inlined2 in
              _2
            in
            let x =
              let x =
                let desc =
                  let x = _1_inlined1 in
                  let gdk = 
# 410 "asllib/Parser0.mly"
                ( AST.GDK_Constant  )
# 12767 "asllib/Parser0.ml"
                   in
                  
# 418 "asllib/Parser0.mly"
          ( AST.D_GlobalStorage {
            keyword = gdk;
            name = x;
            initial_value = Some e;
            ty = Some t;
          } )
# 12777 "asllib/Parser0.ml"
                  
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos_e_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 12786 "asllib/Parser0.ml"
                
              in
              
# 233 "asllib/Parser0.mly"
                      Some  
# 12792 "asllib/Parser0.ml"
               x
            in
            
# 196 "<standard.mly>"
    ( x )
# 12798 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 12804 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = e;
                MenhirLib.EngineTypes.startp = _startpos_e_;
                MenhirLib.EngineTypes.endp = _endpos_e_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _4;
                  MenhirLib.EngineTypes.startp = _startpos__4_;
                  MenhirLib.EngineTypes.endp = _endpos__4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = t;
                      MenhirLib.EngineTypes.startp = _startpos_t_;
                      MenhirLib.EngineTypes.endp = _endpos_t_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let e : (AST.expr) = Obj.magic e in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let t : (AST.ty) = Obj.magic t in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _2 =
              let _1 = _1_inlined2 in
              _2
            in
            let x =
              let x =
                let desc =
                  let x =
                    let _1 = _1_inlined1 in
                    
# 349 "asllib/Parser0.mly"
              ( "record" )
# 12890 "asllib/Parser0.ml"
                    
                  in
                  let gdk = 
# 410 "asllib/Parser0.mly"
                ( AST.GDK_Constant  )
# 12896 "asllib/Parser0.ml"
                   in
                  
# 418 "asllib/Parser0.mly"
          ( AST.D_GlobalStorage {
            keyword = gdk;
            name = x;
            initial_value = Some e;
            ty = Some t;
          } )
# 12906 "asllib/Parser0.ml"
                  
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos_e_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 12915 "asllib/Parser0.ml"
                
              in
              
# 233 "asllib/Parser0.mly"
                      Some  
# 12921 "asllib/Parser0.ml"
               x
            in
            
# 196 "<standard.mly>"
    ( x )
# 12927 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 12933 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = e;
                MenhirLib.EngineTypes.startp = _startpos_e_;
                MenhirLib.EngineTypes.endp = _endpos_e_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _4;
                  MenhirLib.EngineTypes.startp = _startpos__4_;
                  MenhirLib.EngineTypes.endp = _endpos__4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _2_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = q;
                        MenhirLib.EngineTypes.startp = _startpos_q_;
                        MenhirLib.EngineTypes.endp = _endpos_q_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = t;
                          MenhirLib.EngineTypes.startp = _startpos_t_;
                          MenhirLib.EngineTypes.endp = _endpos_t_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let e : (AST.expr) = Obj.magic e in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 13014 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 13020 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let t : (AST.ty) = Obj.magic t in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _2 =
              let _1 = _1_inlined2 in
              _2
            in
            let x =
              let _2 = _2_inlined1 in
              let x =
                let desc =
                  let x =
                    let _1 = _1_inlined1 in
                    let i = _1 in
                    
# 347 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 13043 "asllib/Parser0.ml"
                    
                  in
                  let gdk = 
# 411 "asllib/Parser0.mly"
                ( AST.GDK_Config    )
# 13049 "asllib/Parser0.ml"
                   in
                  
# 418 "asllib/Parser0.mly"
          ( AST.D_GlobalStorage {
            keyword = gdk;
            name = x;
            initial_value = Some e;
            ty = Some t;
          } )
# 13059 "asllib/Parser0.ml"
                  
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos_e_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 13068 "asllib/Parser0.ml"
                
              in
              
# 233 "asllib/Parser0.mly"
                      Some  
# 13074 "asllib/Parser0.ml"
               x
            in
            
# 196 "<standard.mly>"
    ( x )
# 13080 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 13086 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = e;
                MenhirLib.EngineTypes.startp = _startpos_e_;
                MenhirLib.EngineTypes.endp = _endpos_e_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _4;
                  MenhirLib.EngineTypes.startp = _startpos__4_;
                  MenhirLib.EngineTypes.endp = _endpos__4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = t;
                      MenhirLib.EngineTypes.startp = _startpos_t_;
                      MenhirLib.EngineTypes.endp = _endpos_t_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let e : (AST.expr) = Obj.magic e in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 13155 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let t : (AST.ty) = Obj.magic t in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _2 =
              let _1 = _1_inlined2 in
              _2
            in
            let x =
              let x =
                let desc =
                  let x = _1_inlined1 in
                  let gdk = 
# 411 "asllib/Parser0.mly"
                ( AST.GDK_Config    )
# 13175 "asllib/Parser0.ml"
                   in
                  
# 418 "asllib/Parser0.mly"
          ( AST.D_GlobalStorage {
            keyword = gdk;
            name = x;
            initial_value = Some e;
            ty = Some t;
          } )
# 13185 "asllib/Parser0.ml"
                  
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos_e_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 13194 "asllib/Parser0.ml"
                
              in
              
# 233 "asllib/Parser0.mly"
                      Some  
# 13200 "asllib/Parser0.ml"
               x
            in
            
# 196 "<standard.mly>"
    ( x )
# 13206 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 13212 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = e;
                MenhirLib.EngineTypes.startp = _startpos_e_;
                MenhirLib.EngineTypes.endp = _endpos_e_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _4;
                  MenhirLib.EngineTypes.startp = _startpos__4_;
                  MenhirLib.EngineTypes.endp = _endpos__4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = t;
                      MenhirLib.EngineTypes.startp = _startpos_t_;
                      MenhirLib.EngineTypes.endp = _endpos_t_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let e : (AST.expr) = Obj.magic e in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let t : (AST.ty) = Obj.magic t in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _2 =
              let _1 = _1_inlined2 in
              _2
            in
            let x =
              let x =
                let desc =
                  let x =
                    let _1 = _1_inlined1 in
                    
# 349 "asllib/Parser0.mly"
              ( "record" )
# 13298 "asllib/Parser0.ml"
                    
                  in
                  let gdk = 
# 411 "asllib/Parser0.mly"
                ( AST.GDK_Config    )
# 13304 "asllib/Parser0.ml"
                   in
                  
# 418 "asllib/Parser0.mly"
          ( AST.D_GlobalStorage {
            keyword = gdk;
            name = x;
            initial_value = Some e;
            ty = Some t;
          } )
# 13314 "asllib/Parser0.ml"
                  
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos_e_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 13323 "asllib/Parser0.ml"
                
              in
              
# 233 "asllib/Parser0.mly"
                      Some  
# 13329 "asllib/Parser0.ml"
               x
            in
            
# 196 "<standard.mly>"
    ( x )
# 13335 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 13341 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = e;
                MenhirLib.EngineTypes.startp = _startpos_e_;
                MenhirLib.EngineTypes.endp = _endpos_e_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _4;
                  MenhirLib.EngineTypes.startp = _startpos__4_;
                  MenhirLib.EngineTypes.endp = _endpos__4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _2_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = q;
                        MenhirLib.EngineTypes.startp = _startpos_q_;
                        MenhirLib.EngineTypes.endp = _endpos_q_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = t;
                          MenhirLib.EngineTypes.startp = _startpos_t_;
                          MenhirLib.EngineTypes.endp = _endpos_t_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let e : (AST.expr) = Obj.magic e in
        let _4 : unit = Obj.magic _4 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 13416 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 13422 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let t : (AST.ty) = Obj.magic t in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_t_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _2 =
              let _1 = _1_inlined1 in
              _2
            in
            let x =
              let _2 = _2_inlined1 in
              let x =
                let desc =
                  let x =
                    let i = _1 in
                    
# 347 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 13443 "asllib/Parser0.ml"
                    
                  in
                  let gdk = 
# 412 "asllib/Parser0.mly"
                ( AST.GDK_Var       )
# 13449 "asllib/Parser0.ml"
                   in
                  
# 418 "asllib/Parser0.mly"
          ( AST.D_GlobalStorage {
            keyword = gdk;
            name = x;
            initial_value = Some e;
            ty = Some t;
          } )
# 13459 "asllib/Parser0.ml"
                  
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos_e_, _startpos_t_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 13468 "asllib/Parser0.ml"
                
              in
              
# 233 "asllib/Parser0.mly"
                      Some  
# 13474 "asllib/Parser0.ml"
               x
            in
            
# 196 "<standard.mly>"
    ( x )
# 13480 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 13486 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = e;
                MenhirLib.EngineTypes.startp = _startpos_e_;
                MenhirLib.EngineTypes.endp = _endpos_e_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _4;
                  MenhirLib.EngineTypes.startp = _startpos__4_;
                  MenhirLib.EngineTypes.endp = _endpos__4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = t;
                      MenhirLib.EngineTypes.startp = _startpos_t_;
                      MenhirLib.EngineTypes.endp = _endpos_t_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let e : (AST.expr) = Obj.magic e in
        let _4 : unit = Obj.magic _4 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 13549 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let t : (AST.ty) = Obj.magic t in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_t_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _2 =
              let _1 = _1_inlined1 in
              _2
            in
            let x =
              let x =
                let desc =
                  let x = _1 in
                  let gdk = 
# 412 "asllib/Parser0.mly"
                ( AST.GDK_Var       )
# 13568 "asllib/Parser0.ml"
                   in
                  
# 418 "asllib/Parser0.mly"
          ( AST.D_GlobalStorage {
            keyword = gdk;
            name = x;
            initial_value = Some e;
            ty = Some t;
          } )
# 13578 "asllib/Parser0.ml"
                  
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos_e_, _startpos_t_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 13587 "asllib/Parser0.ml"
                
              in
              
# 233 "asllib/Parser0.mly"
                      Some  
# 13593 "asllib/Parser0.ml"
               x
            in
            
# 196 "<standard.mly>"
    ( x )
# 13599 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 13605 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = e;
                MenhirLib.EngineTypes.startp = _startpos_e_;
                MenhirLib.EngineTypes.endp = _endpos_e_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _4;
                  MenhirLib.EngineTypes.startp = _startpos__4_;
                  MenhirLib.EngineTypes.endp = _endpos__4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = t;
                      MenhirLib.EngineTypes.startp = _startpos_t_;
                      MenhirLib.EngineTypes.endp = _endpos_t_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let e : (AST.expr) = Obj.magic e in
        let _4 : unit = Obj.magic _4 in
        let _1 : unit = Obj.magic _1 in
        let t : (AST.ty) = Obj.magic t in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_t_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _2 =
              let _1 = _1_inlined1 in
              _2
            in
            let x =
              let x =
                let desc =
                  let x = 
# 349 "asllib/Parser0.mly"
              ( "record" )
# 13682 "asllib/Parser0.ml"
                   in
                  let gdk = 
# 412 "asllib/Parser0.mly"
                ( AST.GDK_Var       )
# 13687 "asllib/Parser0.ml"
                   in
                  
# 418 "asllib/Parser0.mly"
          ( AST.D_GlobalStorage {
            keyword = gdk;
            name = x;
            initial_value = Some e;
            ty = Some t;
          } )
# 13697 "asllib/Parser0.ml"
                  
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos_e_, _startpos_t_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 13706 "asllib/Parser0.ml"
                
              in
              
# 233 "asllib/Parser0.mly"
                      Some  
# 13712 "asllib/Parser0.ml"
               x
            in
            
# 196 "<standard.mly>"
    ( x )
# 13718 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 13724 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1;
                MenhirLib.EngineTypes.startp = _startpos__1_;
                MenhirLib.EngineTypes.endp = _endpos__1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _2_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = q;
                    MenhirLib.EngineTypes.startp = _startpos_q_;
                    MenhirLib.EngineTypes.endp = _endpos_q_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = ty;
                      MenhirLib.EngineTypes.startp = _startpos_ty_;
                      MenhirLib.EngineTypes.endp = _endpos_ty_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 13785 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 13791 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let ty : (AST.ty) = Obj.magic ty in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_ty_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _2 =
              let _1 = _1_inlined1 in
              _2
            in
            let x =
              let _2 = _2_inlined1 in
              let x =
                let desc =
                  let x =
                    let i = _1 in
                    
# 347 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 13812 "asllib/Parser0.ml"
                    
                  in
                  
# 425 "asllib/Parser0.mly"
          ( AST.D_GlobalStorage {
            keyword = GDK_Var;
            name = x;
            ty = Some ty;
            initial_value = None;
          })
# 13823 "asllib/Parser0.ml"
                  
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos_ty_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 13832 "asllib/Parser0.ml"
                
              in
              
# 233 "asllib/Parser0.mly"
                      Some  
# 13838 "asllib/Parser0.ml"
               x
            in
            
# 196 "<standard.mly>"
    ( x )
# 13844 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 13850 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1;
                MenhirLib.EngineTypes.startp = _startpos__1_;
                MenhirLib.EngineTypes.endp = _endpos__1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = ty;
                  MenhirLib.EngineTypes.startp = _startpos_ty_;
                  MenhirLib.EngineTypes.endp = _endpos_ty_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 13899 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let ty : (AST.ty) = Obj.magic ty in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_ty_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _2 =
              let _1 = _1_inlined1 in
              _2
            in
            let x =
              let x =
                let desc =
                  let x = _1 in
                  
# 425 "asllib/Parser0.mly"
          ( AST.D_GlobalStorage {
            keyword = GDK_Var;
            name = x;
            ty = Some ty;
            initial_value = None;
          })
# 13923 "asllib/Parser0.ml"
                  
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos_ty_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 13932 "asllib/Parser0.ml"
                
              in
              
# 233 "asllib/Parser0.mly"
                      Some  
# 13938 "asllib/Parser0.ml"
               x
            in
            
# 196 "<standard.mly>"
    ( x )
# 13944 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 13950 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1;
                MenhirLib.EngineTypes.startp = _startpos__1_;
                MenhirLib.EngineTypes.endp = _endpos__1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = ty;
                  MenhirLib.EngineTypes.startp = _startpos_ty_;
                  MenhirLib.EngineTypes.endp = _endpos_ty_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let ty : (AST.ty) = Obj.magic ty in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_ty_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _2 =
              let _1 = _1_inlined1 in
              _2
            in
            let x =
              let x =
                let desc =
                  let x = 
# 349 "asllib/Parser0.mly"
              ( "record" )
# 14013 "asllib/Parser0.ml"
                   in
                  
# 425 "asllib/Parser0.mly"
          ( AST.D_GlobalStorage {
            keyword = GDK_Var;
            name = x;
            ty = Some ty;
            initial_value = None;
          })
# 14023 "asllib/Parser0.ml"
                  
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos_ty_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 14032 "asllib/Parser0.ml"
                
              in
              
# 233 "asllib/Parser0.mly"
                      Some  
# 14038 "asllib/Parser0.ml"
               x
            in
            
# 196 "<standard.mly>"
    ( x )
# 14044 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 14050 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _2_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = q;
                          MenhirLib.EngineTypes.startp = _startpos_q_;
                          MenhirLib.EngineTypes.endp = _endpos_q_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = ty;
                            MenhirLib.EngineTypes.startp = _startpos_ty_;
                            MenhirLib.EngineTypes.endp = _endpos_ty_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = _1;
                              MenhirLib.EngineTypes.startp = _startpos__1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined3 : (AST.expr) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 14138 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 14144 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let ty : (AST.ty) = Obj.magic ty in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _2 =
              let _1 = _1_inlined4 in
              _2
            in
            let x =
              let _2 = _2_inlined1 in
              let x =
                let desc =
                  let e =
                    let _1_inlined1 = _1_inlined3 in
                    let x = _1_inlined1 in
                    
# 205 "<standard.mly>"
    ( x )
# 14167 "asllib/Parser0.ml"
                    
                  in
                  let x =
                    let _1 = _1_inlined1 in
                    let i = _1 in
                    
# 347 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 14176 "asllib/Parser0.ml"
                    
                  in
                  
# 432 "asllib/Parser0.mly"
          ( AST.(D_GlobalStorage {
            keyword = GDK_Var;
            name = x;
            ty = Some (T_Array (ArrayLength_Expr e, ty)
                       |> ASTUtils.add_dummy_annotation ~version);
            initial_value = None;
          }))
# 14188 "asllib/Parser0.ml"
                  
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 14197 "asllib/Parser0.ml"
                
              in
              
# 233 "asllib/Parser0.mly"
                      Some  
# 14203 "asllib/Parser0.ml"
               x
            in
            
# 196 "<standard.mly>"
    ( x )
# 14209 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 14215 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _2_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__2_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__2_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined3;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _2_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = q;
                              MenhirLib.EngineTypes.startp = _startpos_q_;
                              MenhirLib.EngineTypes.endp = _endpos_q_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = ty;
                                MenhirLib.EngineTypes.startp = _startpos_ty_;
                                MenhirLib.EngineTypes.endp = _endpos_ty_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _menhir_s;
                                  MenhirLib.EngineTypes.semv = _1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_;
                                  MenhirLib.EngineTypes.next = _menhir_stack;
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : (AST.expr) = Obj.magic _3_inlined1 in
        let _2_inlined2 : unit = Obj.magic _2_inlined2 in
        let _1_inlined3 : (AST.expr) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 14317 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 14323 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let ty : (AST.ty) = Obj.magic ty in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _2 =
              let _1 = _1_inlined4 in
              _2
            in
            let x =
              let (_2_inlined1, _2) = (_2_inlined2, _2_inlined1) in
              let x =
                let desc =
                  let e =
                    let (_2, _1_inlined1) = (_2_inlined1, _1_inlined3) in
                    let x =
                      let (_3, _1) = (_3_inlined1, _1_inlined1) in
                      _3
                    in
                    
# 205 "<standard.mly>"
    ( x )
# 14349 "asllib/Parser0.ml"
                    
                  in
                  let x =
                    let _1 = _1_inlined1 in
                    let i = _1 in
                    
# 347 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 14358 "asllib/Parser0.ml"
                    
                  in
                  
# 432 "asllib/Parser0.mly"
          ( AST.(D_GlobalStorage {
            keyword = GDK_Var;
            name = x;
            ty = Some (T_Array (ArrayLength_Expr e, ty)
                       |> ASTUtils.add_dummy_annotation ~version);
            initial_value = None;
          }))
# 14370 "asllib/Parser0.ml"
                  
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 14379 "asllib/Parser0.ml"
                
              in
              
# 233 "asllib/Parser0.mly"
                      Some  
# 14385 "asllib/Parser0.ml"
               x
            in
            
# 196 "<standard.mly>"
    ( x )
# 14391 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 14397 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = ty;
                        MenhirLib.EngineTypes.startp = _startpos_ty_;
                        MenhirLib.EngineTypes.endp = _endpos_ty_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined3 : (AST.expr) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 14473 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let ty : (AST.ty) = Obj.magic ty in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _2 =
              let _1 = _1_inlined4 in
              _2
            in
            let x =
              let x =
                let desc =
                  let e =
                    let _1_inlined1 = _1_inlined3 in
                    let x = _1_inlined1 in
                    
# 205 "<standard.mly>"
    ( x )
# 14495 "asllib/Parser0.ml"
                    
                  in
                  let x = _1_inlined1 in
                  
# 432 "asllib/Parser0.mly"
          ( AST.(D_GlobalStorage {
            keyword = GDK_Var;
            name = x;
            ty = Some (T_Array (ArrayLength_Expr e, ty)
                       |> ASTUtils.add_dummy_annotation ~version);
            initial_value = None;
          }))
# 14508 "asllib/Parser0.ml"
                  
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 14517 "asllib/Parser0.ml"
                
              in
              
# 233 "asllib/Parser0.mly"
                      Some  
# 14523 "asllib/Parser0.ml"
               x
            in
            
# 196 "<standard.mly>"
    ( x )
# 14529 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 14535 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _2_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined3;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = ty;
                            MenhirLib.EngineTypes.startp = _startpos_ty_;
                            MenhirLib.EngineTypes.endp = _endpos_ty_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = _1;
                              MenhirLib.EngineTypes.startp = _startpos__1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : (AST.expr) = Obj.magic _3_inlined1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined3 : (AST.expr) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 14625 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let ty : (AST.ty) = Obj.magic ty in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _2 =
              let _1 = _1_inlined4 in
              _2
            in
            let x =
              let _2 = _2_inlined1 in
              let x =
                let desc =
                  let e =
                    let _1_inlined1 = _1_inlined3 in
                    let x =
                      let (_3, _1) = (_3_inlined1, _1_inlined1) in
                      _3
                    in
                    
# 205 "<standard.mly>"
    ( x )
# 14651 "asllib/Parser0.ml"
                    
                  in
                  let x = _1_inlined1 in
                  
# 432 "asllib/Parser0.mly"
          ( AST.(D_GlobalStorage {
            keyword = GDK_Var;
            name = x;
            ty = Some (T_Array (ArrayLength_Expr e, ty)
                       |> ASTUtils.add_dummy_annotation ~version);
            initial_value = None;
          }))
# 14664 "asllib/Parser0.ml"
                  
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 14673 "asllib/Parser0.ml"
                
              in
              
# 233 "asllib/Parser0.mly"
                      Some  
# 14679 "asllib/Parser0.ml"
               x
            in
            
# 196 "<standard.mly>"
    ( x )
# 14685 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 14691 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = ty;
                        MenhirLib.EngineTypes.startp = _startpos_ty_;
                        MenhirLib.EngineTypes.endp = _endpos_ty_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined3 : (AST.expr) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let ty : (AST.ty) = Obj.magic ty in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _2 =
              let _1 = _1_inlined4 in
              _2
            in
            let x =
              let x =
                let desc =
                  let e =
                    let _1_inlined1 = _1_inlined3 in
                    let x = _1_inlined1 in
                    
# 205 "<standard.mly>"
    ( x )
# 14785 "asllib/Parser0.ml"
                    
                  in
                  let x =
                    let _1 = _1_inlined1 in
                    
# 349 "asllib/Parser0.mly"
              ( "record" )
# 14793 "asllib/Parser0.ml"
                    
                  in
                  
# 432 "asllib/Parser0.mly"
          ( AST.(D_GlobalStorage {
            keyword = GDK_Var;
            name = x;
            ty = Some (T_Array (ArrayLength_Expr e, ty)
                       |> ASTUtils.add_dummy_annotation ~version);
            initial_value = None;
          }))
# 14805 "asllib/Parser0.ml"
                  
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 14814 "asllib/Parser0.ml"
                
              in
              
# 233 "asllib/Parser0.mly"
                      Some  
# 14820 "asllib/Parser0.ml"
               x
            in
            
# 196 "<standard.mly>"
    ( x )
# 14826 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 14832 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _2_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined3;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = ty;
                            MenhirLib.EngineTypes.startp = _startpos_ty_;
                            MenhirLib.EngineTypes.endp = _endpos_ty_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = _1;
                              MenhirLib.EngineTypes.startp = _startpos__1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : (AST.expr) = Obj.magic _3_inlined1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined3 : (AST.expr) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let ty : (AST.ty) = Obj.magic ty in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _2 =
              let _1 = _1_inlined4 in
              _2
            in
            let x =
              let _2 = _2_inlined1 in
              let x =
                let desc =
                  let e =
                    let _1_inlined1 = _1_inlined3 in
                    let x =
                      let (_3, _1) = (_3_inlined1, _1_inlined1) in
                      _3
                    in
                    
# 205 "<standard.mly>"
    ( x )
# 14944 "asllib/Parser0.ml"
                    
                  in
                  let x =
                    let _1 = _1_inlined1 in
                    
# 349 "asllib/Parser0.mly"
              ( "record" )
# 14952 "asllib/Parser0.ml"
                    
                  in
                  
# 432 "asllib/Parser0.mly"
          ( AST.(D_GlobalStorage {
            keyword = GDK_Var;
            name = x;
            ty = Some (T_Array (ArrayLength_Expr e, ty)
                       |> ASTUtils.add_dummy_annotation ~version);
            initial_value = None;
          }))
# 14964 "asllib/Parser0.ml"
                  
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 14973 "asllib/Parser0.ml"
                
              in
              
# 233 "asllib/Parser0.mly"
                      Some  
# 14979 "asllib/Parser0.ml"
               x
            in
            
# 196 "<standard.mly>"
    ( x )
# 14985 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 14991 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _2;
                          MenhirLib.EngineTypes.startp = _startpos__2_;
                          MenhirLib.EngineTypes.endp = _endpos__2_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = q;
                            MenhirLib.EngineTypes.startp = _startpos_q_;
                            MenhirLib.EngineTypes.endp = _endpos_q_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = ty;
                              MenhirLib.EngineTypes.startp = _startpos_ty_;
                              MenhirLib.EngineTypes.endp = _endpos_ty_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 15080 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 15086 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let ty : (AST.ty) = Obj.magic ty in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_ty_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let (_1_inlined1, _2, _1) = (_1_inlined3, _2_inlined1, _1_inlined2) in
                  let _3 = _1_inlined1 in
                  let _3_1 = _3 in
                  
# 604 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 15103 "asllib/Parser0.ml"
                   _3_1
                in
                let args =
                  let x = 
# 298 "asllib/Parser0.mly"
                ( [] )
# 15110 "asllib/Parser0.ml"
                   in
                  
# 205 "<standard.mly>"
    ( x )
# 15115 "asllib/Parser0.ml"
                  
                in
                let name =
                  let i = _1 in
                  
# 347 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 15123 "asllib/Parser0.ml"
                  
                in
                
# 444 "asllib/Parser0.mly"
        ( make_func name args (Some ty) (SB_ASL body) )
# 15129 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos_ty_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 15138 "asllib/Parser0.ml"
              
            in
            
# 233 "asllib/Parser0.mly"
                      Some  
# 15144 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 15150 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _2;
                            MenhirLib.EngineTypes.startp = _startpos__2_;
                            MenhirLib.EngineTypes.endp = _endpos__2_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = q;
                              MenhirLib.EngineTypes.startp = _startpos_q_;
                              MenhirLib.EngineTypes.endp = _endpos_q_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _menhir_s;
                                MenhirLib.EngineTypes.semv = ty;
                                MenhirLib.EngineTypes.startp = _startpos_ty_;
                                MenhirLib.EngineTypes.endp = _endpos_ty_;
                                MenhirLib.EngineTypes.next = _menhir_stack;
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (AST.typed_identifier list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 15246 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 15252 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let ty : (AST.ty) = Obj.magic ty in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_ty_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let (_1_inlined1, _2, _1) = (_1_inlined4, _2_inlined1, _1_inlined3) in
                  let _3 = _1_inlined1 in
                  let _3_1 = _3 in
                  
# 604 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 15269 "asllib/Parser0.ml"
                   _3_1
                in
                let args =
                  let _1_inlined1 = _1_inlined2 in
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 15278 "asllib/Parser0.ml"
                  
                in
                let name =
                  let i = _1 in
                  
# 347 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 15286 "asllib/Parser0.ml"
                  
                in
                
# 444 "asllib/Parser0.mly"
        ( make_func name args (Some ty) (SB_ASL body) )
# 15292 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos_ty_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 15301 "asllib/Parser0.ml"
              
            in
            
# 233 "asllib/Parser0.mly"
                      Some  
# 15307 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 15313 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = ty;
                          MenhirLib.EngineTypes.startp = _startpos_ty_;
                          MenhirLib.EngineTypes.endp = _endpos_ty_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 15390 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let ty : (AST.ty) = Obj.magic ty in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_ty_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let (_1_inlined1, _1) = (_1_inlined3, _1_inlined2) in
                  let _3 = _1_inlined1 in
                  let _3_1 = _3 in
                  
# 604 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 15407 "asllib/Parser0.ml"
                   _3_1
                in
                let args =
                  let x = 
# 298 "asllib/Parser0.mly"
                ( [] )
# 15414 "asllib/Parser0.ml"
                   in
                  
# 205 "<standard.mly>"
    ( x )
# 15419 "asllib/Parser0.ml"
                  
                in
                let name = _1 in
                
# 444 "asllib/Parser0.mly"
        ( make_func name args (Some ty) (SB_ASL body) )
# 15426 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos_ty_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 15435 "asllib/Parser0.ml"
              
            in
            
# 233 "asllib/Parser0.mly"
                      Some  
# 15441 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 15447 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = ty;
                            MenhirLib.EngineTypes.startp = _startpos_ty_;
                            MenhirLib.EngineTypes.endp = _endpos_ty_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (AST.typed_identifier list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 15531 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let ty : (AST.ty) = Obj.magic ty in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_ty_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let (_1_inlined1, _1) = (_1_inlined4, _1_inlined3) in
                  let _3 = _1_inlined1 in
                  let _3_1 = _3 in
                  
# 604 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 15548 "asllib/Parser0.ml"
                   _3_1
                in
                let args =
                  let _1_inlined1 = _1_inlined2 in
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 15557 "asllib/Parser0.ml"
                  
                in
                let name = _1 in
                
# 444 "asllib/Parser0.mly"
        ( make_func name args (Some ty) (SB_ASL body) )
# 15564 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos_ty_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 15573 "asllib/Parser0.ml"
              
            in
            
# 233 "asllib/Parser0.mly"
                      Some  
# 15579 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 15585 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = ty;
                          MenhirLib.EngineTypes.startp = _startpos_ty_;
                          MenhirLib.EngineTypes.endp = _endpos_ty_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let ty : (AST.ty) = Obj.magic ty in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_ty_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let (_1_inlined1, _1) = (_1_inlined3, _1_inlined2) in
                  let _3 = _1_inlined1 in
                  let _3_1 = _3 in
                  
# 604 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 15675 "asllib/Parser0.ml"
                   _3_1
                in
                let args =
                  let x = 
# 298 "asllib/Parser0.mly"
                ( [] )
# 15682 "asllib/Parser0.ml"
                   in
                  
# 205 "<standard.mly>"
    ( x )
# 15687 "asllib/Parser0.ml"
                  
                in
                let name = 
# 349 "asllib/Parser0.mly"
              ( "record" )
# 15693 "asllib/Parser0.ml"
                 in
                
# 444 "asllib/Parser0.mly"
        ( make_func name args (Some ty) (SB_ASL body) )
# 15698 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos_ty_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 15707 "asllib/Parser0.ml"
              
            in
            
# 233 "asllib/Parser0.mly"
                      Some  
# 15713 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 15719 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = ty;
                            MenhirLib.EngineTypes.startp = _startpos_ty_;
                            MenhirLib.EngineTypes.endp = _endpos_ty_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (AST.typed_identifier list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let ty : (AST.ty) = Obj.magic ty in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_ty_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let (_1_inlined1, _1) = (_1_inlined4, _1_inlined3) in
                  let _3 = _1_inlined1 in
                  let _3_1 = _3 in
                  
# 604 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 15816 "asllib/Parser0.ml"
                   _3_1
                in
                let args =
                  let _1_inlined1 = _1_inlined2 in
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 15825 "asllib/Parser0.ml"
                  
                in
                let name = 
# 349 "asllib/Parser0.mly"
              ( "record" )
# 15831 "asllib/Parser0.ml"
                 in
                
# 444 "asllib/Parser0.mly"
        ( make_func name args (Some ty) (SB_ASL body) )
# 15836 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos_ty_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 15845 "asllib/Parser0.ml"
              
            in
            
# 233 "asllib/Parser0.mly"
                      Some  
# 15851 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 15857 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _2_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = q;
                            MenhirLib.EngineTypes.startp = _startpos_q_;
                            MenhirLib.EngineTypes.endp = _endpos_q_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _2;
                              MenhirLib.EngineTypes.startp = _startpos__2_;
                              MenhirLib.EngineTypes.endp = _endpos__2_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _menhir_s;
                                MenhirLib.EngineTypes.semv = _1;
                                MenhirLib.EngineTypes.startp = _startpos__1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_;
                                MenhirLib.EngineTypes.next = _menhir_stack;
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _2_inlined2 : unit = Obj.magic _2_inlined2 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 15952 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 15958 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let (_1_inlined1, _2, _1) = (_1_inlined4, _2_inlined2, _1_inlined3) in
                  let _3 = _1_inlined1 in
                  let _3_1 = _3 in
                  
# 604 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 15976 "asllib/Parser0.ml"
                   _3_1
                in
                let args =
                  let x = 
# 298 "asllib/Parser0.mly"
                ( [] )
# 15983 "asllib/Parser0.ml"
                   in
                  
# 205 "<standard.mly>"
    ( x )
# 15988 "asllib/Parser0.ml"
                  
                in
                let name =
                  let (_1, _2) = (_1_inlined1, _2_inlined1) in
                  let i = _1 in
                  
# 347 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 15997 "asllib/Parser0.ml"
                  
                in
                
# 448 "asllib/Parser0.mly"
        ( make_func name args None (SB_ASL body) )
# 16003 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 16012 "asllib/Parser0.ml"
              
            in
            
# 233 "asllib/Parser0.mly"
                      Some  
# 16018 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 16024 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined5;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined4;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined3;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _2_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = q;
                              MenhirLib.EngineTypes.startp = _startpos_q_;
                              MenhirLib.EngineTypes.endp = _endpos_q_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _2;
                                MenhirLib.EngineTypes.startp = _startpos__2_;
                                MenhirLib.EngineTypes.endp = _endpos__2_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _menhir_s;
                                  MenhirLib.EngineTypes.semv = _1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_;
                                  MenhirLib.EngineTypes.next = _menhir_stack;
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined5 : (AST.stmt list) = Obj.magic _1_inlined5 in
        let _2_inlined2 : unit = Obj.magic _2_inlined2 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined3 : (AST.typed_identifier list) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 16126 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 16132 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let (_1_inlined1, _2, _1) = (_1_inlined5, _2_inlined2, _1_inlined4) in
                  let _3 = _1_inlined1 in
                  let _3_1 = _3 in
                  
# 604 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 16150 "asllib/Parser0.ml"
                   _3_1
                in
                let args =
                  let _1_inlined1 = _1_inlined3 in
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 16159 "asllib/Parser0.ml"
                  
                in
                let name =
                  let (_1, _2) = (_1_inlined1, _2_inlined1) in
                  let i = _1 in
                  
# 347 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 16168 "asllib/Parser0.ml"
                  
                in
                
# 448 "asllib/Parser0.mly"
        ( make_func name args None (SB_ASL body) )
# 16174 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 16183 "asllib/Parser0.ml"
              
            in
            
# 233 "asllib/Parser0.mly"
                      Some  
# 16189 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 16195 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _2;
                          MenhirLib.EngineTypes.startp = _startpos__2_;
                          MenhirLib.EngineTypes.endp = _endpos__2_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 16278 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let (_1_inlined1, _2, _1) = (_1_inlined4, _2_inlined1, _1_inlined3) in
                  let _3 = _1_inlined1 in
                  let _3_1 = _3 in
                  
# 604 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 16296 "asllib/Parser0.ml"
                   _3_1
                in
                let args =
                  let x = 
# 298 "asllib/Parser0.mly"
                ( [] )
# 16303 "asllib/Parser0.ml"
                   in
                  
# 205 "<standard.mly>"
    ( x )
# 16308 "asllib/Parser0.ml"
                  
                in
                let name = _1_inlined1 in
                
# 448 "asllib/Parser0.mly"
        ( make_func name args None (SB_ASL body) )
# 16315 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 16324 "asllib/Parser0.ml"
              
            in
            
# 233 "asllib/Parser0.mly"
                      Some  
# 16330 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 16336 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined5;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined4;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined3;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _2;
                            MenhirLib.EngineTypes.startp = _startpos__2_;
                            MenhirLib.EngineTypes.endp = _endpos__2_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = _1;
                              MenhirLib.EngineTypes.startp = _startpos__1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined5 : (AST.stmt list) = Obj.magic _1_inlined5 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined3 : (AST.typed_identifier list) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 16426 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let (_1_inlined1, _2, _1) = (_1_inlined5, _2_inlined1, _1_inlined4) in
                  let _3 = _1_inlined1 in
                  let _3_1 = _3 in
                  
# 604 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 16444 "asllib/Parser0.ml"
                   _3_1
                in
                let args =
                  let _1_inlined1 = _1_inlined3 in
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 16453 "asllib/Parser0.ml"
                  
                in
                let name = _1_inlined1 in
                
# 448 "asllib/Parser0.mly"
        ( make_func name args None (SB_ASL body) )
# 16460 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 16469 "asllib/Parser0.ml"
              
            in
            
# 233 "asllib/Parser0.mly"
                      Some  
# 16475 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 16481 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _2;
                          MenhirLib.EngineTypes.startp = _startpos__2_;
                          MenhirLib.EngineTypes.endp = _endpos__2_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let (_1_inlined1, _2, _1) = (_1_inlined4, _2_inlined1, _1_inlined3) in
                  let _3 = _1_inlined1 in
                  let _3_1 = _3 in
                  
# 604 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 16578 "asllib/Parser0.ml"
                   _3_1
                in
                let args =
                  let x = 
# 298 "asllib/Parser0.mly"
                ( [] )
# 16585 "asllib/Parser0.ml"
                   in
                  
# 205 "<standard.mly>"
    ( x )
# 16590 "asllib/Parser0.ml"
                  
                in
                let name =
                  let _1 = _1_inlined1 in
                  
# 349 "asllib/Parser0.mly"
              ( "record" )
# 16598 "asllib/Parser0.ml"
                  
                in
                
# 448 "asllib/Parser0.mly"
        ( make_func name args None (SB_ASL body) )
# 16604 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 16613 "asllib/Parser0.ml"
              
            in
            
# 233 "asllib/Parser0.mly"
                      Some  
# 16619 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 16625 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined5;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined4;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined3;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _2;
                            MenhirLib.EngineTypes.startp = _startpos__2_;
                            MenhirLib.EngineTypes.endp = _endpos__2_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = _1;
                              MenhirLib.EngineTypes.startp = _startpos__1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined5 : (AST.stmt list) = Obj.magic _1_inlined5 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined3 : (AST.typed_identifier list) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let (_1_inlined1, _2, _1) = (_1_inlined5, _2_inlined1, _1_inlined4) in
                  let _3 = _1_inlined1 in
                  let _3_1 = _3 in
                  
# 604 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 16729 "asllib/Parser0.ml"
                   _3_1
                in
                let args =
                  let _1_inlined1 = _1_inlined3 in
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 16738 "asllib/Parser0.ml"
                  
                in
                let name =
                  let _1 = _1_inlined1 in
                  
# 349 "asllib/Parser0.mly"
              ( "record" )
# 16746 "asllib/Parser0.ml"
                  
                in
                
# 448 "asllib/Parser0.mly"
        ( make_func name args None (SB_ASL body) )
# 16752 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 16761 "asllib/Parser0.ml"
              
            in
            
# 233 "asllib/Parser0.mly"
                      Some  
# 16767 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 16773 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _5;
            MenhirLib.EngineTypes.startp = _startpos__5_;
            MenhirLib.EngineTypes.endp = _endpos__5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _2;
                    MenhirLib.EngineTypes.startp = _startpos__2_;
                    MenhirLib.EngineTypes.endp = _endpos__2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = q;
                      MenhirLib.EngineTypes.startp = _startpos_q_;
                      MenhirLib.EngineTypes.endp = _endpos_q_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = x;
                        MenhirLib.EngineTypes.startp = _startpos_x_;
                        MenhirLib.EngineTypes.endp = _endpos_x_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _5 : unit = Obj.magic _5 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 16841 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 16847 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let x : (AST.ty) = Obj.magic x in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_x_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _4 = 
# 123 "<standard.mly>"
    ( None )
# 16859 "asllib/Parser0.ml"
               in
              let _3 =
                let x = 
# 298 "asllib/Parser0.mly"
                ( [] )
# 16865 "asllib/Parser0.ml"
                 in
                
# 205 "<standard.mly>"
    ( x )
# 16870 "asllib/Parser0.ml"
                
              in
              let _2 =
                let i = _1 in
                
# 347 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 16878 "asllib/Parser0.ml"
                
              in
              let _1 = 
# 233 "asllib/Parser0.mly"
                      Some  
# 16884 "asllib/Parser0.ml"
               x in
              _5
            in
            
# 264 "asllib/Parser0.mly"
                                ( None )
# 16891 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 16897 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _5;
            MenhirLib.EngineTypes.startp = _startpos__5_;
            MenhirLib.EngineTypes.endp = _endpos__5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = x_inlined1;
              MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _2;
                      MenhirLib.EngineTypes.startp = _startpos__2_;
                      MenhirLib.EngineTypes.endp = _endpos__2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = q;
                        MenhirLib.EngineTypes.startp = _startpos_q_;
                        MenhirLib.EngineTypes.endp = _endpos_q_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = x;
                          MenhirLib.EngineTypes.startp = _startpos_x_;
                          MenhirLib.EngineTypes.endp = _endpos_x_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _5 : unit = Obj.magic _5 in
        let x_inlined1 : unit = Obj.magic x_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 16972 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 16978 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let x : (AST.ty) = Obj.magic x in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_x_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _4 =
                let x = x_inlined1 in
                
# 126 "<standard.mly>"
    ( Some x )
# 16992 "asllib/Parser0.ml"
                
              in
              let _3 =
                let x = 
# 298 "asllib/Parser0.mly"
                ( [] )
# 16999 "asllib/Parser0.ml"
                 in
                
# 205 "<standard.mly>"
    ( x )
# 17004 "asllib/Parser0.ml"
                
              in
              let _2 =
                let i = _1 in
                
# 347 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 17012 "asllib/Parser0.ml"
                
              in
              let _1 = 
# 233 "asllib/Parser0.mly"
                      Some  
# 17018 "asllib/Parser0.ml"
               x in
              _5
            in
            
# 264 "asllib/Parser0.mly"
                                ( None )
# 17025 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 17031 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _5;
            MenhirLib.EngineTypes.startp = _startpos__5_;
            MenhirLib.EngineTypes.endp = _endpos__5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _2;
                      MenhirLib.EngineTypes.startp = _startpos__2_;
                      MenhirLib.EngineTypes.endp = _endpos__2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = q;
                        MenhirLib.EngineTypes.startp = _startpos_q_;
                        MenhirLib.EngineTypes.endp = _endpos_q_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = x;
                          MenhirLib.EngineTypes.startp = _startpos_x_;
                          MenhirLib.EngineTypes.endp = _endpos_x_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _5 : unit = Obj.magic _5 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (AST.typed_identifier list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 17106 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 17112 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let x : (AST.ty) = Obj.magic x in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_x_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _4 = 
# 123 "<standard.mly>"
    ( None )
# 17124 "asllib/Parser0.ml"
               in
              let _3 =
                let _1_inlined1 = _1_inlined2 in
                let x = _1_inlined1 in
                
# 205 "<standard.mly>"
    ( x )
# 17132 "asllib/Parser0.ml"
                
              in
              let _2 =
                let i = _1 in
                
# 347 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 17140 "asllib/Parser0.ml"
                
              in
              let _1 = 
# 233 "asllib/Parser0.mly"
                      Some  
# 17146 "asllib/Parser0.ml"
               x in
              _5
            in
            
# 264 "asllib/Parser0.mly"
                                ( None )
# 17153 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 17159 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _5;
            MenhirLib.EngineTypes.startp = _startpos__5_;
            MenhirLib.EngineTypes.endp = _endpos__5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = x_inlined1;
              MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _2;
                        MenhirLib.EngineTypes.startp = _startpos__2_;
                        MenhirLib.EngineTypes.endp = _endpos__2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = q;
                          MenhirLib.EngineTypes.startp = _startpos_q_;
                          MenhirLib.EngineTypes.endp = _endpos_q_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = x;
                            MenhirLib.EngineTypes.startp = _startpos_x_;
                            MenhirLib.EngineTypes.endp = _endpos_x_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _5 : unit = Obj.magic _5 in
        let x_inlined1 : unit = Obj.magic x_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (AST.typed_identifier list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 17241 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 17247 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let x : (AST.ty) = Obj.magic x in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_x_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _4 =
                let x = x_inlined1 in
                
# 126 "<standard.mly>"
    ( Some x )
# 17261 "asllib/Parser0.ml"
                
              in
              let _3 =
                let _1_inlined1 = _1_inlined2 in
                let x = _1_inlined1 in
                
# 205 "<standard.mly>"
    ( x )
# 17270 "asllib/Parser0.ml"
                
              in
              let _2 =
                let i = _1 in
                
# 347 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 17278 "asllib/Parser0.ml"
                
              in
              let _1 = 
# 233 "asllib/Parser0.mly"
                      Some  
# 17284 "asllib/Parser0.ml"
               x in
              _5
            in
            
# 264 "asllib/Parser0.mly"
                                ( None )
# 17291 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 17297 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _5;
            MenhirLib.EngineTypes.startp = _startpos__5_;
            MenhirLib.EngineTypes.endp = _endpos__5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = x;
                    MenhirLib.EngineTypes.startp = _startpos_x_;
                    MenhirLib.EngineTypes.endp = _endpos_x_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _5 : unit = Obj.magic _5 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 17353 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let x : (AST.ty) = Obj.magic x in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_x_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _4 = 
# 123 "<standard.mly>"
    ( None )
# 17365 "asllib/Parser0.ml"
               in
              let _3 =
                let x = 
# 298 "asllib/Parser0.mly"
                ( [] )
# 17371 "asllib/Parser0.ml"
                 in
                
# 205 "<standard.mly>"
    ( x )
# 17376 "asllib/Parser0.ml"
                
              in
              let _2 = _1 in
              let _1 = 
# 233 "asllib/Parser0.mly"
                      Some  
# 17383 "asllib/Parser0.ml"
               x in
              _5
            in
            
# 264 "asllib/Parser0.mly"
                                ( None )
# 17390 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 17396 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _5;
            MenhirLib.EngineTypes.startp = _startpos__5_;
            MenhirLib.EngineTypes.endp = _endpos__5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = x_inlined1;
              MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = x;
                      MenhirLib.EngineTypes.startp = _startpos_x_;
                      MenhirLib.EngineTypes.endp = _endpos_x_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _5 : unit = Obj.magic _5 in
        let x_inlined1 : unit = Obj.magic x_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 17459 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let x : (AST.ty) = Obj.magic x in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_x_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _4 =
                let x = x_inlined1 in
                
# 126 "<standard.mly>"
    ( Some x )
# 17473 "asllib/Parser0.ml"
                
              in
              let _3 =
                let x = 
# 298 "asllib/Parser0.mly"
                ( [] )
# 17480 "asllib/Parser0.ml"
                 in
                
# 205 "<standard.mly>"
    ( x )
# 17485 "asllib/Parser0.ml"
                
              in
              let _2 = _1 in
              let _1 = 
# 233 "asllib/Parser0.mly"
                      Some  
# 17492 "asllib/Parser0.ml"
               x in
              _5
            in
            
# 264 "asllib/Parser0.mly"
                                ( None )
# 17499 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 17505 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _5;
            MenhirLib.EngineTypes.startp = _startpos__5_;
            MenhirLib.EngineTypes.endp = _endpos__5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = x;
                      MenhirLib.EngineTypes.startp = _startpos_x_;
                      MenhirLib.EngineTypes.endp = _endpos_x_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _5 : unit = Obj.magic _5 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (AST.typed_identifier list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 17568 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let x : (AST.ty) = Obj.magic x in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_x_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _4 = 
# 123 "<standard.mly>"
    ( None )
# 17580 "asllib/Parser0.ml"
               in
              let _3 =
                let _1_inlined1 = _1_inlined2 in
                let x = _1_inlined1 in
                
# 205 "<standard.mly>"
    ( x )
# 17588 "asllib/Parser0.ml"
                
              in
              let _2 = _1 in
              let _1 = 
# 233 "asllib/Parser0.mly"
                      Some  
# 17595 "asllib/Parser0.ml"
               x in
              _5
            in
            
# 264 "asllib/Parser0.mly"
                                ( None )
# 17602 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 17608 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _5;
            MenhirLib.EngineTypes.startp = _startpos__5_;
            MenhirLib.EngineTypes.endp = _endpos__5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = x_inlined1;
              MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = x;
                        MenhirLib.EngineTypes.startp = _startpos_x_;
                        MenhirLib.EngineTypes.endp = _endpos_x_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _5 : unit = Obj.magic _5 in
        let x_inlined1 : unit = Obj.magic x_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (AST.typed_identifier list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 17678 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let x : (AST.ty) = Obj.magic x in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_x_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _4 =
                let x = x_inlined1 in
                
# 126 "<standard.mly>"
    ( Some x )
# 17692 "asllib/Parser0.ml"
                
              in
              let _3 =
                let _1_inlined1 = _1_inlined2 in
                let x = _1_inlined1 in
                
# 205 "<standard.mly>"
    ( x )
# 17701 "asllib/Parser0.ml"
                
              in
              let _2 = _1 in
              let _1 = 
# 233 "asllib/Parser0.mly"
                      Some  
# 17708 "asllib/Parser0.ml"
               x in
              _5
            in
            
# 264 "asllib/Parser0.mly"
                                ( None )
# 17715 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 17721 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _5;
            MenhirLib.EngineTypes.startp = _startpos__5_;
            MenhirLib.EngineTypes.endp = _endpos__5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = x;
                    MenhirLib.EngineTypes.startp = _startpos_x_;
                    MenhirLib.EngineTypes.endp = _endpos_x_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _5 : unit = Obj.magic _5 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let x : (AST.ty) = Obj.magic x in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_x_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _4 = 
# 123 "<standard.mly>"
    ( None )
# 17785 "asllib/Parser0.ml"
               in
              let _3 =
                let x = 
# 298 "asllib/Parser0.mly"
                ( [] )
# 17791 "asllib/Parser0.ml"
                 in
                
# 205 "<standard.mly>"
    ( x )
# 17796 "asllib/Parser0.ml"
                
              in
              let _2 = 
# 349 "asllib/Parser0.mly"
              ( "record" )
# 17802 "asllib/Parser0.ml"
               in
              let _1 = 
# 233 "asllib/Parser0.mly"
                      Some  
# 17807 "asllib/Parser0.ml"
               x in
              _5
            in
            
# 264 "asllib/Parser0.mly"
                                ( None )
# 17814 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 17820 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _5;
            MenhirLib.EngineTypes.startp = _startpos__5_;
            MenhirLib.EngineTypes.endp = _endpos__5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = x_inlined1;
              MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = x;
                      MenhirLib.EngineTypes.startp = _startpos_x_;
                      MenhirLib.EngineTypes.endp = _endpos_x_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _5 : unit = Obj.magic _5 in
        let x_inlined1 : unit = Obj.magic x_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let x : (AST.ty) = Obj.magic x in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_x_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _4 =
                let x = x_inlined1 in
                
# 126 "<standard.mly>"
    ( Some x )
# 17893 "asllib/Parser0.ml"
                
              in
              let _3 =
                let x = 
# 298 "asllib/Parser0.mly"
                ( [] )
# 17900 "asllib/Parser0.ml"
                 in
                
# 205 "<standard.mly>"
    ( x )
# 17905 "asllib/Parser0.ml"
                
              in
              let _2 = 
# 349 "asllib/Parser0.mly"
              ( "record" )
# 17911 "asllib/Parser0.ml"
               in
              let _1 = 
# 233 "asllib/Parser0.mly"
                      Some  
# 17916 "asllib/Parser0.ml"
               x in
              _5
            in
            
# 264 "asllib/Parser0.mly"
                                ( None )
# 17923 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 17929 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _5;
            MenhirLib.EngineTypes.startp = _startpos__5_;
            MenhirLib.EngineTypes.endp = _endpos__5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = x;
                      MenhirLib.EngineTypes.startp = _startpos_x_;
                      MenhirLib.EngineTypes.endp = _endpos_x_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _5 : unit = Obj.magic _5 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (AST.typed_identifier list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let x : (AST.ty) = Obj.magic x in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_x_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _4 = 
# 123 "<standard.mly>"
    ( None )
# 18000 "asllib/Parser0.ml"
               in
              let _3 =
                let _1_inlined1 = _1_inlined2 in
                let x = _1_inlined1 in
                
# 205 "<standard.mly>"
    ( x )
# 18008 "asllib/Parser0.ml"
                
              in
              let _2 = 
# 349 "asllib/Parser0.mly"
              ( "record" )
# 18014 "asllib/Parser0.ml"
               in
              let _1 = 
# 233 "asllib/Parser0.mly"
                      Some  
# 18019 "asllib/Parser0.ml"
               x in
              _5
            in
            
# 264 "asllib/Parser0.mly"
                                ( None )
# 18026 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 18032 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _5;
            MenhirLib.EngineTypes.startp = _startpos__5_;
            MenhirLib.EngineTypes.endp = _endpos__5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = x_inlined1;
              MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = x;
                        MenhirLib.EngineTypes.startp = _startpos_x_;
                        MenhirLib.EngineTypes.endp = _endpos_x_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _5 : unit = Obj.magic _5 in
        let x_inlined1 : unit = Obj.magic x_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (AST.typed_identifier list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let x : (AST.ty) = Obj.magic x in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_x_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _4 =
                let x = x_inlined1 in
                
# 126 "<standard.mly>"
    ( Some x )
# 18112 "asllib/Parser0.ml"
                
              in
              let _3 =
                let _1_inlined1 = _1_inlined2 in
                let x = _1_inlined1 in
                
# 205 "<standard.mly>"
    ( x )
# 18121 "asllib/Parser0.ml"
                
              in
              let _2 = 
# 349 "asllib/Parser0.mly"
              ( "record" )
# 18127 "asllib/Parser0.ml"
               in
              let _1 = 
# 233 "asllib/Parser0.mly"
                      Some  
# 18132 "asllib/Parser0.ml"
               x in
              _5
            in
            
# 264 "asllib/Parser0.mly"
                                ( None )
# 18139 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 18145 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _2;
                          MenhirLib.EngineTypes.startp = _startpos__2_;
                          MenhirLib.EngineTypes.endp = _endpos__2_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = q;
                            MenhirLib.EngineTypes.startp = _startpos_q_;
                            MenhirLib.EngineTypes.endp = _endpos_q_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 18228 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 18234 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let (_1_inlined1, _2, _1) = (_1_inlined3, _2_inlined1, _1_inlined2) in
                  let _3 = _1_inlined1 in
                  let _3_1 = _3 in
                  
# 604 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 18250 "asllib/Parser0.ml"
                   _3_1
                in
                let args =
                  let x = 
# 298 "asllib/Parser0.mly"
                ( [] )
# 18257 "asllib/Parser0.ml"
                   in
                  
# 205 "<standard.mly>"
    ( x )
# 18262 "asllib/Parser0.ml"
                  
                in
                let name =
                  let i = _1 in
                  
# 347 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 18270 "asllib/Parser0.ml"
                  
                in
                
# 571 "asllib/Parser0.mly"
        (
          let open AST in
          let return_type = None
          and parameters = []
          and body = SB_ASL body
          and recurse_limit = None
          and subprogram_type = ST_Procedure in
          D_Func {
            name;
            args;
            return_type;
            body;
            parameters;
            subprogram_type;
            recurse_limit;
            builtin = false;
          }
        )
# 18293 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos_q_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 18302 "asllib/Parser0.ml"
              
            in
            
# 233 "asllib/Parser0.mly"
                      Some  
# 18308 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 18314 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _2;
                            MenhirLib.EngineTypes.startp = _startpos__2_;
                            MenhirLib.EngineTypes.endp = _endpos__2_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = q;
                              MenhirLib.EngineTypes.startp = _startpos_q_;
                              MenhirLib.EngineTypes.endp = _endpos_q_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (AST.typed_identifier list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 18404 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 18410 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let (_1_inlined1, _2, _1) = (_1_inlined4, _2_inlined1, _1_inlined3) in
                  let _3 = _1_inlined1 in
                  let _3_1 = _3 in
                  
# 604 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 18426 "asllib/Parser0.ml"
                   _3_1
                in
                let args =
                  let _1_inlined1 = _1_inlined2 in
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 18435 "asllib/Parser0.ml"
                  
                in
                let name =
                  let i = _1 in
                  
# 347 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 18443 "asllib/Parser0.ml"
                  
                in
                
# 571 "asllib/Parser0.mly"
        (
          let open AST in
          let return_type = None
          and parameters = []
          and body = SB_ASL body
          and recurse_limit = None
          and subprogram_type = ST_Procedure in
          D_Func {
            name;
            args;
            return_type;
            body;
            parameters;
            subprogram_type;
            recurse_limit;
            builtin = false;
          }
        )
# 18466 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos_q_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 18475 "asllib/Parser0.ml"
              
            in
            
# 233 "asllib/Parser0.mly"
                      Some  
# 18481 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 18487 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 18558 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let (_1_inlined1, _1) = (_1_inlined3, _1_inlined2) in
                  let _3 = _1_inlined1 in
                  let _3_1 = _3 in
                  
# 604 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 18574 "asllib/Parser0.ml"
                   _3_1
                in
                let args =
                  let x = 
# 298 "asllib/Parser0.mly"
                ( [] )
# 18581 "asllib/Parser0.ml"
                   in
                  
# 205 "<standard.mly>"
    ( x )
# 18586 "asllib/Parser0.ml"
                  
                in
                let name = _1 in
                
# 571 "asllib/Parser0.mly"
        (
          let open AST in
          let return_type = None
          and parameters = []
          and body = SB_ASL body
          and recurse_limit = None
          and subprogram_type = ST_Procedure in
          D_Func {
            name;
            args;
            return_type;
            body;
            parameters;
            subprogram_type;
            recurse_limit;
            builtin = false;
          }
        )
# 18610 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 18619 "asllib/Parser0.ml"
              
            in
            
# 233 "asllib/Parser0.mly"
                      Some  
# 18625 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 18631 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (AST.typed_identifier list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 18709 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let (_1_inlined1, _1) = (_1_inlined4, _1_inlined3) in
                  let _3 = _1_inlined1 in
                  let _3_1 = _3 in
                  
# 604 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 18725 "asllib/Parser0.ml"
                   _3_1
                in
                let args =
                  let _1_inlined1 = _1_inlined2 in
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 18734 "asllib/Parser0.ml"
                  
                in
                let name = _1 in
                
# 571 "asllib/Parser0.mly"
        (
          let open AST in
          let return_type = None
          and parameters = []
          and body = SB_ASL body
          and recurse_limit = None
          and subprogram_type = ST_Procedure in
          D_Func {
            name;
            args;
            return_type;
            body;
            parameters;
            subprogram_type;
            recurse_limit;
            builtin = false;
          }
        )
# 18758 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 18767 "asllib/Parser0.ml"
              
            in
            
# 233 "asllib/Parser0.mly"
                      Some  
# 18773 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 18779 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let (_1_inlined1, _1) = (_1_inlined3, _1_inlined2) in
                  let _3 = _1_inlined1 in
                  let _3_1 = _3 in
                  
# 604 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 18862 "asllib/Parser0.ml"
                   _3_1
                in
                let args =
                  let x = 
# 298 "asllib/Parser0.mly"
                ( [] )
# 18869 "asllib/Parser0.ml"
                   in
                  
# 205 "<standard.mly>"
    ( x )
# 18874 "asllib/Parser0.ml"
                  
                in
                let name = 
# 349 "asllib/Parser0.mly"
              ( "record" )
# 18880 "asllib/Parser0.ml"
                 in
                
# 571 "asllib/Parser0.mly"
        (
          let open AST in
          let return_type = None
          and parameters = []
          and body = SB_ASL body
          and recurse_limit = None
          and subprogram_type = ST_Procedure in
          D_Func {
            name;
            args;
            return_type;
            body;
            parameters;
            subprogram_type;
            recurse_limit;
            builtin = false;
          }
        )
# 18902 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 18911 "asllib/Parser0.ml"
              
            in
            
# 233 "asllib/Parser0.mly"
                      Some  
# 18917 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 18923 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (AST.typed_identifier list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let (_1_inlined1, _1) = (_1_inlined4, _1_inlined3) in
                  let _3 = _1_inlined1 in
                  let _3_1 = _3 in
                  
# 604 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 19013 "asllib/Parser0.ml"
                   _3_1
                in
                let args =
                  let _1_inlined1 = _1_inlined2 in
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 19022 "asllib/Parser0.ml"
                  
                in
                let name = 
# 349 "asllib/Parser0.mly"
              ( "record" )
# 19028 "asllib/Parser0.ml"
                 in
                
# 571 "asllib/Parser0.mly"
        (
          let open AST in
          let return_type = None
          and parameters = []
          and body = SB_ASL body
          and recurse_limit = None
          and subprogram_type = ST_Procedure in
          D_Func {
            name;
            args;
            return_type;
            body;
            parameters;
            subprogram_type;
            recurse_limit;
            builtin = false;
          }
        )
# 19050 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 19059 "asllib/Parser0.ml"
              
            in
            
# 233 "asllib/Parser0.mly"
                      Some  
# 19065 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 19071 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _2_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = q;
                      MenhirLib.EngineTypes.startp = _startpos_q_;
                      MenhirLib.EngineTypes.endp = _endpos_q_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 19133 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 19139 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _3 = 
# 123 "<standard.mly>"
    ( None )
# 19150 "asllib/Parser0.ml"
               in
              let _2 =
                let x = 
# 298 "asllib/Parser0.mly"
                ( [] )
# 19156 "asllib/Parser0.ml"
                 in
                
# 205 "<standard.mly>"
    ( x )
# 19161 "asllib/Parser0.ml"
                
              in
              let _1 =
                let _2 = _2_inlined1 in
                let i = _1 in
                
# 347 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 19170 "asllib/Parser0.ml"
                
              in
              _4
            in
            
# 264 "asllib/Parser0.mly"
                                ( None )
# 19178 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 19184 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = x;
              MenhirLib.EngineTypes.startp = _startpos_x_;
              MenhirLib.EngineTypes.endp = _endpos_x_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _2_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = q;
                        MenhirLib.EngineTypes.startp = _startpos_q_;
                        MenhirLib.EngineTypes.endp = _endpos_q_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let x : unit = Obj.magic x in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 19253 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 19259 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _3 = 
# 126 "<standard.mly>"
    ( Some x )
# 19270 "asllib/Parser0.ml"
               in
              let _2 =
                let x = 
# 298 "asllib/Parser0.mly"
                ( [] )
# 19276 "asllib/Parser0.ml"
                 in
                
# 205 "<standard.mly>"
    ( x )
# 19281 "asllib/Parser0.ml"
                
              in
              let _1 =
                let _2 = _2_inlined1 in
                let i = _1 in
                
# 347 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 19290 "asllib/Parser0.ml"
                
              in
              _4
            in
            
# 264 "asllib/Parser0.mly"
                                ( None )
# 19298 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 19304 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _2_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = q;
                        MenhirLib.EngineTypes.startp = _startpos_q_;
                        MenhirLib.EngineTypes.endp = _endpos_q_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (AST.typed_identifier list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 19373 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 19379 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _3 = 
# 123 "<standard.mly>"
    ( None )
# 19390 "asllib/Parser0.ml"
               in
              let _2 =
                let _1_inlined1 = _1_inlined2 in
                let x = _1_inlined1 in
                
# 205 "<standard.mly>"
    ( x )
# 19398 "asllib/Parser0.ml"
                
              in
              let _1 =
                let _2 = _2_inlined1 in
                let i = _1 in
                
# 347 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 19407 "asllib/Parser0.ml"
                
              in
              _4
            in
            
# 264 "asllib/Parser0.mly"
                                ( None )
# 19415 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 19421 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = x;
              MenhirLib.EngineTypes.startp = _startpos_x_;
              MenhirLib.EngineTypes.endp = _endpos_x_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _2_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = q;
                          MenhirLib.EngineTypes.startp = _startpos_q_;
                          MenhirLib.EngineTypes.endp = _endpos_q_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let x : unit = Obj.magic x in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (AST.typed_identifier list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 19497 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 19503 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _3 = 
# 126 "<standard.mly>"
    ( Some x )
# 19514 "asllib/Parser0.ml"
               in
              let _2 =
                let _1_inlined1 = _1_inlined2 in
                let x = _1_inlined1 in
                
# 205 "<standard.mly>"
    ( x )
# 19522 "asllib/Parser0.ml"
                
              in
              let _1 =
                let _2 = _2_inlined1 in
                let i = _1 in
                
# 347 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 19531 "asllib/Parser0.ml"
                
              in
              _4
            in
            
# 264 "asllib/Parser0.mly"
                                ( None )
# 19539 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 19545 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 19595 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _3 = 
# 123 "<standard.mly>"
    ( None )
# 19606 "asllib/Parser0.ml"
               in
              let _2 =
                let x = 
# 298 "asllib/Parser0.mly"
                ( [] )
# 19612 "asllib/Parser0.ml"
                 in
                
# 205 "<standard.mly>"
    ( x )
# 19617 "asllib/Parser0.ml"
                
              in
              _4
            in
            
# 264 "asllib/Parser0.mly"
                                ( None )
# 19625 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 19631 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = x;
              MenhirLib.EngineTypes.startp = _startpos_x_;
              MenhirLib.EngineTypes.endp = _endpos_x_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let x : unit = Obj.magic x in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 19688 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _3 = 
# 126 "<standard.mly>"
    ( Some x )
# 19699 "asllib/Parser0.ml"
               in
              let _2 =
                let x = 
# 298 "asllib/Parser0.mly"
                ( [] )
# 19705 "asllib/Parser0.ml"
                 in
                
# 205 "<standard.mly>"
    ( x )
# 19710 "asllib/Parser0.ml"
                
              in
              _4
            in
            
# 264 "asllib/Parser0.mly"
                                ( None )
# 19718 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 19724 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (AST.typed_identifier list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 19781 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _3 = 
# 123 "<standard.mly>"
    ( None )
# 19792 "asllib/Parser0.ml"
               in
              let _2 =
                let _1_inlined1 = _1_inlined2 in
                let x = _1_inlined1 in
                
# 205 "<standard.mly>"
    ( x )
# 19800 "asllib/Parser0.ml"
                
              in
              _4
            in
            
# 264 "asllib/Parser0.mly"
                                ( None )
# 19808 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 19814 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = x;
              MenhirLib.EngineTypes.startp = _startpos_x_;
              MenhirLib.EngineTypes.endp = _endpos_x_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let x : unit = Obj.magic x in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (AST.typed_identifier list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 19878 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _3 = 
# 126 "<standard.mly>"
    ( Some x )
# 19889 "asllib/Parser0.ml"
               in
              let _2 =
                let _1_inlined1 = _1_inlined2 in
                let x = _1_inlined1 in
                
# 205 "<standard.mly>"
    ( x )
# 19897 "asllib/Parser0.ml"
                
              in
              _4
            in
            
# 264 "asllib/Parser0.mly"
                                ( None )
# 19905 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 19911 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _3 = 
# 123 "<standard.mly>"
    ( None )
# 19968 "asllib/Parser0.ml"
               in
              let _2 =
                let x = 
# 298 "asllib/Parser0.mly"
                ( [] )
# 19974 "asllib/Parser0.ml"
                 in
                
# 205 "<standard.mly>"
    ( x )
# 19979 "asllib/Parser0.ml"
                
              in
              let _1 = 
# 349 "asllib/Parser0.mly"
              ( "record" )
# 19985 "asllib/Parser0.ml"
               in
              _4
            in
            
# 264 "asllib/Parser0.mly"
                                ( None )
# 19992 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 19998 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = x;
              MenhirLib.EngineTypes.startp = _startpos_x_;
              MenhirLib.EngineTypes.endp = _endpos_x_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let x : unit = Obj.magic x in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _3 = 
# 126 "<standard.mly>"
    ( Some x )
# 20062 "asllib/Parser0.ml"
               in
              let _2 =
                let x = 
# 298 "asllib/Parser0.mly"
                ( [] )
# 20068 "asllib/Parser0.ml"
                 in
                
# 205 "<standard.mly>"
    ( x )
# 20073 "asllib/Parser0.ml"
                
              in
              let _1 = 
# 349 "asllib/Parser0.mly"
              ( "record" )
# 20079 "asllib/Parser0.ml"
               in
              _4
            in
            
# 264 "asllib/Parser0.mly"
                                ( None )
# 20086 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 20092 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (AST.typed_identifier list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _3 = 
# 123 "<standard.mly>"
    ( None )
# 20156 "asllib/Parser0.ml"
               in
              let _2 =
                let _1_inlined1 = _1_inlined2 in
                let x = _1_inlined1 in
                
# 205 "<standard.mly>"
    ( x )
# 20164 "asllib/Parser0.ml"
                
              in
              let _1 = 
# 349 "asllib/Parser0.mly"
              ( "record" )
# 20170 "asllib/Parser0.ml"
               in
              _4
            in
            
# 264 "asllib/Parser0.mly"
                                ( None )
# 20177 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 20183 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = x;
              MenhirLib.EngineTypes.startp = _startpos_x_;
              MenhirLib.EngineTypes.endp = _endpos_x_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let x : unit = Obj.magic x in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (AST.typed_identifier list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _3 = 
# 126 "<standard.mly>"
    ( Some x )
# 20254 "asllib/Parser0.ml"
               in
              let _2 =
                let _1_inlined1 = _1_inlined2 in
                let x = _1_inlined1 in
                
# 205 "<standard.mly>"
    ( x )
# 20262 "asllib/Parser0.ml"
                
              in
              let _1 = 
# 349 "asllib/Parser0.mly"
              ( "record" )
# 20268 "asllib/Parser0.ml"
               in
              _4
            in
            
# 264 "asllib/Parser0.mly"
                                ( None )
# 20275 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 20281 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _2;
                      MenhirLib.EngineTypes.startp = _startpos__2_;
                      MenhirLib.EngineTypes.endp = _endpos__2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = q;
                        MenhirLib.EngineTypes.startp = _startpos_q_;
                        MenhirLib.EngineTypes.endp = _endpos_q_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = ty;
                          MenhirLib.EngineTypes.startp = _startpos_ty_;
                          MenhirLib.EngineTypes.endp = _endpos_ty_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 20356 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 20362 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let ty : (AST.ty) = Obj.magic ty in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_ty_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let (_1_inlined1, _2, _1) = (_1_inlined2, _2_inlined1, _1_inlined1) in
                  let _3 = _1_inlined1 in
                  let _3_1 = _3 in
                  
# 604 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 20379 "asllib/Parser0.ml"
                   _3_1
                in
                let name =
                  let i = _1 in
                  
# 347 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 20387 "asllib/Parser0.ml"
                  
                in
                
# 457 "asllib/Parser0.mly"
      (
        let open AST in
        let return_type = Some ty
        and args = []
        and body = SB_ASL body
        and subprogram_type = ST_EmptyGetter
        and recurse_limit = None
        and parameters = [] in
        D_Func {
          name;
          args;
          return_type;
          body;
          parameters;
          subprogram_type;
          recurse_limit;
          builtin = false;
        }
      )
# 20411 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos_ty_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 20420 "asllib/Parser0.ml"
              
            in
            
# 233 "asllib/Parser0.mly"
                      Some  
# 20426 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 20432 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = ty;
                      MenhirLib.EngineTypes.startp = _startpos_ty_;
                      MenhirLib.EngineTypes.endp = _endpos_ty_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 20495 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let ty : (AST.ty) = Obj.magic ty in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_ty_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                  let _3 = _1_inlined1 in
                  let _3_1 = _3 in
                  
# 604 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 20512 "asllib/Parser0.ml"
                   _3_1
                in
                let name = _1 in
                
# 457 "asllib/Parser0.mly"
      (
        let open AST in
        let return_type = Some ty
        and args = []
        and body = SB_ASL body
        and subprogram_type = ST_EmptyGetter
        and recurse_limit = None
        and parameters = [] in
        D_Func {
          name;
          args;
          return_type;
          body;
          parameters;
          subprogram_type;
          recurse_limit;
          builtin = false;
        }
      )
# 20537 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos_ty_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 20546 "asllib/Parser0.ml"
              
            in
            
# 233 "asllib/Parser0.mly"
                      Some  
# 20552 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 20558 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = ty;
                      MenhirLib.EngineTypes.startp = _startpos_ty_;
                      MenhirLib.EngineTypes.endp = _endpos_ty_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let ty : (AST.ty) = Obj.magic ty in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_ty_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                  let _3 = _1_inlined1 in
                  let _3_1 = _3 in
                  
# 604 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 20634 "asllib/Parser0.ml"
                   _3_1
                in
                let name = 
# 349 "asllib/Parser0.mly"
              ( "record" )
# 20640 "asllib/Parser0.ml"
                 in
                
# 457 "asllib/Parser0.mly"
      (
        let open AST in
        let return_type = Some ty
        and args = []
        and body = SB_ASL body
        and subprogram_type = ST_EmptyGetter
        and recurse_limit = None
        and parameters = [] in
        D_Func {
          name;
          args;
          return_type;
          body;
          parameters;
          subprogram_type;
          recurse_limit;
          builtin = false;
        }
      )
# 20663 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos_ty_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 20672 "asllib/Parser0.ml"
              
            in
            
# 233 "asllib/Parser0.mly"
                      Some  
# 20678 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 20684 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _5;
            MenhirLib.EngineTypes.startp = _startpos__5_;
            MenhirLib.EngineTypes.endp = _endpos__5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _4;
              MenhirLib.EngineTypes.startp = _startpos__4_;
              MenhirLib.EngineTypes.endp = _endpos__4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _4_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__4_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__4_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _2_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _2;
                          MenhirLib.EngineTypes.startp = _startpos__2_;
                          MenhirLib.EngineTypes.endp = _endpos__2_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = q;
                            MenhirLib.EngineTypes.startp = _startpos_q_;
                            MenhirLib.EngineTypes.endp = _endpos_q_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = ty;
                              MenhirLib.EngineTypes.startp = _startpos_ty_;
                              MenhirLib.EngineTypes.endp = _endpos_ty_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _5 : unit = Obj.magic _5 in
        let _4 : unit = Obj.magic _4 in
        let _4_inlined1 : unit = Obj.magic _4_inlined1 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 20773 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 20779 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let ty : (AST.ty) = Obj.magic ty in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_ty_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let (_4, _1_inlined1, _2, _1) = (_4_inlined1, _1_inlined2, _2_inlined1, _1_inlined1) in
                  let _3 = _1_inlined1 in
                  let _3_1 = _3 in
                  
# 604 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 20796 "asllib/Parser0.ml"
                   _3_1
                in
                let name =
                  let i = _1 in
                  
# 347 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 20804 "asllib/Parser0.ml"
                  
                in
                
# 477 "asllib/Parser0.mly"
      (
        let open AST in
        let return_type = Some ty
        and args = []
        and body = SB_ASL body
        and recurse_limit = None
        and subprogram_type = ST_EmptyGetter
        and parameters = [] in
        D_Func {
          name;
          args;
          return_type;
          body;
          parameters;
          subprogram_type;
          recurse_limit;
          builtin = false;
        }
      )
# 20828 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__5_, _startpos_ty_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 20837 "asllib/Parser0.ml"
              
            in
            
# 233 "asllib/Parser0.mly"
                      Some  
# 20843 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 20849 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _5;
            MenhirLib.EngineTypes.startp = _startpos__5_;
            MenhirLib.EngineTypes.endp = _endpos__5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _4;
              MenhirLib.EngineTypes.startp = _startpos__4_;
              MenhirLib.EngineTypes.endp = _endpos__4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _2;
                    MenhirLib.EngineTypes.startp = _startpos__2_;
                    MenhirLib.EngineTypes.endp = _endpos__2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = q;
                      MenhirLib.EngineTypes.startp = _startpos_q_;
                      MenhirLib.EngineTypes.endp = _endpos_q_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = ty;
                        MenhirLib.EngineTypes.startp = _startpos_ty_;
                        MenhirLib.EngineTypes.endp = _endpos_ty_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _5 : unit = Obj.magic _5 in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 20917 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 20923 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let ty : (AST.ty) = Obj.magic ty in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_ty_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let _1 = _1_inlined1 in
                  
# 597 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 20938 "asllib/Parser0.ml"
                  
                in
                let name =
                  let i = _1 in
                  
# 347 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 20946 "asllib/Parser0.ml"
                  
                in
                
# 477 "asllib/Parser0.mly"
      (
        let open AST in
        let return_type = Some ty
        and args = []
        and body = SB_ASL body
        and recurse_limit = None
        and subprogram_type = ST_EmptyGetter
        and parameters = [] in
        D_Func {
          name;
          args;
          return_type;
          body;
          parameters;
          subprogram_type;
          recurse_limit;
          builtin = false;
        }
      )
# 20970 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__5_, _startpos_ty_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 20979 "asllib/Parser0.ml"
              
            in
            
# 233 "asllib/Parser0.mly"
                      Some  
# 20985 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 20991 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _5;
            MenhirLib.EngineTypes.startp = _startpos__5_;
            MenhirLib.EngineTypes.endp = _endpos__5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _4;
              MenhirLib.EngineTypes.startp = _startpos__4_;
              MenhirLib.EngineTypes.endp = _endpos__4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _4_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__4_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__4_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _2;
                    MenhirLib.EngineTypes.startp = _startpos__2_;
                    MenhirLib.EngineTypes.endp = _endpos__2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = ty;
                          MenhirLib.EngineTypes.startp = _startpos_ty_;
                          MenhirLib.EngineTypes.endp = _endpos_ty_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _5 : unit = Obj.magic _5 in
        let _4 : unit = Obj.magic _4 in
        let _4_inlined1 : unit = Obj.magic _4_inlined1 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 21068 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let ty : (AST.ty) = Obj.magic ty in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_ty_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let (_4, _1_inlined1, _1) = (_4_inlined1, _1_inlined2, _1_inlined1) in
                  let _3 = _1_inlined1 in
                  let _3_1 = _3 in
                  
# 604 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 21085 "asllib/Parser0.ml"
                   _3_1
                in
                let name = _1 in
                
# 477 "asllib/Parser0.mly"
      (
        let open AST in
        let return_type = Some ty
        and args = []
        and body = SB_ASL body
        and recurse_limit = None
        and subprogram_type = ST_EmptyGetter
        and parameters = [] in
        D_Func {
          name;
          args;
          return_type;
          body;
          parameters;
          subprogram_type;
          recurse_limit;
          builtin = false;
        }
      )
# 21110 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__5_, _startpos_ty_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 21119 "asllib/Parser0.ml"
              
            in
            
# 233 "asllib/Parser0.mly"
                      Some  
# 21125 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 21131 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _5;
            MenhirLib.EngineTypes.startp = _startpos__5_;
            MenhirLib.EngineTypes.endp = _endpos__5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _4;
              MenhirLib.EngineTypes.startp = _startpos__4_;
              MenhirLib.EngineTypes.endp = _endpos__4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = ty;
                    MenhirLib.EngineTypes.startp = _startpos_ty_;
                    MenhirLib.EngineTypes.endp = _endpos_ty_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _5 : unit = Obj.magic _5 in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 21187 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let ty : (AST.ty) = Obj.magic ty in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_ty_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let _1 = _1_inlined1 in
                  
# 597 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 21202 "asllib/Parser0.ml"
                  
                in
                let name = _1 in
                
# 477 "asllib/Parser0.mly"
      (
        let open AST in
        let return_type = Some ty
        and args = []
        and body = SB_ASL body
        and recurse_limit = None
        and subprogram_type = ST_EmptyGetter
        and parameters = [] in
        D_Func {
          name;
          args;
          return_type;
          body;
          parameters;
          subprogram_type;
          recurse_limit;
          builtin = false;
        }
      )
# 21227 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__5_, _startpos_ty_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 21236 "asllib/Parser0.ml"
              
            in
            
# 233 "asllib/Parser0.mly"
                      Some  
# 21242 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 21248 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _5;
            MenhirLib.EngineTypes.startp = _startpos__5_;
            MenhirLib.EngineTypes.endp = _endpos__5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _4;
              MenhirLib.EngineTypes.startp = _startpos__4_;
              MenhirLib.EngineTypes.endp = _endpos__4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _4_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__4_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__4_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _2;
                    MenhirLib.EngineTypes.startp = _startpos__2_;
                    MenhirLib.EngineTypes.endp = _endpos__2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = ty;
                          MenhirLib.EngineTypes.startp = _startpos_ty_;
                          MenhirLib.EngineTypes.endp = _endpos_ty_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _5 : unit = Obj.magic _5 in
        let _4 : unit = Obj.magic _4 in
        let _4_inlined1 : unit = Obj.magic _4_inlined1 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let ty : (AST.ty) = Obj.magic ty in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_ty_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let (_4, _1_inlined1, _1) = (_4_inlined1, _1_inlined2, _1_inlined1) in
                  let _3 = _1_inlined1 in
                  let _3_1 = _3 in
                  
# 604 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 21338 "asllib/Parser0.ml"
                   _3_1
                in
                let name = 
# 349 "asllib/Parser0.mly"
              ( "record" )
# 21344 "asllib/Parser0.ml"
                 in
                
# 477 "asllib/Parser0.mly"
      (
        let open AST in
        let return_type = Some ty
        and args = []
        and body = SB_ASL body
        and recurse_limit = None
        and subprogram_type = ST_EmptyGetter
        and parameters = [] in
        D_Func {
          name;
          args;
          return_type;
          body;
          parameters;
          subprogram_type;
          recurse_limit;
          builtin = false;
        }
      )
# 21367 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__5_, _startpos_ty_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 21376 "asllib/Parser0.ml"
              
            in
            
# 233 "asllib/Parser0.mly"
                      Some  
# 21382 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 21388 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _5;
            MenhirLib.EngineTypes.startp = _startpos__5_;
            MenhirLib.EngineTypes.endp = _endpos__5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _4;
              MenhirLib.EngineTypes.startp = _startpos__4_;
              MenhirLib.EngineTypes.endp = _endpos__4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = ty;
                    MenhirLib.EngineTypes.startp = _startpos_ty_;
                    MenhirLib.EngineTypes.endp = _endpos_ty_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _5 : unit = Obj.magic _5 in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let ty : (AST.ty) = Obj.magic ty in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_ty_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let _1 = _1_inlined1 in
                  
# 597 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 21455 "asllib/Parser0.ml"
                  
                in
                let name = 
# 349 "asllib/Parser0.mly"
              ( "record" )
# 21461 "asllib/Parser0.ml"
                 in
                
# 477 "asllib/Parser0.mly"
      (
        let open AST in
        let return_type = Some ty
        and args = []
        and body = SB_ASL body
        and recurse_limit = None
        and subprogram_type = ST_EmptyGetter
        and parameters = [] in
        D_Func {
          name;
          args;
          return_type;
          body;
          parameters;
          subprogram_type;
          recurse_limit;
          builtin = false;
        }
      )
# 21484 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__5_, _startpos_ty_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 21493 "asllib/Parser0.ml"
              
            in
            
# 233 "asllib/Parser0.mly"
                      Some  
# 21499 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 21505 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _2;
                          MenhirLib.EngineTypes.startp = _startpos__2_;
                          MenhirLib.EngineTypes.endp = _endpos__2_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = q;
                            MenhirLib.EngineTypes.startp = _startpos_q_;
                            MenhirLib.EngineTypes.endp = _endpos_q_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = ty;
                              MenhirLib.EngineTypes.startp = _startpos_ty_;
                              MenhirLib.EngineTypes.endp = _endpos_ty_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 21594 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 21600 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let ty : (AST.ty) = Obj.magic ty in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_ty_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let (_1_inlined1, _2, _1) = (_1_inlined3, _2_inlined1, _1_inlined2) in
                  let _3 = _1_inlined1 in
                  let _3_1 = _3 in
                  
# 604 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 21617 "asllib/Parser0.ml"
                   _3_1
                in
                let args =
                  let x = 
# 298 "asllib/Parser0.mly"
                ( [] )
# 21624 "asllib/Parser0.ml"
                   in
                  
# 205 "<standard.mly>"
    ( x )
# 21629 "asllib/Parser0.ml"
                  
                in
                let name =
                  let i = _1 in
                  
# 347 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 21637 "asllib/Parser0.ml"
                  
                in
                
# 497 "asllib/Parser0.mly"
      (
        let open AST in
        let return_type = Some ty
        and subprogram_type = ST_Getter
        and recurse_limit = None
        and body = SB_ASL body
        and parameters = [] in
        D_Func {
          name;
          args;
          return_type;
          body;
          parameters;
          subprogram_type;
          recurse_limit;
          builtin = false;
        }
      )
# 21660 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos_ty_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 21669 "asllib/Parser0.ml"
              
            in
            
# 233 "asllib/Parser0.mly"
                      Some  
# 21675 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 21681 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _2;
                            MenhirLib.EngineTypes.startp = _startpos__2_;
                            MenhirLib.EngineTypes.endp = _endpos__2_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = q;
                              MenhirLib.EngineTypes.startp = _startpos_q_;
                              MenhirLib.EngineTypes.endp = _endpos_q_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _menhir_s;
                                MenhirLib.EngineTypes.semv = ty;
                                MenhirLib.EngineTypes.startp = _startpos_ty_;
                                MenhirLib.EngineTypes.endp = _endpos_ty_;
                                MenhirLib.EngineTypes.next = _menhir_stack;
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (AST.typed_identifier list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 21777 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 21783 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let ty : (AST.ty) = Obj.magic ty in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_ty_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let (_1_inlined1, _2, _1) = (_1_inlined4, _2_inlined1, _1_inlined3) in
                  let _3 = _1_inlined1 in
                  let _3_1 = _3 in
                  
# 604 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 21800 "asllib/Parser0.ml"
                   _3_1
                in
                let args =
                  let _1_inlined1 = _1_inlined2 in
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 21809 "asllib/Parser0.ml"
                  
                in
                let name =
                  let i = _1 in
                  
# 347 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 21817 "asllib/Parser0.ml"
                  
                in
                
# 497 "asllib/Parser0.mly"
      (
        let open AST in
        let return_type = Some ty
        and subprogram_type = ST_Getter
        and recurse_limit = None
        and body = SB_ASL body
        and parameters = [] in
        D_Func {
          name;
          args;
          return_type;
          body;
          parameters;
          subprogram_type;
          recurse_limit;
          builtin = false;
        }
      )
# 21840 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos_ty_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 21849 "asllib/Parser0.ml"
              
            in
            
# 233 "asllib/Parser0.mly"
                      Some  
# 21855 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 21861 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = ty;
                          MenhirLib.EngineTypes.startp = _startpos_ty_;
                          MenhirLib.EngineTypes.endp = _endpos_ty_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 21938 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let ty : (AST.ty) = Obj.magic ty in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_ty_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let (_1_inlined1, _1) = (_1_inlined3, _1_inlined2) in
                  let _3 = _1_inlined1 in
                  let _3_1 = _3 in
                  
# 604 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 21955 "asllib/Parser0.ml"
                   _3_1
                in
                let args =
                  let x = 
# 298 "asllib/Parser0.mly"
                ( [] )
# 21962 "asllib/Parser0.ml"
                   in
                  
# 205 "<standard.mly>"
    ( x )
# 21967 "asllib/Parser0.ml"
                  
                in
                let name = _1 in
                
# 497 "asllib/Parser0.mly"
      (
        let open AST in
        let return_type = Some ty
        and subprogram_type = ST_Getter
        and recurse_limit = None
        and body = SB_ASL body
        and parameters = [] in
        D_Func {
          name;
          args;
          return_type;
          body;
          parameters;
          subprogram_type;
          recurse_limit;
          builtin = false;
        }
      )
# 21991 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos_ty_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 22000 "asllib/Parser0.ml"
              
            in
            
# 233 "asllib/Parser0.mly"
                      Some  
# 22006 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 22012 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = ty;
                            MenhirLib.EngineTypes.startp = _startpos_ty_;
                            MenhirLib.EngineTypes.endp = _endpos_ty_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (AST.typed_identifier list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 22096 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let ty : (AST.ty) = Obj.magic ty in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_ty_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let (_1_inlined1, _1) = (_1_inlined4, _1_inlined3) in
                  let _3 = _1_inlined1 in
                  let _3_1 = _3 in
                  
# 604 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 22113 "asllib/Parser0.ml"
                   _3_1
                in
                let args =
                  let _1_inlined1 = _1_inlined2 in
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 22122 "asllib/Parser0.ml"
                  
                in
                let name = _1 in
                
# 497 "asllib/Parser0.mly"
      (
        let open AST in
        let return_type = Some ty
        and subprogram_type = ST_Getter
        and recurse_limit = None
        and body = SB_ASL body
        and parameters = [] in
        D_Func {
          name;
          args;
          return_type;
          body;
          parameters;
          subprogram_type;
          recurse_limit;
          builtin = false;
        }
      )
# 22146 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos_ty_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 22155 "asllib/Parser0.ml"
              
            in
            
# 233 "asllib/Parser0.mly"
                      Some  
# 22161 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 22167 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = ty;
                          MenhirLib.EngineTypes.startp = _startpos_ty_;
                          MenhirLib.EngineTypes.endp = _endpos_ty_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let ty : (AST.ty) = Obj.magic ty in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_ty_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let (_1_inlined1, _1) = (_1_inlined3, _1_inlined2) in
                  let _3 = _1_inlined1 in
                  let _3_1 = _3 in
                  
# 604 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 22257 "asllib/Parser0.ml"
                   _3_1
                in
                let args =
                  let x = 
# 298 "asllib/Parser0.mly"
                ( [] )
# 22264 "asllib/Parser0.ml"
                   in
                  
# 205 "<standard.mly>"
    ( x )
# 22269 "asllib/Parser0.ml"
                  
                in
                let name = 
# 349 "asllib/Parser0.mly"
              ( "record" )
# 22275 "asllib/Parser0.ml"
                 in
                
# 497 "asllib/Parser0.mly"
      (
        let open AST in
        let return_type = Some ty
        and subprogram_type = ST_Getter
        and recurse_limit = None
        and body = SB_ASL body
        and parameters = [] in
        D_Func {
          name;
          args;
          return_type;
          body;
          parameters;
          subprogram_type;
          recurse_limit;
          builtin = false;
        }
      )
# 22297 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos_ty_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 22306 "asllib/Parser0.ml"
              
            in
            
# 233 "asllib/Parser0.mly"
                      Some  
# 22312 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 22318 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = ty;
                            MenhirLib.EngineTypes.startp = _startpos_ty_;
                            MenhirLib.EngineTypes.endp = _endpos_ty_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (AST.typed_identifier list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let ty : (AST.ty) = Obj.magic ty in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_ty_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let (_1_inlined1, _1) = (_1_inlined4, _1_inlined3) in
                  let _3 = _1_inlined1 in
                  let _3_1 = _3 in
                  
# 604 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 22415 "asllib/Parser0.ml"
                   _3_1
                in
                let args =
                  let _1_inlined1 = _1_inlined2 in
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 22424 "asllib/Parser0.ml"
                  
                in
                let name = 
# 349 "asllib/Parser0.mly"
              ( "record" )
# 22430 "asllib/Parser0.ml"
                 in
                
# 497 "asllib/Parser0.mly"
      (
        let open AST in
        let return_type = Some ty
        and subprogram_type = ST_Getter
        and recurse_limit = None
        and body = SB_ASL body
        and parameters = [] in
        D_Func {
          name;
          args;
          return_type;
          body;
          parameters;
          subprogram_type;
          recurse_limit;
          builtin = false;
        }
      )
# 22452 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos_ty_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 22461 "asllib/Parser0.ml"
              
            in
            
# 233 "asllib/Parser0.mly"
                      Some  
# 22467 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 22473 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _5;
            MenhirLib.EngineTypes.startp = _startpos__5_;
            MenhirLib.EngineTypes.endp = _endpos__5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _2;
                    MenhirLib.EngineTypes.startp = _startpos__2_;
                    MenhirLib.EngineTypes.endp = _endpos__2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = q;
                      MenhirLib.EngineTypes.startp = _startpos_q_;
                      MenhirLib.EngineTypes.endp = _endpos_q_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _5 : unit = Obj.magic _5 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 22541 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _2 : unit = Obj.magic _2 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 22547 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _1 : (AST.ty) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _4 = 
# 123 "<standard.mly>"
    ( None )
# 22559 "asllib/Parser0.ml"
               in
              let _3 =
                let x = 
# 298 "asllib/Parser0.mly"
                ( [] )
# 22565 "asllib/Parser0.ml"
                 in
                
# 205 "<standard.mly>"
    ( x )
# 22570 "asllib/Parser0.ml"
                
              in
              let _2 =
                let _1 = _1_inlined1 in
                let i = _1 in
                
# 347 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 22579 "asllib/Parser0.ml"
                
              in
              _5
            in
            
# 264 "asllib/Parser0.mly"
                                ( None )
# 22587 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 22593 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _5;
            MenhirLib.EngineTypes.startp = _startpos__5_;
            MenhirLib.EngineTypes.endp = _endpos__5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = x;
              MenhirLib.EngineTypes.startp = _startpos_x_;
              MenhirLib.EngineTypes.endp = _endpos_x_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _2;
                      MenhirLib.EngineTypes.startp = _startpos__2_;
                      MenhirLib.EngineTypes.endp = _endpos__2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = q;
                        MenhirLib.EngineTypes.startp = _startpos_q_;
                        MenhirLib.EngineTypes.endp = _endpos_q_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _5 : unit = Obj.magic _5 in
        let x : unit = Obj.magic x in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 22668 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _2 : unit = Obj.magic _2 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 22674 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _1 : (AST.ty) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _4 = 
# 126 "<standard.mly>"
    ( Some x )
# 22686 "asllib/Parser0.ml"
               in
              let _3 =
                let x = 
# 298 "asllib/Parser0.mly"
                ( [] )
# 22692 "asllib/Parser0.ml"
                 in
                
# 205 "<standard.mly>"
    ( x )
# 22697 "asllib/Parser0.ml"
                
              in
              let _2 =
                let _1 = _1_inlined1 in
                let i = _1 in
                
# 347 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 22706 "asllib/Parser0.ml"
                
              in
              _5
            in
            
# 264 "asllib/Parser0.mly"
                                ( None )
# 22714 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 22720 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _5;
            MenhirLib.EngineTypes.startp = _startpos__5_;
            MenhirLib.EngineTypes.endp = _endpos__5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _2;
                      MenhirLib.EngineTypes.startp = _startpos__2_;
                      MenhirLib.EngineTypes.endp = _endpos__2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = q;
                        MenhirLib.EngineTypes.startp = _startpos_q_;
                        MenhirLib.EngineTypes.endp = _endpos_q_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _5 : unit = Obj.magic _5 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined3 : (AST.typed_identifier list) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 22795 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _2 : unit = Obj.magic _2 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 22801 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _1 : (AST.ty) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _4 = 
# 123 "<standard.mly>"
    ( None )
# 22813 "asllib/Parser0.ml"
               in
              let _3 =
                let _1_inlined1 = _1_inlined3 in
                let x = _1_inlined1 in
                
# 205 "<standard.mly>"
    ( x )
# 22821 "asllib/Parser0.ml"
                
              in
              let _2 =
                let _1 = _1_inlined1 in
                let i = _1 in
                
# 347 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 22830 "asllib/Parser0.ml"
                
              in
              _5
            in
            
# 264 "asllib/Parser0.mly"
                                ( None )
# 22838 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 22844 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _5;
            MenhirLib.EngineTypes.startp = _startpos__5_;
            MenhirLib.EngineTypes.endp = _endpos__5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = x;
              MenhirLib.EngineTypes.startp = _startpos_x_;
              MenhirLib.EngineTypes.endp = _endpos_x_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _2;
                        MenhirLib.EngineTypes.startp = _startpos__2_;
                        MenhirLib.EngineTypes.endp = _endpos__2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = q;
                          MenhirLib.EngineTypes.startp = _startpos_q_;
                          MenhirLib.EngineTypes.endp = _endpos_q_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _5 : unit = Obj.magic _5 in
        let x : unit = Obj.magic x in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined3 : (AST.typed_identifier list) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 22926 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _2 : unit = Obj.magic _2 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 22932 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _1 : (AST.ty) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _4 = 
# 126 "<standard.mly>"
    ( Some x )
# 22944 "asllib/Parser0.ml"
               in
              let _3 =
                let _1_inlined1 = _1_inlined3 in
                let x = _1_inlined1 in
                
# 205 "<standard.mly>"
    ( x )
# 22952 "asllib/Parser0.ml"
                
              in
              let _2 =
                let _1 = _1_inlined1 in
                let i = _1 in
                
# 347 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 22961 "asllib/Parser0.ml"
                
              in
              _5
            in
            
# 264 "asllib/Parser0.mly"
                                ( None )
# 22969 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 22975 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _5;
            MenhirLib.EngineTypes.startp = _startpos__5_;
            MenhirLib.EngineTypes.endp = _endpos__5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _5 : unit = Obj.magic _5 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 23031 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : (AST.ty) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _4 = 
# 123 "<standard.mly>"
    ( None )
# 23043 "asllib/Parser0.ml"
               in
              let _3 =
                let x = 
# 298 "asllib/Parser0.mly"
                ( [] )
# 23049 "asllib/Parser0.ml"
                 in
                
# 205 "<standard.mly>"
    ( x )
# 23054 "asllib/Parser0.ml"
                
              in
              let _2 = _1_inlined1 in
              _5
            in
            
# 264 "asllib/Parser0.mly"
                                ( None )
# 23063 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 23069 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _5;
            MenhirLib.EngineTypes.startp = _startpos__5_;
            MenhirLib.EngineTypes.endp = _endpos__5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = x;
              MenhirLib.EngineTypes.startp = _startpos_x_;
              MenhirLib.EngineTypes.endp = _endpos_x_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _5 : unit = Obj.magic _5 in
        let x : unit = Obj.magic x in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 23132 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : (AST.ty) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _4 = 
# 126 "<standard.mly>"
    ( Some x )
# 23144 "asllib/Parser0.ml"
               in
              let _3 =
                let x = 
# 298 "asllib/Parser0.mly"
                ( [] )
# 23150 "asllib/Parser0.ml"
                 in
                
# 205 "<standard.mly>"
    ( x )
# 23155 "asllib/Parser0.ml"
                
              in
              let _2 = _1_inlined1 in
              _5
            in
            
# 264 "asllib/Parser0.mly"
                                ( None )
# 23164 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 23170 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _5;
            MenhirLib.EngineTypes.startp = _startpos__5_;
            MenhirLib.EngineTypes.endp = _endpos__5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _5 : unit = Obj.magic _5 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined3 : (AST.typed_identifier list) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 23233 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : (AST.ty) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _4 = 
# 123 "<standard.mly>"
    ( None )
# 23245 "asllib/Parser0.ml"
               in
              let _3 =
                let _1_inlined1 = _1_inlined3 in
                let x = _1_inlined1 in
                
# 205 "<standard.mly>"
    ( x )
# 23253 "asllib/Parser0.ml"
                
              in
              let _2 = _1_inlined1 in
              _5
            in
            
# 264 "asllib/Parser0.mly"
                                ( None )
# 23262 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 23268 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _5;
            MenhirLib.EngineTypes.startp = _startpos__5_;
            MenhirLib.EngineTypes.endp = _endpos__5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = x;
              MenhirLib.EngineTypes.startp = _startpos_x_;
              MenhirLib.EngineTypes.endp = _endpos_x_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _5 : unit = Obj.magic _5 in
        let x : unit = Obj.magic x in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined3 : (AST.typed_identifier list) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 23338 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : (AST.ty) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _4 = 
# 126 "<standard.mly>"
    ( Some x )
# 23350 "asllib/Parser0.ml"
               in
              let _3 =
                let _1_inlined1 = _1_inlined3 in
                let x = _1_inlined1 in
                
# 205 "<standard.mly>"
    ( x )
# 23358 "asllib/Parser0.ml"
                
              in
              let _2 = _1_inlined1 in
              _5
            in
            
# 264 "asllib/Parser0.mly"
                                ( None )
# 23367 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 23373 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _5;
            MenhirLib.EngineTypes.startp = _startpos__5_;
            MenhirLib.EngineTypes.endp = _endpos__5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _5 : unit = Obj.magic _5 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (AST.ty) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _4 = 
# 123 "<standard.mly>"
    ( None )
# 23437 "asllib/Parser0.ml"
               in
              let _3 =
                let x = 
# 298 "asllib/Parser0.mly"
                ( [] )
# 23443 "asllib/Parser0.ml"
                 in
                
# 205 "<standard.mly>"
    ( x )
# 23448 "asllib/Parser0.ml"
                
              in
              let _2 =
                let _1 = _1_inlined1 in
                
# 349 "asllib/Parser0.mly"
              ( "record" )
# 23456 "asllib/Parser0.ml"
                
              in
              _5
            in
            
# 264 "asllib/Parser0.mly"
                                ( None )
# 23464 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 23470 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _5;
            MenhirLib.EngineTypes.startp = _startpos__5_;
            MenhirLib.EngineTypes.endp = _endpos__5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = x;
              MenhirLib.EngineTypes.startp = _startpos_x_;
              MenhirLib.EngineTypes.endp = _endpos_x_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _5 : unit = Obj.magic _5 in
        let x : unit = Obj.magic x in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (AST.ty) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _4 = 
# 126 "<standard.mly>"
    ( Some x )
# 23541 "asllib/Parser0.ml"
               in
              let _3 =
                let x = 
# 298 "asllib/Parser0.mly"
                ( [] )
# 23547 "asllib/Parser0.ml"
                 in
                
# 205 "<standard.mly>"
    ( x )
# 23552 "asllib/Parser0.ml"
                
              in
              let _2 =
                let _1 = _1_inlined1 in
                
# 349 "asllib/Parser0.mly"
              ( "record" )
# 23560 "asllib/Parser0.ml"
                
              in
              _5
            in
            
# 264 "asllib/Parser0.mly"
                                ( None )
# 23568 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 23574 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _5;
            MenhirLib.EngineTypes.startp = _startpos__5_;
            MenhirLib.EngineTypes.endp = _endpos__5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _5 : unit = Obj.magic _5 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined3 : (AST.typed_identifier list) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (AST.ty) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _4 = 
# 123 "<standard.mly>"
    ( None )
# 23645 "asllib/Parser0.ml"
               in
              let _3 =
                let _1_inlined1 = _1_inlined3 in
                let x = _1_inlined1 in
                
# 205 "<standard.mly>"
    ( x )
# 23653 "asllib/Parser0.ml"
                
              in
              let _2 =
                let _1 = _1_inlined1 in
                
# 349 "asllib/Parser0.mly"
              ( "record" )
# 23661 "asllib/Parser0.ml"
                
              in
              _5
            in
            
# 264 "asllib/Parser0.mly"
                                ( None )
# 23669 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 23675 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _5;
            MenhirLib.EngineTypes.startp = _startpos__5_;
            MenhirLib.EngineTypes.endp = _endpos__5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = x;
              MenhirLib.EngineTypes.startp = _startpos_x_;
              MenhirLib.EngineTypes.endp = _endpos_x_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _5 : unit = Obj.magic _5 in
        let x : unit = Obj.magic x in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined3 : (AST.typed_identifier list) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (AST.ty) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _4 = 
# 126 "<standard.mly>"
    ( Some x )
# 23753 "asllib/Parser0.ml"
               in
              let _3 =
                let _1_inlined1 = _1_inlined3 in
                let x = _1_inlined1 in
                
# 205 "<standard.mly>"
    ( x )
# 23761 "asllib/Parser0.ml"
                
              in
              let _2 =
                let _1 = _1_inlined1 in
                
# 349 "asllib/Parser0.mly"
              ( "record" )
# 23769 "asllib/Parser0.ml"
                
              in
              _5
            in
            
# 264 "asllib/Parser0.mly"
                                ( None )
# 23777 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 23783 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = ty;
                      MenhirLib.EngineTypes.startp = _startpos_ty_;
                      MenhirLib.EngineTypes.endp = _endpos_ty_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _2;
                        MenhirLib.EngineTypes.startp = _startpos__2_;
                        MenhirLib.EngineTypes.endp = _endpos__2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _2_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = q;
                              MenhirLib.EngineTypes.startp = _startpos_q_;
                              MenhirLib.EngineTypes.endp = _endpos_q_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _2_inlined2 : unit = Obj.magic _2_inlined2 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 23870 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let ty : (AST.ty) = Obj.magic ty in
        let _2 : unit = Obj.magic _2 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 23877 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 23883 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let (_1_inlined1, _2, _1) = (_1_inlined3, _2_inlined2, _1_inlined2) in
                  let _3 = _1_inlined1 in
                  let _3_1 = _3 in
                  
# 604 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 23899 "asllib/Parser0.ml"
                   _3_1
                in
                let ident = _1_inlined1 in
                let name =
                  let _2 = _2_inlined1 in
                  let i = _1 in
                  
# 347 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 23909 "asllib/Parser0.ml"
                  
                in
                
# 524 "asllib/Parser0.mly"
      (
        let open AST in
        let return_type = None
        and parameters = []
        and body = SB_ASL body
        and subprogram_type = ST_EmptySetter
        and recurse_limit = None
        and args = [ (ident, ty) ] in
        D_Func {
          name;
          args;
          return_type;
          body;
          parameters;
          subprogram_type;
          recurse_limit;
          builtin = false;
        }
      )
# 23933 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos_q_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 23942 "asllib/Parser0.ml"
              
            in
            
# 233 "asllib/Parser0.mly"
                      Some  
# 23948 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 23954 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = ty;
                      MenhirLib.EngineTypes.startp = _startpos_ty_;
                      MenhirLib.EngineTypes.endp = _endpos_ty_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _2;
                        MenhirLib.EngineTypes.startp = _startpos__2_;
                        MenhirLib.EngineTypes.endp = _endpos__2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 24029 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let ty : (AST.ty) = Obj.magic ty in
        let _2 : unit = Obj.magic _2 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 24036 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let (_1_inlined1, _2, _1) = (_1_inlined3, _2_inlined1, _1_inlined2) in
                  let _3 = _1_inlined1 in
                  let _3_1 = _3 in
                  
# 604 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 24052 "asllib/Parser0.ml"
                   _3_1
                in
                let ident = _1_inlined1 in
                let name = _1 in
                
# 524 "asllib/Parser0.mly"
      (
        let open AST in
        let return_type = None
        and parameters = []
        and body = SB_ASL body
        and subprogram_type = ST_EmptySetter
        and recurse_limit = None
        and args = [ (ident, ty) ] in
        D_Func {
          name;
          args;
          return_type;
          body;
          parameters;
          subprogram_type;
          recurse_limit;
          builtin = false;
        }
      )
# 24078 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 24087 "asllib/Parser0.ml"
              
            in
            
# 233 "asllib/Parser0.mly"
                      Some  
# 24093 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 24099 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = ty;
                      MenhirLib.EngineTypes.startp = _startpos_ty_;
                      MenhirLib.EngineTypes.endp = _endpos_ty_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _2;
                        MenhirLib.EngineTypes.startp = _startpos__2_;
                        MenhirLib.EngineTypes.endp = _endpos__2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 24174 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let ty : (AST.ty) = Obj.magic ty in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let (_1_inlined1, _2, _1) = (_1_inlined3, _2_inlined1, _1_inlined2) in
                  let _3 = _1_inlined1 in
                  let _3_1 = _3 in
                  
# 604 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 24193 "asllib/Parser0.ml"
                   _3_1
                in
                let ident = _1_inlined1 in
                let name = 
# 349 "asllib/Parser0.mly"
              ( "record" )
# 24200 "asllib/Parser0.ml"
                 in
                
# 524 "asllib/Parser0.mly"
      (
        let open AST in
        let return_type = None
        and parameters = []
        and body = SB_ASL body
        and subprogram_type = ST_EmptySetter
        and recurse_limit = None
        and args = [ (ident, ty) ] in
        D_Func {
          name;
          args;
          return_type;
          body;
          parameters;
          subprogram_type;
          recurse_limit;
          builtin = false;
        }
      )
# 24223 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 24232 "asllib/Parser0.ml"
              
            in
            
# 233 "asllib/Parser0.mly"
                      Some  
# 24238 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 24244 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = ty;
                      MenhirLib.EngineTypes.startp = _startpos_ty_;
                      MenhirLib.EngineTypes.endp = _endpos_ty_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3;
                        MenhirLib.EngineTypes.startp = _startpos__3_;
                        MenhirLib.EngineTypes.endp = _endpos__3_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _3_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1;
                              MenhirLib.EngineTypes.startp = _startpos__1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _2;
                                MenhirLib.EngineTypes.startp = _startpos__2_;
                                MenhirLib.EngineTypes.endp = _endpos__2_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _menhir_s;
                                  MenhirLib.EngineTypes.semv = q;
                                  MenhirLib.EngineTypes.startp = _startpos_q_;
                                  MenhirLib.EngineTypes.endp = _endpos_q_;
                                  MenhirLib.EngineTypes.next = _menhir_stack;
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : (
# 82 "asllib/Parser0.mly"
       (string)
# 24343 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let ty : (AST.ty) = Obj.magic ty in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 24352 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 24358 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let (_1_inlined1, _2, _1) = (_1_inlined4, _2_inlined1, _1_inlined3) in
                  let _3 = _1_inlined1 in
                  let _3_1 = _3 in
                  
# 604 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 24374 "asllib/Parser0.ml"
                   _3_1
                in
                let ident = _1_inlined2 in
                let args =
                  let x = 
# 298 "asllib/Parser0.mly"
                ( [] )
# 24382 "asllib/Parser0.ml"
                   in
                  
# 205 "<standard.mly>"
    ( x )
# 24387 "asllib/Parser0.ml"
                  
                in
                let name =
                  let i = _1 in
                  
# 347 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 24395 "asllib/Parser0.ml"
                  
                in
                
# 544 "asllib/Parser0.mly"
      (
        let open AST in
        let return_type = None
        and parameters = []
        and body = SB_ASL body
        and subprogram_type = ST_Setter
        and recurse_limit = None
        and args = (ident, ty) :: args in
        D_Func {
          name;
          args;
          return_type;
          body;
          parameters;
          subprogram_type;
          recurse_limit;
          builtin = false;
        }
      )
# 24419 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos_q_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 24428 "asllib/Parser0.ml"
              
            in
            
# 233 "asllib/Parser0.mly"
                      Some  
# 24434 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 24440 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined5;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined4;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined3;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = ty;
                      MenhirLib.EngineTypes.startp = _startpos_ty_;
                      MenhirLib.EngineTypes.endp = _endpos_ty_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3;
                        MenhirLib.EngineTypes.startp = _startpos__3_;
                        MenhirLib.EngineTypes.endp = _endpos__3_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _3_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined2;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1;
                                MenhirLib.EngineTypes.startp = _startpos__1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _2;
                                  MenhirLib.EngineTypes.startp = _startpos__2_;
                                  MenhirLib.EngineTypes.endp = _endpos__2_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _menhir_s;
                                    MenhirLib.EngineTypes.semv = q;
                                    MenhirLib.EngineTypes.startp = _startpos_q_;
                                    MenhirLib.EngineTypes.endp = _endpos_q_;
                                    MenhirLib.EngineTypes.next = _menhir_stack;
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined5 : (AST.stmt list) = Obj.magic _1_inlined5 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _1_inlined3 : (
# 82 "asllib/Parser0.mly"
       (string)
# 24545 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let ty : (AST.ty) = Obj.magic ty in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (AST.typed_identifier list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 24555 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 24561 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let (_1_inlined1, _2, _1) = (_1_inlined5, _2_inlined1, _1_inlined4) in
                  let _3 = _1_inlined1 in
                  let _3_1 = _3 in
                  
# 604 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 24577 "asllib/Parser0.ml"
                   _3_1
                in
                let ident = _1_inlined3 in
                let args =
                  let _1_inlined1 = _1_inlined2 in
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 24587 "asllib/Parser0.ml"
                  
                in
                let name =
                  let i = _1 in
                  
# 347 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 24595 "asllib/Parser0.ml"
                  
                in
                
# 544 "asllib/Parser0.mly"
      (
        let open AST in
        let return_type = None
        and parameters = []
        and body = SB_ASL body
        and subprogram_type = ST_Setter
        and recurse_limit = None
        and args = (ident, ty) :: args in
        D_Func {
          name;
          args;
          return_type;
          body;
          parameters;
          subprogram_type;
          recurse_limit;
          builtin = false;
        }
      )
# 24619 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos_q_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 24628 "asllib/Parser0.ml"
              
            in
            
# 233 "asllib/Parser0.mly"
                      Some  
# 24634 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 24640 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = ty;
                      MenhirLib.EngineTypes.startp = _startpos_ty_;
                      MenhirLib.EngineTypes.endp = _endpos_ty_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3;
                        MenhirLib.EngineTypes.startp = _startpos__3_;
                        MenhirLib.EngineTypes.endp = _endpos__3_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _3_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = _1;
                              MenhirLib.EngineTypes.startp = _startpos__1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : (
# 82 "asllib/Parser0.mly"
       (string)
# 24727 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let ty : (AST.ty) = Obj.magic ty in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 24736 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let (_1_inlined1, _1) = (_1_inlined4, _1_inlined3) in
                  let _3 = _1_inlined1 in
                  let _3_1 = _3 in
                  
# 604 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 24752 "asllib/Parser0.ml"
                   _3_1
                in
                let ident = _1_inlined2 in
                let args =
                  let x = 
# 298 "asllib/Parser0.mly"
                ( [] )
# 24760 "asllib/Parser0.ml"
                   in
                  
# 205 "<standard.mly>"
    ( x )
# 24765 "asllib/Parser0.ml"
                  
                in
                let name = _1 in
                
# 544 "asllib/Parser0.mly"
      (
        let open AST in
        let return_type = None
        and parameters = []
        and body = SB_ASL body
        and subprogram_type = ST_Setter
        and recurse_limit = None
        and args = (ident, ty) :: args in
        D_Func {
          name;
          args;
          return_type;
          body;
          parameters;
          subprogram_type;
          recurse_limit;
          builtin = false;
        }
      )
# 24790 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 24799 "asllib/Parser0.ml"
              
            in
            
# 233 "asllib/Parser0.mly"
                      Some  
# 24805 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 24811 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined5;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined4;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined3;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = ty;
                      MenhirLib.EngineTypes.startp = _startpos_ty_;
                      MenhirLib.EngineTypes.endp = _endpos_ty_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3;
                        MenhirLib.EngineTypes.startp = _startpos__3_;
                        MenhirLib.EngineTypes.endp = _endpos__3_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _3_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined2;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _menhir_s;
                                MenhirLib.EngineTypes.semv = _1;
                                MenhirLib.EngineTypes.startp = _startpos__1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_;
                                MenhirLib.EngineTypes.next = _menhir_stack;
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined5 : (AST.stmt list) = Obj.magic _1_inlined5 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _1_inlined3 : (
# 82 "asllib/Parser0.mly"
       (string)
# 24904 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let ty : (AST.ty) = Obj.magic ty in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (AST.typed_identifier list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 24914 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let (_1_inlined1, _1) = (_1_inlined5, _1_inlined4) in
                  let _3 = _1_inlined1 in
                  let _3_1 = _3 in
                  
# 604 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 24930 "asllib/Parser0.ml"
                   _3_1
                in
                let ident = _1_inlined3 in
                let args =
                  let _1_inlined1 = _1_inlined2 in
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 24940 "asllib/Parser0.ml"
                  
                in
                let name = _1 in
                
# 544 "asllib/Parser0.mly"
      (
        let open AST in
        let return_type = None
        and parameters = []
        and body = SB_ASL body
        and subprogram_type = ST_Setter
        and recurse_limit = None
        and args = (ident, ty) :: args in
        D_Func {
          name;
          args;
          return_type;
          body;
          parameters;
          subprogram_type;
          recurse_limit;
          builtin = false;
        }
      )
# 24965 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 24974 "asllib/Parser0.ml"
              
            in
            
# 233 "asllib/Parser0.mly"
                      Some  
# 24980 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 24986 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = ty;
                      MenhirLib.EngineTypes.startp = _startpos_ty_;
                      MenhirLib.EngineTypes.endp = _endpos_ty_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3;
                        MenhirLib.EngineTypes.startp = _startpos__3_;
                        MenhirLib.EngineTypes.endp = _endpos__3_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _3_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = _1;
                              MenhirLib.EngineTypes.startp = _startpos__1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : (
# 82 "asllib/Parser0.mly"
       (string)
# 25073 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let ty : (AST.ty) = Obj.magic ty in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let (_1_inlined1, _1) = (_1_inlined4, _1_inlined3) in
                  let _3 = _1_inlined1 in
                  let _3_1 = _3 in
                  
# 604 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 25094 "asllib/Parser0.ml"
                   _3_1
                in
                let ident = _1_inlined2 in
                let args =
                  let x = 
# 298 "asllib/Parser0.mly"
                ( [] )
# 25102 "asllib/Parser0.ml"
                   in
                  
# 205 "<standard.mly>"
    ( x )
# 25107 "asllib/Parser0.ml"
                  
                in
                let name = 
# 349 "asllib/Parser0.mly"
              ( "record" )
# 25113 "asllib/Parser0.ml"
                 in
                
# 544 "asllib/Parser0.mly"
      (
        let open AST in
        let return_type = None
        and parameters = []
        and body = SB_ASL body
        and subprogram_type = ST_Setter
        and recurse_limit = None
        and args = (ident, ty) :: args in
        D_Func {
          name;
          args;
          return_type;
          body;
          parameters;
          subprogram_type;
          recurse_limit;
          builtin = false;
        }
      )
# 25136 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 25145 "asllib/Parser0.ml"
              
            in
            
# 233 "asllib/Parser0.mly"
                      Some  
# 25151 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 25157 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined5;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined4;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined3;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = ty;
                      MenhirLib.EngineTypes.startp = _startpos_ty_;
                      MenhirLib.EngineTypes.endp = _endpos_ty_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3;
                        MenhirLib.EngineTypes.startp = _startpos__3_;
                        MenhirLib.EngineTypes.endp = _endpos__3_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _3_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined2;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _menhir_s;
                                MenhirLib.EngineTypes.semv = _1;
                                MenhirLib.EngineTypes.startp = _startpos__1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_;
                                MenhirLib.EngineTypes.next = _menhir_stack;
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined5 : (AST.stmt list) = Obj.magic _1_inlined5 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _1_inlined3 : (
# 82 "asllib/Parser0.mly"
       (string)
# 25250 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let ty : (AST.ty) = Obj.magic ty in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (AST.typed_identifier list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let (_1_inlined1, _1) = (_1_inlined5, _1_inlined4) in
                  let _3 = _1_inlined1 in
                  let _3_1 = _3 in
                  
# 604 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 25272 "asllib/Parser0.ml"
                   _3_1
                in
                let ident = _1_inlined3 in
                let args =
                  let _1_inlined1 = _1_inlined2 in
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 25282 "asllib/Parser0.ml"
                  
                in
                let name = 
# 349 "asllib/Parser0.mly"
              ( "record" )
# 25288 "asllib/Parser0.ml"
                 in
                
# 544 "asllib/Parser0.mly"
      (
        let open AST in
        let return_type = None
        and parameters = []
        and body = SB_ASL body
        and subprogram_type = ST_Setter
        and recurse_limit = None
        and args = (ident, ty) :: args in
        D_Func {
          name;
          args;
          return_type;
          body;
          parameters;
          subprogram_type;
          recurse_limit;
          builtin = false;
        }
      )
# 25311 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 25320 "asllib/Parser0.ml"
              
            in
            
# 233 "asllib/Parser0.mly"
                      Some  
# 25326 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 25332 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _7;
            MenhirLib.EngineTypes.startp = _startpos__7_;
            MenhirLib.EngineTypes.endp = _endpos__7_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _4;
                MenhirLib.EngineTypes.startp = _startpos__4_;
                MenhirLib.EngineTypes.endp = _endpos__4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _2_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = q;
                        MenhirLib.EngineTypes.startp = _startpos_q_;
                        MenhirLib.EngineTypes.endp = _endpos_q_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _7 : unit = Obj.magic _7 in
        let _1_inlined1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 25398 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 25405 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 25411 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _6 = 
# 123 "<standard.mly>"
    ( None )
# 25422 "asllib/Parser0.ml"
               in
              let _5 = _1_inlined1 in
              let _2 = 
# 123 "<standard.mly>"
    ( None )
# 25428 "asllib/Parser0.ml"
               in
              let _1 =
                let _2 = _2_inlined1 in
                let i = _1 in
                
# 347 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 25436 "asllib/Parser0.ml"
                
              in
              _7
            in
            
# 264 "asllib/Parser0.mly"
                                ( None )
# 25444 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 25450 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _7;
            MenhirLib.EngineTypes.startp = _startpos__7_;
            MenhirLib.EngineTypes.endp = _endpos__7_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = x;
              MenhirLib.EngineTypes.startp = _startpos_x_;
              MenhirLib.EngineTypes.endp = _endpos_x_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _4;
                  MenhirLib.EngineTypes.startp = _startpos__4_;
                  MenhirLib.EngineTypes.endp = _endpos__4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _2_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = q;
                          MenhirLib.EngineTypes.startp = _startpos_q_;
                          MenhirLib.EngineTypes.endp = _endpos_q_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _7 : unit = Obj.magic _7 in
        let x : unit = Obj.magic x in
        let _1_inlined1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 25523 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 25530 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 25536 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _6 = 
# 126 "<standard.mly>"
    ( Some x )
# 25547 "asllib/Parser0.ml"
               in
              let _5 = _1_inlined1 in
              let _2 = 
# 123 "<standard.mly>"
    ( None )
# 25553 "asllib/Parser0.ml"
               in
              let _1 =
                let _2 = _2_inlined1 in
                let i = _1 in
                
# 347 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 25561 "asllib/Parser0.ml"
                
              in
              _7
            in
            
# 264 "asllib/Parser0.mly"
                                ( None )
# 25569 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 25575 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _7;
            MenhirLib.EngineTypes.startp = _startpos__7_;
            MenhirLib.EngineTypes.endp = _endpos__7_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _4;
                MenhirLib.EngineTypes.startp = _startpos__4_;
                MenhirLib.EngineTypes.endp = _endpos__4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _2_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = q;
                            MenhirLib.EngineTypes.startp = _startpos_q_;
                            MenhirLib.EngineTypes.endp = _endpos_q_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _7 : unit = Obj.magic _7 in
        let _1_inlined2 : (
# 82 "asllib/Parser0.mly"
       (string)
# 25653 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 25662 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 25668 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _6 = 
# 123 "<standard.mly>"
    ( None )
# 25679 "asllib/Parser0.ml"
               in
              let _5 = _1_inlined2 in
              let _2 =
                let x =
                  let x = 
# 298 "asllib/Parser0.mly"
                ( [] )
# 25687 "asllib/Parser0.ml"
                   in
                  
# 205 "<standard.mly>"
    ( x )
# 25692 "asllib/Parser0.ml"
                  
                in
                
# 126 "<standard.mly>"
    ( Some x )
# 25698 "asllib/Parser0.ml"
                
              in
              let _1 =
                let _2 = _2_inlined1 in
                let i = _1 in
                
# 347 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 25707 "asllib/Parser0.ml"
                
              in
              _7
            in
            
# 264 "asllib/Parser0.mly"
                                ( None )
# 25715 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 25721 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _7;
            MenhirLib.EngineTypes.startp = _startpos__7_;
            MenhirLib.EngineTypes.endp = _endpos__7_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = x;
              MenhirLib.EngineTypes.startp = _startpos_x_;
              MenhirLib.EngineTypes.endp = _endpos_x_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _4;
                  MenhirLib.EngineTypes.startp = _startpos__4_;
                  MenhirLib.EngineTypes.endp = _endpos__4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _2_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = q;
                              MenhirLib.EngineTypes.startp = _startpos_q_;
                              MenhirLib.EngineTypes.endp = _endpos_q_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _7 : unit = Obj.magic _7 in
        let x : unit = Obj.magic x in
        let _1_inlined2 : (
# 82 "asllib/Parser0.mly"
       (string)
# 25806 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 25815 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 25821 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _6 = 
# 126 "<standard.mly>"
    ( Some x )
# 25832 "asllib/Parser0.ml"
               in
              let _5 = _1_inlined2 in
              let _2 =
                let x =
                  let x = 
# 298 "asllib/Parser0.mly"
                ( [] )
# 25840 "asllib/Parser0.ml"
                   in
                  
# 205 "<standard.mly>"
    ( x )
# 25845 "asllib/Parser0.ml"
                  
                in
                
# 126 "<standard.mly>"
    ( Some x )
# 25851 "asllib/Parser0.ml"
                
              in
              let _1 =
                let _2 = _2_inlined1 in
                let i = _1 in
                
# 347 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 25860 "asllib/Parser0.ml"
                
              in
              _7
            in
            
# 264 "asllib/Parser0.mly"
                                ( None )
# 25868 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 25874 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _7;
            MenhirLib.EngineTypes.startp = _startpos__7_;
            MenhirLib.EngineTypes.endp = _endpos__7_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _4;
                MenhirLib.EngineTypes.startp = _startpos__4_;
                MenhirLib.EngineTypes.endp = _endpos__4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _2_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = q;
                              MenhirLib.EngineTypes.startp = _startpos_q_;
                              MenhirLib.EngineTypes.endp = _endpos_q_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _7 : unit = Obj.magic _7 in
        let _1_inlined3 : (
# 82 "asllib/Parser0.mly"
       (string)
# 25958 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (AST.typed_identifier list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 25968 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 25974 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _6 = 
# 123 "<standard.mly>"
    ( None )
# 25985 "asllib/Parser0.ml"
               in
              let _5 = _1_inlined3 in
              let _2 =
                let _1_inlined1 = _1_inlined2 in
                let x =
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 25995 "asllib/Parser0.ml"
                  
                in
                
# 126 "<standard.mly>"
    ( Some x )
# 26001 "asllib/Parser0.ml"
                
              in
              let _1 =
                let _2 = _2_inlined1 in
                let i = _1 in
                
# 347 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 26010 "asllib/Parser0.ml"
                
              in
              _7
            in
            
# 264 "asllib/Parser0.mly"
                                ( None )
# 26018 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 26024 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _7;
            MenhirLib.EngineTypes.startp = _startpos__7_;
            MenhirLib.EngineTypes.endp = _endpos__7_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = x;
              MenhirLib.EngineTypes.startp = _startpos_x_;
              MenhirLib.EngineTypes.endp = _endpos_x_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _4;
                  MenhirLib.EngineTypes.startp = _startpos__4_;
                  MenhirLib.EngineTypes.endp = _endpos__4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _2_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _menhir_s;
                                MenhirLib.EngineTypes.semv = q;
                                MenhirLib.EngineTypes.startp = _startpos_q_;
                                MenhirLib.EngineTypes.endp = _endpos_q_;
                                MenhirLib.EngineTypes.next = _menhir_stack;
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _7 : unit = Obj.magic _7 in
        let x : unit = Obj.magic x in
        let _1_inlined3 : (
# 82 "asllib/Parser0.mly"
       (string)
# 26115 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (AST.typed_identifier list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 26125 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 26131 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _6 = 
# 126 "<standard.mly>"
    ( Some x )
# 26142 "asllib/Parser0.ml"
               in
              let _5 = _1_inlined3 in
              let _2 =
                let _1_inlined1 = _1_inlined2 in
                let x =
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 26152 "asllib/Parser0.ml"
                  
                in
                
# 126 "<standard.mly>"
    ( Some x )
# 26158 "asllib/Parser0.ml"
                
              in
              let _1 =
                let _2 = _2_inlined1 in
                let i = _1 in
                
# 347 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 26167 "asllib/Parser0.ml"
                
              in
              _7
            in
            
# 264 "asllib/Parser0.mly"
                                ( None )
# 26175 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 26181 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _7;
            MenhirLib.EngineTypes.startp = _startpos__7_;
            MenhirLib.EngineTypes.endp = _endpos__7_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _4;
                MenhirLib.EngineTypes.startp = _startpos__4_;
                MenhirLib.EngineTypes.endp = _endpos__4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _7 : unit = Obj.magic _7 in
        let _1_inlined1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 26235 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 26242 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _6 = 
# 123 "<standard.mly>"
    ( None )
# 26253 "asllib/Parser0.ml"
               in
              let _5 = _1_inlined1 in
              let _2 = 
# 123 "<standard.mly>"
    ( None )
# 26259 "asllib/Parser0.ml"
               in
              _7
            in
            
# 264 "asllib/Parser0.mly"
                                ( None )
# 26266 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 26272 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _7;
            MenhirLib.EngineTypes.startp = _startpos__7_;
            MenhirLib.EngineTypes.endp = _endpos__7_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = x;
              MenhirLib.EngineTypes.startp = _startpos_x_;
              MenhirLib.EngineTypes.endp = _endpos_x_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _4;
                  MenhirLib.EngineTypes.startp = _startpos__4_;
                  MenhirLib.EngineTypes.endp = _endpos__4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _7 : unit = Obj.magic _7 in
        let x : unit = Obj.magic x in
        let _1_inlined1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 26333 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 26340 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _6 = 
# 126 "<standard.mly>"
    ( Some x )
# 26351 "asllib/Parser0.ml"
               in
              let _5 = _1_inlined1 in
              let _2 = 
# 123 "<standard.mly>"
    ( None )
# 26357 "asllib/Parser0.ml"
               in
              _7
            in
            
# 264 "asllib/Parser0.mly"
                                ( None )
# 26364 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 26370 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _7;
            MenhirLib.EngineTypes.startp = _startpos__7_;
            MenhirLib.EngineTypes.endp = _endpos__7_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _4;
                MenhirLib.EngineTypes.startp = _startpos__4_;
                MenhirLib.EngineTypes.endp = _endpos__4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _7 : unit = Obj.magic _7 in
        let _1_inlined2 : (
# 82 "asllib/Parser0.mly"
       (string)
# 26436 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 26445 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _6 = 
# 123 "<standard.mly>"
    ( None )
# 26456 "asllib/Parser0.ml"
               in
              let _5 = _1_inlined2 in
              let _2 =
                let x =
                  let x = 
# 298 "asllib/Parser0.mly"
                ( [] )
# 26464 "asllib/Parser0.ml"
                   in
                  
# 205 "<standard.mly>"
    ( x )
# 26469 "asllib/Parser0.ml"
                  
                in
                
# 126 "<standard.mly>"
    ( Some x )
# 26475 "asllib/Parser0.ml"
                
              in
              _7
            in
            
# 264 "asllib/Parser0.mly"
                                ( None )
# 26483 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 26489 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _7;
            MenhirLib.EngineTypes.startp = _startpos__7_;
            MenhirLib.EngineTypes.endp = _endpos__7_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = x;
              MenhirLib.EngineTypes.startp = _startpos_x_;
              MenhirLib.EngineTypes.endp = _endpos_x_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _4;
                  MenhirLib.EngineTypes.startp = _startpos__4_;
                  MenhirLib.EngineTypes.endp = _endpos__4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _7 : unit = Obj.magic _7 in
        let x : unit = Obj.magic x in
        let _1_inlined2 : (
# 82 "asllib/Parser0.mly"
       (string)
# 26562 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 26571 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _6 = 
# 126 "<standard.mly>"
    ( Some x )
# 26582 "asllib/Parser0.ml"
               in
              let _5 = _1_inlined2 in
              let _2 =
                let x =
                  let x = 
# 298 "asllib/Parser0.mly"
                ( [] )
# 26590 "asllib/Parser0.ml"
                   in
                  
# 205 "<standard.mly>"
    ( x )
# 26595 "asllib/Parser0.ml"
                  
                in
                
# 126 "<standard.mly>"
    ( Some x )
# 26601 "asllib/Parser0.ml"
                
              in
              _7
            in
            
# 264 "asllib/Parser0.mly"
                                ( None )
# 26609 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 26615 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _7;
            MenhirLib.EngineTypes.startp = _startpos__7_;
            MenhirLib.EngineTypes.endp = _endpos__7_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _4;
                MenhirLib.EngineTypes.startp = _startpos__4_;
                MenhirLib.EngineTypes.endp = _endpos__4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _7 : unit = Obj.magic _7 in
        let _1_inlined3 : (
# 82 "asllib/Parser0.mly"
       (string)
# 26687 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (AST.typed_identifier list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 26697 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _6 = 
# 123 "<standard.mly>"
    ( None )
# 26708 "asllib/Parser0.ml"
               in
              let _5 = _1_inlined3 in
              let _2 =
                let _1_inlined1 = _1_inlined2 in
                let x =
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 26718 "asllib/Parser0.ml"
                  
                in
                
# 126 "<standard.mly>"
    ( Some x )
# 26724 "asllib/Parser0.ml"
                
              in
              _7
            in
            
# 264 "asllib/Parser0.mly"
                                ( None )
# 26732 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 26738 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _7;
            MenhirLib.EngineTypes.startp = _startpos__7_;
            MenhirLib.EngineTypes.endp = _endpos__7_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = x;
              MenhirLib.EngineTypes.startp = _startpos_x_;
              MenhirLib.EngineTypes.endp = _endpos_x_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _4;
                  MenhirLib.EngineTypes.startp = _startpos__4_;
                  MenhirLib.EngineTypes.endp = _endpos__4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _7 : unit = Obj.magic _7 in
        let x : unit = Obj.magic x in
        let _1_inlined3 : (
# 82 "asllib/Parser0.mly"
       (string)
# 26817 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (AST.typed_identifier list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 26827 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _6 = 
# 126 "<standard.mly>"
    ( Some x )
# 26838 "asllib/Parser0.ml"
               in
              let _5 = _1_inlined3 in
              let _2 =
                let _1_inlined1 = _1_inlined2 in
                let x =
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 26848 "asllib/Parser0.ml"
                  
                in
                
# 126 "<standard.mly>"
    ( Some x )
# 26854 "asllib/Parser0.ml"
                
              in
              _7
            in
            
# 264 "asllib/Parser0.mly"
                                ( None )
# 26862 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 26868 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _7;
            MenhirLib.EngineTypes.startp = _startpos__7_;
            MenhirLib.EngineTypes.endp = _endpos__7_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _4;
                MenhirLib.EngineTypes.startp = _startpos__4_;
                MenhirLib.EngineTypes.endp = _endpos__4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _7 : unit = Obj.magic _7 in
        let _1_inlined1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 26922 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _6 = 
# 123 "<standard.mly>"
    ( None )
# 26936 "asllib/Parser0.ml"
               in
              let _5 = _1_inlined1 in
              let _2 = 
# 123 "<standard.mly>"
    ( None )
# 26942 "asllib/Parser0.ml"
               in
              let _1 = 
# 349 "asllib/Parser0.mly"
              ( "record" )
# 26947 "asllib/Parser0.ml"
               in
              _7
            in
            
# 264 "asllib/Parser0.mly"
                                ( None )
# 26954 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 26960 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _7;
            MenhirLib.EngineTypes.startp = _startpos__7_;
            MenhirLib.EngineTypes.endp = _endpos__7_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = x;
              MenhirLib.EngineTypes.startp = _startpos_x_;
              MenhirLib.EngineTypes.endp = _endpos_x_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _4;
                  MenhirLib.EngineTypes.startp = _startpos__4_;
                  MenhirLib.EngineTypes.endp = _endpos__4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _7 : unit = Obj.magic _7 in
        let x : unit = Obj.magic x in
        let _1_inlined1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 27021 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _6 = 
# 126 "<standard.mly>"
    ( Some x )
# 27035 "asllib/Parser0.ml"
               in
              let _5 = _1_inlined1 in
              let _2 = 
# 123 "<standard.mly>"
    ( None )
# 27041 "asllib/Parser0.ml"
               in
              let _1 = 
# 349 "asllib/Parser0.mly"
              ( "record" )
# 27046 "asllib/Parser0.ml"
               in
              _7
            in
            
# 264 "asllib/Parser0.mly"
                                ( None )
# 27053 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 27059 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _7;
            MenhirLib.EngineTypes.startp = _startpos__7_;
            MenhirLib.EngineTypes.endp = _endpos__7_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _4;
                MenhirLib.EngineTypes.startp = _startpos__4_;
                MenhirLib.EngineTypes.endp = _endpos__4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _7 : unit = Obj.magic _7 in
        let _1_inlined2 : (
# 82 "asllib/Parser0.mly"
       (string)
# 27125 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _6 = 
# 123 "<standard.mly>"
    ( None )
# 27141 "asllib/Parser0.ml"
               in
              let _5 = _1_inlined2 in
              let _2 =
                let x =
                  let x = 
# 298 "asllib/Parser0.mly"
                ( [] )
# 27149 "asllib/Parser0.ml"
                   in
                  
# 205 "<standard.mly>"
    ( x )
# 27154 "asllib/Parser0.ml"
                  
                in
                
# 126 "<standard.mly>"
    ( Some x )
# 27160 "asllib/Parser0.ml"
                
              in
              let _1 = 
# 349 "asllib/Parser0.mly"
              ( "record" )
# 27166 "asllib/Parser0.ml"
               in
              _7
            in
            
# 264 "asllib/Parser0.mly"
                                ( None )
# 27173 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 27179 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _7;
            MenhirLib.EngineTypes.startp = _startpos__7_;
            MenhirLib.EngineTypes.endp = _endpos__7_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = x;
              MenhirLib.EngineTypes.startp = _startpos_x_;
              MenhirLib.EngineTypes.endp = _endpos_x_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _4;
                  MenhirLib.EngineTypes.startp = _startpos__4_;
                  MenhirLib.EngineTypes.endp = _endpos__4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _7 : unit = Obj.magic _7 in
        let x : unit = Obj.magic x in
        let _1_inlined2 : (
# 82 "asllib/Parser0.mly"
       (string)
# 27252 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _6 = 
# 126 "<standard.mly>"
    ( Some x )
# 27268 "asllib/Parser0.ml"
               in
              let _5 = _1_inlined2 in
              let _2 =
                let x =
                  let x = 
# 298 "asllib/Parser0.mly"
                ( [] )
# 27276 "asllib/Parser0.ml"
                   in
                  
# 205 "<standard.mly>"
    ( x )
# 27281 "asllib/Parser0.ml"
                  
                in
                
# 126 "<standard.mly>"
    ( Some x )
# 27287 "asllib/Parser0.ml"
                
              in
              let _1 = 
# 349 "asllib/Parser0.mly"
              ( "record" )
# 27293 "asllib/Parser0.ml"
               in
              _7
            in
            
# 264 "asllib/Parser0.mly"
                                ( None )
# 27300 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 27306 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _7;
            MenhirLib.EngineTypes.startp = _startpos__7_;
            MenhirLib.EngineTypes.endp = _endpos__7_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _4;
                MenhirLib.EngineTypes.startp = _startpos__4_;
                MenhirLib.EngineTypes.endp = _endpos__4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _7 : unit = Obj.magic _7 in
        let _1_inlined3 : (
# 82 "asllib/Parser0.mly"
       (string)
# 27378 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (AST.typed_identifier list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _6 = 
# 123 "<standard.mly>"
    ( None )
# 27395 "asllib/Parser0.ml"
               in
              let _5 = _1_inlined3 in
              let _2 =
                let _1_inlined1 = _1_inlined2 in
                let x =
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 27405 "asllib/Parser0.ml"
                  
                in
                
# 126 "<standard.mly>"
    ( Some x )
# 27411 "asllib/Parser0.ml"
                
              in
              let _1 = 
# 349 "asllib/Parser0.mly"
              ( "record" )
# 27417 "asllib/Parser0.ml"
               in
              _7
            in
            
# 264 "asllib/Parser0.mly"
                                ( None )
# 27424 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 27430 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _7;
            MenhirLib.EngineTypes.startp = _startpos__7_;
            MenhirLib.EngineTypes.endp = _endpos__7_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = x;
              MenhirLib.EngineTypes.startp = _startpos_x_;
              MenhirLib.EngineTypes.endp = _endpos_x_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _4;
                  MenhirLib.EngineTypes.startp = _startpos__4_;
                  MenhirLib.EngineTypes.endp = _endpos__4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _7 : unit = Obj.magic _7 in
        let x : unit = Obj.magic x in
        let _1_inlined3 : (
# 82 "asllib/Parser0.mly"
       (string)
# 27509 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (AST.typed_identifier list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _6 = 
# 126 "<standard.mly>"
    ( Some x )
# 27526 "asllib/Parser0.ml"
               in
              let _5 = _1_inlined3 in
              let _2 =
                let _1_inlined1 = _1_inlined2 in
                let x =
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 27536 "asllib/Parser0.ml"
                  
                in
                
# 126 "<standard.mly>"
    ( Some x )
# 27542 "asllib/Parser0.ml"
                
              in
              let _1 = 
# 349 "asllib/Parser0.mly"
              ( "record" )
# 27548 "asllib/Parser0.ml"
               in
              _7
            in
            
# 264 "asllib/Parser0.mly"
                                ( None )
# 27555 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 27561 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = ty;
                MenhirLib.EngineTypes.startp = _startpos_ty_;
                MenhirLib.EngineTypes.endp = _endpos_ty_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let ty : (AST.ty) = Obj.magic ty in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 27624 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let _2 =
                  let _1 = _1_inlined2 in
                  _2
                in
                let x =
                  let x = _1_inlined1 in
                  
# 273 "asllib/Parser0.mly"
          ( AST.(D_TypeDecl (x, ty, None)) )
# 27643 "asllib/Parser0.ml"
                  
                in
                
# 196 "<standard.mly>"
    ( x )
# 27649 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 27658 "asllib/Parser0.ml"
              
            in
            
# 233 "asllib/Parser0.mly"
                      Some  
# 27664 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 27670 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = ty;
                MenhirLib.EngineTypes.startp = _startpos_ty_;
                MenhirLib.EngineTypes.endp = _endpos_ty_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _2_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = q;
                        MenhirLib.EngineTypes.startp = _startpos_q_;
                        MenhirLib.EngineTypes.endp = _endpos_q_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let ty : (AST.ty) = Obj.magic ty in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 27745 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 27751 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let _2 =
                  let _1 = _1_inlined2 in
                  _2
                in
                let x =
                  let _2 = _2_inlined1 in
                  let x =
                    let _1 = _1_inlined1 in
                    let i = _1 in
                    
# 290 "asllib/Parser0.mly"
                               ( q ^ "_" ^ i )
# 27773 "asllib/Parser0.ml"
                    
                  in
                  
# 273 "asllib/Parser0.mly"
          ( AST.(D_TypeDecl (x, ty, None)) )
# 27779 "asllib/Parser0.ml"
                  
                in
                
# 196 "<standard.mly>"
    ( x )
# 27785 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 27794 "asllib/Parser0.ml"
              
            in
            
# 233 "asllib/Parser0.mly"
                      Some  
# 27800 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 27806 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined3 : (AST.field list) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 27876 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let _2 =
                  let _1 = _1_inlined4 in
                  _2
                in
                let x =
                  let fields =
                    let (_startpos__1_, _1_inlined1) = (_startpos__1_inlined2_, _1_inlined3) in
                    let desc =
                      let x = _1_inlined1 in
                      
# 205 "<standard.mly>"
    ( x )
# 27898 "asllib/Parser0.ml"
                      
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 27907 "asllib/Parser0.ml"
                    
                  in
                  let x = _1_inlined1 in
                  
# 275 "asllib/Parser0.mly"
          ( AST.(D_TypeDecl (x, ASTUtils.add_pos_from fields (T_Record fields.desc), None)) )
# 27914 "asllib/Parser0.ml"
                  
                in
                
# 196 "<standard.mly>"
    ( x )
# 27920 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 27929 "asllib/Parser0.ml"
              
            in
            
# 233 "asllib/Parser0.mly"
                      Some  
# 27935 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 27941 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _2_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = q;
                          MenhirLib.EngineTypes.startp = _startpos_q_;
                          MenhirLib.EngineTypes.endp = _endpos_q_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined3 : (AST.field list) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 28023 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 28029 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let _2 =
                  let _1 = _1_inlined4 in
                  _2
                in
                let x =
                  let _2 = _2_inlined1 in
                  let fields =
                    let (_startpos__1_, _1_inlined1) = (_startpos__1_inlined2_, _1_inlined3) in
                    let desc =
                      let x = _1_inlined1 in
                      
# 205 "<standard.mly>"
    ( x )
# 28052 "asllib/Parser0.ml"
                      
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 28061 "asllib/Parser0.ml"
                    
                  in
                  let x =
                    let _1 = _1_inlined1 in
                    let i = _1 in
                    
# 290 "asllib/Parser0.mly"
                               ( q ^ "_" ^ i )
# 28070 "asllib/Parser0.ml"
                    
                  in
                  
# 275 "asllib/Parser0.mly"
          ( AST.(D_TypeDecl (x, ASTUtils.add_pos_from fields (T_Record fields.desc), None)) )
# 28076 "asllib/Parser0.ml"
                  
                in
                
# 196 "<standard.mly>"
    ( x )
# 28082 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 28091 "asllib/Parser0.ml"
              
            in
            
# 233 "asllib/Parser0.mly"
                      Some  
# 28097 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 28103 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = x;
                  MenhirLib.EngineTypes.startp = _startpos_x_;
                  MenhirLib.EngineTypes.endp = _endpos_x_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let x : (string list) = Obj.magic x in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 28173 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let _2 =
                  let _1 = _1_inlined3 in
                  _2
                in
                let x =
                  let li =
                    let _startpos__1_ = _startpos__1_inlined2_ in
                    let desc = 
# 205 "<standard.mly>"
    ( x )
# 28193 "asllib/Parser0.ml"
                     in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 28201 "asllib/Parser0.ml"
                    
                  in
                  let x = _1_inlined1 in
                  
# 277 "asllib/Parser0.mly"
          ( AST.(D_TypeDecl (x, ASTUtils.add_pos_from li (T_Enum li.desc), None)) )
# 28208 "asllib/Parser0.ml"
                  
                in
                
# 196 "<standard.mly>"
    ( x )
# 28214 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 28223 "asllib/Parser0.ml"
              
            in
            
# 233 "asllib/Parser0.mly"
                      Some  
# 28229 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 28235 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = x;
                  MenhirLib.EngineTypes.startp = _startpos_x_;
                  MenhirLib.EngineTypes.endp = _endpos_x_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _2_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = q;
                          MenhirLib.EngineTypes.startp = _startpos_q_;
                          MenhirLib.EngineTypes.endp = _endpos_q_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let x : (string list) = Obj.magic x in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 28317 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 28323 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let _2 =
                  let _1 = _1_inlined3 in
                  _2
                in
                let x =
                  let _2 = _2_inlined1 in
                  let li =
                    let _startpos__1_ = _startpos__1_inlined2_ in
                    let desc = 
# 205 "<standard.mly>"
    ( x )
# 28344 "asllib/Parser0.ml"
                     in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 28352 "asllib/Parser0.ml"
                    
                  in
                  let x =
                    let _1 = _1_inlined1 in
                    let i = _1 in
                    
# 290 "asllib/Parser0.mly"
                               ( q ^ "_" ^ i )
# 28361 "asllib/Parser0.ml"
                    
                  in
                  
# 277 "asllib/Parser0.mly"
          ( AST.(D_TypeDecl (x, ASTUtils.add_pos_from li (T_Enum li.desc), None)) )
# 28367 "asllib/Parser0.ml"
                  
                in
                
# 196 "<standard.mly>"
    ( x )
# 28373 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 28382 "asllib/Parser0.ml"
              
            in
            
# 233 "asllib/Parser0.mly"
                      Some  
# 28388 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 28394 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 28443 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let _2 =
                  let _1 = _1_inlined2 in
                  _2
                in
                let x =
                  let ty =
                    let _endpos__0_ = _endpos__1_inlined1_ in
                    let desc =
                      let _1 = () in
                      
# 265 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 28465 "asllib/Parser0.ml"
                      
                    in
                    let _endpos_desc_ = _endpos__0_ in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _endpos in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 28474 "asllib/Parser0.ml"
                    
                  in
                  let t = _1_inlined1 in
                  
# 280 "asllib/Parser0.mly"
          ( AST.D_TypeDecl (t, ty, None) )
# 28481 "asllib/Parser0.ml"
                  
                in
                
# 196 "<standard.mly>"
    ( x )
# 28487 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 28496 "asllib/Parser0.ml"
              
            in
            
# 233 "asllib/Parser0.mly"
                      Some  
# 28502 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 28508 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _2_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = q;
                    MenhirLib.EngineTypes.startp = _startpos_q_;
                    MenhirLib.EngineTypes.endp = _endpos_q_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 28569 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 28575 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let _2 =
                  let _1 = _1_inlined2 in
                  _2
                in
                let x =
                  let _2 = _2_inlined1 in
                  let ty =
                    let _endpos__0_ = _endpos__1_inlined1_ in
                    let desc =
                      let _1 = () in
                      
# 265 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 28598 "asllib/Parser0.ml"
                      
                    in
                    let _endpos_desc_ = _endpos__0_ in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _endpos in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 28607 "asllib/Parser0.ml"
                    
                  in
                  let t =
                    let _1 = _1_inlined1 in
                    let i = _1 in
                    
# 290 "asllib/Parser0.mly"
                               ( q ^ "_" ^ i )
# 28616 "asllib/Parser0.ml"
                    
                  in
                  
# 280 "asllib/Parser0.mly"
          ( AST.D_TypeDecl (t, ty, None) )
# 28622 "asllib/Parser0.ml"
                  
                in
                
# 196 "<standard.mly>"
    ( x )
# 28628 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 28637 "asllib/Parser0.ml"
              
            in
            
# 233 "asllib/Parser0.mly"
                      Some  
# 28643 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 28649 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _5;
            MenhirLib.EngineTypes.startp = _startpos__5_;
            MenhirLib.EngineTypes.endp = _endpos__5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = x;
                MenhirLib.EngineTypes.startp = _startpos_x_;
                MenhirLib.EngineTypes.endp = _endpos_x_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _5 : unit = Obj.magic _5 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let x : (AST.field list) = Obj.magic x in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 28719 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let li =
                  let (_endpos__3_, _startpos__1_) = (_endpos__3_inlined1_, _startpos__1_inlined2_) in
                  let desc = 
# 205 "<standard.mly>"
    ( x )
# 28734 "asllib/Parser0.ml"
                   in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 28742 "asllib/Parser0.ml"
                  
                in
                let x = _1_inlined1 in
                
# 284 "asllib/Parser0.mly"
        ( AST.(D_TypeDecl (x, ASTUtils.add_pos_from li (T_Record li.desc), None)) )
# 28749 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__5_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 28758 "asllib/Parser0.ml"
              
            in
            
# 233 "asllib/Parser0.mly"
                      Some  
# 28764 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 28770 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _5;
            MenhirLib.EngineTypes.startp = _startpos__5_;
            MenhirLib.EngineTypes.endp = _endpos__5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = x;
                MenhirLib.EngineTypes.startp = _startpos_x_;
                MenhirLib.EngineTypes.endp = _endpos_x_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _2;
                        MenhirLib.EngineTypes.startp = _startpos__2_;
                        MenhirLib.EngineTypes.endp = _endpos__2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = q;
                          MenhirLib.EngineTypes.startp = _startpos_q_;
                          MenhirLib.EngineTypes.endp = _endpos_q_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _5 : unit = Obj.magic _5 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let x : (AST.field list) = Obj.magic x in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 28852 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _2 : unit = Obj.magic _2 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 28858 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let li =
                  let (_endpos__3_, _startpos__1_) = (_endpos__3_inlined1_, _startpos__1_inlined2_) in
                  let desc = 
# 205 "<standard.mly>"
    ( x )
# 28873 "asllib/Parser0.ml"
                   in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 28881 "asllib/Parser0.ml"
                  
                in
                let x =
                  let _1 = _1_inlined1 in
                  let i = _1 in
                  
# 290 "asllib/Parser0.mly"
                               ( q ^ "_" ^ i )
# 28890 "asllib/Parser0.ml"
                  
                in
                
# 284 "asllib/Parser0.mly"
        ( AST.(D_TypeDecl (x, ASTUtils.add_pos_from li (T_Record li.desc), None)) )
# 28896 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__5_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 28905 "asllib/Parser0.ml"
              
            in
            
# 233 "asllib/Parser0.mly"
                      Some  
# 28911 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 28917 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let _menhir_s = _menhir_env.MenhirLib.EngineTypes.current in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _endpos = _startpos in
        let _v : ((AST.expr * AST.expr) AST.annotated list) = 
# 216 "<standard.mly>"
    ( [] )
# 28936 "asllib/Parser0.ml"
         in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = e;
            MenhirLib.EngineTypes.startp = _startpos_e_;
            MenhirLib.EngineTypes.endp = _endpos_e_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = c;
                MenhirLib.EngineTypes.startp = _startpos_c_;
                MenhirLib.EngineTypes.endp = _endpos_c_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : ((AST.expr * AST.expr) AST.annotated list) = Obj.magic xs in
        let e : (AST.expr) = Obj.magic e in
        let _3 : unit = Obj.magic _3 in
        let c : (AST.expr) = Obj.magic c in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc = (c, e) in
            let (_endpos_desc_, _startpos_desc_) = (_endpos_e_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 28995 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 29001 "asllib/Parser0.ml"
           : ((AST.expr * AST.expr) AST.annotated list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let _menhir_s = _menhir_env.MenhirLib.EngineTypes.current in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _endpos = _startpos in
        let _v : ((AST.expr * AST.stmt) AST.annotated list) = 
# 216 "<standard.mly>"
    ( [] )
# 29020 "asllib/Parser0.ml"
         in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = expr;
                      MenhirLib.EngineTypes.startp = _startpos_expr_;
                      MenhirLib.EngineTypes.endp = _endpos_expr_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let possibly_empty_block =
                let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 604 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 29101 "asllib/Parser0.ml"
                 _3_1
              in
              (expr, possibly_empty_block)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 29112 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 29118 "asllib/Parser0.ml"
           : ((AST.expr * AST.stmt) AST.annotated list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = expr_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _3;
                          MenhirLib.EngineTypes.startp = _startpos__3_;
                          MenhirLib.EngineTypes.endp = _endpos__3_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = expr;
                            MenhirLib.EngineTypes.startp = _startpos_expr_;
                            MenhirLib.EngineTypes.endp = _endpos_expr_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = _1;
                              MenhirLib.EngineTypes.startp = _startpos__1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic xs in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let _1 = _1_inlined2 in
                        let _2 = 
# 123 "<standard.mly>"
    ( None )
# 29225 "asllib/Parser0.ml"
                         in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 698 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 29232 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 29241 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 695 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 29247 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 29256 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 29264 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 621 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 29270 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 29279 "asllib/Parser0.ml"
                
              in
              (expr, possibly_empty_block)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 29290 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 29296 "asllib/Parser0.ml"
           : ((AST.expr * AST.stmt) AST.annotated list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined6;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined5;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined4;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined3;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = expr_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined2;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _3;
                              MenhirLib.EngineTypes.startp = _startpos__3_;
                              MenhirLib.EngineTypes.endp = _endpos__3_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = expr;
                                MenhirLib.EngineTypes.startp = _startpos_expr_;
                                MenhirLib.EngineTypes.endp = _endpos_expr_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _menhir_s;
                                  MenhirLib.EngineTypes.semv = _1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_;
                                  MenhirLib.EngineTypes.next = _menhir_stack;
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic xs in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                        let _2 =
                          let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                          let x =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 29422 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 126 "<standard.mly>"
    ( Some x )
# 29428 "asllib/Parser0.ml"
                          
                        in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 698 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 29436 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 29445 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 695 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 29451 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 29460 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 29468 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 621 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 29474 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 29483 "asllib/Parser0.ml"
                
              in
              (expr, possibly_empty_block)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 29494 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 29500 "asllib/Parser0.ml"
           : ((AST.expr * AST.stmt) AST.annotated list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = expr;
                  MenhirLib.EngineTypes.startp = _startpos_expr_;
                  MenhirLib.EngineTypes.endp = _endpos_expr_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                let x =
                  let _1_1 = _1 in
                  
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 29568 "asllib/Parser0.ml"
                   _1_1
                in
                
# 196 "<standard.mly>"
    ( x )
# 29574 "asllib/Parser0.ml"
                
              in
              (expr, possibly_empty_block)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 29585 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 29591 "asllib/Parser0.ml"
           : ((AST.expr * AST.stmt) AST.annotated list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = expr;
                MenhirLib.EngineTypes.startp = _startpos_expr_;
                MenhirLib.EngineTypes.endp = _endpos_expr_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic xs in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                
# 597 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 29650 "asllib/Parser0.ml"
                
              in
              (expr, possibly_empty_block)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 29661 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 29667 "asllib/Parser0.ml"
           : ((AST.expr * AST.stmt) AST.annotated list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let _menhir_s = _menhir_env.MenhirLib.EngineTypes.current in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _endpos = _startpos in
        let _v : ((AST.expr * AST.stmt) AST.annotated list) = 
# 216 "<standard.mly>"
    ( [] )
# 29686 "asllib/Parser0.ml"
         in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = expr;
                MenhirLib.EngineTypes.startp = _startpos_expr_;
                MenhirLib.EngineTypes.endp = _endpos_expr_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic xs in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let simple_stmt_list =
                let _1 = _1_inlined1 in
                let _1_1 = _1 in
                
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 29745 "asllib/Parser0.ml"
                 _1_1
              in
              (expr, simple_stmt_list)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 29756 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 29762 "asllib/Parser0.ml"
           : ((AST.expr * AST.stmt) AST.annotated list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let _menhir_s = _menhir_env.MenhirLib.EngineTypes.current in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _endpos = _startpos in
        let _v : (AST.stmt list) = 
# 216 "<standard.mly>"
    ( [] )
# 29781 "asllib/Parser0.ml"
         in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = expr;
                    MenhirLib.EngineTypes.startp = _startpos_expr_;
                    MenhirLib.EngineTypes.endp = _endpos_expr_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined3 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined3 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (AST.stmt list) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let simple_if_stmt =
                let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_else_opt =
                    let _1 = _1_inlined2 in
                    let _2 = 
# 123 "<standard.mly>"
    ( None )
# 29863 "asllib/Parser0.ml"
                     in
                    let _1_1 = _1 in
                    let _2_1 = _2 in
                    
# 698 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 29870 "asllib/Parser0.ml"
                     (_1_1, _2_1)
                  in
                  let simple_stmt_list =
                    let _1 = _1_inlined1 in
                    let _1_1 = _1 in
                    
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 29879 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 695 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 29885 "asllib/Parser0.ml"
                   (expr, simple_stmt_list, simple_else_opt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 29894 "asllib/Parser0.ml"
                
              in
              let simple_stmt_list =
                let _1_1 = _1 in
                
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 29902 "asllib/Parser0.ml"
                 _1_1
              in
              
# 621 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 29908 "asllib/Parser0.ml"
               (simple_stmt_list, simple_if_stmt)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 29917 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 29923 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined5;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined4;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3;
                      MenhirLib.EngineTypes.startp = _startpos__3_;
                      MenhirLib.EngineTypes.endp = _endpos__3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = expr;
                        MenhirLib.EngineTypes.startp = _startpos_expr_;
                        MenhirLib.EngineTypes.endp = _endpos_expr_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined5 : (AST.stmt list) = Obj.magic _1_inlined5 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _1_inlined3 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined3 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (AST.stmt list) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let simple_if_stmt =
                let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_else_opt =
                    let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                    let _2 =
                      let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                      let x =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 30025 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 126 "<standard.mly>"
    ( Some x )
# 30031 "asllib/Parser0.ml"
                      
                    in
                    let _1_1 = _1 in
                    let _2_1 = _2 in
                    
# 698 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 30039 "asllib/Parser0.ml"
                     (_1_1, _2_1)
                  in
                  let simple_stmt_list =
                    let _1 = _1_inlined1 in
                    let _1_1 = _1 in
                    
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 30048 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 695 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 30054 "asllib/Parser0.ml"
                   (expr, simple_stmt_list, simple_else_opt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 30063 "asllib/Parser0.ml"
                
              in
              let simple_stmt_list =
                let _1_1 = _1 in
                
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 30071 "asllib/Parser0.ml"
                 _1_1
              in
              
# 621 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 30077 "asllib/Parser0.ml"
               (simple_stmt_list, simple_if_stmt)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 30086 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 30092 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1 : (AST.stmt list) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let _1_1 = _1 in
              
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 30136 "asllib/Parser0.ml"
               _1_1
            in
            
# 196 "<standard.mly>"
    ( x )
# 30142 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 30148 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined3;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _4;
              MenhirLib.EngineTypes.startp = _startpos__4_;
              MenhirLib.EngineTypes.endp = _endpos__4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _2;
                  MenhirLib.EngineTypes.startp = _startpos__2_;
                  MenhirLib.EngineTypes.endp = _endpos__2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3;
                      MenhirLib.EngineTypes.startp = _startpos__3_;
                      MenhirLib.EngineTypes.endp = _endpos__3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = expr;
                        MenhirLib.EngineTypes.startp = _startpos_expr_;
                        MenhirLib.EngineTypes.endp = _endpos_expr_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _1_inlined3 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined3 in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let _1 = _1_inlined3 in
                let _2 = 
# 123 "<standard.mly>"
    ( None )
# 30235 "asllib/Parser0.ml"
                 in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 718 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 30242 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 604 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 30252 "asllib/Parser0.ml"
                 _3_1
              in
              
# 713 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 30258 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined3_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 30267 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 30273 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__4_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__4_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined6;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined5;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined4;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined3;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _4;
                        MenhirLib.EngineTypes.startp = _startpos__4_;
                        MenhirLib.EngineTypes.endp = _endpos__4_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined2;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _2;
                            MenhirLib.EngineTypes.startp = _startpos__2_;
                            MenhirLib.EngineTypes.endp = _endpos__2_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _3;
                                MenhirLib.EngineTypes.startp = _startpos__3_;
                                MenhirLib.EngineTypes.endp = _endpos__3_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = expr;
                                  MenhirLib.EngineTypes.startp = _startpos_expr_;
                                  MenhirLib.EngineTypes.endp = _endpos_expr_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _menhir_s;
                                    MenhirLib.EngineTypes.semv = _1;
                                    MenhirLib.EngineTypes.startp = _startpos__1_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_;
                                    MenhirLib.EngineTypes.next = _menhir_stack;
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _4_inlined1 : unit = Obj.magic _4_inlined1 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _1_inlined3 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined3 in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_4, _1_inlined3, _2, _1_inlined2, _1_inlined1, _1) = (_4_inlined1, _1_inlined6, _2_inlined1, _1_inlined5, _1_inlined4, _1_inlined3) in
                let _2 =
                  let (_1_inlined2, _1_inlined1, _1) = (_1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                    let _3 = _1_inlined1 in
                    let _3_1 = _3 in
                    
# 604 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 30401 "asllib/Parser0.ml"
                     _3_1
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 30407 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 718 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 30415 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 604 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 30425 "asllib/Parser0.ml"
                 _3_1
              in
              
# 713 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 30431 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__4_inlined1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 30440 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 30446 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined8;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined7;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = expr_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined6;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined5;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined4;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined3;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _4;
                              MenhirLib.EngineTypes.startp = _startpos__4_;
                              MenhirLib.EngineTypes.endp = _endpos__4_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined2;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _2;
                                  MenhirLib.EngineTypes.startp = _startpos__2_;
                                  MenhirLib.EngineTypes.endp = _endpos__2_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _1_inlined1;
                                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = _3;
                                      MenhirLib.EngineTypes.startp = _startpos__3_;
                                      MenhirLib.EngineTypes.endp = _endpos__3_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _;
                                        MenhirLib.EngineTypes.semv = expr;
                                        MenhirLib.EngineTypes.startp = _startpos_expr_;
                                        MenhirLib.EngineTypes.endp = _endpos_expr_;
                                        MenhirLib.EngineTypes.next = {
                                          MenhirLib.EngineTypes.state = _menhir_s;
                                          MenhirLib.EngineTypes.semv = _1;
                                          MenhirLib.EngineTypes.startp = _startpos__1_;
                                          MenhirLib.EngineTypes.endp = _endpos__1_;
                                          MenhirLib.EngineTypes.next = _menhir_stack;
                                        };
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined8 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined8 in
        let _1_inlined7 : (AST.stmt list) = Obj.magic _1_inlined7 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined6 : unit = Obj.magic _1_inlined6 in
        let _1_inlined5 : (AST.stmt list) = Obj.magic _1_inlined5 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _1_inlined3 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined3 in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined5, _1_inlined4, _3, expr, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined6_, _startpos__1_inlined5_, _1_inlined8, _1_inlined7, _3_inlined1, expr_inlined1, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3) in
                let _2 =
                  let (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_if_stmt =
                        let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                        let desc =
                          let simple_else_opt =
                            let _1 = _1_inlined2 in
                            let _2 = 
# 123 "<standard.mly>"
    ( None )
# 30599 "asllib/Parser0.ml"
                             in
                            let _1_1 = _1 in
                            let _2_1 = _2 in
                            
# 698 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 30606 "asllib/Parser0.ml"
                             (_1_1, _2_1)
                          in
                          let simple_stmt_list =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 30615 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 695 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 30621 "asllib/Parser0.ml"
                           (expr, simple_stmt_list, simple_else_opt)
                        in
                        let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                        let _endpos = _endpos_desc_ in
                        let _symbolstartpos = _startpos_desc_ in
                        
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 30630 "asllib/Parser0.ml"
                        
                      in
                      let simple_stmt_list =
                        let _1_1 = _1 in
                        
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 30638 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 621 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 30644 "asllib/Parser0.ml"
                       (simple_stmt_list, simple_if_stmt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 30653 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 30659 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 718 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 30667 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 604 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 30677 "asllib/Parser0.ml"
                 _3_1
              in
              
# 713 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 30683 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 30692 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 30698 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined10;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined10_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined10_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined9;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined9_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined9_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined8;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined7;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = expr_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined6;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined5;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined4;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined3;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _4;
                                  MenhirLib.EngineTypes.startp = _startpos__4_;
                                  MenhirLib.EngineTypes.endp = _endpos__4_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _1_inlined2;
                                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = _2;
                                      MenhirLib.EngineTypes.startp = _startpos__2_;
                                      MenhirLib.EngineTypes.endp = _endpos__2_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _;
                                        MenhirLib.EngineTypes.semv = _1_inlined1;
                                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                        MenhirLib.EngineTypes.next = {
                                          MenhirLib.EngineTypes.state = _;
                                          MenhirLib.EngineTypes.semv = _3;
                                          MenhirLib.EngineTypes.startp = _startpos__3_;
                                          MenhirLib.EngineTypes.endp = _endpos__3_;
                                          MenhirLib.EngineTypes.next = {
                                            MenhirLib.EngineTypes.state = _;
                                            MenhirLib.EngineTypes.semv = expr;
                                            MenhirLib.EngineTypes.startp = _startpos_expr_;
                                            MenhirLib.EngineTypes.endp = _endpos_expr_;
                                            MenhirLib.EngineTypes.next = {
                                              MenhirLib.EngineTypes.state = _menhir_s;
                                              MenhirLib.EngineTypes.semv = _1;
                                              MenhirLib.EngineTypes.startp = _startpos__1_;
                                              MenhirLib.EngineTypes.endp = _endpos__1_;
                                              MenhirLib.EngineTypes.next = _menhir_stack;
                                            };
                                          };
                                        };
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined10 : (AST.stmt list) = Obj.magic _1_inlined10 in
        let _1_inlined9 : unit = Obj.magic _1_inlined9 in
        let _1_inlined8 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined8 in
        let _1_inlined7 : (AST.stmt list) = Obj.magic _1_inlined7 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined6 : unit = Obj.magic _1_inlined6 in
        let _1_inlined5 : (AST.stmt list) = Obj.magic _1_inlined5 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _1_inlined3 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined3 in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined7, _1_inlined6, _1_inlined5, _1_inlined4, _3, expr, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined6_, _startpos__1_inlined5_, _1_inlined10, _1_inlined9, _1_inlined8, _1_inlined7, _3_inlined1, expr_inlined1, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3) in
                let _2 =
                  let (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined7, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_if_stmt =
                        let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                        let desc =
                          let simple_else_opt =
                            let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                            let _2 =
                              let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                              let x =
                                let _1 = _1_inlined1 in
                                let _1_1 = _1 in
                                
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 30870 "asllib/Parser0.ml"
                                 _1_1
                              in
                              
# 126 "<standard.mly>"
    ( Some x )
# 30876 "asllib/Parser0.ml"
                              
                            in
                            let _1_1 = _1 in
                            let _2_1 = _2 in
                            
# 698 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 30884 "asllib/Parser0.ml"
                             (_1_1, _2_1)
                          in
                          let simple_stmt_list =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 30893 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 695 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 30899 "asllib/Parser0.ml"
                           (expr, simple_stmt_list, simple_else_opt)
                        in
                        let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                        let _endpos = _endpos_desc_ in
                        let _symbolstartpos = _startpos_desc_ in
                        
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 30908 "asllib/Parser0.ml"
                        
                      in
                      let simple_stmt_list =
                        let _1_1 = _1 in
                        
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 30916 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 621 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 30922 "asllib/Parser0.ml"
                       (simple_stmt_list, simple_if_stmt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 30931 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 30937 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 718 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 30945 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 604 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 30955 "asllib/Parser0.ml"
                 _3_1
              in
              
# 713 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 30961 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 30970 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 30976 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined5;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined4;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _4;
                    MenhirLib.EngineTypes.startp = _startpos__4_;
                    MenhirLib.EngineTypes.endp = _endpos__4_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _2;
                        MenhirLib.EngineTypes.startp = _startpos__2_;
                        MenhirLib.EngineTypes.endp = _endpos__2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _3;
                            MenhirLib.EngineTypes.startp = _startpos__3_;
                            MenhirLib.EngineTypes.endp = _endpos__3_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = expr;
                              MenhirLib.EngineTypes.startp = _startpos_expr_;
                              MenhirLib.EngineTypes.endp = _endpos_expr_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _menhir_s;
                                MenhirLib.EngineTypes.semv = _1;
                                MenhirLib.EngineTypes.startp = _startpos__1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_;
                                MenhirLib.EngineTypes.next = _menhir_stack;
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined5 : (AST.stmt list) = Obj.magic _1_inlined5 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _1_inlined3 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined3 in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined2, _1_inlined1, _1) = (_1_inlined5, _1_inlined4, _1_inlined3) in
                let _2 =
                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    let x =
                      let _1_1 = _1 in
                      
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 31090 "asllib/Parser0.ml"
                       _1_1
                    in
                    
# 196 "<standard.mly>"
    ( x )
# 31096 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 31102 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 718 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 31110 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 604 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 31120 "asllib/Parser0.ml"
                 _3_1
              in
              
# 713 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 31126 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_inlined1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 31135 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 31141 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined5;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _4;
                  MenhirLib.EngineTypes.startp = _startpos__4_;
                  MenhirLib.EngineTypes.endp = _endpos__4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _2;
                      MenhirLib.EngineTypes.startp = _startpos__2_;
                      MenhirLib.EngineTypes.endp = _endpos__2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _3;
                          MenhirLib.EngineTypes.startp = _startpos__3_;
                          MenhirLib.EngineTypes.endp = _endpos__3_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = expr;
                            MenhirLib.EngineTypes.startp = _startpos_expr_;
                            MenhirLib.EngineTypes.endp = _endpos_expr_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = _1;
                              MenhirLib.EngineTypes.startp = _startpos__1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _1_inlined3 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined3 in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined2, _1_inlined1, _1) = (_1_inlined5, _1_inlined4, _1_inlined3) in
                let _2 =
                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    
# 597 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 31246 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 31252 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 718 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 31260 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 604 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 31270 "asllib/Parser0.ml"
                 _3_1
              in
              
# 713 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 31276 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined5_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 31285 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 31291 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined5;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _6;
              MenhirLib.EngineTypes.startp = _startpos__6_;
              MenhirLib.EngineTypes.endp = _endpos__6_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined4;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = expr_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _3;
                            MenhirLib.EngineTypes.startp = _startpos__3_;
                            MenhirLib.EngineTypes.endp = _endpos__3_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = expr;
                              MenhirLib.EngineTypes.startp = _startpos_expr_;
                              MenhirLib.EngineTypes.endp = _endpos_expr_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _menhir_s;
                                MenhirLib.EngineTypes.semv = _1;
                                MenhirLib.EngineTypes.startp = _startpos__1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_;
                                MenhirLib.EngineTypes.next = _menhir_stack;
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _1_inlined5 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined5 in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let _1 = _1_inlined5 in
                let _2 = 
# 123 "<standard.mly>"
    ( None )
# 31399 "asllib/Parser0.ml"
                 in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 718 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 31406 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let _1 = _1_inlined2 in
                        let _2 = 
# 123 "<standard.mly>"
    ( None )
# 31420 "asllib/Parser0.ml"
                         in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 698 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 31427 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 31436 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 695 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 31442 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 31451 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 31459 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 621 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 31465 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 31474 "asllib/Parser0.ml"
                
              in
              
# 713 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 31480 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined5_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 31489 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 31495 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined8;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined7;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined6;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined5;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _6;
                        MenhirLib.EngineTypes.startp = _startpos__6_;
                        MenhirLib.EngineTypes.endp = _endpos__6_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined4;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined3;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _3_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = expr_inlined1;
                                MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                                MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _1_inlined2;
                                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _1_inlined1;
                                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = _3;
                                      MenhirLib.EngineTypes.startp = _startpos__3_;
                                      MenhirLib.EngineTypes.endp = _endpos__3_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _;
                                        MenhirLib.EngineTypes.semv = expr;
                                        MenhirLib.EngineTypes.startp = _startpos_expr_;
                                        MenhirLib.EngineTypes.endp = _endpos_expr_;
                                        MenhirLib.EngineTypes.next = {
                                          MenhirLib.EngineTypes.state = _menhir_s;
                                          MenhirLib.EngineTypes.semv = _1;
                                          MenhirLib.EngineTypes.startp = _startpos__1_;
                                          MenhirLib.EngineTypes.endp = _endpos__1_;
                                          MenhirLib.EngineTypes.next = _menhir_stack;
                                        };
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined8 : (AST.stmt list) = Obj.magic _1_inlined8 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined7 : unit = Obj.magic _1_inlined7 in
        let _1_inlined6 : unit = Obj.magic _1_inlined6 in
        let _1_inlined5 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined5 in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined3, _1_inlined2, _1_inlined1, _1) = (_1_inlined8, _1_inlined7, _1_inlined6, _1_inlined5) in
                let _2 =
                  let (_1_inlined2, _1_inlined1, _1) = (_1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                    let _3 = _1_inlined1 in
                    let _3_1 = _3 in
                    
# 604 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 31644 "asllib/Parser0.ml"
                     _3_1
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 31650 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 718 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 31658 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let _1 = _1_inlined2 in
                        let _2 = 
# 123 "<standard.mly>"
    ( None )
# 31672 "asllib/Parser0.ml"
                         in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 698 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 31679 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 31688 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 695 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 31694 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 31703 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 31711 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 621 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 31717 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 31726 "asllib/Parser0.ml"
                
              in
              
# 713 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 31732 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 31741 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 31747 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__6_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__6_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined10;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined10_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined10_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined9;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined9_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined9_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = expr_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos_expr_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos_expr_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined8;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined7;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined6;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined5;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _6;
                              MenhirLib.EngineTypes.startp = _startpos__6_;
                              MenhirLib.EngineTypes.endp = _endpos__6_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined4;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _1_inlined3;
                                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _3_inlined1;
                                    MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                                    MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = expr_inlined1;
                                      MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                                      MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _;
                                        MenhirLib.EngineTypes.semv = _1_inlined2;
                                        MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                        MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                        MenhirLib.EngineTypes.next = {
                                          MenhirLib.EngineTypes.state = _;
                                          MenhirLib.EngineTypes.semv = _1_inlined1;
                                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                          MenhirLib.EngineTypes.next = {
                                            MenhirLib.EngineTypes.state = _;
                                            MenhirLib.EngineTypes.semv = _3;
                                            MenhirLib.EngineTypes.startp = _startpos__3_;
                                            MenhirLib.EngineTypes.endp = _endpos__3_;
                                            MenhirLib.EngineTypes.next = {
                                              MenhirLib.EngineTypes.state = _;
                                              MenhirLib.EngineTypes.semv = expr;
                                              MenhirLib.EngineTypes.startp = _startpos_expr_;
                                              MenhirLib.EngineTypes.endp = _endpos_expr_;
                                              MenhirLib.EngineTypes.next = {
                                                MenhirLib.EngineTypes.state = _menhir_s;
                                                MenhirLib.EngineTypes.semv = _1;
                                                MenhirLib.EngineTypes.startp = _startpos__1_;
                                                MenhirLib.EngineTypes.endp = _endpos__1_;
                                                MenhirLib.EngineTypes.next = _menhir_stack;
                                              };
                                            };
                                          };
                                        };
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _6_inlined1 : unit = Obj.magic _6_inlined1 in
        let _1_inlined10 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined10 in
        let _1_inlined9 : (AST.stmt list) = Obj.magic _1_inlined9 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let expr_inlined2 : (AST.expr) = Obj.magic expr_inlined2 in
        let _1_inlined8 : unit = Obj.magic _1_inlined8 in
        let _1_inlined7 : (AST.stmt list) = Obj.magic _1_inlined7 in
        let _1_inlined6 : unit = Obj.magic _1_inlined6 in
        let _1_inlined5 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined5 in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_endpos__6_, _startpos__1_inlined3_, _startpos__1_inlined2_, _6, _1_inlined5, _1_inlined4, _3, expr, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_endpos__6_inlined1_, _startpos__1_inlined8_, _startpos__1_inlined7_, _6_inlined1, _1_inlined10, _1_inlined9, _3_inlined2, expr_inlined2, _1_inlined8, _1_inlined7, _1_inlined6, _1_inlined5) in
                let _2 =
                  let (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_if_stmt =
                        let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                        let desc =
                          let simple_else_opt =
                            let _1 = _1_inlined2 in
                            let _2 = 
# 123 "<standard.mly>"
    ( None )
# 31921 "asllib/Parser0.ml"
                             in
                            let _1_1 = _1 in
                            let _2_1 = _2 in
                            
# 698 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 31928 "asllib/Parser0.ml"
                             (_1_1, _2_1)
                          in
                          let simple_stmt_list =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 31937 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 695 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 31943 "asllib/Parser0.ml"
                           (expr, simple_stmt_list, simple_else_opt)
                        in
                        let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                        let _endpos = _endpos_desc_ in
                        let _symbolstartpos = _startpos_desc_ in
                        
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 31952 "asllib/Parser0.ml"
                        
                      in
                      let simple_stmt_list =
                        let _1_1 = _1 in
                        
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 31960 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 621 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 31966 "asllib/Parser0.ml"
                       (simple_stmt_list, simple_if_stmt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 31975 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 31981 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 718 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 31989 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let _1 = _1_inlined2 in
                        let _2 = 
# 123 "<standard.mly>"
    ( None )
# 32003 "asllib/Parser0.ml"
                         in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 698 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 32010 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 32019 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 695 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 32025 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 32034 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 32042 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 621 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 32048 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 32057 "asllib/Parser0.ml"
                
              in
              
# 713 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 32063 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_inlined1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 32072 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 32078 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__6_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__6_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined12;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined12_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined12_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined11;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined11_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined11_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined10;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined10_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined10_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined9;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined9_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined9_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = expr_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos_expr_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos_expr_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined8;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined7;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined6;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined5;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _6;
                                  MenhirLib.EngineTypes.startp = _startpos__6_;
                                  MenhirLib.EngineTypes.endp = _endpos__6_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _1_inlined4;
                                    MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = _1_inlined3;
                                      MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                                      MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _;
                                        MenhirLib.EngineTypes.semv = _3_inlined1;
                                        MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                                        MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                                        MenhirLib.EngineTypes.next = {
                                          MenhirLib.EngineTypes.state = _;
                                          MenhirLib.EngineTypes.semv = expr_inlined1;
                                          MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                                          MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                                          MenhirLib.EngineTypes.next = {
                                            MenhirLib.EngineTypes.state = _;
                                            MenhirLib.EngineTypes.semv = _1_inlined2;
                                            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                            MenhirLib.EngineTypes.next = {
                                              MenhirLib.EngineTypes.state = _;
                                              MenhirLib.EngineTypes.semv = _1_inlined1;
                                              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                              MenhirLib.EngineTypes.next = {
                                                MenhirLib.EngineTypes.state = _;
                                                MenhirLib.EngineTypes.semv = _3;
                                                MenhirLib.EngineTypes.startp = _startpos__3_;
                                                MenhirLib.EngineTypes.endp = _endpos__3_;
                                                MenhirLib.EngineTypes.next = {
                                                  MenhirLib.EngineTypes.state = _;
                                                  MenhirLib.EngineTypes.semv = expr;
                                                  MenhirLib.EngineTypes.startp = _startpos_expr_;
                                                  MenhirLib.EngineTypes.endp = _endpos_expr_;
                                                  MenhirLib.EngineTypes.next = {
                                                    MenhirLib.EngineTypes.state = _menhir_s;
                                                    MenhirLib.EngineTypes.semv = _1;
                                                    MenhirLib.EngineTypes.startp = _startpos__1_;
                                                    MenhirLib.EngineTypes.endp = _endpos__1_;
                                                    MenhirLib.EngineTypes.next = _menhir_stack;
                                                  };
                                                };
                                              };
                                            };
                                          };
                                        };
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _6_inlined1 : unit = Obj.magic _6_inlined1 in
        let _1_inlined12 : (AST.stmt list) = Obj.magic _1_inlined12 in
        let _1_inlined11 : unit = Obj.magic _1_inlined11 in
        let _1_inlined10 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined10 in
        let _1_inlined9 : (AST.stmt list) = Obj.magic _1_inlined9 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let expr_inlined2 : (AST.expr) = Obj.magic expr_inlined2 in
        let _1_inlined8 : unit = Obj.magic _1_inlined8 in
        let _1_inlined7 : (AST.stmt list) = Obj.magic _1_inlined7 in
        let _1_inlined6 : unit = Obj.magic _1_inlined6 in
        let _1_inlined5 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined5 in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_endpos__6_, _startpos__1_inlined3_, _startpos__1_inlined2_, _6, _1_inlined7, _1_inlined6, _1_inlined5, _1_inlined4, _3, expr, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_endpos__6_inlined1_, _startpos__1_inlined8_, _startpos__1_inlined7_, _6_inlined1, _1_inlined12, _1_inlined11, _1_inlined10, _1_inlined9, _3_inlined2, expr_inlined2, _1_inlined8, _1_inlined7, _1_inlined6, _1_inlined5) in
                let _2 =
                  let (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined7, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_if_stmt =
                        let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                        let desc =
                          let simple_else_opt =
                            let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                            let _2 =
                              let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                              let x =
                                let _1 = _1_inlined1 in
                                let _1_1 = _1 in
                                
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 32271 "asllib/Parser0.ml"
                                 _1_1
                              in
                              
# 126 "<standard.mly>"
    ( Some x )
# 32277 "asllib/Parser0.ml"
                              
                            in
                            let _1_1 = _1 in
                            let _2_1 = _2 in
                            
# 698 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 32285 "asllib/Parser0.ml"
                             (_1_1, _2_1)
                          in
                          let simple_stmt_list =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 32294 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 695 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 32300 "asllib/Parser0.ml"
                           (expr, simple_stmt_list, simple_else_opt)
                        in
                        let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                        let _endpos = _endpos_desc_ in
                        let _symbolstartpos = _startpos_desc_ in
                        
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 32309 "asllib/Parser0.ml"
                        
                      in
                      let simple_stmt_list =
                        let _1_1 = _1 in
                        
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 32317 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 621 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 32323 "asllib/Parser0.ml"
                       (simple_stmt_list, simple_if_stmt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 32332 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 32338 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 718 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 32346 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let _1 = _1_inlined2 in
                        let _2 = 
# 123 "<standard.mly>"
    ( None )
# 32360 "asllib/Parser0.ml"
                         in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 698 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 32367 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 32376 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 695 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 32382 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 32391 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 32399 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 621 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 32405 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 32414 "asllib/Parser0.ml"
                
              in
              
# 713 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 32420 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_inlined1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 32429 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 32435 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined7;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined6;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined5;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _6;
                    MenhirLib.EngineTypes.startp = _startpos__6_;
                    MenhirLib.EngineTypes.endp = _endpos__6_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined4;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined3;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _3_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = expr_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined2;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined1;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _3;
                                  MenhirLib.EngineTypes.startp = _startpos__3_;
                                  MenhirLib.EngineTypes.endp = _endpos__3_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = expr;
                                    MenhirLib.EngineTypes.startp = _startpos_expr_;
                                    MenhirLib.EngineTypes.endp = _endpos_expr_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _menhir_s;
                                      MenhirLib.EngineTypes.semv = _1;
                                      MenhirLib.EngineTypes.startp = _startpos__1_;
                                      MenhirLib.EngineTypes.endp = _endpos__1_;
                                      MenhirLib.EngineTypes.next = _menhir_stack;
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined7 : (AST.stmt list) = Obj.magic _1_inlined7 in
        let _1_inlined6 : unit = Obj.magic _1_inlined6 in
        let _1_inlined5 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined5 in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined2, _1_inlined1, _1) = (_1_inlined7, _1_inlined6, _1_inlined5) in
                let _2 =
                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    let x =
                      let _1_1 = _1 in
                      
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 32570 "asllib/Parser0.ml"
                       _1_1
                    in
                    
# 196 "<standard.mly>"
    ( x )
# 32576 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 32582 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 718 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 32590 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let _1 = _1_inlined2 in
                        let _2 = 
# 123 "<standard.mly>"
    ( None )
# 32604 "asllib/Parser0.ml"
                         in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 698 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 32611 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 32620 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 695 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 32626 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 32635 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 32643 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 621 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 32649 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 32658 "asllib/Parser0.ml"
                
              in
              
# 713 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 32664 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 32673 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 32679 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined7;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined6;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined5;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _6;
                  MenhirLib.EngineTypes.startp = _startpos__6_;
                  MenhirLib.EngineTypes.endp = _endpos__6_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined4;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined3;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = expr_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined2;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _3;
                                MenhirLib.EngineTypes.startp = _startpos__3_;
                                MenhirLib.EngineTypes.endp = _endpos__3_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = expr;
                                  MenhirLib.EngineTypes.startp = _startpos_expr_;
                                  MenhirLib.EngineTypes.endp = _endpos_expr_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _menhir_s;
                                    MenhirLib.EngineTypes.semv = _1;
                                    MenhirLib.EngineTypes.startp = _startpos__1_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_;
                                    MenhirLib.EngineTypes.next = _menhir_stack;
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _1_inlined7 : unit = Obj.magic _1_inlined7 in
        let _1_inlined6 : unit = Obj.magic _1_inlined6 in
        let _1_inlined5 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined5 in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined2, _1_inlined1, _1) = (_1_inlined7, _1_inlined6, _1_inlined5) in
                let _2 =
                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    
# 597 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 32805 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 32811 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 718 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 32819 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let _1 = _1_inlined2 in
                        let _2 = 
# 123 "<standard.mly>"
    ( None )
# 32833 "asllib/Parser0.ml"
                         in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 698 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 32840 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 32849 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 695 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 32855 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 32864 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 32872 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 621 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 32878 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 32887 "asllib/Parser0.ml"
                
              in
              
# 713 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 32893 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined7_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 32902 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 32908 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined7;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _6;
              MenhirLib.EngineTypes.startp = _startpos__6_;
              MenhirLib.EngineTypes.endp = _endpos__6_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined6;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined5;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined4;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined3;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = expr_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined2;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _3;
                                MenhirLib.EngineTypes.startp = _startpos__3_;
                                MenhirLib.EngineTypes.endp = _endpos__3_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = expr;
                                  MenhirLib.EngineTypes.startp = _startpos_expr_;
                                  MenhirLib.EngineTypes.endp = _endpos_expr_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _menhir_s;
                                    MenhirLib.EngineTypes.semv = _1;
                                    MenhirLib.EngineTypes.startp = _startpos__1_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_;
                                    MenhirLib.EngineTypes.next = _menhir_stack;
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _1_inlined7 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined7 in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let _1 = _1_inlined7 in
                let _2 = 
# 123 "<standard.mly>"
    ( None )
# 33030 "asllib/Parser0.ml"
                 in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 718 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 33037 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                        let _2 =
                          let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                          let x =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 33056 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 126 "<standard.mly>"
    ( Some x )
# 33062 "asllib/Parser0.ml"
                          
                        in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 698 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 33070 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 33079 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 695 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 33085 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 33094 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 33102 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 621 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 33108 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 33117 "asllib/Parser0.ml"
                
              in
              
# 713 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 33123 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined7_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 33132 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 33138 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined10;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined10_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined10_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined9;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined9_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined9_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined8;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined7;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _6;
                        MenhirLib.EngineTypes.startp = _startpos__6_;
                        MenhirLib.EngineTypes.endp = _endpos__6_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined6;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined5;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined4;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined3;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _3_inlined1;
                                  MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                                  MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = expr_inlined1;
                                    MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                                    MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = _1_inlined2;
                                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _;
                                        MenhirLib.EngineTypes.semv = _1_inlined1;
                                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                        MenhirLib.EngineTypes.next = {
                                          MenhirLib.EngineTypes.state = _;
                                          MenhirLib.EngineTypes.semv = _3;
                                          MenhirLib.EngineTypes.startp = _startpos__3_;
                                          MenhirLib.EngineTypes.endp = _endpos__3_;
                                          MenhirLib.EngineTypes.next = {
                                            MenhirLib.EngineTypes.state = _;
                                            MenhirLib.EngineTypes.semv = expr;
                                            MenhirLib.EngineTypes.startp = _startpos_expr_;
                                            MenhirLib.EngineTypes.endp = _endpos_expr_;
                                            MenhirLib.EngineTypes.next = {
                                              MenhirLib.EngineTypes.state = _menhir_s;
                                              MenhirLib.EngineTypes.semv = _1;
                                              MenhirLib.EngineTypes.startp = _startpos__1_;
                                              MenhirLib.EngineTypes.endp = _endpos__1_;
                                              MenhirLib.EngineTypes.next = _menhir_stack;
                                            };
                                          };
                                        };
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined10 : (AST.stmt list) = Obj.magic _1_inlined10 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined9 : unit = Obj.magic _1_inlined9 in
        let _1_inlined8 : unit = Obj.magic _1_inlined8 in
        let _1_inlined7 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined7 in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined3, _1_inlined2, _1_inlined1, _1) = (_1_inlined10, _1_inlined9, _1_inlined8, _1_inlined7) in
                let _2 =
                  let (_1_inlined2, _1_inlined1, _1) = (_1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                    let _3 = _1_inlined1 in
                    let _3_1 = _3 in
                    
# 604 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 33301 "asllib/Parser0.ml"
                     _3_1
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 33307 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 718 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 33315 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                        let _2 =
                          let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                          let x =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 33334 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 126 "<standard.mly>"
    ( Some x )
# 33340 "asllib/Parser0.ml"
                          
                        in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 698 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 33348 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 33357 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 695 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 33363 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 33372 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 33380 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 621 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 33386 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 33395 "asllib/Parser0.ml"
                
              in
              
# 713 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 33401 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 33410 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 33416 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__6_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__6_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined12;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined12_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined12_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined11;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined11_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined11_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = expr_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos_expr_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos_expr_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined10;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined10_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined10_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined9;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined9_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined9_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined8;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined7;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _6;
                              MenhirLib.EngineTypes.startp = _startpos__6_;
                              MenhirLib.EngineTypes.endp = _endpos__6_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined6;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _1_inlined5;
                                  MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _1_inlined4;
                                    MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = _1_inlined3;
                                      MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                                      MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _;
                                        MenhirLib.EngineTypes.semv = _3_inlined1;
                                        MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                                        MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                                        MenhirLib.EngineTypes.next = {
                                          MenhirLib.EngineTypes.state = _;
                                          MenhirLib.EngineTypes.semv = expr_inlined1;
                                          MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                                          MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                                          MenhirLib.EngineTypes.next = {
                                            MenhirLib.EngineTypes.state = _;
                                            MenhirLib.EngineTypes.semv = _1_inlined2;
                                            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                            MenhirLib.EngineTypes.next = {
                                              MenhirLib.EngineTypes.state = _;
                                              MenhirLib.EngineTypes.semv = _1_inlined1;
                                              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                              MenhirLib.EngineTypes.next = {
                                                MenhirLib.EngineTypes.state = _;
                                                MenhirLib.EngineTypes.semv = _3;
                                                MenhirLib.EngineTypes.startp = _startpos__3_;
                                                MenhirLib.EngineTypes.endp = _endpos__3_;
                                                MenhirLib.EngineTypes.next = {
                                                  MenhirLib.EngineTypes.state = _;
                                                  MenhirLib.EngineTypes.semv = expr;
                                                  MenhirLib.EngineTypes.startp = _startpos_expr_;
                                                  MenhirLib.EngineTypes.endp = _endpos_expr_;
                                                  MenhirLib.EngineTypes.next = {
                                                    MenhirLib.EngineTypes.state = _menhir_s;
                                                    MenhirLib.EngineTypes.semv = _1;
                                                    MenhirLib.EngineTypes.startp = _startpos__1_;
                                                    MenhirLib.EngineTypes.endp = _endpos__1_;
                                                    MenhirLib.EngineTypes.next = _menhir_stack;
                                                  };
                                                };
                                              };
                                            };
                                          };
                                        };
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _6_inlined1 : unit = Obj.magic _6_inlined1 in
        let _1_inlined12 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined12 in
        let _1_inlined11 : (AST.stmt list) = Obj.magic _1_inlined11 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let expr_inlined2 : (AST.expr) = Obj.magic expr_inlined2 in
        let _1_inlined10 : unit = Obj.magic _1_inlined10 in
        let _1_inlined9 : (AST.stmt list) = Obj.magic _1_inlined9 in
        let _1_inlined8 : unit = Obj.magic _1_inlined8 in
        let _1_inlined7 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined7 in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_endpos__6_, _startpos__1_inlined3_, _startpos__1_inlined2_, _6, _1_inlined5, _1_inlined4, _3, expr, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_endpos__6_inlined1_, _startpos__1_inlined10_, _startpos__1_inlined9_, _6_inlined1, _1_inlined12, _1_inlined11, _3_inlined2, expr_inlined2, _1_inlined10, _1_inlined9, _1_inlined8, _1_inlined7) in
                let _2 =
                  let (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_if_stmt =
                        let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                        let desc =
                          let simple_else_opt =
                            let _1 = _1_inlined2 in
                            let _2 = 
# 123 "<standard.mly>"
    ( None )
# 33604 "asllib/Parser0.ml"
                             in
                            let _1_1 = _1 in
                            let _2_1 = _2 in
                            
# 698 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 33611 "asllib/Parser0.ml"
                             (_1_1, _2_1)
                          in
                          let simple_stmt_list =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 33620 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 695 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 33626 "asllib/Parser0.ml"
                           (expr, simple_stmt_list, simple_else_opt)
                        in
                        let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                        let _endpos = _endpos_desc_ in
                        let _symbolstartpos = _startpos_desc_ in
                        
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 33635 "asllib/Parser0.ml"
                        
                      in
                      let simple_stmt_list =
                        let _1_1 = _1 in
                        
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 33643 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 621 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 33649 "asllib/Parser0.ml"
                       (simple_stmt_list, simple_if_stmt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 33658 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 33664 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 718 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 33672 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                        let _2 =
                          let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                          let x =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 33691 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 126 "<standard.mly>"
    ( Some x )
# 33697 "asllib/Parser0.ml"
                          
                        in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 698 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 33705 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 33714 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 695 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 33720 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 33729 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 33737 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 621 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 33743 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 33752 "asllib/Parser0.ml"
                
              in
              
# 713 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 33758 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_inlined1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 33767 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 33773 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__6_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__6_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined14;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined14_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined14_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined13;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined13_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined13_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined12;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined12_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined12_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined11;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined11_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined11_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = expr_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos_expr_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos_expr_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined10;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined10_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined10_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined9;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined9_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined9_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined8;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined7;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _6;
                                  MenhirLib.EngineTypes.startp = _startpos__6_;
                                  MenhirLib.EngineTypes.endp = _endpos__6_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _1_inlined6;
                                    MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = _1_inlined5;
                                      MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                                      MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _;
                                        MenhirLib.EngineTypes.semv = _1_inlined4;
                                        MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                                        MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                                        MenhirLib.EngineTypes.next = {
                                          MenhirLib.EngineTypes.state = _;
                                          MenhirLib.EngineTypes.semv = _1_inlined3;
                                          MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                                          MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                                          MenhirLib.EngineTypes.next = {
                                            MenhirLib.EngineTypes.state = _;
                                            MenhirLib.EngineTypes.semv = _3_inlined1;
                                            MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                                            MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                                            MenhirLib.EngineTypes.next = {
                                              MenhirLib.EngineTypes.state = _;
                                              MenhirLib.EngineTypes.semv = expr_inlined1;
                                              MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                                              MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                                              MenhirLib.EngineTypes.next = {
                                                MenhirLib.EngineTypes.state = _;
                                                MenhirLib.EngineTypes.semv = _1_inlined2;
                                                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                                MenhirLib.EngineTypes.next = {
                                                  MenhirLib.EngineTypes.state = _;
                                                  MenhirLib.EngineTypes.semv = _1_inlined1;
                                                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                                  MenhirLib.EngineTypes.next = {
                                                    MenhirLib.EngineTypes.state = _;
                                                    MenhirLib.EngineTypes.semv = _3;
                                                    MenhirLib.EngineTypes.startp = _startpos__3_;
                                                    MenhirLib.EngineTypes.endp = _endpos__3_;
                                                    MenhirLib.EngineTypes.next = {
                                                      MenhirLib.EngineTypes.state = _;
                                                      MenhirLib.EngineTypes.semv = expr;
                                                      MenhirLib.EngineTypes.startp = _startpos_expr_;
                                                      MenhirLib.EngineTypes.endp = _endpos_expr_;
                                                      MenhirLib.EngineTypes.next = {
                                                        MenhirLib.EngineTypes.state = _menhir_s;
                                                        MenhirLib.EngineTypes.semv = _1;
                                                        MenhirLib.EngineTypes.startp = _startpos__1_;
                                                        MenhirLib.EngineTypes.endp = _endpos__1_;
                                                        MenhirLib.EngineTypes.next = _menhir_stack;
                                                      };
                                                    };
                                                  };
                                                };
                                              };
                                            };
                                          };
                                        };
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _6_inlined1 : unit = Obj.magic _6_inlined1 in
        let _1_inlined14 : (AST.stmt list) = Obj.magic _1_inlined14 in
        let _1_inlined13 : unit = Obj.magic _1_inlined13 in
        let _1_inlined12 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined12 in
        let _1_inlined11 : (AST.stmt list) = Obj.magic _1_inlined11 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let expr_inlined2 : (AST.expr) = Obj.magic expr_inlined2 in
        let _1_inlined10 : unit = Obj.magic _1_inlined10 in
        let _1_inlined9 : (AST.stmt list) = Obj.magic _1_inlined9 in
        let _1_inlined8 : unit = Obj.magic _1_inlined8 in
        let _1_inlined7 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined7 in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_endpos__6_, _startpos__1_inlined3_, _startpos__1_inlined2_, _6, _1_inlined7, _1_inlined6, _1_inlined5, _1_inlined4, _3, expr, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_endpos__6_inlined1_, _startpos__1_inlined10_, _startpos__1_inlined9_, _6_inlined1, _1_inlined14, _1_inlined13, _1_inlined12, _1_inlined11, _3_inlined2, expr_inlined2, _1_inlined10, _1_inlined9, _1_inlined8, _1_inlined7) in
                let _2 =
                  let (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined7, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_if_stmt =
                        let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                        let desc =
                          let simple_else_opt =
                            let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                            let _2 =
                              let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                              let x =
                                let _1 = _1_inlined1 in
                                let _1_1 = _1 in
                                
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 33980 "asllib/Parser0.ml"
                                 _1_1
                              in
                              
# 126 "<standard.mly>"
    ( Some x )
# 33986 "asllib/Parser0.ml"
                              
                            in
                            let _1_1 = _1 in
                            let _2_1 = _2 in
                            
# 698 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 33994 "asllib/Parser0.ml"
                             (_1_1, _2_1)
                          in
                          let simple_stmt_list =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 34003 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 695 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 34009 "asllib/Parser0.ml"
                           (expr, simple_stmt_list, simple_else_opt)
                        in
                        let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                        let _endpos = _endpos_desc_ in
                        let _symbolstartpos = _startpos_desc_ in
                        
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 34018 "asllib/Parser0.ml"
                        
                      in
                      let simple_stmt_list =
                        let _1_1 = _1 in
                        
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 34026 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 621 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 34032 "asllib/Parser0.ml"
                       (simple_stmt_list, simple_if_stmt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 34041 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 34047 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 718 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 34055 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                        let _2 =
                          let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                          let x =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 34074 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 126 "<standard.mly>"
    ( Some x )
# 34080 "asllib/Parser0.ml"
                          
                        in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 698 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 34088 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 34097 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 695 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 34103 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 34112 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 34120 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 621 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 34126 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 34135 "asllib/Parser0.ml"
                
              in
              
# 713 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 34141 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_inlined1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 34150 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 34156 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined9;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined9_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined9_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined8;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined7;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _6;
                    MenhirLib.EngineTypes.startp = _startpos__6_;
                    MenhirLib.EngineTypes.endp = _endpos__6_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined6;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined5;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined4;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined3;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _3_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = expr_inlined1;
                                MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                                MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _1_inlined2;
                                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _1_inlined1;
                                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = _3;
                                      MenhirLib.EngineTypes.startp = _startpos__3_;
                                      MenhirLib.EngineTypes.endp = _endpos__3_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _;
                                        MenhirLib.EngineTypes.semv = expr;
                                        MenhirLib.EngineTypes.startp = _startpos_expr_;
                                        MenhirLib.EngineTypes.endp = _endpos_expr_;
                                        MenhirLib.EngineTypes.next = {
                                          MenhirLib.EngineTypes.state = _menhir_s;
                                          MenhirLib.EngineTypes.semv = _1;
                                          MenhirLib.EngineTypes.startp = _startpos__1_;
                                          MenhirLib.EngineTypes.endp = _endpos__1_;
                                          MenhirLib.EngineTypes.next = _menhir_stack;
                                        };
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined9 : (AST.stmt list) = Obj.magic _1_inlined9 in
        let _1_inlined8 : unit = Obj.magic _1_inlined8 in
        let _1_inlined7 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined7 in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined2, _1_inlined1, _1) = (_1_inlined9, _1_inlined8, _1_inlined7) in
                let _2 =
                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    let x =
                      let _1_1 = _1 in
                      
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 34305 "asllib/Parser0.ml"
                       _1_1
                    in
                    
# 196 "<standard.mly>"
    ( x )
# 34311 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 34317 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 718 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 34325 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                        let _2 =
                          let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                          let x =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 34344 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 126 "<standard.mly>"
    ( Some x )
# 34350 "asllib/Parser0.ml"
                          
                        in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 698 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 34358 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 34367 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 695 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 34373 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 34382 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 34390 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 621 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 34396 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 34405 "asllib/Parser0.ml"
                
              in
              
# 713 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 34411 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 34420 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 34426 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined9;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined9_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined9_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined8;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined7;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _6;
                  MenhirLib.EngineTypes.startp = _startpos__6_;
                  MenhirLib.EngineTypes.endp = _endpos__6_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined6;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined5;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined4;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined3;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _3_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = expr_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined2;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _1_inlined1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _3;
                                    MenhirLib.EngineTypes.startp = _startpos__3_;
                                    MenhirLib.EngineTypes.endp = _endpos__3_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = expr;
                                      MenhirLib.EngineTypes.startp = _startpos_expr_;
                                      MenhirLib.EngineTypes.endp = _endpos_expr_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _menhir_s;
                                        MenhirLib.EngineTypes.semv = _1;
                                        MenhirLib.EngineTypes.startp = _startpos__1_;
                                        MenhirLib.EngineTypes.endp = _endpos__1_;
                                        MenhirLib.EngineTypes.next = _menhir_stack;
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _1_inlined9 : unit = Obj.magic _1_inlined9 in
        let _1_inlined8 : unit = Obj.magic _1_inlined8 in
        let _1_inlined7 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined7 in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined2, _1_inlined1, _1) = (_1_inlined9, _1_inlined8, _1_inlined7) in
                let _2 =
                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    
# 597 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 34566 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 34572 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 718 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 34580 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                        let _2 =
                          let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                          let x =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 34599 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 126 "<standard.mly>"
    ( Some x )
# 34605 "asllib/Parser0.ml"
                          
                        in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 698 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 34613 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 34622 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 695 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 34628 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 34637 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 34645 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 621 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 34651 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 34660 "asllib/Parser0.ml"
                
              in
              
# 713 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 34666 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined9_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 34675 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 34681 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined2;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2;
              MenhirLib.EngineTypes.startp = _startpos__2_;
              MenhirLib.EngineTypes.endp = _endpos__2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = expr;
                    MenhirLib.EngineTypes.startp = _startpos_expr_;
                    MenhirLib.EngineTypes.endp = _endpos_expr_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let _1 = _1_inlined2 in
                let _2 = 
# 123 "<standard.mly>"
    ( None )
# 34754 "asllib/Parser0.ml"
                 in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 718 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 34761 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                let x =
                  let _1_1 = _1 in
                  
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 34771 "asllib/Parser0.ml"
                   _1_1
                in
                
# 196 "<standard.mly>"
    ( x )
# 34777 "asllib/Parser0.ml"
                
              in
              
# 713 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 34783 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 34792 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 34798 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined5;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined4;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined3;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _2;
                        MenhirLib.EngineTypes.startp = _startpos__2_;
                        MenhirLib.EngineTypes.endp = _endpos__2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _3;
                            MenhirLib.EngineTypes.startp = _startpos__3_;
                            MenhirLib.EngineTypes.endp = _endpos__3_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = expr;
                              MenhirLib.EngineTypes.startp = _startpos_expr_;
                              MenhirLib.EngineTypes.endp = _endpos_expr_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _menhir_s;
                                MenhirLib.EngineTypes.semv = _1;
                                MenhirLib.EngineTypes.startp = _startpos__1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_;
                                MenhirLib.EngineTypes.next = _menhir_stack;
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined5 : (AST.stmt list) = Obj.magic _1_inlined5 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined3, _2, _1_inlined2, _1_inlined1, _1) = (_1_inlined5, _2_inlined1, _1_inlined4, _1_inlined3, _1_inlined2) in
                let _2 =
                  let (_1_inlined2, _1_inlined1, _1) = (_1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                    let _3 = _1_inlined1 in
                    let _3_1 = _3 in
                    
# 604 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 34912 "asllib/Parser0.ml"
                     _3_1
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 34918 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 718 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 34926 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                let x =
                  let _1_1 = _1 in
                  
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 34936 "asllib/Parser0.ml"
                   _1_1
                in
                
# 196 "<standard.mly>"
    ( x )
# 34942 "asllib/Parser0.ml"
                
              in
              
# 713 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 34948 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 34957 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 34963 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined7;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined6;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = expr_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined5;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined4;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined3;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined2;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _2;
                              MenhirLib.EngineTypes.startp = _startpos__2_;
                              MenhirLib.EngineTypes.endp = _endpos__2_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined1;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _3;
                                  MenhirLib.EngineTypes.startp = _startpos__3_;
                                  MenhirLib.EngineTypes.endp = _endpos__3_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = expr;
                                    MenhirLib.EngineTypes.startp = _startpos_expr_;
                                    MenhirLib.EngineTypes.endp = _endpos_expr_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _menhir_s;
                                      MenhirLib.EngineTypes.semv = _1;
                                      MenhirLib.EngineTypes.startp = _startpos__1_;
                                      MenhirLib.EngineTypes.endp = _endpos__1_;
                                      MenhirLib.EngineTypes.next = _menhir_stack;
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined7 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined7 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined5, _1_inlined4, _3, expr, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined5_, _startpos__1_inlined4_, _1_inlined7, _1_inlined6, _3_inlined1, expr_inlined1, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2) in
                let _2 =
                  let (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_if_stmt =
                        let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                        let desc =
                          let simple_else_opt =
                            let _1 = _1_inlined2 in
                            let _2 = 
# 123 "<standard.mly>"
    ( None )
# 35102 "asllib/Parser0.ml"
                             in
                            let _1_1 = _1 in
                            let _2_1 = _2 in
                            
# 698 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 35109 "asllib/Parser0.ml"
                             (_1_1, _2_1)
                          in
                          let simple_stmt_list =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 35118 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 695 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 35124 "asllib/Parser0.ml"
                           (expr, simple_stmt_list, simple_else_opt)
                        in
                        let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                        let _endpos = _endpos_desc_ in
                        let _symbolstartpos = _startpos_desc_ in
                        
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 35133 "asllib/Parser0.ml"
                        
                      in
                      let simple_stmt_list =
                        let _1_1 = _1 in
                        
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 35141 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 621 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 35147 "asllib/Parser0.ml"
                       (simple_stmt_list, simple_if_stmt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 35156 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 35162 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 718 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 35170 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                let x =
                  let _1_1 = _1 in
                  
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 35180 "asllib/Parser0.ml"
                   _1_1
                in
                
# 196 "<standard.mly>"
    ( x )
# 35186 "asllib/Parser0.ml"
                
              in
              
# 713 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 35192 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 35201 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 35207 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined9;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined9_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined9_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined8;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined7;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined6;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = expr_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined5;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined4;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined3;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined2;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _2;
                                  MenhirLib.EngineTypes.startp = _startpos__2_;
                                  MenhirLib.EngineTypes.endp = _endpos__2_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _1_inlined1;
                                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = _3;
                                      MenhirLib.EngineTypes.startp = _startpos__3_;
                                      MenhirLib.EngineTypes.endp = _endpos__3_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _;
                                        MenhirLib.EngineTypes.semv = expr;
                                        MenhirLib.EngineTypes.startp = _startpos_expr_;
                                        MenhirLib.EngineTypes.endp = _endpos_expr_;
                                        MenhirLib.EngineTypes.next = {
                                          MenhirLib.EngineTypes.state = _menhir_s;
                                          MenhirLib.EngineTypes.semv = _1;
                                          MenhirLib.EngineTypes.startp = _startpos__1_;
                                          MenhirLib.EngineTypes.endp = _endpos__1_;
                                          MenhirLib.EngineTypes.next = _menhir_stack;
                                        };
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined9 : (AST.stmt list) = Obj.magic _1_inlined9 in
        let _1_inlined8 : unit = Obj.magic _1_inlined8 in
        let _1_inlined7 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined7 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined7, _1_inlined6, _1_inlined5, _1_inlined4, _3, expr, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined5_, _startpos__1_inlined4_, _1_inlined9, _1_inlined8, _1_inlined7, _1_inlined6, _3_inlined1, expr_inlined1, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2) in
                let _2 =
                  let (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined7, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_if_stmt =
                        let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                        let desc =
                          let simple_else_opt =
                            let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                            let _2 =
                              let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                              let x =
                                let _1 = _1_inlined1 in
                                let _1_1 = _1 in
                                
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 35365 "asllib/Parser0.ml"
                                 _1_1
                              in
                              
# 126 "<standard.mly>"
    ( Some x )
# 35371 "asllib/Parser0.ml"
                              
                            in
                            let _1_1 = _1 in
                            let _2_1 = _2 in
                            
# 698 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 35379 "asllib/Parser0.ml"
                             (_1_1, _2_1)
                          in
                          let simple_stmt_list =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 35388 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 695 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 35394 "asllib/Parser0.ml"
                           (expr, simple_stmt_list, simple_else_opt)
                        in
                        let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                        let _endpos = _endpos_desc_ in
                        let _symbolstartpos = _startpos_desc_ in
                        
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 35403 "asllib/Parser0.ml"
                        
                      in
                      let simple_stmt_list =
                        let _1_1 = _1 in
                        
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 35411 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 621 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 35417 "asllib/Parser0.ml"
                       (simple_stmt_list, simple_if_stmt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 35426 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 35432 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 718 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 35440 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                let x =
                  let _1_1 = _1 in
                  
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 35450 "asllib/Parser0.ml"
                   _1_1
                in
                
# 196 "<standard.mly>"
    ( x )
# 35456 "asllib/Parser0.ml"
                
              in
              
# 713 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 35462 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 35471 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 35477 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _2;
                    MenhirLib.EngineTypes.startp = _startpos__2_;
                    MenhirLib.EngineTypes.endp = _endpos__2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3;
                        MenhirLib.EngineTypes.startp = _startpos__3_;
                        MenhirLib.EngineTypes.endp = _endpos__3_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = expr;
                          MenhirLib.EngineTypes.startp = _startpos_expr_;
                          MenhirLib.EngineTypes.endp = _endpos_expr_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                let _2 =
                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    let x =
                      let _1_1 = _1 in
                      
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 35577 "asllib/Parser0.ml"
                       _1_1
                    in
                    
# 196 "<standard.mly>"
    ( x )
# 35583 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 35589 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 718 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 35597 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                let x =
                  let _1_1 = _1 in
                  
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 35607 "asllib/Parser0.ml"
                   _1_1
                in
                
# 196 "<standard.mly>"
    ( x )
# 35613 "asllib/Parser0.ml"
                
              in
              
# 713 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 35619 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_inlined1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 35628 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 35634 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined4;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _2;
                  MenhirLib.EngineTypes.startp = _startpos__2_;
                  MenhirLib.EngineTypes.endp = _endpos__2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3;
                      MenhirLib.EngineTypes.startp = _startpos__3_;
                      MenhirLib.EngineTypes.endp = _endpos__3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = expr;
                        MenhirLib.EngineTypes.startp = _startpos_expr_;
                        MenhirLib.EngineTypes.endp = _endpos_expr_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                let _2 =
                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    
# 597 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 35725 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 35731 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 718 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 35739 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                let x =
                  let _1_1 = _1 in
                  
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 35749 "asllib/Parser0.ml"
                   _1_1
                in
                
# 196 "<standard.mly>"
    ( x )
# 35755 "asllib/Parser0.ml"
                
              in
              
# 713 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 35761 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined4_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 35770 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 35776 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined2;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = expr;
                  MenhirLib.EngineTypes.startp = _startpos_expr_;
                  MenhirLib.EngineTypes.endp = _endpos_expr_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let _1 = _1_inlined2 in
                let _2 = 
# 123 "<standard.mly>"
    ( None )
# 35842 "asllib/Parser0.ml"
                 in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 718 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 35849 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                
# 597 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 35857 "asllib/Parser0.ml"
                
              in
              
# 713 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 35863 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 35872 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 35878 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined5;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined4;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined3;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _3;
                          MenhirLib.EngineTypes.startp = _startpos__3_;
                          MenhirLib.EngineTypes.endp = _endpos__3_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = expr;
                            MenhirLib.EngineTypes.startp = _startpos_expr_;
                            MenhirLib.EngineTypes.endp = _endpos_expr_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = _1;
                              MenhirLib.EngineTypes.startp = _startpos__1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined5 : (AST.stmt list) = Obj.magic _1_inlined5 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined3, _1_inlined2, _1_inlined1, _1) = (_1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2) in
                let _2 =
                  let (_1_inlined2, _1_inlined1, _1) = (_1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                    let _3 = _1_inlined1 in
                    let _3_1 = _3 in
                    
# 604 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 35985 "asllib/Parser0.ml"
                     _3_1
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 35991 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 718 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 35999 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                
# 597 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 36007 "asllib/Parser0.ml"
                
              in
              
# 713 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 36013 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 36022 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 36028 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined7;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined6;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = expr_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined5;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined4;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined3;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined2;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _3;
                                MenhirLib.EngineTypes.startp = _startpos__3_;
                                MenhirLib.EngineTypes.endp = _endpos__3_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = expr;
                                  MenhirLib.EngineTypes.startp = _startpos_expr_;
                                  MenhirLib.EngineTypes.endp = _endpos_expr_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _menhir_s;
                                    MenhirLib.EngineTypes.semv = _1;
                                    MenhirLib.EngineTypes.startp = _startpos__1_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_;
                                    MenhirLib.EngineTypes.next = _menhir_stack;
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined7 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined7 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined5, _1_inlined4, _3, expr, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined5_, _startpos__1_inlined4_, _1_inlined7, _1_inlined6, _3_inlined1, expr_inlined1, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2) in
                let _2 =
                  let (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_if_stmt =
                        let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                        let desc =
                          let simple_else_opt =
                            let _1 = _1_inlined2 in
                            let _2 = 
# 123 "<standard.mly>"
    ( None )
# 36160 "asllib/Parser0.ml"
                             in
                            let _1_1 = _1 in
                            let _2_1 = _2 in
                            
# 698 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 36167 "asllib/Parser0.ml"
                             (_1_1, _2_1)
                          in
                          let simple_stmt_list =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 36176 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 695 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 36182 "asllib/Parser0.ml"
                           (expr, simple_stmt_list, simple_else_opt)
                        in
                        let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                        let _endpos = _endpos_desc_ in
                        let _symbolstartpos = _startpos_desc_ in
                        
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 36191 "asllib/Parser0.ml"
                        
                      in
                      let simple_stmt_list =
                        let _1_1 = _1 in
                        
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 36199 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 621 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 36205 "asllib/Parser0.ml"
                       (simple_stmt_list, simple_if_stmt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 36214 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 36220 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 718 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 36228 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                
# 597 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 36236 "asllib/Parser0.ml"
                
              in
              
# 713 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 36242 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 36251 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 36257 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined9;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined9_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined9_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined8;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined7;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined6;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = expr_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined5;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined4;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined3;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined2;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _1_inlined1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _3;
                                    MenhirLib.EngineTypes.startp = _startpos__3_;
                                    MenhirLib.EngineTypes.endp = _endpos__3_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = expr;
                                      MenhirLib.EngineTypes.startp = _startpos_expr_;
                                      MenhirLib.EngineTypes.endp = _endpos_expr_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _menhir_s;
                                        MenhirLib.EngineTypes.semv = _1;
                                        MenhirLib.EngineTypes.startp = _startpos__1_;
                                        MenhirLib.EngineTypes.endp = _endpos__1_;
                                        MenhirLib.EngineTypes.next = _menhir_stack;
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined9 : (AST.stmt list) = Obj.magic _1_inlined9 in
        let _1_inlined8 : unit = Obj.magic _1_inlined8 in
        let _1_inlined7 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined7 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined7, _1_inlined6, _1_inlined5, _1_inlined4, _3, expr, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined5_, _startpos__1_inlined4_, _1_inlined9, _1_inlined8, _1_inlined7, _1_inlined6, _3_inlined1, expr_inlined1, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2) in
                let _2 =
                  let (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined7, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_if_stmt =
                        let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                        let desc =
                          let simple_else_opt =
                            let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                            let _2 =
                              let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                              let x =
                                let _1 = _1_inlined1 in
                                let _1_1 = _1 in
                                
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 36408 "asllib/Parser0.ml"
                                 _1_1
                              in
                              
# 126 "<standard.mly>"
    ( Some x )
# 36414 "asllib/Parser0.ml"
                              
                            in
                            let _1_1 = _1 in
                            let _2_1 = _2 in
                            
# 698 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 36422 "asllib/Parser0.ml"
                             (_1_1, _2_1)
                          in
                          let simple_stmt_list =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 36431 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 695 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 36437 "asllib/Parser0.ml"
                           (expr, simple_stmt_list, simple_else_opt)
                        in
                        let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                        let _endpos = _endpos_desc_ in
                        let _symbolstartpos = _startpos_desc_ in
                        
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 36446 "asllib/Parser0.ml"
                        
                      in
                      let simple_stmt_list =
                        let _1_1 = _1 in
                        
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 36454 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 621 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 36460 "asllib/Parser0.ml"
                       (simple_stmt_list, simple_if_stmt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 36469 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 36475 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 718 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 36483 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                
# 597 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 36491 "asllib/Parser0.ml"
                
              in
              
# 713 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 36497 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 36506 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 36512 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3;
                      MenhirLib.EngineTypes.startp = _startpos__3_;
                      MenhirLib.EngineTypes.endp = _endpos__3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = expr;
                        MenhirLib.EngineTypes.startp = _startpos_expr_;
                        MenhirLib.EngineTypes.endp = _endpos_expr_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                let _2 =
                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    let x =
                      let _1_1 = _1 in
                      
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 36605 "asllib/Parser0.ml"
                       _1_1
                    in
                    
# 196 "<standard.mly>"
    ( x )
# 36611 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 36617 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 718 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 36625 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                
# 597 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 36633 "asllib/Parser0.ml"
                
              in
              
# 713 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 36639 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 36648 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 36654 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined4;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = expr;
                      MenhirLib.EngineTypes.startp = _startpos_expr_;
                      MenhirLib.EngineTypes.endp = _endpos_expr_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                let _2 =
                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    
# 597 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 36738 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 36744 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 718 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 36752 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                
# 597 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 36760 "asllib/Parser0.ml"
                
              in
              
# 713 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 36766 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined4_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 36775 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 36781 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3;
                      MenhirLib.EngineTypes.startp = _startpos__3_;
                      MenhirLib.EngineTypes.endp = _endpos__3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = expr;
                        MenhirLib.EngineTypes.startp = _startpos_expr_;
                        MenhirLib.EngineTypes.endp = _endpos_expr_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let simple_else =
                let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                let _2 =
                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    let _1_1 = _1 in
                    
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 36873 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 233 "asllib/Parser0.mly"
                      Some  
# 36879 "asllib/Parser0.ml"
                   x
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 699 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 36887 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let simple_stmt_list =
                let _1 = _1_inlined1 in
                let _1_1 = _1 in
                
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 36896 "asllib/Parser0.ml"
                 _1_1
              in
              
# 714 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 36902 "asllib/Parser0.ml"
               (expr, simple_stmt_list, simple_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 36911 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 36917 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _7;
            MenhirLib.EngineTypes.startp = _startpos__7_;
            MenhirLib.EngineTypes.endp = _endpos__7_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _6;
              MenhirLib.EngineTypes.startp = _startpos__6_;
              MenhirLib.EngineTypes.endp = _endpos__6_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _5;
                MenhirLib.EngineTypes.startp = _startpos__5_;
                MenhirLib.EngineTypes.endp = _endpos__5_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _4;
                  MenhirLib.EngineTypes.startp = _startpos__4_;
                  MenhirLib.EngineTypes.endp = _endpos__4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = expr;
                      MenhirLib.EngineTypes.startp = _startpos_expr_;
                      MenhirLib.EngineTypes.endp = _endpos_expr_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _7 : unit = Obj.magic _7 in
        let _6 : (AST.case_alt list) = Obj.magic _6 in
        let _5 : unit = Obj.magic _5 in
        let _4 : unit = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let _6_1 = _6 in
              
# 715 "asllib/Parser0.mly"
                                                            AST.S_Case  
# 36996 "asllib/Parser0.ml"
               (expr, _6_1)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__7_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 37005 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 37011 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = end_e;
                    MenhirLib.EngineTypes.startp = _startpos_end_e_;
                    MenhirLib.EngineTypes.endp = _endpos_end_e_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = start_e;
                        MenhirLib.EngineTypes.startp = _startpos_start_e_;
                        MenhirLib.EngineTypes.endp = _endpos_start_e_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _3;
                          MenhirLib.EngineTypes.startp = _startpos__3_;
                          MenhirLib.EngineTypes.endp = _endpos__3_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = _1;
                              MenhirLib.EngineTypes.startp = _startpos__1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let end_e : (AST.expr) = Obj.magic end_e in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let start_e : (AST.expr) = Obj.magic start_e in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 37102 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let body =
                let (_1_inlined1, _1) = (_1_inlined4, _1_inlined3) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 604 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 37118 "asllib/Parser0.ml"
                 _3_1
              in
              let limit = 
# 123 "<standard.mly>"
    ( None )
# 37124 "asllib/Parser0.ml"
               in
              let dir =
                let _1 = _1_inlined2 in
                
# 766 "asllib/Parser0.mly"
                       ( AST.Up )
# 37131 "asllib/Parser0.ml"
                
              in
              let index_name = _1_inlined1 in
              
# 761 "asllib/Parser0.mly"
      ( AST.S_For { index_name; start_e; dir; end_e; body; limit } )
# 37138 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 37147 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 37153 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined5;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined4;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _2;
                    MenhirLib.EngineTypes.startp = _startpos__2_;
                    MenhirLib.EngineTypes.endp = _endpos__2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined3;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = end_e;
                        MenhirLib.EngineTypes.startp = _startpos_end_e_;
                        MenhirLib.EngineTypes.endp = _endpos_end_e_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined2;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = start_e;
                            MenhirLib.EngineTypes.startp = _startpos_start_e_;
                            MenhirLib.EngineTypes.endp = _endpos_start_e_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _3;
                              MenhirLib.EngineTypes.startp = _startpos__3_;
                              MenhirLib.EngineTypes.endp = _endpos__3_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined1;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _menhir_s;
                                  MenhirLib.EngineTypes.semv = _1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_;
                                  MenhirLib.EngineTypes.next = _menhir_stack;
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined5 : (AST.stmt list) = Obj.magic _1_inlined5 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _2 : (AST.expr) = Obj.magic _2 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let end_e : (AST.expr) = Obj.magic end_e in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let start_e : (AST.expr) = Obj.magic start_e in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 37258 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let body =
                let (_1_inlined1, _2, _1) = (_1_inlined5, _2_inlined1, _1_inlined4) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 604 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 37274 "asllib/Parser0.ml"
                 _3_1
              in
              let limit =
                let _1 = _1_inlined3 in
                let x = _2 in
                
# 126 "<standard.mly>"
    ( Some x )
# 37283 "asllib/Parser0.ml"
                
              in
              let dir =
                let _1 = _1_inlined2 in
                
# 766 "asllib/Parser0.mly"
                       ( AST.Up )
# 37291 "asllib/Parser0.ml"
                
              in
              let index_name = _1_inlined1 in
              
# 761 "asllib/Parser0.mly"
      ( AST.S_For { index_name; start_e; dir; end_e; body; limit } )
# 37298 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 37307 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 37313 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = end_e;
                    MenhirLib.EngineTypes.startp = _startpos_end_e_;
                    MenhirLib.EngineTypes.endp = _endpos_end_e_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = start_e;
                        MenhirLib.EngineTypes.startp = _startpos_start_e_;
                        MenhirLib.EngineTypes.endp = _endpos_start_e_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _3;
                          MenhirLib.EngineTypes.startp = _startpos__3_;
                          MenhirLib.EngineTypes.endp = _endpos__3_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = _1;
                              MenhirLib.EngineTypes.startp = _startpos__1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let end_e : (AST.expr) = Obj.magic end_e in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let start_e : (AST.expr) = Obj.magic start_e in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 37404 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let body =
                let (_1_inlined1, _1) = (_1_inlined4, _1_inlined3) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 604 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 37420 "asllib/Parser0.ml"
                 _3_1
              in
              let limit = 
# 123 "<standard.mly>"
    ( None )
# 37426 "asllib/Parser0.ml"
               in
              let dir =
                let _1 = _1_inlined2 in
                
# 766 "asllib/Parser0.mly"
                                            ( AST.Down )
# 37433 "asllib/Parser0.ml"
                
              in
              let index_name = _1_inlined1 in
              
# 761 "asllib/Parser0.mly"
      ( AST.S_For { index_name; start_e; dir; end_e; body; limit } )
# 37440 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 37449 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 37455 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined5;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined4;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _2;
                    MenhirLib.EngineTypes.startp = _startpos__2_;
                    MenhirLib.EngineTypes.endp = _endpos__2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined3;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = end_e;
                        MenhirLib.EngineTypes.startp = _startpos_end_e_;
                        MenhirLib.EngineTypes.endp = _endpos_end_e_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined2;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = start_e;
                            MenhirLib.EngineTypes.startp = _startpos_start_e_;
                            MenhirLib.EngineTypes.endp = _endpos_start_e_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _3;
                              MenhirLib.EngineTypes.startp = _startpos__3_;
                              MenhirLib.EngineTypes.endp = _endpos__3_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined1;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _menhir_s;
                                  MenhirLib.EngineTypes.semv = _1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_;
                                  MenhirLib.EngineTypes.next = _menhir_stack;
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined5 : (AST.stmt list) = Obj.magic _1_inlined5 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _2 : (AST.expr) = Obj.magic _2 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let end_e : (AST.expr) = Obj.magic end_e in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let start_e : (AST.expr) = Obj.magic start_e in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 37560 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let body =
                let (_1_inlined1, _2, _1) = (_1_inlined5, _2_inlined1, _1_inlined4) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 604 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 37576 "asllib/Parser0.ml"
                 _3_1
              in
              let limit =
                let _1 = _1_inlined3 in
                let x = _2 in
                
# 126 "<standard.mly>"
    ( Some x )
# 37585 "asllib/Parser0.ml"
                
              in
              let dir =
                let _1 = _1_inlined2 in
                
# 766 "asllib/Parser0.mly"
                                            ( AST.Down )
# 37593 "asllib/Parser0.ml"
                
              in
              let index_name = _1_inlined1 in
              
# 761 "asllib/Parser0.mly"
      ( AST.S_For { index_name; start_e; dir; end_e; body; limit } )
# 37600 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 37609 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 37615 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__4_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__4_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _4;
                    MenhirLib.EngineTypes.startp = _startpos__4_;
                    MenhirLib.EngineTypes.endp = _endpos__4_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = expr;
                      MenhirLib.EngineTypes.startp = _startpos_expr_;
                      MenhirLib.EngineTypes.endp = _endpos_expr_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _4_inlined1 : unit = Obj.magic _4_inlined1 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _4 : unit = Obj.magic _4 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let indented_block =
                let (_4, _1_inlined1, _1) = (_4_inlined1, _1_inlined2, _1_inlined1) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 604 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 37697 "asllib/Parser0.ml"
                 _3_1
              in
              let _3 = 
# 123 "<standard.mly>"
    ( None )
# 37703 "asllib/Parser0.ml"
               in
              let _3_1 = _3 in
              
# 762 "asllib/Parser0.mly"
                                                                  AST.S_While 
# 37709 "asllib/Parser0.ml"
               (expr, _3_1, indented_block)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__4_inlined1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 37718 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 37724 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__4_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__4_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _4;
                    MenhirLib.EngineTypes.startp = _startpos__4_;
                    MenhirLib.EngineTypes.endp = _endpos__4_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _2;
                      MenhirLib.EngineTypes.startp = _startpos__2_;
                      MenhirLib.EngineTypes.endp = _endpos__2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = expr;
                          MenhirLib.EngineTypes.startp = _startpos_expr_;
                          MenhirLib.EngineTypes.endp = _endpos_expr_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _4_inlined1 : unit = Obj.magic _4_inlined1 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _4 : unit = Obj.magic _4 in
        let _2 : (AST.expr) = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let indented_block =
                let (_4, _1_inlined1, _2, _1) = (_4_inlined1, _1_inlined3, _2_inlined1, _1_inlined2) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 604 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 37820 "asllib/Parser0.ml"
                 _3_1
              in
              let _3 =
                let _1 = _1_inlined1 in
                let x = _2 in
                
# 126 "<standard.mly>"
    ( Some x )
# 37829 "asllib/Parser0.ml"
                
              in
              let _3_1 = _3 in
              
# 762 "asllib/Parser0.mly"
                                                                  AST.S_While 
# 37836 "asllib/Parser0.ml"
               (expr, _3_1, indented_block)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__4_inlined1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 37845 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 37851 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _7;
            MenhirLib.EngineTypes.startp = _startpos__7_;
            MenhirLib.EngineTypes.endp = _endpos__7_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _6;
              MenhirLib.EngineTypes.startp = _startpos__6_;
              MenhirLib.EngineTypes.endp = _endpos__6_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = expr;
                MenhirLib.EngineTypes.startp = _startpos_expr_;
                MenhirLib.EngineTypes.endp = _endpos_expr_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _4;
                    MenhirLib.EngineTypes.startp = _startpos__4_;
                    MenhirLib.EngineTypes.endp = _endpos__4_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _2;
                        MenhirLib.EngineTypes.startp = _startpos__2_;
                        MenhirLib.EngineTypes.endp = _endpos__2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _7 : unit = Obj.magic _7 in
        let _6 : unit = Obj.magic _6 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let _5 = 
# 123 "<standard.mly>"
    ( None )
# 37943 "asllib/Parser0.ml"
               in
              let indented_block =
                let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 604 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 37952 "asllib/Parser0.ml"
                 _3_1
              in
              let _5_1 = _5 in
              
# 764 "asllib/Parser0.mly"
                       AST.S_Repeat 
# 37959 "asllib/Parser0.ml"
               (indented_block, expr, _5_1)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__7_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 37968 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 37974 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _7;
            MenhirLib.EngineTypes.startp = _startpos__7_;
            MenhirLib.EngineTypes.endp = _endpos__7_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _6;
              MenhirLib.EngineTypes.startp = _startpos__6_;
              MenhirLib.EngineTypes.endp = _endpos__6_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = expr;
                    MenhirLib.EngineTypes.startp = _startpos_expr_;
                    MenhirLib.EngineTypes.endp = _endpos_expr_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3;
                      MenhirLib.EngineTypes.startp = _startpos__3_;
                      MenhirLib.EngineTypes.endp = _endpos__3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _4;
                        MenhirLib.EngineTypes.startp = _startpos__4_;
                        MenhirLib.EngineTypes.endp = _endpos__4_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined2;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _2;
                            MenhirLib.EngineTypes.startp = _startpos__2_;
                            MenhirLib.EngineTypes.endp = _endpos__2_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _menhir_s;
                                MenhirLib.EngineTypes.semv = _1;
                                MenhirLib.EngineTypes.startp = _startpos__1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_;
                                MenhirLib.EngineTypes.next = _menhir_stack;
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _7 : unit = Obj.magic _7 in
        let _6 : unit = Obj.magic _6 in
        let _2_inlined1 : (AST.expr) = Obj.magic _2_inlined1 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let _5 =
                let (_2, _1) = (_2_inlined1, _1_inlined3) in
                let x = _2 in
                
# 126 "<standard.mly>"
    ( Some x )
# 38083 "asllib/Parser0.ml"
                
              in
              let indented_block =
                let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 604 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 38093 "asllib/Parser0.ml"
                 _3_1
              in
              let _5_1 = _5 in
              
# 764 "asllib/Parser0.mly"
                       AST.S_Repeat 
# 38100 "asllib/Parser0.ml"
               (indented_block, expr, _5_1)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__7_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 38109 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 38115 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _9;
            MenhirLib.EngineTypes.startp = _startpos__9_;
            MenhirLib.EngineTypes.endp = _endpos__9_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _6;
                MenhirLib.EngineTypes.startp = _startpos__6_;
                MenhirLib.EngineTypes.endp = _endpos__6_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _5;
                  MenhirLib.EngineTypes.startp = _startpos__5_;
                  MenhirLib.EngineTypes.endp = _endpos__5_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined3;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3;
                      MenhirLib.EngineTypes.startp = _startpos__3_;
                      MenhirLib.EngineTypes.endp = _endpos__3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _4_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__4_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__4_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined2;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _2;
                            MenhirLib.EngineTypes.startp = _startpos__2_;
                            MenhirLib.EngineTypes.endp = _endpos__2_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _menhir_s;
                                MenhirLib.EngineTypes.semv = _1;
                                MenhirLib.EngineTypes.startp = _startpos__1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_;
                                MenhirLib.EngineTypes.next = _menhir_stack;
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _9 : unit = Obj.magic _9 in
        let _1_inlined4 : (unit list) = Obj.magic _1_inlined4 in
        let _6 : unit = Obj.magic _6 in
        let _5 : unit = Obj.magic _5 in
        let _1_inlined3 : (
# 82 "asllib/Parser0.mly"
       (string)
# 38208 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _4_inlined1 : unit = Obj.magic _4_inlined1 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let _1 =
                let _1 =
                  let _8 = 
# 123 "<standard.mly>"
    ( None )
# 38227 "asllib/Parser0.ml"
                   in
                  let _7 = _1_inlined4 in
                  let _4 = _1_inlined3 in
                  let _2 =
                    let (_4, _1_inlined1, _1) = (_4_inlined1, _1_inlined2, _1_inlined1) in
                    let _3 = _1_inlined1 in
                    let _3_1 = _3 in
                    
# 604 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 38238 "asllib/Parser0.ml"
                     _3_1
                  in
                  ()
                in
                ()
              in
              
# 612 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 38248 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__9_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 38257 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 38263 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _9;
            MenhirLib.EngineTypes.startp = _startpos__9_;
            MenhirLib.EngineTypes.endp = _endpos__9_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _4;
              MenhirLib.EngineTypes.startp = _startpos__4_;
              MenhirLib.EngineTypes.endp = _endpos__4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined7;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _2_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined6;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined5;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined4;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _6;
                          MenhirLib.EngineTypes.startp = _startpos__6_;
                          MenhirLib.EngineTypes.endp = _endpos__6_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _5;
                            MenhirLib.EngineTypes.startp = _startpos__5_;
                            MenhirLib.EngineTypes.endp = _endpos__5_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined3;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _3;
                                MenhirLib.EngineTypes.startp = _startpos__3_;
                                MenhirLib.EngineTypes.endp = _endpos__3_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _4_inlined1;
                                  MenhirLib.EngineTypes.startp = _startpos__4_inlined1_;
                                  MenhirLib.EngineTypes.endp = _endpos__4_inlined1_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _1_inlined2;
                                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = _2;
                                      MenhirLib.EngineTypes.startp = _startpos__2_;
                                      MenhirLib.EngineTypes.endp = _endpos__2_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _;
                                        MenhirLib.EngineTypes.semv = _1_inlined1;
                                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                        MenhirLib.EngineTypes.next = {
                                          MenhirLib.EngineTypes.state = _menhir_s;
                                          MenhirLib.EngineTypes.semv = _1;
                                          MenhirLib.EngineTypes.startp = _startpos__1_;
                                          MenhirLib.EngineTypes.endp = _endpos__1_;
                                          MenhirLib.EngineTypes.next = _menhir_stack;
                                        };
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _9 : unit = Obj.magic _9 in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined7 : (AST.stmt list) = Obj.magic _1_inlined7 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined6 : unit = Obj.magic _1_inlined6 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : (unit list) = Obj.magic _1_inlined4 in
        let _6 : unit = Obj.magic _6 in
        let _5 : unit = Obj.magic _5 in
        let _1_inlined3 : (
# 82 "asllib/Parser0.mly"
       (string)
# 38391 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _4_inlined1 : unit = Obj.magic _4_inlined1 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let _1 =
                let _1 =
                  let _8 =
                    let (_startpos__1_, _1_inlined2, _2, _1_inlined1, _1) = (_startpos__1_inlined5_, _1_inlined7, _2_inlined1, _1_inlined6, _1_inlined5) in
                    let x =
                      let desc =
                        let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                        let _3 = _1_inlined1 in
                        let _3_1 = _3 in
                        
# 604 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 38417 "asllib/Parser0.ml"
                         _3_1
                      in
                      let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
                      let _endpos = _endpos_desc_ in
                      let _symbolstartpos = _startpos_desc_ in
                      
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 38426 "asllib/Parser0.ml"
                      
                    in
                    
# 126 "<standard.mly>"
    ( Some x )
# 38432 "asllib/Parser0.ml"
                    
                  in
                  let _7 = _1_inlined4 in
                  let _4 = _1_inlined3 in
                  let _2 =
                    let (_4, _1_inlined1, _1) = (_4_inlined1, _1_inlined2, _1_inlined1) in
                    let _3 = _1_inlined1 in
                    let _3_1 = _3 in
                    
# 604 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 38444 "asllib/Parser0.ml"
                     _3_1
                  in
                  ()
                in
                ()
              in
              
# 612 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 38454 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__9_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 38463 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 38469 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _9;
            MenhirLib.EngineTypes.startp = _startpos__9_;
            MenhirLib.EngineTypes.endp = _endpos__9_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _6_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__6_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__6_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined9;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined9_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined9_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined8;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = expr;
                      MenhirLib.EngineTypes.startp = _startpos_expr_;
                      MenhirLib.EngineTypes.endp = _endpos_expr_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined7;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined6;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined5;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined4;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _6;
                                MenhirLib.EngineTypes.startp = _startpos__6_;
                                MenhirLib.EngineTypes.endp = _endpos__6_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _5;
                                  MenhirLib.EngineTypes.startp = _startpos__5_;
                                  MenhirLib.EngineTypes.endp = _endpos__5_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _1_inlined3;
                                    MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = _3;
                                      MenhirLib.EngineTypes.startp = _startpos__3_;
                                      MenhirLib.EngineTypes.endp = _endpos__3_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _;
                                        MenhirLib.EngineTypes.semv = _4_inlined1;
                                        MenhirLib.EngineTypes.startp = _startpos__4_inlined1_;
                                        MenhirLib.EngineTypes.endp = _endpos__4_inlined1_;
                                        MenhirLib.EngineTypes.next = {
                                          MenhirLib.EngineTypes.state = _;
                                          MenhirLib.EngineTypes.semv = _1_inlined2;
                                          MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                          MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                          MenhirLib.EngineTypes.next = {
                                            MenhirLib.EngineTypes.state = _;
                                            MenhirLib.EngineTypes.semv = _2;
                                            MenhirLib.EngineTypes.startp = _startpos__2_;
                                            MenhirLib.EngineTypes.endp = _endpos__2_;
                                            MenhirLib.EngineTypes.next = {
                                              MenhirLib.EngineTypes.state = _;
                                              MenhirLib.EngineTypes.semv = _1_inlined1;
                                              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                              MenhirLib.EngineTypes.next = {
                                                MenhirLib.EngineTypes.state = _menhir_s;
                                                MenhirLib.EngineTypes.semv = _1;
                                                MenhirLib.EngineTypes.startp = _startpos__1_;
                                                MenhirLib.EngineTypes.endp = _endpos__1_;
                                                MenhirLib.EngineTypes.next = _menhir_stack;
                                              };
                                            };
                                          };
                                        };
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _9 : unit = Obj.magic _9 in
        let _6_inlined1 : unit = Obj.magic _6_inlined1 in
        let _1_inlined9 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined9 in
        let _1_inlined8 : (AST.stmt list) = Obj.magic _1_inlined8 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1_inlined7 : unit = Obj.magic _1_inlined7 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : (unit list) = Obj.magic _1_inlined4 in
        let _6 : unit = Obj.magic _6 in
        let _5 : unit = Obj.magic _5 in
        let _1_inlined3 : (
# 82 "asllib/Parser0.mly"
       (string)
# 38618 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _4_inlined1 : unit = Obj.magic _4_inlined1 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let _1 =
                let _1 =
                  let _8 =
                    let (_endpos__6_, _startpos__1_inlined2_, _startpos__1_inlined1_, _startpos__1_, _6, _1_inlined4, _1_inlined3, _3, _1_inlined2, _1_inlined1, _1) = (_endpos__6_inlined1_, _startpos__1_inlined7_, _startpos__1_inlined6_, _startpos__1_inlined5_, _6_inlined1, _1_inlined9, _1_inlined8, _3_inlined1, _1_inlined7, _1_inlined6, _1_inlined5) in
                    let x =
                      let desc =
                        let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                        let desc =
                          let simple_if_stmt =
                            let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                            let desc =
                              let simple_else_opt =
                                let _1 = _1_inlined2 in
                                let _2 = 
# 123 "<standard.mly>"
    ( None )
# 38648 "asllib/Parser0.ml"
                                 in
                                let _1_1 = _1 in
                                let _2_1 = _2 in
                                
# 698 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 38655 "asllib/Parser0.ml"
                                 (_1_1, _2_1)
                              in
                              let simple_stmt_list =
                                let _1 = _1_inlined1 in
                                let _1_1 = _1 in
                                
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 38664 "asllib/Parser0.ml"
                                 _1_1
                              in
                              
# 695 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 38670 "asllib/Parser0.ml"
                               (expr, simple_stmt_list, simple_else_opt)
                            in
                            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                            let _endpos = _endpos_desc_ in
                            let _symbolstartpos = _startpos_desc_ in
                            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 38679 "asllib/Parser0.ml"
                            
                          in
                          let simple_stmt_list =
                            let _1_1 = _1 in
                            
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 38687 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 621 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 38693 "asllib/Parser0.ml"
                           (simple_stmt_list, simple_if_stmt)
                        in
                        let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                        let _endpos = _endpos_desc_ in
                        let _symbolstartpos = _startpos_desc_ in
                        
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 38702 "asllib/Parser0.ml"
                        
                      in
                      let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                      let _endpos = _endpos_desc_ in
                      let _symbolstartpos = _startpos_desc_ in
                      
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 38711 "asllib/Parser0.ml"
                      
                    in
                    
# 126 "<standard.mly>"
    ( Some x )
# 38717 "asllib/Parser0.ml"
                    
                  in
                  let _7 = _1_inlined4 in
                  let _4 = _1_inlined3 in
                  let _2 =
                    let (_4, _1_inlined1, _1) = (_4_inlined1, _1_inlined2, _1_inlined1) in
                    let _3 = _1_inlined1 in
                    let _3_1 = _3 in
                    
# 604 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 38729 "asllib/Parser0.ml"
                     _3_1
                  in
                  ()
                in
                ()
              in
              
# 612 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 38739 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__9_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 38748 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 38754 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _9;
            MenhirLib.EngineTypes.startp = _startpos__9_;
            MenhirLib.EngineTypes.endp = _endpos__9_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _6_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__6_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__6_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined11;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined11_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined11_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined10;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined10_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined10_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined9;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined9_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined9_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined8;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = expr;
                          MenhirLib.EngineTypes.startp = _startpos_expr_;
                          MenhirLib.EngineTypes.endp = _endpos_expr_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined7;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined6;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined5;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _1_inlined4;
                                  MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _6;
                                    MenhirLib.EngineTypes.startp = _startpos__6_;
                                    MenhirLib.EngineTypes.endp = _endpos__6_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = _5;
                                      MenhirLib.EngineTypes.startp = _startpos__5_;
                                      MenhirLib.EngineTypes.endp = _endpos__5_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _;
                                        MenhirLib.EngineTypes.semv = _1_inlined3;
                                        MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                                        MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                                        MenhirLib.EngineTypes.next = {
                                          MenhirLib.EngineTypes.state = _;
                                          MenhirLib.EngineTypes.semv = _3;
                                          MenhirLib.EngineTypes.startp = _startpos__3_;
                                          MenhirLib.EngineTypes.endp = _endpos__3_;
                                          MenhirLib.EngineTypes.next = {
                                            MenhirLib.EngineTypes.state = _;
                                            MenhirLib.EngineTypes.semv = _4_inlined1;
                                            MenhirLib.EngineTypes.startp = _startpos__4_inlined1_;
                                            MenhirLib.EngineTypes.endp = _endpos__4_inlined1_;
                                            MenhirLib.EngineTypes.next = {
                                              MenhirLib.EngineTypes.state = _;
                                              MenhirLib.EngineTypes.semv = _1_inlined2;
                                              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                              MenhirLib.EngineTypes.next = {
                                                MenhirLib.EngineTypes.state = _;
                                                MenhirLib.EngineTypes.semv = _2;
                                                MenhirLib.EngineTypes.startp = _startpos__2_;
                                                MenhirLib.EngineTypes.endp = _endpos__2_;
                                                MenhirLib.EngineTypes.next = {
                                                  MenhirLib.EngineTypes.state = _;
                                                  MenhirLib.EngineTypes.semv = _1_inlined1;
                                                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                                  MenhirLib.EngineTypes.next = {
                                                    MenhirLib.EngineTypes.state = _menhir_s;
                                                    MenhirLib.EngineTypes.semv = _1;
                                                    MenhirLib.EngineTypes.startp = _startpos__1_;
                                                    MenhirLib.EngineTypes.endp = _endpos__1_;
                                                    MenhirLib.EngineTypes.next = _menhir_stack;
                                                  };
                                                };
                                              };
                                            };
                                          };
                                        };
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _9 : unit = Obj.magic _9 in
        let _6_inlined1 : unit = Obj.magic _6_inlined1 in
        let _1_inlined11 : (AST.stmt list) = Obj.magic _1_inlined11 in
        let _1_inlined10 : unit = Obj.magic _1_inlined10 in
        let _1_inlined9 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined9 in
        let _1_inlined8 : (AST.stmt list) = Obj.magic _1_inlined8 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1_inlined7 : unit = Obj.magic _1_inlined7 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : (unit list) = Obj.magic _1_inlined4 in
        let _6 : unit = Obj.magic _6 in
        let _5 : unit = Obj.magic _5 in
        let _1_inlined3 : (
# 82 "asllib/Parser0.mly"
       (string)
# 38917 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _4_inlined1 : unit = Obj.magic _4_inlined1 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let _1 =
                let _1 =
                  let _8 =
                    let (_endpos__6_, _startpos__1_inlined2_, _startpos__1_inlined1_, _startpos__1_, _6, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _3, _1_inlined2, _1_inlined1, _1) = (_endpos__6_inlined1_, _startpos__1_inlined7_, _startpos__1_inlined6_, _startpos__1_inlined5_, _6_inlined1, _1_inlined11, _1_inlined10, _1_inlined9, _1_inlined8, _3_inlined1, _1_inlined7, _1_inlined6, _1_inlined5) in
                    let x =
                      let desc =
                        let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                        let desc =
                          let simple_if_stmt =
                            let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                            let desc =
                              let simple_else_opt =
                                let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                                let _2 =
                                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                                  let x =
                                    let _1 = _1_inlined1 in
                                    let _1_1 = _1 in
                                    
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 38952 "asllib/Parser0.ml"
                                     _1_1
                                  in
                                  
# 126 "<standard.mly>"
    ( Some x )
# 38958 "asllib/Parser0.ml"
                                  
                                in
                                let _1_1 = _1 in
                                let _2_1 = _2 in
                                
# 698 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 38966 "asllib/Parser0.ml"
                                 (_1_1, _2_1)
                              in
                              let simple_stmt_list =
                                let _1 = _1_inlined1 in
                                let _1_1 = _1 in
                                
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 38975 "asllib/Parser0.ml"
                                 _1_1
                              in
                              
# 695 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 38981 "asllib/Parser0.ml"
                               (expr, simple_stmt_list, simple_else_opt)
                            in
                            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                            let _endpos = _endpos_desc_ in
                            let _symbolstartpos = _startpos_desc_ in
                            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 38990 "asllib/Parser0.ml"
                            
                          in
                          let simple_stmt_list =
                            let _1_1 = _1 in
                            
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 38998 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 621 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 39004 "asllib/Parser0.ml"
                           (simple_stmt_list, simple_if_stmt)
                        in
                        let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                        let _endpos = _endpos_desc_ in
                        let _symbolstartpos = _startpos_desc_ in
                        
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 39013 "asllib/Parser0.ml"
                        
                      in
                      let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                      let _endpos = _endpos_desc_ in
                      let _symbolstartpos = _startpos_desc_ in
                      
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 39022 "asllib/Parser0.ml"
                      
                    in
                    
# 126 "<standard.mly>"
    ( Some x )
# 39028 "asllib/Parser0.ml"
                    
                  in
                  let _7 = _1_inlined4 in
                  let _4 = _1_inlined3 in
                  let _2 =
                    let (_4, _1_inlined1, _1) = (_4_inlined1, _1_inlined2, _1_inlined1) in
                    let _3 = _1_inlined1 in
                    let _3_1 = _3 in
                    
# 604 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 39040 "asllib/Parser0.ml"
                     _3_1
                  in
                  ()
                in
                ()
              in
              
# 612 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 39050 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__9_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 39059 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 39065 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _9;
            MenhirLib.EngineTypes.startp = _startpos__9_;
            MenhirLib.EngineTypes.endp = _endpos__9_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined6;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined5;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined4;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _6;
                      MenhirLib.EngineTypes.startp = _startpos__6_;
                      MenhirLib.EngineTypes.endp = _endpos__6_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _5;
                        MenhirLib.EngineTypes.startp = _startpos__5_;
                        MenhirLib.EngineTypes.endp = _endpos__5_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined3;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _3;
                            MenhirLib.EngineTypes.startp = _startpos__3_;
                            MenhirLib.EngineTypes.endp = _endpos__3_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _4_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__4_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__4_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined2;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _2;
                                  MenhirLib.EngineTypes.startp = _startpos__2_;
                                  MenhirLib.EngineTypes.endp = _endpos__2_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _1_inlined1;
                                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _menhir_s;
                                      MenhirLib.EngineTypes.semv = _1;
                                      MenhirLib.EngineTypes.startp = _startpos__1_;
                                      MenhirLib.EngineTypes.endp = _endpos__1_;
                                      MenhirLib.EngineTypes.next = _menhir_stack;
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _9 : unit = Obj.magic _9 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : (unit list) = Obj.magic _1_inlined4 in
        let _6 : unit = Obj.magic _6 in
        let _5 : unit = Obj.magic _5 in
        let _1_inlined3 : (
# 82 "asllib/Parser0.mly"
       (string)
# 39179 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _4_inlined1 : unit = Obj.magic _4_inlined1 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let _1 =
                let _1 =
                  let _8 =
                    let (_endpos__2_, _startpos__1_, _1_inlined1, _1) = (_endpos__2_inlined1_, _startpos__1_inlined5_, _1_inlined6, _1_inlined5) in
                    let x =
                      let desc =
                        let _1 = _1_inlined1 in
                        let x =
                          let _1_1 = _1 in
                          
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 39205 "asllib/Parser0.ml"
                           _1_1
                        in
                        
# 196 "<standard.mly>"
    ( x )
# 39211 "asllib/Parser0.ml"
                        
                      in
                      let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
                      let _endpos = _endpos_desc_ in
                      let _symbolstartpos = _startpos_desc_ in
                      
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 39220 "asllib/Parser0.ml"
                      
                    in
                    
# 126 "<standard.mly>"
    ( Some x )
# 39226 "asllib/Parser0.ml"
                    
                  in
                  let _7 = _1_inlined4 in
                  let _4 = _1_inlined3 in
                  let _2 =
                    let (_4, _1_inlined1, _1) = (_4_inlined1, _1_inlined2, _1_inlined1) in
                    let _3 = _1_inlined1 in
                    let _3_1 = _3 in
                    
# 604 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 39238 "asllib/Parser0.ml"
                     _3_1
                  in
                  ()
                in
                ()
              in
              
# 612 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 39248 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__9_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 39257 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 39263 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _9;
            MenhirLib.EngineTypes.startp = _startpos__9_;
            MenhirLib.EngineTypes.endp = _endpos__9_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined6;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined5;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined4;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _6;
                    MenhirLib.EngineTypes.startp = _startpos__6_;
                    MenhirLib.EngineTypes.endp = _endpos__6_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _5;
                      MenhirLib.EngineTypes.startp = _startpos__5_;
                      MenhirLib.EngineTypes.endp = _endpos__5_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined3;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _3;
                          MenhirLib.EngineTypes.startp = _startpos__3_;
                          MenhirLib.EngineTypes.endp = _endpos__3_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _4_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__4_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__4_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined2;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _2;
                                MenhirLib.EngineTypes.startp = _startpos__2_;
                                MenhirLib.EngineTypes.endp = _endpos__2_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _1_inlined1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _menhir_s;
                                    MenhirLib.EngineTypes.semv = _1;
                                    MenhirLib.EngineTypes.startp = _startpos__1_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_;
                                    MenhirLib.EngineTypes.next = _menhir_stack;
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _9 : unit = Obj.magic _9 in
        let _1_inlined6 : unit = Obj.magic _1_inlined6 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : (unit list) = Obj.magic _1_inlined4 in
        let _6 : unit = Obj.magic _6 in
        let _5 : unit = Obj.magic _5 in
        let _1_inlined3 : (
# 82 "asllib/Parser0.mly"
       (string)
# 39370 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _4_inlined1 : unit = Obj.magic _4_inlined1 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let _1 =
                let _1 =
                  let _8 =
                    let (_endpos__1_inlined1_, _startpos__1_, _1_inlined1, _1) = (_endpos__1_inlined6_, _startpos__1_inlined5_, _1_inlined6, _1_inlined5) in
                    let x =
                      let desc =
                        let _1 = _1_inlined1 in
                        
# 597 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 39394 "asllib/Parser0.ml"
                        
                      in
                      let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined1_, _startpos__1_) in
                      let _endpos = _endpos_desc_ in
                      let _symbolstartpos = _startpos_desc_ in
                      
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 39403 "asllib/Parser0.ml"
                      
                    in
                    
# 126 "<standard.mly>"
    ( Some x )
# 39409 "asllib/Parser0.ml"
                    
                  in
                  let _7 = _1_inlined4 in
                  let _4 = _1_inlined3 in
                  let _2 =
                    let (_4, _1_inlined1, _1) = (_4_inlined1, _1_inlined2, _1_inlined1) in
                    let _3 = _1_inlined1 in
                    let _3_1 = _3 in
                    
# 604 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 39421 "asllib/Parser0.ml"
                     _3_1
                  in
                  ()
                in
                ()
              in
              
# 612 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 39431 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__9_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 39440 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 39446 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let _menhir_s = _menhir_env.MenhirLib.EngineTypes.current in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _endpos = _startpos in
        let _v : (AST.bitfield list) = 
# 145 "<standard.mly>"
    ( [] )
# 39465 "asllib/Parser0.ml"
         in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = x;
          MenhirLib.EngineTypes.startp = _startpos_x_;
          MenhirLib.EngineTypes.endp = _endpos_x_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let x : (AST.bitfield list) = Obj.magic x in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_x_ in
        let _endpos = _endpos_x_ in
        let _v : (AST.bitfield list) = 
# 148 "<standard.mly>"
    ( x )
# 39490 "asllib/Parser0.ml"
         in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _4;
          MenhirLib.EngineTypes.startp = _startpos__4_;
          MenhirLib.EngineTypes.endp = _endpos__4_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined2;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _2;
                  MenhirLib.EngineTypes.startp = _startpos__2_;
                  MenhirLib.EngineTypes.endp = _endpos__2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _2 : (AST.expr) = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__4_ in
        let _v =
          let x =
            let _3 =
              let (_1_inlined1, _2, _1) = (_1_inlined2, _2_inlined1, _1_inlined1) in
              let _3 = _1_inlined1 in
              let _3_1 = _3 in
              
# 604 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 39556 "asllib/Parser0.ml"
               _3_1
            in
            ()
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 39564 "asllib/Parser0.ml"
           : (unit list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _1_inlined1;
          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _2 : (AST.expr) = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_inlined1_ in
        let _v =
          let x =
            let _3 =
              let _1 = _1_inlined1 in
              
# 597 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 39608 "asllib/Parser0.ml"
              
            in
            ()
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 39616 "asllib/Parser0.ml"
           : (unit list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _2;
                    MenhirLib.EngineTypes.startp = _startpos__2_;
                    MenhirLib.EngineTypes.endp = _endpos__2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (unit list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _2 : (AST.expr) = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _3 =
              let (_1_inlined1, _2, _1) = (_1_inlined2, _2_inlined1, _1_inlined1) in
              let _3 = _1_inlined1 in
              let _3_1 = _3 in
              
# 604 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 39690 "asllib/Parser0.ml"
               _3_1
            in
            ()
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 39698 "asllib/Parser0.ml"
           : (unit list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2;
              MenhirLib.EngineTypes.startp = _startpos__2_;
              MenhirLib.EngineTypes.endp = _endpos__2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = _1;
                MenhirLib.EngineTypes.startp = _startpos__1_;
                MenhirLib.EngineTypes.endp = _endpos__1_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let xs : (unit list) = Obj.magic xs in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _2 : (AST.expr) = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _3 =
              let _1 = _1_inlined1 in
              
# 597 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 39749 "asllib/Parser0.ml"
              
            in
            ()
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 39757 "asllib/Parser0.ml"
           : (unit list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = t;
              MenhirLib.EngineTypes.startp = _startpos_t_;
              MenhirLib.EngineTypes.endp = _endpos_t_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 39792 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let t : (AST.ty) = Obj.magic t in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_t_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let x =
              let x = _1 in
              
# 293 "asllib/Parser0.mly"
                               ( (x, t) )
# 39805 "asllib/Parser0.ml"
              
            in
            
# 196 "<standard.mly>"
    ( x )
# 39811 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 39817 "asllib/Parser0.ml"
           : (AST.field list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = t;
                MenhirLib.EngineTypes.startp = _startpos_t_;
                MenhirLib.EngineTypes.endp = _endpos_t_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.field list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 39859 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let t : (AST.ty) = Obj.magic t in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_t_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let x = _1 in
              
# 293 "asllib/Parser0.mly"
                               ( (x, t) )
# 39872 "asllib/Parser0.ml"
              
            in
            
# 196 "<standard.mly>"
    ( x )
# 39878 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 39884 "asllib/Parser0.ml"
           : (AST.field list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = e;
            MenhirLib.EngineTypes.startp = _startpos_e_;
            MenhirLib.EngineTypes.endp = _endpos_e_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = le;
                MenhirLib.EngineTypes.startp = _startpos_le_;
                MenhirLib.EngineTypes.endp = _endpos_le_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let e : (AST.expr) = Obj.magic e in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let le : (AST.lexpr) = Obj.magic le in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_le_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                
# 652 "asllib/Parser0.mly"
                                AST.S_Assign  
# 39936 "asllib/Parser0.ml"
                 (le, e)
              in
              
# 196 "<standard.mly>"
    ( x )
# 39942 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos_le_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 39951 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 39957 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 40006 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let ldi =
                  let x = _1_inlined1 in
                  let t =
                    let desc = 
# 319 "asllib/Parser0.mly"
                          ( AST.(T_Int UnConstrained) )
# 40023 "asllib/Parser0.ml"
                     in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 40031 "asllib/Parser0.ml"
                    
                  in
                  
# 669 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 40037 "asllib/Parser0.ml"
                  
                in
                
# 654 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, ldi, Some expr)) )
# 40043 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 40049 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 40058 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 40064 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let ldi =
                  let x =
                    let _1 = _1_inlined1 in
                    
# 344 "asllib/Parser0.mly"
                                         ( "record" )
# 40126 "asllib/Parser0.ml"
                    
                  in
                  let t =
                    let desc = 
# 319 "asllib/Parser0.mly"
                          ( AST.(T_Int UnConstrained) )
# 40133 "asllib/Parser0.ml"
                     in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 40141 "asllib/Parser0.ml"
                    
                  in
                  
# 669 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 40147 "asllib/Parser0.ml"
                  
                in
                
# 654 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, ldi, Some expr)) )
# 40153 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 40159 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 40168 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 40174 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 40223 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let ldi =
                  let x = _1_inlined1 in
                  let t =
                    let desc = 
# 320 "asllib/Parser0.mly"
                          ( AST.T_Real                )
# 40240 "asllib/Parser0.ml"
                     in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 40248 "asllib/Parser0.ml"
                    
                  in
                  
# 669 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 40254 "asllib/Parser0.ml"
                  
                in
                
# 654 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, ldi, Some expr)) )
# 40260 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 40266 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 40275 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 40281 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let ldi =
                  let x =
                    let _1 = _1_inlined1 in
                    
# 344 "asllib/Parser0.mly"
                                         ( "record" )
# 40343 "asllib/Parser0.ml"
                    
                  in
                  let t =
                    let desc = 
# 320 "asllib/Parser0.mly"
                          ( AST.T_Real                )
# 40350 "asllib/Parser0.ml"
                     in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 40358 "asllib/Parser0.ml"
                    
                  in
                  
# 669 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 40364 "asllib/Parser0.ml"
                  
                in
                
# 654 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, ldi, Some expr)) )
# 40370 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 40376 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 40385 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 40391 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 40440 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let ldi =
                  let x = _1_inlined1 in
                  let t =
                    let desc = 
# 321 "asllib/Parser0.mly"
                          ( AST.T_Bool                )
# 40457 "asllib/Parser0.ml"
                     in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 40465 "asllib/Parser0.ml"
                    
                  in
                  
# 669 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 40471 "asllib/Parser0.ml"
                  
                in
                
# 654 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, ldi, Some expr)) )
# 40477 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 40483 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 40492 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 40498 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let ldi =
                  let x =
                    let _1 = _1_inlined1 in
                    
# 344 "asllib/Parser0.mly"
                                         ( "record" )
# 40560 "asllib/Parser0.ml"
                    
                  in
                  let t =
                    let desc = 
# 321 "asllib/Parser0.mly"
                          ( AST.T_Bool                )
# 40567 "asllib/Parser0.ml"
                     in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 40575 "asllib/Parser0.ml"
                    
                  in
                  
# 669 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 40581 "asllib/Parser0.ml"
                  
                in
                
# 654 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, ldi, Some expr)) )
# 40587 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 40593 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 40602 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 40608 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 40657 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 40662 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let ldi =
                  let x = _1_inlined1 in
                  let t =
                    let desc =
                      let tident = _1 in
                      
# 322 "asllib/Parser0.mly"
                            AST.T_Named                
# 40680 "asllib/Parser0.ml"
                       tident
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 40689 "asllib/Parser0.ml"
                    
                  in
                  
# 669 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 40695 "asllib/Parser0.ml"
                  
                in
                
# 654 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, ldi, Some expr)) )
# 40701 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 40707 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 40716 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 40722 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 40772 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let ldi =
                  let x =
                    let _1 = _1_inlined1 in
                    
# 344 "asllib/Parser0.mly"
                                         ( "record" )
# 40788 "asllib/Parser0.ml"
                    
                  in
                  let t =
                    let desc =
                      let tident = _1 in
                      
# 322 "asllib/Parser0.mly"
                            AST.T_Named                
# 40797 "asllib/Parser0.ml"
                       tident
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 40806 "asllib/Parser0.ml"
                    
                  in
                  
# 669 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 40812 "asllib/Parser0.ml"
                  
                in
                
# 654 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, ldi, Some expr)) )
# 40818 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 40824 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 40833 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 40839 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__2_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__2_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _2_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = q;
                      MenhirLib.EngineTypes.startp = _startpos_q_;
                      MenhirLib.EngineTypes.endp = _endpos_q_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _2_inlined2 : unit = Obj.magic _2_inlined2 in
        let _1_inlined1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 40900 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 40905 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 40911 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined2 in
                let ldi =
                  let _2 = _2_inlined1 in
                  let x = _1_inlined1 in
                  let t =
                    let desc =
                      let tident =
                        let i = _1 in
                        
# 339 "asllib/Parser0.mly"
                                   ( q ^ "_" ^ i )
# 40931 "asllib/Parser0.ml"
                        
                      in
                      
# 322 "asllib/Parser0.mly"
                            AST.T_Named                
# 40937 "asllib/Parser0.ml"
                       tident
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos_q_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 40946 "asllib/Parser0.ml"
                    
                  in
                  
# 669 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 40952 "asllib/Parser0.ml"
                  
                in
                
# 654 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, ldi, Some expr)) )
# 40958 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 40964 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos_q_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 40973 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 40979 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__2_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__2_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _2_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = q;
                      MenhirLib.EngineTypes.startp = _startpos_q_;
                      MenhirLib.EngineTypes.endp = _endpos_q_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _2_inlined2 : unit = Obj.magic _2_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 41041 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 41047 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined2 in
                let ldi =
                  let _2 = _2_inlined1 in
                  let x =
                    let _1 = _1_inlined1 in
                    
# 344 "asllib/Parser0.mly"
                                         ( "record" )
# 41064 "asllib/Parser0.ml"
                    
                  in
                  let t =
                    let desc =
                      let tident =
                        let i = _1 in
                        
# 339 "asllib/Parser0.mly"
                                   ( q ^ "_" ^ i )
# 41074 "asllib/Parser0.ml"
                        
                      in
                      
# 322 "asllib/Parser0.mly"
                            AST.T_Named                
# 41080 "asllib/Parser0.ml"
                       tident
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos_q_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 41089 "asllib/Parser0.ml"
                    
                  in
                  
# 669 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 41095 "asllib/Parser0.ml"
                  
                in
                
# 654 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, ldi, Some expr)) )
# 41101 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 41107 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos_q_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 41116 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 41122 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 41171 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let ldi =
                  let x = _1_inlined1 in
                  let t =
                    let desc = 
# 323 "asllib/Parser0.mly"
                          ( t_bit                     )
# 41188 "asllib/Parser0.ml"
                     in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 41196 "asllib/Parser0.ml"
                    
                  in
                  
# 669 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 41202 "asllib/Parser0.ml"
                  
                in
                
# 654 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, ldi, Some expr)) )
# 41208 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 41214 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 41223 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 41229 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let ldi =
                  let x =
                    let _1 = _1_inlined1 in
                    
# 344 "asllib/Parser0.mly"
                                         ( "record" )
# 41291 "asllib/Parser0.ml"
                    
                  in
                  let t =
                    let desc = 
# 323 "asllib/Parser0.mly"
                          ( t_bit                     )
# 41298 "asllib/Parser0.ml"
                     in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 41306 "asllib/Parser0.ml"
                    
                  in
                  
# 669 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 41312 "asllib/Parser0.ml"
                  
                in
                
# 654 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, ldi, Some expr)) )
# 41318 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 41324 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 41333 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 41339 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = x_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined2 : (
# 82 "asllib/Parser0.mly"
       (string)
# 41406 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let x_inlined1 : (AST.expr) = Obj.magic x_inlined1 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let ldi =
                  let x = _1_inlined2 in
                  let t =
                    let x = x_inlined1 in
                    let desc =
                      let e = 
# 205 "<standard.mly>"
    ( x )
# 41428 "asllib/Parser0.ml"
                       in
                      
# 324 "asllib/Parser0.mly"
                          ( AST.(T_Bits (e, []))      )
# 41433 "asllib/Parser0.ml"
                      
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 41442 "asllib/Parser0.ml"
                    
                  in
                  
# 669 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 41448 "asllib/Parser0.ml"
                  
                in
                
# 654 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, ldi, Some expr)) )
# 41454 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 41460 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 41469 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 41475 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = x_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let x_inlined1 : (AST.expr) = Obj.magic x_inlined1 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let ldi =
                  let x =
                    let _1 = _1_inlined2 in
                    
# 344 "asllib/Parser0.mly"
                                         ( "record" )
# 41558 "asllib/Parser0.ml"
                    
                  in
                  let t =
                    let x = x_inlined1 in
                    let desc =
                      let e = 
# 205 "<standard.mly>"
    ( x )
# 41567 "asllib/Parser0.ml"
                       in
                      
# 324 "asllib/Parser0.mly"
                          ( AST.(T_Bits (e, []))      )
# 41572 "asllib/Parser0.ml"
                      
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 41581 "asllib/Parser0.ml"
                    
                  in
                  
# 669 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 41587 "asllib/Parser0.ml"
                  
                in
                
# 654 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, ldi, Some expr)) )
# 41593 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 41599 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 41608 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 41614 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined4;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined3;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3;
                        MenhirLib.EngineTypes.startp = _startpos__3_;
                        MenhirLib.EngineTypes.endp = _endpos__3_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = x_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = _1;
                              MenhirLib.EngineTypes.startp = _startpos__1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined4 : (
# 82 "asllib/Parser0.mly"
       (string)
# 41699 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined4 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined3 : (AST.bitfield list) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let x_inlined1 : (AST.expr) = Obj.magic x_inlined1 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let ldi =
                  let x = _1_inlined4 in
                  let t =
                    let x = x_inlined1 in
                    let desc =
                      let b =
                        let _1_inlined1 = _1_inlined3 in
                        let x = _1_inlined1 in
                        
# 205 "<standard.mly>"
    ( x )
# 41727 "asllib/Parser0.ml"
                        
                      in
                      let e = 
# 205 "<standard.mly>"
    ( x )
# 41733 "asllib/Parser0.ml"
                       in
                      
# 325 "asllib/Parser0.mly"
                                      ( AST.(T_Bits (e, b)) )
# 41738 "asllib/Parser0.ml"
                      
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__3_inlined1_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 41747 "asllib/Parser0.ml"
                    
                  in
                  
# 669 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 41753 "asllib/Parser0.ml"
                  
                in
                
# 654 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, ldi, Some expr)) )
# 41759 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 41765 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 41774 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 41780 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined4;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined3;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3;
                        MenhirLib.EngineTypes.startp = _startpos__3_;
                        MenhirLib.EngineTypes.endp = _endpos__3_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = x_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = _1;
                              MenhirLib.EngineTypes.startp = _startpos__1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined3 : (AST.bitfield list) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let x_inlined1 : (AST.expr) = Obj.magic x_inlined1 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let ldi =
                  let x =
                    let _1 = _1_inlined4 in
                    
# 344 "asllib/Parser0.mly"
                                         ( "record" )
# 41884 "asllib/Parser0.ml"
                    
                  in
                  let t =
                    let x = x_inlined1 in
                    let desc =
                      let b =
                        let _1_inlined1 = _1_inlined3 in
                        let x = _1_inlined1 in
                        
# 205 "<standard.mly>"
    ( x )
# 41896 "asllib/Parser0.ml"
                        
                      in
                      let e = 
# 205 "<standard.mly>"
    ( x )
# 41902 "asllib/Parser0.ml"
                       in
                      
# 325 "asllib/Parser0.mly"
                                      ( AST.(T_Bits (e, b)) )
# 41907 "asllib/Parser0.ml"
                      
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__3_inlined1_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 41916 "asllib/Parser0.ml"
                    
                  in
                  
# 669 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 41922 "asllib/Parser0.ml"
                  
                in
                
# 654 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, ldi, Some expr)) )
# 41928 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 41934 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 41943 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 41949 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = x_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined2 : (
# 82 "asllib/Parser0.mly"
       (string)
# 42016 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let x_inlined1 : (AST.expr) = Obj.magic x_inlined1 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let ldi =
                  let x = _1_inlined2 in
                  let t =
                    let x = x_inlined1 in
                    let desc =
                      let _1 =
                        let _2 = 
# 205 "<standard.mly>"
    ( x )
# 42039 "asllib/Parser0.ml"
                         in
                        ()
                      in
                      
# 265 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 42046 "asllib/Parser0.ml"
                      
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 42055 "asllib/Parser0.ml"
                    
                  in
                  
# 669 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 42061 "asllib/Parser0.ml"
                  
                in
                
# 654 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, ldi, Some expr)) )
# 42067 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 42073 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 42082 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 42088 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = x_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let x_inlined1 : (AST.expr) = Obj.magic x_inlined1 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let ldi =
                  let x =
                    let _1 = _1_inlined2 in
                    
# 344 "asllib/Parser0.mly"
                                         ( "record" )
# 42171 "asllib/Parser0.ml"
                    
                  in
                  let t =
                    let x = x_inlined1 in
                    let desc =
                      let _1 =
                        let _2 = 
# 205 "<standard.mly>"
    ( x )
# 42181 "asllib/Parser0.ml"
                         in
                        ()
                      in
                      
# 265 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 42188 "asllib/Parser0.ml"
                      
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 42197 "asllib/Parser0.ml"
                    
                  in
                  
# 669 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 42203 "asllib/Parser0.ml"
                  
                in
                
# 654 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, ldi, Some expr)) )
# 42209 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 42215 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 42224 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 42230 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _4;
                  MenhirLib.EngineTypes.startp = _startpos__4_;
                  MenhirLib.EngineTypes.endp = _endpos__4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined3 : (
# 82 "asllib/Parser0.mly"
       (string)
# 42309 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (
# 82 "asllib/Parser0.mly"
       (string)
# 42317 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let ldi =
                  let x = _1_inlined3 in
                  let t =
                    let desc =
                      let _1 =
                        let _2 =
                          let _1_inlined1 = _1_inlined2 in
                          let x =
                            let _1 = _1_inlined1 in
                            ()
                          in
                          
# 205 "<standard.mly>"
    ( x )
# 42343 "asllib/Parser0.ml"
                          
                        in
                        ()
                      in
                      
# 265 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 42351 "asllib/Parser0.ml"
                      
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 42360 "asllib/Parser0.ml"
                    
                  in
                  
# 669 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 42366 "asllib/Parser0.ml"
                  
                in
                
# 654 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, ldi, Some expr)) )
# 42372 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 42378 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 42387 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 42393 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _4;
                  MenhirLib.EngineTypes.startp = _startpos__4_;
                  MenhirLib.EngineTypes.endp = _endpos__4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (
# 82 "asllib/Parser0.mly"
       (string)
# 42476 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let ldi =
                  let x =
                    let _1 = _1_inlined3 in
                    
# 344 "asllib/Parser0.mly"
                                         ( "record" )
# 42494 "asllib/Parser0.ml"
                    
                  in
                  let t =
                    let desc =
                      let _1 =
                        let _2 =
                          let _1_inlined1 = _1_inlined2 in
                          let x =
                            let _1 = _1_inlined1 in
                            ()
                          in
                          
# 205 "<standard.mly>"
    ( x )
# 42509 "asllib/Parser0.ml"
                          
                        in
                        ()
                      in
                      
# 265 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 42517 "asllib/Parser0.ml"
                      
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 42526 "asllib/Parser0.ml"
                    
                  in
                  
# 669 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 42532 "asllib/Parser0.ml"
                  
                in
                
# 654 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, ldi, Some expr)) )
# 42538 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 42544 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 42553 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 42559 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__2_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__2_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _4;
                  MenhirLib.EngineTypes.startp = _startpos__4_;
                  MenhirLib.EngineTypes.endp = _endpos__4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _2_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = q;
                            MenhirLib.EngineTypes.startp = _startpos_q_;
                            MenhirLib.EngineTypes.endp = _endpos_q_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _menhir_s;
                                MenhirLib.EngineTypes.semv = _1;
                                MenhirLib.EngineTypes.startp = _startpos__1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_;
                                MenhirLib.EngineTypes.next = _menhir_stack;
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _2_inlined2 : unit = Obj.magic _2_inlined2 in
        let _1_inlined3 : (
# 82 "asllib/Parser0.mly"
       (string)
# 42650 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (
# 82 "asllib/Parser0.mly"
       (string)
# 42658 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 42664 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined2 in
                let ldi =
                  let _2 = _2_inlined1 in
                  let x = _1_inlined3 in
                  let t =
                    let desc =
                      let _1 =
                        let _2 =
                          let _1_inlined1 = _1_inlined2 in
                          let x =
                            let _1 = _1_inlined1 in
                            let _1 =
                              let i = _1 in
                              
# 339 "asllib/Parser0.mly"
                                   ( q ^ "_" ^ i )
# 42691 "asllib/Parser0.ml"
                              
                            in
                            ()
                          in
                          
# 205 "<standard.mly>"
    ( x )
# 42699 "asllib/Parser0.ml"
                          
                        in
                        ()
                      in
                      
# 265 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 42707 "asllib/Parser0.ml"
                      
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 42716 "asllib/Parser0.ml"
                    
                  in
                  
# 669 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 42722 "asllib/Parser0.ml"
                  
                in
                
# 654 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, ldi, Some expr)) )
# 42728 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 42734 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 42743 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 42749 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__2_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__2_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _4;
                  MenhirLib.EngineTypes.startp = _startpos__4_;
                  MenhirLib.EngineTypes.endp = _endpos__4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _2_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = q;
                            MenhirLib.EngineTypes.startp = _startpos_q_;
                            MenhirLib.EngineTypes.endp = _endpos_q_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _menhir_s;
                                MenhirLib.EngineTypes.semv = _1;
                                MenhirLib.EngineTypes.startp = _startpos__1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_;
                                MenhirLib.EngineTypes.next = _menhir_stack;
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _2_inlined2 : unit = Obj.magic _2_inlined2 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (
# 82 "asllib/Parser0.mly"
       (string)
# 42844 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 42850 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined2 in
                let ldi =
                  let _2 = _2_inlined1 in
                  let x =
                    let _1 = _1_inlined3 in
                    
# 344 "asllib/Parser0.mly"
                                         ( "record" )
# 42869 "asllib/Parser0.ml"
                    
                  in
                  let t =
                    let desc =
                      let _1 =
                        let _2 =
                          let _1_inlined1 = _1_inlined2 in
                          let x =
                            let _1 = _1_inlined1 in
                            let _1 =
                              let i = _1 in
                              
# 339 "asllib/Parser0.mly"
                                   ( q ^ "_" ^ i )
# 42884 "asllib/Parser0.ml"
                              
                            in
                            ()
                          in
                          
# 205 "<standard.mly>"
    ( x )
# 42892 "asllib/Parser0.ml"
                          
                        in
                        ()
                      in
                      
# 265 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 42900 "asllib/Parser0.ml"
                      
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 42909 "asllib/Parser0.ml"
                    
                  in
                  
# 669 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 42915 "asllib/Parser0.ml"
                  
                in
                
# 654 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, ldi, Some expr)) )
# 42921 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 42927 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 42936 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 42942 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__2_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__2_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _4;
                  MenhirLib.EngineTypes.startp = _startpos__4_;
                  MenhirLib.EngineTypes.endp = _endpos__4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _2_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined2;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _menhir_s;
                                MenhirLib.EngineTypes.semv = _1;
                                MenhirLib.EngineTypes.startp = _startpos__1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_;
                                MenhirLib.EngineTypes.next = _menhir_stack;
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _2_inlined2 : unit = Obj.magic _2_inlined2 in
        let _1_inlined3 : (
# 82 "asllib/Parser0.mly"
       (string)
# 43033 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _3_inlined1 : (AST.expr) = Obj.magic _3_inlined1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined2 : (AST.expr) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined2 in
                let ldi =
                  let _2 = _2_inlined1 in
                  let x = _1_inlined3 in
                  let t =
                    let desc =
                      let _1 =
                        let _2 =
                          let _1_inlined1 = _1_inlined2 in
                          let x =
                            let (_3, _1) = (_3_inlined1, _1_inlined1) in
                            ()
                          in
                          
# 205 "<standard.mly>"
    ( x )
# 43066 "asllib/Parser0.ml"
                          
                        in
                        ()
                      in
                      
# 265 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 43074 "asllib/Parser0.ml"
                      
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 43083 "asllib/Parser0.ml"
                    
                  in
                  
# 669 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 43089 "asllib/Parser0.ml"
                  
                in
                
# 654 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, ldi, Some expr)) )
# 43095 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 43101 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 43110 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 43116 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__2_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__2_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _4;
                  MenhirLib.EngineTypes.startp = _startpos__4_;
                  MenhirLib.EngineTypes.endp = _endpos__4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _2_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined2;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _menhir_s;
                                MenhirLib.EngineTypes.semv = _1;
                                MenhirLib.EngineTypes.startp = _startpos__1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_;
                                MenhirLib.EngineTypes.next = _menhir_stack;
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _2_inlined2 : unit = Obj.magic _2_inlined2 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _3_inlined1 : (AST.expr) = Obj.magic _3_inlined1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined2 : (AST.expr) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined2 in
                let ldi =
                  let _2 = _2_inlined1 in
                  let x =
                    let _1 = _1_inlined3 in
                    
# 344 "asllib/Parser0.mly"
                                         ( "record" )
# 43228 "asllib/Parser0.ml"
                    
                  in
                  let t =
                    let desc =
                      let _1 =
                        let _2 =
                          let _1_inlined1 = _1_inlined2 in
                          let x =
                            let (_3, _1) = (_3_inlined1, _1_inlined1) in
                            ()
                          in
                          
# 205 "<standard.mly>"
    ( x )
# 43243 "asllib/Parser0.ml"
                          
                        in
                        ()
                      in
                      
# 265 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 43251 "asllib/Parser0.ml"
                      
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 43260 "asllib/Parser0.ml"
                    
                  in
                  
# 669 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 43266 "asllib/Parser0.ml"
                  
                in
                
# 654 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, ldi, Some expr)) )
# 43272 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 43278 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 43287 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 43293 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (
# 82 "asllib/Parser0.mly"
       (string)
# 43348 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let ldi =
                  let (_endpos__1_, _startpos__1_, _1_inlined1, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined2, _1_inlined1) in
                  let x = _1_inlined1 in
                  let t =
                    let desc = 
# 319 "asllib/Parser0.mly"
                          ( AST.(T_Int UnConstrained) )
# 43366 "asllib/Parser0.ml"
                     in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 43374 "asllib/Parser0.ml"
                    
                  in
                  
# 669 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 43380 "asllib/Parser0.ml"
                  
                in
                
# 656 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, ldi, Some expr)) )
# 43386 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 43392 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 43401 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 43407 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let ldi =
                  let (_endpos__1_, _startpos__1_, _1_inlined1, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    
# 344 "asllib/Parser0.mly"
                                         ( "record" )
# 43476 "asllib/Parser0.ml"
                    
                  in
                  let t =
                    let desc = 
# 319 "asllib/Parser0.mly"
                          ( AST.(T_Int UnConstrained) )
# 43483 "asllib/Parser0.ml"
                     in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 43491 "asllib/Parser0.ml"
                    
                  in
                  
# 669 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 43497 "asllib/Parser0.ml"
                  
                in
                
# 656 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, ldi, Some expr)) )
# 43503 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 43509 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 43518 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 43524 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (
# 82 "asllib/Parser0.mly"
       (string)
# 43579 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let ldi =
                  let (_endpos__1_, _startpos__1_, _1_inlined1, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined2, _1_inlined1) in
                  let x = _1_inlined1 in
                  let t =
                    let desc = 
# 320 "asllib/Parser0.mly"
                          ( AST.T_Real                )
# 43597 "asllib/Parser0.ml"
                     in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 43605 "asllib/Parser0.ml"
                    
                  in
                  
# 669 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 43611 "asllib/Parser0.ml"
                  
                in
                
# 656 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, ldi, Some expr)) )
# 43617 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 43623 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 43632 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 43638 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let ldi =
                  let (_endpos__1_, _startpos__1_, _1_inlined1, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    
# 344 "asllib/Parser0.mly"
                                         ( "record" )
# 43707 "asllib/Parser0.ml"
                    
                  in
                  let t =
                    let desc = 
# 320 "asllib/Parser0.mly"
                          ( AST.T_Real                )
# 43714 "asllib/Parser0.ml"
                     in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 43722 "asllib/Parser0.ml"
                    
                  in
                  
# 669 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 43728 "asllib/Parser0.ml"
                  
                in
                
# 656 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, ldi, Some expr)) )
# 43734 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 43740 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 43749 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 43755 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (
# 82 "asllib/Parser0.mly"
       (string)
# 43810 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let ldi =
                  let (_endpos__1_, _startpos__1_, _1_inlined1, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined2, _1_inlined1) in
                  let x = _1_inlined1 in
                  let t =
                    let desc = 
# 321 "asllib/Parser0.mly"
                          ( AST.T_Bool                )
# 43828 "asllib/Parser0.ml"
                     in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 43836 "asllib/Parser0.ml"
                    
                  in
                  
# 669 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 43842 "asllib/Parser0.ml"
                  
                in
                
# 656 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, ldi, Some expr)) )
# 43848 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 43854 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 43863 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 43869 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let ldi =
                  let (_endpos__1_, _startpos__1_, _1_inlined1, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    
# 344 "asllib/Parser0.mly"
                                         ( "record" )
# 43938 "asllib/Parser0.ml"
                    
                  in
                  let t =
                    let desc = 
# 321 "asllib/Parser0.mly"
                          ( AST.T_Bool                )
# 43945 "asllib/Parser0.ml"
                     in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 43953 "asllib/Parser0.ml"
                    
                  in
                  
# 669 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 43959 "asllib/Parser0.ml"
                  
                in
                
# 656 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, ldi, Some expr)) )
# 43965 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 43971 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 43980 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 43986 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (
# 82 "asllib/Parser0.mly"
       (string)
# 44041 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _1_inlined1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 44046 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let ldi =
                  let (_endpos__1_, _startpos__1_, _1_inlined1, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined2, _1_inlined1) in
                  let x = _1_inlined1 in
                  let t =
                    let desc =
                      let tident = _1 in
                      
# 322 "asllib/Parser0.mly"
                            AST.T_Named                
# 44065 "asllib/Parser0.ml"
                       tident
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 44074 "asllib/Parser0.ml"
                    
                  in
                  
# 669 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 44080 "asllib/Parser0.ml"
                  
                in
                
# 656 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, ldi, Some expr)) )
# 44086 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 44092 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 44101 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 44107 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 44163 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let ldi =
                  let (_endpos__1_, _startpos__1_, _1_inlined1, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    
# 344 "asllib/Parser0.mly"
                                         ( "record" )
# 44180 "asllib/Parser0.ml"
                    
                  in
                  let t =
                    let desc =
                      let tident = _1 in
                      
# 322 "asllib/Parser0.mly"
                            AST.T_Named                
# 44189 "asllib/Parser0.ml"
                       tident
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 44198 "asllib/Parser0.ml"
                    
                  in
                  
# 669 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 44204 "asllib/Parser0.ml"
                  
                in
                
# 656 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, ldi, Some expr)) )
# 44210 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 44216 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 44225 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 44231 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _2_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = q;
                      MenhirLib.EngineTypes.startp = _startpos_q_;
                      MenhirLib.EngineTypes.endp = _endpos_q_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (
# 82 "asllib/Parser0.mly"
       (string)
# 44298 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _1_inlined1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 44303 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 44309 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let ldi =
                  let (_endpos__1_, _1_inlined1, _1) = (_endpos__1_inlined1_, _1_inlined2, _1_inlined1) in
                  let x = _1_inlined1 in
                  let t =
                    let desc =
                      let tident =
                        let i = _1 in
                        
# 339 "asllib/Parser0.mly"
                                   ( q ^ "_" ^ i )
# 44330 "asllib/Parser0.ml"
                        
                      in
                      
# 322 "asllib/Parser0.mly"
                            AST.T_Named                
# 44336 "asllib/Parser0.ml"
                       tident
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos_q_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 44345 "asllib/Parser0.ml"
                    
                  in
                  
# 669 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 44351 "asllib/Parser0.ml"
                  
                in
                
# 656 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, ldi, Some expr)) )
# 44357 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 44363 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 44372 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 44378 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _2_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = q;
                      MenhirLib.EngineTypes.startp = _startpos_q_;
                      MenhirLib.EngineTypes.endp = _endpos_q_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 44446 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 44452 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let ldi =
                  let (_endpos__1_, _1_inlined1, _1) = (_endpos__1_inlined1_, _1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    
# 344 "asllib/Parser0.mly"
                                         ( "record" )
# 44470 "asllib/Parser0.ml"
                    
                  in
                  let t =
                    let desc =
                      let tident =
                        let i = _1 in
                        
# 339 "asllib/Parser0.mly"
                                   ( q ^ "_" ^ i )
# 44480 "asllib/Parser0.ml"
                        
                      in
                      
# 322 "asllib/Parser0.mly"
                            AST.T_Named                
# 44486 "asllib/Parser0.ml"
                       tident
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos_q_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 44495 "asllib/Parser0.ml"
                    
                  in
                  
# 669 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 44501 "asllib/Parser0.ml"
                  
                in
                
# 656 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, ldi, Some expr)) )
# 44507 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 44513 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 44522 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 44528 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (
# 82 "asllib/Parser0.mly"
       (string)
# 44583 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let ldi =
                  let (_endpos__1_, _startpos__1_, _1_inlined1, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined2, _1_inlined1) in
                  let x = _1_inlined1 in
                  let t =
                    let desc = 
# 323 "asllib/Parser0.mly"
                          ( t_bit                     )
# 44601 "asllib/Parser0.ml"
                     in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 44609 "asllib/Parser0.ml"
                    
                  in
                  
# 669 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 44615 "asllib/Parser0.ml"
                  
                in
                
# 656 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, ldi, Some expr)) )
# 44621 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 44627 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 44636 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 44642 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let ldi =
                  let (_endpos__1_, _startpos__1_, _1_inlined1, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    
# 344 "asllib/Parser0.mly"
                                         ( "record" )
# 44711 "asllib/Parser0.ml"
                    
                  in
                  let t =
                    let desc = 
# 323 "asllib/Parser0.mly"
                          ( t_bit                     )
# 44718 "asllib/Parser0.ml"
                     in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 44726 "asllib/Parser0.ml"
                    
                  in
                  
# 669 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 44732 "asllib/Parser0.ml"
                  
                in
                
# 656 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, ldi, Some expr)) )
# 44738 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 44744 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 44753 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 44759 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = x_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined3 : (
# 82 "asllib/Parser0.mly"
       (string)
# 44832 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let x_inlined1 : (AST.expr) = Obj.magic x_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let ldi =
                  let (_endpos__3_, _startpos__1_, _1_inlined2, _1) = (_endpos__3_inlined1_, _startpos__1_inlined1_, _1_inlined3, _1_inlined1) in
                  let x = _1_inlined2 in
                  let t =
                    let x = x_inlined1 in
                    let desc =
                      let e = 
# 205 "<standard.mly>"
    ( x )
# 44855 "asllib/Parser0.ml"
                       in
                      
# 324 "asllib/Parser0.mly"
                          ( AST.(T_Bits (e, []))      )
# 44860 "asllib/Parser0.ml"
                      
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 44869 "asllib/Parser0.ml"
                    
                  in
                  
# 669 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 44875 "asllib/Parser0.ml"
                  
                in
                
# 656 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, ldi, Some expr)) )
# 44881 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 44887 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 44896 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 44902 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = x_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let x_inlined1 : (AST.expr) = Obj.magic x_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let ldi =
                  let (_endpos__3_, _startpos__1_, _1_inlined2, _1) = (_endpos__3_inlined1_, _startpos__1_inlined1_, _1_inlined3, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined2 in
                    
# 344 "asllib/Parser0.mly"
                                         ( "record" )
# 44992 "asllib/Parser0.ml"
                    
                  in
                  let t =
                    let x = x_inlined1 in
                    let desc =
                      let e = 
# 205 "<standard.mly>"
    ( x )
# 45001 "asllib/Parser0.ml"
                       in
                      
# 324 "asllib/Parser0.mly"
                          ( AST.(T_Bits (e, []))      )
# 45006 "asllib/Parser0.ml"
                      
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 45015 "asllib/Parser0.ml"
                    
                  in
                  
# 669 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 45021 "asllib/Parser0.ml"
                  
                in
                
# 656 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, ldi, Some expr)) )
# 45027 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 45033 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 45042 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 45048 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined5;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined4;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined3;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = x_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined2;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _menhir_s;
                                MenhirLib.EngineTypes.semv = _1;
                                MenhirLib.EngineTypes.startp = _startpos__1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_;
                                MenhirLib.EngineTypes.next = _menhir_stack;
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined5 : (
# 82 "asllib/Parser0.mly"
       (string)
# 45139 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined5 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _1_inlined4 : (AST.bitfield list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let x_inlined1 : (AST.expr) = Obj.magic x_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let ldi =
                  let (_endpos__3_inlined1_, _startpos__1_, _1_inlined4, _1_inlined3, _1) = (_endpos__3_inlined2_, _startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined1) in
                  let x = _1_inlined4 in
                  let t =
                    let x = x_inlined1 in
                    let desc =
                      let b =
                        let _1_inlined1 = _1_inlined3 in
                        let x = _1_inlined1 in
                        
# 205 "<standard.mly>"
    ( x )
# 45168 "asllib/Parser0.ml"
                        
                      in
                      let e = 
# 205 "<standard.mly>"
    ( x )
# 45174 "asllib/Parser0.ml"
                       in
                      
# 325 "asllib/Parser0.mly"
                                      ( AST.(T_Bits (e, b)) )
# 45179 "asllib/Parser0.ml"
                      
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__3_inlined1_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 45188 "asllib/Parser0.ml"
                    
                  in
                  
# 669 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 45194 "asllib/Parser0.ml"
                  
                in
                
# 656 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, ldi, Some expr)) )
# 45200 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 45206 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 45215 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 45221 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined5;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined4;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined3;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = x_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined2;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _menhir_s;
                                MenhirLib.EngineTypes.semv = _1;
                                MenhirLib.EngineTypes.startp = _startpos__1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_;
                                MenhirLib.EngineTypes.next = _menhir_stack;
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _1_inlined4 : (AST.bitfield list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let x_inlined1 : (AST.expr) = Obj.magic x_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let ldi =
                  let (_endpos__3_inlined1_, _startpos__1_, _1_inlined4, _1_inlined3, _1) = (_endpos__3_inlined2_, _startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined4 in
                    
# 344 "asllib/Parser0.mly"
                                         ( "record" )
# 45332 "asllib/Parser0.ml"
                    
                  in
                  let t =
                    let x = x_inlined1 in
                    let desc =
                      let b =
                        let _1_inlined1 = _1_inlined3 in
                        let x = _1_inlined1 in
                        
# 205 "<standard.mly>"
    ( x )
# 45344 "asllib/Parser0.ml"
                        
                      in
                      let e = 
# 205 "<standard.mly>"
    ( x )
# 45350 "asllib/Parser0.ml"
                       in
                      
# 325 "asllib/Parser0.mly"
                                      ( AST.(T_Bits (e, b)) )
# 45355 "asllib/Parser0.ml"
                      
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__3_inlined1_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 45364 "asllib/Parser0.ml"
                    
                  in
                  
# 669 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 45370 "asllib/Parser0.ml"
                  
                in
                
# 656 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, ldi, Some expr)) )
# 45376 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 45382 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 45391 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 45397 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = x_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined3 : (
# 82 "asllib/Parser0.mly"
       (string)
# 45470 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let x_inlined1 : (AST.expr) = Obj.magic x_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let ldi =
                  let (_endpos__3_, _startpos__1_, _1_inlined2, _1) = (_endpos__3_inlined1_, _startpos__1_inlined1_, _1_inlined3, _1_inlined1) in
                  let x = _1_inlined2 in
                  let t =
                    let x = x_inlined1 in
                    let desc =
                      let _1 =
                        let _2 = 
# 205 "<standard.mly>"
    ( x )
# 45494 "asllib/Parser0.ml"
                         in
                        ()
                      in
                      
# 265 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 45501 "asllib/Parser0.ml"
                      
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 45510 "asllib/Parser0.ml"
                    
                  in
                  
# 669 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 45516 "asllib/Parser0.ml"
                  
                in
                
# 656 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, ldi, Some expr)) )
# 45522 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 45528 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 45537 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 45543 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = x_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let x_inlined1 : (AST.expr) = Obj.magic x_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let ldi =
                  let (_endpos__3_, _startpos__1_, _1_inlined2, _1) = (_endpos__3_inlined1_, _startpos__1_inlined1_, _1_inlined3, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined2 in
                    
# 344 "asllib/Parser0.mly"
                                         ( "record" )
# 45633 "asllib/Parser0.ml"
                    
                  in
                  let t =
                    let x = x_inlined1 in
                    let desc =
                      let _1 =
                        let _2 = 
# 205 "<standard.mly>"
    ( x )
# 45643 "asllib/Parser0.ml"
                         in
                        ()
                      in
                      
# 265 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 45650 "asllib/Parser0.ml"
                      
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 45659 "asllib/Parser0.ml"
                    
                  in
                  
# 669 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 45665 "asllib/Parser0.ml"
                  
                in
                
# 656 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, ldi, Some expr)) )
# 45671 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 45677 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 45686 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 45692 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined4;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _4;
                  MenhirLib.EngineTypes.startp = _startpos__4_;
                  MenhirLib.EngineTypes.endp = _endpos__4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined3;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined2;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = _1;
                              MenhirLib.EngineTypes.startp = _startpos__1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined4 : (
# 82 "asllib/Parser0.mly"
       (string)
# 45777 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined4 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined3 : (
# 82 "asllib/Parser0.mly"
       (string)
# 45785 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let ldi =
                  let (_startpos__1_, _1_inlined3, _3, _1_inlined2, _1) = (_startpos__1_inlined1_, _1_inlined4, _3_inlined2, _1_inlined3, _1_inlined1) in
                  let x = _1_inlined3 in
                  let t =
                    let desc =
                      let _1 =
                        let _2 =
                          let _1_inlined1 = _1_inlined2 in
                          let x =
                            let _1 = _1_inlined1 in
                            ()
                          in
                          
# 205 "<standard.mly>"
    ( x )
# 45812 "asllib/Parser0.ml"
                          
                        in
                        ()
                      in
                      
# 265 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 45820 "asllib/Parser0.ml"
                      
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 45829 "asllib/Parser0.ml"
                    
                  in
                  
# 669 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 45835 "asllib/Parser0.ml"
                  
                in
                
# 656 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, ldi, Some expr)) )
# 45841 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 45847 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 45856 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 45862 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined4;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _4;
                  MenhirLib.EngineTypes.startp = _startpos__4_;
                  MenhirLib.EngineTypes.endp = _endpos__4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined3;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined2;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = _1;
                              MenhirLib.EngineTypes.startp = _startpos__1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined3 : (
# 82 "asllib/Parser0.mly"
       (string)
# 45951 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let ldi =
                  let (_startpos__1_, _1_inlined3, _3, _1_inlined2, _1) = (_startpos__1_inlined1_, _1_inlined4, _3_inlined2, _1_inlined3, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined3 in
                    
# 344 "asllib/Parser0.mly"
                                         ( "record" )
# 45970 "asllib/Parser0.ml"
                    
                  in
                  let t =
                    let desc =
                      let _1 =
                        let _2 =
                          let _1_inlined1 = _1_inlined2 in
                          let x =
                            let _1 = _1_inlined1 in
                            ()
                          in
                          
# 205 "<standard.mly>"
    ( x )
# 45985 "asllib/Parser0.ml"
                          
                        in
                        ()
                      in
                      
# 265 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 45993 "asllib/Parser0.ml"
                      
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 46002 "asllib/Parser0.ml"
                    
                  in
                  
# 669 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 46008 "asllib/Parser0.ml"
                  
                in
                
# 656 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, ldi, Some expr)) )
# 46014 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 46020 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 46029 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 46035 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined4;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _4;
                  MenhirLib.EngineTypes.startp = _startpos__4_;
                  MenhirLib.EngineTypes.endp = _endpos__4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined3;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _2_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = q;
                            MenhirLib.EngineTypes.startp = _startpos_q_;
                            MenhirLib.EngineTypes.endp = _endpos_q_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined2;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined1;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _menhir_s;
                                  MenhirLib.EngineTypes.semv = _1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_;
                                  MenhirLib.EngineTypes.next = _menhir_stack;
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined4 : (
# 82 "asllib/Parser0.mly"
       (string)
# 46132 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined4 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined3 : (
# 82 "asllib/Parser0.mly"
       (string)
# 46140 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 46146 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let ldi =
                  let (_startpos__1_, _1_inlined3, _3, _1_inlined2, _1) = (_startpos__1_inlined1_, _1_inlined4, _3_inlined2, _1_inlined3, _1_inlined1) in
                  let x = _1_inlined3 in
                  let t =
                    let desc =
                      let _1 =
                        let _2 =
                          let _1_inlined1 = _1_inlined2 in
                          let x =
                            let _1 = _1_inlined1 in
                            let _1 =
                              let i = _1 in
                              
# 339 "asllib/Parser0.mly"
                                   ( q ^ "_" ^ i )
# 46174 "asllib/Parser0.ml"
                              
                            in
                            ()
                          in
                          
# 205 "<standard.mly>"
    ( x )
# 46182 "asllib/Parser0.ml"
                          
                        in
                        ()
                      in
                      
# 265 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 46190 "asllib/Parser0.ml"
                      
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 46199 "asllib/Parser0.ml"
                    
                  in
                  
# 669 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 46205 "asllib/Parser0.ml"
                  
                in
                
# 656 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, ldi, Some expr)) )
# 46211 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 46217 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 46226 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 46232 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined4;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _4;
                  MenhirLib.EngineTypes.startp = _startpos__4_;
                  MenhirLib.EngineTypes.endp = _endpos__4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined3;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _2_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = q;
                            MenhirLib.EngineTypes.startp = _startpos_q_;
                            MenhirLib.EngineTypes.endp = _endpos_q_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined2;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined1;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _menhir_s;
                                  MenhirLib.EngineTypes.semv = _1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_;
                                  MenhirLib.EngineTypes.next = _menhir_stack;
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined3 : (
# 82 "asllib/Parser0.mly"
       (string)
# 46333 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 46339 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let ldi =
                  let (_startpos__1_, _1_inlined3, _3, _1_inlined2, _1) = (_startpos__1_inlined1_, _1_inlined4, _3_inlined2, _1_inlined3, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined3 in
                    
# 344 "asllib/Parser0.mly"
                                         ( "record" )
# 46359 "asllib/Parser0.ml"
                    
                  in
                  let t =
                    let desc =
                      let _1 =
                        let _2 =
                          let _1_inlined1 = _1_inlined2 in
                          let x =
                            let _1 = _1_inlined1 in
                            let _1 =
                              let i = _1 in
                              
# 339 "asllib/Parser0.mly"
                                   ( q ^ "_" ^ i )
# 46374 "asllib/Parser0.ml"
                              
                            in
                            ()
                          in
                          
# 205 "<standard.mly>"
    ( x )
# 46382 "asllib/Parser0.ml"
                          
                        in
                        ()
                      in
                      
# 265 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 46390 "asllib/Parser0.ml"
                      
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 46399 "asllib/Parser0.ml"
                    
                  in
                  
# 669 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 46405 "asllib/Parser0.ml"
                  
                in
                
# 656 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, ldi, Some expr)) )
# 46411 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 46417 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 46426 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 46432 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined4;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _4;
                  MenhirLib.EngineTypes.startp = _startpos__4_;
                  MenhirLib.EngineTypes.endp = _endpos__4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3_inlined3;
                    MenhirLib.EngineTypes.startp = _startpos__3_inlined3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_inlined3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _2_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined3;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined2;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined1;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _menhir_s;
                                  MenhirLib.EngineTypes.semv = _1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_;
                                  MenhirLib.EngineTypes.next = _menhir_stack;
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined4 : (
# 82 "asllib/Parser0.mly"
       (string)
# 46529 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined4 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3_inlined3 : unit = Obj.magic _3_inlined3 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _3_inlined1 : (AST.expr) = Obj.magic _3_inlined1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined3 : (AST.expr) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let ldi =
                  let (_startpos__1_, _1_inlined3, _3, _1_inlined2, _1) = (_startpos__1_inlined1_, _1_inlined4, _3_inlined3, _1_inlined3, _1_inlined1) in
                  let x = _1_inlined3 in
                  let t =
                    let desc =
                      let _1 =
                        let _2 =
                          let _1_inlined1 = _1_inlined2 in
                          let x =
                            let (_3, _1) = (_3_inlined1, _1_inlined1) in
                            ()
                          in
                          
# 205 "<standard.mly>"
    ( x )
# 46563 "asllib/Parser0.ml"
                          
                        in
                        ()
                      in
                      
# 265 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 46571 "asllib/Parser0.ml"
                      
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 46580 "asllib/Parser0.ml"
                    
                  in
                  
# 669 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 46586 "asllib/Parser0.ml"
                  
                in
                
# 656 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, ldi, Some expr)) )
# 46592 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 46598 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 46607 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 46613 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined4;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _4;
                  MenhirLib.EngineTypes.startp = _startpos__4_;
                  MenhirLib.EngineTypes.endp = _endpos__4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3_inlined3;
                    MenhirLib.EngineTypes.startp = _startpos__3_inlined3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_inlined3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _2_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined3;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined2;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined1;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _menhir_s;
                                  MenhirLib.EngineTypes.semv = _1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_;
                                  MenhirLib.EngineTypes.next = _menhir_stack;
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3_inlined3 : unit = Obj.magic _3_inlined3 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _3_inlined1 : (AST.expr) = Obj.magic _3_inlined1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined3 : (AST.expr) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let ldi =
                  let (_startpos__1_, _1_inlined3, _3, _1_inlined2, _1) = (_startpos__1_inlined1_, _1_inlined4, _3_inlined3, _1_inlined3, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined3 in
                    
# 344 "asllib/Parser0.mly"
                                         ( "record" )
# 46732 "asllib/Parser0.ml"
                    
                  in
                  let t =
                    let desc =
                      let _1 =
                        let _2 =
                          let _1_inlined1 = _1_inlined2 in
                          let x =
                            let (_3, _1) = (_3_inlined1, _1_inlined1) in
                            ()
                          in
                          
# 205 "<standard.mly>"
    ( x )
# 46747 "asllib/Parser0.ml"
                          
                        in
                        ()
                      in
                      
# 265 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 46755 "asllib/Parser0.ml"
                      
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 46764 "asllib/Parser0.ml"
                    
                  in
                  
# 669 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 46770 "asllib/Parser0.ml"
                  
                in
                
# 656 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, ldi, Some expr)) )
# 46776 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 46782 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 46791 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 46797 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 46846 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let x = _1_inlined1 in
                
# 658 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, LDI_Var x, Some expr)) )
# 46860 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 46866 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 46875 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 46881 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = e;
            MenhirLib.EngineTypes.startp = _startpos_e_;
            MenhirLib.EngineTypes.endp = _endpos_e_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _2_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = h;
                      MenhirLib.EngineTypes.startp = _startpos_h_;
                      MenhirLib.EngineTypes.endp = _endpos_h_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let e : (AST.expr) = Obj.magic e in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (AST.local_decl_item list) = Obj.magic _1_inlined2 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let h : (AST.local_decl_item) = Obj.magic h in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let ldi =
                  let _1_inlined1 = _1_inlined2 in
                  let ldis =
                    let x =
                      let _1 = _1_inlined1 in
                      let t = _1 in
                      
# 301 "asllib/Parser0.mly"
                                           ( h::t )
# 46974 "asllib/Parser0.ml"
                      
                    in
                    
# 205 "<standard.mly>"
    ( x )
# 46980 "asllib/Parser0.ml"
                    
                  in
                  
# 691 "asllib/Parser0.mly"
                                           ( AST.LDI_Tuple ldis )
# 46986 "asllib/Parser0.ml"
                  
                in
                
# 660 "asllib/Parser0.mly"
        ( AST.S_Decl (LDK_Let, ldi, Some e) )
# 46992 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 46998 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 47007 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 47013 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (string list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let li = _1_inlined1 in
                let t =
                  let desc = 
# 319 "asllib/Parser0.mly"
                          ( AST.(T_Int UnConstrained) )
# 47059 "asllib/Parser0.ml"
                   in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 47067 "asllib/Parser0.ml"
                  
                in
                
# 661 "asllib/Parser0.mly"
                                                       make_ldi_vars  
# 47073 "asllib/Parser0.ml"
                 (t, li)
              in
              
# 196 "<standard.mly>"
    ( x )
# 47079 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 47088 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 47094 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (string list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let li = _1_inlined1 in
                let t =
                  let desc = 
# 320 "asllib/Parser0.mly"
                          ( AST.T_Real                )
# 47140 "asllib/Parser0.ml"
                   in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 47148 "asllib/Parser0.ml"
                  
                in
                
# 661 "asllib/Parser0.mly"
                                                       make_ldi_vars  
# 47154 "asllib/Parser0.ml"
                 (t, li)
              in
              
# 196 "<standard.mly>"
    ( x )
# 47160 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 47169 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 47175 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (string list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let li = _1_inlined1 in
                let t =
                  let desc = 
# 321 "asllib/Parser0.mly"
                          ( AST.T_Bool                )
# 47221 "asllib/Parser0.ml"
                   in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 47229 "asllib/Parser0.ml"
                  
                in
                
# 661 "asllib/Parser0.mly"
                                                       make_ldi_vars  
# 47235 "asllib/Parser0.ml"
                 (t, li)
              in
              
# 196 "<standard.mly>"
    ( x )
# 47241 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 47250 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 47256 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (string list) = Obj.magic _1_inlined1 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 47292 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let li = _1_inlined1 in
                let t =
                  let desc =
                    let tident = _1 in
                    
# 322 "asllib/Parser0.mly"
                            AST.T_Named                
# 47308 "asllib/Parser0.ml"
                     tident
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 47317 "asllib/Parser0.ml"
                  
                in
                
# 661 "asllib/Parser0.mly"
                                                       make_ldi_vars  
# 47323 "asllib/Parser0.ml"
                 (t, li)
              in
              
# 196 "<standard.mly>"
    ( x )
# 47329 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 47338 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 47344 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = q;
                  MenhirLib.EngineTypes.startp = _startpos_q_;
                  MenhirLib.EngineTypes.endp = _endpos_q_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (string list) = Obj.magic _1_inlined1 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 47392 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 47398 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let li = _1_inlined1 in
                let t =
                  let desc =
                    let tident =
                      let i = _1 in
                      
# 339 "asllib/Parser0.mly"
                                   ( q ^ "_" ^ i )
# 47416 "asllib/Parser0.ml"
                      
                    in
                    
# 322 "asllib/Parser0.mly"
                            AST.T_Named                
# 47422 "asllib/Parser0.ml"
                     tident
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos_q_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 47431 "asllib/Parser0.ml"
                  
                in
                
# 661 "asllib/Parser0.mly"
                                                       make_ldi_vars  
# 47437 "asllib/Parser0.ml"
                 (t, li)
              in
              
# 196 "<standard.mly>"
    ( x )
# 47443 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos_q_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 47452 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 47458 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (string list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let li = _1_inlined1 in
                let t =
                  let desc = 
# 323 "asllib/Parser0.mly"
                          ( t_bit                     )
# 47504 "asllib/Parser0.ml"
                   in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 47512 "asllib/Parser0.ml"
                  
                in
                
# 661 "asllib/Parser0.mly"
                                                       make_ldi_vars  
# 47518 "asllib/Parser0.ml"
                 (t, li)
              in
              
# 196 "<standard.mly>"
    ( x )
# 47524 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 47533 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 47539 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined2;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = x;
                MenhirLib.EngineTypes.startp = _startpos_x_;
                MenhirLib.EngineTypes.endp = _endpos_x_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined2 : (string list) = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let x : (AST.expr) = Obj.magic x in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let li = _1_inlined2 in
                let t =
                  let desc =
                    let e = 
# 205 "<standard.mly>"
    ( x )
# 47607 "asllib/Parser0.ml"
                     in
                    
# 324 "asllib/Parser0.mly"
                          ( AST.(T_Bits (e, []))      )
# 47612 "asllib/Parser0.ml"
                    
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 47621 "asllib/Parser0.ml"
                  
                in
                
# 661 "asllib/Parser0.mly"
                                                       make_ldi_vars  
# 47627 "asllib/Parser0.ml"
                 (t, li)
              in
              
# 196 "<standard.mly>"
    ( x )
# 47633 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 47642 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 47648 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined4;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = x;
                      MenhirLib.EngineTypes.startp = _startpos_x_;
                      MenhirLib.EngineTypes.endp = _endpos_x_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined4 : (string list) = Obj.magic _1_inlined4 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined3 : (AST.bitfield list) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let x : (AST.expr) = Obj.magic x in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let li = _1_inlined4 in
                let t =
                  let desc =
                    let b =
                      let _1_inlined1 = _1_inlined3 in
                      let x = _1_inlined1 in
                      
# 205 "<standard.mly>"
    ( x )
# 47740 "asllib/Parser0.ml"
                      
                    in
                    let e = 
# 205 "<standard.mly>"
    ( x )
# 47746 "asllib/Parser0.ml"
                     in
                    
# 325 "asllib/Parser0.mly"
                                      ( AST.(T_Bits (e, b)) )
# 47751 "asllib/Parser0.ml"
                    
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__3_inlined1_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 47760 "asllib/Parser0.ml"
                  
                in
                
# 661 "asllib/Parser0.mly"
                                                       make_ldi_vars  
# 47766 "asllib/Parser0.ml"
                 (t, li)
              in
              
# 196 "<standard.mly>"
    ( x )
# 47772 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 47781 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 47787 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined2;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = x;
                MenhirLib.EngineTypes.startp = _startpos_x_;
                MenhirLib.EngineTypes.endp = _endpos_x_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined2 : (string list) = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let x : (AST.expr) = Obj.magic x in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let li = _1_inlined2 in
                let t =
                  let desc =
                    let _1 =
                      let _2 = 
# 205 "<standard.mly>"
    ( x )
# 47856 "asllib/Parser0.ml"
                       in
                      ()
                    in
                    
# 265 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 47863 "asllib/Parser0.ml"
                    
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 47872 "asllib/Parser0.ml"
                  
                in
                
# 661 "asllib/Parser0.mly"
                                                       make_ldi_vars  
# 47878 "asllib/Parser0.ml"
                 (t, li)
              in
              
# 196 "<standard.mly>"
    ( x )
# 47884 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 47893 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 47899 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined3;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _4;
              MenhirLib.EngineTypes.startp = _startpos__4_;
              MenhirLib.EngineTypes.endp = _endpos__4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined3 : (string list) = Obj.magic _1_inlined3 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (
# 82 "asllib/Parser0.mly"
       (string)
# 47968 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let li = _1_inlined3 in
                let t =
                  let desc =
                    let _1 =
                      let _2 =
                        let _1_inlined1 = _1_inlined2 in
                        let x =
                          let _1 = _1_inlined1 in
                          ()
                        in
                        
# 205 "<standard.mly>"
    ( x )
# 47992 "asllib/Parser0.ml"
                        
                      in
                      ()
                    in
                    
# 265 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 48000 "asllib/Parser0.ml"
                    
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 48009 "asllib/Parser0.ml"
                  
                in
                
# 661 "asllib/Parser0.mly"
                                                       make_ldi_vars  
# 48015 "asllib/Parser0.ml"
                 (t, li)
              in
              
# 196 "<standard.mly>"
    ( x )
# 48021 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 48030 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 48036 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined3;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _4;
              MenhirLib.EngineTypes.startp = _startpos__4_;
              MenhirLib.EngineTypes.endp = _endpos__4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _2_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = q;
                        MenhirLib.EngineTypes.startp = _startpos_q_;
                        MenhirLib.EngineTypes.endp = _endpos_q_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined3 : (string list) = Obj.magic _1_inlined3 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (
# 82 "asllib/Parser0.mly"
       (string)
# 48117 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 48123 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let li = _1_inlined3 in
                let t =
                  let desc =
                    let _1 =
                      let _2 =
                        let _1_inlined1 = _1_inlined2 in
                        let x =
                          let _1 = _1_inlined1 in
                          let _1 =
                            let i = _1 in
                            
# 339 "asllib/Parser0.mly"
                                   ( q ^ "_" ^ i )
# 48148 "asllib/Parser0.ml"
                            
                          in
                          ()
                        in
                        
# 205 "<standard.mly>"
    ( x )
# 48156 "asllib/Parser0.ml"
                        
                      in
                      ()
                    in
                    
# 265 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 48164 "asllib/Parser0.ml"
                    
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 48173 "asllib/Parser0.ml"
                  
                in
                
# 661 "asllib/Parser0.mly"
                                                       make_ldi_vars  
# 48179 "asllib/Parser0.ml"
                 (t, li)
              in
              
# 196 "<standard.mly>"
    ( x )
# 48185 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 48194 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 48200 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined3;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _4;
              MenhirLib.EngineTypes.startp = _startpos__4_;
              MenhirLib.EngineTypes.endp = _endpos__4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _2_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined3 : (string list) = Obj.magic _1_inlined3 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _3_inlined1 : (AST.expr) = Obj.magic _3_inlined1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined2 : (AST.expr) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let li = _1_inlined3 in
                let t =
                  let desc =
                    let _1 =
                      let _2 =
                        let _1_inlined1 = _1_inlined2 in
                        let x =
                          let (_3, _1) = (_3_inlined1, _1_inlined1) in
                          ()
                        in
                        
# 205 "<standard.mly>"
    ( x )
# 48304 "asllib/Parser0.ml"
                        
                      in
                      ()
                    in
                    
# 265 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 48312 "asllib/Parser0.ml"
                    
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 48321 "asllib/Parser0.ml"
                  
                in
                
# 661 "asllib/Parser0.mly"
                                                       make_ldi_vars  
# 48327 "asllib/Parser0.ml"
                 (t, li)
              in
              
# 196 "<standard.mly>"
    ( x )
# 48333 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 48342 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 48348 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _3;
            MenhirLib.EngineTypes.startp = _startpos__3_;
            MenhirLib.EngineTypes.endp = _endpos__3_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1;
                MenhirLib.EngineTypes.startp = _startpos__1_;
                MenhirLib.EngineTypes.endp = _endpos__1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _2_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = q;
                    MenhirLib.EngineTypes.startp = _startpos_q_;
                    MenhirLib.EngineTypes.endp = _endpos_q_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 48403 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 48409 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let params = 
# 352 "asllib/Parser0.mly"
             ( [] )
# 48422 "asllib/Parser0.ml"
                 in
                let args =
                  let x = 
# 298 "asllib/Parser0.mly"
                ( [] )
# 48428 "asllib/Parser0.ml"
                   in
                  
# 205 "<standard.mly>"
    ( x )
# 48433 "asllib/Parser0.ml"
                  
                in
                let name =
                  let i = _1 in
                  
# 347 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 48441 "asllib/Parser0.ml"
                  
                in
                
# 631 "asllib/Parser0.mly"
      ( AST.S_Call { name; args; params ; call_type = ST_Procedure } )
# 48447 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 48453 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos_q_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 48462 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 48468 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _3;
            MenhirLib.EngineTypes.startp = _startpos__3_;
            MenhirLib.EngineTypes.endp = _endpos__3_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _2_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = q;
                      MenhirLib.EngineTypes.startp = _startpos_q_;
                      MenhirLib.EngineTypes.endp = _endpos_q_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (AST.expr list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 48530 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 48536 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let params = 
# 352 "asllib/Parser0.mly"
             ( [] )
# 48549 "asllib/Parser0.ml"
                 in
                let args =
                  let _1_inlined1 = _1_inlined2 in
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 48557 "asllib/Parser0.ml"
                  
                in
                let name =
                  let i = _1 in
                  
# 347 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 48565 "asllib/Parser0.ml"
                  
                in
                
# 631 "asllib/Parser0.mly"
      ( AST.S_Call { name; args; params ; call_type = ST_Procedure } )
# 48571 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 48577 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos_q_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 48586 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 48592 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _3;
            MenhirLib.EngineTypes.startp = _startpos__3_;
            MenhirLib.EngineTypes.endp = _endpos__3_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = _1;
                MenhirLib.EngineTypes.startp = _startpos__1_;
                MenhirLib.EngineTypes.endp = _endpos__1_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 48635 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let params = 
# 352 "asllib/Parser0.mly"
             ( [] )
# 48647 "asllib/Parser0.ml"
                 in
                let args =
                  let x = 
# 298 "asllib/Parser0.mly"
                ( [] )
# 48653 "asllib/Parser0.ml"
                   in
                  
# 205 "<standard.mly>"
    ( x )
# 48658 "asllib/Parser0.ml"
                  
                in
                let name = _1 in
                
# 631 "asllib/Parser0.mly"
      ( AST.S_Call { name; args; params ; call_type = ST_Procedure } )
# 48665 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 48671 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 48680 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 48686 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _3;
            MenhirLib.EngineTypes.startp = _startpos__3_;
            MenhirLib.EngineTypes.endp = _endpos__3_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (AST.expr list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 48736 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let params = 
# 352 "asllib/Parser0.mly"
             ( [] )
# 48748 "asllib/Parser0.ml"
                 in
                let args =
                  let _1_inlined1 = _1_inlined2 in
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 48756 "asllib/Parser0.ml"
                  
                in
                let name = _1 in
                
# 631 "asllib/Parser0.mly"
      ( AST.S_Call { name; args; params ; call_type = ST_Procedure } )
# 48763 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 48769 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 48778 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 48784 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _3;
            MenhirLib.EngineTypes.startp = _startpos__3_;
            MenhirLib.EngineTypes.endp = _endpos__3_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = _1;
                MenhirLib.EngineTypes.startp = _startpos__1_;
                MenhirLib.EngineTypes.endp = _endpos__1_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let params = 
# 352 "asllib/Parser0.mly"
             ( [] )
# 48835 "asllib/Parser0.ml"
                 in
                let args =
                  let x = 
# 298 "asllib/Parser0.mly"
                ( [] )
# 48841 "asllib/Parser0.ml"
                   in
                  
# 205 "<standard.mly>"
    ( x )
# 48846 "asllib/Parser0.ml"
                  
                in
                let name = 
# 349 "asllib/Parser0.mly"
              ( "record" )
# 48852 "asllib/Parser0.ml"
                 in
                
# 631 "asllib/Parser0.mly"
      ( AST.S_Call { name; args; params ; call_type = ST_Procedure } )
# 48857 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 48863 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 48872 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 48878 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _3;
            MenhirLib.EngineTypes.startp = _startpos__3_;
            MenhirLib.EngineTypes.endp = _endpos__3_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (AST.expr list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let params = 
# 352 "asllib/Parser0.mly"
             ( [] )
# 48936 "asllib/Parser0.ml"
                 in
                let args =
                  let _1_inlined1 = _1_inlined2 in
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 48944 "asllib/Parser0.ml"
                  
                in
                let name = 
# 349 "asllib/Parser0.mly"
              ( "record" )
# 48950 "asllib/Parser0.ml"
                 in
                
# 631 "asllib/Parser0.mly"
      ( AST.S_Call { name; args; params ; call_type = ST_Procedure } )
# 48955 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 48961 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 48970 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 48976 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = 
# 123 "<standard.mly>"
    ( None )
# 49013 "asllib/Parser0.ml"
                 in
                let _2_1 = _2 in
                
# 632 "asllib/Parser0.mly"
                                                    AST.S_Return  
# 49019 "asllib/Parser0.ml"
                 _2_1
              in
              
# 196 "<standard.mly>"
    ( x )
# 49025 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 49034 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 49040 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = x;
            MenhirLib.EngineTypes.startp = _startpos_x_;
            MenhirLib.EngineTypes.endp = _endpos_x_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let x : (AST.expr) = Obj.magic x in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = 
# 126 "<standard.mly>"
    ( Some x )
# 49084 "asllib/Parser0.ml"
                 in
                let _2_1 = _2 in
                
# 632 "asllib/Parser0.mly"
                                                    AST.S_Return  
# 49090 "asllib/Parser0.ml"
                 _2_1
              in
              
# 196 "<standard.mly>"
    ( x )
# 49096 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 49105 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 49111 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x = 
# 633 "asllib/Parser0.mly"
                                                    AST.S_Assert  
# 49154 "asllib/Parser0.ml"
               expr in
              
# 196 "<standard.mly>"
    ( x )
# 49159 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 49168 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 49174 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = e;
            MenhirLib.EngineTypes.startp = _startpos_e_;
            MenhirLib.EngineTypes.endp = _endpos_e_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let e : (AST.expr) = Obj.magic e in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x = 
# 634 "asllib/Parser0.mly"
                                                  ( AST.S_Print { args = [ e ]; debug = true } )
# 49217 "asllib/Parser0.ml"
               in
              
# 196 "<standard.mly>"
    ( x )
# 49222 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 49231 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 49237 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _1 =
                  let _2 = 
# 123 "<standard.mly>"
    ( None )
# 49275 "asllib/Parser0.ml"
                   in
                  ()
                in
                
# 612 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 49282 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 49288 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 49297 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 49303 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _3;
            MenhirLib.EngineTypes.startp = _startpos__3_;
            MenhirLib.EngineTypes.endp = _endpos__3_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = _1;
                MenhirLib.EngineTypes.startp = _startpos__1_;
                MenhirLib.EngineTypes.endp = _endpos__1_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _1 =
                  let _2 =
                    let x =
                      let x = () in
                      
# 205 "<standard.mly>"
    ( x )
# 49358 "asllib/Parser0.ml"
                      
                    in
                    
# 126 "<standard.mly>"
    ( Some x )
# 49364 "asllib/Parser0.ml"
                    
                  in
                  ()
                in
                
# 612 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 49372 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 49378 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 49387 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 49393 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _1 = () in
                
# 612 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 49431 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 49437 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 49446 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 49452 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _3;
            MenhirLib.EngineTypes.startp = _startpos__3_;
            MenhirLib.EngineTypes.endp = _endpos__3_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (
# 82 "asllib/Parser0.mly"
       (string)
# 49500 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _1 =
                  let _2 =
                    let _1_inlined1 = _1_inlined2 in
                    let x = _1_inlined1 in
                    
# 205 "<standard.mly>"
    ( x )
# 49518 "asllib/Parser0.ml"
                    
                  in
                  ()
                in
                
# 612 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 49526 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 49532 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 49541 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 49547 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _1 =
                  let _2 = 
# 123 "<standard.mly>"
    ( None )
# 49585 "asllib/Parser0.ml"
                   in
                  ()
                in
                
# 612 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 49592 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 49598 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 49607 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 49613 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _3;
            MenhirLib.EngineTypes.startp = _startpos__3_;
            MenhirLib.EngineTypes.endp = _endpos__3_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = _1;
                MenhirLib.EngineTypes.startp = _startpos__1_;
                MenhirLib.EngineTypes.endp = _endpos__1_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _1 =
                  let _2 =
                    let x =
                      let x = () in
                      
# 205 "<standard.mly>"
    ( x )
# 49668 "asllib/Parser0.ml"
                      
                    in
                    
# 126 "<standard.mly>"
    ( Some x )
# 49674 "asllib/Parser0.ml"
                    
                  in
                  ()
                in
                
# 612 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 49682 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 49688 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 49697 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 49703 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _1 =
                  let _2 = 
# 123 "<standard.mly>"
    ( None )
# 49741 "asllib/Parser0.ml"
                   in
                  ()
                in
                
# 612 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 49748 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 49754 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 49763 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 49769 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = x;
            MenhirLib.EngineTypes.startp = _startpos_x_;
            MenhirLib.EngineTypes.endp = _endpos_x_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let x : (
# 82 "asllib/Parser0.mly"
       (string)
# 49804 "asllib/Parser0.ml"
        ) = Obj.magic x in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _1 =
                  let _2 = 
# 126 "<standard.mly>"
    ( Some x )
# 49818 "asllib/Parser0.ml"
                   in
                  ()
                in
                
# 612 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 49825 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 49831 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 49840 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 49846 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _3;
            MenhirLib.EngineTypes.startp = _startpos__3_;
            MenhirLib.EngineTypes.endp = _endpos__3_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = x;
              MenhirLib.EngineTypes.startp = _startpos_x_;
              MenhirLib.EngineTypes.endp = _endpos_x_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _3 : unit = Obj.magic _3 in
        let x : (AST.expr) = Obj.magic x in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _1 =
                  let _2 = 
# 205 "<standard.mly>"
    ( x )
# 49905 "asllib/Parser0.ml"
                   in
                  ()
                in
                
# 612 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 49912 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 49918 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 49927 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 49933 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _2_inlined1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 49968 "asllib/Parser0.ml"
        ) = Obj.magic _2_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let _1 = () in
                
# 612 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 49983 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 49989 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 49998 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 50004 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 50039 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _1 =
                  let _2 = _1_inlined1 in
                  ()
                in
                
# 612 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 50056 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 50062 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 50071 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 50077 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 50112 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _1 =
                  let _2 = _1_inlined1 in
                  ()
                in
                
# 612 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 50129 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 50135 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 50144 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 50150 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = e;
              MenhirLib.EngineTypes.startp = _startpos_e_;
              MenhirLib.EngineTypes.endp = _endpos_e_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = le;
                  MenhirLib.EngineTypes.startp = _startpos_le_;
                  MenhirLib.EngineTypes.endp = _endpos_le_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let e : (AST.expr) = Obj.magic e in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let le : (AST.lexpr) = Obj.magic le in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_le_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                
# 652 "asllib/Parser0.mly"
                                AST.S_Assign  
# 50209 "asllib/Parser0.ml"
                 (le, e)
              in
              
# 196 "<standard.mly>"
    ( x )
# 50215 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos_le_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 50224 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 50230 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 50286 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let ldi =
                  let x = _1_inlined1 in
                  let t =
                    let desc = 
# 319 "asllib/Parser0.mly"
                          ( AST.(T_Int UnConstrained) )
# 50303 "asllib/Parser0.ml"
                     in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 50311 "asllib/Parser0.ml"
                    
                  in
                  
# 669 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 50317 "asllib/Parser0.ml"
                  
                in
                
# 654 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, ldi, Some expr)) )
# 50323 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 50329 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 50338 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 50344 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let ldi =
                  let x =
                    let _1 = _1_inlined1 in
                    
# 344 "asllib/Parser0.mly"
                                         ( "record" )
# 50413 "asllib/Parser0.ml"
                    
                  in
                  let t =
                    let desc = 
# 319 "asllib/Parser0.mly"
                          ( AST.(T_Int UnConstrained) )
# 50420 "asllib/Parser0.ml"
                     in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 50428 "asllib/Parser0.ml"
                    
                  in
                  
# 669 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 50434 "asllib/Parser0.ml"
                  
                in
                
# 654 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, ldi, Some expr)) )
# 50440 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 50446 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 50455 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 50461 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 50517 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let ldi =
                  let x = _1_inlined1 in
                  let t =
                    let desc = 
# 320 "asllib/Parser0.mly"
                          ( AST.T_Real                )
# 50534 "asllib/Parser0.ml"
                     in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 50542 "asllib/Parser0.ml"
                    
                  in
                  
# 669 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 50548 "asllib/Parser0.ml"
                  
                in
                
# 654 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, ldi, Some expr)) )
# 50554 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 50560 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 50569 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 50575 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let ldi =
                  let x =
                    let _1 = _1_inlined1 in
                    
# 344 "asllib/Parser0.mly"
                                         ( "record" )
# 50644 "asllib/Parser0.ml"
                    
                  in
                  let t =
                    let desc = 
# 320 "asllib/Parser0.mly"
                          ( AST.T_Real                )
# 50651 "asllib/Parser0.ml"
                     in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 50659 "asllib/Parser0.ml"
                    
                  in
                  
# 669 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 50665 "asllib/Parser0.ml"
                  
                in
                
# 654 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, ldi, Some expr)) )
# 50671 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 50677 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 50686 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 50692 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 50748 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let ldi =
                  let x = _1_inlined1 in
                  let t =
                    let desc = 
# 321 "asllib/Parser0.mly"
                          ( AST.T_Bool                )
# 50765 "asllib/Parser0.ml"
                     in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 50773 "asllib/Parser0.ml"
                    
                  in
                  
# 669 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 50779 "asllib/Parser0.ml"
                  
                in
                
# 654 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, ldi, Some expr)) )
# 50785 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 50791 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 50800 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 50806 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let ldi =
                  let x =
                    let _1 = _1_inlined1 in
                    
# 344 "asllib/Parser0.mly"
                                         ( "record" )
# 50875 "asllib/Parser0.ml"
                    
                  in
                  let t =
                    let desc = 
# 321 "asllib/Parser0.mly"
                          ( AST.T_Bool                )
# 50882 "asllib/Parser0.ml"
                     in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 50890 "asllib/Parser0.ml"
                    
                  in
                  
# 669 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 50896 "asllib/Parser0.ml"
                  
                in
                
# 654 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, ldi, Some expr)) )
# 50902 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 50908 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 50917 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 50923 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 50979 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 50984 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let ldi =
                  let x = _1_inlined1 in
                  let t =
                    let desc =
                      let tident = _1 in
                      
# 322 "asllib/Parser0.mly"
                            AST.T_Named                
# 51002 "asllib/Parser0.ml"
                       tident
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 51011 "asllib/Parser0.ml"
                    
                  in
                  
# 669 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 51017 "asllib/Parser0.ml"
                  
                in
                
# 654 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, ldi, Some expr)) )
# 51023 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 51029 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 51038 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 51044 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 51101 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let ldi =
                  let x =
                    let _1 = _1_inlined1 in
                    
# 344 "asllib/Parser0.mly"
                                         ( "record" )
# 51117 "asllib/Parser0.ml"
                    
                  in
                  let t =
                    let desc =
                      let tident = _1 in
                      
# 322 "asllib/Parser0.mly"
                            AST.T_Named                
# 51126 "asllib/Parser0.ml"
                       tident
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 51135 "asllib/Parser0.ml"
                    
                  in
                  
# 669 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 51141 "asllib/Parser0.ml"
                  
                in
                
# 654 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, ldi, Some expr)) )
# 51147 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 51153 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 51162 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 51168 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _2_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = q;
                        MenhirLib.EngineTypes.startp = _startpos_q_;
                        MenhirLib.EngineTypes.endp = _endpos_q_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _2_inlined2 : unit = Obj.magic _2_inlined2 in
        let _1_inlined1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 51236 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 51241 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 51247 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined2 in
                let ldi =
                  let _2 = _2_inlined1 in
                  let x = _1_inlined1 in
                  let t =
                    let desc =
                      let tident =
                        let i = _1 in
                        
# 339 "asllib/Parser0.mly"
                                   ( q ^ "_" ^ i )
# 51267 "asllib/Parser0.ml"
                        
                      in
                      
# 322 "asllib/Parser0.mly"
                            AST.T_Named                
# 51273 "asllib/Parser0.ml"
                       tident
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos_q_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 51282 "asllib/Parser0.ml"
                    
                  in
                  
# 669 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 51288 "asllib/Parser0.ml"
                  
                in
                
# 654 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, ldi, Some expr)) )
# 51294 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 51300 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos_q_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 51309 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 51315 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _2_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = q;
                        MenhirLib.EngineTypes.startp = _startpos_q_;
                        MenhirLib.EngineTypes.endp = _endpos_q_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _2_inlined2 : unit = Obj.magic _2_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 51384 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 51390 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined2 in
                let ldi =
                  let _2 = _2_inlined1 in
                  let x =
                    let _1 = _1_inlined1 in
                    
# 344 "asllib/Parser0.mly"
                                         ( "record" )
# 51407 "asllib/Parser0.ml"
                    
                  in
                  let t =
                    let desc =
                      let tident =
                        let i = _1 in
                        
# 339 "asllib/Parser0.mly"
                                   ( q ^ "_" ^ i )
# 51417 "asllib/Parser0.ml"
                        
                      in
                      
# 322 "asllib/Parser0.mly"
                            AST.T_Named                
# 51423 "asllib/Parser0.ml"
                       tident
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos_q_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 51432 "asllib/Parser0.ml"
                    
                  in
                  
# 669 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 51438 "asllib/Parser0.ml"
                  
                in
                
# 654 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, ldi, Some expr)) )
# 51444 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 51450 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos_q_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 51459 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 51465 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 51521 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let ldi =
                  let x = _1_inlined1 in
                  let t =
                    let desc = 
# 323 "asllib/Parser0.mly"
                          ( t_bit                     )
# 51538 "asllib/Parser0.ml"
                     in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 51546 "asllib/Parser0.ml"
                    
                  in
                  
# 669 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 51552 "asllib/Parser0.ml"
                  
                in
                
# 654 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, ldi, Some expr)) )
# 51558 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 51564 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 51573 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 51579 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let ldi =
                  let x =
                    let _1 = _1_inlined1 in
                    
# 344 "asllib/Parser0.mly"
                                         ( "record" )
# 51648 "asllib/Parser0.ml"
                    
                  in
                  let t =
                    let desc = 
# 323 "asllib/Parser0.mly"
                          ( t_bit                     )
# 51655 "asllib/Parser0.ml"
                     in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 51663 "asllib/Parser0.ml"
                    
                  in
                  
# 669 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 51669 "asllib/Parser0.ml"
                  
                in
                
# 654 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, ldi, Some expr)) )
# 51675 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 51681 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 51690 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 51696 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = x_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined2 : (
# 82 "asllib/Parser0.mly"
       (string)
# 51770 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let x_inlined1 : (AST.expr) = Obj.magic x_inlined1 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let ldi =
                  let x = _1_inlined2 in
                  let t =
                    let x = x_inlined1 in
                    let desc =
                      let e = 
# 205 "<standard.mly>"
    ( x )
# 51792 "asllib/Parser0.ml"
                       in
                      
# 324 "asllib/Parser0.mly"
                          ( AST.(T_Bits (e, []))      )
# 51797 "asllib/Parser0.ml"
                      
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 51806 "asllib/Parser0.ml"
                    
                  in
                  
# 669 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 51812 "asllib/Parser0.ml"
                  
                in
                
# 654 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, ldi, Some expr)) )
# 51818 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 51824 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 51833 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 51839 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = x_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let x_inlined1 : (AST.expr) = Obj.magic x_inlined1 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let ldi =
                  let x =
                    let _1 = _1_inlined2 in
                    
# 344 "asllib/Parser0.mly"
                                         ( "record" )
# 51929 "asllib/Parser0.ml"
                    
                  in
                  let t =
                    let x = x_inlined1 in
                    let desc =
                      let e = 
# 205 "<standard.mly>"
    ( x )
# 51938 "asllib/Parser0.ml"
                       in
                      
# 324 "asllib/Parser0.mly"
                          ( AST.(T_Bits (e, []))      )
# 51943 "asllib/Parser0.ml"
                      
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 51952 "asllib/Parser0.ml"
                    
                  in
                  
# 669 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 51958 "asllib/Parser0.ml"
                  
                in
                
# 654 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, ldi, Some expr)) )
# 51964 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 51970 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 51979 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 51985 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined4;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined3;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _3;
                          MenhirLib.EngineTypes.startp = _startpos__3_;
                          MenhirLib.EngineTypes.endp = _endpos__3_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = x_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _menhir_s;
                                MenhirLib.EngineTypes.semv = _1;
                                MenhirLib.EngineTypes.startp = _startpos__1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_;
                                MenhirLib.EngineTypes.next = _menhir_stack;
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined4 : (
# 82 "asllib/Parser0.mly"
       (string)
# 52077 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined4 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined3 : (AST.bitfield list) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let x_inlined1 : (AST.expr) = Obj.magic x_inlined1 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let ldi =
                  let x = _1_inlined4 in
                  let t =
                    let x = x_inlined1 in
                    let desc =
                      let b =
                        let _1_inlined1 = _1_inlined3 in
                        let x = _1_inlined1 in
                        
# 205 "<standard.mly>"
    ( x )
# 52105 "asllib/Parser0.ml"
                        
                      in
                      let e = 
# 205 "<standard.mly>"
    ( x )
# 52111 "asllib/Parser0.ml"
                       in
                      
# 325 "asllib/Parser0.mly"
                                      ( AST.(T_Bits (e, b)) )
# 52116 "asllib/Parser0.ml"
                      
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__3_inlined1_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 52125 "asllib/Parser0.ml"
                    
                  in
                  
# 669 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 52131 "asllib/Parser0.ml"
                  
                in
                
# 654 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, ldi, Some expr)) )
# 52137 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 52143 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 52152 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 52158 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined4;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined3;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _3;
                          MenhirLib.EngineTypes.startp = _startpos__3_;
                          MenhirLib.EngineTypes.endp = _endpos__3_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = x_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _menhir_s;
                                MenhirLib.EngineTypes.semv = _1;
                                MenhirLib.EngineTypes.startp = _startpos__1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_;
                                MenhirLib.EngineTypes.next = _menhir_stack;
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined3 : (AST.bitfield list) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let x_inlined1 : (AST.expr) = Obj.magic x_inlined1 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let ldi =
                  let x =
                    let _1 = _1_inlined4 in
                    
# 344 "asllib/Parser0.mly"
                                         ( "record" )
# 52269 "asllib/Parser0.ml"
                    
                  in
                  let t =
                    let x = x_inlined1 in
                    let desc =
                      let b =
                        let _1_inlined1 = _1_inlined3 in
                        let x = _1_inlined1 in
                        
# 205 "<standard.mly>"
    ( x )
# 52281 "asllib/Parser0.ml"
                        
                      in
                      let e = 
# 205 "<standard.mly>"
    ( x )
# 52287 "asllib/Parser0.ml"
                       in
                      
# 325 "asllib/Parser0.mly"
                                      ( AST.(T_Bits (e, b)) )
# 52292 "asllib/Parser0.ml"
                      
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__3_inlined1_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 52301 "asllib/Parser0.ml"
                    
                  in
                  
# 669 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 52307 "asllib/Parser0.ml"
                  
                in
                
# 654 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, ldi, Some expr)) )
# 52313 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 52319 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 52328 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 52334 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = x_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined2 : (
# 82 "asllib/Parser0.mly"
       (string)
# 52408 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let x_inlined1 : (AST.expr) = Obj.magic x_inlined1 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let ldi =
                  let x = _1_inlined2 in
                  let t =
                    let x = x_inlined1 in
                    let desc =
                      let _1 =
                        let _2 = 
# 205 "<standard.mly>"
    ( x )
# 52431 "asllib/Parser0.ml"
                         in
                        ()
                      in
                      
# 265 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 52438 "asllib/Parser0.ml"
                      
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 52447 "asllib/Parser0.ml"
                    
                  in
                  
# 669 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 52453 "asllib/Parser0.ml"
                  
                in
                
# 654 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, ldi, Some expr)) )
# 52459 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 52465 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 52474 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 52480 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = x_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let x_inlined1 : (AST.expr) = Obj.magic x_inlined1 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let ldi =
                  let x =
                    let _1 = _1_inlined2 in
                    
# 344 "asllib/Parser0.mly"
                                         ( "record" )
# 52570 "asllib/Parser0.ml"
                    
                  in
                  let t =
                    let x = x_inlined1 in
                    let desc =
                      let _1 =
                        let _2 = 
# 205 "<standard.mly>"
    ( x )
# 52580 "asllib/Parser0.ml"
                         in
                        ()
                      in
                      
# 265 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 52587 "asllib/Parser0.ml"
                      
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 52596 "asllib/Parser0.ml"
                    
                  in
                  
# 669 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 52602 "asllib/Parser0.ml"
                  
                in
                
# 654 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, ldi, Some expr)) )
# 52608 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 52614 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 52623 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 52629 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _4;
                    MenhirLib.EngineTypes.startp = _startpos__4_;
                    MenhirLib.EngineTypes.endp = _endpos__4_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3;
                      MenhirLib.EngineTypes.startp = _startpos__3_;
                      MenhirLib.EngineTypes.endp = _endpos__3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined2;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = _1;
                              MenhirLib.EngineTypes.startp = _startpos__1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined3 : (
# 82 "asllib/Parser0.mly"
       (string)
# 52715 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (
# 82 "asllib/Parser0.mly"
       (string)
# 52723 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let ldi =
                  let x = _1_inlined3 in
                  let t =
                    let desc =
                      let _1 =
                        let _2 =
                          let _1_inlined1 = _1_inlined2 in
                          let x =
                            let _1 = _1_inlined1 in
                            ()
                          in
                          
# 205 "<standard.mly>"
    ( x )
# 52749 "asllib/Parser0.ml"
                          
                        in
                        ()
                      in
                      
# 265 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 52757 "asllib/Parser0.ml"
                      
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 52766 "asllib/Parser0.ml"
                    
                  in
                  
# 669 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 52772 "asllib/Parser0.ml"
                  
                in
                
# 654 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, ldi, Some expr)) )
# 52778 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 52784 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 52793 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 52799 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _4;
                    MenhirLib.EngineTypes.startp = _startpos__4_;
                    MenhirLib.EngineTypes.endp = _endpos__4_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3;
                      MenhirLib.EngineTypes.startp = _startpos__3_;
                      MenhirLib.EngineTypes.endp = _endpos__3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined2;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = _1;
                              MenhirLib.EngineTypes.startp = _startpos__1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (
# 82 "asllib/Parser0.mly"
       (string)
# 52889 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let ldi =
                  let x =
                    let _1 = _1_inlined3 in
                    
# 344 "asllib/Parser0.mly"
                                         ( "record" )
# 52907 "asllib/Parser0.ml"
                    
                  in
                  let t =
                    let desc =
                      let _1 =
                        let _2 =
                          let _1_inlined1 = _1_inlined2 in
                          let x =
                            let _1 = _1_inlined1 in
                            ()
                          in
                          
# 205 "<standard.mly>"
    ( x )
# 52922 "asllib/Parser0.ml"
                          
                        in
                        ()
                      in
                      
# 265 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 52930 "asllib/Parser0.ml"
                      
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 52939 "asllib/Parser0.ml"
                    
                  in
                  
# 669 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 52945 "asllib/Parser0.ml"
                  
                in
                
# 654 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, ldi, Some expr)) )
# 52951 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 52957 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 52966 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 52972 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _4;
                    MenhirLib.EngineTypes.startp = _startpos__4_;
                    MenhirLib.EngineTypes.endp = _endpos__4_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3;
                      MenhirLib.EngineTypes.startp = _startpos__3_;
                      MenhirLib.EngineTypes.endp = _endpos__3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined2;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _2_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = q;
                              MenhirLib.EngineTypes.startp = _startpos_q_;
                              MenhirLib.EngineTypes.endp = _endpos_q_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined1;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _menhir_s;
                                  MenhirLib.EngineTypes.semv = _1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_;
                                  MenhirLib.EngineTypes.next = _menhir_stack;
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _2_inlined2 : unit = Obj.magic _2_inlined2 in
        let _1_inlined3 : (
# 82 "asllib/Parser0.mly"
       (string)
# 53070 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (
# 82 "asllib/Parser0.mly"
       (string)
# 53078 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 53084 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined2 in
                let ldi =
                  let _2 = _2_inlined1 in
                  let x = _1_inlined3 in
                  let t =
                    let desc =
                      let _1 =
                        let _2 =
                          let _1_inlined1 = _1_inlined2 in
                          let x =
                            let _1 = _1_inlined1 in
                            let _1 =
                              let i = _1 in
                              
# 339 "asllib/Parser0.mly"
                                   ( q ^ "_" ^ i )
# 53111 "asllib/Parser0.ml"
                              
                            in
                            ()
                          in
                          
# 205 "<standard.mly>"
    ( x )
# 53119 "asllib/Parser0.ml"
                          
                        in
                        ()
                      in
                      
# 265 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 53127 "asllib/Parser0.ml"
                      
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 53136 "asllib/Parser0.ml"
                    
                  in
                  
# 669 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 53142 "asllib/Parser0.ml"
                  
                in
                
# 654 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, ldi, Some expr)) )
# 53148 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 53154 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 53163 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 53169 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _4;
                    MenhirLib.EngineTypes.startp = _startpos__4_;
                    MenhirLib.EngineTypes.endp = _endpos__4_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3;
                      MenhirLib.EngineTypes.startp = _startpos__3_;
                      MenhirLib.EngineTypes.endp = _endpos__3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined2;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _2_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = q;
                              MenhirLib.EngineTypes.startp = _startpos_q_;
                              MenhirLib.EngineTypes.endp = _endpos_q_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined1;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _menhir_s;
                                  MenhirLib.EngineTypes.semv = _1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_;
                                  MenhirLib.EngineTypes.next = _menhir_stack;
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _2_inlined2 : unit = Obj.magic _2_inlined2 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (
# 82 "asllib/Parser0.mly"
       (string)
# 53271 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 53277 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined2 in
                let ldi =
                  let _2 = _2_inlined1 in
                  let x =
                    let _1 = _1_inlined3 in
                    
# 344 "asllib/Parser0.mly"
                                         ( "record" )
# 53296 "asllib/Parser0.ml"
                    
                  in
                  let t =
                    let desc =
                      let _1 =
                        let _2 =
                          let _1_inlined1 = _1_inlined2 in
                          let x =
                            let _1 = _1_inlined1 in
                            let _1 =
                              let i = _1 in
                              
# 339 "asllib/Parser0.mly"
                                   ( q ^ "_" ^ i )
# 53311 "asllib/Parser0.ml"
                              
                            in
                            ()
                          in
                          
# 205 "<standard.mly>"
    ( x )
# 53319 "asllib/Parser0.ml"
                          
                        in
                        ()
                      in
                      
# 265 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 53327 "asllib/Parser0.ml"
                      
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 53336 "asllib/Parser0.ml"
                    
                  in
                  
# 669 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 53342 "asllib/Parser0.ml"
                  
                in
                
# 654 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, ldi, Some expr)) )
# 53348 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 53354 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 53363 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 53369 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _4;
                    MenhirLib.EngineTypes.startp = _startpos__4_;
                    MenhirLib.EngineTypes.endp = _endpos__4_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3;
                      MenhirLib.EngineTypes.startp = _startpos__3_;
                      MenhirLib.EngineTypes.endp = _endpos__3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _3_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _2_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined2;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined1;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _menhir_s;
                                  MenhirLib.EngineTypes.semv = _1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_;
                                  MenhirLib.EngineTypes.next = _menhir_stack;
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _2_inlined2 : unit = Obj.magic _2_inlined2 in
        let _1_inlined3 : (
# 82 "asllib/Parser0.mly"
       (string)
# 53467 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _3_inlined1 : (AST.expr) = Obj.magic _3_inlined1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined2 : (AST.expr) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined2 in
                let ldi =
                  let _2 = _2_inlined1 in
                  let x = _1_inlined3 in
                  let t =
                    let desc =
                      let _1 =
                        let _2 =
                          let _1_inlined1 = _1_inlined2 in
                          let x =
                            let (_3, _1) = (_3_inlined1, _1_inlined1) in
                            ()
                          in
                          
# 205 "<standard.mly>"
    ( x )
# 53500 "asllib/Parser0.ml"
                          
                        in
                        ()
                      in
                      
# 265 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 53508 "asllib/Parser0.ml"
                      
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 53517 "asllib/Parser0.ml"
                    
                  in
                  
# 669 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 53523 "asllib/Parser0.ml"
                  
                in
                
# 654 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, ldi, Some expr)) )
# 53529 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 53535 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 53544 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 53550 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _4;
                    MenhirLib.EngineTypes.startp = _startpos__4_;
                    MenhirLib.EngineTypes.endp = _endpos__4_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3;
                      MenhirLib.EngineTypes.startp = _startpos__3_;
                      MenhirLib.EngineTypes.endp = _endpos__3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _3_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _2_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined2;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined1;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _menhir_s;
                                  MenhirLib.EngineTypes.semv = _1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_;
                                  MenhirLib.EngineTypes.next = _menhir_stack;
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _2_inlined2 : unit = Obj.magic _2_inlined2 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _3_inlined1 : (AST.expr) = Obj.magic _3_inlined1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined2 : (AST.expr) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined2 in
                let ldi =
                  let _2 = _2_inlined1 in
                  let x =
                    let _1 = _1_inlined3 in
                    
# 344 "asllib/Parser0.mly"
                                         ( "record" )
# 53669 "asllib/Parser0.ml"
                    
                  in
                  let t =
                    let desc =
                      let _1 =
                        let _2 =
                          let _1_inlined1 = _1_inlined2 in
                          let x =
                            let (_3, _1) = (_3_inlined1, _1_inlined1) in
                            ()
                          in
                          
# 205 "<standard.mly>"
    ( x )
# 53684 "asllib/Parser0.ml"
                          
                        in
                        ()
                      in
                      
# 265 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 53692 "asllib/Parser0.ml"
                      
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 53701 "asllib/Parser0.ml"
                    
                  in
                  
# 669 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 53707 "asllib/Parser0.ml"
                  
                in
                
# 654 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, ldi, Some expr)) )
# 53713 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 53719 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 53728 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 53734 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (
# 82 "asllib/Parser0.mly"
       (string)
# 53796 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let ldi =
                  let (_endpos__1_, _startpos__1_, _1_inlined1, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined2, _1_inlined1) in
                  let x = _1_inlined1 in
                  let t =
                    let desc = 
# 319 "asllib/Parser0.mly"
                          ( AST.(T_Int UnConstrained) )
# 53814 "asllib/Parser0.ml"
                     in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 53822 "asllib/Parser0.ml"
                    
                  in
                  
# 669 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 53828 "asllib/Parser0.ml"
                  
                in
                
# 656 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, ldi, Some expr)) )
# 53834 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 53840 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 53849 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 53855 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let ldi =
                  let (_endpos__1_, _startpos__1_, _1_inlined1, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    
# 344 "asllib/Parser0.mly"
                                         ( "record" )
# 53931 "asllib/Parser0.ml"
                    
                  in
                  let t =
                    let desc = 
# 319 "asllib/Parser0.mly"
                          ( AST.(T_Int UnConstrained) )
# 53938 "asllib/Parser0.ml"
                     in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 53946 "asllib/Parser0.ml"
                    
                  in
                  
# 669 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 53952 "asllib/Parser0.ml"
                  
                in
                
# 656 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, ldi, Some expr)) )
# 53958 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 53964 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 53973 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 53979 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (
# 82 "asllib/Parser0.mly"
       (string)
# 54041 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let ldi =
                  let (_endpos__1_, _startpos__1_, _1_inlined1, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined2, _1_inlined1) in
                  let x = _1_inlined1 in
                  let t =
                    let desc = 
# 320 "asllib/Parser0.mly"
                          ( AST.T_Real                )
# 54059 "asllib/Parser0.ml"
                     in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 54067 "asllib/Parser0.ml"
                    
                  in
                  
# 669 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 54073 "asllib/Parser0.ml"
                  
                in
                
# 656 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, ldi, Some expr)) )
# 54079 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 54085 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 54094 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 54100 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let ldi =
                  let (_endpos__1_, _startpos__1_, _1_inlined1, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    
# 344 "asllib/Parser0.mly"
                                         ( "record" )
# 54176 "asllib/Parser0.ml"
                    
                  in
                  let t =
                    let desc = 
# 320 "asllib/Parser0.mly"
                          ( AST.T_Real                )
# 54183 "asllib/Parser0.ml"
                     in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 54191 "asllib/Parser0.ml"
                    
                  in
                  
# 669 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 54197 "asllib/Parser0.ml"
                  
                in
                
# 656 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, ldi, Some expr)) )
# 54203 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 54209 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 54218 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 54224 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (
# 82 "asllib/Parser0.mly"
       (string)
# 54286 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let ldi =
                  let (_endpos__1_, _startpos__1_, _1_inlined1, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined2, _1_inlined1) in
                  let x = _1_inlined1 in
                  let t =
                    let desc = 
# 321 "asllib/Parser0.mly"
                          ( AST.T_Bool                )
# 54304 "asllib/Parser0.ml"
                     in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 54312 "asllib/Parser0.ml"
                    
                  in
                  
# 669 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 54318 "asllib/Parser0.ml"
                  
                in
                
# 656 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, ldi, Some expr)) )
# 54324 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 54330 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 54339 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 54345 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let ldi =
                  let (_endpos__1_, _startpos__1_, _1_inlined1, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    
# 344 "asllib/Parser0.mly"
                                         ( "record" )
# 54421 "asllib/Parser0.ml"
                    
                  in
                  let t =
                    let desc = 
# 321 "asllib/Parser0.mly"
                          ( AST.T_Bool                )
# 54428 "asllib/Parser0.ml"
                     in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 54436 "asllib/Parser0.ml"
                    
                  in
                  
# 669 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 54442 "asllib/Parser0.ml"
                  
                in
                
# 656 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, ldi, Some expr)) )
# 54448 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 54454 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 54463 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 54469 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (
# 82 "asllib/Parser0.mly"
       (string)
# 54531 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _1_inlined1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 54536 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let ldi =
                  let (_endpos__1_, _startpos__1_, _1_inlined1, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined2, _1_inlined1) in
                  let x = _1_inlined1 in
                  let t =
                    let desc =
                      let tident = _1 in
                      
# 322 "asllib/Parser0.mly"
                            AST.T_Named                
# 54555 "asllib/Parser0.ml"
                       tident
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 54564 "asllib/Parser0.ml"
                    
                  in
                  
# 669 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 54570 "asllib/Parser0.ml"
                  
                in
                
# 656 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, ldi, Some expr)) )
# 54576 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 54582 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 54591 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 54597 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 54660 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let ldi =
                  let (_endpos__1_, _startpos__1_, _1_inlined1, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    
# 344 "asllib/Parser0.mly"
                                         ( "record" )
# 54677 "asllib/Parser0.ml"
                    
                  in
                  let t =
                    let desc =
                      let tident = _1 in
                      
# 322 "asllib/Parser0.mly"
                            AST.T_Named                
# 54686 "asllib/Parser0.ml"
                       tident
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 54695 "asllib/Parser0.ml"
                    
                  in
                  
# 669 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 54701 "asllib/Parser0.ml"
                  
                in
                
# 656 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, ldi, Some expr)) )
# 54707 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 54713 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 54722 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 54728 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _2_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = q;
                        MenhirLib.EngineTypes.startp = _startpos_q_;
                        MenhirLib.EngineTypes.endp = _endpos_q_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (
# 82 "asllib/Parser0.mly"
       (string)
# 54802 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _1_inlined1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 54807 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 54813 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let ldi =
                  let (_endpos__1_, _1_inlined1, _1) = (_endpos__1_inlined1_, _1_inlined2, _1_inlined1) in
                  let x = _1_inlined1 in
                  let t =
                    let desc =
                      let tident =
                        let i = _1 in
                        
# 339 "asllib/Parser0.mly"
                                   ( q ^ "_" ^ i )
# 54834 "asllib/Parser0.ml"
                        
                      in
                      
# 322 "asllib/Parser0.mly"
                            AST.T_Named                
# 54840 "asllib/Parser0.ml"
                       tident
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos_q_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 54849 "asllib/Parser0.ml"
                    
                  in
                  
# 669 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 54855 "asllib/Parser0.ml"
                  
                in
                
# 656 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, ldi, Some expr)) )
# 54861 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 54867 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 54876 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 54882 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _2_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = q;
                        MenhirLib.EngineTypes.startp = _startpos_q_;
                        MenhirLib.EngineTypes.endp = _endpos_q_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 54957 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 54963 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let ldi =
                  let (_endpos__1_, _1_inlined1, _1) = (_endpos__1_inlined1_, _1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    
# 344 "asllib/Parser0.mly"
                                         ( "record" )
# 54981 "asllib/Parser0.ml"
                    
                  in
                  let t =
                    let desc =
                      let tident =
                        let i = _1 in
                        
# 339 "asllib/Parser0.mly"
                                   ( q ^ "_" ^ i )
# 54991 "asllib/Parser0.ml"
                        
                      in
                      
# 322 "asllib/Parser0.mly"
                            AST.T_Named                
# 54997 "asllib/Parser0.ml"
                       tident
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos_q_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 55006 "asllib/Parser0.ml"
                    
                  in
                  
# 669 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 55012 "asllib/Parser0.ml"
                  
                in
                
# 656 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, ldi, Some expr)) )
# 55018 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 55024 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 55033 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 55039 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (
# 82 "asllib/Parser0.mly"
       (string)
# 55101 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let ldi =
                  let (_endpos__1_, _startpos__1_, _1_inlined1, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined2, _1_inlined1) in
                  let x = _1_inlined1 in
                  let t =
                    let desc = 
# 323 "asllib/Parser0.mly"
                          ( t_bit                     )
# 55119 "asllib/Parser0.ml"
                     in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 55127 "asllib/Parser0.ml"
                    
                  in
                  
# 669 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 55133 "asllib/Parser0.ml"
                  
                in
                
# 656 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, ldi, Some expr)) )
# 55139 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 55145 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 55154 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 55160 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let ldi =
                  let (_endpos__1_, _startpos__1_, _1_inlined1, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    
# 344 "asllib/Parser0.mly"
                                         ( "record" )
# 55236 "asllib/Parser0.ml"
                    
                  in
                  let t =
                    let desc = 
# 323 "asllib/Parser0.mly"
                          ( t_bit                     )
# 55243 "asllib/Parser0.ml"
                     in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 55251 "asllib/Parser0.ml"
                    
                  in
                  
# 669 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 55257 "asllib/Parser0.ml"
                  
                in
                
# 656 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, ldi, Some expr)) )
# 55263 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 55269 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 55278 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 55284 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = x_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined3 : (
# 82 "asllib/Parser0.mly"
       (string)
# 55364 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let x_inlined1 : (AST.expr) = Obj.magic x_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let ldi =
                  let (_endpos__3_, _startpos__1_, _1_inlined2, _1) = (_endpos__3_inlined1_, _startpos__1_inlined1_, _1_inlined3, _1_inlined1) in
                  let x = _1_inlined2 in
                  let t =
                    let x = x_inlined1 in
                    let desc =
                      let e = 
# 205 "<standard.mly>"
    ( x )
# 55387 "asllib/Parser0.ml"
                       in
                      
# 324 "asllib/Parser0.mly"
                          ( AST.(T_Bits (e, []))      )
# 55392 "asllib/Parser0.ml"
                      
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 55401 "asllib/Parser0.ml"
                    
                  in
                  
# 669 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 55407 "asllib/Parser0.ml"
                  
                in
                
# 656 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, ldi, Some expr)) )
# 55413 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 55419 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 55428 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 55434 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = x_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let x_inlined1 : (AST.expr) = Obj.magic x_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let ldi =
                  let (_endpos__3_, _startpos__1_, _1_inlined2, _1) = (_endpos__3_inlined1_, _startpos__1_inlined1_, _1_inlined3, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined2 in
                    
# 344 "asllib/Parser0.mly"
                                         ( "record" )
# 55531 "asllib/Parser0.ml"
                    
                  in
                  let t =
                    let x = x_inlined1 in
                    let desc =
                      let e = 
# 205 "<standard.mly>"
    ( x )
# 55540 "asllib/Parser0.ml"
                       in
                      
# 324 "asllib/Parser0.mly"
                          ( AST.(T_Bits (e, []))      )
# 55545 "asllib/Parser0.ml"
                      
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 55554 "asllib/Parser0.ml"
                    
                  in
                  
# 669 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 55560 "asllib/Parser0.ml"
                  
                in
                
# 656 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, ldi, Some expr)) )
# 55566 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 55572 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 55581 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 55587 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined5;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined4;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined3;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _3_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = x_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined2;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined1;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _menhir_s;
                                  MenhirLib.EngineTypes.semv = _1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_;
                                  MenhirLib.EngineTypes.next = _menhir_stack;
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined5 : (
# 82 "asllib/Parser0.mly"
       (string)
# 55685 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined5 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _1_inlined4 : (AST.bitfield list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let x_inlined1 : (AST.expr) = Obj.magic x_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let ldi =
                  let (_endpos__3_inlined1_, _startpos__1_, _1_inlined4, _1_inlined3, _1) = (_endpos__3_inlined2_, _startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined1) in
                  let x = _1_inlined4 in
                  let t =
                    let x = x_inlined1 in
                    let desc =
                      let b =
                        let _1_inlined1 = _1_inlined3 in
                        let x = _1_inlined1 in
                        
# 205 "<standard.mly>"
    ( x )
# 55714 "asllib/Parser0.ml"
                        
                      in
                      let e = 
# 205 "<standard.mly>"
    ( x )
# 55720 "asllib/Parser0.ml"
                       in
                      
# 325 "asllib/Parser0.mly"
                                      ( AST.(T_Bits (e, b)) )
# 55725 "asllib/Parser0.ml"
                      
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__3_inlined1_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 55734 "asllib/Parser0.ml"
                    
                  in
                  
# 669 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 55740 "asllib/Parser0.ml"
                  
                in
                
# 656 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, ldi, Some expr)) )
# 55746 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 55752 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 55761 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 55767 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined5;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined4;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined3;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _3_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = x_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined2;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined1;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _menhir_s;
                                  MenhirLib.EngineTypes.semv = _1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_;
                                  MenhirLib.EngineTypes.next = _menhir_stack;
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _1_inlined4 : (AST.bitfield list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let x_inlined1 : (AST.expr) = Obj.magic x_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let ldi =
                  let (_endpos__3_inlined1_, _startpos__1_, _1_inlined4, _1_inlined3, _1) = (_endpos__3_inlined2_, _startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined4 in
                    
# 344 "asllib/Parser0.mly"
                                         ( "record" )
# 55885 "asllib/Parser0.ml"
                    
                  in
                  let t =
                    let x = x_inlined1 in
                    let desc =
                      let b =
                        let _1_inlined1 = _1_inlined3 in
                        let x = _1_inlined1 in
                        
# 205 "<standard.mly>"
    ( x )
# 55897 "asllib/Parser0.ml"
                        
                      in
                      let e = 
# 205 "<standard.mly>"
    ( x )
# 55903 "asllib/Parser0.ml"
                       in
                      
# 325 "asllib/Parser0.mly"
                                      ( AST.(T_Bits (e, b)) )
# 55908 "asllib/Parser0.ml"
                      
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__3_inlined1_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 55917 "asllib/Parser0.ml"
                    
                  in
                  
# 669 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 55923 "asllib/Parser0.ml"
                  
                in
                
# 656 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, ldi, Some expr)) )
# 55929 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 55935 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 55944 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 55950 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = x_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined3 : (
# 82 "asllib/Parser0.mly"
       (string)
# 56030 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let x_inlined1 : (AST.expr) = Obj.magic x_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let ldi =
                  let (_endpos__3_, _startpos__1_, _1_inlined2, _1) = (_endpos__3_inlined1_, _startpos__1_inlined1_, _1_inlined3, _1_inlined1) in
                  let x = _1_inlined2 in
                  let t =
                    let x = x_inlined1 in
                    let desc =
                      let _1 =
                        let _2 = 
# 205 "<standard.mly>"
    ( x )
# 56054 "asllib/Parser0.ml"
                         in
                        ()
                      in
                      
# 265 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 56061 "asllib/Parser0.ml"
                      
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 56070 "asllib/Parser0.ml"
                    
                  in
                  
# 669 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 56076 "asllib/Parser0.ml"
                  
                in
                
# 656 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, ldi, Some expr)) )
# 56082 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 56088 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 56097 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 56103 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = x_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let x_inlined1 : (AST.expr) = Obj.magic x_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let ldi =
                  let (_endpos__3_, _startpos__1_, _1_inlined2, _1) = (_endpos__3_inlined1_, _startpos__1_inlined1_, _1_inlined3, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined2 in
                    
# 344 "asllib/Parser0.mly"
                                         ( "record" )
# 56200 "asllib/Parser0.ml"
                    
                  in
                  let t =
                    let x = x_inlined1 in
                    let desc =
                      let _1 =
                        let _2 = 
# 205 "<standard.mly>"
    ( x )
# 56210 "asllib/Parser0.ml"
                         in
                        ()
                      in
                      
# 265 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 56217 "asllib/Parser0.ml"
                      
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 56226 "asllib/Parser0.ml"
                    
                  in
                  
# 669 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 56232 "asllib/Parser0.ml"
                  
                in
                
# 656 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, ldi, Some expr)) )
# 56238 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 56244 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 56253 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 56259 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined4;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _4;
                    MenhirLib.EngineTypes.startp = _startpos__4_;
                    MenhirLib.EngineTypes.endp = _endpos__4_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined3;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined2;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _menhir_s;
                                MenhirLib.EngineTypes.semv = _1;
                                MenhirLib.EngineTypes.startp = _startpos__1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_;
                                MenhirLib.EngineTypes.next = _menhir_stack;
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined4 : (
# 82 "asllib/Parser0.mly"
       (string)
# 56351 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined4 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined3 : (
# 82 "asllib/Parser0.mly"
       (string)
# 56359 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let ldi =
                  let (_startpos__1_, _1_inlined3, _3, _1_inlined2, _1) = (_startpos__1_inlined1_, _1_inlined4, _3_inlined2, _1_inlined3, _1_inlined1) in
                  let x = _1_inlined3 in
                  let t =
                    let desc =
                      let _1 =
                        let _2 =
                          let _1_inlined1 = _1_inlined2 in
                          let x =
                            let _1 = _1_inlined1 in
                            ()
                          in
                          
# 205 "<standard.mly>"
    ( x )
# 56386 "asllib/Parser0.ml"
                          
                        in
                        ()
                      in
                      
# 265 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 56394 "asllib/Parser0.ml"
                      
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 56403 "asllib/Parser0.ml"
                    
                  in
                  
# 669 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 56409 "asllib/Parser0.ml"
                  
                in
                
# 656 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, ldi, Some expr)) )
# 56415 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 56421 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 56430 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 56436 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined4;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _4;
                    MenhirLib.EngineTypes.startp = _startpos__4_;
                    MenhirLib.EngineTypes.endp = _endpos__4_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined3;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined2;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _menhir_s;
                                MenhirLib.EngineTypes.semv = _1;
                                MenhirLib.EngineTypes.startp = _startpos__1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_;
                                MenhirLib.EngineTypes.next = _menhir_stack;
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined3 : (
# 82 "asllib/Parser0.mly"
       (string)
# 56532 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let ldi =
                  let (_startpos__1_, _1_inlined3, _3, _1_inlined2, _1) = (_startpos__1_inlined1_, _1_inlined4, _3_inlined2, _1_inlined3, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined3 in
                    
# 344 "asllib/Parser0.mly"
                                         ( "record" )
# 56551 "asllib/Parser0.ml"
                    
                  in
                  let t =
                    let desc =
                      let _1 =
                        let _2 =
                          let _1_inlined1 = _1_inlined2 in
                          let x =
                            let _1 = _1_inlined1 in
                            ()
                          in
                          
# 205 "<standard.mly>"
    ( x )
# 56566 "asllib/Parser0.ml"
                          
                        in
                        ()
                      in
                      
# 265 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 56574 "asllib/Parser0.ml"
                      
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 56583 "asllib/Parser0.ml"
                    
                  in
                  
# 669 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 56589 "asllib/Parser0.ml"
                  
                in
                
# 656 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, ldi, Some expr)) )
# 56595 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 56601 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 56610 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 56616 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined4;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _4;
                    MenhirLib.EngineTypes.startp = _startpos__4_;
                    MenhirLib.EngineTypes.endp = _endpos__4_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined3;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _2_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = q;
                              MenhirLib.EngineTypes.startp = _startpos_q_;
                              MenhirLib.EngineTypes.endp = _endpos_q_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined2;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _1_inlined1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _menhir_s;
                                    MenhirLib.EngineTypes.semv = _1;
                                    MenhirLib.EngineTypes.startp = _startpos__1_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_;
                                    MenhirLib.EngineTypes.next = _menhir_stack;
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined4 : (
# 82 "asllib/Parser0.mly"
       (string)
# 56720 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined4 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined3 : (
# 82 "asllib/Parser0.mly"
       (string)
# 56728 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 56734 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let ldi =
                  let (_startpos__1_, _1_inlined3, _3, _1_inlined2, _1) = (_startpos__1_inlined1_, _1_inlined4, _3_inlined2, _1_inlined3, _1_inlined1) in
                  let x = _1_inlined3 in
                  let t =
                    let desc =
                      let _1 =
                        let _2 =
                          let _1_inlined1 = _1_inlined2 in
                          let x =
                            let _1 = _1_inlined1 in
                            let _1 =
                              let i = _1 in
                              
# 339 "asllib/Parser0.mly"
                                   ( q ^ "_" ^ i )
# 56762 "asllib/Parser0.ml"
                              
                            in
                            ()
                          in
                          
# 205 "<standard.mly>"
    ( x )
# 56770 "asllib/Parser0.ml"
                          
                        in
                        ()
                      in
                      
# 265 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 56778 "asllib/Parser0.ml"
                      
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 56787 "asllib/Parser0.ml"
                    
                  in
                  
# 669 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 56793 "asllib/Parser0.ml"
                  
                in
                
# 656 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, ldi, Some expr)) )
# 56799 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 56805 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 56814 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 56820 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined4;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _4;
                    MenhirLib.EngineTypes.startp = _startpos__4_;
                    MenhirLib.EngineTypes.endp = _endpos__4_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined3;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _2_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = q;
                              MenhirLib.EngineTypes.startp = _startpos_q_;
                              MenhirLib.EngineTypes.endp = _endpos_q_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined2;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _1_inlined1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _menhir_s;
                                    MenhirLib.EngineTypes.semv = _1;
                                    MenhirLib.EngineTypes.startp = _startpos__1_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_;
                                    MenhirLib.EngineTypes.next = _menhir_stack;
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined3 : (
# 82 "asllib/Parser0.mly"
       (string)
# 56928 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 56934 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let ldi =
                  let (_startpos__1_, _1_inlined3, _3, _1_inlined2, _1) = (_startpos__1_inlined1_, _1_inlined4, _3_inlined2, _1_inlined3, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined3 in
                    
# 344 "asllib/Parser0.mly"
                                         ( "record" )
# 56954 "asllib/Parser0.ml"
                    
                  in
                  let t =
                    let desc =
                      let _1 =
                        let _2 =
                          let _1_inlined1 = _1_inlined2 in
                          let x =
                            let _1 = _1_inlined1 in
                            let _1 =
                              let i = _1 in
                              
# 339 "asllib/Parser0.mly"
                                   ( q ^ "_" ^ i )
# 56969 "asllib/Parser0.ml"
                              
                            in
                            ()
                          in
                          
# 205 "<standard.mly>"
    ( x )
# 56977 "asllib/Parser0.ml"
                          
                        in
                        ()
                      in
                      
# 265 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 56985 "asllib/Parser0.ml"
                      
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 56994 "asllib/Parser0.ml"
                    
                  in
                  
# 669 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 57000 "asllib/Parser0.ml"
                  
                in
                
# 656 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, ldi, Some expr)) )
# 57006 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 57012 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 57021 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 57027 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined4;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _4;
                    MenhirLib.EngineTypes.startp = _startpos__4_;
                    MenhirLib.EngineTypes.endp = _endpos__4_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3_inlined3;
                      MenhirLib.EngineTypes.startp = _startpos__3_inlined3_;
                      MenhirLib.EngineTypes.endp = _endpos__3_inlined3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _3_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _2_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined3;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined2;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _1_inlined1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _menhir_s;
                                    MenhirLib.EngineTypes.semv = _1;
                                    MenhirLib.EngineTypes.startp = _startpos__1_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_;
                                    MenhirLib.EngineTypes.next = _menhir_stack;
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined4 : (
# 82 "asllib/Parser0.mly"
       (string)
# 57131 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined4 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3_inlined3 : unit = Obj.magic _3_inlined3 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _3_inlined1 : (AST.expr) = Obj.magic _3_inlined1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined3 : (AST.expr) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let ldi =
                  let (_startpos__1_, _1_inlined3, _3, _1_inlined2, _1) = (_startpos__1_inlined1_, _1_inlined4, _3_inlined3, _1_inlined3, _1_inlined1) in
                  let x = _1_inlined3 in
                  let t =
                    let desc =
                      let _1 =
                        let _2 =
                          let _1_inlined1 = _1_inlined2 in
                          let x =
                            let (_3, _1) = (_3_inlined1, _1_inlined1) in
                            ()
                          in
                          
# 205 "<standard.mly>"
    ( x )
# 57165 "asllib/Parser0.ml"
                          
                        in
                        ()
                      in
                      
# 265 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 57173 "asllib/Parser0.ml"
                      
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 57182 "asllib/Parser0.ml"
                    
                  in
                  
# 669 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 57188 "asllib/Parser0.ml"
                  
                in
                
# 656 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, ldi, Some expr)) )
# 57194 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 57200 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 57209 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 57215 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined4;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _4;
                    MenhirLib.EngineTypes.startp = _startpos__4_;
                    MenhirLib.EngineTypes.endp = _endpos__4_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3_inlined3;
                      MenhirLib.EngineTypes.startp = _startpos__3_inlined3_;
                      MenhirLib.EngineTypes.endp = _endpos__3_inlined3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _3_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _2_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined3;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined2;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _1_inlined1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _menhir_s;
                                    MenhirLib.EngineTypes.semv = _1;
                                    MenhirLib.EngineTypes.startp = _startpos__1_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_;
                                    MenhirLib.EngineTypes.next = _menhir_stack;
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3_inlined3 : unit = Obj.magic _3_inlined3 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _3_inlined1 : (AST.expr) = Obj.magic _3_inlined1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined3 : (AST.expr) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let ldi =
                  let (_startpos__1_, _1_inlined3, _3, _1_inlined2, _1) = (_startpos__1_inlined1_, _1_inlined4, _3_inlined3, _1_inlined3, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined3 in
                    
# 344 "asllib/Parser0.mly"
                                         ( "record" )
# 57341 "asllib/Parser0.ml"
                    
                  in
                  let t =
                    let desc =
                      let _1 =
                        let _2 =
                          let _1_inlined1 = _1_inlined2 in
                          let x =
                            let (_3, _1) = (_3_inlined1, _1_inlined1) in
                            ()
                          in
                          
# 205 "<standard.mly>"
    ( x )
# 57356 "asllib/Parser0.ml"
                          
                        in
                        ()
                      in
                      
# 265 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 57364 "asllib/Parser0.ml"
                      
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 57373 "asllib/Parser0.ml"
                    
                  in
                  
# 669 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 57379 "asllib/Parser0.ml"
                  
                in
                
# 656 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, ldi, Some expr)) )
# 57385 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 57391 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 57400 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 57406 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 57462 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let x = _1_inlined1 in
                
# 658 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, LDI_Var x, Some expr)) )
# 57476 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 57482 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 57491 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 57497 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = e;
              MenhirLib.EngineTypes.startp = _startpos_e_;
              MenhirLib.EngineTypes.endp = _endpos_e_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _2_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = h;
                        MenhirLib.EngineTypes.startp = _startpos_h_;
                        MenhirLib.EngineTypes.endp = _endpos_h_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let e : (AST.expr) = Obj.magic e in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (AST.local_decl_item list) = Obj.magic _1_inlined2 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let h : (AST.local_decl_item) = Obj.magic h in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let ldi =
                  let _1_inlined1 = _1_inlined2 in
                  let ldis =
                    let x =
                      let _1 = _1_inlined1 in
                      let t = _1 in
                      
# 301 "asllib/Parser0.mly"
                                           ( h::t )
# 57597 "asllib/Parser0.ml"
                      
                    in
                    
# 205 "<standard.mly>"
    ( x )
# 57603 "asllib/Parser0.ml"
                    
                  in
                  
# 691 "asllib/Parser0.mly"
                                           ( AST.LDI_Tuple ldis )
# 57609 "asllib/Parser0.ml"
                  
                in
                
# 660 "asllib/Parser0.mly"
        ( AST.S_Decl (LDK_Let, ldi, Some e) )
# 57615 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 57621 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 57630 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 57636 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = _1;
                MenhirLib.EngineTypes.startp = _startpos__1_;
                MenhirLib.EngineTypes.endp = _endpos__1_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (string list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let li = _1_inlined1 in
                let t =
                  let desc = 
# 319 "asllib/Parser0.mly"
                          ( AST.(T_Int UnConstrained) )
# 57689 "asllib/Parser0.ml"
                   in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 57697 "asllib/Parser0.ml"
                  
                in
                
# 661 "asllib/Parser0.mly"
                                                       make_ldi_vars  
# 57703 "asllib/Parser0.ml"
                 (t, li)
              in
              
# 196 "<standard.mly>"
    ( x )
# 57709 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 57718 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 57724 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = _1;
                MenhirLib.EngineTypes.startp = _startpos__1_;
                MenhirLib.EngineTypes.endp = _endpos__1_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (string list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let li = _1_inlined1 in
                let t =
                  let desc = 
# 320 "asllib/Parser0.mly"
                          ( AST.T_Real                )
# 57777 "asllib/Parser0.ml"
                   in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 57785 "asllib/Parser0.ml"
                  
                in
                
# 661 "asllib/Parser0.mly"
                                                       make_ldi_vars  
# 57791 "asllib/Parser0.ml"
                 (t, li)
              in
              
# 196 "<standard.mly>"
    ( x )
# 57797 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 57806 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 57812 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = _1;
                MenhirLib.EngineTypes.startp = _startpos__1_;
                MenhirLib.EngineTypes.endp = _endpos__1_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (string list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let li = _1_inlined1 in
                let t =
                  let desc = 
# 321 "asllib/Parser0.mly"
                          ( AST.T_Bool                )
# 57865 "asllib/Parser0.ml"
                   in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 57873 "asllib/Parser0.ml"
                  
                in
                
# 661 "asllib/Parser0.mly"
                                                       make_ldi_vars  
# 57879 "asllib/Parser0.ml"
                 (t, li)
              in
              
# 196 "<standard.mly>"
    ( x )
# 57885 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 57894 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 57900 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = _1;
                MenhirLib.EngineTypes.startp = _startpos__1_;
                MenhirLib.EngineTypes.endp = _endpos__1_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (string list) = Obj.magic _1_inlined1 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 57943 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let li = _1_inlined1 in
                let t =
                  let desc =
                    let tident = _1 in
                    
# 322 "asllib/Parser0.mly"
                            AST.T_Named                
# 57959 "asllib/Parser0.ml"
                     tident
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 57968 "asllib/Parser0.ml"
                  
                in
                
# 661 "asllib/Parser0.mly"
                                                       make_ldi_vars  
# 57974 "asllib/Parser0.ml"
                 (t, li)
              in
              
# 196 "<standard.mly>"
    ( x )
# 57980 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 57989 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 57995 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1;
                MenhirLib.EngineTypes.startp = _startpos__1_;
                MenhirLib.EngineTypes.endp = _endpos__1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _2_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = q;
                    MenhirLib.EngineTypes.startp = _startpos_q_;
                    MenhirLib.EngineTypes.endp = _endpos_q_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (string list) = Obj.magic _1_inlined1 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 58050 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 58056 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let li = _1_inlined1 in
                let t =
                  let desc =
                    let tident =
                      let i = _1 in
                      
# 339 "asllib/Parser0.mly"
                                   ( q ^ "_" ^ i )
# 58074 "asllib/Parser0.ml"
                      
                    in
                    
# 322 "asllib/Parser0.mly"
                            AST.T_Named                
# 58080 "asllib/Parser0.ml"
                     tident
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos_q_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 58089 "asllib/Parser0.ml"
                  
                in
                
# 661 "asllib/Parser0.mly"
                                                       make_ldi_vars  
# 58095 "asllib/Parser0.ml"
                 (t, li)
              in
              
# 196 "<standard.mly>"
    ( x )
# 58101 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos_q_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 58110 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 58116 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = _1;
                MenhirLib.EngineTypes.startp = _startpos__1_;
                MenhirLib.EngineTypes.endp = _endpos__1_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (string list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let li = _1_inlined1 in
                let t =
                  let desc = 
# 323 "asllib/Parser0.mly"
                          ( t_bit                     )
# 58169 "asllib/Parser0.ml"
                   in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 58177 "asllib/Parser0.ml"
                  
                in
                
# 661 "asllib/Parser0.mly"
                                                       make_ldi_vars  
# 58183 "asllib/Parser0.ml"
                 (t, li)
              in
              
# 196 "<standard.mly>"
    ( x )
# 58189 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 58198 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 58204 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = x;
                  MenhirLib.EngineTypes.startp = _startpos_x_;
                  MenhirLib.EngineTypes.endp = _endpos_x_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined2 : (string list) = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let x : (AST.expr) = Obj.magic x in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let li = _1_inlined2 in
                let t =
                  let desc =
                    let e = 
# 205 "<standard.mly>"
    ( x )
# 58279 "asllib/Parser0.ml"
                     in
                    
# 324 "asllib/Parser0.mly"
                          ( AST.(T_Bits (e, []))      )
# 58284 "asllib/Parser0.ml"
                    
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 58293 "asllib/Parser0.ml"
                  
                in
                
# 661 "asllib/Parser0.mly"
                                                       make_ldi_vars  
# 58299 "asllib/Parser0.ml"
                 (t, li)
              in
              
# 196 "<standard.mly>"
    ( x )
# 58305 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 58314 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 58320 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3;
                      MenhirLib.EngineTypes.startp = _startpos__3_;
                      MenhirLib.EngineTypes.endp = _endpos__3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = x;
                        MenhirLib.EngineTypes.startp = _startpos_x_;
                        MenhirLib.EngineTypes.endp = _endpos_x_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined4 : (string list) = Obj.magic _1_inlined4 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined3 : (AST.bitfield list) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let x : (AST.expr) = Obj.magic x in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let li = _1_inlined4 in
                let t =
                  let desc =
                    let b =
                      let _1_inlined1 = _1_inlined3 in
                      let x = _1_inlined1 in
                      
# 205 "<standard.mly>"
    ( x )
# 58419 "asllib/Parser0.ml"
                      
                    in
                    let e = 
# 205 "<standard.mly>"
    ( x )
# 58425 "asllib/Parser0.ml"
                     in
                    
# 325 "asllib/Parser0.mly"
                                      ( AST.(T_Bits (e, b)) )
# 58430 "asllib/Parser0.ml"
                    
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__3_inlined1_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 58439 "asllib/Parser0.ml"
                  
                in
                
# 661 "asllib/Parser0.mly"
                                                       make_ldi_vars  
# 58445 "asllib/Parser0.ml"
                 (t, li)
              in
              
# 196 "<standard.mly>"
    ( x )
# 58451 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 58460 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 58466 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = x;
                  MenhirLib.EngineTypes.startp = _startpos_x_;
                  MenhirLib.EngineTypes.endp = _endpos_x_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined2 : (string list) = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let x : (AST.expr) = Obj.magic x in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let li = _1_inlined2 in
                let t =
                  let desc =
                    let _1 =
                      let _2 = 
# 205 "<standard.mly>"
    ( x )
# 58542 "asllib/Parser0.ml"
                       in
                      ()
                    in
                    
# 265 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 58549 "asllib/Parser0.ml"
                    
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 58558 "asllib/Parser0.ml"
                  
                in
                
# 661 "asllib/Parser0.mly"
                                                       make_ldi_vars  
# 58564 "asllib/Parser0.ml"
                 (t, li)
              in
              
# 196 "<standard.mly>"
    ( x )
# 58570 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 58579 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 58585 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _4;
                MenhirLib.EngineTypes.startp = _startpos__4_;
                MenhirLib.EngineTypes.endp = _endpos__4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined3 : (string list) = Obj.magic _1_inlined3 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (
# 82 "asllib/Parser0.mly"
       (string)
# 58661 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let li = _1_inlined3 in
                let t =
                  let desc =
                    let _1 =
                      let _2 =
                        let _1_inlined1 = _1_inlined2 in
                        let x =
                          let _1 = _1_inlined1 in
                          ()
                        in
                        
# 205 "<standard.mly>"
    ( x )
# 58685 "asllib/Parser0.ml"
                        
                      in
                      ()
                    in
                    
# 265 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 58693 "asllib/Parser0.ml"
                    
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 58702 "asllib/Parser0.ml"
                  
                in
                
# 661 "asllib/Parser0.mly"
                                                       make_ldi_vars  
# 58708 "asllib/Parser0.ml"
                 (t, li)
              in
              
# 196 "<standard.mly>"
    ( x )
# 58714 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 58723 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 58729 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _4;
                MenhirLib.EngineTypes.startp = _startpos__4_;
                MenhirLib.EngineTypes.endp = _endpos__4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _2_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = q;
                          MenhirLib.EngineTypes.startp = _startpos_q_;
                          MenhirLib.EngineTypes.endp = _endpos_q_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = _1;
                              MenhirLib.EngineTypes.startp = _startpos__1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined3 : (string list) = Obj.magic _1_inlined3 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (
# 82 "asllib/Parser0.mly"
       (string)
# 58817 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 58823 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let li = _1_inlined3 in
                let t =
                  let desc =
                    let _1 =
                      let _2 =
                        let _1_inlined1 = _1_inlined2 in
                        let x =
                          let _1 = _1_inlined1 in
                          let _1 =
                            let i = _1 in
                            
# 339 "asllib/Parser0.mly"
                                   ( q ^ "_" ^ i )
# 58848 "asllib/Parser0.ml"
                            
                          in
                          ()
                        in
                        
# 205 "<standard.mly>"
    ( x )
# 58856 "asllib/Parser0.ml"
                        
                      in
                      ()
                    in
                    
# 265 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 58864 "asllib/Parser0.ml"
                    
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 58873 "asllib/Parser0.ml"
                  
                in
                
# 661 "asllib/Parser0.mly"
                                                       make_ldi_vars  
# 58879 "asllib/Parser0.ml"
                 (t, li)
              in
              
# 196 "<standard.mly>"
    ( x )
# 58885 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 58894 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 58900 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _4;
                MenhirLib.EngineTypes.startp = _startpos__4_;
                MenhirLib.EngineTypes.endp = _endpos__4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _2_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined2;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = _1;
                              MenhirLib.EngineTypes.startp = _startpos__1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined3 : (string list) = Obj.magic _1_inlined3 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _3_inlined1 : (AST.expr) = Obj.magic _3_inlined1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined2 : (AST.expr) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let li = _1_inlined3 in
                let t =
                  let desc =
                    let _1 =
                      let _2 =
                        let _1_inlined1 = _1_inlined2 in
                        let x =
                          let (_3, _1) = (_3_inlined1, _1_inlined1) in
                          ()
                        in
                        
# 205 "<standard.mly>"
    ( x )
# 59011 "asllib/Parser0.ml"
                        
                      in
                      ()
                    in
                    
# 265 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 59019 "asllib/Parser0.ml"
                    
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 59028 "asllib/Parser0.ml"
                  
                in
                
# 661 "asllib/Parser0.mly"
                                                       make_ldi_vars  
# 59034 "asllib/Parser0.ml"
                 (t, li)
              in
              
# 196 "<standard.mly>"
    ( x )
# 59040 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 59049 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 59055 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _2_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = q;
                      MenhirLib.EngineTypes.startp = _startpos_q_;
                      MenhirLib.EngineTypes.endp = _endpos_q_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 59117 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 59123 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let params = 
# 352 "asllib/Parser0.mly"
             ( [] )
# 59136 "asllib/Parser0.ml"
                 in
                let args =
                  let x = 
# 298 "asllib/Parser0.mly"
                ( [] )
# 59142 "asllib/Parser0.ml"
                   in
                  
# 205 "<standard.mly>"
    ( x )
# 59147 "asllib/Parser0.ml"
                  
                in
                let name =
                  let i = _1 in
                  
# 347 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 59155 "asllib/Parser0.ml"
                  
                in
                
# 631 "asllib/Parser0.mly"
      ( AST.S_Call { name; args; params ; call_type = ST_Procedure } )
# 59161 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 59167 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos_q_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 59176 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 59182 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _2_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = q;
                        MenhirLib.EngineTypes.startp = _startpos_q_;
                        MenhirLib.EngineTypes.endp = _endpos_q_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (AST.expr list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 59251 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 59257 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let params = 
# 352 "asllib/Parser0.mly"
             ( [] )
# 59270 "asllib/Parser0.ml"
                 in
                let args =
                  let _1_inlined1 = _1_inlined2 in
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 59278 "asllib/Parser0.ml"
                  
                in
                let name =
                  let i = _1 in
                  
# 347 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 59286 "asllib/Parser0.ml"
                  
                in
                
# 631 "asllib/Parser0.mly"
      ( AST.S_Call { name; args; params ; call_type = ST_Procedure } )
# 59292 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 59298 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos_q_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 59307 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 59313 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 59363 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let params = 
# 352 "asllib/Parser0.mly"
             ( [] )
# 59375 "asllib/Parser0.ml"
                 in
                let args =
                  let x = 
# 298 "asllib/Parser0.mly"
                ( [] )
# 59381 "asllib/Parser0.ml"
                   in
                  
# 205 "<standard.mly>"
    ( x )
# 59386 "asllib/Parser0.ml"
                  
                in
                let name = _1 in
                
# 631 "asllib/Parser0.mly"
      ( AST.S_Call { name; args; params ; call_type = ST_Procedure } )
# 59393 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 59399 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 59408 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 59414 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (AST.expr list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 59471 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let params = 
# 352 "asllib/Parser0.mly"
             ( [] )
# 59483 "asllib/Parser0.ml"
                 in
                let args =
                  let _1_inlined1 = _1_inlined2 in
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 59491 "asllib/Parser0.ml"
                  
                in
                let name = _1 in
                
# 631 "asllib/Parser0.mly"
      ( AST.S_Call { name; args; params ; call_type = ST_Procedure } )
# 59498 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 59504 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 59513 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 59519 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let params = 
# 352 "asllib/Parser0.mly"
             ( [] )
# 59577 "asllib/Parser0.ml"
                 in
                let args =
                  let x = 
# 298 "asllib/Parser0.mly"
                ( [] )
# 59583 "asllib/Parser0.ml"
                   in
                  
# 205 "<standard.mly>"
    ( x )
# 59588 "asllib/Parser0.ml"
                  
                in
                let name = 
# 349 "asllib/Parser0.mly"
              ( "record" )
# 59594 "asllib/Parser0.ml"
                 in
                
# 631 "asllib/Parser0.mly"
      ( AST.S_Call { name; args; params ; call_type = ST_Procedure } )
# 59599 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 59605 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 59614 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 59620 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (AST.expr list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let params = 
# 352 "asllib/Parser0.mly"
             ( [] )
# 59685 "asllib/Parser0.ml"
                 in
                let args =
                  let _1_inlined1 = _1_inlined2 in
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 59693 "asllib/Parser0.ml"
                  
                in
                let name = 
# 349 "asllib/Parser0.mly"
              ( "record" )
# 59699 "asllib/Parser0.ml"
                 in
                
# 631 "asllib/Parser0.mly"
      ( AST.S_Call { name; args; params ; call_type = ST_Procedure } )
# 59704 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 59710 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 59719 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 59725 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = 
# 123 "<standard.mly>"
    ( None )
# 59769 "asllib/Parser0.ml"
                 in
                let _2_1 = _2 in
                
# 632 "asllib/Parser0.mly"
                                                    AST.S_Return  
# 59775 "asllib/Parser0.ml"
                 _2_1
              in
              
# 196 "<standard.mly>"
    ( x )
# 59781 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 59790 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 59796 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = x;
              MenhirLib.EngineTypes.startp = _startpos_x_;
              MenhirLib.EngineTypes.endp = _endpos_x_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = _1;
                MenhirLib.EngineTypes.startp = _startpos__1_;
                MenhirLib.EngineTypes.endp = _endpos__1_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let x : (AST.expr) = Obj.magic x in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = 
# 126 "<standard.mly>"
    ( Some x )
# 59847 "asllib/Parser0.ml"
                 in
                let _2_1 = _2 in
                
# 632 "asllib/Parser0.mly"
                                                    AST.S_Return  
# 59853 "asllib/Parser0.ml"
                 _2_1
              in
              
# 196 "<standard.mly>"
    ( x )
# 59859 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 59868 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 59874 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = _1;
                MenhirLib.EngineTypes.startp = _startpos__1_;
                MenhirLib.EngineTypes.endp = _endpos__1_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x = 
# 633 "asllib/Parser0.mly"
                                                    AST.S_Assert  
# 59924 "asllib/Parser0.ml"
               expr in
              
# 196 "<standard.mly>"
    ( x )
# 59929 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 59938 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 59944 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = e;
              MenhirLib.EngineTypes.startp = _startpos_e_;
              MenhirLib.EngineTypes.endp = _endpos_e_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = _1;
                MenhirLib.EngineTypes.startp = _startpos__1_;
                MenhirLib.EngineTypes.endp = _endpos__1_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let e : (AST.expr) = Obj.magic e in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x = 
# 634 "asllib/Parser0.mly"
                                                  ( AST.S_Print { args = [ e ]; debug = true } )
# 59994 "asllib/Parser0.ml"
               in
              
# 196 "<standard.mly>"
    ( x )
# 59999 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 60008 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 60014 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _1 =
                  let _2 = 
# 123 "<standard.mly>"
    ( None )
# 60059 "asllib/Parser0.ml"
                   in
                  ()
                in
                
# 612 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 60066 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 60072 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 60081 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 60087 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _1 =
                  let _2 =
                    let x =
                      let x = () in
                      
# 205 "<standard.mly>"
    ( x )
# 60149 "asllib/Parser0.ml"
                      
                    in
                    
# 126 "<standard.mly>"
    ( Some x )
# 60155 "asllib/Parser0.ml"
                    
                  in
                  ()
                in
                
# 612 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 60163 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 60169 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 60178 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 60184 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _1 = () in
                
# 612 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 60229 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 60235 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 60244 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 60250 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (
# 82 "asllib/Parser0.mly"
       (string)
# 60305 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _1 =
                  let _2 =
                    let _1_inlined1 = _1_inlined2 in
                    let x = _1_inlined1 in
                    
# 205 "<standard.mly>"
    ( x )
# 60323 "asllib/Parser0.ml"
                    
                  in
                  ()
                in
                
# 612 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 60331 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 60337 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 60346 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 60352 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _1 =
                  let _2 = 
# 123 "<standard.mly>"
    ( None )
# 60397 "asllib/Parser0.ml"
                   in
                  ()
                in
                
# 612 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 60404 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 60410 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 60419 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 60425 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _1 =
                  let _2 =
                    let x =
                      let x = () in
                      
# 205 "<standard.mly>"
    ( x )
# 60487 "asllib/Parser0.ml"
                      
                    in
                    
# 126 "<standard.mly>"
    ( Some x )
# 60493 "asllib/Parser0.ml"
                    
                  in
                  ()
                in
                
# 612 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 60501 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 60507 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 60516 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 60522 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _1 =
                  let _2 = 
# 123 "<standard.mly>"
    ( None )
# 60567 "asllib/Parser0.ml"
                   in
                  ()
                in
                
# 612 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 60574 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 60580 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 60589 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 60595 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = x;
              MenhirLib.EngineTypes.startp = _startpos_x_;
              MenhirLib.EngineTypes.endp = _endpos_x_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = _1;
                MenhirLib.EngineTypes.startp = _startpos__1_;
                MenhirLib.EngineTypes.endp = _endpos__1_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let x : (
# 82 "asllib/Parser0.mly"
       (string)
# 60637 "asllib/Parser0.ml"
        ) = Obj.magic x in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _1 =
                  let _2 = 
# 126 "<standard.mly>"
    ( Some x )
# 60651 "asllib/Parser0.ml"
                   in
                  ()
                in
                
# 612 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 60658 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 60664 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 60673 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 60679 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = x;
                MenhirLib.EngineTypes.startp = _startpos_x_;
                MenhirLib.EngineTypes.endp = _endpos_x_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _3 : unit = Obj.magic _3 in
        let x : (AST.expr) = Obj.magic x in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _1 =
                  let _2 = 
# 205 "<standard.mly>"
    ( x )
# 60745 "asllib/Parser0.ml"
                   in
                  ()
                in
                
# 612 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 60752 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 60758 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 60767 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 60773 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = _1;
                MenhirLib.EngineTypes.startp = _startpos__1_;
                MenhirLib.EngineTypes.endp = _endpos__1_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _2_inlined1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 60815 "asllib/Parser0.ml"
        ) = Obj.magic _2_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let _1 = () in
                
# 612 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 60830 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 60836 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 60845 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 60851 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = _1;
                MenhirLib.EngineTypes.startp = _startpos__1_;
                MenhirLib.EngineTypes.endp = _endpos__1_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 60893 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _1 =
                  let _2 = _1_inlined1 in
                  ()
                in
                
# 612 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 60910 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 60916 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 60925 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 60931 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = _1;
                MenhirLib.EngineTypes.startp = _startpos__1_;
                MenhirLib.EngineTypes.endp = _endpos__1_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 60973 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _1 =
                  let _2 = _1_inlined1 in
                  ()
                in
                
# 612 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 60990 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 60996 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 61005 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 61011 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _6;
          MenhirLib.EngineTypes.startp = _startpos__6_;
          MenhirLib.EngineTypes.endp = _endpos__6_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined3;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = expr;
                  MenhirLib.EngineTypes.startp = _startpos_expr_;
                  MenhirLib.EngineTypes.endp = _endpos_expr_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined3 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined3 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (AST.stmt list) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__6_ in
        let _v =
          let x =
            let desc =
              let simple_if_stmt =
                let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_else_opt =
                    let _1 = _1_inlined2 in
                    let _2 = 
# 123 "<standard.mly>"
    ( None )
# 61087 "asllib/Parser0.ml"
                     in
                    let _1_1 = _1 in
                    let _2_1 = _2 in
                    
# 698 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 61094 "asllib/Parser0.ml"
                     (_1_1, _2_1)
                  in
                  let simple_stmt_list =
                    let _1 = _1_inlined1 in
                    let _1_1 = _1 in
                    
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 61103 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 695 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 61109 "asllib/Parser0.ml"
                   (expr, simple_stmt_list, simple_else_opt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 61118 "asllib/Parser0.ml"
                
              in
              let simple_stmt_list =
                let _1_1 = _1 in
                
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 61126 "asllib/Parser0.ml"
                 _1_1
              in
              
# 621 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 61132 "asllib/Parser0.ml"
               (simple_stmt_list, simple_if_stmt)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 61141 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 61147 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _6;
          MenhirLib.EngineTypes.startp = _startpos__6_;
          MenhirLib.EngineTypes.endp = _endpos__6_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined5;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = expr;
                      MenhirLib.EngineTypes.startp = _startpos_expr_;
                      MenhirLib.EngineTypes.endp = _endpos_expr_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined5 : (AST.stmt list) = Obj.magic _1_inlined5 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _1_inlined3 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined3 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (AST.stmt list) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__6_ in
        let _v =
          let x =
            let desc =
              let simple_if_stmt =
                let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_else_opt =
                    let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                    let _2 =
                      let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                      let x =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 61242 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 126 "<standard.mly>"
    ( Some x )
# 61248 "asllib/Parser0.ml"
                      
                    in
                    let _1_1 = _1 in
                    let _2_1 = _2 in
                    
# 698 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 61256 "asllib/Parser0.ml"
                     (_1_1, _2_1)
                  in
                  let simple_stmt_list =
                    let _1 = _1_inlined1 in
                    let _1_1 = _1 in
                    
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 61265 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 695 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 61271 "asllib/Parser0.ml"
                   (expr, simple_stmt_list, simple_else_opt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 61280 "asllib/Parser0.ml"
                
              in
              let simple_stmt_list =
                let _1_1 = _1 in
                
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 61288 "asllib/Parser0.ml"
                 _1_1
              in
              
# 621 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 61294 "asllib/Parser0.ml"
               (simple_stmt_list, simple_if_stmt)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 61303 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 61309 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1 : (AST.stmt list) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let x =
              let _1_1 = _1 in
              
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 61346 "asllib/Parser0.ml"
               _1_1
            in
            
# 196 "<standard.mly>"
    ( x )
# 61352 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 61358 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _1_inlined3;
          MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
          MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = expr;
                      MenhirLib.EngineTypes.startp = _startpos_expr_;
                      MenhirLib.EngineTypes.endp = _endpos_expr_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _1_inlined3 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined3 in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_inlined3_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let _1 = _1_inlined3 in
                let _2 = 
# 123 "<standard.mly>"
    ( None )
# 61438 "asllib/Parser0.ml"
                 in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 718 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 61445 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 604 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 61455 "asllib/Parser0.ml"
                 _3_1
              in
              
# 713 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 61461 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined3_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 61470 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 61476 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _4_inlined1;
          MenhirLib.EngineTypes.startp = _startpos__4_inlined1_;
          MenhirLib.EngineTypes.endp = _endpos__4_inlined1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined6;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined5;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined4;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined3;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _4;
                      MenhirLib.EngineTypes.startp = _startpos__4_;
                      MenhirLib.EngineTypes.endp = _endpos__4_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _2;
                          MenhirLib.EngineTypes.startp = _startpos__2_;
                          MenhirLib.EngineTypes.endp = _endpos__2_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _3;
                              MenhirLib.EngineTypes.startp = _startpos__3_;
                              MenhirLib.EngineTypes.endp = _endpos__3_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = expr;
                                MenhirLib.EngineTypes.startp = _startpos_expr_;
                                MenhirLib.EngineTypes.endp = _endpos_expr_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _menhir_s;
                                  MenhirLib.EngineTypes.semv = _1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_;
                                  MenhirLib.EngineTypes.next = _menhir_stack;
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _4_inlined1 : unit = Obj.magic _4_inlined1 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _1_inlined3 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined3 in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__4_inlined1_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_4, _1_inlined3, _2, _1_inlined2, _1_inlined1, _1) = (_4_inlined1, _1_inlined6, _2_inlined1, _1_inlined5, _1_inlined4, _1_inlined3) in
                let _2 =
                  let (_1_inlined2, _1_inlined1, _1) = (_1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                    let _3 = _1_inlined1 in
                    let _3_1 = _3 in
                    
# 604 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 61597 "asllib/Parser0.ml"
                     _3_1
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 61603 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 718 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 61611 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 604 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 61621 "asllib/Parser0.ml"
                 _3_1
              in
              
# 713 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 61627 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__4_inlined1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 61636 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 61642 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _6;
          MenhirLib.EngineTypes.startp = _startpos__6_;
          MenhirLib.EngineTypes.endp = _endpos__6_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined8;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined7;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = expr_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined6;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined5;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined4;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined3;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _4;
                            MenhirLib.EngineTypes.startp = _startpos__4_;
                            MenhirLib.EngineTypes.endp = _endpos__4_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined2;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _2;
                                MenhirLib.EngineTypes.startp = _startpos__2_;
                                MenhirLib.EngineTypes.endp = _endpos__2_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _1_inlined1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _3;
                                    MenhirLib.EngineTypes.startp = _startpos__3_;
                                    MenhirLib.EngineTypes.endp = _endpos__3_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = expr;
                                      MenhirLib.EngineTypes.startp = _startpos_expr_;
                                      MenhirLib.EngineTypes.endp = _endpos_expr_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _menhir_s;
                                        MenhirLib.EngineTypes.semv = _1;
                                        MenhirLib.EngineTypes.startp = _startpos__1_;
                                        MenhirLib.EngineTypes.endp = _endpos__1_;
                                        MenhirLib.EngineTypes.next = _menhir_stack;
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined8 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined8 in
        let _1_inlined7 : (AST.stmt list) = Obj.magic _1_inlined7 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined6 : unit = Obj.magic _1_inlined6 in
        let _1_inlined5 : (AST.stmt list) = Obj.magic _1_inlined5 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _1_inlined3 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined3 in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__6_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined5, _1_inlined4, _3, expr, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined6_, _startpos__1_inlined5_, _1_inlined8, _1_inlined7, _3_inlined1, expr_inlined1, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3) in
                let _2 =
                  let (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_if_stmt =
                        let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                        let desc =
                          let simple_else_opt =
                            let _1 = _1_inlined2 in
                            let _2 = 
# 123 "<standard.mly>"
    ( None )
# 61788 "asllib/Parser0.ml"
                             in
                            let _1_1 = _1 in
                            let _2_1 = _2 in
                            
# 698 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 61795 "asllib/Parser0.ml"
                             (_1_1, _2_1)
                          in
                          let simple_stmt_list =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 61804 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 695 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 61810 "asllib/Parser0.ml"
                           (expr, simple_stmt_list, simple_else_opt)
                        in
                        let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                        let _endpos = _endpos_desc_ in
                        let _symbolstartpos = _startpos_desc_ in
                        
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 61819 "asllib/Parser0.ml"
                        
                      in
                      let simple_stmt_list =
                        let _1_1 = _1 in
                        
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 61827 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 621 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 61833 "asllib/Parser0.ml"
                       (simple_stmt_list, simple_if_stmt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 61842 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 61848 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 718 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 61856 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 604 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 61866 "asllib/Parser0.ml"
                 _3_1
              in
              
# 713 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 61872 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 61881 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 61887 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _6;
          MenhirLib.EngineTypes.startp = _startpos__6_;
          MenhirLib.EngineTypes.endp = _endpos__6_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined10;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined10_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined10_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined9;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined9_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined9_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined8;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined7;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = expr_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined6;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined5;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined4;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined3;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _4;
                                MenhirLib.EngineTypes.startp = _startpos__4_;
                                MenhirLib.EngineTypes.endp = _endpos__4_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _1_inlined2;
                                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _2;
                                    MenhirLib.EngineTypes.startp = _startpos__2_;
                                    MenhirLib.EngineTypes.endp = _endpos__2_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = _1_inlined1;
                                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _;
                                        MenhirLib.EngineTypes.semv = _3;
                                        MenhirLib.EngineTypes.startp = _startpos__3_;
                                        MenhirLib.EngineTypes.endp = _endpos__3_;
                                        MenhirLib.EngineTypes.next = {
                                          MenhirLib.EngineTypes.state = _;
                                          MenhirLib.EngineTypes.semv = expr;
                                          MenhirLib.EngineTypes.startp = _startpos_expr_;
                                          MenhirLib.EngineTypes.endp = _endpos_expr_;
                                          MenhirLib.EngineTypes.next = {
                                            MenhirLib.EngineTypes.state = _menhir_s;
                                            MenhirLib.EngineTypes.semv = _1;
                                            MenhirLib.EngineTypes.startp = _startpos__1_;
                                            MenhirLib.EngineTypes.endp = _endpos__1_;
                                            MenhirLib.EngineTypes.next = _menhir_stack;
                                          };
                                        };
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined10 : (AST.stmt list) = Obj.magic _1_inlined10 in
        let _1_inlined9 : unit = Obj.magic _1_inlined9 in
        let _1_inlined8 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined8 in
        let _1_inlined7 : (AST.stmt list) = Obj.magic _1_inlined7 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined6 : unit = Obj.magic _1_inlined6 in
        let _1_inlined5 : (AST.stmt list) = Obj.magic _1_inlined5 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _1_inlined3 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined3 in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__6_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined7, _1_inlined6, _1_inlined5, _1_inlined4, _3, expr, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined6_, _startpos__1_inlined5_, _1_inlined10, _1_inlined9, _1_inlined8, _1_inlined7, _3_inlined1, expr_inlined1, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3) in
                let _2 =
                  let (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined7, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_if_stmt =
                        let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                        let desc =
                          let simple_else_opt =
                            let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                            let _2 =
                              let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                              let x =
                                let _1 = _1_inlined1 in
                                let _1_1 = _1 in
                                
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 62052 "asllib/Parser0.ml"
                                 _1_1
                              in
                              
# 126 "<standard.mly>"
    ( Some x )
# 62058 "asllib/Parser0.ml"
                              
                            in
                            let _1_1 = _1 in
                            let _2_1 = _2 in
                            
# 698 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 62066 "asllib/Parser0.ml"
                             (_1_1, _2_1)
                          in
                          let simple_stmt_list =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 62075 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 695 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 62081 "asllib/Parser0.ml"
                           (expr, simple_stmt_list, simple_else_opt)
                        in
                        let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                        let _endpos = _endpos_desc_ in
                        let _symbolstartpos = _startpos_desc_ in
                        
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 62090 "asllib/Parser0.ml"
                        
                      in
                      let simple_stmt_list =
                        let _1_1 = _1 in
                        
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 62098 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 621 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 62104 "asllib/Parser0.ml"
                       (simple_stmt_list, simple_if_stmt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 62113 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 62119 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 718 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 62127 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 604 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 62137 "asllib/Parser0.ml"
                 _3_1
              in
              
# 713 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 62143 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 62152 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 62158 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2_inlined1;
          MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
          MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined5;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _4;
                  MenhirLib.EngineTypes.startp = _startpos__4_;
                  MenhirLib.EngineTypes.endp = _endpos__4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _2;
                      MenhirLib.EngineTypes.startp = _startpos__2_;
                      MenhirLib.EngineTypes.endp = _endpos__2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _3;
                          MenhirLib.EngineTypes.startp = _startpos__3_;
                          MenhirLib.EngineTypes.endp = _endpos__3_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = expr;
                            MenhirLib.EngineTypes.startp = _startpos_expr_;
                            MenhirLib.EngineTypes.endp = _endpos_expr_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = _1;
                              MenhirLib.EngineTypes.startp = _startpos__1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined5 : (AST.stmt list) = Obj.magic _1_inlined5 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _1_inlined3 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined3 in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_inlined1_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined2, _1_inlined1, _1) = (_1_inlined5, _1_inlined4, _1_inlined3) in
                let _2 =
                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    let x =
                      let _1_1 = _1 in
                      
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 62265 "asllib/Parser0.ml"
                       _1_1
                    in
                    
# 196 "<standard.mly>"
    ( x )
# 62271 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 62277 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 718 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 62285 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 604 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 62295 "asllib/Parser0.ml"
                 _3_1
              in
              
# 713 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 62301 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_inlined1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 62310 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 62316 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _1_inlined5;
          MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
          MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined4;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _4;
                MenhirLib.EngineTypes.startp = _startpos__4_;
                MenhirLib.EngineTypes.endp = _endpos__4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _2;
                    MenhirLib.EngineTypes.startp = _startpos__2_;
                    MenhirLib.EngineTypes.endp = _endpos__2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3;
                        MenhirLib.EngineTypes.startp = _startpos__3_;
                        MenhirLib.EngineTypes.endp = _endpos__3_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = expr;
                          MenhirLib.EngineTypes.startp = _startpos_expr_;
                          MenhirLib.EngineTypes.endp = _endpos_expr_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _1_inlined3 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined3 in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_inlined5_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined2, _1_inlined1, _1) = (_1_inlined5, _1_inlined4, _1_inlined3) in
                let _2 =
                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    
# 597 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 62414 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 62420 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 718 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 62428 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 604 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 62438 "asllib/Parser0.ml"
                 _3_1
              in
              
# 713 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 62444 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined5_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 62453 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 62459 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _1_inlined5;
          MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
          MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = expr_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _3;
                          MenhirLib.EngineTypes.startp = _startpos__3_;
                          MenhirLib.EngineTypes.endp = _endpos__3_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = expr;
                            MenhirLib.EngineTypes.startp = _startpos_expr_;
                            MenhirLib.EngineTypes.endp = _endpos_expr_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = _1;
                              MenhirLib.EngineTypes.startp = _startpos__1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _1_inlined5 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined5 in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_inlined5_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let _1 = _1_inlined5 in
                let _2 = 
# 123 "<standard.mly>"
    ( None )
# 62560 "asllib/Parser0.ml"
                 in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 718 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 62567 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let _1 = _1_inlined2 in
                        let _2 = 
# 123 "<standard.mly>"
    ( None )
# 62581 "asllib/Parser0.ml"
                         in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 698 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 62588 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 62597 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 695 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 62603 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 62612 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 62620 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 621 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 62626 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 62635 "asllib/Parser0.ml"
                
              in
              
# 713 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 62641 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined5_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 62650 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 62656 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _4;
          MenhirLib.EngineTypes.startp = _startpos__4_;
          MenhirLib.EngineTypes.endp = _endpos__4_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined8;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2;
              MenhirLib.EngineTypes.startp = _startpos__2_;
              MenhirLib.EngineTypes.endp = _endpos__2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined7;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined6;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined5;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _6;
                      MenhirLib.EngineTypes.startp = _startpos__6_;
                      MenhirLib.EngineTypes.endp = _endpos__6_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined4;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined3;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _3_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = expr_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined2;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _1_inlined1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _3;
                                    MenhirLib.EngineTypes.startp = _startpos__3_;
                                    MenhirLib.EngineTypes.endp = _endpos__3_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = expr;
                                      MenhirLib.EngineTypes.startp = _startpos_expr_;
                                      MenhirLib.EngineTypes.endp = _endpos_expr_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _menhir_s;
                                        MenhirLib.EngineTypes.semv = _1;
                                        MenhirLib.EngineTypes.startp = _startpos__1_;
                                        MenhirLib.EngineTypes.endp = _endpos__1_;
                                        MenhirLib.EngineTypes.next = _menhir_stack;
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined8 : (AST.stmt list) = Obj.magic _1_inlined8 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined7 : unit = Obj.magic _1_inlined7 in
        let _1_inlined6 : unit = Obj.magic _1_inlined6 in
        let _1_inlined5 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined5 in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__4_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined3, _1_inlined2, _1_inlined1, _1) = (_1_inlined8, _1_inlined7, _1_inlined6, _1_inlined5) in
                let _2 =
                  let (_1_inlined2, _1_inlined1, _1) = (_1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                    let _3 = _1_inlined1 in
                    let _3_1 = _3 in
                    
# 604 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 62798 "asllib/Parser0.ml"
                     _3_1
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 62804 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 718 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 62812 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let _1 = _1_inlined2 in
                        let _2 = 
# 123 "<standard.mly>"
    ( None )
# 62826 "asllib/Parser0.ml"
                         in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 698 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 62833 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 62842 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 695 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 62848 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 62857 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 62865 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 621 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 62871 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 62880 "asllib/Parser0.ml"
                
              in
              
# 713 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 62886 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 62895 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 62901 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _6_inlined1;
          MenhirLib.EngineTypes.startp = _startpos__6_inlined1_;
          MenhirLib.EngineTypes.endp = _endpos__6_inlined1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined10;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined10_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined10_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined9;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined9_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined9_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = expr_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos_expr_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos_expr_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined8;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined7;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined6;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined5;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _6;
                            MenhirLib.EngineTypes.startp = _startpos__6_;
                            MenhirLib.EngineTypes.endp = _endpos__6_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined4;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined3;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _3_inlined1;
                                  MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                                  MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = expr_inlined1;
                                    MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                                    MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = _1_inlined2;
                                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _;
                                        MenhirLib.EngineTypes.semv = _1_inlined1;
                                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                        MenhirLib.EngineTypes.next = {
                                          MenhirLib.EngineTypes.state = _;
                                          MenhirLib.EngineTypes.semv = _3;
                                          MenhirLib.EngineTypes.startp = _startpos__3_;
                                          MenhirLib.EngineTypes.endp = _endpos__3_;
                                          MenhirLib.EngineTypes.next = {
                                            MenhirLib.EngineTypes.state = _;
                                            MenhirLib.EngineTypes.semv = expr;
                                            MenhirLib.EngineTypes.startp = _startpos_expr_;
                                            MenhirLib.EngineTypes.endp = _endpos_expr_;
                                            MenhirLib.EngineTypes.next = {
                                              MenhirLib.EngineTypes.state = _menhir_s;
                                              MenhirLib.EngineTypes.semv = _1;
                                              MenhirLib.EngineTypes.startp = _startpos__1_;
                                              MenhirLib.EngineTypes.endp = _endpos__1_;
                                              MenhirLib.EngineTypes.next = _menhir_stack;
                                            };
                                          };
                                        };
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _6_inlined1 : unit = Obj.magic _6_inlined1 in
        let _1_inlined10 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined10 in
        let _1_inlined9 : (AST.stmt list) = Obj.magic _1_inlined9 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let expr_inlined2 : (AST.expr) = Obj.magic expr_inlined2 in
        let _1_inlined8 : unit = Obj.magic _1_inlined8 in
        let _1_inlined7 : (AST.stmt list) = Obj.magic _1_inlined7 in
        let _1_inlined6 : unit = Obj.magic _1_inlined6 in
        let _1_inlined5 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined5 in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__6_inlined1_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_endpos__6_, _startpos__1_inlined3_, _startpos__1_inlined2_, _6, _1_inlined5, _1_inlined4, _3, expr, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_endpos__6_inlined1_, _startpos__1_inlined8_, _startpos__1_inlined7_, _6_inlined1, _1_inlined10, _1_inlined9, _3_inlined2, expr_inlined2, _1_inlined8, _1_inlined7, _1_inlined6, _1_inlined5) in
                let _2 =
                  let (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_if_stmt =
                        let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                        let desc =
                          let simple_else_opt =
                            let _1 = _1_inlined2 in
                            let _2 = 
# 123 "<standard.mly>"
    ( None )
# 63068 "asllib/Parser0.ml"
                             in
                            let _1_1 = _1 in
                            let _2_1 = _2 in
                            
# 698 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 63075 "asllib/Parser0.ml"
                             (_1_1, _2_1)
                          in
                          let simple_stmt_list =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 63084 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 695 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 63090 "asllib/Parser0.ml"
                           (expr, simple_stmt_list, simple_else_opt)
                        in
                        let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                        let _endpos = _endpos_desc_ in
                        let _symbolstartpos = _startpos_desc_ in
                        
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 63099 "asllib/Parser0.ml"
                        
                      in
                      let simple_stmt_list =
                        let _1_1 = _1 in
                        
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 63107 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 621 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 63113 "asllib/Parser0.ml"
                       (simple_stmt_list, simple_if_stmt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 63122 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 63128 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 718 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 63136 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let _1 = _1_inlined2 in
                        let _2 = 
# 123 "<standard.mly>"
    ( None )
# 63150 "asllib/Parser0.ml"
                         in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 698 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 63157 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 63166 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 695 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 63172 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 63181 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 63189 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 621 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 63195 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 63204 "asllib/Parser0.ml"
                
              in
              
# 713 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 63210 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_inlined1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 63219 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 63225 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _6_inlined1;
          MenhirLib.EngineTypes.startp = _startpos__6_inlined1_;
          MenhirLib.EngineTypes.endp = _endpos__6_inlined1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined12;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined12_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined12_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined11;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined11_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined11_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined10;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined10_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined10_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined9;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined9_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined9_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = expr_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos_expr_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos_expr_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined8;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined7;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined6;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined5;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _6;
                                MenhirLib.EngineTypes.startp = _startpos__6_;
                                MenhirLib.EngineTypes.endp = _endpos__6_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _1_inlined4;
                                  MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _1_inlined3;
                                    MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = _3_inlined1;
                                      MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                                      MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _;
                                        MenhirLib.EngineTypes.semv = expr_inlined1;
                                        MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                                        MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                                        MenhirLib.EngineTypes.next = {
                                          MenhirLib.EngineTypes.state = _;
                                          MenhirLib.EngineTypes.semv = _1_inlined2;
                                          MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                          MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                          MenhirLib.EngineTypes.next = {
                                            MenhirLib.EngineTypes.state = _;
                                            MenhirLib.EngineTypes.semv = _1_inlined1;
                                            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                            MenhirLib.EngineTypes.next = {
                                              MenhirLib.EngineTypes.state = _;
                                              MenhirLib.EngineTypes.semv = _3;
                                              MenhirLib.EngineTypes.startp = _startpos__3_;
                                              MenhirLib.EngineTypes.endp = _endpos__3_;
                                              MenhirLib.EngineTypes.next = {
                                                MenhirLib.EngineTypes.state = _;
                                                MenhirLib.EngineTypes.semv = expr;
                                                MenhirLib.EngineTypes.startp = _startpos_expr_;
                                                MenhirLib.EngineTypes.endp = _endpos_expr_;
                                                MenhirLib.EngineTypes.next = {
                                                  MenhirLib.EngineTypes.state = _menhir_s;
                                                  MenhirLib.EngineTypes.semv = _1;
                                                  MenhirLib.EngineTypes.startp = _startpos__1_;
                                                  MenhirLib.EngineTypes.endp = _endpos__1_;
                                                  MenhirLib.EngineTypes.next = _menhir_stack;
                                                };
                                              };
                                            };
                                          };
                                        };
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _6_inlined1 : unit = Obj.magic _6_inlined1 in
        let _1_inlined12 : (AST.stmt list) = Obj.magic _1_inlined12 in
        let _1_inlined11 : unit = Obj.magic _1_inlined11 in
        let _1_inlined10 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined10 in
        let _1_inlined9 : (AST.stmt list) = Obj.magic _1_inlined9 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let expr_inlined2 : (AST.expr) = Obj.magic expr_inlined2 in
        let _1_inlined8 : unit = Obj.magic _1_inlined8 in
        let _1_inlined7 : (AST.stmt list) = Obj.magic _1_inlined7 in
        let _1_inlined6 : unit = Obj.magic _1_inlined6 in
        let _1_inlined5 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined5 in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__6_inlined1_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_endpos__6_, _startpos__1_inlined3_, _startpos__1_inlined2_, _6, _1_inlined7, _1_inlined6, _1_inlined5, _1_inlined4, _3, expr, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_endpos__6_inlined1_, _startpos__1_inlined8_, _startpos__1_inlined7_, _6_inlined1, _1_inlined12, _1_inlined11, _1_inlined10, _1_inlined9, _3_inlined2, expr_inlined2, _1_inlined8, _1_inlined7, _1_inlined6, _1_inlined5) in
                let _2 =
                  let (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined7, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_if_stmt =
                        let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                        let desc =
                          let simple_else_opt =
                            let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                            let _2 =
                              let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                              let x =
                                let _1 = _1_inlined1 in
                                let _1_1 = _1 in
                                
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 63411 "asllib/Parser0.ml"
                                 _1_1
                              in
                              
# 126 "<standard.mly>"
    ( Some x )
# 63417 "asllib/Parser0.ml"
                              
                            in
                            let _1_1 = _1 in
                            let _2_1 = _2 in
                            
# 698 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 63425 "asllib/Parser0.ml"
                             (_1_1, _2_1)
                          in
                          let simple_stmt_list =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 63434 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 695 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 63440 "asllib/Parser0.ml"
                           (expr, simple_stmt_list, simple_else_opt)
                        in
                        let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                        let _endpos = _endpos_desc_ in
                        let _symbolstartpos = _startpos_desc_ in
                        
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 63449 "asllib/Parser0.ml"
                        
                      in
                      let simple_stmt_list =
                        let _1_1 = _1 in
                        
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 63457 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 621 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 63463 "asllib/Parser0.ml"
                       (simple_stmt_list, simple_if_stmt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 63472 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 63478 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 718 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 63486 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let _1 = _1_inlined2 in
                        let _2 = 
# 123 "<standard.mly>"
    ( None )
# 63500 "asllib/Parser0.ml"
                         in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 698 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 63507 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 63516 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 695 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 63522 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 63531 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 63539 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 621 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 63545 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 63554 "asllib/Parser0.ml"
                
              in
              
# 713 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 63560 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_inlined1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 63569 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 63575 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined7;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined6;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined5;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _6;
                  MenhirLib.EngineTypes.startp = _startpos__6_;
                  MenhirLib.EngineTypes.endp = _endpos__6_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined4;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined3;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = expr_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined2;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _3;
                                MenhirLib.EngineTypes.startp = _startpos__3_;
                                MenhirLib.EngineTypes.endp = _endpos__3_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = expr;
                                  MenhirLib.EngineTypes.startp = _startpos_expr_;
                                  MenhirLib.EngineTypes.endp = _endpos_expr_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _menhir_s;
                                    MenhirLib.EngineTypes.semv = _1;
                                    MenhirLib.EngineTypes.startp = _startpos__1_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_;
                                    MenhirLib.EngineTypes.next = _menhir_stack;
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined7 : (AST.stmt list) = Obj.magic _1_inlined7 in
        let _1_inlined6 : unit = Obj.magic _1_inlined6 in
        let _1_inlined5 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined5 in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined2, _1_inlined1, _1) = (_1_inlined7, _1_inlined6, _1_inlined5) in
                let _2 =
                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    let x =
                      let _1_1 = _1 in
                      
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 63703 "asllib/Parser0.ml"
                       _1_1
                    in
                    
# 196 "<standard.mly>"
    ( x )
# 63709 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 63715 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 718 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 63723 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let _1 = _1_inlined2 in
                        let _2 = 
# 123 "<standard.mly>"
    ( None )
# 63737 "asllib/Parser0.ml"
                         in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 698 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 63744 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 63753 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 695 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 63759 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 63768 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 63776 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 621 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 63782 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 63791 "asllib/Parser0.ml"
                
              in
              
# 713 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 63797 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 63806 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 63812 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _1_inlined7;
          MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
          MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined6;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined5;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _6;
                MenhirLib.EngineTypes.startp = _startpos__6_;
                MenhirLib.EngineTypes.endp = _endpos__6_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined4;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined3;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = expr_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined2;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _3;
                              MenhirLib.EngineTypes.startp = _startpos__3_;
                              MenhirLib.EngineTypes.endp = _endpos__3_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = expr;
                                MenhirLib.EngineTypes.startp = _startpos_expr_;
                                MenhirLib.EngineTypes.endp = _endpos_expr_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _menhir_s;
                                  MenhirLib.EngineTypes.semv = _1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_;
                                  MenhirLib.EngineTypes.next = _menhir_stack;
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _1_inlined7 : unit = Obj.magic _1_inlined7 in
        let _1_inlined6 : unit = Obj.magic _1_inlined6 in
        let _1_inlined5 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined5 in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_inlined7_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined2, _1_inlined1, _1) = (_1_inlined7, _1_inlined6, _1_inlined5) in
                let _2 =
                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    
# 597 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 63931 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 63937 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 718 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 63945 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let _1 = _1_inlined2 in
                        let _2 = 
# 123 "<standard.mly>"
    ( None )
# 63959 "asllib/Parser0.ml"
                         in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 698 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 63966 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 63975 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 695 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 63981 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 63990 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 63998 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 621 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 64004 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 64013 "asllib/Parser0.ml"
                
              in
              
# 713 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 64019 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined7_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 64028 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 64034 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _1_inlined7;
          MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
          MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined6;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined5;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined4;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined3;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = expr_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined2;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _3;
                              MenhirLib.EngineTypes.startp = _startpos__3_;
                              MenhirLib.EngineTypes.endp = _endpos__3_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = expr;
                                MenhirLib.EngineTypes.startp = _startpos_expr_;
                                MenhirLib.EngineTypes.endp = _endpos_expr_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _menhir_s;
                                  MenhirLib.EngineTypes.semv = _1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_;
                                  MenhirLib.EngineTypes.next = _menhir_stack;
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _1_inlined7 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined7 in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_inlined7_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let _1 = _1_inlined7 in
                let _2 = 
# 123 "<standard.mly>"
    ( None )
# 64149 "asllib/Parser0.ml"
                 in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 718 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 64156 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                        let _2 =
                          let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                          let x =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 64175 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 126 "<standard.mly>"
    ( Some x )
# 64181 "asllib/Parser0.ml"
                          
                        in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 698 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 64189 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 64198 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 695 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 64204 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 64213 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 64221 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 621 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 64227 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 64236 "asllib/Parser0.ml"
                
              in
              
# 713 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 64242 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined7_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 64251 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 64257 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _4;
          MenhirLib.EngineTypes.startp = _startpos__4_;
          MenhirLib.EngineTypes.endp = _endpos__4_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined10;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined10_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined10_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2;
              MenhirLib.EngineTypes.startp = _startpos__2_;
              MenhirLib.EngineTypes.endp = _endpos__2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined9;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined9_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined9_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined8;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined7;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _6;
                      MenhirLib.EngineTypes.startp = _startpos__6_;
                      MenhirLib.EngineTypes.endp = _endpos__6_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined6;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined5;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined4;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined3;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _3_inlined1;
                                MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                                MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = expr_inlined1;
                                  MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                                  MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _1_inlined2;
                                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = _1_inlined1;
                                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _;
                                        MenhirLib.EngineTypes.semv = _3;
                                        MenhirLib.EngineTypes.startp = _startpos__3_;
                                        MenhirLib.EngineTypes.endp = _endpos__3_;
                                        MenhirLib.EngineTypes.next = {
                                          MenhirLib.EngineTypes.state = _;
                                          MenhirLib.EngineTypes.semv = expr;
                                          MenhirLib.EngineTypes.startp = _startpos_expr_;
                                          MenhirLib.EngineTypes.endp = _endpos_expr_;
                                          MenhirLib.EngineTypes.next = {
                                            MenhirLib.EngineTypes.state = _menhir_s;
                                            MenhirLib.EngineTypes.semv = _1;
                                            MenhirLib.EngineTypes.startp = _startpos__1_;
                                            MenhirLib.EngineTypes.endp = _endpos__1_;
                                            MenhirLib.EngineTypes.next = _menhir_stack;
                                          };
                                        };
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined10 : (AST.stmt list) = Obj.magic _1_inlined10 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined9 : unit = Obj.magic _1_inlined9 in
        let _1_inlined8 : unit = Obj.magic _1_inlined8 in
        let _1_inlined7 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined7 in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__4_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined3, _1_inlined2, _1_inlined1, _1) = (_1_inlined10, _1_inlined9, _1_inlined8, _1_inlined7) in
                let _2 =
                  let (_1_inlined2, _1_inlined1, _1) = (_1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                    let _3 = _1_inlined1 in
                    let _3_1 = _3 in
                    
# 604 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 64413 "asllib/Parser0.ml"
                     _3_1
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 64419 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 718 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 64427 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                        let _2 =
                          let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                          let x =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 64446 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 126 "<standard.mly>"
    ( Some x )
# 64452 "asllib/Parser0.ml"
                          
                        in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 698 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 64460 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 64469 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 695 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 64475 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 64484 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 64492 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 621 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 64498 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 64507 "asllib/Parser0.ml"
                
              in
              
# 713 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 64513 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 64522 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 64528 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _6_inlined1;
          MenhirLib.EngineTypes.startp = _startpos__6_inlined1_;
          MenhirLib.EngineTypes.endp = _endpos__6_inlined1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined12;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined12_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined12_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined11;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined11_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined11_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = expr_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos_expr_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos_expr_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined10;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined10_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined10_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined9;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined9_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined9_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined8;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined7;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _6;
                            MenhirLib.EngineTypes.startp = _startpos__6_;
                            MenhirLib.EngineTypes.endp = _endpos__6_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined6;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined5;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _1_inlined4;
                                  MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _1_inlined3;
                                    MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = _3_inlined1;
                                      MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                                      MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _;
                                        MenhirLib.EngineTypes.semv = expr_inlined1;
                                        MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                                        MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                                        MenhirLib.EngineTypes.next = {
                                          MenhirLib.EngineTypes.state = _;
                                          MenhirLib.EngineTypes.semv = _1_inlined2;
                                          MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                          MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                          MenhirLib.EngineTypes.next = {
                                            MenhirLib.EngineTypes.state = _;
                                            MenhirLib.EngineTypes.semv = _1_inlined1;
                                            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                            MenhirLib.EngineTypes.next = {
                                              MenhirLib.EngineTypes.state = _;
                                              MenhirLib.EngineTypes.semv = _3;
                                              MenhirLib.EngineTypes.startp = _startpos__3_;
                                              MenhirLib.EngineTypes.endp = _endpos__3_;
                                              MenhirLib.EngineTypes.next = {
                                                MenhirLib.EngineTypes.state = _;
                                                MenhirLib.EngineTypes.semv = expr;
                                                MenhirLib.EngineTypes.startp = _startpos_expr_;
                                                MenhirLib.EngineTypes.endp = _endpos_expr_;
                                                MenhirLib.EngineTypes.next = {
                                                  MenhirLib.EngineTypes.state = _menhir_s;
                                                  MenhirLib.EngineTypes.semv = _1;
                                                  MenhirLib.EngineTypes.startp = _startpos__1_;
                                                  MenhirLib.EngineTypes.endp = _endpos__1_;
                                                  MenhirLib.EngineTypes.next = _menhir_stack;
                                                };
                                              };
                                            };
                                          };
                                        };
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _6_inlined1 : unit = Obj.magic _6_inlined1 in
        let _1_inlined12 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined12 in
        let _1_inlined11 : (AST.stmt list) = Obj.magic _1_inlined11 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let expr_inlined2 : (AST.expr) = Obj.magic expr_inlined2 in
        let _1_inlined10 : unit = Obj.magic _1_inlined10 in
        let _1_inlined9 : (AST.stmt list) = Obj.magic _1_inlined9 in
        let _1_inlined8 : unit = Obj.magic _1_inlined8 in
        let _1_inlined7 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined7 in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__6_inlined1_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_endpos__6_, _startpos__1_inlined3_, _startpos__1_inlined2_, _6, _1_inlined5, _1_inlined4, _3, expr, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_endpos__6_inlined1_, _startpos__1_inlined10_, _startpos__1_inlined9_, _6_inlined1, _1_inlined12, _1_inlined11, _3_inlined2, expr_inlined2, _1_inlined10, _1_inlined9, _1_inlined8, _1_inlined7) in
                let _2 =
                  let (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_if_stmt =
                        let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                        let desc =
                          let simple_else_opt =
                            let _1 = _1_inlined2 in
                            let _2 = 
# 123 "<standard.mly>"
    ( None )
# 64709 "asllib/Parser0.ml"
                             in
                            let _1_1 = _1 in
                            let _2_1 = _2 in
                            
# 698 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 64716 "asllib/Parser0.ml"
                             (_1_1, _2_1)
                          in
                          let simple_stmt_list =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 64725 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 695 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 64731 "asllib/Parser0.ml"
                           (expr, simple_stmt_list, simple_else_opt)
                        in
                        let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                        let _endpos = _endpos_desc_ in
                        let _symbolstartpos = _startpos_desc_ in
                        
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 64740 "asllib/Parser0.ml"
                        
                      in
                      let simple_stmt_list =
                        let _1_1 = _1 in
                        
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 64748 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 621 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 64754 "asllib/Parser0.ml"
                       (simple_stmt_list, simple_if_stmt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 64763 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 64769 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 718 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 64777 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                        let _2 =
                          let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                          let x =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 64796 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 126 "<standard.mly>"
    ( Some x )
# 64802 "asllib/Parser0.ml"
                          
                        in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 698 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 64810 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 64819 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 695 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 64825 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 64834 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 64842 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 621 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 64848 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 64857 "asllib/Parser0.ml"
                
              in
              
# 713 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 64863 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_inlined1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 64872 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 64878 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _6_inlined1;
          MenhirLib.EngineTypes.startp = _startpos__6_inlined1_;
          MenhirLib.EngineTypes.endp = _endpos__6_inlined1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined14;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined14_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined14_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined13;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined13_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined13_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined12;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined12_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined12_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined11;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined11_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined11_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = expr_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos_expr_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos_expr_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined10;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined10_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined10_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined9;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined9_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined9_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined8;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined7;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _6;
                                MenhirLib.EngineTypes.startp = _startpos__6_;
                                MenhirLib.EngineTypes.endp = _endpos__6_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _1_inlined6;
                                  MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _1_inlined5;
                                    MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = _1_inlined4;
                                      MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                                      MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _;
                                        MenhirLib.EngineTypes.semv = _1_inlined3;
                                        MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                                        MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                                        MenhirLib.EngineTypes.next = {
                                          MenhirLib.EngineTypes.state = _;
                                          MenhirLib.EngineTypes.semv = _3_inlined1;
                                          MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                                          MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                                          MenhirLib.EngineTypes.next = {
                                            MenhirLib.EngineTypes.state = _;
                                            MenhirLib.EngineTypes.semv = expr_inlined1;
                                            MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                                            MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                                            MenhirLib.EngineTypes.next = {
                                              MenhirLib.EngineTypes.state = _;
                                              MenhirLib.EngineTypes.semv = _1_inlined2;
                                              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                              MenhirLib.EngineTypes.next = {
                                                MenhirLib.EngineTypes.state = _;
                                                MenhirLib.EngineTypes.semv = _1_inlined1;
                                                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                                MenhirLib.EngineTypes.next = {
                                                  MenhirLib.EngineTypes.state = _;
                                                  MenhirLib.EngineTypes.semv = _3;
                                                  MenhirLib.EngineTypes.startp = _startpos__3_;
                                                  MenhirLib.EngineTypes.endp = _endpos__3_;
                                                  MenhirLib.EngineTypes.next = {
                                                    MenhirLib.EngineTypes.state = _;
                                                    MenhirLib.EngineTypes.semv = expr;
                                                    MenhirLib.EngineTypes.startp = _startpos_expr_;
                                                    MenhirLib.EngineTypes.endp = _endpos_expr_;
                                                    MenhirLib.EngineTypes.next = {
                                                      MenhirLib.EngineTypes.state = _menhir_s;
                                                      MenhirLib.EngineTypes.semv = _1;
                                                      MenhirLib.EngineTypes.startp = _startpos__1_;
                                                      MenhirLib.EngineTypes.endp = _endpos__1_;
                                                      MenhirLib.EngineTypes.next = _menhir_stack;
                                                    };
                                                  };
                                                };
                                              };
                                            };
                                          };
                                        };
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _6_inlined1 : unit = Obj.magic _6_inlined1 in
        let _1_inlined14 : (AST.stmt list) = Obj.magic _1_inlined14 in
        let _1_inlined13 : unit = Obj.magic _1_inlined13 in
        let _1_inlined12 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined12 in
        let _1_inlined11 : (AST.stmt list) = Obj.magic _1_inlined11 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let expr_inlined2 : (AST.expr) = Obj.magic expr_inlined2 in
        let _1_inlined10 : unit = Obj.magic _1_inlined10 in
        let _1_inlined9 : (AST.stmt list) = Obj.magic _1_inlined9 in
        let _1_inlined8 : unit = Obj.magic _1_inlined8 in
        let _1_inlined7 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined7 in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__6_inlined1_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_endpos__6_, _startpos__1_inlined3_, _startpos__1_inlined2_, _6, _1_inlined7, _1_inlined6, _1_inlined5, _1_inlined4, _3, expr, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_endpos__6_inlined1_, _startpos__1_inlined10_, _startpos__1_inlined9_, _6_inlined1, _1_inlined14, _1_inlined13, _1_inlined12, _1_inlined11, _3_inlined2, expr_inlined2, _1_inlined10, _1_inlined9, _1_inlined8, _1_inlined7) in
                let _2 =
                  let (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined7, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_if_stmt =
                        let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                        let desc =
                          let simple_else_opt =
                            let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                            let _2 =
                              let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                              let x =
                                let _1 = _1_inlined1 in
                                let _1_1 = _1 in
                                
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 65078 "asllib/Parser0.ml"
                                 _1_1
                              in
                              
# 126 "<standard.mly>"
    ( Some x )
# 65084 "asllib/Parser0.ml"
                              
                            in
                            let _1_1 = _1 in
                            let _2_1 = _2 in
                            
# 698 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 65092 "asllib/Parser0.ml"
                             (_1_1, _2_1)
                          in
                          let simple_stmt_list =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 65101 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 695 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 65107 "asllib/Parser0.ml"
                           (expr, simple_stmt_list, simple_else_opt)
                        in
                        let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                        let _endpos = _endpos_desc_ in
                        let _symbolstartpos = _startpos_desc_ in
                        
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 65116 "asllib/Parser0.ml"
                        
                      in
                      let simple_stmt_list =
                        let _1_1 = _1 in
                        
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 65124 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 621 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 65130 "asllib/Parser0.ml"
                       (simple_stmt_list, simple_if_stmt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 65139 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 65145 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 718 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 65153 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                        let _2 =
                          let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                          let x =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 65172 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 126 "<standard.mly>"
    ( Some x )
# 65178 "asllib/Parser0.ml"
                          
                        in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 698 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 65186 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 65195 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 695 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 65201 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 65210 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 65218 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 621 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 65224 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 65233 "asllib/Parser0.ml"
                
              in
              
# 713 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 65239 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_inlined1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 65248 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 65254 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined9;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined9_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined9_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined8;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined7;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _6;
                  MenhirLib.EngineTypes.startp = _startpos__6_;
                  MenhirLib.EngineTypes.endp = _endpos__6_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined6;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined5;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined4;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined3;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _3_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = expr_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined2;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _1_inlined1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _3;
                                    MenhirLib.EngineTypes.startp = _startpos__3_;
                                    MenhirLib.EngineTypes.endp = _endpos__3_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = expr;
                                      MenhirLib.EngineTypes.startp = _startpos_expr_;
                                      MenhirLib.EngineTypes.endp = _endpos_expr_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _menhir_s;
                                        MenhirLib.EngineTypes.semv = _1;
                                        MenhirLib.EngineTypes.startp = _startpos__1_;
                                        MenhirLib.EngineTypes.endp = _endpos__1_;
                                        MenhirLib.EngineTypes.next = _menhir_stack;
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined9 : (AST.stmt list) = Obj.magic _1_inlined9 in
        let _1_inlined8 : unit = Obj.magic _1_inlined8 in
        let _1_inlined7 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined7 in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined2, _1_inlined1, _1) = (_1_inlined9, _1_inlined8, _1_inlined7) in
                let _2 =
                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    let x =
                      let _1_1 = _1 in
                      
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 65396 "asllib/Parser0.ml"
                       _1_1
                    in
                    
# 196 "<standard.mly>"
    ( x )
# 65402 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 65408 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 718 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 65416 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                        let _2 =
                          let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                          let x =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 65435 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 126 "<standard.mly>"
    ( Some x )
# 65441 "asllib/Parser0.ml"
                          
                        in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 698 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 65449 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 65458 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 695 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 65464 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 65473 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 65481 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 621 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 65487 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 65496 "asllib/Parser0.ml"
                
              in
              
# 713 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 65502 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 65511 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 65517 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _1_inlined9;
          MenhirLib.EngineTypes.startp = _startpos__1_inlined9_;
          MenhirLib.EngineTypes.endp = _endpos__1_inlined9_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined8;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined7;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _6;
                MenhirLib.EngineTypes.startp = _startpos__6_;
                MenhirLib.EngineTypes.endp = _endpos__6_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined6;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined5;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined4;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined3;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _3_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = expr_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined2;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined1;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _3;
                                  MenhirLib.EngineTypes.startp = _startpos__3_;
                                  MenhirLib.EngineTypes.endp = _endpos__3_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = expr;
                                    MenhirLib.EngineTypes.startp = _startpos_expr_;
                                    MenhirLib.EngineTypes.endp = _endpos_expr_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _menhir_s;
                                      MenhirLib.EngineTypes.semv = _1;
                                      MenhirLib.EngineTypes.startp = _startpos__1_;
                                      MenhirLib.EngineTypes.endp = _endpos__1_;
                                      MenhirLib.EngineTypes.next = _menhir_stack;
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _1_inlined9 : unit = Obj.magic _1_inlined9 in
        let _1_inlined8 : unit = Obj.magic _1_inlined8 in
        let _1_inlined7 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined7 in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_inlined9_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined2, _1_inlined1, _1) = (_1_inlined9, _1_inlined8, _1_inlined7) in
                let _2 =
                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    
# 597 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 65650 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 65656 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 718 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 65664 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                        let _2 =
                          let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                          let x =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 65683 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 126 "<standard.mly>"
    ( Some x )
# 65689 "asllib/Parser0.ml"
                          
                        in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 698 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 65697 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 65706 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 695 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 65712 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 65721 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 65729 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 621 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 65735 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 65744 "asllib/Parser0.ml"
                
              in
              
# 713 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 65750 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined9_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 65759 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 65765 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _1_inlined2;
          MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
          MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = expr;
                  MenhirLib.EngineTypes.startp = _startpos_expr_;
                  MenhirLib.EngineTypes.endp = _endpos_expr_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_inlined2_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let _1 = _1_inlined2 in
                let _2 = 
# 123 "<standard.mly>"
    ( None )
# 65831 "asllib/Parser0.ml"
                 in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 718 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 65838 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                let x =
                  let _1_1 = _1 in
                  
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 65848 "asllib/Parser0.ml"
                   _1_1
                in
                
# 196 "<standard.mly>"
    ( x )
# 65854 "asllib/Parser0.ml"
                
              in
              
# 713 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 65860 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 65869 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 65875 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _4;
          MenhirLib.EngineTypes.startp = _startpos__4_;
          MenhirLib.EngineTypes.endp = _endpos__4_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined5;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined4;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _2;
                      MenhirLib.EngineTypes.startp = _startpos__2_;
                      MenhirLib.EngineTypes.endp = _endpos__2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _3;
                          MenhirLib.EngineTypes.startp = _startpos__3_;
                          MenhirLib.EngineTypes.endp = _endpos__3_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = expr;
                            MenhirLib.EngineTypes.startp = _startpos_expr_;
                            MenhirLib.EngineTypes.endp = _endpos_expr_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = _1;
                              MenhirLib.EngineTypes.startp = _startpos__1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined5 : (AST.stmt list) = Obj.magic _1_inlined5 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__4_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined3, _2, _1_inlined2, _1_inlined1, _1) = (_1_inlined5, _2_inlined1, _1_inlined4, _1_inlined3, _1_inlined2) in
                let _2 =
                  let (_1_inlined2, _1_inlined1, _1) = (_1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                    let _3 = _1_inlined1 in
                    let _3_1 = _3 in
                    
# 604 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 65982 "asllib/Parser0.ml"
                     _3_1
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 65988 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 718 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 65996 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                let x =
                  let _1_1 = _1 in
                  
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 66006 "asllib/Parser0.ml"
                   _1_1
                in
                
# 196 "<standard.mly>"
    ( x )
# 66012 "asllib/Parser0.ml"
                
              in
              
# 713 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 66018 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 66027 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 66033 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _6;
          MenhirLib.EngineTypes.startp = _startpos__6_;
          MenhirLib.EngineTypes.endp = _endpos__6_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined7;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined6;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = expr_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined5;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined4;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined3;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined2;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _2;
                            MenhirLib.EngineTypes.startp = _startpos__2_;
                            MenhirLib.EngineTypes.endp = _endpos__2_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _3;
                                MenhirLib.EngineTypes.startp = _startpos__3_;
                                MenhirLib.EngineTypes.endp = _endpos__3_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = expr;
                                  MenhirLib.EngineTypes.startp = _startpos_expr_;
                                  MenhirLib.EngineTypes.endp = _endpos_expr_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _menhir_s;
                                    MenhirLib.EngineTypes.semv = _1;
                                    MenhirLib.EngineTypes.startp = _startpos__1_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_;
                                    MenhirLib.EngineTypes.next = _menhir_stack;
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined7 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined7 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__6_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined5, _1_inlined4, _3, expr, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined5_, _startpos__1_inlined4_, _1_inlined7, _1_inlined6, _3_inlined1, expr_inlined1, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2) in
                let _2 =
                  let (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_if_stmt =
                        let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                        let desc =
                          let simple_else_opt =
                            let _1 = _1_inlined2 in
                            let _2 = 
# 123 "<standard.mly>"
    ( None )
# 66165 "asllib/Parser0.ml"
                             in
                            let _1_1 = _1 in
                            let _2_1 = _2 in
                            
# 698 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 66172 "asllib/Parser0.ml"
                             (_1_1, _2_1)
                          in
                          let simple_stmt_list =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 66181 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 695 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 66187 "asllib/Parser0.ml"
                           (expr, simple_stmt_list, simple_else_opt)
                        in
                        let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                        let _endpos = _endpos_desc_ in
                        let _symbolstartpos = _startpos_desc_ in
                        
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 66196 "asllib/Parser0.ml"
                        
                      in
                      let simple_stmt_list =
                        let _1_1 = _1 in
                        
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 66204 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 621 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 66210 "asllib/Parser0.ml"
                       (simple_stmt_list, simple_if_stmt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 66219 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 66225 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 718 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 66233 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                let x =
                  let _1_1 = _1 in
                  
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 66243 "asllib/Parser0.ml"
                   _1_1
                in
                
# 196 "<standard.mly>"
    ( x )
# 66249 "asllib/Parser0.ml"
                
              in
              
# 713 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 66255 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 66264 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 66270 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _6;
          MenhirLib.EngineTypes.startp = _startpos__6_;
          MenhirLib.EngineTypes.endp = _endpos__6_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined9;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined9_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined9_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined8;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined7;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined6;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = expr_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined5;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined4;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined3;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined2;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _2;
                                MenhirLib.EngineTypes.startp = _startpos__2_;
                                MenhirLib.EngineTypes.endp = _endpos__2_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _1_inlined1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _3;
                                    MenhirLib.EngineTypes.startp = _startpos__3_;
                                    MenhirLib.EngineTypes.endp = _endpos__3_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = expr;
                                      MenhirLib.EngineTypes.startp = _startpos_expr_;
                                      MenhirLib.EngineTypes.endp = _endpos_expr_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _menhir_s;
                                        MenhirLib.EngineTypes.semv = _1;
                                        MenhirLib.EngineTypes.startp = _startpos__1_;
                                        MenhirLib.EngineTypes.endp = _endpos__1_;
                                        MenhirLib.EngineTypes.next = _menhir_stack;
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined9 : (AST.stmt list) = Obj.magic _1_inlined9 in
        let _1_inlined8 : unit = Obj.magic _1_inlined8 in
        let _1_inlined7 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined7 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__6_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined7, _1_inlined6, _1_inlined5, _1_inlined4, _3, expr, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined5_, _startpos__1_inlined4_, _1_inlined9, _1_inlined8, _1_inlined7, _1_inlined6, _3_inlined1, expr_inlined1, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2) in
                let _2 =
                  let (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined7, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_if_stmt =
                        let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                        let desc =
                          let simple_else_opt =
                            let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                            let _2 =
                              let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                              let x =
                                let _1 = _1_inlined1 in
                                let _1_1 = _1 in
                                
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 66421 "asllib/Parser0.ml"
                                 _1_1
                              in
                              
# 126 "<standard.mly>"
    ( Some x )
# 66427 "asllib/Parser0.ml"
                              
                            in
                            let _1_1 = _1 in
                            let _2_1 = _2 in
                            
# 698 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 66435 "asllib/Parser0.ml"
                             (_1_1, _2_1)
                          in
                          let simple_stmt_list =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 66444 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 695 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 66450 "asllib/Parser0.ml"
                           (expr, simple_stmt_list, simple_else_opt)
                        in
                        let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                        let _endpos = _endpos_desc_ in
                        let _symbolstartpos = _startpos_desc_ in
                        
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 66459 "asllib/Parser0.ml"
                        
                      in
                      let simple_stmt_list =
                        let _1_1 = _1 in
                        
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 66467 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 621 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 66473 "asllib/Parser0.ml"
                       (simple_stmt_list, simple_if_stmt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 66482 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 66488 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 718 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 66496 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                let x =
                  let _1_1 = _1 in
                  
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 66506 "asllib/Parser0.ml"
                   _1_1
                in
                
# 196 "<standard.mly>"
    ( x )
# 66512 "asllib/Parser0.ml"
                
              in
              
# 713 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 66518 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 66527 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 66533 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2_inlined1;
          MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
          MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined4;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _2;
                  MenhirLib.EngineTypes.startp = _startpos__2_;
                  MenhirLib.EngineTypes.endp = _endpos__2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3;
                      MenhirLib.EngineTypes.startp = _startpos__3_;
                      MenhirLib.EngineTypes.endp = _endpos__3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = expr;
                        MenhirLib.EngineTypes.startp = _startpos_expr_;
                        MenhirLib.EngineTypes.endp = _endpos_expr_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_inlined1_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                let _2 =
                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    let x =
                      let _1_1 = _1 in
                      
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 66626 "asllib/Parser0.ml"
                       _1_1
                    in
                    
# 196 "<standard.mly>"
    ( x )
# 66632 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 66638 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 718 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 66646 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                let x =
                  let _1_1 = _1 in
                  
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 66656 "asllib/Parser0.ml"
                   _1_1
                in
                
# 196 "<standard.mly>"
    ( x )
# 66662 "asllib/Parser0.ml"
                
              in
              
# 713 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 66668 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_inlined1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 66677 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 66683 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _1_inlined4;
          MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
          MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined3;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = expr;
                      MenhirLib.EngineTypes.startp = _startpos_expr_;
                      MenhirLib.EngineTypes.endp = _endpos_expr_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_inlined4_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                let _2 =
                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    
# 597 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 66767 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 66773 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 718 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 66781 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                let x =
                  let _1_1 = _1 in
                  
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 66791 "asllib/Parser0.ml"
                   _1_1
                in
                
# 196 "<standard.mly>"
    ( x )
# 66797 "asllib/Parser0.ml"
                
              in
              
# 713 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 66803 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined4_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 66812 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 66818 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _1_inlined2;
          MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
          MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = expr;
                MenhirLib.EngineTypes.startp = _startpos_expr_;
                MenhirLib.EngineTypes.endp = _endpos_expr_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_inlined2_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let _1 = _1_inlined2 in
                let _2 = 
# 123 "<standard.mly>"
    ( None )
# 66877 "asllib/Parser0.ml"
                 in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 718 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 66884 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                
# 597 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 66892 "asllib/Parser0.ml"
                
              in
              
# 713 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 66898 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 66907 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 66913 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _4;
          MenhirLib.EngineTypes.startp = _startpos__4_;
          MenhirLib.EngineTypes.endp = _endpos__4_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined5;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2;
              MenhirLib.EngineTypes.startp = _startpos__2_;
              MenhirLib.EngineTypes.endp = _endpos__2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined4;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3;
                        MenhirLib.EngineTypes.startp = _startpos__3_;
                        MenhirLib.EngineTypes.endp = _endpos__3_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = expr;
                          MenhirLib.EngineTypes.startp = _startpos_expr_;
                          MenhirLib.EngineTypes.endp = _endpos_expr_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined5 : (AST.stmt list) = Obj.magic _1_inlined5 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__4_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined3, _1_inlined2, _1_inlined1, _1) = (_1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2) in
                let _2 =
                  let (_1_inlined2, _1_inlined1, _1) = (_1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                    let _3 = _1_inlined1 in
                    let _3_1 = _3 in
                    
# 604 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 67013 "asllib/Parser0.ml"
                     _3_1
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 67019 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 718 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 67027 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                
# 597 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 67035 "asllib/Parser0.ml"
                
              in
              
# 713 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 67041 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 67050 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 67056 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _6;
          MenhirLib.EngineTypes.startp = _startpos__6_;
          MenhirLib.EngineTypes.endp = _endpos__6_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined7;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined6;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = expr_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined5;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined4;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined3;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined2;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _3;
                              MenhirLib.EngineTypes.startp = _startpos__3_;
                              MenhirLib.EngineTypes.endp = _endpos__3_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = expr;
                                MenhirLib.EngineTypes.startp = _startpos_expr_;
                                MenhirLib.EngineTypes.endp = _endpos_expr_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _menhir_s;
                                  MenhirLib.EngineTypes.semv = _1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_;
                                  MenhirLib.EngineTypes.next = _menhir_stack;
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined7 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined7 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__6_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined5, _1_inlined4, _3, expr, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined5_, _startpos__1_inlined4_, _1_inlined7, _1_inlined6, _3_inlined1, expr_inlined1, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2) in
                let _2 =
                  let (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_if_stmt =
                        let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                        let desc =
                          let simple_else_opt =
                            let _1 = _1_inlined2 in
                            let _2 = 
# 123 "<standard.mly>"
    ( None )
# 67181 "asllib/Parser0.ml"
                             in
                            let _1_1 = _1 in
                            let _2_1 = _2 in
                            
# 698 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 67188 "asllib/Parser0.ml"
                             (_1_1, _2_1)
                          in
                          let simple_stmt_list =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 67197 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 695 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 67203 "asllib/Parser0.ml"
                           (expr, simple_stmt_list, simple_else_opt)
                        in
                        let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                        let _endpos = _endpos_desc_ in
                        let _symbolstartpos = _startpos_desc_ in
                        
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 67212 "asllib/Parser0.ml"
                        
                      in
                      let simple_stmt_list =
                        let _1_1 = _1 in
                        
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 67220 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 621 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 67226 "asllib/Parser0.ml"
                       (simple_stmt_list, simple_if_stmt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 67235 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 67241 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 718 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 67249 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                
# 597 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 67257 "asllib/Parser0.ml"
                
              in
              
# 713 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 67263 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 67272 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 67278 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _6;
          MenhirLib.EngineTypes.startp = _startpos__6_;
          MenhirLib.EngineTypes.endp = _endpos__6_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined9;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined9_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined9_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined8;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined7;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined6;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = expr_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined5;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined4;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined3;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined2;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined1;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _3;
                                  MenhirLib.EngineTypes.startp = _startpos__3_;
                                  MenhirLib.EngineTypes.endp = _endpos__3_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = expr;
                                    MenhirLib.EngineTypes.startp = _startpos_expr_;
                                    MenhirLib.EngineTypes.endp = _endpos_expr_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _menhir_s;
                                      MenhirLib.EngineTypes.semv = _1;
                                      MenhirLib.EngineTypes.startp = _startpos__1_;
                                      MenhirLib.EngineTypes.endp = _endpos__1_;
                                      MenhirLib.EngineTypes.next = _menhir_stack;
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined9 : (AST.stmt list) = Obj.magic _1_inlined9 in
        let _1_inlined8 : unit = Obj.magic _1_inlined8 in
        let _1_inlined7 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined7 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__6_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined7, _1_inlined6, _1_inlined5, _1_inlined4, _3, expr, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined5_, _startpos__1_inlined4_, _1_inlined9, _1_inlined8, _1_inlined7, _1_inlined6, _3_inlined1, expr_inlined1, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2) in
                let _2 =
                  let (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined7, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_if_stmt =
                        let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                        let desc =
                          let simple_else_opt =
                            let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                            let _2 =
                              let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                              let x =
                                let _1 = _1_inlined1 in
                                let _1_1 = _1 in
                                
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 67422 "asllib/Parser0.ml"
                                 _1_1
                              in
                              
# 126 "<standard.mly>"
    ( Some x )
# 67428 "asllib/Parser0.ml"
                              
                            in
                            let _1_1 = _1 in
                            let _2_1 = _2 in
                            
# 698 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 67436 "asllib/Parser0.ml"
                             (_1_1, _2_1)
                          in
                          let simple_stmt_list =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 67445 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 695 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 67451 "asllib/Parser0.ml"
                           (expr, simple_stmt_list, simple_else_opt)
                        in
                        let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                        let _endpos = _endpos_desc_ in
                        let _symbolstartpos = _startpos_desc_ in
                        
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 67460 "asllib/Parser0.ml"
                        
                      in
                      let simple_stmt_list =
                        let _1_1 = _1 in
                        
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 67468 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 621 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 67474 "asllib/Parser0.ml"
                       (simple_stmt_list, simple_if_stmt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 67483 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 67489 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 718 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 67497 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                
# 597 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 67505 "asllib/Parser0.ml"
                
              in
              
# 713 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 67511 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 67520 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 67526 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined4;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = expr;
                      MenhirLib.EngineTypes.startp = _startpos_expr_;
                      MenhirLib.EngineTypes.endp = _endpos_expr_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                let _2 =
                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    let x =
                      let _1_1 = _1 in
                      
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 67612 "asllib/Parser0.ml"
                       _1_1
                    in
                    
# 196 "<standard.mly>"
    ( x )
# 67618 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 67624 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 718 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 67632 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                
# 597 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 67640 "asllib/Parser0.ml"
                
              in
              
# 713 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 67646 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 67655 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 67661 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _1_inlined4;
          MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
          MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined3;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = expr;
                    MenhirLib.EngineTypes.startp = _startpos_expr_;
                    MenhirLib.EngineTypes.endp = _endpos_expr_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_inlined4_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                let _2 =
                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    
# 597 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 67738 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 67744 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 718 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 67752 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                
# 597 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 67760 "asllib/Parser0.ml"
                
              in
              
# 713 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 67766 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined4_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 67775 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 67781 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _6;
          MenhirLib.EngineTypes.startp = _startpos__6_;
          MenhirLib.EngineTypes.endp = _endpos__6_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined4;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = expr;
                      MenhirLib.EngineTypes.startp = _startpos_expr_;
                      MenhirLib.EngineTypes.endp = _endpos_expr_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__6_ in
        let _v =
          let x =
            let desc =
              let simple_else =
                let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                let _2 =
                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    let _1_1 = _1 in
                    
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 67866 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 233 "asllib/Parser0.mly"
                      Some  
# 67872 "asllib/Parser0.ml"
                   x
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 699 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 67880 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let simple_stmt_list =
                let _1 = _1_inlined1 in
                let _1_1 = _1 in
                
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 67889 "asllib/Parser0.ml"
                 _1_1
              in
              
# 714 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 67895 "asllib/Parser0.ml"
               (expr, simple_stmt_list, simple_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 67904 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 67910 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _7;
          MenhirLib.EngineTypes.startp = _startpos__7_;
          MenhirLib.EngineTypes.endp = _endpos__7_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _5;
              MenhirLib.EngineTypes.startp = _startpos__5_;
              MenhirLib.EngineTypes.endp = _endpos__5_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _4;
                MenhirLib.EngineTypes.startp = _startpos__4_;
                MenhirLib.EngineTypes.endp = _endpos__4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = expr;
                    MenhirLib.EngineTypes.startp = _startpos_expr_;
                    MenhirLib.EngineTypes.endp = _endpos_expr_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _7 : unit = Obj.magic _7 in
        let _6 : (AST.case_alt list) = Obj.magic _6 in
        let _5 : unit = Obj.magic _5 in
        let _4 : unit = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__7_ in
        let _v =
          let x =
            let desc =
              let _6_1 = _6 in
              
# 715 "asllib/Parser0.mly"
                                                            AST.S_Case  
# 67982 "asllib/Parser0.ml"
               (expr, _6_1)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__7_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 67991 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 67997 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _4;
          MenhirLib.EngineTypes.startp = _startpos__4_;
          MenhirLib.EngineTypes.endp = _endpos__4_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined4;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2;
              MenhirLib.EngineTypes.startp = _startpos__2_;
              MenhirLib.EngineTypes.endp = _endpos__2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = end_e;
                  MenhirLib.EngineTypes.startp = _startpos_end_e_;
                  MenhirLib.EngineTypes.endp = _endpos_end_e_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = start_e;
                      MenhirLib.EngineTypes.startp = _startpos_start_e_;
                      MenhirLib.EngineTypes.endp = _endpos_start_e_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3;
                        MenhirLib.EngineTypes.startp = _startpos__3_;
                        MenhirLib.EngineTypes.endp = _endpos__3_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let end_e : (AST.expr) = Obj.magic end_e in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let start_e : (AST.expr) = Obj.magic start_e in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 68081 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__4_ in
        let _v =
          let x =
            let desc =
              let body =
                let (_1_inlined1, _1) = (_1_inlined4, _1_inlined3) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 604 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 68097 "asllib/Parser0.ml"
                 _3_1
              in
              let limit = 
# 123 "<standard.mly>"
    ( None )
# 68103 "asllib/Parser0.ml"
               in
              let dir =
                let _1 = _1_inlined2 in
                
# 766 "asllib/Parser0.mly"
                       ( AST.Up )
# 68110 "asllib/Parser0.ml"
                
              in
              let index_name = _1_inlined1 in
              
# 761 "asllib/Parser0.mly"
      ( AST.S_For { index_name; start_e; dir; end_e; body; limit } )
# 68117 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 68126 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 68132 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _4;
          MenhirLib.EngineTypes.startp = _startpos__4_;
          MenhirLib.EngineTypes.endp = _endpos__4_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined5;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined4;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _2;
                  MenhirLib.EngineTypes.startp = _startpos__2_;
                  MenhirLib.EngineTypes.endp = _endpos__2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined3;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = end_e;
                      MenhirLib.EngineTypes.startp = _startpos_end_e_;
                      MenhirLib.EngineTypes.endp = _endpos_end_e_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = start_e;
                          MenhirLib.EngineTypes.startp = _startpos_start_e_;
                          MenhirLib.EngineTypes.endp = _endpos_start_e_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _3;
                            MenhirLib.EngineTypes.startp = _startpos__3_;
                            MenhirLib.EngineTypes.endp = _endpos__3_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _menhir_s;
                                MenhirLib.EngineTypes.semv = _1;
                                MenhirLib.EngineTypes.startp = _startpos__1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_;
                                MenhirLib.EngineTypes.next = _menhir_stack;
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined5 : (AST.stmt list) = Obj.magic _1_inlined5 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _2 : (AST.expr) = Obj.magic _2 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let end_e : (AST.expr) = Obj.magic end_e in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let start_e : (AST.expr) = Obj.magic start_e in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 68230 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__4_ in
        let _v =
          let x =
            let desc =
              let body =
                let (_1_inlined1, _2, _1) = (_1_inlined5, _2_inlined1, _1_inlined4) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 604 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 68246 "asllib/Parser0.ml"
                 _3_1
              in
              let limit =
                let _1 = _1_inlined3 in
                let x = _2 in
                
# 126 "<standard.mly>"
    ( Some x )
# 68255 "asllib/Parser0.ml"
                
              in
              let dir =
                let _1 = _1_inlined2 in
                
# 766 "asllib/Parser0.mly"
                       ( AST.Up )
# 68263 "asllib/Parser0.ml"
                
              in
              let index_name = _1_inlined1 in
              
# 761 "asllib/Parser0.mly"
      ( AST.S_For { index_name; start_e; dir; end_e; body; limit } )
# 68270 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 68279 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 68285 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _4;
          MenhirLib.EngineTypes.startp = _startpos__4_;
          MenhirLib.EngineTypes.endp = _endpos__4_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined4;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2;
              MenhirLib.EngineTypes.startp = _startpos__2_;
              MenhirLib.EngineTypes.endp = _endpos__2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = end_e;
                  MenhirLib.EngineTypes.startp = _startpos_end_e_;
                  MenhirLib.EngineTypes.endp = _endpos_end_e_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = start_e;
                      MenhirLib.EngineTypes.startp = _startpos_start_e_;
                      MenhirLib.EngineTypes.endp = _endpos_start_e_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3;
                        MenhirLib.EngineTypes.startp = _startpos__3_;
                        MenhirLib.EngineTypes.endp = _endpos__3_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let end_e : (AST.expr) = Obj.magic end_e in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let start_e : (AST.expr) = Obj.magic start_e in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 68369 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__4_ in
        let _v =
          let x =
            let desc =
              let body =
                let (_1_inlined1, _1) = (_1_inlined4, _1_inlined3) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 604 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 68385 "asllib/Parser0.ml"
                 _3_1
              in
              let limit = 
# 123 "<standard.mly>"
    ( None )
# 68391 "asllib/Parser0.ml"
               in
              let dir =
                let _1 = _1_inlined2 in
                
# 766 "asllib/Parser0.mly"
                                            ( AST.Down )
# 68398 "asllib/Parser0.ml"
                
              in
              let index_name = _1_inlined1 in
              
# 761 "asllib/Parser0.mly"
      ( AST.S_For { index_name; start_e; dir; end_e; body; limit } )
# 68405 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 68414 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 68420 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _4;
          MenhirLib.EngineTypes.startp = _startpos__4_;
          MenhirLib.EngineTypes.endp = _endpos__4_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined5;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined4;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _2;
                  MenhirLib.EngineTypes.startp = _startpos__2_;
                  MenhirLib.EngineTypes.endp = _endpos__2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined3;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = end_e;
                      MenhirLib.EngineTypes.startp = _startpos_end_e_;
                      MenhirLib.EngineTypes.endp = _endpos_end_e_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = start_e;
                          MenhirLib.EngineTypes.startp = _startpos_start_e_;
                          MenhirLib.EngineTypes.endp = _endpos_start_e_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _3;
                            MenhirLib.EngineTypes.startp = _startpos__3_;
                            MenhirLib.EngineTypes.endp = _endpos__3_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _menhir_s;
                                MenhirLib.EngineTypes.semv = _1;
                                MenhirLib.EngineTypes.startp = _startpos__1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_;
                                MenhirLib.EngineTypes.next = _menhir_stack;
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined5 : (AST.stmt list) = Obj.magic _1_inlined5 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _2 : (AST.expr) = Obj.magic _2 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let end_e : (AST.expr) = Obj.magic end_e in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let start_e : (AST.expr) = Obj.magic start_e in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 68518 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__4_ in
        let _v =
          let x =
            let desc =
              let body =
                let (_1_inlined1, _2, _1) = (_1_inlined5, _2_inlined1, _1_inlined4) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 604 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 68534 "asllib/Parser0.ml"
                 _3_1
              in
              let limit =
                let _1 = _1_inlined3 in
                let x = _2 in
                
# 126 "<standard.mly>"
    ( Some x )
# 68543 "asllib/Parser0.ml"
                
              in
              let dir =
                let _1 = _1_inlined2 in
                
# 766 "asllib/Parser0.mly"
                                            ( AST.Down )
# 68551 "asllib/Parser0.ml"
                
              in
              let index_name = _1_inlined1 in
              
# 761 "asllib/Parser0.mly"
      ( AST.S_For { index_name; start_e; dir; end_e; body; limit } )
# 68558 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 68567 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 68573 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _4_inlined1;
          MenhirLib.EngineTypes.startp = _startpos__4_inlined1_;
          MenhirLib.EngineTypes.endp = _endpos__4_inlined1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined2;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2;
              MenhirLib.EngineTypes.startp = _startpos__2_;
              MenhirLib.EngineTypes.endp = _endpos__2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _4;
                  MenhirLib.EngineTypes.startp = _startpos__4_;
                  MenhirLib.EngineTypes.endp = _endpos__4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = expr;
                    MenhirLib.EngineTypes.startp = _startpos_expr_;
                    MenhirLib.EngineTypes.endp = _endpos_expr_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _4_inlined1 : unit = Obj.magic _4_inlined1 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _4 : unit = Obj.magic _4 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__4_inlined1_ in
        let _v =
          let x =
            let desc =
              let indented_block =
                let (_4, _1_inlined1, _1) = (_4_inlined1, _1_inlined2, _1_inlined1) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 604 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 68648 "asllib/Parser0.ml"
                 _3_1
              in
              let _3 = 
# 123 "<standard.mly>"
    ( None )
# 68654 "asllib/Parser0.ml"
               in
              let _3_1 = _3 in
              
# 762 "asllib/Parser0.mly"
                                                                  AST.S_While 
# 68660 "asllib/Parser0.ml"
               (expr, _3_1, indented_block)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__4_inlined1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 68669 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 68675 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _4_inlined1;
          MenhirLib.EngineTypes.startp = _startpos__4_inlined1_;
          MenhirLib.EngineTypes.endp = _endpos__4_inlined1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined3;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _4;
                  MenhirLib.EngineTypes.startp = _startpos__4_;
                  MenhirLib.EngineTypes.endp = _endpos__4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _2;
                    MenhirLib.EngineTypes.startp = _startpos__2_;
                    MenhirLib.EngineTypes.endp = _endpos__2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = expr;
                        MenhirLib.EngineTypes.startp = _startpos_expr_;
                        MenhirLib.EngineTypes.endp = _endpos_expr_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _4_inlined1 : unit = Obj.magic _4_inlined1 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _4 : unit = Obj.magic _4 in
        let _2 : (AST.expr) = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__4_inlined1_ in
        let _v =
          let x =
            let desc =
              let indented_block =
                let (_4, _1_inlined1, _2, _1) = (_4_inlined1, _1_inlined3, _2_inlined1, _1_inlined2) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 604 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 68764 "asllib/Parser0.ml"
                 _3_1
              in
              let _3 =
                let _1 = _1_inlined1 in
                let x = _2 in
                
# 126 "<standard.mly>"
    ( Some x )
# 68773 "asllib/Parser0.ml"
                
              in
              let _3_1 = _3 in
              
# 762 "asllib/Parser0.mly"
                                                                  AST.S_While 
# 68780 "asllib/Parser0.ml"
               (expr, _3_1, indented_block)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__4_inlined1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 68789 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 68795 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _7;
          MenhirLib.EngineTypes.startp = _startpos__7_;
          MenhirLib.EngineTypes.endp = _endpos__7_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _4;
                  MenhirLib.EngineTypes.startp = _startpos__4_;
                  MenhirLib.EngineTypes.endp = _endpos__4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _2;
                      MenhirLib.EngineTypes.startp = _startpos__2_;
                      MenhirLib.EngineTypes.endp = _endpos__2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _7 : unit = Obj.magic _7 in
        let _6 : unit = Obj.magic _6 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__7_ in
        let _v =
          let x =
            let desc =
              let _5 = 
# 123 "<standard.mly>"
    ( None )
# 68880 "asllib/Parser0.ml"
               in
              let indented_block =
                let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 604 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 68889 "asllib/Parser0.ml"
                 _3_1
              in
              let _5_1 = _5 in
              
# 764 "asllib/Parser0.mly"
                       AST.S_Repeat 
# 68896 "asllib/Parser0.ml"
               (indented_block, expr, _5_1)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__7_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 68905 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 68911 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _7;
          MenhirLib.EngineTypes.startp = _startpos__7_;
          MenhirLib.EngineTypes.endp = _endpos__7_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = expr;
                  MenhirLib.EngineTypes.startp = _startpos_expr_;
                  MenhirLib.EngineTypes.endp = _endpos_expr_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _4;
                      MenhirLib.EngineTypes.startp = _startpos__4_;
                      MenhirLib.EngineTypes.endp = _endpos__4_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _2;
                          MenhirLib.EngineTypes.startp = _startpos__2_;
                          MenhirLib.EngineTypes.endp = _endpos__2_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = _1;
                              MenhirLib.EngineTypes.startp = _startpos__1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _7 : unit = Obj.magic _7 in
        let _6 : unit = Obj.magic _6 in
        let _2_inlined1 : (AST.expr) = Obj.magic _2_inlined1 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__7_ in
        let _v =
          let x =
            let desc =
              let _5 =
                let (_2, _1) = (_2_inlined1, _1_inlined3) in
                let x = _2 in
                
# 126 "<standard.mly>"
    ( Some x )
# 69013 "asllib/Parser0.ml"
                
              in
              let indented_block =
                let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 604 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 69023 "asllib/Parser0.ml"
                 _3_1
              in
              let _5_1 = _5 in
              
# 764 "asllib/Parser0.mly"
                       AST.S_Repeat 
# 69030 "asllib/Parser0.ml"
               (indented_block, expr, _5_1)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__7_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 69039 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 69045 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _9;
          MenhirLib.EngineTypes.startp = _startpos__9_;
          MenhirLib.EngineTypes.endp = _endpos__9_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined4;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _6;
              MenhirLib.EngineTypes.startp = _startpos__6_;
              MenhirLib.EngineTypes.endp = _endpos__6_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _5;
                MenhirLib.EngineTypes.startp = _startpos__5_;
                MenhirLib.EngineTypes.endp = _endpos__5_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _4_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__4_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__4_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _2;
                          MenhirLib.EngineTypes.startp = _startpos__2_;
                          MenhirLib.EngineTypes.endp = _endpos__2_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = _1;
                              MenhirLib.EngineTypes.startp = _startpos__1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _9 : unit = Obj.magic _9 in
        let _1_inlined4 : (unit list) = Obj.magic _1_inlined4 in
        let _6 : unit = Obj.magic _6 in
        let _5 : unit = Obj.magic _5 in
        let _1_inlined3 : (
# 82 "asllib/Parser0.mly"
       (string)
# 69131 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _4_inlined1 : unit = Obj.magic _4_inlined1 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__9_ in
        let _v =
          let x =
            let desc =
              let _1 =
                let _1 =
                  let _8 = 
# 123 "<standard.mly>"
    ( None )
# 69150 "asllib/Parser0.ml"
                   in
                  let _7 = _1_inlined4 in
                  let _4 = _1_inlined3 in
                  let _2 =
                    let (_4, _1_inlined1, _1) = (_4_inlined1, _1_inlined2, _1_inlined1) in
                    let _3 = _1_inlined1 in
                    let _3_1 = _3 in
                    
# 604 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 69161 "asllib/Parser0.ml"
                     _3_1
                  in
                  ()
                in
                ()
              in
              
# 612 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 69171 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__9_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 69180 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 69186 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _9;
          MenhirLib.EngineTypes.startp = _startpos__9_;
          MenhirLib.EngineTypes.endp = _endpos__9_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined7;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined6;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined5;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined4;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _6;
                        MenhirLib.EngineTypes.startp = _startpos__6_;
                        MenhirLib.EngineTypes.endp = _endpos__6_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _5;
                          MenhirLib.EngineTypes.startp = _startpos__5_;
                          MenhirLib.EngineTypes.endp = _endpos__5_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined3;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _3;
                              MenhirLib.EngineTypes.startp = _startpos__3_;
                              MenhirLib.EngineTypes.endp = _endpos__3_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _4_inlined1;
                                MenhirLib.EngineTypes.startp = _startpos__4_inlined1_;
                                MenhirLib.EngineTypes.endp = _endpos__4_inlined1_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _1_inlined2;
                                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _2;
                                    MenhirLib.EngineTypes.startp = _startpos__2_;
                                    MenhirLib.EngineTypes.endp = _endpos__2_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = _1_inlined1;
                                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _menhir_s;
                                        MenhirLib.EngineTypes.semv = _1;
                                        MenhirLib.EngineTypes.startp = _startpos__1_;
                                        MenhirLib.EngineTypes.endp = _endpos__1_;
                                        MenhirLib.EngineTypes.next = _menhir_stack;
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _9 : unit = Obj.magic _9 in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined7 : (AST.stmt list) = Obj.magic _1_inlined7 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined6 : unit = Obj.magic _1_inlined6 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : (unit list) = Obj.magic _1_inlined4 in
        let _6 : unit = Obj.magic _6 in
        let _5 : unit = Obj.magic _5 in
        let _1_inlined3 : (
# 82 "asllib/Parser0.mly"
       (string)
# 69307 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _4_inlined1 : unit = Obj.magic _4_inlined1 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__9_ in
        let _v =
          let x =
            let desc =
              let _1 =
                let _1 =
                  let _8 =
                    let (_startpos__1_, _1_inlined2, _2, _1_inlined1, _1) = (_startpos__1_inlined5_, _1_inlined7, _2_inlined1, _1_inlined6, _1_inlined5) in
                    let x =
                      let desc =
                        let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                        let _3 = _1_inlined1 in
                        let _3_1 = _3 in
                        
# 604 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 69333 "asllib/Parser0.ml"
                         _3_1
                      in
                      let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
                      let _endpos = _endpos_desc_ in
                      let _symbolstartpos = _startpos_desc_ in
                      
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 69342 "asllib/Parser0.ml"
                      
                    in
                    
# 126 "<standard.mly>"
    ( Some x )
# 69348 "asllib/Parser0.ml"
                    
                  in
                  let _7 = _1_inlined4 in
                  let _4 = _1_inlined3 in
                  let _2 =
                    let (_4, _1_inlined1, _1) = (_4_inlined1, _1_inlined2, _1_inlined1) in
                    let _3 = _1_inlined1 in
                    let _3_1 = _3 in
                    
# 604 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 69360 "asllib/Parser0.ml"
                     _3_1
                  in
                  ()
                in
                ()
              in
              
# 612 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 69370 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__9_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 69379 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 69385 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _9;
          MenhirLib.EngineTypes.startp = _startpos__9_;
          MenhirLib.EngineTypes.endp = _endpos__9_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__6_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__6_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined9;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined9_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined9_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined8;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = expr;
                    MenhirLib.EngineTypes.startp = _startpos_expr_;
                    MenhirLib.EngineTypes.endp = _endpos_expr_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined7;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined6;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined5;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined4;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _6;
                              MenhirLib.EngineTypes.startp = _startpos__6_;
                              MenhirLib.EngineTypes.endp = _endpos__6_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _5;
                                MenhirLib.EngineTypes.startp = _startpos__5_;
                                MenhirLib.EngineTypes.endp = _endpos__5_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _1_inlined3;
                                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _3;
                                    MenhirLib.EngineTypes.startp = _startpos__3_;
                                    MenhirLib.EngineTypes.endp = _endpos__3_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = _4_inlined1;
                                      MenhirLib.EngineTypes.startp = _startpos__4_inlined1_;
                                      MenhirLib.EngineTypes.endp = _endpos__4_inlined1_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _;
                                        MenhirLib.EngineTypes.semv = _1_inlined2;
                                        MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                        MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                        MenhirLib.EngineTypes.next = {
                                          MenhirLib.EngineTypes.state = _;
                                          MenhirLib.EngineTypes.semv = _2;
                                          MenhirLib.EngineTypes.startp = _startpos__2_;
                                          MenhirLib.EngineTypes.endp = _endpos__2_;
                                          MenhirLib.EngineTypes.next = {
                                            MenhirLib.EngineTypes.state = _;
                                            MenhirLib.EngineTypes.semv = _1_inlined1;
                                            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                            MenhirLib.EngineTypes.next = {
                                              MenhirLib.EngineTypes.state = _menhir_s;
                                              MenhirLib.EngineTypes.semv = _1;
                                              MenhirLib.EngineTypes.startp = _startpos__1_;
                                              MenhirLib.EngineTypes.endp = _endpos__1_;
                                              MenhirLib.EngineTypes.next = _menhir_stack;
                                            };
                                          };
                                        };
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _9 : unit = Obj.magic _9 in
        let _6_inlined1 : unit = Obj.magic _6_inlined1 in
        let _1_inlined9 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined9 in
        let _1_inlined8 : (AST.stmt list) = Obj.magic _1_inlined8 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1_inlined7 : unit = Obj.magic _1_inlined7 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : (unit list) = Obj.magic _1_inlined4 in
        let _6 : unit = Obj.magic _6 in
        let _5 : unit = Obj.magic _5 in
        let _1_inlined3 : (
# 82 "asllib/Parser0.mly"
       (string)
# 69527 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _4_inlined1 : unit = Obj.magic _4_inlined1 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__9_ in
        let _v =
          let x =
            let desc =
              let _1 =
                let _1 =
                  let _8 =
                    let (_endpos__6_, _startpos__1_inlined2_, _startpos__1_inlined1_, _startpos__1_, _6, _1_inlined4, _1_inlined3, _3, _1_inlined2, _1_inlined1, _1) = (_endpos__6_inlined1_, _startpos__1_inlined7_, _startpos__1_inlined6_, _startpos__1_inlined5_, _6_inlined1, _1_inlined9, _1_inlined8, _3_inlined1, _1_inlined7, _1_inlined6, _1_inlined5) in
                    let x =
                      let desc =
                        let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                        let desc =
                          let simple_if_stmt =
                            let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                            let desc =
                              let simple_else_opt =
                                let _1 = _1_inlined2 in
                                let _2 = 
# 123 "<standard.mly>"
    ( None )
# 69557 "asllib/Parser0.ml"
                                 in
                                let _1_1 = _1 in
                                let _2_1 = _2 in
                                
# 698 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 69564 "asllib/Parser0.ml"
                                 (_1_1, _2_1)
                              in
                              let simple_stmt_list =
                                let _1 = _1_inlined1 in
                                let _1_1 = _1 in
                                
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 69573 "asllib/Parser0.ml"
                                 _1_1
                              in
                              
# 695 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 69579 "asllib/Parser0.ml"
                               (expr, simple_stmt_list, simple_else_opt)
                            in
                            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                            let _endpos = _endpos_desc_ in
                            let _symbolstartpos = _startpos_desc_ in
                            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 69588 "asllib/Parser0.ml"
                            
                          in
                          let simple_stmt_list =
                            let _1_1 = _1 in
                            
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 69596 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 621 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 69602 "asllib/Parser0.ml"
                           (simple_stmt_list, simple_if_stmt)
                        in
                        let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                        let _endpos = _endpos_desc_ in
                        let _symbolstartpos = _startpos_desc_ in
                        
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 69611 "asllib/Parser0.ml"
                        
                      in
                      let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                      let _endpos = _endpos_desc_ in
                      let _symbolstartpos = _startpos_desc_ in
                      
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 69620 "asllib/Parser0.ml"
                      
                    in
                    
# 126 "<standard.mly>"
    ( Some x )
# 69626 "asllib/Parser0.ml"
                    
                  in
                  let _7 = _1_inlined4 in
                  let _4 = _1_inlined3 in
                  let _2 =
                    let (_4, _1_inlined1, _1) = (_4_inlined1, _1_inlined2, _1_inlined1) in
                    let _3 = _1_inlined1 in
                    let _3_1 = _3 in
                    
# 604 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 69638 "asllib/Parser0.ml"
                     _3_1
                  in
                  ()
                in
                ()
              in
              
# 612 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 69648 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__9_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 69657 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 69663 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _9;
          MenhirLib.EngineTypes.startp = _startpos__9_;
          MenhirLib.EngineTypes.endp = _endpos__9_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__6_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__6_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined11;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined11_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined11_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined10;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined10_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined10_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined9;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined9_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined9_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined8;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = expr;
                        MenhirLib.EngineTypes.startp = _startpos_expr_;
                        MenhirLib.EngineTypes.endp = _endpos_expr_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined7;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined6;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined5;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined4;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _6;
                                  MenhirLib.EngineTypes.startp = _startpos__6_;
                                  MenhirLib.EngineTypes.endp = _endpos__6_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _5;
                                    MenhirLib.EngineTypes.startp = _startpos__5_;
                                    MenhirLib.EngineTypes.endp = _endpos__5_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = _1_inlined3;
                                      MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                                      MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _;
                                        MenhirLib.EngineTypes.semv = _3;
                                        MenhirLib.EngineTypes.startp = _startpos__3_;
                                        MenhirLib.EngineTypes.endp = _endpos__3_;
                                        MenhirLib.EngineTypes.next = {
                                          MenhirLib.EngineTypes.state = _;
                                          MenhirLib.EngineTypes.semv = _4_inlined1;
                                          MenhirLib.EngineTypes.startp = _startpos__4_inlined1_;
                                          MenhirLib.EngineTypes.endp = _endpos__4_inlined1_;
                                          MenhirLib.EngineTypes.next = {
                                            MenhirLib.EngineTypes.state = _;
                                            MenhirLib.EngineTypes.semv = _1_inlined2;
                                            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                            MenhirLib.EngineTypes.next = {
                                              MenhirLib.EngineTypes.state = _;
                                              MenhirLib.EngineTypes.semv = _2;
                                              MenhirLib.EngineTypes.startp = _startpos__2_;
                                              MenhirLib.EngineTypes.endp = _endpos__2_;
                                              MenhirLib.EngineTypes.next = {
                                                MenhirLib.EngineTypes.state = _;
                                                MenhirLib.EngineTypes.semv = _1_inlined1;
                                                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                                MenhirLib.EngineTypes.next = {
                                                  MenhirLib.EngineTypes.state = _menhir_s;
                                                  MenhirLib.EngineTypes.semv = _1;
                                                  MenhirLib.EngineTypes.startp = _startpos__1_;
                                                  MenhirLib.EngineTypes.endp = _endpos__1_;
                                                  MenhirLib.EngineTypes.next = _menhir_stack;
                                                };
                                              };
                                            };
                                          };
                                        };
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _9 : unit = Obj.magic _9 in
        let _6_inlined1 : unit = Obj.magic _6_inlined1 in
        let _1_inlined11 : (AST.stmt list) = Obj.magic _1_inlined11 in
        let _1_inlined10 : unit = Obj.magic _1_inlined10 in
        let _1_inlined9 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined9 in
        let _1_inlined8 : (AST.stmt list) = Obj.magic _1_inlined8 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1_inlined7 : unit = Obj.magic _1_inlined7 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : (unit list) = Obj.magic _1_inlined4 in
        let _6 : unit = Obj.magic _6 in
        let _5 : unit = Obj.magic _5 in
        let _1_inlined3 : (
# 82 "asllib/Parser0.mly"
       (string)
# 69819 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _4_inlined1 : unit = Obj.magic _4_inlined1 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__9_ in
        let _v =
          let x =
            let desc =
              let _1 =
                let _1 =
                  let _8 =
                    let (_endpos__6_, _startpos__1_inlined2_, _startpos__1_inlined1_, _startpos__1_, _6, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _3, _1_inlined2, _1_inlined1, _1) = (_endpos__6_inlined1_, _startpos__1_inlined7_, _startpos__1_inlined6_, _startpos__1_inlined5_, _6_inlined1, _1_inlined11, _1_inlined10, _1_inlined9, _1_inlined8, _3_inlined1, _1_inlined7, _1_inlined6, _1_inlined5) in
                    let x =
                      let desc =
                        let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                        let desc =
                          let simple_if_stmt =
                            let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                            let desc =
                              let simple_else_opt =
                                let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                                let _2 =
                                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                                  let x =
                                    let _1 = _1_inlined1 in
                                    let _1_1 = _1 in
                                    
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 69854 "asllib/Parser0.ml"
                                     _1_1
                                  in
                                  
# 126 "<standard.mly>"
    ( Some x )
# 69860 "asllib/Parser0.ml"
                                  
                                in
                                let _1_1 = _1 in
                                let _2_1 = _2 in
                                
# 698 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 69868 "asllib/Parser0.ml"
                                 (_1_1, _2_1)
                              in
                              let simple_stmt_list =
                                let _1 = _1_inlined1 in
                                let _1_1 = _1 in
                                
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 69877 "asllib/Parser0.ml"
                                 _1_1
                              in
                              
# 695 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 69883 "asllib/Parser0.ml"
                               (expr, simple_stmt_list, simple_else_opt)
                            in
                            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                            let _endpos = _endpos_desc_ in
                            let _symbolstartpos = _startpos_desc_ in
                            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 69892 "asllib/Parser0.ml"
                            
                          in
                          let simple_stmt_list =
                            let _1_1 = _1 in
                            
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 69900 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 621 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 69906 "asllib/Parser0.ml"
                           (simple_stmt_list, simple_if_stmt)
                        in
                        let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                        let _endpos = _endpos_desc_ in
                        let _symbolstartpos = _startpos_desc_ in
                        
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 69915 "asllib/Parser0.ml"
                        
                      in
                      let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                      let _endpos = _endpos_desc_ in
                      let _symbolstartpos = _startpos_desc_ in
                      
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 69924 "asllib/Parser0.ml"
                      
                    in
                    
# 126 "<standard.mly>"
    ( Some x )
# 69930 "asllib/Parser0.ml"
                    
                  in
                  let _7 = _1_inlined4 in
                  let _4 = _1_inlined3 in
                  let _2 =
                    let (_4, _1_inlined1, _1) = (_4_inlined1, _1_inlined2, _1_inlined1) in
                    let _3 = _1_inlined1 in
                    let _3_1 = _3 in
                    
# 604 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 69942 "asllib/Parser0.ml"
                     _3_1
                  in
                  ()
                in
                ()
              in
              
# 612 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 69952 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__9_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 69961 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 69967 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _9;
          MenhirLib.EngineTypes.startp = _startpos__9_;
          MenhirLib.EngineTypes.endp = _endpos__9_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined6;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined5;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined4;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _6;
                    MenhirLib.EngineTypes.startp = _startpos__6_;
                    MenhirLib.EngineTypes.endp = _endpos__6_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _5;
                      MenhirLib.EngineTypes.startp = _startpos__5_;
                      MenhirLib.EngineTypes.endp = _endpos__5_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined3;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _3;
                          MenhirLib.EngineTypes.startp = _startpos__3_;
                          MenhirLib.EngineTypes.endp = _endpos__3_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _4_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__4_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__4_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined2;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _2;
                                MenhirLib.EngineTypes.startp = _startpos__2_;
                                MenhirLib.EngineTypes.endp = _endpos__2_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _1_inlined1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _menhir_s;
                                    MenhirLib.EngineTypes.semv = _1;
                                    MenhirLib.EngineTypes.startp = _startpos__1_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_;
                                    MenhirLib.EngineTypes.next = _menhir_stack;
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _9 : unit = Obj.magic _9 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : (unit list) = Obj.magic _1_inlined4 in
        let _6 : unit = Obj.magic _6 in
        let _5 : unit = Obj.magic _5 in
        let _1_inlined3 : (
# 82 "asllib/Parser0.mly"
       (string)
# 70074 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _4_inlined1 : unit = Obj.magic _4_inlined1 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__9_ in
        let _v =
          let x =
            let desc =
              let _1 =
                let _1 =
                  let _8 =
                    let (_endpos__2_, _startpos__1_, _1_inlined1, _1) = (_endpos__2_inlined1_, _startpos__1_inlined5_, _1_inlined6, _1_inlined5) in
                    let x =
                      let desc =
                        let _1 = _1_inlined1 in
                        let x =
                          let _1_1 = _1 in
                          
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 70100 "asllib/Parser0.ml"
                           _1_1
                        in
                        
# 196 "<standard.mly>"
    ( x )
# 70106 "asllib/Parser0.ml"
                        
                      in
                      let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
                      let _endpos = _endpos_desc_ in
                      let _symbolstartpos = _startpos_desc_ in
                      
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 70115 "asllib/Parser0.ml"
                      
                    in
                    
# 126 "<standard.mly>"
    ( Some x )
# 70121 "asllib/Parser0.ml"
                    
                  in
                  let _7 = _1_inlined4 in
                  let _4 = _1_inlined3 in
                  let _2 =
                    let (_4, _1_inlined1, _1) = (_4_inlined1, _1_inlined2, _1_inlined1) in
                    let _3 = _1_inlined1 in
                    let _3_1 = _3 in
                    
# 604 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 70133 "asllib/Parser0.ml"
                     _3_1
                  in
                  ()
                in
                ()
              in
              
# 612 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 70143 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__9_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 70152 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 70158 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _9;
          MenhirLib.EngineTypes.startp = _startpos__9_;
          MenhirLib.EngineTypes.endp = _endpos__9_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined6;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined5;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined4;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _6;
                  MenhirLib.EngineTypes.startp = _startpos__6_;
                  MenhirLib.EngineTypes.endp = _endpos__6_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _5;
                    MenhirLib.EngineTypes.startp = _startpos__5_;
                    MenhirLib.EngineTypes.endp = _endpos__5_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined3;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3;
                        MenhirLib.EngineTypes.startp = _startpos__3_;
                        MenhirLib.EngineTypes.endp = _endpos__3_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _4_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__4_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__4_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined2;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _2;
                              MenhirLib.EngineTypes.startp = _startpos__2_;
                              MenhirLib.EngineTypes.endp = _endpos__2_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined1;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _menhir_s;
                                  MenhirLib.EngineTypes.semv = _1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_;
                                  MenhirLib.EngineTypes.next = _menhir_stack;
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _9 : unit = Obj.magic _9 in
        let _1_inlined6 : unit = Obj.magic _1_inlined6 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : (unit list) = Obj.magic _1_inlined4 in
        let _6 : unit = Obj.magic _6 in
        let _5 : unit = Obj.magic _5 in
        let _1_inlined3 : (
# 82 "asllib/Parser0.mly"
       (string)
# 70258 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _4_inlined1 : unit = Obj.magic _4_inlined1 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__9_ in
        let _v =
          let x =
            let desc =
              let _1 =
                let _1 =
                  let _8 =
                    let (_endpos__1_inlined1_, _startpos__1_, _1_inlined1, _1) = (_endpos__1_inlined6_, _startpos__1_inlined5_, _1_inlined6, _1_inlined5) in
                    let x =
                      let desc =
                        let _1 = _1_inlined1 in
                        
# 597 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 70282 "asllib/Parser0.ml"
                        
                      in
                      let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined1_, _startpos__1_) in
                      let _endpos = _endpos_desc_ in
                      let _symbolstartpos = _startpos_desc_ in
                      
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 70291 "asllib/Parser0.ml"
                      
                    in
                    
# 126 "<standard.mly>"
    ( Some x )
# 70297 "asllib/Parser0.ml"
                    
                  in
                  let _7 = _1_inlined4 in
                  let _4 = _1_inlined3 in
                  let _2 =
                    let (_4, _1_inlined1, _1) = (_4_inlined1, _1_inlined2, _1_inlined1) in
                    let _3 = _1_inlined1 in
                    let _3_1 = _3 in
                    
# 604 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 70309 "asllib/Parser0.ml"
                     _3_1
                  in
                  ()
                in
                ()
              in
              
# 612 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 70319 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__9_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 70328 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 70334 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = expr;
                    MenhirLib.EngineTypes.startp = _startpos_expr_;
                    MenhirLib.EngineTypes.endp = _endpos_expr_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined3 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined3 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (AST.stmt list) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let simple_if_stmt =
                let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_else_opt =
                    let _1 = _1_inlined2 in
                    let _2 = 
# 123 "<standard.mly>"
    ( None )
# 70417 "asllib/Parser0.ml"
                     in
                    let _1_1 = _1 in
                    let _2_1 = _2 in
                    
# 698 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 70424 "asllib/Parser0.ml"
                     (_1_1, _2_1)
                  in
                  let simple_stmt_list =
                    let _1 = _1_inlined1 in
                    let _1_1 = _1 in
                    
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 70433 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 695 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 70439 "asllib/Parser0.ml"
                   (expr, simple_stmt_list, simple_else_opt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 70448 "asllib/Parser0.ml"
                
              in
              let simple_stmt_list =
                let _1_1 = _1 in
                
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 70456 "asllib/Parser0.ml"
                 _1_1
              in
              
# 621 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 70462 "asllib/Parser0.ml"
               (simple_stmt_list, simple_if_stmt)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 70471 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 70477 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined5;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined4;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3;
                      MenhirLib.EngineTypes.startp = _startpos__3_;
                      MenhirLib.EngineTypes.endp = _endpos__3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = expr;
                        MenhirLib.EngineTypes.startp = _startpos_expr_;
                        MenhirLib.EngineTypes.endp = _endpos_expr_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined5 : (AST.stmt list) = Obj.magic _1_inlined5 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _1_inlined3 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined3 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (AST.stmt list) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let simple_if_stmt =
                let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_else_opt =
                    let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                    let _2 =
                      let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                      let x =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 70579 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 126 "<standard.mly>"
    ( Some x )
# 70585 "asllib/Parser0.ml"
                      
                    in
                    let _1_1 = _1 in
                    let _2_1 = _2 in
                    
# 698 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 70593 "asllib/Parser0.ml"
                     (_1_1, _2_1)
                  in
                  let simple_stmt_list =
                    let _1 = _1_inlined1 in
                    let _1_1 = _1 in
                    
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 70602 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 695 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 70608 "asllib/Parser0.ml"
                   (expr, simple_stmt_list, simple_else_opt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 70617 "asllib/Parser0.ml"
                
              in
              let simple_stmt_list =
                let _1_1 = _1 in
                
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 70625 "asllib/Parser0.ml"
                 _1_1
              in
              
# 621 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 70631 "asllib/Parser0.ml"
               (simple_stmt_list, simple_if_stmt)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 70640 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 70646 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1 : (AST.stmt list) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let _1_1 = _1 in
              
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 70690 "asllib/Parser0.ml"
               _1_1
            in
            
# 196 "<standard.mly>"
    ( x )
# 70696 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 70702 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined3;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _4;
              MenhirLib.EngineTypes.startp = _startpos__4_;
              MenhirLib.EngineTypes.endp = _endpos__4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _2;
                  MenhirLib.EngineTypes.startp = _startpos__2_;
                  MenhirLib.EngineTypes.endp = _endpos__2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3;
                      MenhirLib.EngineTypes.startp = _startpos__3_;
                      MenhirLib.EngineTypes.endp = _endpos__3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = expr;
                        MenhirLib.EngineTypes.startp = _startpos_expr_;
                        MenhirLib.EngineTypes.endp = _endpos_expr_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _1_inlined3 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined3 in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let _1 = _1_inlined3 in
                let _2 = 
# 123 "<standard.mly>"
    ( None )
# 70789 "asllib/Parser0.ml"
                 in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 718 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 70796 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 604 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 70806 "asllib/Parser0.ml"
                 _3_1
              in
              
# 713 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 70812 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined3_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 70821 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 70827 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__4_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__4_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined6;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined5;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined4;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined3;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _4;
                        MenhirLib.EngineTypes.startp = _startpos__4_;
                        MenhirLib.EngineTypes.endp = _endpos__4_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined2;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _2;
                            MenhirLib.EngineTypes.startp = _startpos__2_;
                            MenhirLib.EngineTypes.endp = _endpos__2_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _3;
                                MenhirLib.EngineTypes.startp = _startpos__3_;
                                MenhirLib.EngineTypes.endp = _endpos__3_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = expr;
                                  MenhirLib.EngineTypes.startp = _startpos_expr_;
                                  MenhirLib.EngineTypes.endp = _endpos_expr_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _menhir_s;
                                    MenhirLib.EngineTypes.semv = _1;
                                    MenhirLib.EngineTypes.startp = _startpos__1_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_;
                                    MenhirLib.EngineTypes.next = _menhir_stack;
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _4_inlined1 : unit = Obj.magic _4_inlined1 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _1_inlined3 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined3 in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_4, _1_inlined3, _2, _1_inlined2, _1_inlined1, _1) = (_4_inlined1, _1_inlined6, _2_inlined1, _1_inlined5, _1_inlined4, _1_inlined3) in
                let _2 =
                  let (_1_inlined2, _1_inlined1, _1) = (_1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                    let _3 = _1_inlined1 in
                    let _3_1 = _3 in
                    
# 604 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 70955 "asllib/Parser0.ml"
                     _3_1
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 70961 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 718 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 70969 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 604 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 70979 "asllib/Parser0.ml"
                 _3_1
              in
              
# 713 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 70985 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__4_inlined1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 70994 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 71000 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined8;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined7;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = expr_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined6;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined5;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined4;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined3;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _4;
                              MenhirLib.EngineTypes.startp = _startpos__4_;
                              MenhirLib.EngineTypes.endp = _endpos__4_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined2;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _2;
                                  MenhirLib.EngineTypes.startp = _startpos__2_;
                                  MenhirLib.EngineTypes.endp = _endpos__2_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _1_inlined1;
                                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = _3;
                                      MenhirLib.EngineTypes.startp = _startpos__3_;
                                      MenhirLib.EngineTypes.endp = _endpos__3_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _;
                                        MenhirLib.EngineTypes.semv = expr;
                                        MenhirLib.EngineTypes.startp = _startpos_expr_;
                                        MenhirLib.EngineTypes.endp = _endpos_expr_;
                                        MenhirLib.EngineTypes.next = {
                                          MenhirLib.EngineTypes.state = _menhir_s;
                                          MenhirLib.EngineTypes.semv = _1;
                                          MenhirLib.EngineTypes.startp = _startpos__1_;
                                          MenhirLib.EngineTypes.endp = _endpos__1_;
                                          MenhirLib.EngineTypes.next = _menhir_stack;
                                        };
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined8 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined8 in
        let _1_inlined7 : (AST.stmt list) = Obj.magic _1_inlined7 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined6 : unit = Obj.magic _1_inlined6 in
        let _1_inlined5 : (AST.stmt list) = Obj.magic _1_inlined5 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _1_inlined3 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined3 in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined5, _1_inlined4, _3, expr, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined6_, _startpos__1_inlined5_, _1_inlined8, _1_inlined7, _3_inlined1, expr_inlined1, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3) in
                let _2 =
                  let (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_if_stmt =
                        let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                        let desc =
                          let simple_else_opt =
                            let _1 = _1_inlined2 in
                            let _2 = 
# 123 "<standard.mly>"
    ( None )
# 71153 "asllib/Parser0.ml"
                             in
                            let _1_1 = _1 in
                            let _2_1 = _2 in
                            
# 698 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 71160 "asllib/Parser0.ml"
                             (_1_1, _2_1)
                          in
                          let simple_stmt_list =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 71169 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 695 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 71175 "asllib/Parser0.ml"
                           (expr, simple_stmt_list, simple_else_opt)
                        in
                        let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                        let _endpos = _endpos_desc_ in
                        let _symbolstartpos = _startpos_desc_ in
                        
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 71184 "asllib/Parser0.ml"
                        
                      in
                      let simple_stmt_list =
                        let _1_1 = _1 in
                        
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 71192 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 621 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 71198 "asllib/Parser0.ml"
                       (simple_stmt_list, simple_if_stmt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 71207 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 71213 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 718 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 71221 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 604 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 71231 "asllib/Parser0.ml"
                 _3_1
              in
              
# 713 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 71237 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 71246 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 71252 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined10;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined10_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined10_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined9;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined9_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined9_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined8;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined7;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = expr_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined6;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined5;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined4;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined3;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _4;
                                  MenhirLib.EngineTypes.startp = _startpos__4_;
                                  MenhirLib.EngineTypes.endp = _endpos__4_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _1_inlined2;
                                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = _2;
                                      MenhirLib.EngineTypes.startp = _startpos__2_;
                                      MenhirLib.EngineTypes.endp = _endpos__2_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _;
                                        MenhirLib.EngineTypes.semv = _1_inlined1;
                                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                        MenhirLib.EngineTypes.next = {
                                          MenhirLib.EngineTypes.state = _;
                                          MenhirLib.EngineTypes.semv = _3;
                                          MenhirLib.EngineTypes.startp = _startpos__3_;
                                          MenhirLib.EngineTypes.endp = _endpos__3_;
                                          MenhirLib.EngineTypes.next = {
                                            MenhirLib.EngineTypes.state = _;
                                            MenhirLib.EngineTypes.semv = expr;
                                            MenhirLib.EngineTypes.startp = _startpos_expr_;
                                            MenhirLib.EngineTypes.endp = _endpos_expr_;
                                            MenhirLib.EngineTypes.next = {
                                              MenhirLib.EngineTypes.state = _menhir_s;
                                              MenhirLib.EngineTypes.semv = _1;
                                              MenhirLib.EngineTypes.startp = _startpos__1_;
                                              MenhirLib.EngineTypes.endp = _endpos__1_;
                                              MenhirLib.EngineTypes.next = _menhir_stack;
                                            };
                                          };
                                        };
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined10 : (AST.stmt list) = Obj.magic _1_inlined10 in
        let _1_inlined9 : unit = Obj.magic _1_inlined9 in
        let _1_inlined8 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined8 in
        let _1_inlined7 : (AST.stmt list) = Obj.magic _1_inlined7 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined6 : unit = Obj.magic _1_inlined6 in
        let _1_inlined5 : (AST.stmt list) = Obj.magic _1_inlined5 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _1_inlined3 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined3 in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined7, _1_inlined6, _1_inlined5, _1_inlined4, _3, expr, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined6_, _startpos__1_inlined5_, _1_inlined10, _1_inlined9, _1_inlined8, _1_inlined7, _3_inlined1, expr_inlined1, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3) in
                let _2 =
                  let (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined7, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_if_stmt =
                        let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                        let desc =
                          let simple_else_opt =
                            let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                            let _2 =
                              let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                              let x =
                                let _1 = _1_inlined1 in
                                let _1_1 = _1 in
                                
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 71424 "asllib/Parser0.ml"
                                 _1_1
                              in
                              
# 126 "<standard.mly>"
    ( Some x )
# 71430 "asllib/Parser0.ml"
                              
                            in
                            let _1_1 = _1 in
                            let _2_1 = _2 in
                            
# 698 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 71438 "asllib/Parser0.ml"
                             (_1_1, _2_1)
                          in
                          let simple_stmt_list =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 71447 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 695 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 71453 "asllib/Parser0.ml"
                           (expr, simple_stmt_list, simple_else_opt)
                        in
                        let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                        let _endpos = _endpos_desc_ in
                        let _symbolstartpos = _startpos_desc_ in
                        
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 71462 "asllib/Parser0.ml"
                        
                      in
                      let simple_stmt_list =
                        let _1_1 = _1 in
                        
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 71470 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 621 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 71476 "asllib/Parser0.ml"
                       (simple_stmt_list, simple_if_stmt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 71485 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 71491 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 718 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 71499 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 604 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 71509 "asllib/Parser0.ml"
                 _3_1
              in
              
# 713 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 71515 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 71524 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 71530 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined5;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined4;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _4;
                    MenhirLib.EngineTypes.startp = _startpos__4_;
                    MenhirLib.EngineTypes.endp = _endpos__4_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _2;
                        MenhirLib.EngineTypes.startp = _startpos__2_;
                        MenhirLib.EngineTypes.endp = _endpos__2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _3;
                            MenhirLib.EngineTypes.startp = _startpos__3_;
                            MenhirLib.EngineTypes.endp = _endpos__3_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = expr;
                              MenhirLib.EngineTypes.startp = _startpos_expr_;
                              MenhirLib.EngineTypes.endp = _endpos_expr_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _menhir_s;
                                MenhirLib.EngineTypes.semv = _1;
                                MenhirLib.EngineTypes.startp = _startpos__1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_;
                                MenhirLib.EngineTypes.next = _menhir_stack;
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined5 : (AST.stmt list) = Obj.magic _1_inlined5 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _1_inlined3 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined3 in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined2, _1_inlined1, _1) = (_1_inlined5, _1_inlined4, _1_inlined3) in
                let _2 =
                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    let x =
                      let _1_1 = _1 in
                      
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 71644 "asllib/Parser0.ml"
                       _1_1
                    in
                    
# 196 "<standard.mly>"
    ( x )
# 71650 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 71656 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 718 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 71664 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 604 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 71674 "asllib/Parser0.ml"
                 _3_1
              in
              
# 713 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 71680 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_inlined1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 71689 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 71695 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined5;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _4;
                  MenhirLib.EngineTypes.startp = _startpos__4_;
                  MenhirLib.EngineTypes.endp = _endpos__4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _2;
                      MenhirLib.EngineTypes.startp = _startpos__2_;
                      MenhirLib.EngineTypes.endp = _endpos__2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _3;
                          MenhirLib.EngineTypes.startp = _startpos__3_;
                          MenhirLib.EngineTypes.endp = _endpos__3_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = expr;
                            MenhirLib.EngineTypes.startp = _startpos_expr_;
                            MenhirLib.EngineTypes.endp = _endpos_expr_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = _1;
                              MenhirLib.EngineTypes.startp = _startpos__1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _1_inlined3 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined3 in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined2, _1_inlined1, _1) = (_1_inlined5, _1_inlined4, _1_inlined3) in
                let _2 =
                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    
# 597 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 71800 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 71806 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 718 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 71814 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 604 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 71824 "asllib/Parser0.ml"
                 _3_1
              in
              
# 713 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 71830 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined5_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 71839 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 71845 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined5;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _6;
              MenhirLib.EngineTypes.startp = _startpos__6_;
              MenhirLib.EngineTypes.endp = _endpos__6_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined4;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = expr_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _3;
                            MenhirLib.EngineTypes.startp = _startpos__3_;
                            MenhirLib.EngineTypes.endp = _endpos__3_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = expr;
                              MenhirLib.EngineTypes.startp = _startpos_expr_;
                              MenhirLib.EngineTypes.endp = _endpos_expr_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _menhir_s;
                                MenhirLib.EngineTypes.semv = _1;
                                MenhirLib.EngineTypes.startp = _startpos__1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_;
                                MenhirLib.EngineTypes.next = _menhir_stack;
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _1_inlined5 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined5 in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let _1 = _1_inlined5 in
                let _2 = 
# 123 "<standard.mly>"
    ( None )
# 71953 "asllib/Parser0.ml"
                 in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 718 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 71960 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let _1 = _1_inlined2 in
                        let _2 = 
# 123 "<standard.mly>"
    ( None )
# 71974 "asllib/Parser0.ml"
                         in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 698 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 71981 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 71990 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 695 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 71996 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 72005 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 72013 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 621 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 72019 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 72028 "asllib/Parser0.ml"
                
              in
              
# 713 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 72034 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined5_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 72043 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 72049 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined8;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined7;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined6;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined5;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _6;
                        MenhirLib.EngineTypes.startp = _startpos__6_;
                        MenhirLib.EngineTypes.endp = _endpos__6_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined4;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined3;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _3_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = expr_inlined1;
                                MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                                MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _1_inlined2;
                                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _1_inlined1;
                                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = _3;
                                      MenhirLib.EngineTypes.startp = _startpos__3_;
                                      MenhirLib.EngineTypes.endp = _endpos__3_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _;
                                        MenhirLib.EngineTypes.semv = expr;
                                        MenhirLib.EngineTypes.startp = _startpos_expr_;
                                        MenhirLib.EngineTypes.endp = _endpos_expr_;
                                        MenhirLib.EngineTypes.next = {
                                          MenhirLib.EngineTypes.state = _menhir_s;
                                          MenhirLib.EngineTypes.semv = _1;
                                          MenhirLib.EngineTypes.startp = _startpos__1_;
                                          MenhirLib.EngineTypes.endp = _endpos__1_;
                                          MenhirLib.EngineTypes.next = _menhir_stack;
                                        };
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined8 : (AST.stmt list) = Obj.magic _1_inlined8 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined7 : unit = Obj.magic _1_inlined7 in
        let _1_inlined6 : unit = Obj.magic _1_inlined6 in
        let _1_inlined5 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined5 in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined3, _1_inlined2, _1_inlined1, _1) = (_1_inlined8, _1_inlined7, _1_inlined6, _1_inlined5) in
                let _2 =
                  let (_1_inlined2, _1_inlined1, _1) = (_1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                    let _3 = _1_inlined1 in
                    let _3_1 = _3 in
                    
# 604 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 72198 "asllib/Parser0.ml"
                     _3_1
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 72204 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 718 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 72212 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let _1 = _1_inlined2 in
                        let _2 = 
# 123 "<standard.mly>"
    ( None )
# 72226 "asllib/Parser0.ml"
                         in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 698 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 72233 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 72242 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 695 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 72248 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 72257 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 72265 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 621 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 72271 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 72280 "asllib/Parser0.ml"
                
              in
              
# 713 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 72286 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 72295 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 72301 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__6_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__6_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined10;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined10_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined10_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined9;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined9_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined9_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = expr_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos_expr_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos_expr_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined8;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined7;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined6;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined5;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _6;
                              MenhirLib.EngineTypes.startp = _startpos__6_;
                              MenhirLib.EngineTypes.endp = _endpos__6_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined4;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _1_inlined3;
                                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _3_inlined1;
                                    MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                                    MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = expr_inlined1;
                                      MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                                      MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _;
                                        MenhirLib.EngineTypes.semv = _1_inlined2;
                                        MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                        MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                        MenhirLib.EngineTypes.next = {
                                          MenhirLib.EngineTypes.state = _;
                                          MenhirLib.EngineTypes.semv = _1_inlined1;
                                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                          MenhirLib.EngineTypes.next = {
                                            MenhirLib.EngineTypes.state = _;
                                            MenhirLib.EngineTypes.semv = _3;
                                            MenhirLib.EngineTypes.startp = _startpos__3_;
                                            MenhirLib.EngineTypes.endp = _endpos__3_;
                                            MenhirLib.EngineTypes.next = {
                                              MenhirLib.EngineTypes.state = _;
                                              MenhirLib.EngineTypes.semv = expr;
                                              MenhirLib.EngineTypes.startp = _startpos_expr_;
                                              MenhirLib.EngineTypes.endp = _endpos_expr_;
                                              MenhirLib.EngineTypes.next = {
                                                MenhirLib.EngineTypes.state = _menhir_s;
                                                MenhirLib.EngineTypes.semv = _1;
                                                MenhirLib.EngineTypes.startp = _startpos__1_;
                                                MenhirLib.EngineTypes.endp = _endpos__1_;
                                                MenhirLib.EngineTypes.next = _menhir_stack;
                                              };
                                            };
                                          };
                                        };
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _6_inlined1 : unit = Obj.magic _6_inlined1 in
        let _1_inlined10 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined10 in
        let _1_inlined9 : (AST.stmt list) = Obj.magic _1_inlined9 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let expr_inlined2 : (AST.expr) = Obj.magic expr_inlined2 in
        let _1_inlined8 : unit = Obj.magic _1_inlined8 in
        let _1_inlined7 : (AST.stmt list) = Obj.magic _1_inlined7 in
        let _1_inlined6 : unit = Obj.magic _1_inlined6 in
        let _1_inlined5 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined5 in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_endpos__6_, _startpos__1_inlined3_, _startpos__1_inlined2_, _6, _1_inlined5, _1_inlined4, _3, expr, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_endpos__6_inlined1_, _startpos__1_inlined8_, _startpos__1_inlined7_, _6_inlined1, _1_inlined10, _1_inlined9, _3_inlined2, expr_inlined2, _1_inlined8, _1_inlined7, _1_inlined6, _1_inlined5) in
                let _2 =
                  let (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_if_stmt =
                        let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                        let desc =
                          let simple_else_opt =
                            let _1 = _1_inlined2 in
                            let _2 = 
# 123 "<standard.mly>"
    ( None )
# 72475 "asllib/Parser0.ml"
                             in
                            let _1_1 = _1 in
                            let _2_1 = _2 in
                            
# 698 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 72482 "asllib/Parser0.ml"
                             (_1_1, _2_1)
                          in
                          let simple_stmt_list =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 72491 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 695 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 72497 "asllib/Parser0.ml"
                           (expr, simple_stmt_list, simple_else_opt)
                        in
                        let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                        let _endpos = _endpos_desc_ in
                        let _symbolstartpos = _startpos_desc_ in
                        
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 72506 "asllib/Parser0.ml"
                        
                      in
                      let simple_stmt_list =
                        let _1_1 = _1 in
                        
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 72514 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 621 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 72520 "asllib/Parser0.ml"
                       (simple_stmt_list, simple_if_stmt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 72529 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 72535 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 718 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 72543 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let _1 = _1_inlined2 in
                        let _2 = 
# 123 "<standard.mly>"
    ( None )
# 72557 "asllib/Parser0.ml"
                         in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 698 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 72564 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 72573 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 695 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 72579 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 72588 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 72596 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 621 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 72602 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 72611 "asllib/Parser0.ml"
                
              in
              
# 713 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 72617 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_inlined1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 72626 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 72632 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__6_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__6_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined12;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined12_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined12_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined11;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined11_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined11_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined10;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined10_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined10_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined9;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined9_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined9_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = expr_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos_expr_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos_expr_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined8;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined7;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined6;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined5;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _6;
                                  MenhirLib.EngineTypes.startp = _startpos__6_;
                                  MenhirLib.EngineTypes.endp = _endpos__6_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _1_inlined4;
                                    MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = _1_inlined3;
                                      MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                                      MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _;
                                        MenhirLib.EngineTypes.semv = _3_inlined1;
                                        MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                                        MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                                        MenhirLib.EngineTypes.next = {
                                          MenhirLib.EngineTypes.state = _;
                                          MenhirLib.EngineTypes.semv = expr_inlined1;
                                          MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                                          MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                                          MenhirLib.EngineTypes.next = {
                                            MenhirLib.EngineTypes.state = _;
                                            MenhirLib.EngineTypes.semv = _1_inlined2;
                                            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                            MenhirLib.EngineTypes.next = {
                                              MenhirLib.EngineTypes.state = _;
                                              MenhirLib.EngineTypes.semv = _1_inlined1;
                                              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                              MenhirLib.EngineTypes.next = {
                                                MenhirLib.EngineTypes.state = _;
                                                MenhirLib.EngineTypes.semv = _3;
                                                MenhirLib.EngineTypes.startp = _startpos__3_;
                                                MenhirLib.EngineTypes.endp = _endpos__3_;
                                                MenhirLib.EngineTypes.next = {
                                                  MenhirLib.EngineTypes.state = _;
                                                  MenhirLib.EngineTypes.semv = expr;
                                                  MenhirLib.EngineTypes.startp = _startpos_expr_;
                                                  MenhirLib.EngineTypes.endp = _endpos_expr_;
                                                  MenhirLib.EngineTypes.next = {
                                                    MenhirLib.EngineTypes.state = _menhir_s;
                                                    MenhirLib.EngineTypes.semv = _1;
                                                    MenhirLib.EngineTypes.startp = _startpos__1_;
                                                    MenhirLib.EngineTypes.endp = _endpos__1_;
                                                    MenhirLib.EngineTypes.next = _menhir_stack;
                                                  };
                                                };
                                              };
                                            };
                                          };
                                        };
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _6_inlined1 : unit = Obj.magic _6_inlined1 in
        let _1_inlined12 : (AST.stmt list) = Obj.magic _1_inlined12 in
        let _1_inlined11 : unit = Obj.magic _1_inlined11 in
        let _1_inlined10 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined10 in
        let _1_inlined9 : (AST.stmt list) = Obj.magic _1_inlined9 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let expr_inlined2 : (AST.expr) = Obj.magic expr_inlined2 in
        let _1_inlined8 : unit = Obj.magic _1_inlined8 in
        let _1_inlined7 : (AST.stmt list) = Obj.magic _1_inlined7 in
        let _1_inlined6 : unit = Obj.magic _1_inlined6 in
        let _1_inlined5 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined5 in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_endpos__6_, _startpos__1_inlined3_, _startpos__1_inlined2_, _6, _1_inlined7, _1_inlined6, _1_inlined5, _1_inlined4, _3, expr, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_endpos__6_inlined1_, _startpos__1_inlined8_, _startpos__1_inlined7_, _6_inlined1, _1_inlined12, _1_inlined11, _1_inlined10, _1_inlined9, _3_inlined2, expr_inlined2, _1_inlined8, _1_inlined7, _1_inlined6, _1_inlined5) in
                let _2 =
                  let (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined7, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_if_stmt =
                        let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                        let desc =
                          let simple_else_opt =
                            let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                            let _2 =
                              let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                              let x =
                                let _1 = _1_inlined1 in
                                let _1_1 = _1 in
                                
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 72825 "asllib/Parser0.ml"
                                 _1_1
                              in
                              
# 126 "<standard.mly>"
    ( Some x )
# 72831 "asllib/Parser0.ml"
                              
                            in
                            let _1_1 = _1 in
                            let _2_1 = _2 in
                            
# 698 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 72839 "asllib/Parser0.ml"
                             (_1_1, _2_1)
                          in
                          let simple_stmt_list =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 72848 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 695 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 72854 "asllib/Parser0.ml"
                           (expr, simple_stmt_list, simple_else_opt)
                        in
                        let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                        let _endpos = _endpos_desc_ in
                        let _symbolstartpos = _startpos_desc_ in
                        
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 72863 "asllib/Parser0.ml"
                        
                      in
                      let simple_stmt_list =
                        let _1_1 = _1 in
                        
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 72871 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 621 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 72877 "asllib/Parser0.ml"
                       (simple_stmt_list, simple_if_stmt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 72886 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 72892 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 718 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 72900 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let _1 = _1_inlined2 in
                        let _2 = 
# 123 "<standard.mly>"
    ( None )
# 72914 "asllib/Parser0.ml"
                         in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 698 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 72921 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 72930 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 695 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 72936 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 72945 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 72953 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 621 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 72959 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 72968 "asllib/Parser0.ml"
                
              in
              
# 713 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 72974 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_inlined1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 72983 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 72989 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined7;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined6;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined5;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _6;
                    MenhirLib.EngineTypes.startp = _startpos__6_;
                    MenhirLib.EngineTypes.endp = _endpos__6_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined4;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined3;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _3_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = expr_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined2;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined1;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _3;
                                  MenhirLib.EngineTypes.startp = _startpos__3_;
                                  MenhirLib.EngineTypes.endp = _endpos__3_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = expr;
                                    MenhirLib.EngineTypes.startp = _startpos_expr_;
                                    MenhirLib.EngineTypes.endp = _endpos_expr_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _menhir_s;
                                      MenhirLib.EngineTypes.semv = _1;
                                      MenhirLib.EngineTypes.startp = _startpos__1_;
                                      MenhirLib.EngineTypes.endp = _endpos__1_;
                                      MenhirLib.EngineTypes.next = _menhir_stack;
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined7 : (AST.stmt list) = Obj.magic _1_inlined7 in
        let _1_inlined6 : unit = Obj.magic _1_inlined6 in
        let _1_inlined5 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined5 in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined2, _1_inlined1, _1) = (_1_inlined7, _1_inlined6, _1_inlined5) in
                let _2 =
                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    let x =
                      let _1_1 = _1 in
                      
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 73124 "asllib/Parser0.ml"
                       _1_1
                    in
                    
# 196 "<standard.mly>"
    ( x )
# 73130 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 73136 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 718 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 73144 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let _1 = _1_inlined2 in
                        let _2 = 
# 123 "<standard.mly>"
    ( None )
# 73158 "asllib/Parser0.ml"
                         in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 698 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 73165 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 73174 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 695 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 73180 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 73189 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 73197 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 621 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 73203 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 73212 "asllib/Parser0.ml"
                
              in
              
# 713 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 73218 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 73227 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 73233 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined7;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined6;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined5;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _6;
                  MenhirLib.EngineTypes.startp = _startpos__6_;
                  MenhirLib.EngineTypes.endp = _endpos__6_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined4;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined3;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = expr_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined2;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _3;
                                MenhirLib.EngineTypes.startp = _startpos__3_;
                                MenhirLib.EngineTypes.endp = _endpos__3_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = expr;
                                  MenhirLib.EngineTypes.startp = _startpos_expr_;
                                  MenhirLib.EngineTypes.endp = _endpos_expr_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _menhir_s;
                                    MenhirLib.EngineTypes.semv = _1;
                                    MenhirLib.EngineTypes.startp = _startpos__1_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_;
                                    MenhirLib.EngineTypes.next = _menhir_stack;
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _1_inlined7 : unit = Obj.magic _1_inlined7 in
        let _1_inlined6 : unit = Obj.magic _1_inlined6 in
        let _1_inlined5 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined5 in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined2, _1_inlined1, _1) = (_1_inlined7, _1_inlined6, _1_inlined5) in
                let _2 =
                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    
# 597 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 73359 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 73365 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 718 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 73373 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let _1 = _1_inlined2 in
                        let _2 = 
# 123 "<standard.mly>"
    ( None )
# 73387 "asllib/Parser0.ml"
                         in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 698 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 73394 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 73403 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 695 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 73409 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 73418 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 73426 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 621 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 73432 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 73441 "asllib/Parser0.ml"
                
              in
              
# 713 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 73447 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined7_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 73456 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 73462 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined7;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _6;
              MenhirLib.EngineTypes.startp = _startpos__6_;
              MenhirLib.EngineTypes.endp = _endpos__6_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined6;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined5;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined4;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined3;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = expr_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined2;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _3;
                                MenhirLib.EngineTypes.startp = _startpos__3_;
                                MenhirLib.EngineTypes.endp = _endpos__3_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = expr;
                                  MenhirLib.EngineTypes.startp = _startpos_expr_;
                                  MenhirLib.EngineTypes.endp = _endpos_expr_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _menhir_s;
                                    MenhirLib.EngineTypes.semv = _1;
                                    MenhirLib.EngineTypes.startp = _startpos__1_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_;
                                    MenhirLib.EngineTypes.next = _menhir_stack;
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _1_inlined7 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined7 in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let _1 = _1_inlined7 in
                let _2 = 
# 123 "<standard.mly>"
    ( None )
# 73584 "asllib/Parser0.ml"
                 in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 718 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 73591 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                        let _2 =
                          let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                          let x =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 73610 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 126 "<standard.mly>"
    ( Some x )
# 73616 "asllib/Parser0.ml"
                          
                        in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 698 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 73624 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 73633 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 695 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 73639 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 73648 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 73656 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 621 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 73662 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 73671 "asllib/Parser0.ml"
                
              in
              
# 713 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 73677 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined7_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 73686 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 73692 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined10;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined10_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined10_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined9;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined9_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined9_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined8;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined7;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _6;
                        MenhirLib.EngineTypes.startp = _startpos__6_;
                        MenhirLib.EngineTypes.endp = _endpos__6_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined6;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined5;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined4;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined3;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _3_inlined1;
                                  MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                                  MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = expr_inlined1;
                                    MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                                    MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = _1_inlined2;
                                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _;
                                        MenhirLib.EngineTypes.semv = _1_inlined1;
                                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                        MenhirLib.EngineTypes.next = {
                                          MenhirLib.EngineTypes.state = _;
                                          MenhirLib.EngineTypes.semv = _3;
                                          MenhirLib.EngineTypes.startp = _startpos__3_;
                                          MenhirLib.EngineTypes.endp = _endpos__3_;
                                          MenhirLib.EngineTypes.next = {
                                            MenhirLib.EngineTypes.state = _;
                                            MenhirLib.EngineTypes.semv = expr;
                                            MenhirLib.EngineTypes.startp = _startpos_expr_;
                                            MenhirLib.EngineTypes.endp = _endpos_expr_;
                                            MenhirLib.EngineTypes.next = {
                                              MenhirLib.EngineTypes.state = _menhir_s;
                                              MenhirLib.EngineTypes.semv = _1;
                                              MenhirLib.EngineTypes.startp = _startpos__1_;
                                              MenhirLib.EngineTypes.endp = _endpos__1_;
                                              MenhirLib.EngineTypes.next = _menhir_stack;
                                            };
                                          };
                                        };
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined10 : (AST.stmt list) = Obj.magic _1_inlined10 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined9 : unit = Obj.magic _1_inlined9 in
        let _1_inlined8 : unit = Obj.magic _1_inlined8 in
        let _1_inlined7 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined7 in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined3, _1_inlined2, _1_inlined1, _1) = (_1_inlined10, _1_inlined9, _1_inlined8, _1_inlined7) in
                let _2 =
                  let (_1_inlined2, _1_inlined1, _1) = (_1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                    let _3 = _1_inlined1 in
                    let _3_1 = _3 in
                    
# 604 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 73855 "asllib/Parser0.ml"
                     _3_1
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 73861 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 718 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 73869 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                        let _2 =
                          let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                          let x =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 73888 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 126 "<standard.mly>"
    ( Some x )
# 73894 "asllib/Parser0.ml"
                          
                        in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 698 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 73902 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 73911 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 695 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 73917 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 73926 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 73934 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 621 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 73940 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 73949 "asllib/Parser0.ml"
                
              in
              
# 713 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 73955 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 73964 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 73970 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__6_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__6_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined12;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined12_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined12_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined11;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined11_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined11_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = expr_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos_expr_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos_expr_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined10;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined10_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined10_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined9;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined9_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined9_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined8;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined7;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _6;
                              MenhirLib.EngineTypes.startp = _startpos__6_;
                              MenhirLib.EngineTypes.endp = _endpos__6_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined6;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _1_inlined5;
                                  MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _1_inlined4;
                                    MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = _1_inlined3;
                                      MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                                      MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _;
                                        MenhirLib.EngineTypes.semv = _3_inlined1;
                                        MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                                        MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                                        MenhirLib.EngineTypes.next = {
                                          MenhirLib.EngineTypes.state = _;
                                          MenhirLib.EngineTypes.semv = expr_inlined1;
                                          MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                                          MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                                          MenhirLib.EngineTypes.next = {
                                            MenhirLib.EngineTypes.state = _;
                                            MenhirLib.EngineTypes.semv = _1_inlined2;
                                            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                            MenhirLib.EngineTypes.next = {
                                              MenhirLib.EngineTypes.state = _;
                                              MenhirLib.EngineTypes.semv = _1_inlined1;
                                              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                              MenhirLib.EngineTypes.next = {
                                                MenhirLib.EngineTypes.state = _;
                                                MenhirLib.EngineTypes.semv = _3;
                                                MenhirLib.EngineTypes.startp = _startpos__3_;
                                                MenhirLib.EngineTypes.endp = _endpos__3_;
                                                MenhirLib.EngineTypes.next = {
                                                  MenhirLib.EngineTypes.state = _;
                                                  MenhirLib.EngineTypes.semv = expr;
                                                  MenhirLib.EngineTypes.startp = _startpos_expr_;
                                                  MenhirLib.EngineTypes.endp = _endpos_expr_;
                                                  MenhirLib.EngineTypes.next = {
                                                    MenhirLib.EngineTypes.state = _menhir_s;
                                                    MenhirLib.EngineTypes.semv = _1;
                                                    MenhirLib.EngineTypes.startp = _startpos__1_;
                                                    MenhirLib.EngineTypes.endp = _endpos__1_;
                                                    MenhirLib.EngineTypes.next = _menhir_stack;
                                                  };
                                                };
                                              };
                                            };
                                          };
                                        };
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _6_inlined1 : unit = Obj.magic _6_inlined1 in
        let _1_inlined12 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined12 in
        let _1_inlined11 : (AST.stmt list) = Obj.magic _1_inlined11 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let expr_inlined2 : (AST.expr) = Obj.magic expr_inlined2 in
        let _1_inlined10 : unit = Obj.magic _1_inlined10 in
        let _1_inlined9 : (AST.stmt list) = Obj.magic _1_inlined9 in
        let _1_inlined8 : unit = Obj.magic _1_inlined8 in
        let _1_inlined7 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined7 in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_endpos__6_, _startpos__1_inlined3_, _startpos__1_inlined2_, _6, _1_inlined5, _1_inlined4, _3, expr, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_endpos__6_inlined1_, _startpos__1_inlined10_, _startpos__1_inlined9_, _6_inlined1, _1_inlined12, _1_inlined11, _3_inlined2, expr_inlined2, _1_inlined10, _1_inlined9, _1_inlined8, _1_inlined7) in
                let _2 =
                  let (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_if_stmt =
                        let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                        let desc =
                          let simple_else_opt =
                            let _1 = _1_inlined2 in
                            let _2 = 
# 123 "<standard.mly>"
    ( None )
# 74158 "asllib/Parser0.ml"
                             in
                            let _1_1 = _1 in
                            let _2_1 = _2 in
                            
# 698 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 74165 "asllib/Parser0.ml"
                             (_1_1, _2_1)
                          in
                          let simple_stmt_list =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 74174 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 695 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 74180 "asllib/Parser0.ml"
                           (expr, simple_stmt_list, simple_else_opt)
                        in
                        let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                        let _endpos = _endpos_desc_ in
                        let _symbolstartpos = _startpos_desc_ in
                        
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 74189 "asllib/Parser0.ml"
                        
                      in
                      let simple_stmt_list =
                        let _1_1 = _1 in
                        
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 74197 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 621 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 74203 "asllib/Parser0.ml"
                       (simple_stmt_list, simple_if_stmt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 74212 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 74218 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 718 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 74226 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                        let _2 =
                          let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                          let x =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 74245 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 126 "<standard.mly>"
    ( Some x )
# 74251 "asllib/Parser0.ml"
                          
                        in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 698 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 74259 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 74268 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 695 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 74274 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 74283 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 74291 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 621 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 74297 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 74306 "asllib/Parser0.ml"
                
              in
              
# 713 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 74312 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_inlined1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 74321 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 74327 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__6_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__6_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined14;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined14_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined14_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined13;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined13_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined13_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined12;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined12_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined12_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined11;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined11_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined11_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = expr_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos_expr_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos_expr_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined10;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined10_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined10_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined9;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined9_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined9_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined8;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined7;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _6;
                                  MenhirLib.EngineTypes.startp = _startpos__6_;
                                  MenhirLib.EngineTypes.endp = _endpos__6_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _1_inlined6;
                                    MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = _1_inlined5;
                                      MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                                      MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _;
                                        MenhirLib.EngineTypes.semv = _1_inlined4;
                                        MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                                        MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                                        MenhirLib.EngineTypes.next = {
                                          MenhirLib.EngineTypes.state = _;
                                          MenhirLib.EngineTypes.semv = _1_inlined3;
                                          MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                                          MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                                          MenhirLib.EngineTypes.next = {
                                            MenhirLib.EngineTypes.state = _;
                                            MenhirLib.EngineTypes.semv = _3_inlined1;
                                            MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                                            MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                                            MenhirLib.EngineTypes.next = {
                                              MenhirLib.EngineTypes.state = _;
                                              MenhirLib.EngineTypes.semv = expr_inlined1;
                                              MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                                              MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                                              MenhirLib.EngineTypes.next = {
                                                MenhirLib.EngineTypes.state = _;
                                                MenhirLib.EngineTypes.semv = _1_inlined2;
                                                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                                MenhirLib.EngineTypes.next = {
                                                  MenhirLib.EngineTypes.state = _;
                                                  MenhirLib.EngineTypes.semv = _1_inlined1;
                                                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                                  MenhirLib.EngineTypes.next = {
                                                    MenhirLib.EngineTypes.state = _;
                                                    MenhirLib.EngineTypes.semv = _3;
                                                    MenhirLib.EngineTypes.startp = _startpos__3_;
                                                    MenhirLib.EngineTypes.endp = _endpos__3_;
                                                    MenhirLib.EngineTypes.next = {
                                                      MenhirLib.EngineTypes.state = _;
                                                      MenhirLib.EngineTypes.semv = expr;
                                                      MenhirLib.EngineTypes.startp = _startpos_expr_;
                                                      MenhirLib.EngineTypes.endp = _endpos_expr_;
                                                      MenhirLib.EngineTypes.next = {
                                                        MenhirLib.EngineTypes.state = _menhir_s;
                                                        MenhirLib.EngineTypes.semv = _1;
                                                        MenhirLib.EngineTypes.startp = _startpos__1_;
                                                        MenhirLib.EngineTypes.endp = _endpos__1_;
                                                        MenhirLib.EngineTypes.next = _menhir_stack;
                                                      };
                                                    };
                                                  };
                                                };
                                              };
                                            };
                                          };
                                        };
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _6_inlined1 : unit = Obj.magic _6_inlined1 in
        let _1_inlined14 : (AST.stmt list) = Obj.magic _1_inlined14 in
        let _1_inlined13 : unit = Obj.magic _1_inlined13 in
        let _1_inlined12 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined12 in
        let _1_inlined11 : (AST.stmt list) = Obj.magic _1_inlined11 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let expr_inlined2 : (AST.expr) = Obj.magic expr_inlined2 in
        let _1_inlined10 : unit = Obj.magic _1_inlined10 in
        let _1_inlined9 : (AST.stmt list) = Obj.magic _1_inlined9 in
        let _1_inlined8 : unit = Obj.magic _1_inlined8 in
        let _1_inlined7 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined7 in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_endpos__6_, _startpos__1_inlined3_, _startpos__1_inlined2_, _6, _1_inlined7, _1_inlined6, _1_inlined5, _1_inlined4, _3, expr, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_endpos__6_inlined1_, _startpos__1_inlined10_, _startpos__1_inlined9_, _6_inlined1, _1_inlined14, _1_inlined13, _1_inlined12, _1_inlined11, _3_inlined2, expr_inlined2, _1_inlined10, _1_inlined9, _1_inlined8, _1_inlined7) in
                let _2 =
                  let (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined7, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_if_stmt =
                        let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                        let desc =
                          let simple_else_opt =
                            let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                            let _2 =
                              let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                              let x =
                                let _1 = _1_inlined1 in
                                let _1_1 = _1 in
                                
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 74534 "asllib/Parser0.ml"
                                 _1_1
                              in
                              
# 126 "<standard.mly>"
    ( Some x )
# 74540 "asllib/Parser0.ml"
                              
                            in
                            let _1_1 = _1 in
                            let _2_1 = _2 in
                            
# 698 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 74548 "asllib/Parser0.ml"
                             (_1_1, _2_1)
                          in
                          let simple_stmt_list =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 74557 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 695 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 74563 "asllib/Parser0.ml"
                           (expr, simple_stmt_list, simple_else_opt)
                        in
                        let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                        let _endpos = _endpos_desc_ in
                        let _symbolstartpos = _startpos_desc_ in
                        
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 74572 "asllib/Parser0.ml"
                        
                      in
                      let simple_stmt_list =
                        let _1_1 = _1 in
                        
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 74580 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 621 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 74586 "asllib/Parser0.ml"
                       (simple_stmt_list, simple_if_stmt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 74595 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 74601 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 718 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 74609 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                        let _2 =
                          let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                          let x =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 74628 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 126 "<standard.mly>"
    ( Some x )
# 74634 "asllib/Parser0.ml"
                          
                        in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 698 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 74642 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 74651 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 695 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 74657 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 74666 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 74674 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 621 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 74680 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 74689 "asllib/Parser0.ml"
                
              in
              
# 713 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 74695 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_inlined1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 74704 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 74710 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined9;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined9_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined9_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined8;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined7;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _6;
                    MenhirLib.EngineTypes.startp = _startpos__6_;
                    MenhirLib.EngineTypes.endp = _endpos__6_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined6;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined5;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined4;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined3;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _3_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = expr_inlined1;
                                MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                                MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _1_inlined2;
                                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _1_inlined1;
                                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = _3;
                                      MenhirLib.EngineTypes.startp = _startpos__3_;
                                      MenhirLib.EngineTypes.endp = _endpos__3_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _;
                                        MenhirLib.EngineTypes.semv = expr;
                                        MenhirLib.EngineTypes.startp = _startpos_expr_;
                                        MenhirLib.EngineTypes.endp = _endpos_expr_;
                                        MenhirLib.EngineTypes.next = {
                                          MenhirLib.EngineTypes.state = _menhir_s;
                                          MenhirLib.EngineTypes.semv = _1;
                                          MenhirLib.EngineTypes.startp = _startpos__1_;
                                          MenhirLib.EngineTypes.endp = _endpos__1_;
                                          MenhirLib.EngineTypes.next = _menhir_stack;
                                        };
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined9 : (AST.stmt list) = Obj.magic _1_inlined9 in
        let _1_inlined8 : unit = Obj.magic _1_inlined8 in
        let _1_inlined7 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined7 in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined2, _1_inlined1, _1) = (_1_inlined9, _1_inlined8, _1_inlined7) in
                let _2 =
                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    let x =
                      let _1_1 = _1 in
                      
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 74859 "asllib/Parser0.ml"
                       _1_1
                    in
                    
# 196 "<standard.mly>"
    ( x )
# 74865 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 74871 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 718 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 74879 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                        let _2 =
                          let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                          let x =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 74898 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 126 "<standard.mly>"
    ( Some x )
# 74904 "asllib/Parser0.ml"
                          
                        in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 698 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 74912 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 74921 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 695 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 74927 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 74936 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 74944 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 621 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 74950 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 74959 "asllib/Parser0.ml"
                
              in
              
# 713 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 74965 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 74974 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 74980 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined9;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined9_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined9_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined8;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined7;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _6;
                  MenhirLib.EngineTypes.startp = _startpos__6_;
                  MenhirLib.EngineTypes.endp = _endpos__6_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined6;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined5;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined4;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined3;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _3_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = expr_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined2;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _1_inlined1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _3;
                                    MenhirLib.EngineTypes.startp = _startpos__3_;
                                    MenhirLib.EngineTypes.endp = _endpos__3_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = expr;
                                      MenhirLib.EngineTypes.startp = _startpos_expr_;
                                      MenhirLib.EngineTypes.endp = _endpos_expr_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _menhir_s;
                                        MenhirLib.EngineTypes.semv = _1;
                                        MenhirLib.EngineTypes.startp = _startpos__1_;
                                        MenhirLib.EngineTypes.endp = _endpos__1_;
                                        MenhirLib.EngineTypes.next = _menhir_stack;
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _1_inlined9 : unit = Obj.magic _1_inlined9 in
        let _1_inlined8 : unit = Obj.magic _1_inlined8 in
        let _1_inlined7 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined7 in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined2, _1_inlined1, _1) = (_1_inlined9, _1_inlined8, _1_inlined7) in
                let _2 =
                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    
# 597 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 75120 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 75126 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 718 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 75134 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                        let _2 =
                          let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                          let x =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 75153 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 126 "<standard.mly>"
    ( Some x )
# 75159 "asllib/Parser0.ml"
                          
                        in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 698 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 75167 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 75176 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 695 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 75182 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 75191 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 75199 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 621 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 75205 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 75214 "asllib/Parser0.ml"
                
              in
              
# 713 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 75220 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined9_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 75229 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 75235 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined2;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2;
              MenhirLib.EngineTypes.startp = _startpos__2_;
              MenhirLib.EngineTypes.endp = _endpos__2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = expr;
                    MenhirLib.EngineTypes.startp = _startpos_expr_;
                    MenhirLib.EngineTypes.endp = _endpos_expr_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let _1 = _1_inlined2 in
                let _2 = 
# 123 "<standard.mly>"
    ( None )
# 75308 "asllib/Parser0.ml"
                 in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 718 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 75315 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                let x =
                  let _1_1 = _1 in
                  
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 75325 "asllib/Parser0.ml"
                   _1_1
                in
                
# 196 "<standard.mly>"
    ( x )
# 75331 "asllib/Parser0.ml"
                
              in
              
# 713 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 75337 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 75346 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 75352 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined5;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined4;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined3;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _2;
                        MenhirLib.EngineTypes.startp = _startpos__2_;
                        MenhirLib.EngineTypes.endp = _endpos__2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _3;
                            MenhirLib.EngineTypes.startp = _startpos__3_;
                            MenhirLib.EngineTypes.endp = _endpos__3_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = expr;
                              MenhirLib.EngineTypes.startp = _startpos_expr_;
                              MenhirLib.EngineTypes.endp = _endpos_expr_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _menhir_s;
                                MenhirLib.EngineTypes.semv = _1;
                                MenhirLib.EngineTypes.startp = _startpos__1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_;
                                MenhirLib.EngineTypes.next = _menhir_stack;
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined5 : (AST.stmt list) = Obj.magic _1_inlined5 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined3, _2, _1_inlined2, _1_inlined1, _1) = (_1_inlined5, _2_inlined1, _1_inlined4, _1_inlined3, _1_inlined2) in
                let _2 =
                  let (_1_inlined2, _1_inlined1, _1) = (_1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                    let _3 = _1_inlined1 in
                    let _3_1 = _3 in
                    
# 604 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 75466 "asllib/Parser0.ml"
                     _3_1
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 75472 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 718 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 75480 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                let x =
                  let _1_1 = _1 in
                  
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 75490 "asllib/Parser0.ml"
                   _1_1
                in
                
# 196 "<standard.mly>"
    ( x )
# 75496 "asllib/Parser0.ml"
                
              in
              
# 713 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 75502 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 75511 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 75517 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined7;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined6;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = expr_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined5;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined4;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined3;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined2;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _2;
                              MenhirLib.EngineTypes.startp = _startpos__2_;
                              MenhirLib.EngineTypes.endp = _endpos__2_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined1;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _3;
                                  MenhirLib.EngineTypes.startp = _startpos__3_;
                                  MenhirLib.EngineTypes.endp = _endpos__3_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = expr;
                                    MenhirLib.EngineTypes.startp = _startpos_expr_;
                                    MenhirLib.EngineTypes.endp = _endpos_expr_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _menhir_s;
                                      MenhirLib.EngineTypes.semv = _1;
                                      MenhirLib.EngineTypes.startp = _startpos__1_;
                                      MenhirLib.EngineTypes.endp = _endpos__1_;
                                      MenhirLib.EngineTypes.next = _menhir_stack;
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined7 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined7 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined5, _1_inlined4, _3, expr, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined5_, _startpos__1_inlined4_, _1_inlined7, _1_inlined6, _3_inlined1, expr_inlined1, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2) in
                let _2 =
                  let (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_if_stmt =
                        let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                        let desc =
                          let simple_else_opt =
                            let _1 = _1_inlined2 in
                            let _2 = 
# 123 "<standard.mly>"
    ( None )
# 75656 "asllib/Parser0.ml"
                             in
                            let _1_1 = _1 in
                            let _2_1 = _2 in
                            
# 698 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 75663 "asllib/Parser0.ml"
                             (_1_1, _2_1)
                          in
                          let simple_stmt_list =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 75672 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 695 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 75678 "asllib/Parser0.ml"
                           (expr, simple_stmt_list, simple_else_opt)
                        in
                        let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                        let _endpos = _endpos_desc_ in
                        let _symbolstartpos = _startpos_desc_ in
                        
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 75687 "asllib/Parser0.ml"
                        
                      in
                      let simple_stmt_list =
                        let _1_1 = _1 in
                        
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 75695 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 621 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 75701 "asllib/Parser0.ml"
                       (simple_stmt_list, simple_if_stmt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 75710 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 75716 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 718 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 75724 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                let x =
                  let _1_1 = _1 in
                  
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 75734 "asllib/Parser0.ml"
                   _1_1
                in
                
# 196 "<standard.mly>"
    ( x )
# 75740 "asllib/Parser0.ml"
                
              in
              
# 713 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 75746 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 75755 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 75761 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined9;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined9_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined9_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined8;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined7;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined6;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = expr_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined5;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined4;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined3;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined2;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _2;
                                  MenhirLib.EngineTypes.startp = _startpos__2_;
                                  MenhirLib.EngineTypes.endp = _endpos__2_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _1_inlined1;
                                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = _3;
                                      MenhirLib.EngineTypes.startp = _startpos__3_;
                                      MenhirLib.EngineTypes.endp = _endpos__3_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _;
                                        MenhirLib.EngineTypes.semv = expr;
                                        MenhirLib.EngineTypes.startp = _startpos_expr_;
                                        MenhirLib.EngineTypes.endp = _endpos_expr_;
                                        MenhirLib.EngineTypes.next = {
                                          MenhirLib.EngineTypes.state = _menhir_s;
                                          MenhirLib.EngineTypes.semv = _1;
                                          MenhirLib.EngineTypes.startp = _startpos__1_;
                                          MenhirLib.EngineTypes.endp = _endpos__1_;
                                          MenhirLib.EngineTypes.next = _menhir_stack;
                                        };
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined9 : (AST.stmt list) = Obj.magic _1_inlined9 in
        let _1_inlined8 : unit = Obj.magic _1_inlined8 in
        let _1_inlined7 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined7 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined7, _1_inlined6, _1_inlined5, _1_inlined4, _3, expr, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined5_, _startpos__1_inlined4_, _1_inlined9, _1_inlined8, _1_inlined7, _1_inlined6, _3_inlined1, expr_inlined1, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2) in
                let _2 =
                  let (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined7, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_if_stmt =
                        let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                        let desc =
                          let simple_else_opt =
                            let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                            let _2 =
                              let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                              let x =
                                let _1 = _1_inlined1 in
                                let _1_1 = _1 in
                                
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 75919 "asllib/Parser0.ml"
                                 _1_1
                              in
                              
# 126 "<standard.mly>"
    ( Some x )
# 75925 "asllib/Parser0.ml"
                              
                            in
                            let _1_1 = _1 in
                            let _2_1 = _2 in
                            
# 698 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 75933 "asllib/Parser0.ml"
                             (_1_1, _2_1)
                          in
                          let simple_stmt_list =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 75942 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 695 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 75948 "asllib/Parser0.ml"
                           (expr, simple_stmt_list, simple_else_opt)
                        in
                        let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                        let _endpos = _endpos_desc_ in
                        let _symbolstartpos = _startpos_desc_ in
                        
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 75957 "asllib/Parser0.ml"
                        
                      in
                      let simple_stmt_list =
                        let _1_1 = _1 in
                        
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 75965 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 621 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 75971 "asllib/Parser0.ml"
                       (simple_stmt_list, simple_if_stmt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 75980 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 75986 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 718 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 75994 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                let x =
                  let _1_1 = _1 in
                  
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 76004 "asllib/Parser0.ml"
                   _1_1
                in
                
# 196 "<standard.mly>"
    ( x )
# 76010 "asllib/Parser0.ml"
                
              in
              
# 713 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 76016 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 76025 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 76031 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _2;
                    MenhirLib.EngineTypes.startp = _startpos__2_;
                    MenhirLib.EngineTypes.endp = _endpos__2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3;
                        MenhirLib.EngineTypes.startp = _startpos__3_;
                        MenhirLib.EngineTypes.endp = _endpos__3_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = expr;
                          MenhirLib.EngineTypes.startp = _startpos_expr_;
                          MenhirLib.EngineTypes.endp = _endpos_expr_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                let _2 =
                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    let x =
                      let _1_1 = _1 in
                      
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 76131 "asllib/Parser0.ml"
                       _1_1
                    in
                    
# 196 "<standard.mly>"
    ( x )
# 76137 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 76143 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 718 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 76151 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                let x =
                  let _1_1 = _1 in
                  
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 76161 "asllib/Parser0.ml"
                   _1_1
                in
                
# 196 "<standard.mly>"
    ( x )
# 76167 "asllib/Parser0.ml"
                
              in
              
# 713 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 76173 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_inlined1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 76182 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 76188 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined4;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _2;
                  MenhirLib.EngineTypes.startp = _startpos__2_;
                  MenhirLib.EngineTypes.endp = _endpos__2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3;
                      MenhirLib.EngineTypes.startp = _startpos__3_;
                      MenhirLib.EngineTypes.endp = _endpos__3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = expr;
                        MenhirLib.EngineTypes.startp = _startpos_expr_;
                        MenhirLib.EngineTypes.endp = _endpos_expr_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                let _2 =
                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    
# 597 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 76279 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 76285 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 718 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 76293 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                let x =
                  let _1_1 = _1 in
                  
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 76303 "asllib/Parser0.ml"
                   _1_1
                in
                
# 196 "<standard.mly>"
    ( x )
# 76309 "asllib/Parser0.ml"
                
              in
              
# 713 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 76315 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined4_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 76324 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 76330 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined2;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = expr;
                  MenhirLib.EngineTypes.startp = _startpos_expr_;
                  MenhirLib.EngineTypes.endp = _endpos_expr_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let _1 = _1_inlined2 in
                let _2 = 
# 123 "<standard.mly>"
    ( None )
# 76396 "asllib/Parser0.ml"
                 in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 718 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 76403 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                
# 597 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 76411 "asllib/Parser0.ml"
                
              in
              
# 713 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 76417 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 76426 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 76432 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined5;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined4;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined3;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _3;
                          MenhirLib.EngineTypes.startp = _startpos__3_;
                          MenhirLib.EngineTypes.endp = _endpos__3_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = expr;
                            MenhirLib.EngineTypes.startp = _startpos_expr_;
                            MenhirLib.EngineTypes.endp = _endpos_expr_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = _1;
                              MenhirLib.EngineTypes.startp = _startpos__1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined5 : (AST.stmt list) = Obj.magic _1_inlined5 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined3, _1_inlined2, _1_inlined1, _1) = (_1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2) in
                let _2 =
                  let (_1_inlined2, _1_inlined1, _1) = (_1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                    let _3 = _1_inlined1 in
                    let _3_1 = _3 in
                    
# 604 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 76539 "asllib/Parser0.ml"
                     _3_1
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 76545 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 718 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 76553 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                
# 597 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 76561 "asllib/Parser0.ml"
                
              in
              
# 713 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 76567 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 76576 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 76582 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined7;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined6;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = expr_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined5;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined4;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined3;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined2;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _3;
                                MenhirLib.EngineTypes.startp = _startpos__3_;
                                MenhirLib.EngineTypes.endp = _endpos__3_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = expr;
                                  MenhirLib.EngineTypes.startp = _startpos_expr_;
                                  MenhirLib.EngineTypes.endp = _endpos_expr_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _menhir_s;
                                    MenhirLib.EngineTypes.semv = _1;
                                    MenhirLib.EngineTypes.startp = _startpos__1_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_;
                                    MenhirLib.EngineTypes.next = _menhir_stack;
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined7 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined7 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined5, _1_inlined4, _3, expr, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined5_, _startpos__1_inlined4_, _1_inlined7, _1_inlined6, _3_inlined1, expr_inlined1, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2) in
                let _2 =
                  let (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_if_stmt =
                        let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                        let desc =
                          let simple_else_opt =
                            let _1 = _1_inlined2 in
                            let _2 = 
# 123 "<standard.mly>"
    ( None )
# 76714 "asllib/Parser0.ml"
                             in
                            let _1_1 = _1 in
                            let _2_1 = _2 in
                            
# 698 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 76721 "asllib/Parser0.ml"
                             (_1_1, _2_1)
                          in
                          let simple_stmt_list =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 76730 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 695 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 76736 "asllib/Parser0.ml"
                           (expr, simple_stmt_list, simple_else_opt)
                        in
                        let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                        let _endpos = _endpos_desc_ in
                        let _symbolstartpos = _startpos_desc_ in
                        
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 76745 "asllib/Parser0.ml"
                        
                      in
                      let simple_stmt_list =
                        let _1_1 = _1 in
                        
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 76753 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 621 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 76759 "asllib/Parser0.ml"
                       (simple_stmt_list, simple_if_stmt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 76768 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 76774 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 718 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 76782 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                
# 597 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 76790 "asllib/Parser0.ml"
                
              in
              
# 713 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 76796 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 76805 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 76811 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined9;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined9_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined9_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined8;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined7;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined6;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = expr_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined5;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined4;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined3;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined2;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _1_inlined1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _3;
                                    MenhirLib.EngineTypes.startp = _startpos__3_;
                                    MenhirLib.EngineTypes.endp = _endpos__3_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = expr;
                                      MenhirLib.EngineTypes.startp = _startpos_expr_;
                                      MenhirLib.EngineTypes.endp = _endpos_expr_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _menhir_s;
                                        MenhirLib.EngineTypes.semv = _1;
                                        MenhirLib.EngineTypes.startp = _startpos__1_;
                                        MenhirLib.EngineTypes.endp = _endpos__1_;
                                        MenhirLib.EngineTypes.next = _menhir_stack;
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined9 : (AST.stmt list) = Obj.magic _1_inlined9 in
        let _1_inlined8 : unit = Obj.magic _1_inlined8 in
        let _1_inlined7 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined7 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined7, _1_inlined6, _1_inlined5, _1_inlined4, _3, expr, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined5_, _startpos__1_inlined4_, _1_inlined9, _1_inlined8, _1_inlined7, _1_inlined6, _3_inlined1, expr_inlined1, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2) in
                let _2 =
                  let (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined7, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_if_stmt =
                        let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                        let desc =
                          let simple_else_opt =
                            let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                            let _2 =
                              let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                              let x =
                                let _1 = _1_inlined1 in
                                let _1_1 = _1 in
                                
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 76962 "asllib/Parser0.ml"
                                 _1_1
                              in
                              
# 126 "<standard.mly>"
    ( Some x )
# 76968 "asllib/Parser0.ml"
                              
                            in
                            let _1_1 = _1 in
                            let _2_1 = _2 in
                            
# 698 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 76976 "asllib/Parser0.ml"
                             (_1_1, _2_1)
                          in
                          let simple_stmt_list =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 76985 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 695 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 76991 "asllib/Parser0.ml"
                           (expr, simple_stmt_list, simple_else_opt)
                        in
                        let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                        let _endpos = _endpos_desc_ in
                        let _symbolstartpos = _startpos_desc_ in
                        
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 77000 "asllib/Parser0.ml"
                        
                      in
                      let simple_stmt_list =
                        let _1_1 = _1 in
                        
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 77008 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 621 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 77014 "asllib/Parser0.ml"
                       (simple_stmt_list, simple_if_stmt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 77023 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 77029 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 718 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 77037 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                
# 597 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 77045 "asllib/Parser0.ml"
                
              in
              
# 713 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 77051 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 77060 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 77066 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3;
                      MenhirLib.EngineTypes.startp = _startpos__3_;
                      MenhirLib.EngineTypes.endp = _endpos__3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = expr;
                        MenhirLib.EngineTypes.startp = _startpos_expr_;
                        MenhirLib.EngineTypes.endp = _endpos_expr_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                let _2 =
                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    let x =
                      let _1_1 = _1 in
                      
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 77159 "asllib/Parser0.ml"
                       _1_1
                    in
                    
# 196 "<standard.mly>"
    ( x )
# 77165 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 77171 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 718 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 77179 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                
# 597 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 77187 "asllib/Parser0.ml"
                
              in
              
# 713 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 77193 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 77202 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 77208 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined4;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = expr;
                      MenhirLib.EngineTypes.startp = _startpos_expr_;
                      MenhirLib.EngineTypes.endp = _endpos_expr_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                let _2 =
                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    
# 597 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 77292 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 77298 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 718 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 77306 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                
# 597 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 77314 "asllib/Parser0.ml"
                
              in
              
# 713 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 77320 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined4_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 77329 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 77335 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3;
                      MenhirLib.EngineTypes.startp = _startpos__3_;
                      MenhirLib.EngineTypes.endp = _endpos__3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = expr;
                        MenhirLib.EngineTypes.startp = _startpos_expr_;
                        MenhirLib.EngineTypes.endp = _endpos_expr_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let simple_else =
                let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                let _2 =
                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    let _1_1 = _1 in
                    
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 77427 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 233 "asllib/Parser0.mly"
                      Some  
# 77433 "asllib/Parser0.ml"
                   x
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 699 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 77441 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let simple_stmt_list =
                let _1 = _1_inlined1 in
                let _1_1 = _1 in
                
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 77450 "asllib/Parser0.ml"
                 _1_1
              in
              
# 714 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 77456 "asllib/Parser0.ml"
               (expr, simple_stmt_list, simple_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 77465 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 77471 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _7;
            MenhirLib.EngineTypes.startp = _startpos__7_;
            MenhirLib.EngineTypes.endp = _endpos__7_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _6;
              MenhirLib.EngineTypes.startp = _startpos__6_;
              MenhirLib.EngineTypes.endp = _endpos__6_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _5;
                MenhirLib.EngineTypes.startp = _startpos__5_;
                MenhirLib.EngineTypes.endp = _endpos__5_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _4;
                  MenhirLib.EngineTypes.startp = _startpos__4_;
                  MenhirLib.EngineTypes.endp = _endpos__4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = expr;
                      MenhirLib.EngineTypes.startp = _startpos_expr_;
                      MenhirLib.EngineTypes.endp = _endpos_expr_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _7 : unit = Obj.magic _7 in
        let _6 : (AST.case_alt list) = Obj.magic _6 in
        let _5 : unit = Obj.magic _5 in
        let _4 : unit = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let _6_1 = _6 in
              
# 715 "asllib/Parser0.mly"
                                                            AST.S_Case  
# 77550 "asllib/Parser0.ml"
               (expr, _6_1)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__7_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 77559 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 77565 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = end_e;
                    MenhirLib.EngineTypes.startp = _startpos_end_e_;
                    MenhirLib.EngineTypes.endp = _endpos_end_e_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = start_e;
                        MenhirLib.EngineTypes.startp = _startpos_start_e_;
                        MenhirLib.EngineTypes.endp = _endpos_start_e_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _3;
                          MenhirLib.EngineTypes.startp = _startpos__3_;
                          MenhirLib.EngineTypes.endp = _endpos__3_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = _1;
                              MenhirLib.EngineTypes.startp = _startpos__1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let end_e : (AST.expr) = Obj.magic end_e in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let start_e : (AST.expr) = Obj.magic start_e in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 77656 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let body =
                let (_1_inlined1, _1) = (_1_inlined4, _1_inlined3) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 604 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 77672 "asllib/Parser0.ml"
                 _3_1
              in
              let limit = 
# 123 "<standard.mly>"
    ( None )
# 77678 "asllib/Parser0.ml"
               in
              let dir =
                let _1 = _1_inlined2 in
                
# 766 "asllib/Parser0.mly"
                       ( AST.Up )
# 77685 "asllib/Parser0.ml"
                
              in
              let index_name = _1_inlined1 in
              
# 761 "asllib/Parser0.mly"
      ( AST.S_For { index_name; start_e; dir; end_e; body; limit } )
# 77692 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 77701 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 77707 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined5;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined4;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _2;
                    MenhirLib.EngineTypes.startp = _startpos__2_;
                    MenhirLib.EngineTypes.endp = _endpos__2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined3;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = end_e;
                        MenhirLib.EngineTypes.startp = _startpos_end_e_;
                        MenhirLib.EngineTypes.endp = _endpos_end_e_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined2;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = start_e;
                            MenhirLib.EngineTypes.startp = _startpos_start_e_;
                            MenhirLib.EngineTypes.endp = _endpos_start_e_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _3;
                              MenhirLib.EngineTypes.startp = _startpos__3_;
                              MenhirLib.EngineTypes.endp = _endpos__3_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined1;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _menhir_s;
                                  MenhirLib.EngineTypes.semv = _1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_;
                                  MenhirLib.EngineTypes.next = _menhir_stack;
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined5 : (AST.stmt list) = Obj.magic _1_inlined5 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _2 : (AST.expr) = Obj.magic _2 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let end_e : (AST.expr) = Obj.magic end_e in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let start_e : (AST.expr) = Obj.magic start_e in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 77812 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let body =
                let (_1_inlined1, _2, _1) = (_1_inlined5, _2_inlined1, _1_inlined4) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 604 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 77828 "asllib/Parser0.ml"
                 _3_1
              in
              let limit =
                let _1 = _1_inlined3 in
                let x = _2 in
                
# 126 "<standard.mly>"
    ( Some x )
# 77837 "asllib/Parser0.ml"
                
              in
              let dir =
                let _1 = _1_inlined2 in
                
# 766 "asllib/Parser0.mly"
                       ( AST.Up )
# 77845 "asllib/Parser0.ml"
                
              in
              let index_name = _1_inlined1 in
              
# 761 "asllib/Parser0.mly"
      ( AST.S_For { index_name; start_e; dir; end_e; body; limit } )
# 77852 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 77861 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 77867 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = end_e;
                    MenhirLib.EngineTypes.startp = _startpos_end_e_;
                    MenhirLib.EngineTypes.endp = _endpos_end_e_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = start_e;
                        MenhirLib.EngineTypes.startp = _startpos_start_e_;
                        MenhirLib.EngineTypes.endp = _endpos_start_e_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _3;
                          MenhirLib.EngineTypes.startp = _startpos__3_;
                          MenhirLib.EngineTypes.endp = _endpos__3_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = _1;
                              MenhirLib.EngineTypes.startp = _startpos__1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let end_e : (AST.expr) = Obj.magic end_e in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let start_e : (AST.expr) = Obj.magic start_e in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 77958 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let body =
                let (_1_inlined1, _1) = (_1_inlined4, _1_inlined3) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 604 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 77974 "asllib/Parser0.ml"
                 _3_1
              in
              let limit = 
# 123 "<standard.mly>"
    ( None )
# 77980 "asllib/Parser0.ml"
               in
              let dir =
                let _1 = _1_inlined2 in
                
# 766 "asllib/Parser0.mly"
                                            ( AST.Down )
# 77987 "asllib/Parser0.ml"
                
              in
              let index_name = _1_inlined1 in
              
# 761 "asllib/Parser0.mly"
      ( AST.S_For { index_name; start_e; dir; end_e; body; limit } )
# 77994 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 78003 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 78009 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined5;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined4;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _2;
                    MenhirLib.EngineTypes.startp = _startpos__2_;
                    MenhirLib.EngineTypes.endp = _endpos__2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined3;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = end_e;
                        MenhirLib.EngineTypes.startp = _startpos_end_e_;
                        MenhirLib.EngineTypes.endp = _endpos_end_e_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined2;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = start_e;
                            MenhirLib.EngineTypes.startp = _startpos_start_e_;
                            MenhirLib.EngineTypes.endp = _endpos_start_e_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _3;
                              MenhirLib.EngineTypes.startp = _startpos__3_;
                              MenhirLib.EngineTypes.endp = _endpos__3_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined1;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _menhir_s;
                                  MenhirLib.EngineTypes.semv = _1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_;
                                  MenhirLib.EngineTypes.next = _menhir_stack;
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined5 : (AST.stmt list) = Obj.magic _1_inlined5 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _2 : (AST.expr) = Obj.magic _2 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let end_e : (AST.expr) = Obj.magic end_e in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let start_e : (AST.expr) = Obj.magic start_e in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 78114 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let body =
                let (_1_inlined1, _2, _1) = (_1_inlined5, _2_inlined1, _1_inlined4) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 604 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 78130 "asllib/Parser0.ml"
                 _3_1
              in
              let limit =
                let _1 = _1_inlined3 in
                let x = _2 in
                
# 126 "<standard.mly>"
    ( Some x )
# 78139 "asllib/Parser0.ml"
                
              in
              let dir =
                let _1 = _1_inlined2 in
                
# 766 "asllib/Parser0.mly"
                                            ( AST.Down )
# 78147 "asllib/Parser0.ml"
                
              in
              let index_name = _1_inlined1 in
              
# 761 "asllib/Parser0.mly"
      ( AST.S_For { index_name; start_e; dir; end_e; body; limit } )
# 78154 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 78163 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 78169 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__4_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__4_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _4;
                    MenhirLib.EngineTypes.startp = _startpos__4_;
                    MenhirLib.EngineTypes.endp = _endpos__4_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = expr;
                      MenhirLib.EngineTypes.startp = _startpos_expr_;
                      MenhirLib.EngineTypes.endp = _endpos_expr_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _4_inlined1 : unit = Obj.magic _4_inlined1 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _4 : unit = Obj.magic _4 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let indented_block =
                let (_4, _1_inlined1, _1) = (_4_inlined1, _1_inlined2, _1_inlined1) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 604 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 78251 "asllib/Parser0.ml"
                 _3_1
              in
              let _3 = 
# 123 "<standard.mly>"
    ( None )
# 78257 "asllib/Parser0.ml"
               in
              let _3_1 = _3 in
              
# 762 "asllib/Parser0.mly"
                                                                  AST.S_While 
# 78263 "asllib/Parser0.ml"
               (expr, _3_1, indented_block)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__4_inlined1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 78272 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 78278 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__4_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__4_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _4;
                    MenhirLib.EngineTypes.startp = _startpos__4_;
                    MenhirLib.EngineTypes.endp = _endpos__4_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _2;
                      MenhirLib.EngineTypes.startp = _startpos__2_;
                      MenhirLib.EngineTypes.endp = _endpos__2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = expr;
                          MenhirLib.EngineTypes.startp = _startpos_expr_;
                          MenhirLib.EngineTypes.endp = _endpos_expr_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _4_inlined1 : unit = Obj.magic _4_inlined1 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _4 : unit = Obj.magic _4 in
        let _2 : (AST.expr) = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let indented_block =
                let (_4, _1_inlined1, _2, _1) = (_4_inlined1, _1_inlined3, _2_inlined1, _1_inlined2) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 604 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 78374 "asllib/Parser0.ml"
                 _3_1
              in
              let _3 =
                let _1 = _1_inlined1 in
                let x = _2 in
                
# 126 "<standard.mly>"
    ( Some x )
# 78383 "asllib/Parser0.ml"
                
              in
              let _3_1 = _3 in
              
# 762 "asllib/Parser0.mly"
                                                                  AST.S_While 
# 78390 "asllib/Parser0.ml"
               (expr, _3_1, indented_block)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__4_inlined1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 78399 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 78405 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _7;
            MenhirLib.EngineTypes.startp = _startpos__7_;
            MenhirLib.EngineTypes.endp = _endpos__7_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _6;
              MenhirLib.EngineTypes.startp = _startpos__6_;
              MenhirLib.EngineTypes.endp = _endpos__6_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = expr;
                MenhirLib.EngineTypes.startp = _startpos_expr_;
                MenhirLib.EngineTypes.endp = _endpos_expr_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _4;
                    MenhirLib.EngineTypes.startp = _startpos__4_;
                    MenhirLib.EngineTypes.endp = _endpos__4_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _2;
                        MenhirLib.EngineTypes.startp = _startpos__2_;
                        MenhirLib.EngineTypes.endp = _endpos__2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _7 : unit = Obj.magic _7 in
        let _6 : unit = Obj.magic _6 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let _5 = 
# 123 "<standard.mly>"
    ( None )
# 78497 "asllib/Parser0.ml"
               in
              let indented_block =
                let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 604 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 78506 "asllib/Parser0.ml"
                 _3_1
              in
              let _5_1 = _5 in
              
# 764 "asllib/Parser0.mly"
                       AST.S_Repeat 
# 78513 "asllib/Parser0.ml"
               (indented_block, expr, _5_1)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__7_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 78522 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 78528 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _7;
            MenhirLib.EngineTypes.startp = _startpos__7_;
            MenhirLib.EngineTypes.endp = _endpos__7_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _6;
              MenhirLib.EngineTypes.startp = _startpos__6_;
              MenhirLib.EngineTypes.endp = _endpos__6_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = expr;
                    MenhirLib.EngineTypes.startp = _startpos_expr_;
                    MenhirLib.EngineTypes.endp = _endpos_expr_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3;
                      MenhirLib.EngineTypes.startp = _startpos__3_;
                      MenhirLib.EngineTypes.endp = _endpos__3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _4;
                        MenhirLib.EngineTypes.startp = _startpos__4_;
                        MenhirLib.EngineTypes.endp = _endpos__4_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined2;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _2;
                            MenhirLib.EngineTypes.startp = _startpos__2_;
                            MenhirLib.EngineTypes.endp = _endpos__2_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _menhir_s;
                                MenhirLib.EngineTypes.semv = _1;
                                MenhirLib.EngineTypes.startp = _startpos__1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_;
                                MenhirLib.EngineTypes.next = _menhir_stack;
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _7 : unit = Obj.magic _7 in
        let _6 : unit = Obj.magic _6 in
        let _2_inlined1 : (AST.expr) = Obj.magic _2_inlined1 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let _5 =
                let (_2, _1) = (_2_inlined1, _1_inlined3) in
                let x = _2 in
                
# 126 "<standard.mly>"
    ( Some x )
# 78637 "asllib/Parser0.ml"
                
              in
              let indented_block =
                let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 604 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 78647 "asllib/Parser0.ml"
                 _3_1
              in
              let _5_1 = _5 in
              
# 764 "asllib/Parser0.mly"
                       AST.S_Repeat 
# 78654 "asllib/Parser0.ml"
               (indented_block, expr, _5_1)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__7_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 78663 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 78669 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _9;
            MenhirLib.EngineTypes.startp = _startpos__9_;
            MenhirLib.EngineTypes.endp = _endpos__9_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _6;
                MenhirLib.EngineTypes.startp = _startpos__6_;
                MenhirLib.EngineTypes.endp = _endpos__6_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _5;
                  MenhirLib.EngineTypes.startp = _startpos__5_;
                  MenhirLib.EngineTypes.endp = _endpos__5_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined3;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3;
                      MenhirLib.EngineTypes.startp = _startpos__3_;
                      MenhirLib.EngineTypes.endp = _endpos__3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _4_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__4_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__4_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined2;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _2;
                            MenhirLib.EngineTypes.startp = _startpos__2_;
                            MenhirLib.EngineTypes.endp = _endpos__2_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _menhir_s;
                                MenhirLib.EngineTypes.semv = _1;
                                MenhirLib.EngineTypes.startp = _startpos__1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_;
                                MenhirLib.EngineTypes.next = _menhir_stack;
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _9 : unit = Obj.magic _9 in
        let _1_inlined4 : (unit list) = Obj.magic _1_inlined4 in
        let _6 : unit = Obj.magic _6 in
        let _5 : unit = Obj.magic _5 in
        let _1_inlined3 : (
# 82 "asllib/Parser0.mly"
       (string)
# 78762 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _4_inlined1 : unit = Obj.magic _4_inlined1 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let _1 =
                let _1 =
                  let _8 = 
# 123 "<standard.mly>"
    ( None )
# 78781 "asllib/Parser0.ml"
                   in
                  let _7 = _1_inlined4 in
                  let _4 = _1_inlined3 in
                  let _2 =
                    let (_4, _1_inlined1, _1) = (_4_inlined1, _1_inlined2, _1_inlined1) in
                    let _3 = _1_inlined1 in
                    let _3_1 = _3 in
                    
# 604 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 78792 "asllib/Parser0.ml"
                     _3_1
                  in
                  ()
                in
                ()
              in
              
# 612 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 78802 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__9_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 78811 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 78817 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _9;
            MenhirLib.EngineTypes.startp = _startpos__9_;
            MenhirLib.EngineTypes.endp = _endpos__9_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _4;
              MenhirLib.EngineTypes.startp = _startpos__4_;
              MenhirLib.EngineTypes.endp = _endpos__4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined7;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _2_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined6;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined5;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined4;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _6;
                          MenhirLib.EngineTypes.startp = _startpos__6_;
                          MenhirLib.EngineTypes.endp = _endpos__6_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _5;
                            MenhirLib.EngineTypes.startp = _startpos__5_;
                            MenhirLib.EngineTypes.endp = _endpos__5_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined3;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _3;
                                MenhirLib.EngineTypes.startp = _startpos__3_;
                                MenhirLib.EngineTypes.endp = _endpos__3_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _4_inlined1;
                                  MenhirLib.EngineTypes.startp = _startpos__4_inlined1_;
                                  MenhirLib.EngineTypes.endp = _endpos__4_inlined1_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _1_inlined2;
                                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = _2;
                                      MenhirLib.EngineTypes.startp = _startpos__2_;
                                      MenhirLib.EngineTypes.endp = _endpos__2_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _;
                                        MenhirLib.EngineTypes.semv = _1_inlined1;
                                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                        MenhirLib.EngineTypes.next = {
                                          MenhirLib.EngineTypes.state = _menhir_s;
                                          MenhirLib.EngineTypes.semv = _1;
                                          MenhirLib.EngineTypes.startp = _startpos__1_;
                                          MenhirLib.EngineTypes.endp = _endpos__1_;
                                          MenhirLib.EngineTypes.next = _menhir_stack;
                                        };
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _9 : unit = Obj.magic _9 in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined7 : (AST.stmt list) = Obj.magic _1_inlined7 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined6 : unit = Obj.magic _1_inlined6 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : (unit list) = Obj.magic _1_inlined4 in
        let _6 : unit = Obj.magic _6 in
        let _5 : unit = Obj.magic _5 in
        let _1_inlined3 : (
# 82 "asllib/Parser0.mly"
       (string)
# 78945 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _4_inlined1 : unit = Obj.magic _4_inlined1 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let _1 =
                let _1 =
                  let _8 =
                    let (_startpos__1_, _1_inlined2, _2, _1_inlined1, _1) = (_startpos__1_inlined5_, _1_inlined7, _2_inlined1, _1_inlined6, _1_inlined5) in
                    let x =
                      let desc =
                        let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                        let _3 = _1_inlined1 in
                        let _3_1 = _3 in
                        
# 604 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 78971 "asllib/Parser0.ml"
                         _3_1
                      in
                      let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
                      let _endpos = _endpos_desc_ in
                      let _symbolstartpos = _startpos_desc_ in
                      
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 78980 "asllib/Parser0.ml"
                      
                    in
                    
# 126 "<standard.mly>"
    ( Some x )
# 78986 "asllib/Parser0.ml"
                    
                  in
                  let _7 = _1_inlined4 in
                  let _4 = _1_inlined3 in
                  let _2 =
                    let (_4, _1_inlined1, _1) = (_4_inlined1, _1_inlined2, _1_inlined1) in
                    let _3 = _1_inlined1 in
                    let _3_1 = _3 in
                    
# 604 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 78998 "asllib/Parser0.ml"
                     _3_1
                  in
                  ()
                in
                ()
              in
              
# 612 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 79008 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__9_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 79017 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 79023 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _9;
            MenhirLib.EngineTypes.startp = _startpos__9_;
            MenhirLib.EngineTypes.endp = _endpos__9_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _6_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__6_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__6_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined9;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined9_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined9_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined8;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = expr;
                      MenhirLib.EngineTypes.startp = _startpos_expr_;
                      MenhirLib.EngineTypes.endp = _endpos_expr_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined7;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined6;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined5;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined4;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _6;
                                MenhirLib.EngineTypes.startp = _startpos__6_;
                                MenhirLib.EngineTypes.endp = _endpos__6_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _5;
                                  MenhirLib.EngineTypes.startp = _startpos__5_;
                                  MenhirLib.EngineTypes.endp = _endpos__5_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _1_inlined3;
                                    MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = _3;
                                      MenhirLib.EngineTypes.startp = _startpos__3_;
                                      MenhirLib.EngineTypes.endp = _endpos__3_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _;
                                        MenhirLib.EngineTypes.semv = _4_inlined1;
                                        MenhirLib.EngineTypes.startp = _startpos__4_inlined1_;
                                        MenhirLib.EngineTypes.endp = _endpos__4_inlined1_;
                                        MenhirLib.EngineTypes.next = {
                                          MenhirLib.EngineTypes.state = _;
                                          MenhirLib.EngineTypes.semv = _1_inlined2;
                                          MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                          MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                          MenhirLib.EngineTypes.next = {
                                            MenhirLib.EngineTypes.state = _;
                                            MenhirLib.EngineTypes.semv = _2;
                                            MenhirLib.EngineTypes.startp = _startpos__2_;
                                            MenhirLib.EngineTypes.endp = _endpos__2_;
                                            MenhirLib.EngineTypes.next = {
                                              MenhirLib.EngineTypes.state = _;
                                              MenhirLib.EngineTypes.semv = _1_inlined1;
                                              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                              MenhirLib.EngineTypes.next = {
                                                MenhirLib.EngineTypes.state = _menhir_s;
                                                MenhirLib.EngineTypes.semv = _1;
                                                MenhirLib.EngineTypes.startp = _startpos__1_;
                                                MenhirLib.EngineTypes.endp = _endpos__1_;
                                                MenhirLib.EngineTypes.next = _menhir_stack;
                                              };
                                            };
                                          };
                                        };
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _9 : unit = Obj.magic _9 in
        let _6_inlined1 : unit = Obj.magic _6_inlined1 in
        let _1_inlined9 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined9 in
        let _1_inlined8 : (AST.stmt list) = Obj.magic _1_inlined8 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1_inlined7 : unit = Obj.magic _1_inlined7 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : (unit list) = Obj.magic _1_inlined4 in
        let _6 : unit = Obj.magic _6 in
        let _5 : unit = Obj.magic _5 in
        let _1_inlined3 : (
# 82 "asllib/Parser0.mly"
       (string)
# 79172 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _4_inlined1 : unit = Obj.magic _4_inlined1 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let _1 =
                let _1 =
                  let _8 =
                    let (_endpos__6_, _startpos__1_inlined2_, _startpos__1_inlined1_, _startpos__1_, _6, _1_inlined4, _1_inlined3, _3, _1_inlined2, _1_inlined1, _1) = (_endpos__6_inlined1_, _startpos__1_inlined7_, _startpos__1_inlined6_, _startpos__1_inlined5_, _6_inlined1, _1_inlined9, _1_inlined8, _3_inlined1, _1_inlined7, _1_inlined6, _1_inlined5) in
                    let x =
                      let desc =
                        let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                        let desc =
                          let simple_if_stmt =
                            let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                            let desc =
                              let simple_else_opt =
                                let _1 = _1_inlined2 in
                                let _2 = 
# 123 "<standard.mly>"
    ( None )
# 79202 "asllib/Parser0.ml"
                                 in
                                let _1_1 = _1 in
                                let _2_1 = _2 in
                                
# 698 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 79209 "asllib/Parser0.ml"
                                 (_1_1, _2_1)
                              in
                              let simple_stmt_list =
                                let _1 = _1_inlined1 in
                                let _1_1 = _1 in
                                
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 79218 "asllib/Parser0.ml"
                                 _1_1
                              in
                              
# 695 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 79224 "asllib/Parser0.ml"
                               (expr, simple_stmt_list, simple_else_opt)
                            in
                            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                            let _endpos = _endpos_desc_ in
                            let _symbolstartpos = _startpos_desc_ in
                            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 79233 "asllib/Parser0.ml"
                            
                          in
                          let simple_stmt_list =
                            let _1_1 = _1 in
                            
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 79241 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 621 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 79247 "asllib/Parser0.ml"
                           (simple_stmt_list, simple_if_stmt)
                        in
                        let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                        let _endpos = _endpos_desc_ in
                        let _symbolstartpos = _startpos_desc_ in
                        
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 79256 "asllib/Parser0.ml"
                        
                      in
                      let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                      let _endpos = _endpos_desc_ in
                      let _symbolstartpos = _startpos_desc_ in
                      
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 79265 "asllib/Parser0.ml"
                      
                    in
                    
# 126 "<standard.mly>"
    ( Some x )
# 79271 "asllib/Parser0.ml"
                    
                  in
                  let _7 = _1_inlined4 in
                  let _4 = _1_inlined3 in
                  let _2 =
                    let (_4, _1_inlined1, _1) = (_4_inlined1, _1_inlined2, _1_inlined1) in
                    let _3 = _1_inlined1 in
                    let _3_1 = _3 in
                    
# 604 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 79283 "asllib/Parser0.ml"
                     _3_1
                  in
                  ()
                in
                ()
              in
              
# 612 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 79293 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__9_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 79302 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 79308 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _9;
            MenhirLib.EngineTypes.startp = _startpos__9_;
            MenhirLib.EngineTypes.endp = _endpos__9_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _6_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__6_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__6_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined11;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined11_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined11_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined10;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined10_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined10_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined9;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined9_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined9_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined8;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = expr;
                          MenhirLib.EngineTypes.startp = _startpos_expr_;
                          MenhirLib.EngineTypes.endp = _endpos_expr_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined7;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined6;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined5;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _1_inlined4;
                                  MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _6;
                                    MenhirLib.EngineTypes.startp = _startpos__6_;
                                    MenhirLib.EngineTypes.endp = _endpos__6_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = _5;
                                      MenhirLib.EngineTypes.startp = _startpos__5_;
                                      MenhirLib.EngineTypes.endp = _endpos__5_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _;
                                        MenhirLib.EngineTypes.semv = _1_inlined3;
                                        MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                                        MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                                        MenhirLib.EngineTypes.next = {
                                          MenhirLib.EngineTypes.state = _;
                                          MenhirLib.EngineTypes.semv = _3;
                                          MenhirLib.EngineTypes.startp = _startpos__3_;
                                          MenhirLib.EngineTypes.endp = _endpos__3_;
                                          MenhirLib.EngineTypes.next = {
                                            MenhirLib.EngineTypes.state = _;
                                            MenhirLib.EngineTypes.semv = _4_inlined1;
                                            MenhirLib.EngineTypes.startp = _startpos__4_inlined1_;
                                            MenhirLib.EngineTypes.endp = _endpos__4_inlined1_;
                                            MenhirLib.EngineTypes.next = {
                                              MenhirLib.EngineTypes.state = _;
                                              MenhirLib.EngineTypes.semv = _1_inlined2;
                                              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                              MenhirLib.EngineTypes.next = {
                                                MenhirLib.EngineTypes.state = _;
                                                MenhirLib.EngineTypes.semv = _2;
                                                MenhirLib.EngineTypes.startp = _startpos__2_;
                                                MenhirLib.EngineTypes.endp = _endpos__2_;
                                                MenhirLib.EngineTypes.next = {
                                                  MenhirLib.EngineTypes.state = _;
                                                  MenhirLib.EngineTypes.semv = _1_inlined1;
                                                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                                  MenhirLib.EngineTypes.next = {
                                                    MenhirLib.EngineTypes.state = _menhir_s;
                                                    MenhirLib.EngineTypes.semv = _1;
                                                    MenhirLib.EngineTypes.startp = _startpos__1_;
                                                    MenhirLib.EngineTypes.endp = _endpos__1_;
                                                    MenhirLib.EngineTypes.next = _menhir_stack;
                                                  };
                                                };
                                              };
                                            };
                                          };
                                        };
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _9 : unit = Obj.magic _9 in
        let _6_inlined1 : unit = Obj.magic _6_inlined1 in
        let _1_inlined11 : (AST.stmt list) = Obj.magic _1_inlined11 in
        let _1_inlined10 : unit = Obj.magic _1_inlined10 in
        let _1_inlined9 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined9 in
        let _1_inlined8 : (AST.stmt list) = Obj.magic _1_inlined8 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1_inlined7 : unit = Obj.magic _1_inlined7 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : (unit list) = Obj.magic _1_inlined4 in
        let _6 : unit = Obj.magic _6 in
        let _5 : unit = Obj.magic _5 in
        let _1_inlined3 : (
# 82 "asllib/Parser0.mly"
       (string)
# 79471 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _4_inlined1 : unit = Obj.magic _4_inlined1 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let _1 =
                let _1 =
                  let _8 =
                    let (_endpos__6_, _startpos__1_inlined2_, _startpos__1_inlined1_, _startpos__1_, _6, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _3, _1_inlined2, _1_inlined1, _1) = (_endpos__6_inlined1_, _startpos__1_inlined7_, _startpos__1_inlined6_, _startpos__1_inlined5_, _6_inlined1, _1_inlined11, _1_inlined10, _1_inlined9, _1_inlined8, _3_inlined1, _1_inlined7, _1_inlined6, _1_inlined5) in
                    let x =
                      let desc =
                        let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                        let desc =
                          let simple_if_stmt =
                            let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                            let desc =
                              let simple_else_opt =
                                let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                                let _2 =
                                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                                  let x =
                                    let _1 = _1_inlined1 in
                                    let _1_1 = _1 in
                                    
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 79506 "asllib/Parser0.ml"
                                     _1_1
                                  in
                                  
# 126 "<standard.mly>"
    ( Some x )
# 79512 "asllib/Parser0.ml"
                                  
                                in
                                let _1_1 = _1 in
                                let _2_1 = _2 in
                                
# 698 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 79520 "asllib/Parser0.ml"
                                 (_1_1, _2_1)
                              in
                              let simple_stmt_list =
                                let _1 = _1_inlined1 in
                                let _1_1 = _1 in
                                
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 79529 "asllib/Parser0.ml"
                                 _1_1
                              in
                              
# 695 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 79535 "asllib/Parser0.ml"
                               (expr, simple_stmt_list, simple_else_opt)
                            in
                            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                            let _endpos = _endpos_desc_ in
                            let _symbolstartpos = _startpos_desc_ in
                            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 79544 "asllib/Parser0.ml"
                            
                          in
                          let simple_stmt_list =
                            let _1_1 = _1 in
                            
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 79552 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 621 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 79558 "asllib/Parser0.ml"
                           (simple_stmt_list, simple_if_stmt)
                        in
                        let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                        let _endpos = _endpos_desc_ in
                        let _symbolstartpos = _startpos_desc_ in
                        
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 79567 "asllib/Parser0.ml"
                        
                      in
                      let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                      let _endpos = _endpos_desc_ in
                      let _symbolstartpos = _startpos_desc_ in
                      
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 79576 "asllib/Parser0.ml"
                      
                    in
                    
# 126 "<standard.mly>"
    ( Some x )
# 79582 "asllib/Parser0.ml"
                    
                  in
                  let _7 = _1_inlined4 in
                  let _4 = _1_inlined3 in
                  let _2 =
                    let (_4, _1_inlined1, _1) = (_4_inlined1, _1_inlined2, _1_inlined1) in
                    let _3 = _1_inlined1 in
                    let _3_1 = _3 in
                    
# 604 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 79594 "asllib/Parser0.ml"
                     _3_1
                  in
                  ()
                in
                ()
              in
              
# 612 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 79604 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__9_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 79613 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 79619 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _9;
            MenhirLib.EngineTypes.startp = _startpos__9_;
            MenhirLib.EngineTypes.endp = _endpos__9_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined6;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined5;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined4;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _6;
                      MenhirLib.EngineTypes.startp = _startpos__6_;
                      MenhirLib.EngineTypes.endp = _endpos__6_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _5;
                        MenhirLib.EngineTypes.startp = _startpos__5_;
                        MenhirLib.EngineTypes.endp = _endpos__5_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined3;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _3;
                            MenhirLib.EngineTypes.startp = _startpos__3_;
                            MenhirLib.EngineTypes.endp = _endpos__3_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _4_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__4_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__4_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined2;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _2;
                                  MenhirLib.EngineTypes.startp = _startpos__2_;
                                  MenhirLib.EngineTypes.endp = _endpos__2_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _1_inlined1;
                                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _menhir_s;
                                      MenhirLib.EngineTypes.semv = _1;
                                      MenhirLib.EngineTypes.startp = _startpos__1_;
                                      MenhirLib.EngineTypes.endp = _endpos__1_;
                                      MenhirLib.EngineTypes.next = _menhir_stack;
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _9 : unit = Obj.magic _9 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : (unit list) = Obj.magic _1_inlined4 in
        let _6 : unit = Obj.magic _6 in
        let _5 : unit = Obj.magic _5 in
        let _1_inlined3 : (
# 82 "asllib/Parser0.mly"
       (string)
# 79733 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _4_inlined1 : unit = Obj.magic _4_inlined1 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let _1 =
                let _1 =
                  let _8 =
                    let (_endpos__2_, _startpos__1_, _1_inlined1, _1) = (_endpos__2_inlined1_, _startpos__1_inlined5_, _1_inlined6, _1_inlined5) in
                    let x =
                      let desc =
                        let _1 = _1_inlined1 in
                        let x =
                          let _1_1 = _1 in
                          
# 625 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 79759 "asllib/Parser0.ml"
                           _1_1
                        in
                        
# 196 "<standard.mly>"
    ( x )
# 79765 "asllib/Parser0.ml"
                        
                      in
                      let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
                      let _endpos = _endpos_desc_ in
                      let _symbolstartpos = _startpos_desc_ in
                      
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 79774 "asllib/Parser0.ml"
                      
                    in
                    
# 126 "<standard.mly>"
    ( Some x )
# 79780 "asllib/Parser0.ml"
                    
                  in
                  let _7 = _1_inlined4 in
                  let _4 = _1_inlined3 in
                  let _2 =
                    let (_4, _1_inlined1, _1) = (_4_inlined1, _1_inlined2, _1_inlined1) in
                    let _3 = _1_inlined1 in
                    let _3_1 = _3 in
                    
# 604 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 79792 "asllib/Parser0.ml"
                     _3_1
                  in
                  ()
                in
                ()
              in
              
# 612 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 79802 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__9_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 79811 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 79817 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _9;
            MenhirLib.EngineTypes.startp = _startpos__9_;
            MenhirLib.EngineTypes.endp = _endpos__9_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined6;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined5;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined4;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _6;
                    MenhirLib.EngineTypes.startp = _startpos__6_;
                    MenhirLib.EngineTypes.endp = _endpos__6_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _5;
                      MenhirLib.EngineTypes.startp = _startpos__5_;
                      MenhirLib.EngineTypes.endp = _endpos__5_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined3;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _3;
                          MenhirLib.EngineTypes.startp = _startpos__3_;
                          MenhirLib.EngineTypes.endp = _endpos__3_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _4_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__4_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__4_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined2;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _2;
                                MenhirLib.EngineTypes.startp = _startpos__2_;
                                MenhirLib.EngineTypes.endp = _endpos__2_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _1_inlined1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _menhir_s;
                                    MenhirLib.EngineTypes.semv = _1;
                                    MenhirLib.EngineTypes.startp = _startpos__1_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_;
                                    MenhirLib.EngineTypes.next = _menhir_stack;
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _9 : unit = Obj.magic _9 in
        let _1_inlined6 : unit = Obj.magic _1_inlined6 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : (unit list) = Obj.magic _1_inlined4 in
        let _6 : unit = Obj.magic _6 in
        let _5 : unit = Obj.magic _5 in
        let _1_inlined3 : (
# 82 "asllib/Parser0.mly"
       (string)
# 79924 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _4_inlined1 : unit = Obj.magic _4_inlined1 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let _1 =
                let _1 =
                  let _8 =
                    let (_endpos__1_inlined1_, _startpos__1_, _1_inlined1, _1) = (_endpos__1_inlined6_, _startpos__1_inlined5_, _1_inlined6, _1_inlined5) in
                    let x =
                      let desc =
                        let _1 = _1_inlined1 in
                        
# 597 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 79948 "asllib/Parser0.ml"
                        
                      in
                      let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined1_, _startpos__1_) in
                      let _endpos = _endpos_desc_ in
                      let _symbolstartpos = _startpos_desc_ in
                      
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 79957 "asllib/Parser0.ml"
                      
                    in
                    
# 126 "<standard.mly>"
    ( Some x )
# 79963 "asllib/Parser0.ml"
                    
                  in
                  let _7 = _1_inlined4 in
                  let _4 = _1_inlined3 in
                  let _2 =
                    let (_4, _1_inlined1, _1) = (_4_inlined1, _1_inlined2, _1_inlined1) in
                    let _3 = _1_inlined1 in
                    let _3_1 = _3 in
                    
# 604 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 79975 "asllib/Parser0.ml"
                     _3_1
                  in
                  ()
                in
                ()
              in
              
# 612 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 79985 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__9_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 79994 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 80000 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _1_inlined1;
          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let _1_inlined1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 80028 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : (AST.slice list) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_inlined1_ in
        let _v =
          let _2 = 
# 123 "<standard.mly>"
    ( None )
# 80038 "asllib/Parser0.ml"
           in
          let x =
            let x = _1_inlined1 in
            let s = _1 in
            
# 316 "asllib/Parser0.mly"
                                          ( AST.BitField_Simple(x, s) )
# 80046 "asllib/Parser0.ml"
            
          in
          (
# 305 "asllib/Parser0.mly"
                                ( [ x ]  )
# 80052 "asllib/Parser0.ml"
           : (AST.bitfield list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = x;
          MenhirLib.EngineTypes.startp = _startpos_x_;
          MenhirLib.EngineTypes.endp = _endpos_x_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let x : unit = Obj.magic x in
        let _1_inlined1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 80087 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : (AST.slice list) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_x_ in
        let _v =
          let _2 = 
# 126 "<standard.mly>"
    ( Some x )
# 80097 "asllib/Parser0.ml"
           in
          let x =
            let x = _1_inlined1 in
            let s = _1 in
            
# 316 "asllib/Parser0.mly"
                                          ( AST.BitField_Simple(x, s) )
# 80105 "asllib/Parser0.ml"
            
          in
          (
# 305 "asllib/Parser0.mly"
                                ( [ x ]  )
# 80111 "asllib/Parser0.ml"
           : (AST.bitfield list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = t;
          MenhirLib.EngineTypes.startp = _startpos_t_;
          MenhirLib.EngineTypes.endp = _endpos_t_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = _1;
                MenhirLib.EngineTypes.startp = _startpos__1_;
                MenhirLib.EngineTypes.endp = _endpos__1_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let t : (AST.bitfield list) = Obj.magic t in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 80153 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : (AST.slice list) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_t_ in
        let _v =
          let x =
            let x = _1_inlined1 in
            let s = _1 in
            
# 316 "asllib/Parser0.mly"
                                          ( AST.BitField_Simple(x, s) )
# 80166 "asllib/Parser0.ml"
            
          in
          (
# 306 "asllib/Parser0.mly"
                                ( x :: t )
# 80172 "asllib/Parser0.ml"
           : (AST.bitfield list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = t;
            MenhirLib.EngineTypes.startp = _startpos_t_;
            MenhirLib.EngineTypes.endp = _endpos_t_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 80200 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let t : (AST.ty) = Obj.magic t in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_t_ in
        let _endpos = _endpos__1_ in
        let _v =
          let _2 = 
# 123 "<standard.mly>"
    ( None )
# 80210 "asllib/Parser0.ml"
           in
          let x =
            let x = _1 in
            
# 293 "asllib/Parser0.mly"
                               ( (x, t) )
# 80217 "asllib/Parser0.ml"
            
          in
          (
# 305 "asllib/Parser0.mly"
                                ( [ x ]  )
# 80223 "asllib/Parser0.ml"
           : (AST.field list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = x;
          MenhirLib.EngineTypes.startp = _startpos_x_;
          MenhirLib.EngineTypes.endp = _endpos_x_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = t;
              MenhirLib.EngineTypes.startp = _startpos_t_;
              MenhirLib.EngineTypes.endp = _endpos_t_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let x : unit = Obj.magic x in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 80258 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let t : (AST.ty) = Obj.magic t in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_t_ in
        let _endpos = _endpos_x_ in
        let _v =
          let _2 = 
# 126 "<standard.mly>"
    ( Some x )
# 80268 "asllib/Parser0.ml"
           in
          let x =
            let x = _1 in
            
# 293 "asllib/Parser0.mly"
                               ( (x, t) )
# 80275 "asllib/Parser0.ml"
            
          in
          (
# 305 "asllib/Parser0.mly"
                                ( [ x ]  )
# 80281 "asllib/Parser0.ml"
           : (AST.field list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = t;
          MenhirLib.EngineTypes.startp = _startpos_t_;
          MenhirLib.EngineTypes.endp = _endpos_t_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = t_inlined1;
                MenhirLib.EngineTypes.startp = _startpos_t_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos_t_inlined1_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let t : (AST.field list) = Obj.magic t in
        let _2 : unit = Obj.magic _2 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 80323 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let t_inlined1 : (AST.ty) = Obj.magic t_inlined1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_t_inlined1_ in
        let _endpos = _endpos_t_ in
        let _v =
          let x =
            let t = t_inlined1 in
            let x = _1 in
            
# 293 "asllib/Parser0.mly"
                               ( (x, t) )
# 80336 "asllib/Parser0.ml"
            
          in
          (
# 306 "asllib/Parser0.mly"
                                ( x :: t )
# 80342 "asllib/Parser0.ml"
           : (AST.field list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 80364 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v =
          let _2 = 
# 123 "<standard.mly>"
    ( None )
# 80373 "asllib/Parser0.ml"
           in
          let x = _1 in
          (
# 305 "asllib/Parser0.mly"
                                ( [ x ]  )
# 80379 "asllib/Parser0.ml"
           : (string list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = x;
          MenhirLib.EngineTypes.startp = _startpos_x_;
          MenhirLib.EngineTypes.endp = _endpos_x_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let x : unit = Obj.magic x in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 80408 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_x_ in
        let _v =
          let _2 = 
# 126 "<standard.mly>"
    ( Some x )
# 80417 "asllib/Parser0.ml"
           in
          let x = _1 in
          (
# 305 "asllib/Parser0.mly"
                                ( [ x ]  )
# 80423 "asllib/Parser0.ml"
           : (string list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = t;
          MenhirLib.EngineTypes.startp = _startpos_t_;
          MenhirLib.EngineTypes.endp = _endpos_t_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let t : (string list) = Obj.magic t in
        let _2 : unit = Obj.magic _2 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 80459 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_t_ in
        let _v =
          let x = _1 in
          (
# 306 "asllib/Parser0.mly"
                                ( x :: t )
# 80469 "asllib/Parser0.ml"
           : (string list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = body;
            MenhirLib.EngineTypes.startp = _startpos_body_;
            MenhirLib.EngineTypes.endp = _endpos_body_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let body : (AST.stmt list) = Obj.magic body in
        let _1 : (unit list) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__3_ in
        let _v : (AST.t) = 
# 238 "asllib/Parser0.mly"
    (
      let body = ASTUtils.stmt_from_list body in
      AST.[
        D_Func {
          name = "main";
          args = [];
          parameters = [];
          body = SB_ASL body;
          return_type = None;
          subprogram_type = ST_Procedure;
          recurse_limit = None;
          builtin = false;
        } |> ASTUtils.add_pos_from body
      ]
    )
# 80523 "asllib/Parser0.ml"
         in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = expr;
          MenhirLib.EngineTypes.startp = _startpos_expr_;
          MenhirLib.EngineTypes.endp = _endpos_expr_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let expr : (AST.expr) = Obj.magic expr in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_expr_ in
        let _endpos = _endpos_expr_ in
        let _v =
          let x =
            let desc = 
# 752 "asllib/Parser0.mly"
                AST.Pattern_Single  
# 80550 "asllib/Parser0.ml"
             expr in
            let (_endpos_desc_, _startpos_desc_) = (_endpos_expr_, _startpos_expr_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 80558 "asllib/Parser0.ml"
            
          in
          (
# 250 "<standard.mly>"
    ( [ x ] )
# 80564 "asllib/Parser0.ml"
           : (AST.pattern list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _2 : unit = Obj.magic _2 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let x =
            let desc = 
# 753 "asllib/Parser0.mly"
                                   AST.Pattern_Range  
# 80606 "asllib/Parser0.ml"
             (e1, e2) in
            let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 80614 "asllib/Parser0.ml"
            
          in
          (
# 250 "<standard.mly>"
    ( [ x ] )
# 80620 "asllib/Parser0.ml"
           : (AST.pattern list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v =
          let x =
            let desc = 
# 737 "asllib/Parser0.mly"
                                    ( AST.Pattern_All )
# 80648 "asllib/Parser0.ml"
             in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 80656 "asllib/Parser0.ml"
            
          in
          (
# 250 "<standard.mly>"
    ( [ x ] )
# 80662 "asllib/Parser0.ml"
           : (AST.pattern list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : (
# 83 "asllib/Parser0.mly"
       (Bitvector.mask)
# 80684 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v =
          let x =
            let desc =
              let _1_1 = _1 in
              
# 736 "asllib/Parser0.mly"
                                           AST.Pattern_Mask 
# 80696 "asllib/Parser0.ml"
               _1_1
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 80705 "asllib/Parser0.ml"
            
          in
          (
# 250 "<standard.mly>"
    ( [ x ] )
# 80711 "asllib/Parser0.ml"
           : (AST.pattern list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let xs : (AST.pattern list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_expr_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc = 
# 752 "asllib/Parser0.mly"
                AST.Pattern_Single  
# 80753 "asllib/Parser0.ml"
             expr in
            let (_endpos_desc_, _startpos_desc_) = (_endpos_expr_, _startpos_expr_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 80761 "asllib/Parser0.ml"
            
          in
          (
# 253 "<standard.mly>"
    ( x :: xs )
# 80767 "asllib/Parser0.ml"
           : (AST.pattern list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = e2;
              MenhirLib.EngineTypes.startp = _startpos_e2_;
              MenhirLib.EngineTypes.endp = _endpos_e2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = e1;
                  MenhirLib.EngineTypes.startp = _startpos_e1_;
                  MenhirLib.EngineTypes.endp = _endpos_e1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.pattern list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _2 = _2_inlined1 in
            let desc = 
# 753 "asllib/Parser0.mly"
                                   AST.Pattern_Range  
# 80824 "asllib/Parser0.ml"
             (e1, e2) in
            let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 80832 "asllib/Parser0.ml"
            
          in
          (
# 253 "<standard.mly>"
    ( x :: xs )
# 80838 "asllib/Parser0.ml"
           : (AST.pattern list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let xs : (AST.pattern list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc = 
# 737 "asllib/Parser0.mly"
                                    ( AST.Pattern_All )
# 80880 "asllib/Parser0.ml"
             in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 80888 "asllib/Parser0.ml"
            
          in
          (
# 253 "<standard.mly>"
    ( x :: xs )
# 80894 "asllib/Parser0.ml"
           : (AST.pattern list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let xs : (AST.pattern list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1 : (
# 83 "asllib/Parser0.mly"
       (Bitvector.mask)
# 80930 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let _1_1 = _1 in
              
# 736 "asllib/Parser0.mly"
                                           AST.Pattern_Mask 
# 80942 "asllib/Parser0.ml"
               _1_1
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 80951 "asllib/Parser0.ml"
            
          in
          (
# 253 "<standard.mly>"
    ( x :: xs )
# 80957 "asllib/Parser0.ml"
           : (AST.pattern list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = x;
          MenhirLib.EngineTypes.startp = _startpos_x_;
          MenhirLib.EngineTypes.endp = _endpos_x_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let x : (AST.expr) = Obj.magic x in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_x_ in
        let _endpos = _endpos_x_ in
        let _v : (AST.expr list) = 
# 250 "<standard.mly>"
    ( [ x ] )
# 80983 "asllib/Parser0.ml"
         in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = x;
              MenhirLib.EngineTypes.startp = _startpos_x_;
              MenhirLib.EngineTypes.endp = _endpos_x_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let xs : (AST.expr list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let x : (AST.expr) = Obj.magic x in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_x_ in
        let _endpos = _endpos_xs_ in
        let _v : (AST.expr list) = 
# 253 "<standard.mly>"
    ( x :: xs )
# 81022 "asllib/Parser0.ml"
         in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = t;
            MenhirLib.EngineTypes.startp = _startpos_t_;
            MenhirLib.EngineTypes.endp = _endpos_t_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 81049 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let t : (AST.ty) = Obj.magic t in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_t_ in
        let _endpos = _endpos__1_ in
        let _v =
          let x =
            let x = _1 in
            
# 595 "asllib/Parser0.mly"
                             ( (x, t) )
# 81061 "asllib/Parser0.ml"
            
          in
          (
# 250 "<standard.mly>"
    ( [ x ] )
# 81067 "asllib/Parser0.ml"
           : (AST.typed_identifier list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = t;
                MenhirLib.EngineTypes.startp = _startpos_t_;
                MenhirLib.EngineTypes.endp = _endpos_t_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.typed_identifier list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 81109 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let t : (AST.ty) = Obj.magic t in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_t_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x = _1 in
            
# 595 "asllib/Parser0.mly"
                             ( (x, t) )
# 81121 "asllib/Parser0.ml"
            
          in
          (
# 253 "<standard.mly>"
    ( x :: xs )
# 81127 "asllib/Parser0.ml"
           : (AST.typed_identifier list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 81149 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v =
          let x = _1 in
          (
# 250 "<standard.mly>"
    ( [ x ] )
# 81159 "asllib/Parser0.ml"
           : (string list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let xs : (string list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 81195 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x = _1 in
          (
# 253 "<standard.mly>"
    ( x :: xs )
# 81205 "asllib/Parser0.ml"
           : (string list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = x;
          MenhirLib.EngineTypes.startp = _startpos_x_;
          MenhirLib.EngineTypes.endp = _endpos_x_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let x : (AST.local_decl_item) = Obj.magic x in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_x_ in
        let _endpos = _endpos_x_ in
        let _v : (AST.local_decl_item list) = 
# 250 "<standard.mly>"
    ( [ x ] )
# 81231 "asllib/Parser0.ml"
         in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = x;
              MenhirLib.EngineTypes.startp = _startpos_x_;
              MenhirLib.EngineTypes.endp = _endpos_x_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let xs : (AST.local_decl_item list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let x : (AST.local_decl_item) = Obj.magic x in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_x_ in
        let _endpos = _endpos_xs_ in
        let _v : (AST.local_decl_item list) = 
# 253 "<standard.mly>"
    ( x :: xs )
# 81270 "asllib/Parser0.ml"
         in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = x;
          MenhirLib.EngineTypes.startp = _startpos_x_;
          MenhirLib.EngineTypes.endp = _endpos_x_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let x : (AST.lexpr) = Obj.magic x in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_x_ in
        let _endpos = _endpos_x_ in
        let _v : (AST.lexpr list) = 
# 250 "<standard.mly>"
    ( [ x ] )
# 81295 "asllib/Parser0.ml"
         in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = x;
              MenhirLib.EngineTypes.startp = _startpos_x_;
              MenhirLib.EngineTypes.endp = _endpos_x_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let xs : (AST.lexpr list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let x : (AST.lexpr) = Obj.magic x in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_x_ in
        let _endpos = _endpos_xs_ in
        let _v : (AST.lexpr list) = 
# 253 "<standard.mly>"
    ( x :: xs )
# 81334 "asllib/Parser0.ml"
         in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (AST.pattern list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__3_ in
        let _v =
          let x =
            let desc =
              let x =
                let _1 = _1_inlined1 in
                let _1_1 = _1 in
                
# 749 "asllib/Parser0.mly"
                                                       AST.Pattern_Any  
# 81379 "asllib/Parser0.ml"
                 _1_1
              in
              
# 205 "<standard.mly>"
    ( x )
# 81385 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 81394 "asllib/Parser0.ml"
            
          in
          (
# 250 "<standard.mly>"
    ( [ x ] )
# 81400 "asllib/Parser0.ml"
           : (AST.pattern list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : (
# 83 "asllib/Parser0.mly"
       (Bitvector.mask)
# 81422 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v =
          let x =
            let desc =
              let _1_1 = _1 in
              
# 736 "asllib/Parser0.mly"
                                           AST.Pattern_Mask 
# 81434 "asllib/Parser0.ml"
               _1_1
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 81443 "asllib/Parser0.ml"
            
          in
          (
# 250 "<standard.mly>"
    ( [ x ] )
# 81449 "asllib/Parser0.ml"
           : (AST.pattern list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v =
          let x =
            let desc = 
# 737 "asllib/Parser0.mly"
                                    ( AST.Pattern_All )
# 81477 "asllib/Parser0.ml"
             in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 81485 "asllib/Parser0.ml"
            
          in
          (
# 250 "<standard.mly>"
    ( [ x ] )
# 81491 "asllib/Parser0.ml"
           : (AST.pattern list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : (
# 87 "asllib/Parser0.mly"
       (bool)
# 81513 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v =
          let x =
            let desc =
              let _1 =
                let desc =
                  let literal_expression =
                    let _1_1 = _1 in
                    
# 399 "asllib/Parser0.mly"
                       AST.L_Bool        
# 81528 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 745 "asllib/Parser0.mly"
                                  AST.E_Literal  
# 81534 "asllib/Parser0.ml"
                   literal_expression
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 81543 "asllib/Parser0.ml"
                
              in
              let _1_1 = _1 in
              
# 747 "asllib/Parser0.mly"
           AST.Pattern_Single  
# 81550 "asllib/Parser0.ml"
               _1_1
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 81559 "asllib/Parser0.ml"
            
          in
          (
# 250 "<standard.mly>"
    ( [ x ] )
# 81565 "asllib/Parser0.ml"
           : (AST.pattern list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : (
# 85 "asllib/Parser0.mly"
       (Z.t)
# 81587 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v =
          let x =
            let desc =
              let _1 =
                let desc =
                  let literal_expression =
                    let _1_1 = _1 in
                    
# 400 "asllib/Parser0.mly"
                       AST.L_Int         
# 81602 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 745 "asllib/Parser0.mly"
                                  AST.E_Literal  
# 81608 "asllib/Parser0.ml"
                   literal_expression
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 81617 "asllib/Parser0.ml"
                
              in
              let _1_1 = _1 in
              
# 747 "asllib/Parser0.mly"
           AST.Pattern_Single  
# 81624 "asllib/Parser0.ml"
               _1_1
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 81633 "asllib/Parser0.ml"
            
          in
          (
# 250 "<standard.mly>"
    ( [ x ] )
# 81639 "asllib/Parser0.ml"
           : (AST.pattern list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : (
# 86 "asllib/Parser0.mly"
       (Q.t)
# 81661 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v =
          let x =
            let desc =
              let _1 =
                let desc =
                  let literal_expression =
                    let _1_1 = _1 in
                    
# 401 "asllib/Parser0.mly"
                       AST.L_Real        
# 81676 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 745 "asllib/Parser0.mly"
                                  AST.E_Literal  
# 81682 "asllib/Parser0.ml"
                   literal_expression
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 81691 "asllib/Parser0.ml"
                
              in
              let _1_1 = _1 in
              
# 747 "asllib/Parser0.mly"
           AST.Pattern_Single  
# 81698 "asllib/Parser0.ml"
               _1_1
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 81707 "asllib/Parser0.ml"
            
          in
          (
# 250 "<standard.mly>"
    ( [ x ] )
# 81713 "asllib/Parser0.ml"
           : (AST.pattern list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : (
# 84 "asllib/Parser0.mly"
       (Bitvector.t)
# 81735 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v =
          let x =
            let desc =
              let _1 =
                let desc =
                  let literal_expression =
                    let _1_1 = _1 in
                    
# 402 "asllib/Parser0.mly"
                       AST.L_BitVector   
# 81750 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 745 "asllib/Parser0.mly"
                                  AST.E_Literal  
# 81756 "asllib/Parser0.ml"
                   literal_expression
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 81765 "asllib/Parser0.ml"
                
              in
              let _1_1 = _1 in
              
# 747 "asllib/Parser0.mly"
           AST.Pattern_Single  
# 81772 "asllib/Parser0.ml"
               _1_1
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 81781 "asllib/Parser0.ml"
            
          in
          (
# 250 "<standard.mly>"
    ( [ x ] )
# 81787 "asllib/Parser0.ml"
           : (AST.pattern list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 81809 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v =
          let x =
            let desc =
              let _1 =
                let desc =
                  let literal_expression =
                    let _1_1 = _1 in
                    
# 403 "asllib/Parser0.mly"
                       AST.L_String      
# 81824 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 745 "asllib/Parser0.mly"
                                  AST.E_Literal  
# 81830 "asllib/Parser0.ml"
                   literal_expression
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 81839 "asllib/Parser0.ml"
                
              in
              let _1_1 = _1 in
              
# 747 "asllib/Parser0.mly"
           AST.Pattern_Single  
# 81846 "asllib/Parser0.ml"
               _1_1
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 81855 "asllib/Parser0.ml"
            
          in
          (
# 250 "<standard.mly>"
    ( [ x ] )
# 81861 "asllib/Parser0.ml"
           : (AST.pattern list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = q;
              MenhirLib.EngineTypes.startp = _startpos_q_;
              MenhirLib.EngineTypes.endp = _endpos_q_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 81895 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 81901 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos__1_ in
        let _v =
          let x =
            let desc =
              let _1 =
                let desc =
                  let qualident =
                    let i = _1 in
                    
# 347 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 81916 "asllib/Parser0.ml"
                    
                  in
                  
# 746 "asllib/Parser0.mly"
                         AST.E_Var  
# 81922 "asllib/Parser0.ml"
                   qualident
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos_q_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 81931 "asllib/Parser0.ml"
                
              in
              let _1_1 = _1 in
              
# 747 "asllib/Parser0.mly"
           AST.Pattern_Single  
# 81938 "asllib/Parser0.ml"
               _1_1
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos_q_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 81947 "asllib/Parser0.ml"
            
          in
          (
# 250 "<standard.mly>"
    ( [ x ] )
# 81953 "asllib/Parser0.ml"
           : (AST.pattern list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 81975 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v =
          let x =
            let desc =
              let _1 =
                let desc =
                  let qualident = _1 in
                  
# 746 "asllib/Parser0.mly"
                         AST.E_Var  
# 81989 "asllib/Parser0.ml"
                   qualident
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 81998 "asllib/Parser0.ml"
                
              in
              let _1_1 = _1 in
              
# 747 "asllib/Parser0.mly"
           AST.Pattern_Single  
# 82005 "asllib/Parser0.ml"
               _1_1
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 82014 "asllib/Parser0.ml"
            
          in
          (
# 250 "<standard.mly>"
    ( [ x ] )
# 82020 "asllib/Parser0.ml"
           : (AST.pattern list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v =
          let x =
            let desc =
              let _1 =
                let desc =
                  let qualident = 
# 349 "asllib/Parser0.mly"
              ( "record" )
# 82051 "asllib/Parser0.ml"
                   in
                  
# 746 "asllib/Parser0.mly"
                         AST.E_Var  
# 82056 "asllib/Parser0.ml"
                   qualident
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 82065 "asllib/Parser0.ml"
                
              in
              let _1_1 = _1 in
              
# 747 "asllib/Parser0.mly"
           AST.Pattern_Single  
# 82072 "asllib/Parser0.ml"
               _1_1
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 82081 "asllib/Parser0.ml"
            
          in
          (
# 250 "<standard.mly>"
    ( [ x ] )
# 82087 "asllib/Parser0.ml"
           : (AST.pattern list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.pattern list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (AST.pattern list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _1 = _1_inlined1 in
                let _1_1 = _1 in
                
# 749 "asllib/Parser0.mly"
                                                       AST.Pattern_Any  
# 82147 "asllib/Parser0.ml"
                 _1_1
              in
              
# 205 "<standard.mly>"
    ( x )
# 82153 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 82162 "asllib/Parser0.ml"
            
          in
          (
# 253 "<standard.mly>"
    ( x :: xs )
# 82168 "asllib/Parser0.ml"
           : (AST.pattern list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let xs : (AST.pattern list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1 : (
# 83 "asllib/Parser0.mly"
       (Bitvector.mask)
# 82204 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let _1_1 = _1 in
              
# 736 "asllib/Parser0.mly"
                                           AST.Pattern_Mask 
# 82216 "asllib/Parser0.ml"
               _1_1
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 82225 "asllib/Parser0.ml"
            
          in
          (
# 253 "<standard.mly>"
    ( x :: xs )
# 82231 "asllib/Parser0.ml"
           : (AST.pattern list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let xs : (AST.pattern list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc = 
# 737 "asllib/Parser0.mly"
                                    ( AST.Pattern_All )
# 82273 "asllib/Parser0.ml"
             in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 82281 "asllib/Parser0.ml"
            
          in
          (
# 253 "<standard.mly>"
    ( x :: xs )
# 82287 "asllib/Parser0.ml"
           : (AST.pattern list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let xs : (AST.pattern list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1 : (
# 87 "asllib/Parser0.mly"
       (bool)
# 82323 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let _1 =
                let desc =
                  let literal_expression =
                    let _1_1 = _1 in
                    
# 399 "asllib/Parser0.mly"
                       AST.L_Bool        
# 82338 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 745 "asllib/Parser0.mly"
                                  AST.E_Literal  
# 82344 "asllib/Parser0.ml"
                   literal_expression
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 82353 "asllib/Parser0.ml"
                
              in
              let _1_1 = _1 in
              
# 747 "asllib/Parser0.mly"
           AST.Pattern_Single  
# 82360 "asllib/Parser0.ml"
               _1_1
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 82369 "asllib/Parser0.ml"
            
          in
          (
# 253 "<standard.mly>"
    ( x :: xs )
# 82375 "asllib/Parser0.ml"
           : (AST.pattern list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let xs : (AST.pattern list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1 : (
# 85 "asllib/Parser0.mly"
       (Z.t)
# 82411 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let _1 =
                let desc =
                  let literal_expression =
                    let _1_1 = _1 in
                    
# 400 "asllib/Parser0.mly"
                       AST.L_Int         
# 82426 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 745 "asllib/Parser0.mly"
                                  AST.E_Literal  
# 82432 "asllib/Parser0.ml"
                   literal_expression
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 82441 "asllib/Parser0.ml"
                
              in
              let _1_1 = _1 in
              
# 747 "asllib/Parser0.mly"
           AST.Pattern_Single  
# 82448 "asllib/Parser0.ml"
               _1_1
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 82457 "asllib/Parser0.ml"
            
          in
          (
# 253 "<standard.mly>"
    ( x :: xs )
# 82463 "asllib/Parser0.ml"
           : (AST.pattern list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let xs : (AST.pattern list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1 : (
# 86 "asllib/Parser0.mly"
       (Q.t)
# 82499 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let _1 =
                let desc =
                  let literal_expression =
                    let _1_1 = _1 in
                    
# 401 "asllib/Parser0.mly"
                       AST.L_Real        
# 82514 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 745 "asllib/Parser0.mly"
                                  AST.E_Literal  
# 82520 "asllib/Parser0.ml"
                   literal_expression
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 82529 "asllib/Parser0.ml"
                
              in
              let _1_1 = _1 in
              
# 747 "asllib/Parser0.mly"
           AST.Pattern_Single  
# 82536 "asllib/Parser0.ml"
               _1_1
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 82545 "asllib/Parser0.ml"
            
          in
          (
# 253 "<standard.mly>"
    ( x :: xs )
# 82551 "asllib/Parser0.ml"
           : (AST.pattern list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let xs : (AST.pattern list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1 : (
# 84 "asllib/Parser0.mly"
       (Bitvector.t)
# 82587 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let _1 =
                let desc =
                  let literal_expression =
                    let _1_1 = _1 in
                    
# 402 "asllib/Parser0.mly"
                       AST.L_BitVector   
# 82602 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 745 "asllib/Parser0.mly"
                                  AST.E_Literal  
# 82608 "asllib/Parser0.ml"
                   literal_expression
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 82617 "asllib/Parser0.ml"
                
              in
              let _1_1 = _1 in
              
# 747 "asllib/Parser0.mly"
           AST.Pattern_Single  
# 82624 "asllib/Parser0.ml"
               _1_1
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 82633 "asllib/Parser0.ml"
            
          in
          (
# 253 "<standard.mly>"
    ( x :: xs )
# 82639 "asllib/Parser0.ml"
           : (AST.pattern list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let xs : (AST.pattern list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 82675 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let _1 =
                let desc =
                  let literal_expression =
                    let _1_1 = _1 in
                    
# 403 "asllib/Parser0.mly"
                       AST.L_String      
# 82690 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 745 "asllib/Parser0.mly"
                                  AST.E_Literal  
# 82696 "asllib/Parser0.ml"
                   literal_expression
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 82705 "asllib/Parser0.ml"
                
              in
              let _1_1 = _1 in
              
# 747 "asllib/Parser0.mly"
           AST.Pattern_Single  
# 82712 "asllib/Parser0.ml"
               _1_1
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 82721 "asllib/Parser0.ml"
            
          in
          (
# 253 "<standard.mly>"
    ( x :: xs )
# 82727 "asllib/Parser0.ml"
           : (AST.pattern list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = q;
                  MenhirLib.EngineTypes.startp = _startpos_q_;
                  MenhirLib.EngineTypes.endp = _endpos_q_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.pattern list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 82775 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 82781 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _2 = _2_inlined1 in
            let desc =
              let _1 =
                let desc =
                  let qualident =
                    let i = _1 in
                    
# 347 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 82797 "asllib/Parser0.ml"
                    
                  in
                  
# 746 "asllib/Parser0.mly"
                         AST.E_Var  
# 82803 "asllib/Parser0.ml"
                   qualident
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos_q_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 82812 "asllib/Parser0.ml"
                
              in
              let _1_1 = _1 in
              
# 747 "asllib/Parser0.mly"
           AST.Pattern_Single  
# 82819 "asllib/Parser0.ml"
               _1_1
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos_q_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 82828 "asllib/Parser0.ml"
            
          in
          (
# 253 "<standard.mly>"
    ( x :: xs )
# 82834 "asllib/Parser0.ml"
           : (AST.pattern list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let xs : (AST.pattern list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 82870 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let _1 =
                let desc =
                  let qualident = _1 in
                  
# 746 "asllib/Parser0.mly"
                         AST.E_Var  
# 82884 "asllib/Parser0.ml"
                   qualident
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 82893 "asllib/Parser0.ml"
                
              in
              let _1_1 = _1 in
              
# 747 "asllib/Parser0.mly"
           AST.Pattern_Single  
# 82900 "asllib/Parser0.ml"
               _1_1
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 82909 "asllib/Parser0.ml"
            
          in
          (
# 253 "<standard.mly>"
    ( x :: xs )
# 82915 "asllib/Parser0.ml"
           : (AST.pattern list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let xs : (AST.pattern list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let _1 =
                let desc =
                  let qualident = 
# 349 "asllib/Parser0.mly"
              ( "record" )
# 82960 "asllib/Parser0.ml"
                   in
                  
# 746 "asllib/Parser0.mly"
                         AST.E_Var  
# 82965 "asllib/Parser0.ml"
                   qualident
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 82974 "asllib/Parser0.ml"
                
              in
              let _1_1 = _1 in
              
# 747 "asllib/Parser0.mly"
           AST.Pattern_Single  
# 82981 "asllib/Parser0.ml"
               _1_1
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 82990 "asllib/Parser0.ml"
            
          in
          (
# 253 "<standard.mly>"
    ( x :: xs )
# 82996 "asllib/Parser0.ml"
           : (AST.pattern list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = t;
            MenhirLib.EngineTypes.startp = _startpos_t_;
            MenhirLib.EngineTypes.endp = _endpos_t_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 83024 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let t : (AST.ty) = Obj.magic t in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_t_ in
        let _endpos = _endpos__1_ in
        let _v =
          let x =
            let x = _1 in
            let _2 = 
# 123 "<standard.mly>"
    ( None )
# 83036 "asllib/Parser0.ml"
             in
            
# 594 "asllib/Parser0.mly"
                                            ( (x, t) )
# 83041 "asllib/Parser0.ml"
            
          in
          (
# 250 "<standard.mly>"
    ( [ x ] )
# 83047 "asllib/Parser0.ml"
           : (AST.typed_identifier list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = x_inlined1;
            MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = t;
              MenhirLib.EngineTypes.startp = _startpos_t_;
              MenhirLib.EngineTypes.endp = _endpos_t_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 83081 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let x_inlined1 : unit = Obj.magic x_inlined1 in
        let t : (AST.ty) = Obj.magic t in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_t_ in
        let _endpos = _endpos__1_ in
        let _v =
          let x =
            let x = _1 in
            let _2 =
              let x = x_inlined1 in
              
# 126 "<standard.mly>"
    ( Some x )
# 83096 "asllib/Parser0.ml"
              
            in
            
# 594 "asllib/Parser0.mly"
                                            ( (x, t) )
# 83102 "asllib/Parser0.ml"
            
          in
          (
# 250 "<standard.mly>"
    ( [ x ] )
# 83108 "asllib/Parser0.ml"
           : (AST.typed_identifier list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = t;
                MenhirLib.EngineTypes.startp = _startpos_t_;
                MenhirLib.EngineTypes.endp = _endpos_t_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.typed_identifier list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 83150 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let t : (AST.ty) = Obj.magic t in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_t_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x = _1 in
            let _2 = 
# 123 "<standard.mly>"
    ( None )
# 83162 "asllib/Parser0.ml"
             in
            
# 594 "asllib/Parser0.mly"
                                            ( (x, t) )
# 83167 "asllib/Parser0.ml"
            
          in
          (
# 253 "<standard.mly>"
    ( x :: xs )
# 83173 "asllib/Parser0.ml"
           : (AST.typed_identifier list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = x_inlined1;
                MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = t;
                  MenhirLib.EngineTypes.startp = _startpos_t_;
                  MenhirLib.EngineTypes.endp = _endpos_t_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.typed_identifier list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 83221 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let x_inlined1 : unit = Obj.magic x_inlined1 in
        let t : (AST.ty) = Obj.magic t in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_t_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x = _1 in
            let _2 =
              let x = x_inlined1 in
              
# 126 "<standard.mly>"
    ( Some x )
# 83236 "asllib/Parser0.ml"
              
            in
            
# 594 "asllib/Parser0.mly"
                                            ( (x, t) )
# 83242 "asllib/Parser0.ml"
            
          in
          (
# 253 "<standard.mly>"
    ( x :: xs )
# 83248 "asllib/Parser0.ml"
           : (AST.typed_identifier list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = sexpr;
          MenhirLib.EngineTypes.startp = _startpos_sexpr_;
          MenhirLib.EngineTypes.endp = _endpos_sexpr_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let sexpr : (AST.expr) = Obj.magic sexpr in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_sexpr_ in
        let _endpos = _endpos_sexpr_ in
        let _v =
          let x = 
# 394 "asllib/Parser0.mly"
                                      AST.Slice_Single  
# 83275 "asllib/Parser0.ml"
           sexpr in
          (
# 250 "<standard.mly>"
    ( [ x ] )
# 83280 "asllib/Parser0.ml"
           : (AST.slice list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _2 : unit = Obj.magic _2 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let x = 
# 395 "asllib/Parser0.mly"
                                      AST.Slice_Range   
# 83321 "asllib/Parser0.ml"
           (e1, e2) in
          (
# 250 "<standard.mly>"
    ( [ x ] )
# 83326 "asllib/Parser0.ml"
           : (AST.slice list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _2 : unit = Obj.magic _2 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let x = 
# 396 "asllib/Parser0.mly"
                                      AST.Slice_Length  
# 83367 "asllib/Parser0.ml"
           (e1, e2) in
          (
# 250 "<standard.mly>"
    ( [ x ] )
# 83372 "asllib/Parser0.ml"
           : (AST.slice list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = sexpr;
              MenhirLib.EngineTypes.startp = _startpos_sexpr_;
              MenhirLib.EngineTypes.endp = _endpos_sexpr_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let xs : (AST.slice list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let sexpr : (AST.expr) = Obj.magic sexpr in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_sexpr_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x = 
# 394 "asllib/Parser0.mly"
                                      AST.Slice_Single  
# 83413 "asllib/Parser0.ml"
           sexpr in
          (
# 253 "<standard.mly>"
    ( x :: xs )
# 83418 "asllib/Parser0.ml"
           : (AST.slice list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = e2;
              MenhirLib.EngineTypes.startp = _startpos_e2_;
              MenhirLib.EngineTypes.endp = _endpos_e2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = e1;
                  MenhirLib.EngineTypes.startp = _startpos_e1_;
                  MenhirLib.EngineTypes.endp = _endpos_e1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.slice list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _2 = _2_inlined1 in
            
# 395 "asllib/Parser0.mly"
                                      AST.Slice_Range   
# 83475 "asllib/Parser0.ml"
             (e1, e2)
          in
          (
# 253 "<standard.mly>"
    ( x :: xs )
# 83481 "asllib/Parser0.ml"
           : (AST.slice list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = e2;
              MenhirLib.EngineTypes.startp = _startpos_e2_;
              MenhirLib.EngineTypes.endp = _endpos_e2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = e1;
                  MenhirLib.EngineTypes.startp = _startpos_e1_;
                  MenhirLib.EngineTypes.endp = _endpos_e1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.slice list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _2 = _2_inlined1 in
            
# 396 "asllib/Parser0.mly"
                                      AST.Slice_Length  
# 83538 "asllib/Parser0.ml"
             (e1, e2)
          in
          (
# 253 "<standard.mly>"
    ( x :: xs )
# 83544 "asllib/Parser0.ml"
           : (AST.slice list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = x;
          MenhirLib.EngineTypes.startp = _startpos_x_;
          MenhirLib.EngineTypes.endp = _endpos_x_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let x : (AST.ty) = Obj.magic x in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_x_ in
        let _endpos = _endpos_x_ in
        let _v : (AST.ty list) = 
# 250 "<standard.mly>"
    ( [ x ] )
# 83570 "asllib/Parser0.ml"
         in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = x;
              MenhirLib.EngineTypes.startp = _startpos_x_;
              MenhirLib.EngineTypes.endp = _endpos_x_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let xs : (AST.ty list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let x : (AST.ty) = Obj.magic x in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_x_ in
        let _endpos = _endpos_xs_ in
        let _v : (AST.ty list) = 
# 253 "<standard.mly>"
    ( x :: xs )
# 83609 "asllib/Parser0.ml"
         in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = x;
            MenhirLib.EngineTypes.startp = _startpos_x_;
            MenhirLib.EngineTypes.endp = _endpos_x_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let x : (AST.expr) = Obj.magic x in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__3_ in
        let _v : (AST.expr) = 
# 205 "<standard.mly>"
    ( x )
# 83648 "asllib/Parser0.ml"
         in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : (
# 87 "asllib/Parser0.mly"
       (bool)
# 83669 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v =
          let desc =
            let literal_expression =
              let _1_1 = _1 in
              
# 399 "asllib/Parser0.mly"
                       AST.L_Bool        
# 83681 "asllib/Parser0.ml"
               _1_1
            in
            
# 365 "asllib/Parser0.mly"
                                                        AST.E_Literal    
# 83687 "asllib/Parser0.ml"
             literal_expression
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 83696 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : (
# 85 "asllib/Parser0.mly"
       (Z.t)
# 83718 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v =
          let desc =
            let literal_expression =
              let _1_1 = _1 in
              
# 400 "asllib/Parser0.mly"
                       AST.L_Int         
# 83730 "asllib/Parser0.ml"
               _1_1
            in
            
# 365 "asllib/Parser0.mly"
                                                        AST.E_Literal    
# 83736 "asllib/Parser0.ml"
             literal_expression
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 83745 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : (
# 86 "asllib/Parser0.mly"
       (Q.t)
# 83767 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v =
          let desc =
            let literal_expression =
              let _1_1 = _1 in
              
# 401 "asllib/Parser0.mly"
                       AST.L_Real        
# 83779 "asllib/Parser0.ml"
               _1_1
            in
            
# 365 "asllib/Parser0.mly"
                                                        AST.E_Literal    
# 83785 "asllib/Parser0.ml"
             literal_expression
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 83794 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : (
# 84 "asllib/Parser0.mly"
       (Bitvector.t)
# 83816 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v =
          let desc =
            let literal_expression =
              let _1_1 = _1 in
              
# 402 "asllib/Parser0.mly"
                       AST.L_BitVector   
# 83828 "asllib/Parser0.ml"
               _1_1
            in
            
# 365 "asllib/Parser0.mly"
                                                        AST.E_Literal    
# 83834 "asllib/Parser0.ml"
             literal_expression
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 83843 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 83865 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v =
          let desc =
            let literal_expression =
              let _1_1 = _1 in
              
# 403 "asllib/Parser0.mly"
                       AST.L_String      
# 83877 "asllib/Parser0.ml"
               _1_1
            in
            
# 365 "asllib/Parser0.mly"
                                                        AST.E_Literal    
# 83883 "asllib/Parser0.ml"
             literal_expression
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 83892 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = q;
              MenhirLib.EngineTypes.startp = _startpos_q_;
              MenhirLib.EngineTypes.endp = _endpos_q_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 83926 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 83932 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos__1_ in
        let _v =
          let desc =
            let qualident =
              let i = _1 in
              
# 347 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 83944 "asllib/Parser0.ml"
              
            in
            
# 366 "asllib/Parser0.mly"
                                                        AST.E_Var        
# 83950 "asllib/Parser0.ml"
             qualident
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos_q_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 83959 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 83981 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v =
          let desc =
            let qualident = _1 in
            
# 366 "asllib/Parser0.mly"
                                                        AST.E_Var        
# 83992 "asllib/Parser0.ml"
             qualident
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 84001 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v =
          let desc =
            let qualident = 
# 349 "asllib/Parser0.mly"
              ( "record" )
# 84029 "asllib/Parser0.ml"
             in
            
# 366 "asllib/Parser0.mly"
                                                        AST.E_Var        
# 84034 "asllib/Parser0.ml"
             qualident
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 84043 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = q;
                  MenhirLib.EngineTypes.startp = _startpos_q_;
                  MenhirLib.EngineTypes.endp = _endpos_q_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 84091 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 84097 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos__3_ in
        let _v =
          let desc =
            let params = 
# 352 "asllib/Parser0.mly"
             ( [] )
# 84107 "asllib/Parser0.ml"
             in
            let args =
              let x = 
# 298 "asllib/Parser0.mly"
                ( [] )
# 84113 "asllib/Parser0.ml"
               in
              
# 205 "<standard.mly>"
    ( x )
# 84118 "asllib/Parser0.ml"
              
            in
            let name =
              let i = _1 in
              
# 347 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 84126 "asllib/Parser0.ml"
              
            in
            
# 368 "asllib/Parser0.mly"
        ( AST.E_Call { name; args; params; call_type = ST_Function } )
# 84132 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos_q_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 84141 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined2;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1;
                MenhirLib.EngineTypes.startp = _startpos__1_;
                MenhirLib.EngineTypes.endp = _endpos__1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _2;
                  MenhirLib.EngineTypes.startp = _startpos__2_;
                  MenhirLib.EngineTypes.endp = _endpos__2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = q;
                    MenhirLib.EngineTypes.startp = _startpos_q_;
                    MenhirLib.EngineTypes.endp = _endpos_q_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (AST.expr list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 84196 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 84202 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos__3_ in
        let _v =
          let desc =
            let params = 
# 352 "asllib/Parser0.mly"
             ( [] )
# 84212 "asllib/Parser0.ml"
             in
            let args =
              let _1_inlined1 = _1_inlined2 in
              let x = _1_inlined1 in
              
# 205 "<standard.mly>"
    ( x )
# 84220 "asllib/Parser0.ml"
              
            in
            let name =
              let i = _1 in
              
# 347 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 84228 "asllib/Parser0.ml"
              
            in
            
# 368 "asllib/Parser0.mly"
        ( AST.E_Call { name; args; params; call_type = ST_Function } )
# 84234 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos_q_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 84243 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 84279 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__3_ in
        let _v =
          let desc =
            let params = 
# 352 "asllib/Parser0.mly"
             ( [] )
# 84289 "asllib/Parser0.ml"
             in
            let args =
              let x = 
# 298 "asllib/Parser0.mly"
                ( [] )
# 84295 "asllib/Parser0.ml"
               in
              
# 205 "<standard.mly>"
    ( x )
# 84300 "asllib/Parser0.ml"
              
            in
            let name = _1 in
            
# 368 "asllib/Parser0.mly"
        ( AST.E_Call { name; args; params; call_type = ST_Function } )
# 84307 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 84316 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined2;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = _1;
                MenhirLib.EngineTypes.startp = _startpos__1_;
                MenhirLib.EngineTypes.endp = _endpos__1_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (AST.expr list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 84359 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__3_ in
        let _v =
          let desc =
            let params = 
# 352 "asllib/Parser0.mly"
             ( [] )
# 84369 "asllib/Parser0.ml"
             in
            let args =
              let _1_inlined1 = _1_inlined2 in
              let x = _1_inlined1 in
              
# 205 "<standard.mly>"
    ( x )
# 84377 "asllib/Parser0.ml"
              
            in
            let name = _1 in
            
# 368 "asllib/Parser0.mly"
        ( AST.E_Call { name; args; params; call_type = ST_Function } )
# 84384 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 84393 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__3_ in
        let _v =
          let desc =
            let params = 
# 352 "asllib/Parser0.mly"
             ( [] )
# 84435 "asllib/Parser0.ml"
             in
            let args =
              let x = 
# 298 "asllib/Parser0.mly"
                ( [] )
# 84441 "asllib/Parser0.ml"
               in
              
# 205 "<standard.mly>"
    ( x )
# 84446 "asllib/Parser0.ml"
              
            in
            let name = 
# 349 "asllib/Parser0.mly"
              ( "record" )
# 84452 "asllib/Parser0.ml"
             in
            
# 368 "asllib/Parser0.mly"
        ( AST.E_Call { name; args; params; call_type = ST_Function } )
# 84457 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 84466 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined2;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = _1;
                MenhirLib.EngineTypes.startp = _startpos__1_;
                MenhirLib.EngineTypes.endp = _endpos__1_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (AST.expr list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__3_ in
        let _v =
          let desc =
            let params = 
# 352 "asllib/Parser0.mly"
             ( [] )
# 84515 "asllib/Parser0.ml"
             in
            let args =
              let _1_inlined1 = _1_inlined2 in
              let x = _1_inlined1 in
              
# 205 "<standard.mly>"
    ( x )
# 84523 "asllib/Parser0.ml"
              
            in
            let name = 
# 349 "asllib/Parser0.mly"
              ( "record" )
# 84529 "asllib/Parser0.ml"
             in
            
# 368 "asllib/Parser0.mly"
        ( AST.E_Call { name; args; params; call_type = ST_Function } )
# 84534 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 84543 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e;
          MenhirLib.EngineTypes.startp = _startpos_e_;
          MenhirLib.EngineTypes.endp = _endpos_e_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let e : (AST.expr) = Obj.magic e in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_e_ in
        let _v =
          let desc =
            let unop = 
# 774 "asllib/Parser0.mly"
            ( AST.BNOT )
# 84578 "asllib/Parser0.ml"
             in
            
# 369 "asllib/Parser0.mly"
                                                        AST.E_Unop       
# 84583 "asllib/Parser0.ml"
             (unop, e)
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 84592 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e;
          MenhirLib.EngineTypes.startp = _startpos_e_;
          MenhirLib.EngineTypes.endp = _endpos_e_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let e : (AST.expr) = Obj.magic e in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_e_ in
        let _v =
          let desc =
            let unop = 
# 775 "asllib/Parser0.mly"
            ( AST.NEG )
# 84627 "asllib/Parser0.ml"
             in
            
# 369 "asllib/Parser0.mly"
                                                        AST.E_Unop       
# 84632 "asllib/Parser0.ml"
             (unop, e)
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 84641 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e;
          MenhirLib.EngineTypes.startp = _startpos_e_;
          MenhirLib.EngineTypes.endp = _endpos_e_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let e : (AST.expr) = Obj.magic e in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_e_ in
        let _v =
          let desc =
            let unop = 
# 776 "asllib/Parser0.mly"
            ( AST.NOT )
# 84676 "asllib/Parser0.ml"
             in
            
# 369 "asllib/Parser0.mly"
                                                        AST.E_Unop       
# 84681 "asllib/Parser0.ml"
             (unop, e)
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 84690 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 781 "asllib/Parser0.mly"
                 ( AST.AND    )
# 84732 "asllib/Parser0.ml"
             in
            
# 370 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 84737 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 84746 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 782 "asllib/Parser0.mly"
                 ( AST.BAND   )
# 84788 "asllib/Parser0.ml"
             in
            
# 370 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 84793 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 84802 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 783 "asllib/Parser0.mly"
                 ( AST.BOR    )
# 84844 "asllib/Parser0.ml"
             in
            
# 370 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 84849 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 84858 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 784 "asllib/Parser0.mly"
                 ( AST.DIV    )
# 84900 "asllib/Parser0.ml"
             in
            
# 370 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 84905 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 84914 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 785 "asllib/Parser0.mly"
                 ( AST.EOR    )
# 84956 "asllib/Parser0.ml"
             in
            
# 370 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 84961 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 84970 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 786 "asllib/Parser0.mly"
                 ( AST.EQ_OP  )
# 85012 "asllib/Parser0.ml"
             in
            
# 370 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 85017 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 85026 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 787 "asllib/Parser0.mly"
                 ( AST.NEQ    )
# 85068 "asllib/Parser0.ml"
             in
            
# 370 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 85073 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 85082 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 788 "asllib/Parser0.mly"
                 ( AST.GEQ    )
# 85124 "asllib/Parser0.ml"
             in
            
# 370 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 85129 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 85138 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 789 "asllib/Parser0.mly"
                 ( AST.IMPL   )
# 85180 "asllib/Parser0.ml"
             in
            
# 370 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 85185 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 85194 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 790 "asllib/Parser0.mly"
                 ( AST.LEQ    )
# 85236 "asllib/Parser0.ml"
             in
            
# 370 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 85241 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 85250 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 791 "asllib/Parser0.mly"
                 ( AST.PLUS   )
# 85292 "asllib/Parser0.ml"
             in
            
# 370 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 85297 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 85306 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 792 "asllib/Parser0.mly"
                 ( AST.MINUS  )
# 85348 "asllib/Parser0.ml"
             in
            
# 370 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 85353 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 85362 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 793 "asllib/Parser0.mly"
                 ( AST.MOD    )
# 85404 "asllib/Parser0.ml"
             in
            
# 370 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 85409 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 85418 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 794 "asllib/Parser0.mly"
                 ( AST.MUL    )
# 85460 "asllib/Parser0.ml"
             in
            
# 370 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 85465 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 85474 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 795 "asllib/Parser0.mly"
                 ( AST.OR     )
# 85516 "asllib/Parser0.ml"
             in
            
# 370 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 85521 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 85530 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 796 "asllib/Parser0.mly"
                 ( AST.RDIV   )
# 85572 "asllib/Parser0.ml"
             in
            
# 370 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 85577 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 85586 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 797 "asllib/Parser0.mly"
                 ( AST.SHL    )
# 85628 "asllib/Parser0.ml"
             in
            
# 370 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 85633 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 85642 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 798 "asllib/Parser0.mly"
                 ( AST.SHR    )
# 85684 "asllib/Parser0.ml"
             in
            
# 370 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 85689 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 85698 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 778 "asllib/Parser0.mly"
                                  ( AST.PLUS )
# 85740 "asllib/Parser0.ml"
             in
            
# 370 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 85745 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 85754 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2;
              MenhirLib.EngineTypes.startp = _startpos__2_;
              MenhirLib.EngineTypes.endp = _endpos__2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = h;
                MenhirLib.EngineTypes.startp = _startpos_h_;
                MenhirLib.EngineTypes.endp = _endpos_h_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (AST.expr list) = Obj.magic _1_inlined1 in
        let _2 : unit = Obj.magic _2 in
        let h : (AST.expr) = Obj.magic h in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__3_ in
        let _v =
          let desc =
            let _1 =
              let x =
                let _1 = _1_inlined1 in
                let t = _1 in
                
# 301 "asllib/Parser0.mly"
                                           ( h::t )
# 85814 "asllib/Parser0.ml"
                
              in
              
# 205 "<standard.mly>"
    ( x )
# 85820 "asllib/Parser0.ml"
              
            in
            let _1_1 = _1 in
            
# 371 "asllib/Parser0.mly"
                                                        AST.E_Tuple      
# 85827 "asllib/Parser0.ml"
             _1_1
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 85836 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = expr;
          MenhirLib.EngineTypes.startp = _startpos_expr_;
          MenhirLib.EngineTypes.endp = _endpos_expr_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = e;
                MenhirLib.EngineTypes.startp = _startpos_e_;
                MenhirLib.EngineTypes.endp = _endpos_e_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = c;
                    MenhirLib.EngineTypes.startp = _startpos_c_;
                    MenhirLib.EngineTypes.endp = _endpos_c_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let expr : (AST.expr) = Obj.magic expr in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : ((AST.expr * AST.expr) AST.annotated list) = Obj.magic _1_inlined1 in
        let e : (AST.expr) = Obj.magic e in
        let _3 : unit = Obj.magic _3 in
        let c : (AST.expr) = Obj.magic c in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_expr_ in
        let _v =
          let desc =
            let e_else =
              let _1 = _1_inlined1 in
              let _1_1 = _1 in
              
# 391 "asllib/Parser0.mly"
                                                build_expr_conds  
# 85909 "asllib/Parser0.ml"
               (_1_1, expr)
            in
            
# 372 "asllib/Parser0.mly"
                                                        AST.E_Cond       
# 85915 "asllib/Parser0.ml"
             (c, e, e_else)
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_expr_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 85924 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e;
              MenhirLib.EngineTypes.startp = _startpos_e_;
              MenhirLib.EngineTypes.endp = _endpos_e_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 85958 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let e : (AST.expr) = Obj.magic e in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e_ in
        let _endpos = _endpos__1_ in
        let _v =
          let desc =
            let ident = _1 in
            
# 373 "asllib/Parser0.mly"
                                                        AST.E_GetField   
# 85971 "asllib/Parser0.ml"
             (e, ident)
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos_e_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 85980 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2;
              MenhirLib.EngineTypes.startp = _startpos__2_;
              MenhirLib.EngineTypes.endp = _endpos__2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = e;
                MenhirLib.EngineTypes.startp = _startpos_e_;
                MenhirLib.EngineTypes.endp = _endpos_e_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let _1 : unit = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let e : (AST.expr) = Obj.magic e in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e_ in
        let _endpos = _endpos__3_ in
        let _v =
          let desc =
            let _3 =
              let x = 
# 298 "asllib/Parser0.mly"
                ( [] )
# 86030 "asllib/Parser0.ml"
               in
              
# 205 "<standard.mly>"
    ( x )
# 86035 "asllib/Parser0.ml"
              
            in
            let _3_1 = _3 in
            
# 374 "asllib/Parser0.mly"
                                                        AST.E_GetFields  
# 86042 "asllib/Parser0.ml"
             (e, _3_1)
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos_e_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 86051 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = e;
                  MenhirLib.EngineTypes.startp = _startpos_e_;
                  MenhirLib.EngineTypes.endp = _endpos_e_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (string list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let e : (AST.expr) = Obj.magic e in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e_ in
        let _endpos = _endpos__3_ in
        let _v =
          let desc =
            let _3 =
              let x = _1_inlined1 in
              
# 205 "<standard.mly>"
    ( x )
# 86109 "asllib/Parser0.ml"
              
            in
            let _3_1 = _3 in
            
# 374 "asllib/Parser0.mly"
                                                        AST.E_GetFields  
# 86116 "asllib/Parser0.ml"
             (e, _3_1)
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos_e_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 86125 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e;
              MenhirLib.EngineTypes.startp = _startpos_e_;
              MenhirLib.EngineTypes.endp = _endpos_e_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let _1 : unit = Obj.magic _1 in
        let e : (AST.expr) = Obj.magic e in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e_ in
        let _endpos = _endpos__3_ in
        let _v =
          let desc =
            let _2 =
              let x = 
# 298 "asllib/Parser0.mly"
                ( [] )
# 86168 "asllib/Parser0.ml"
               in
              
# 205 "<standard.mly>"
    ( x )
# 86173 "asllib/Parser0.ml"
              
            in
            let _2_1 = _2 in
            
# 375 "asllib/Parser0.mly"
                                                        AST.E_Slice      
# 86180 "asllib/Parser0.ml"
             (e, _2_1)
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos_e_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 86189 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = e;
                MenhirLib.EngineTypes.startp = _startpos_e_;
                MenhirLib.EngineTypes.endp = _endpos_e_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (AST.slice list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let e : (AST.expr) = Obj.magic e in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e_ in
        let _endpos = _endpos__3_ in
        let _v =
          let desc =
            let _2 =
              let x = _1_inlined1 in
              
# 205 "<standard.mly>"
    ( x )
# 86240 "asllib/Parser0.ml"
              
            in
            let _2_1 = _2 in
            
# 375 "asllib/Parser0.mly"
                                                        AST.E_Slice      
# 86247 "asllib/Parser0.ml"
             (e, _2_1)
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos_e_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 86256 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__3_ in
        let _v =
          let desc =
            let _1 =
              let x = 
# 298 "asllib/Parser0.mly"
                ( [] )
# 86292 "asllib/Parser0.ml"
               in
              
# 205 "<standard.mly>"
    ( x )
# 86297 "asllib/Parser0.ml"
              
            in
            let _1_1 = _1 in
            
# 376 "asllib/Parser0.mly"
                                                        make_concat      
# 86304 "asllib/Parser0.ml"
             _1_1
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 86313 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (AST.expr list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__3_ in
        let _v =
          let desc =
            let _1 =
              let x = _1_inlined1 in
              
# 205 "<standard.mly>"
    ( x )
# 86357 "asllib/Parser0.ml"
              
            in
            let _1_1 = _1 in
            
# 376 "asllib/Parser0.mly"
                                                        make_concat      
# 86364 "asllib/Parser0.ml"
             _1_1
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 86373 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = e;
                  MenhirLib.EngineTypes.startp = _startpos_e_;
                  MenhirLib.EngineTypes.endp = _endpos_e_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (AST.pattern list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let e : (AST.expr) = Obj.magic e in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e_ in
        let _endpos = _endpos__3_ in
        let _v =
          let desc =
            let bpattern =
              let desc =
                let x =
                  let _1 = _1_inlined1 in
                  let _1_1 = _1 in
                  
# 749 "asllib/Parser0.mly"
                                                       AST.Pattern_Any  
# 86434 "asllib/Parser0.ml"
                   _1_1
                in
                
# 205 "<standard.mly>"
    ( x )
# 86440 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 86449 "asllib/Parser0.ml"
              
            in
            
# 377 "asllib/Parser0.mly"
                                                        AST.E_Pattern    
# 86455 "asllib/Parser0.ml"
             (e, bpattern)
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos_e_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 86464 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e;
              MenhirLib.EngineTypes.startp = _startpos_e_;
              MenhirLib.EngineTypes.endp = _endpos_e_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _1 : (
# 83 "asllib/Parser0.mly"
       (Bitvector.mask)
# 86498 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let e : (AST.expr) = Obj.magic e in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e_ in
        let _endpos = _endpos__1_ in
        let _v =
          let desc =
            let pattern_mask =
              let desc =
                let _1_1 = _1 in
                
# 736 "asllib/Parser0.mly"
                                           AST.Pattern_Mask 
# 86513 "asllib/Parser0.ml"
                 _1_1
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 86522 "asllib/Parser0.ml"
              
            in
            
# 378 "asllib/Parser0.mly"
                                                        AST.E_Pattern    
# 86528 "asllib/Parser0.ml"
             (e, pattern_mask)
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos_e_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 86537 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _1_inlined1;
          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e;
              MenhirLib.EngineTypes.startp = _startpos_e_;
              MenhirLib.EngineTypes.endp = _endpos_e_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _1_inlined1 : (
# 83 "asllib/Parser0.mly"
       (Bitvector.mask)
# 86571 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let e : (AST.expr) = Obj.magic e in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e_ in
        let _endpos = _endpos__1_inlined1_ in
        let _v =
          let desc =
            let _2 =
              let desc =
                let pm =
                  let (_endpos__1_, _startpos__1_, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined1) in
                  let desc =
                    let _1_1 = _1 in
                    
# 736 "asllib/Parser0.mly"
                                           AST.Pattern_Mask 
# 86589 "asllib/Parser0.ml"
                     _1_1
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 86598 "asllib/Parser0.ml"
                  
                in
                
# 379 "asllib/Parser0.mly"
                                                     AST.Pattern_Not  
# 86604 "asllib/Parser0.ml"
                 pm
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined1_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 86613 "asllib/Parser0.ml"
              
            in
            let _2_1 = _2 in
            
# 379 "asllib/Parser0.mly"
                                                                           AST.E_Pattern  
# 86620 "asllib/Parser0.ml"
             (e, _2_1)
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined1_, _startpos_e_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 86629 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let desc = 
# 319 "asllib/Parser0.mly"
                          ( AST.(T_Int UnConstrained) )
# 86665 "asllib/Parser0.ml"
               in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 86673 "asllib/Parser0.ml"
              
            in
            let _1_1 = _1 in
            
# 380 "asllib/Parser0.mly"
                                                        AST.E_Unknown    
# 86680 "asllib/Parser0.ml"
             _1_1
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 86689 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let desc = 
# 320 "asllib/Parser0.mly"
                          ( AST.T_Real                )
# 86725 "asllib/Parser0.ml"
               in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 86733 "asllib/Parser0.ml"
              
            in
            let _1_1 = _1 in
            
# 380 "asllib/Parser0.mly"
                                                        AST.E_Unknown    
# 86740 "asllib/Parser0.ml"
             _1_1
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 86749 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let desc = 
# 321 "asllib/Parser0.mly"
                          ( AST.T_Bool                )
# 86785 "asllib/Parser0.ml"
               in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 86793 "asllib/Parser0.ml"
              
            in
            let _1_1 = _1 in
            
# 380 "asllib/Parser0.mly"
                                                        AST.E_Unknown    
# 86800 "asllib/Parser0.ml"
             _1_1
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 86809 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 86838 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let desc =
                let tident = _1 in
                
# 322 "asllib/Parser0.mly"
                            AST.T_Named                
# 86851 "asllib/Parser0.ml"
                 tident
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 86860 "asllib/Parser0.ml"
              
            in
            let _1_1 = _1 in
            
# 380 "asllib/Parser0.mly"
                                                        AST.E_Unknown    
# 86867 "asllib/Parser0.ml"
             _1_1
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 86876 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = q;
                MenhirLib.EngineTypes.startp = _startpos_q_;
                MenhirLib.EngineTypes.endp = _endpos_q_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 86917 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 86923 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let _2 = _2_inlined1 in
              let desc =
                let tident =
                  let i = _1 in
                  
# 339 "asllib/Parser0.mly"
                                   ( q ^ "_" ^ i )
# 86938 "asllib/Parser0.ml"
                  
                in
                
# 322 "asllib/Parser0.mly"
                            AST.T_Named                
# 86944 "asllib/Parser0.ml"
                 tident
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos_q_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 86953 "asllib/Parser0.ml"
              
            in
            let _1_1 = _1 in
            
# 380 "asllib/Parser0.mly"
                                                        AST.E_Unknown    
# 86960 "asllib/Parser0.ml"
             _1_1
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos_q_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 86969 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let desc = 
# 323 "asllib/Parser0.mly"
                          ( t_bit                     )
# 87005 "asllib/Parser0.ml"
               in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 87013 "asllib/Parser0.ml"
              
            in
            let _1_1 = _1 in
            
# 380 "asllib/Parser0.mly"
                                                        AST.E_Unknown    
# 87020 "asllib/Parser0.ml"
             _1_1
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 87029 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _3;
            MenhirLib.EngineTypes.startp = _startpos__3_;
            MenhirLib.EngineTypes.endp = _endpos__3_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = x;
              MenhirLib.EngineTypes.startp = _startpos_x_;
              MenhirLib.EngineTypes.endp = _endpos_x_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _3 : unit = Obj.magic _3 in
        let x : (AST.expr) = Obj.magic x in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let desc =
                let e = 
# 205 "<standard.mly>"
    ( x )
# 87087 "asllib/Parser0.ml"
                 in
                
# 324 "asllib/Parser0.mly"
                          ( AST.(T_Bits (e, []))      )
# 87092 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 87101 "asllib/Parser0.ml"
              
            in
            let _1_1 = _1 in
            
# 380 "asllib/Parser0.mly"
                                                        AST.E_Unknown    
# 87108 "asllib/Parser0.ml"
             _1_1
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 87117 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _3_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = x;
                    MenhirLib.EngineTypes.startp = _startpos_x_;
                    MenhirLib.EngineTypes.endp = _endpos_x_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined3 : (AST.bitfield list) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let x : (AST.expr) = Obj.magic x in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let desc =
                let b =
                  let _1_inlined1 = _1_inlined3 in
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 87199 "asllib/Parser0.ml"
                  
                in
                let e = 
# 205 "<standard.mly>"
    ( x )
# 87205 "asllib/Parser0.ml"
                 in
                
# 325 "asllib/Parser0.mly"
                                      ( AST.(T_Bits (e, b)) )
# 87210 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__3_inlined1_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 87219 "asllib/Parser0.ml"
              
            in
            let _1_1 = _1 in
            
# 380 "asllib/Parser0.mly"
                                                        AST.E_Unknown    
# 87226 "asllib/Parser0.ml"
             _1_1
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 87235 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _3;
            MenhirLib.EngineTypes.startp = _startpos__3_;
            MenhirLib.EngineTypes.endp = _endpos__3_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = x;
              MenhirLib.EngineTypes.startp = _startpos_x_;
              MenhirLib.EngineTypes.endp = _endpos_x_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _3 : unit = Obj.magic _3 in
        let x : (AST.expr) = Obj.magic x in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let desc =
                let _1 =
                  let _2 = 
# 205 "<standard.mly>"
    ( x )
# 87294 "asllib/Parser0.ml"
                   in
                  ()
                in
                
# 265 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 87301 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 87310 "asllib/Parser0.ml"
              
            in
            let _1_1 = _1 in
            
# 380 "asllib/Parser0.mly"
                                                        AST.E_Unknown    
# 87317 "asllib/Parser0.ml"
             _1_1
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 87326 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (
# 82 "asllib/Parser0.mly"
       (string)
# 87388 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let desc =
                let _1 =
                  let _2 =
                    let _1_inlined1 = _1_inlined2 in
                    let x =
                      let _1 = _1_inlined1 in
                      ()
                    in
                    
# 205 "<standard.mly>"
    ( x )
# 87409 "asllib/Parser0.ml"
                    
                  in
                  ()
                in
                
# 265 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 87417 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 87426 "asllib/Parser0.ml"
              
            in
            let _1_1 = _1 in
            
# 380 "asllib/Parser0.mly"
                                                        AST.E_Unknown    
# 87433 "asllib/Parser0.ml"
             _1_1
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 87442 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _2_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = q;
                      MenhirLib.EngineTypes.startp = _startpos_q_;
                      MenhirLib.EngineTypes.endp = _endpos_q_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (
# 82 "asllib/Parser0.mly"
       (string)
# 87516 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 87522 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let _2 = _2_inlined1 in
              let desc =
                let _1 =
                  let _2 =
                    let _1_inlined1 = _1_inlined2 in
                    let x =
                      let _1 = _1_inlined1 in
                      let _1 =
                        let i = _1 in
                        
# 339 "asllib/Parser0.mly"
                                   ( q ^ "_" ^ i )
# 87544 "asllib/Parser0.ml"
                        
                      in
                      ()
                    in
                    
# 205 "<standard.mly>"
    ( x )
# 87552 "asllib/Parser0.ml"
                    
                  in
                  ()
                in
                
# 265 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 87560 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 87569 "asllib/Parser0.ml"
              
            in
            let _1_1 = _1 in
            
# 380 "asllib/Parser0.mly"
                                                        AST.E_Unknown    
# 87576 "asllib/Parser0.ml"
             _1_1
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 87585 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _2_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _3_inlined1 : (AST.expr) = Obj.magic _3_inlined1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined2 : (AST.expr) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let _2 = _2_inlined1 in
              let desc =
                let _1 =
                  let _2 =
                    let _1_inlined1 = _1_inlined2 in
                    let x =
                      let (_3, _1) = (_3_inlined1, _1_inlined1) in
                      ()
                    in
                    
# 205 "<standard.mly>"
    ( x )
# 87679 "asllib/Parser0.ml"
                    
                  in
                  ()
                in
                
# 265 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 87687 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 87696 "asllib/Parser0.ml"
              
            in
            let _1_1 = _1 in
            
# 380 "asllib/Parser0.mly"
                                                        AST.E_Unknown    
# 87703 "asllib/Parser0.ml"
             _1_1
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 87712 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 123 "<standard.mly>"
    ( None )
# 87748 "asllib/Parser0.ml"
               in
              let _1 = 
# 319 "asllib/Parser0.mly"
                          ( AST.(T_Int UnConstrained) )
# 87753 "asllib/Parser0.ml"
               in
              ()
            in
            
# 351 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 87760 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 87769 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = x;
          MenhirLib.EngineTypes.startp = _startpos_x_;
          MenhirLib.EngineTypes.endp = _endpos_x_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let x : (
# 82 "asllib/Parser0.mly"
       (string)
# 87803 "asllib/Parser0.ml"
        ) = Obj.magic x in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_x_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 126 "<standard.mly>"
    ( Some x )
# 87816 "asllib/Parser0.ml"
               in
              let _1 = 
# 319 "asllib/Parser0.mly"
                          ( AST.(T_Int UnConstrained) )
# 87821 "asllib/Parser0.ml"
               in
              ()
            in
            
# 351 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 87828 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_x_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 87837 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 123 "<standard.mly>"
    ( None )
# 87873 "asllib/Parser0.ml"
               in
              let _1 = 
# 320 "asllib/Parser0.mly"
                          ( AST.T_Real                )
# 87878 "asllib/Parser0.ml"
               in
              ()
            in
            
# 351 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 87885 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 87894 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = x;
          MenhirLib.EngineTypes.startp = _startpos_x_;
          MenhirLib.EngineTypes.endp = _endpos_x_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let x : (
# 82 "asllib/Parser0.mly"
       (string)
# 87928 "asllib/Parser0.ml"
        ) = Obj.magic x in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_x_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 126 "<standard.mly>"
    ( Some x )
# 87941 "asllib/Parser0.ml"
               in
              let _1 = 
# 320 "asllib/Parser0.mly"
                          ( AST.T_Real                )
# 87946 "asllib/Parser0.ml"
               in
              ()
            in
            
# 351 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 87953 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_x_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 87962 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 123 "<standard.mly>"
    ( None )
# 87998 "asllib/Parser0.ml"
               in
              let _1 = 
# 321 "asllib/Parser0.mly"
                          ( AST.T_Bool                )
# 88003 "asllib/Parser0.ml"
               in
              ()
            in
            
# 351 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 88010 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 88019 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = x;
          MenhirLib.EngineTypes.startp = _startpos_x_;
          MenhirLib.EngineTypes.endp = _endpos_x_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let x : (
# 82 "asllib/Parser0.mly"
       (string)
# 88053 "asllib/Parser0.ml"
        ) = Obj.magic x in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_x_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 126 "<standard.mly>"
    ( Some x )
# 88066 "asllib/Parser0.ml"
               in
              let _1 = 
# 321 "asllib/Parser0.mly"
                          ( AST.T_Bool                )
# 88071 "asllib/Parser0.ml"
               in
              ()
            in
            
# 351 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 88078 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_x_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 88087 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 88116 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 123 "<standard.mly>"
    ( None )
# 88127 "asllib/Parser0.ml"
               in
              let _1 =
                let tident = _1 in
                
# 322 "asllib/Parser0.mly"
                            AST.T_Named                
# 88134 "asllib/Parser0.ml"
                 tident
              in
              ()
            in
            
# 351 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 88142 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 88151 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = x;
          MenhirLib.EngineTypes.startp = _startpos_x_;
          MenhirLib.EngineTypes.endp = _endpos_x_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let x : (
# 82 "asllib/Parser0.mly"
       (string)
# 88185 "asllib/Parser0.ml"
        ) = Obj.magic x in
        let _2 : unit = Obj.magic _2 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 88191 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_x_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 126 "<standard.mly>"
    ( Some x )
# 88202 "asllib/Parser0.ml"
               in
              let _1 =
                let tident = _1 in
                
# 322 "asllib/Parser0.mly"
                            AST.T_Named                
# 88209 "asllib/Parser0.ml"
                 tident
              in
              ()
            in
            
# 351 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 88217 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_x_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 88226 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = q;
                MenhirLib.EngineTypes.startp = _startpos_q_;
                MenhirLib.EngineTypes.endp = _endpos_q_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 88267 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 88273 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 123 "<standard.mly>"
    ( None )
# 88284 "asllib/Parser0.ml"
               in
              let _1 =
                let _2 = _2_inlined1 in
                let tident =
                  let i = _1 in
                  
# 339 "asllib/Parser0.mly"
                                   ( q ^ "_" ^ i )
# 88293 "asllib/Parser0.ml"
                  
                in
                
# 322 "asllib/Parser0.mly"
                            AST.T_Named                
# 88299 "asllib/Parser0.ml"
                 tident
              in
              ()
            in
            
# 351 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 88307 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos_q_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 88316 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = x;
          MenhirLib.EngineTypes.startp = _startpos_x_;
          MenhirLib.EngineTypes.endp = _endpos_x_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = q;
                  MenhirLib.EngineTypes.startp = _startpos_q_;
                  MenhirLib.EngineTypes.endp = _endpos_q_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let x : (
# 82 "asllib/Parser0.mly"
       (string)
# 88362 "asllib/Parser0.ml"
        ) = Obj.magic x in
        let _2 : unit = Obj.magic _2 in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 88368 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 88374 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos_x_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 126 "<standard.mly>"
    ( Some x )
# 88385 "asllib/Parser0.ml"
               in
              let _1 =
                let _2 = _2_inlined1 in
                let tident =
                  let i = _1 in
                  
# 339 "asllib/Parser0.mly"
                                   ( q ^ "_" ^ i )
# 88394 "asllib/Parser0.ml"
                  
                in
                
# 322 "asllib/Parser0.mly"
                            AST.T_Named                
# 88400 "asllib/Parser0.ml"
                 tident
              in
              ()
            in
            
# 351 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 88408 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_x_, _startpos_q_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 88417 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 123 "<standard.mly>"
    ( None )
# 88453 "asllib/Parser0.ml"
               in
              let _1 = 
# 323 "asllib/Parser0.mly"
                          ( t_bit                     )
# 88458 "asllib/Parser0.ml"
               in
              ()
            in
            
# 351 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 88465 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 88474 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = x;
          MenhirLib.EngineTypes.startp = _startpos_x_;
          MenhirLib.EngineTypes.endp = _endpos_x_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let x : (
# 82 "asllib/Parser0.mly"
       (string)
# 88508 "asllib/Parser0.ml"
        ) = Obj.magic x in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_x_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 126 "<standard.mly>"
    ( Some x )
# 88521 "asllib/Parser0.ml"
               in
              let _1 = 
# 323 "asllib/Parser0.mly"
                          ( t_bit                     )
# 88526 "asllib/Parser0.ml"
               in
              ()
            in
            
# 351 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 88533 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_x_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 88542 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _3_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = x;
              MenhirLib.EngineTypes.startp = _startpos_x_;
              MenhirLib.EngineTypes.endp = _endpos_x_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let x : (AST.expr) = Obj.magic x in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 123 "<standard.mly>"
    ( None )
# 88599 "asllib/Parser0.ml"
               in
              let _1 =
                let e = 
# 205 "<standard.mly>"
    ( x )
# 88605 "asllib/Parser0.ml"
                 in
                
# 324 "asllib/Parser0.mly"
                          ( AST.(T_Bits (e, []))      )
# 88610 "asllib/Parser0.ml"
                
              in
              ()
            in
            
# 351 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 88618 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 88627 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = x_inlined1;
          MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
          MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = x;
                MenhirLib.EngineTypes.startp = _startpos_x_;
                MenhirLib.EngineTypes.endp = _endpos_x_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let x_inlined1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 88679 "asllib/Parser0.ml"
        ) = Obj.magic x_inlined1 in
        let _2 : unit = Obj.magic _2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let x : (AST.expr) = Obj.magic x in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_x_inlined1_ in
        let _v =
          let desc =
            let _1 =
              let _3 =
                let x = x_inlined1 in
                
# 126 "<standard.mly>"
    ( Some x )
# 88697 "asllib/Parser0.ml"
                
              in
              let _1 =
                let e = 
# 205 "<standard.mly>"
    ( x )
# 88704 "asllib/Parser0.ml"
                 in
                
# 324 "asllib/Parser0.mly"
                          ( AST.(T_Bits (e, []))      )
# 88709 "asllib/Parser0.ml"
                
              in
              ()
            in
            
# 351 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 88717 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_x_inlined1_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 88726 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _3_inlined2;
            MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
            MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = x;
                    MenhirLib.EngineTypes.startp = _startpos_x_;
                    MenhirLib.EngineTypes.endp = _endpos_x_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _1_inlined3 : (AST.bitfield list) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let x : (AST.expr) = Obj.magic x in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 123 "<standard.mly>"
    ( None )
# 88804 "asllib/Parser0.ml"
               in
              let _1 =
                let b =
                  let _1_inlined1 = _1_inlined3 in
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 88813 "asllib/Parser0.ml"
                  
                in
                let e = 
# 205 "<standard.mly>"
    ( x )
# 88819 "asllib/Parser0.ml"
                 in
                
# 325 "asllib/Parser0.mly"
                                      ( AST.(T_Bits (e, b)) )
# 88824 "asllib/Parser0.ml"
                
              in
              ()
            in
            
# 351 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 88832 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 88841 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = x_inlined1;
          MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
          MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = x;
                      MenhirLib.EngineTypes.startp = _startpos_x_;
                      MenhirLib.EngineTypes.endp = _endpos_x_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let x_inlined1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 88911 "asllib/Parser0.ml"
        ) = Obj.magic x_inlined1 in
        let _2 : unit = Obj.magic _2 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _1_inlined3 : (AST.bitfield list) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let x : (AST.expr) = Obj.magic x in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_x_inlined1_ in
        let _v =
          let desc =
            let _1 =
              let _3 =
                let x = x_inlined1 in
                
# 126 "<standard.mly>"
    ( Some x )
# 88932 "asllib/Parser0.ml"
                
              in
              let _1 =
                let b =
                  let _1_inlined1 = _1_inlined3 in
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 88942 "asllib/Parser0.ml"
                  
                in
                let e = 
# 205 "<standard.mly>"
    ( x )
# 88948 "asllib/Parser0.ml"
                 in
                
# 325 "asllib/Parser0.mly"
                                      ( AST.(T_Bits (e, b)) )
# 88953 "asllib/Parser0.ml"
                
              in
              ()
            in
            
# 351 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 88961 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_x_inlined1_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 88970 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _3_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = x;
              MenhirLib.EngineTypes.startp = _startpos_x_;
              MenhirLib.EngineTypes.endp = _endpos_x_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let x : (AST.expr) = Obj.magic x in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 123 "<standard.mly>"
    ( None )
# 89027 "asllib/Parser0.ml"
               in
              let _1 =
                let _1 =
                  let _2 = 
# 205 "<standard.mly>"
    ( x )
# 89034 "asllib/Parser0.ml"
                   in
                  ()
                in
                
# 265 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 89041 "asllib/Parser0.ml"
                
              in
              ()
            in
            
# 351 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 89049 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 89058 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = x_inlined1;
          MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
          MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = x;
                MenhirLib.EngineTypes.startp = _startpos_x_;
                MenhirLib.EngineTypes.endp = _endpos_x_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let x_inlined1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 89110 "asllib/Parser0.ml"
        ) = Obj.magic x_inlined1 in
        let _2 : unit = Obj.magic _2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let x : (AST.expr) = Obj.magic x in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_x_inlined1_ in
        let _v =
          let desc =
            let _1 =
              let _3 =
                let x = x_inlined1 in
                
# 126 "<standard.mly>"
    ( Some x )
# 89128 "asllib/Parser0.ml"
                
              in
              let _1 =
                let _1 =
                  let _2 = 
# 205 "<standard.mly>"
    ( x )
# 89136 "asllib/Parser0.ml"
                   in
                  ()
                in
                
# 265 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 89143 "asllib/Parser0.ml"
                
              in
              ()
            in
            
# 351 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 89151 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_x_inlined1_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 89160 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (
# 82 "asllib/Parser0.mly"
       (string)
# 89222 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 123 "<standard.mly>"
    ( None )
# 89235 "asllib/Parser0.ml"
               in
              let _1 =
                let _3 = _3_inlined2 in
                let _1 =
                  let _2 =
                    let _1_inlined1 = _1_inlined2 in
                    let x =
                      let _1 = _1_inlined1 in
                      ()
                    in
                    
# 205 "<standard.mly>"
    ( x )
# 89249 "asllib/Parser0.ml"
                    
                  in
                  ()
                in
                
# 265 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 89257 "asllib/Parser0.ml"
                
              in
              ()
            in
            
# 351 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 89265 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 89274 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = x;
          MenhirLib.EngineTypes.startp = _startpos_x_;
          MenhirLib.EngineTypes.endp = _endpos_x_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _4;
              MenhirLib.EngineTypes.startp = _startpos__4_;
              MenhirLib.EngineTypes.endp = _endpos__4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let x : (
# 82 "asllib/Parser0.mly"
       (string)
# 89338 "asllib/Parser0.ml"
        ) = Obj.magic x in
        let _2 : unit = Obj.magic _2 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (
# 82 "asllib/Parser0.mly"
       (string)
# 89347 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_x_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 126 "<standard.mly>"
    ( Some x )
# 89360 "asllib/Parser0.ml"
               in
              let _1 =
                let _3 = _3_inlined2 in
                let _1 =
                  let _2 =
                    let _1_inlined1 = _1_inlined2 in
                    let x =
                      let _1 = _1_inlined1 in
                      ()
                    in
                    
# 205 "<standard.mly>"
    ( x )
# 89374 "asllib/Parser0.ml"
                    
                  in
                  ()
                in
                
# 265 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 89382 "asllib/Parser0.ml"
                
              in
              ()
            in
            
# 351 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 89390 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_x_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 89399 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _2_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = q;
                      MenhirLib.EngineTypes.startp = _startpos_q_;
                      MenhirLib.EngineTypes.endp = _endpos_q_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (
# 82 "asllib/Parser0.mly"
       (string)
# 89473 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 89479 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 123 "<standard.mly>"
    ( None )
# 89492 "asllib/Parser0.ml"
               in
              let _1 =
                let (_3, _2) = (_3_inlined2, _2_inlined1) in
                let _1 =
                  let _2 =
                    let _1_inlined1 = _1_inlined2 in
                    let x =
                      let _1 = _1_inlined1 in
                      let _1 =
                        let i = _1 in
                        
# 339 "asllib/Parser0.mly"
                                   ( q ^ "_" ^ i )
# 89506 "asllib/Parser0.ml"
                        
                      in
                      ()
                    in
                    
# 205 "<standard.mly>"
    ( x )
# 89514 "asllib/Parser0.ml"
                    
                  in
                  ()
                in
                
# 265 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 89522 "asllib/Parser0.ml"
                
              in
              ()
            in
            
# 351 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 89530 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 89539 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = x;
          MenhirLib.EngineTypes.startp = _startpos_x_;
          MenhirLib.EngineTypes.endp = _endpos_x_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _4;
              MenhirLib.EngineTypes.startp = _startpos__4_;
              MenhirLib.EngineTypes.endp = _endpos__4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _2_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = q;
                        MenhirLib.EngineTypes.startp = _startpos_q_;
                        MenhirLib.EngineTypes.endp = _endpos_q_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let x : (
# 82 "asllib/Parser0.mly"
       (string)
# 89615 "asllib/Parser0.ml"
        ) = Obj.magic x in
        let _2 : unit = Obj.magic _2 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (
# 82 "asllib/Parser0.mly"
       (string)
# 89624 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 89630 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_x_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 126 "<standard.mly>"
    ( Some x )
# 89643 "asllib/Parser0.ml"
               in
              let _1 =
                let (_3, _2) = (_3_inlined2, _2_inlined1) in
                let _1 =
                  let _2 =
                    let _1_inlined1 = _1_inlined2 in
                    let x =
                      let _1 = _1_inlined1 in
                      let _1 =
                        let i = _1 in
                        
# 339 "asllib/Parser0.mly"
                                   ( q ^ "_" ^ i )
# 89657 "asllib/Parser0.ml"
                        
                      in
                      ()
                    in
                    
# 205 "<standard.mly>"
    ( x )
# 89665 "asllib/Parser0.ml"
                    
                  in
                  ()
                in
                
# 265 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 89673 "asllib/Parser0.ml"
                
              in
              ()
            in
            
# 351 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 89681 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_x_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 89690 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__3_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__3_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _2_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3_inlined3 : unit = Obj.magic _3_inlined3 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _3_inlined1 : (AST.expr) = Obj.magic _3_inlined1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined2 : (AST.expr) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 123 "<standard.mly>"
    ( None )
# 89775 "asllib/Parser0.ml"
               in
              let _1 =
                let (_3, _2) = (_3_inlined3, _2_inlined1) in
                let _1 =
                  let _2 =
                    let _1_inlined1 = _1_inlined2 in
                    let x =
                      let (_3, _1) = (_3_inlined1, _1_inlined1) in
                      ()
                    in
                    
# 205 "<standard.mly>"
    ( x )
# 89789 "asllib/Parser0.ml"
                    
                  in
                  ()
                in
                
# 265 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 89797 "asllib/Parser0.ml"
                
              in
              ()
            in
            
# 351 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 89805 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 89814 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = x;
          MenhirLib.EngineTypes.startp = _startpos_x_;
          MenhirLib.EngineTypes.endp = _endpos_x_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _4;
              MenhirLib.EngineTypes.startp = _startpos__4_;
              MenhirLib.EngineTypes.endp = _endpos__4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__3_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__3_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _2_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let x : (
# 82 "asllib/Parser0.mly"
       (string)
# 89890 "asllib/Parser0.ml"
        ) = Obj.magic x in
        let _2 : unit = Obj.magic _2 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3_inlined3 : unit = Obj.magic _3_inlined3 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _3_inlined1 : (AST.expr) = Obj.magic _3_inlined1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined2 : (AST.expr) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_x_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 126 "<standard.mly>"
    ( Some x )
# 89910 "asllib/Parser0.ml"
               in
              let _1 =
                let (_3, _2) = (_3_inlined3, _2_inlined1) in
                let _1 =
                  let _2 =
                    let _1_inlined1 = _1_inlined2 in
                    let x =
                      let (_3, _1) = (_3_inlined1, _1_inlined1) in
                      ()
                    in
                    
# 205 "<standard.mly>"
    ( x )
# 89924 "asllib/Parser0.ml"
                    
                  in
                  ()
                in
                
# 265 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 89932 "asllib/Parser0.ml"
                
              in
              ()
            in
            
# 351 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 89940 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_x_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 89949 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v =
          let desc = 
# 319 "asllib/Parser0.mly"
                          ( AST.(T_Int UnConstrained) )
# 89976 "asllib/Parser0.ml"
           in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 89984 "asllib/Parser0.ml"
           : (AST.ty))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v =
          let desc = 
# 320 "asllib/Parser0.mly"
                          ( AST.T_Real                )
# 90011 "asllib/Parser0.ml"
           in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 90019 "asllib/Parser0.ml"
           : (AST.ty))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v =
          let desc = 
# 321 "asllib/Parser0.mly"
                          ( AST.T_Bool                )
# 90046 "asllib/Parser0.ml"
           in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 90054 "asllib/Parser0.ml"
           : (AST.ty))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 90076 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v =
          let desc =
            let tident = _1 in
            
# 322 "asllib/Parser0.mly"
                            AST.T_Named                
# 90087 "asllib/Parser0.ml"
             tident
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 90096 "asllib/Parser0.ml"
           : (AST.ty))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = q;
              MenhirLib.EngineTypes.startp = _startpos_q_;
              MenhirLib.EngineTypes.endp = _endpos_q_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _1 : (
# 82 "asllib/Parser0.mly"
       (string)
# 90130 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 90136 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos__1_ in
        let _v =
          let desc =
            let tident =
              let i = _1 in
              
# 339 "asllib/Parser0.mly"
                                   ( q ^ "_" ^ i )
# 90148 "asllib/Parser0.ml"
              
            in
            
# 322 "asllib/Parser0.mly"
                            AST.T_Named                
# 90154 "asllib/Parser0.ml"
             tident
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos_q_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 90163 "asllib/Parser0.ml"
           : (AST.ty))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v =
          let desc = 
# 323 "asllib/Parser0.mly"
                          ( t_bit                     )
# 90190 "asllib/Parser0.ml"
           in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 90198 "asllib/Parser0.ml"
           : (AST.ty))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = x;
            MenhirLib.EngineTypes.startp = _startpos_x_;
            MenhirLib.EngineTypes.endp = _endpos_x_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = _1;
                MenhirLib.EngineTypes.startp = _startpos__1_;
                MenhirLib.EngineTypes.endp = _endpos__1_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let x : (AST.expr) = Obj.magic x in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__3_ in
        let _v =
          let desc =
            let e = 
# 205 "<standard.mly>"
    ( x )
# 90247 "asllib/Parser0.ml"
             in
            
# 324 "asllib/Parser0.mly"
                          ( AST.(T_Bits (e, []))      )
# 90252 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 90261 "asllib/Parser0.ml"
           : (AST.ty))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3_inlined1;
          MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
          MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined3;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = x;
                  MenhirLib.EngineTypes.startp = _startpos_x_;
                  MenhirLib.EngineTypes.endp = _endpos_x_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined3 : (AST.bitfield list) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let x : (AST.expr) = Obj.magic x in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__3_inlined1_ in
        let _v =
          let desc =
            let b =
              let _1_inlined1 = _1_inlined3 in
              let x = _1_inlined1 in
              
# 205 "<standard.mly>"
    ( x )
# 90334 "asllib/Parser0.ml"
              
            in
            let e = 
# 205 "<standard.mly>"
    ( x )
# 90340 "asllib/Parser0.ml"
             in
            
# 325 "asllib/Parser0.mly"
                                      ( AST.(T_Bits (e, b)) )
# 90345 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_inlined1_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 90354 "asllib/Parser0.ml"
           : (AST.ty))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = x;
            MenhirLib.EngineTypes.startp = _startpos_x_;
            MenhirLib.EngineTypes.endp = _endpos_x_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = _1;
                MenhirLib.EngineTypes.startp = _startpos__1_;
                MenhirLib.EngineTypes.endp = _endpos__1_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let x : (AST.expr) = Obj.magic x in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__3_ in
        let _v =
          let desc =
            let _1 =
              let _2 = 
# 205 "<standard.mly>"
    ( x )
# 90404 "asllib/Parser0.ml"
               in
              ()
            in
            
# 265 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 90411 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 90420 "asllib/Parser0.ml"
           : (AST.ty))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _4;
          MenhirLib.EngineTypes.startp = _startpos__4_;
          MenhirLib.EngineTypes.endp = _endpos__4_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _3;
            MenhirLib.EngineTypes.startp = _startpos__3_;
            MenhirLib.EngineTypes.endp = _endpos__3_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (
# 82 "asllib/Parser0.mly"
       (string)
# 90475 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__4_ in
        let _v =
          let desc =
            let _1 =
              let _2 =
                let _1_inlined1 = _1_inlined2 in
                let x =
                  let _1 = _1_inlined1 in
                  ()
                in
                
# 205 "<standard.mly>"
    ( x )
# 90494 "asllib/Parser0.ml"
                
              in
              ()
            in
            
# 265 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 90502 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 90511 "asllib/Parser0.ml"
           : (AST.ty))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _4;
          MenhirLib.EngineTypes.startp = _startpos__4_;
          MenhirLib.EngineTypes.endp = _endpos__4_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _3;
            MenhirLib.EngineTypes.startp = _startpos__3_;
            MenhirLib.EngineTypes.endp = _endpos__3_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _2;
                  MenhirLib.EngineTypes.startp = _startpos__2_;
                  MenhirLib.EngineTypes.endp = _endpos__2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = q;
                    MenhirLib.EngineTypes.startp = _startpos_q_;
                    MenhirLib.EngineTypes.endp = _endpos_q_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (
# 82 "asllib/Parser0.mly"
       (string)
# 90578 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let q : (
# 88 "asllib/Parser0.mly"
       (string)
# 90584 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__4_ in
        let _v =
          let desc =
            let _1 =
              let _2 =
                let _1_inlined1 = _1_inlined2 in
                let x =
                  let _1 = _1_inlined1 in
                  let _1 =
                    let i = _1 in
                    
# 339 "asllib/Parser0.mly"
                                   ( q ^ "_" ^ i )
# 90603 "asllib/Parser0.ml"
                    
                  in
                  ()
                in
                
# 205 "<standard.mly>"
    ( x )
# 90611 "asllib/Parser0.ml"
                
              in
              ()
            in
            
# 265 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 90619 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 90628 "asllib/Parser0.ml"
           : (AST.ty))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _4;
          MenhirLib.EngineTypes.startp = _startpos__4_;
          MenhirLib.EngineTypes.endp = _endpos__4_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _3;
            MenhirLib.EngineTypes.startp = _startpos__3_;
            MenhirLib.EngineTypes.endp = _endpos__3_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _2;
                  MenhirLib.EngineTypes.startp = _startpos__2_;
                  MenhirLib.EngineTypes.endp = _endpos__2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _3_inlined1 : (AST.expr) = Obj.magic _3_inlined1 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined2 : (AST.expr) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__4_ in
        let _v =
          let desc =
            let _1 =
              let _2 =
                let _1_inlined1 = _1_inlined2 in
                let x =
                  let (_3, _1) = (_3_inlined1, _1_inlined1) in
                  ()
                in
                
# 205 "<standard.mly>"
    ( x )
# 90712 "asllib/Parser0.ml"
                
              in
              ()
            in
            
# 265 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 90720 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 90729 "asllib/Parser0.ml"
           : (AST.ty))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2;
              MenhirLib.EngineTypes.startp = _startpos__2_;
              MenhirLib.EngineTypes.endp = _endpos__2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = h;
                MenhirLib.EngineTypes.startp = _startpos_h_;
                MenhirLib.EngineTypes.endp = _endpos_h_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (AST.ty list) = Obj.magic _1_inlined1 in
        let _2 : unit = Obj.magic _2 in
        let h : (AST.ty) = Obj.magic h in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__3_ in
        let _v =
          let desc =
            let _1 =
              let x =
                let _1 = _1_inlined1 in
                let t = _1 in
                
# 301 "asllib/Parser0.mly"
                                           ( h::t )
# 90789 "asllib/Parser0.ml"
                
              in
              
# 205 "<standard.mly>"
    ( x )
# 90795 "asllib/Parser0.ml"
              
            in
            let _1_1 = _1 in
            
# 312 "asllib/Parser0.mly"
                              AST.T_Tuple  
# 90802 "asllib/Parser0.ml"
             _1_1
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 262 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 90811 "asllib/Parser0.ml"
           : (AST.ty))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
    |]
  
  and trace =
    None
  
end

module MenhirInterpreter = struct
  
  module ET = MenhirLib.TableInterpreter.MakeEngineTable (Tables)
  
  module TI = MenhirLib.Engine.Make (ET)
  
  include TI
  
end

let opn =
  fun lexer lexbuf : (AST.t) ->
    Obj.magic (MenhirInterpreter.entry `Legacy 1991 lexer lexbuf)

and ast =
  fun lexer lexbuf : (AST.t) ->
    Obj.magic (MenhirInterpreter.entry `Legacy 0 lexer lexbuf)

module Incremental = struct
  
  let opn =
    fun initial_position : (AST.t) MenhirInterpreter.checkpoint ->
      Obj.magic (MenhirInterpreter.start 1991 initial_position)
  
  and ast =
    fun initial_position : (AST.t) MenhirInterpreter.checkpoint ->
      Obj.magic (MenhirInterpreter.start 0 initial_position)
  
end
